
#include <stdio.h>

#include "ttterm.h"
#include "ttbuffer.h"
#include "ttutils.h"
#include "ttparse.h"

#include "c/VSCParse.h"
#include "c/VSCScan.h"

typedef TTterm(*fparse)(void);

static TTterm parse_wrap(void)
{
    fparse fs[3];

    fs[0] = TTparseVSC_LAYOUT;
    fs[1] = TTparseVSC_main_programs;
    fs[2] = TTparseVSC_LAYOUT;
    return TTparseVSC_CONJUNCTION(TTfun_sandwich, fs);
}

static TTterm parse(TTbuf buf)
{
	VSCinit();
	return TTparse_buffer(parse_wrap, buf);
}

int
main(int argc, char **argv)
{
	TTbuf buf;
	TTterm pt;

	buf = TTbuffer_create();
	TTbuffer_read(buf, stdin);
	pt = parse(buf);
	TTbuffer_destroy(buf);

	buf = TTbuffer_create();
	TTunparse(buf, pt);
	TTbuffer_write(buf, stdout);
	TTbuffer_destroy(buf);

	return 0;
}



