
#include <stdio.h>
#include <sys/types.h>

#include "ttterm.h"
#include "ttbuffer.h"
#include "ttutils.h"

#include "c/VSCParse.h"
#include "utils.h"
#include "expandpic.h"

static TTtype_list st_affected;

#define m_pic TTmatchVSC_dd_entry_picture_clause
#define b_pic TTbuildVSC_dd_entry_picture_clause
#define m_dd_entry TTmatchVSC_dd_entry_data_description_entry_1

static TTterm b_pic_str(const char * str)
{
	return TTbuildVSC_lex_picture_string(TTbuild_string(str));
}

static TTterm expandpic_rule(TTterm t)
{
	TTterm pic;
	TTtype_string is;
	TTterm pic_string;

	if (m_pic(t, &pic, &is, &pic_string)) {
		if (TTequal_string(select_string(pic_string), "99")) {
			return b_pic(pic, is, b_pic_str("999"));
		}
	}
	return 0;
}

static TTterm expandpic_stop(TTterm t)
{
	TTterm level;
	TTterm field;
	TTterm clauses;
	TTtype_string dot, name;

	if (m_dd_entry(t, &level, &field, &clauses, &dot)) {
		name = get_name(field);
		if (name && TTelem(name, st_affected)) {
			return TTtransform(t, expandpic_rule);
		}
	}
	return 0;
}

TTterm expandpic_trav(TTtype_list affected, TTterm t)
{
	st_affected = affected;
	return TTtransform(t, expandpic_stop);
}

