
#include <assert.h>
#include <stdio.h>
#include <sys/types.h>

#include "ttterm.h"
#include "ttbuffer.h"
#include "ttutils.h"

#include "c/VSCParse.h"
#include "utils.h"
#include "propagate.h"

/* shortcuts */
#define m_move TTmatchVSC_stat_move_statement_1

static TTtype_list st_known;

static TTtype_list
propagate_one(TTterm from_name, TTterm to_name)
{
	BOOL from_known, to_known;

	from_known = TTelem(from_name, st_known);
	to_known = TTelem(to_name, st_known);
	if (from_known && !to_known) {
		return TTbuild_singleton(to_name);
	} else if (to_known && !from_known) {
		return TTbuild_singleton(from_name);
	}
	return TTbuild_nil();
}

static TTtype_list
propagate_rule(TTterm t)
{
	TTtype_list move, to;
	TTterm from_field;
	TTterm to_field;
	TTterm from_name, to_name;

	if (m_move(t, &move, &from_field, &to, &to_field)) {
		from_name = get_name(from_field);
		to_name = get_name(to_field);
		if (from_name && to_name) {
		    return propagate_one(from_name, to_name);
		}
	}
	return 0;
}

TTtype_list
propagate_trav(TTtype_list known, TTterm t)
{
	st_known = known;
	return TTanalyze(t, propagate_rule, TTunion, TTbuild_nil());
}

