
#include <stdio.h>
#include <sys/types.h>

#include "ttterm.h"
#include "ttbuffer.h"
#include "ttutils.h"

#include "c/VSCParse.h"
#include "utils.h"
#include "expandmax.h"

static TTtype_list st_affected;

static TTterm
max99to299Trafo(TTterm t)
{
	if (t->fun == TTfun_string) {
		if (TTequal_string(t, "99")) {
			return TTbuild_string("299");
		} else if (TTequal_string(t, "100")) {
			return TTbuild_string("300");
		}
		return 0;
	}
	return 0;
}

static TTterm
max99to299(TTterm t)
{
	TTterm e1, new_e1;
	TTterm rel;
	TTterm e2, new_e2;
	TTtype_string name1, name2;

	if (TTmatchVSC_cond_relation_condition(t, &e1, &rel, &e2)) {
		name1 = get_name(e1);
		name2 = get_name(e2);
		if (name1 && TTelem(name1, st_affected)) {
			new_e2 = transform(e2, max99to299Trafo);
			return TTbuildVSC_cond_relation_condition(e1, rel, new_e2);
		} else if (name2 && TTelem(name2, st_affected)) {
			new_e1 = transform(e1, max99to299Trafo);
			return TTbuildVSC_cond_relation_condition(new_e1, rel, e2);
		} else {
			return t;
		}
	}
	return 0;
}

TTterm
expandmax(TTtype_list affected, TTterm t)
{
	st_affected = affected;
	return transform(t, max99to299);
}

