#include <assert.h>
#include <stdio.h>

#include "ttterm.h"
#include "ttbuffer.h"
#include "ttutils.h"
#include "tterror.h"

#include "bison/parsevsc.h"

static TTbuf st_buf;

static void error_handler(const char * msg)
{
	TTbuffer_append(st_buf, msg);
}

static void parse(const char * filename)
{
	TTbuf buf;
	TTterm pt;

	buf = TTbuffer_create();
	TTbuffer_read_named(buf, filename);
	pt = VSCparse(buf);
	TTbuffer_destroy(buf);
}

int
main(int argc, char **argv)
{
	TTbuf buf;

	TTerror_set_handler(error_handler);

	st_buf = TTbuffer_create();

	parse("tests/cob/test1.cob.trm");
	parse("tests/cob/test2.cob.trm");
	parse("tests/cob/test3.cob.trm");

	buf = TTbuffer_create();
	TTbuffer_read_named(buf, "tests/test3/test3.errors");
/*fprintf(stdout, "%s", st_buf->data);*/
	assert(strcmp(buf->data, st_buf->data) == 0);
	TTbuffer_destroy(buf);

	TTbuffer_destroy(st_buf);

	return 0;
}

