
#include <stdio.h>
#include <assert.h>

#include "ttterm.h"
#include "ttbuffer.h"
#include "ttutils.h"
#include "tterror.h"
#include "parsefst.h"
#include "parselll.h"
#include "fsttrafos.h"

static TTbuf st_buf;

static void error_handler(const char * msg)
{
	TTbuffer_append(st_buf, msg);
	TTbuffer_append(st_buf, "\n");
}

int
main(int argc, char **argv)
{
	FILE * f;
	TTbuf buf;
	TTterm spec, trafos;

	TTerror_set_handler(error_handler);

	st_buf = TTbuffer_create();

	buf = TTbuffer_create();
	TTbuffer_read_named(buf, "tests/test4/test4.trafo");
	trafos = FSTparse(buf);
	TTbuffer_destroy(buf);
/*
	trafos = TTunsandwich_rec(trafos);
*/

	buf = TTbuffer_create();
	TTbuffer_read_named(buf, "tests/test4/test4.lll");
	spec = LLLparse(buf);
	TTbuffer_destroy(buf);

	spec = TTunsandwich_rec(spec);

	spec = FSTapply_trafos("tests/test4/test4.trafo", trafos, spec);

	buf = TTbuffer_create();
	TTbuffer_read_named(buf, "tests/test4/test4.errors");
f = fopen("tests/test4/test4.errors.tmp", "w");
assert(f);
fprintf(f, "%s", st_buf->data);
fclose(f);
	assert(strcmp(buf->data, st_buf->data) == 0);
	TTbuffer_destroy(buf);

	TTbuffer_destroy(st_buf);

	return 0;
}



