
#include <stdio.h>
#include <string.h>

static void usage(const char *program_name)
{
	fprintf(stderr, "Usage: %s [options]\n", program_name);
	fprintf(stderr, "Options:\n");
	fprintf(stderr, "  --version\n");
	fprintf(stderr, "  --libs\n");
	fprintf(stderr, "  --cflags\n");
}

int main(int argc, char **argv)
{
	int i;
	if (argc == 1) {
		usage(argv[0]);
		exit(0);
	}
	for (i = 1; i < argc; i++) {
		if (strcmp(argv[i], "--version") == 0) {
			printf("%s\n", VERSION);
		} else if (strcmp(argv[i], "--libs") == 0) {
			printf("%s\n", VSCLIBS);
		} else if (strcmp(argv[i], "--cflags") == 0) {
			printf("%s\n", VSCCFLAGS);
		} else {
			usage(argv[0]);
			exit(1);
		}
	}
	return 0;
}
