#include <stdio.h>
#include <assert.h>
#include <sys/types.h>
#include "ttterm.h"
#include "ttbuffer.h"
#include "ttutils.h"
#include "VSCFuns.h"

static int init = 0;
static TTterm args[1000];

void
VSCinit( void )
{
    if(init == 0)
    {
        TTutils_init();
        TTfunVSC_cond_alt_and_or = TTbuild_fun("VSC_cond_alt_and_or", 1);
        TTfunVSC_cond_and_or_combinable_condition = TTbuild_fun("VSC_cond_and_or_combinable_condition", 3);
        TTfunVSC_cond_class_condition = TTbuild_fun("VSC_cond_class_condition", 3);
        TTfunVSC_cond_class_type = TTbuild_fun("VSC_cond_class_type", 1);
        TTfunVSC_cond_combinable_condition = TTbuild_fun("VSC_cond_combinable_condition", 1);
        TTfunVSC_cond_combined_conditions = TTbuild_fun("VSC_cond_combined_conditions", 2);
        TTfunVSC_cond_condition = TTbuild_fun("VSC_cond_condition", 1);
        TTfunVSC_cond_condition_name_reference = TTbuild_fun("VSC_cond_condition_name_reference", 3);
        TTfunVSC_cond_greater = TTbuild_fun("VSC_cond_greater", 2);
        TTfunVSC_cond_greater_equal = TTbuild_fun("VSC_cond_greater_equal", 5);
        TTfunVSC_cond_greater_than = TTbuild_fun("VSC_cond_greater_than", 1);
        TTfunVSC_cond_greater_than_1 = TTbuild_fun("VSC_cond_greater_than_1", 2);
        TTfunVSC_cond_greater_than_or_equal_to = TTbuild_fun("VSC_cond_greater_than_or_equal_to", 1);
        TTfunVSC_cond_greater_than_or_equal_to_1 = TTbuild_fun("VSC_cond_greater_than_or_equal_to_1", 5);
        TTfunVSC_cond_greater_than_or_equal_to_2 = TTbuild_fun("VSC_cond_greater_than_or_equal_to_2", 3);
        TTfunVSC_cond_greater_than_or_equal_to_3 = TTbuild_fun("VSC_cond_greater_than_or_equal_to_3", 2);
        TTfunVSC_cond_is_not = TTbuild_fun("VSC_cond_is_not", 2);
        TTfunVSC_cond_is_or_is_not = TTbuild_fun("VSC_cond_is_or_is_not", 1);
        TTfunVSC_cond_less = TTbuild_fun("VSC_cond_less", 2);
        TTfunVSC_cond_less_equal = TTbuild_fun("VSC_cond_less_equal", 5);
        TTfunVSC_cond_less_equal_2 = TTbuild_fun("VSC_cond_less_equal_2", 2);
        TTfunVSC_cond_negated_simple_conditions = TTbuild_fun("VSC_cond_negated_simple_conditions", 2);
        TTfunVSC_cond_not_is = TTbuild_fun("VSC_cond_not_is", 2);
        TTfunVSC_cond_not_relational_operator_rest = TTbuild_fun("VSC_cond_not_relational_operator_rest", 2);
        TTfunVSC_cond_relation_condition = TTbuild_fun("VSC_cond_relation_condition", 3);
        TTfunVSC_cond_relational_operator = TTbuild_fun("VSC_cond_relational_operator", 2);
        TTfunVSC_cond_relational_operator_rest = TTbuild_fun("VSC_cond_relational_operator_rest", 1);
        TTfunVSC_cond_relational_operator_tail = TTbuild_fun("VSC_cond_relational_operator_tail", 1);
        TTfunVSC_cond_sign_condition = TTbuild_fun("VSC_cond_sign_condition", 3);
        TTfunVSC_cond_sign_type = TTbuild_fun("VSC_cond_sign_type", 1);
        TTfunVSC_cond_simple_condition = TTbuild_fun("VSC_cond_simple_condition", 1);
        TTfunVSC_cond_simple_condition_1 = TTbuild_fun("VSC_cond_simple_condition_1", 3);
        TTfunVSC_cond_than = TTbuild_fun("VSC_cond_than", 1);
        TTfunVSC_conf_sec_alphabet_clause = TTbuild_fun("VSC_conf_sec_alphabet_clause", 4);
        TTfunVSC_conf_sec_alphabet_type = TTbuild_fun("VSC_conf_sec_alphabet_type", 1);
        TTfunVSC_conf_sec_alphabet_type_also = TTbuild_fun("VSC_conf_sec_alphabet_type_also", 2);
        TTfunVSC_conf_sec_alphabet_type_also_through = TTbuild_fun("VSC_conf_sec_alphabet_type_also_through", 1);
        TTfunVSC_conf_sec_alphabet_type_alsos = TTbuild_fun("VSC_conf_sec_alphabet_type_alsos", 1);
        TTfunVSC_conf_sec_alphabet_type_other = TTbuild_fun("VSC_conf_sec_alphabet_type_other", 2);
        TTfunVSC_conf_sec_alphabet_type_others = TTbuild_fun("VSC_conf_sec_alphabet_type_others", 1);
        TTfunVSC_conf_sec_are = TTbuild_fun("VSC_conf_sec_are", 1);
        TTfunVSC_conf_sec_class_clause = TTbuild_fun("VSC_conf_sec_class_clause", 4);
        TTfunVSC_conf_sec_configuration_section = TTbuild_fun("VSC_conf_sec_configuration_section", 4);
        TTfunVSC_conf_sec_configuration_section_paragraph = TTbuild_fun("VSC_conf_sec_configuration_section_paragraph", 1);
        TTfunVSC_conf_sec_configuration_section_paragraphs = TTbuild_fun("VSC_conf_sec_configuration_section_paragraphs", 1);
        TTfunVSC_conf_sec_currency_sign_clause = TTbuild_fun("VSC_conf_sec_currency_sign_clause", 4);
        TTfunVSC_conf_sec_decimal_point_clause = TTbuild_fun("VSC_conf_sec_decimal_point_clause", 3);
        TTfunVSC_conf_sec_in_alphabet_name = TTbuild_fun("VSC_conf_sec_in_alphabet_name", 2);
        TTfunVSC_conf_sec_is_mnemonic_name = TTbuild_fun("VSC_conf_sec_is_mnemonic_name", 3);
        TTfunVSC_conf_sec_memory_size = TTbuild_fun("VSC_conf_sec_memory_size", 4);
        TTfunVSC_conf_sec_memory_size_type = TTbuild_fun("VSC_conf_sec_memory_size_type", 1);
        TTfunVSC_conf_sec_object_computer_name = TTbuild_fun("VSC_conf_sec_object_computer_name", 4);
        TTfunVSC_conf_sec_object_computer_paragraph = TTbuild_fun("VSC_conf_sec_object_computer_paragraph", 3);
        TTfunVSC_conf_sec_object_computer_paragraph_sequence_phrase = TTbuild_fun("VSC_conf_sec_object_computer_paragraph_sequence_phrase", 2);
        TTfunVSC_conf_sec_off_status = TTbuild_fun("VSC_conf_sec_off_status", 4);
        TTfunVSC_conf_sec_on_status = TTbuild_fun("VSC_conf_sec_on_status", 4);
        TTfunVSC_conf_sec_program_collating_sequence = TTbuild_fun("VSC_conf_sec_program_collating_sequence", 5);
        TTfunVSC_conf_sec_segment_limit = TTbuild_fun("VSC_conf_sec_segment_limit", 3);
        TTfunVSC_conf_sec_source_computer_name = TTbuild_fun("VSC_conf_sec_source_computer_name", 3);
        TTfunVSC_conf_sec_source_computer_paragraph = TTbuild_fun("VSC_conf_sec_source_computer_paragraph", 3);
        TTfunVSC_conf_sec_special_names_paragraph = TTbuild_fun("VSC_conf_sec_special_names_paragraph", 5);
        TTfunVSC_conf_sec_special_names_paragraph_clause = TTbuild_fun("VSC_conf_sec_special_names_paragraph_clause", 1);
        TTfunVSC_conf_sec_special_names_paragraph_clauses = TTbuild_fun("VSC_conf_sec_special_names_paragraph_clauses", 1);
        TTfunVSC_conf_sec_special_names_paragraph_phrase = TTbuild_fun("VSC_conf_sec_special_names_paragraph_phrase", 2);
        TTfunVSC_conf_sec_special_names_paragraph_phrase_tail = TTbuild_fun("VSC_conf_sec_special_names_paragraph_phrase_tail", 1);
        TTfunVSC_conf_sec_special_names_paragraph_status_phrase = TTbuild_fun("VSC_conf_sec_special_names_paragraph_status_phrase", 1);
        TTfunVSC_conf_sec_special_names_paragraph_status_phrase_1 = TTbuild_fun("VSC_conf_sec_special_names_paragraph_status_phrase_1", 5);
        TTfunVSC_conf_sec_special_names_paragraph_status_phrase_2 = TTbuild_fun("VSC_conf_sec_special_names_paragraph_status_phrase_2", 5);
        TTfunVSC_conf_sec_symbolic_character_mapping = TTbuild_fun("VSC_conf_sec_symbolic_character_mapping", 3);
        TTfunVSC_conf_sec_symbolic_characters_clause = TTbuild_fun("VSC_conf_sec_symbolic_characters_clause", 4);
        TTfunVSC_conf_sec_with_debugging_mode = TTbuild_fun("VSC_conf_sec_with_debugging_mode", 3);
        TTfunVSC_data_div_data_division = TTbuild_fun("VSC_data_div_data_division", 4);
        TTfunVSC_data_div_data_division_content = TTbuild_fun("VSC_data_div_data_division_content", 3);
        TTfunVSC_data_div_file_section = TTbuild_fun("VSC_data_div_file_section", 4);
        TTfunVSC_data_div_file_section_entry = TTbuild_fun("VSC_data_div_file_section_entry", 2);
        TTfunVSC_data_div_linkage_section = TTbuild_fun("VSC_data_div_linkage_section", 4);
        TTfunVSC_data_div_working_storage_section = TTbuild_fun("VSC_data_div_working_storage_section", 4);
        TTfunVSC_dd_entry_alt_data_name_filler = TTbuild_fun("VSC_dd_entry_alt_data_name_filler", 1);
        TTfunVSC_dd_entry_alt_leading_trailing = TTbuild_fun("VSC_dd_entry_alt_leading_trailing", 1);
        TTfunVSC_dd_entry_alt_left_right = TTbuild_fun("VSC_dd_entry_alt_left_right", 1);
        TTfunVSC_dd_entry_blank_when_zero_clause = TTbuild_fun("VSC_dd_entry_blank_when_zero_clause", 3);
        TTfunVSC_dd_entry_condition_value_clause = TTbuild_fun("VSC_dd_entry_condition_value_clause", 2);
        TTfunVSC_dd_entry_data_description_entry = TTbuild_fun("VSC_dd_entry_data_description_entry", 1);
        TTfunVSC_dd_entry_data_description_entry_1 = TTbuild_fun("VSC_dd_entry_data_description_entry_1", 4);
        TTfunVSC_dd_entry_data_description_entry_clause = TTbuild_fun("VSC_dd_entry_data_description_entry_clause", 1);
        TTfunVSC_dd_entry_data_description_entry_clauses = TTbuild_fun("VSC_dd_entry_data_description_entry_clauses", 1);
        TTfunVSC_dd_entry_external_clause = TTbuild_fun("VSC_dd_entry_external_clause", 2);
        TTfunVSC_dd_entry_global_clause = TTbuild_fun("VSC_dd_entry_global_clause", 2);
        TTfunVSC_dd_entry_indexed_by = TTbuild_fun("VSC_dd_entry_indexed_by", 3);
        TTfunVSC_dd_entry_integer_to = TTbuild_fun("VSC_dd_entry_integer_to", 2);
        TTfunVSC_dd_entry_justified = TTbuild_fun("VSC_dd_entry_justified", 1);
        TTfunVSC_dd_entry_justified_clause = TTbuild_fun("VSC_dd_entry_justified_clause", 2);
        TTfunVSC_dd_entry_occurs_clause = TTbuild_fun("VSC_dd_entry_occurs_clause", 1);
        TTfunVSC_dd_entry_occurs_clause_1 = TTbuild_fun("VSC_dd_entry_occurs_clause_1", 5);
        TTfunVSC_dd_entry_occurs_clause_2 = TTbuild_fun("VSC_dd_entry_occurs_clause_2", 9);
        TTfunVSC_dd_entry_occurs_clause_key = TTbuild_fun("VSC_dd_entry_occurs_clause_key", 4);
        TTfunVSC_dd_entry_picture = TTbuild_fun("VSC_dd_entry_picture", 1);
        TTfunVSC_dd_entry_picture_clause = TTbuild_fun("VSC_dd_entry_picture_clause", 3);
        TTfunVSC_dd_entry_redefines_clause = TTbuild_fun("VSC_dd_entry_redefines_clause", 2);
        TTfunVSC_dd_entry_renames_clause = TTbuild_fun("VSC_dd_entry_renames_clause", 3);
        TTfunVSC_dd_entry_separate_character = TTbuild_fun("VSC_dd_entry_separate_character", 2);
        TTfunVSC_dd_entry_sign_clause = TTbuild_fun("VSC_dd_entry_sign_clause", 3);
        TTfunVSC_dd_entry_sign_is = TTbuild_fun("VSC_dd_entry_sign_is", 2);
        TTfunVSC_dd_entry_synchronized = TTbuild_fun("VSC_dd_entry_synchronized", 1);
        TTfunVSC_dd_entry_synchronized_clause = TTbuild_fun("VSC_dd_entry_synchronized_clause", 2);
        TTfunVSC_dd_entry_usage = TTbuild_fun("VSC_dd_entry_usage", 1);
        TTfunVSC_dd_entry_usage_clause = TTbuild_fun("VSC_dd_entry_usage_clause", 2);
        TTfunVSC_dd_entry_usage_is = TTbuild_fun("VSC_dd_entry_usage_is", 2);
        TTfunVSC_dd_entry_values_are = TTbuild_fun("VSC_dd_entry_values_are", 2);
        TTfunVSC_dd_entry_zeroes = TTbuild_fun("VSC_dd_entry_zeroes", 1);
        TTfunVSC_env_div_environment_division = TTbuild_fun("VSC_env_div_environment_division", 4);
        TTfunVSC_env_div_environment_division_content = TTbuild_fun("VSC_env_div_environment_division_content", 2);
        TTfunVSC_expr_alphabet_name = TTbuild_fun("VSC_expr_alphabet_name", 1);
        TTfunVSC_expr_alphabetic_user_defined_word = TTbuild_fun("VSC_expr_alphabetic_user_defined_word", 1);
        TTfunVSC_expr_alt_ascending_descending = TTbuild_fun("VSC_expr_alt_ascending_descending", 1);
        TTfunVSC_expr_alt_library_name_literal = TTbuild_fun("VSC_expr_alt_library_name_literal", 1);
        TTfunVSC_expr_alt_plus_minus = TTbuild_fun("VSC_expr_alt_plus_minus", 1);
        TTfunVSC_expr_alt_reel_unit = TTbuild_fun("VSC_expr_alt_reel_unit", 1);
        TTfunVSC_expr_alt_text_name_literal = TTbuild_fun("VSC_expr_alt_text_name_literal", 1);
        TTfunVSC_expr_alt_times_div = TTbuild_fun("VSC_expr_alt_times_div", 1);
        TTfunVSC_expr_arithmetic_expression = TTbuild_fun("VSC_expr_arithmetic_expression", 2);
        TTfunVSC_expr_arithmetic_expression_tail = TTbuild_fun("VSC_expr_arithmetic_expression_tail", 2);
        TTfunVSC_expr_assignment_name = TTbuild_fun("VSC_expr_assignment_name", 1);
        TTfunVSC_expr_basis = TTbuild_fun("VSC_expr_basis", 1);
        TTfunVSC_expr_basis_1 = TTbuild_fun("VSC_expr_basis_1", 3);
        TTfunVSC_expr_class_name = TTbuild_fun("VSC_expr_class_name", 1);
        TTfunVSC_expr_computer_name = TTbuild_fun("VSC_expr_computer_name", 1);
        TTfunVSC_expr_condition_name = TTbuild_fun("VSC_expr_condition_name", 1);
        TTfunVSC_expr_copy_operand = TTbuild_fun("VSC_expr_copy_operand", 1);
        TTfunVSC_expr_copy_statement = TTbuild_fun("VSC_expr_copy_statement", 6);
        TTfunVSC_expr_copy_statement_by_phrase = TTbuild_fun("VSC_expr_copy_statement_by_phrase", 3);
        TTfunVSC_expr_copy_statement_replacing_phrase = TTbuild_fun("VSC_expr_copy_statement_replacing_phrase", 2);
        TTfunVSC_expr_data_name = TTbuild_fun("VSC_expr_data_name", 1);
        TTfunVSC_expr_data_or_file_name = TTbuild_fun("VSC_expr_data_or_file_name", 1);
        TTfunVSC_expr_data_or_file_or_mnemonic_name = TTbuild_fun("VSC_expr_data_or_file_or_mnemonic_name", 1);
        TTfunVSC_expr_environment_name = TTbuild_fun("VSC_expr_environment_name", 1);
        TTfunVSC_expr_equal_to = TTbuild_fun("VSC_expr_equal_to", 1);
        TTfunVSC_expr_equal_to_1 = TTbuild_fun("VSC_expr_equal_to_1", 2);
        TTfunVSC_expr_figurative_constant = TTbuild_fun("VSC_expr_figurative_constant", 1);
        TTfunVSC_expr_figurative_constant_all = TTbuild_fun("VSC_expr_figurative_constant_all", 2);
        TTfunVSC_expr_figurative_constant_simple = TTbuild_fun("VSC_expr_figurative_constant_simple", 1);
        TTfunVSC_expr_file_name = TTbuild_fun("VSC_expr_file_name", 1);
        TTfunVSC_expr_identifier = TTbuild_fun("VSC_expr_identifier", 1);
        TTfunVSC_expr_identifier_1 = TTbuild_fun("VSC_expr_identifier_1", 3);
        TTfunVSC_expr_identifier_2 = TTbuild_fun("VSC_expr_identifier_2", 2);
        TTfunVSC_expr_in = TTbuild_fun("VSC_expr_in", 1);
        TTfunVSC_expr_in_data_or_file_name = TTbuild_fun("VSC_expr_in_data_or_file_name", 2);
        TTfunVSC_expr_in_data_or_file_or_mnemonic_name = TTbuild_fun("VSC_expr_in_data_or_file_or_mnemonic_name", 2);
        TTfunVSC_expr_in_file_name = TTbuild_fun("VSC_expr_in_file_name", 2);
        TTfunVSC_expr_in_library = TTbuild_fun("VSC_expr_in_library", 2);
        TTfunVSC_expr_in_section_name = TTbuild_fun("VSC_expr_in_section_name", 2);
        TTfunVSC_expr_index_name = TTbuild_fun("VSC_expr_index_name", 1);
        TTfunVSC_expr_integer = TTbuild_fun("VSC_expr_integer", 1);
        TTfunVSC_expr_leftmost_character_position = TTbuild_fun("VSC_expr_leftmost_character_position", 1);
        TTfunVSC_expr_length = TTbuild_fun("VSC_expr_length", 1);
        TTfunVSC_expr_level_number = TTbuild_fun("VSC_expr_level_number", 1);
        TTfunVSC_expr_library_name = TTbuild_fun("VSC_expr_library_name", 1);
        TTfunVSC_expr_literal = TTbuild_fun("VSC_expr_literal", 1);
        TTfunVSC_expr_literal_through_literal = TTbuild_fun("VSC_expr_literal_through_literal", 2);
        TTfunVSC_expr_mnemonic_name = TTbuild_fun("VSC_expr_mnemonic_name", 1);
        TTfunVSC_expr_numeric = TTbuild_fun("VSC_expr_numeric", 1);
        TTfunVSC_expr_paragraph_name = TTbuild_fun("VSC_expr_paragraph_name", 1);
        TTfunVSC_expr_paragraph_or_section_name = TTbuild_fun("VSC_expr_paragraph_or_section_name", 1);
        TTfunVSC_expr_plus_minus_integer = TTbuild_fun("VSC_expr_plus_minus_integer", 2);
        TTfunVSC_expr_power = TTbuild_fun("VSC_expr_power", 3);
        TTfunVSC_expr_power_tail = TTbuild_fun("VSC_expr_power_tail", 2);
        TTfunVSC_expr_priority_number = TTbuild_fun("VSC_expr_priority_number", 1);
        TTfunVSC_expr_procedure_name = TTbuild_fun("VSC_expr_procedure_name", 2);
        TTfunVSC_expr_program_name = TTbuild_fun("VSC_expr_program_name", 1);
        TTfunVSC_expr_qualified_data_name = TTbuild_fun("VSC_expr_qualified_data_name", 1);
        TTfunVSC_expr_qualified_data_name_1 = TTbuild_fun("VSC_expr_qualified_data_name_1", 2);
        TTfunVSC_expr_record_name = TTbuild_fun("VSC_expr_record_name", 1);
        TTfunVSC_expr_records = TTbuild_fun("VSC_expr_records", 1);
        TTfunVSC_expr_reference_modification = TTbuild_fun("VSC_expr_reference_modification", 5);
        TTfunVSC_expr_section_name = TTbuild_fun("VSC_expr_section_name", 1);
        TTfunVSC_expr_special_register_1 = TTbuild_fun("VSC_expr_special_register_1", 3);
        TTfunVSC_expr_special_register_2 = TTbuild_fun("VSC_expr_special_register_2", 3);
        TTfunVSC_expr_subscript = TTbuild_fun("VSC_expr_subscript", 1);
        TTfunVSC_expr_subscript_expression = TTbuild_fun("VSC_expr_subscript_expression", 1);
        TTfunVSC_expr_subscript_expression_ambiguous = TTbuild_fun("VSC_expr_subscript_expression_ambiguous", 2);
        TTfunVSC_expr_subscript_parentheses = TTbuild_fun("VSC_expr_subscript_parentheses", 3);
        TTfunVSC_expr_symbolic_character = TTbuild_fun("VSC_expr_symbolic_character", 1);
        TTfunVSC_expr_system_name = TTbuild_fun("VSC_expr_system_name", 1);
        TTfunVSC_expr_text_name = TTbuild_fun("VSC_expr_text_name", 1);
        TTfunVSC_expr_through = TTbuild_fun("VSC_expr_through", 1);
        TTfunVSC_expr_through_arithmetic_expression = TTbuild_fun("VSC_expr_through_arithmetic_expression", 2);
        TTfunVSC_expr_through_literal = TTbuild_fun("VSC_expr_through_literal", 2);
        TTfunVSC_expr_through_qualified_data_name = TTbuild_fun("VSC_expr_through_qualified_data_name", 2);
        TTfunVSC_expr_times_div = TTbuild_fun("VSC_expr_times_div", 2);
        TTfunVSC_expr_times_div_tail = TTbuild_fun("VSC_expr_times_div_tail", 2);
        TTfunVSC_expr_user_defined_word = TTbuild_fun("VSC_expr_user_defined_word", 1);
        TTfunVSC_expr_values = TTbuild_fun("VSC_expr_values", 1);
        TTfunVSC_fd_entry_alt_characters_records = TTbuild_fun("VSC_fd_entry_alt_characters_records", 1);
        TTfunVSC_fd_entry_alt_data_name_integer = TTbuild_fun("VSC_fd_entry_alt_data_name_integer", 1);
        TTfunVSC_fd_entry_alt_fd_sd = TTbuild_fun("VSC_fd_entry_alt_fd_sd", 1);
        TTfunVSC_fd_entry_alt_qualified_data_name_literal = TTbuild_fun("VSC_fd_entry_alt_qualified_data_name_literal", 1);
        TTfunVSC_fd_entry_block_contains_clause = TTbuild_fun("VSC_fd_entry_block_contains_clause", 5);
        TTfunVSC_fd_entry_code_set_clause = TTbuild_fun("VSC_fd_entry_code_set_clause", 3);
        TTfunVSC_fd_entry_data_names = TTbuild_fun("VSC_fd_entry_data_names", 1);
        TTfunVSC_fd_entry_data_records_clause = TTbuild_fun("VSC_fd_entry_data_records_clause", 3);
        TTfunVSC_fd_entry_depending_on = TTbuild_fun("VSC_fd_entry_depending_on", 3);
        TTfunVSC_fd_entry_file_and_sort_description_entry = TTbuild_fun("VSC_fd_entry_file_and_sort_description_entry", 4);
        TTfunVSC_fd_entry_file_and_sort_description_entry_clause = TTbuild_fun("VSC_fd_entry_file_and_sort_description_entry_clause", 1);
        TTfunVSC_fd_entry_file_and_sort_description_entry_clauses = TTbuild_fun("VSC_fd_entry_file_and_sort_description_entry_clauses", 1);
        TTfunVSC_fd_entry_footing = TTbuild_fun("VSC_fd_entry_footing", 4);
        TTfunVSC_fd_entry_from_integer = TTbuild_fun("VSC_fd_entry_from_integer", 2);
        TTfunVSC_fd_entry_label_records_clause = TTbuild_fun("VSC_fd_entry_label_records_clause", 3);
        TTfunVSC_fd_entry_label_records_clause_tail = TTbuild_fun("VSC_fd_entry_label_records_clause_tail", 1);
        TTfunVSC_fd_entry_linage_clause = TTbuild_fun("VSC_fd_entry_linage_clause", 5);
        TTfunVSC_fd_entry_linage_footing_phrase = TTbuild_fun("VSC_fd_entry_linage_footing_phrase", 3);
        TTfunVSC_fd_entry_lines_bottom = TTbuild_fun("VSC_fd_entry_lines_bottom", 4);
        TTfunVSC_fd_entry_lines_top = TTbuild_fun("VSC_fd_entry_lines_top", 4);
        TTfunVSC_fd_entry_record_clause = TTbuild_fun("VSC_fd_entry_record_clause", 2);
        TTfunVSC_fd_entry_record_clause_tail = TTbuild_fun("VSC_fd_entry_record_clause_tail", 1);
        TTfunVSC_fd_entry_record_clause_tail_1 = TTbuild_fun("VSC_fd_entry_record_clause_tail_1", 3);
        TTfunVSC_fd_entry_record_clause_tail_2 = TTbuild_fun("VSC_fd_entry_record_clause_tail_2", 5);
        TTfunVSC_fd_entry_record_clause_tail_3 = TTbuild_fun("VSC_fd_entry_record_clause_tail_3", 2);
        TTfunVSC_fd_entry_record_varying_phrase = TTbuild_fun("VSC_fd_entry_record_varying_phrase", 7);
        TTfunVSC_fd_entry_recording_mode_clause = TTbuild_fun("VSC_fd_entry_recording_mode_clause", 4);
        TTfunVSC_fd_entry_records_are = TTbuild_fun("VSC_fd_entry_records_are", 2);
        TTfunVSC_fd_entry_to_integer = TTbuild_fun("VSC_fd_entry_to_integer", 2);
        TTfunVSC_fd_entry_value_of_clause = TTbuild_fun("VSC_fd_entry_value_of_clause", 3);
        TTfunVSC_fd_entry_value_of_clause_tail = TTbuild_fun("VSC_fd_entry_value_of_clause_tail", 3);
        TTfunVSC_id_div_author = TTbuild_fun("VSC_id_div_author", 2);
        TTfunVSC_id_div_date_compiled = TTbuild_fun("VSC_id_div_date_compiled", 2);
        TTfunVSC_id_div_date_written = TTbuild_fun("VSC_id_div_date_written", 2);
        TTfunVSC_id_div_identification = TTbuild_fun("VSC_id_div_identification", 1);
        TTfunVSC_id_div_identification_division = TTbuild_fun("VSC_id_div_identification_division", 5);
        TTfunVSC_id_div_identification_division_content = TTbuild_fun("VSC_id_div_identification_division_content", 1);
        TTfunVSC_id_div_identification_division_phrase = TTbuild_fun("VSC_id_div_identification_division_phrase", 1);
        TTfunVSC_id_div_initial_program = TTbuild_fun("VSC_id_div_initial_program", 3);
        TTfunVSC_id_div_installation = TTbuild_fun("VSC_id_div_installation", 2);
        TTfunVSC_id_div_program_id_cobol_source_program = TTbuild_fun("VSC_id_div_program_id_cobol_source_program", 5);
        TTfunVSC_id_div_remarks = TTbuild_fun("VSC_id_div_remarks", 2);
        TTfunVSC_id_div_security = TTbuild_fun("VSC_id_div_security", 2);
        TTfunVSC_io_sec_alt_assignment_name_file_name = TTbuild_fun("VSC_io_sec_alt_assignment_name_file_name", 1);
        TTfunVSC_io_sec_alt_assignment_name_literal = TTbuild_fun("VSC_io_sec_alt_assignment_name_literal", 1);
        TTfunVSC_io_sec_alt_indexed_relative_sequential = TTbuild_fun("VSC_io_sec_alt_indexed_relative_sequential", 1);
        TTfunVSC_io_sec_alt_sequential_random_dynamic = TTbuild_fun("VSC_io_sec_alt_sequential_random_dynamic", 1);
        TTfunVSC_io_sec_alternate_record_key_clause = TTbuild_fun("VSC_io_sec_alternate_record_key_clause", 7);
        TTfunVSC_io_sec_areas = TTbuild_fun("VSC_io_sec_areas", 1);
        TTfunVSC_io_sec_assign_clause = TTbuild_fun("VSC_io_sec_assign_clause", 3);
        TTfunVSC_io_sec_every_phrase = TTbuild_fun("VSC_io_sec_every_phrase", 1);
        TTfunVSC_io_sec_every_phrase_1 = TTbuild_fun("VSC_io_sec_every_phrase_1", 2);
        TTfunVSC_io_sec_every_phrase_2 = TTbuild_fun("VSC_io_sec_every_phrase_2", 3);
        TTfunVSC_io_sec_fce_access_mode = TTbuild_fun("VSC_io_sec_fce_access_mode", 5);
        TTfunVSC_io_sec_fce_organization = TTbuild_fun("VSC_io_sec_fce_organization", 2);
        TTfunVSC_io_sec_fce_phrase = TTbuild_fun("VSC_io_sec_fce_phrase", 1);
        TTfunVSC_io_sec_file_control_entry = TTbuild_fun("VSC_io_sec_file_control_entry", 4);
        TTfunVSC_io_sec_file_control_paragraph = TTbuild_fun("VSC_io_sec_file_control_paragraph", 3);
        TTfunVSC_io_sec_file_name_position = TTbuild_fun("VSC_io_sec_file_name_position", 2);
        TTfunVSC_io_sec_file_status_clause = TTbuild_fun("VSC_io_sec_file_status_clause", 5);
        TTfunVSC_io_sec_i_o_control_paragraph = TTbuild_fun("VSC_io_sec_i_o_control_paragraph", 4);
        TTfunVSC_io_sec_i_o_sam = TTbuild_fun("VSC_io_sec_i_o_sam", 2);
        TTfunVSC_io_sec_i_o_sort_merge = TTbuild_fun("VSC_io_sec_i_o_sort_merge", 2);
        TTfunVSC_io_sec_input_output_section = TTbuild_fun("VSC_io_sec_input_output_section", 5);
        TTfunVSC_io_sec_organization_is = TTbuild_fun("VSC_io_sec_organization_is", 2);
        TTfunVSC_io_sec_padding_character_clause = TTbuild_fun("VSC_io_sec_padding_character_clause", 4);
        TTfunVSC_io_sec_password_clause = TTbuild_fun("VSC_io_sec_password_clause", 3);
        TTfunVSC_io_sec_position = TTbuild_fun("VSC_io_sec_position", 2);
        TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries = TTbuild_fun("VSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries", 1);
        TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_1 = TTbuild_fun("VSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_1", 7);
        TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_2 = TTbuild_fun("VSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_2", 6);
        TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_3 = TTbuild_fun("VSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_3", 5);
        TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_4 = TTbuild_fun("VSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_4", 4);
        TTfunVSC_io_sec_record_delimiter_clause = TTbuild_fun("VSC_io_sec_record_delimiter_clause", 4);
        TTfunVSC_io_sec_record_delimiter_name = TTbuild_fun("VSC_io_sec_record_delimiter_name", 1);
        TTfunVSC_io_sec_record_key_clause = TTbuild_fun("VSC_io_sec_record_key_clause", 4);
        TTfunVSC_io_sec_record_sort = TTbuild_fun("VSC_io_sec_record_sort", 1);
        TTfunVSC_io_sec_relative_key_clause = TTbuild_fun("VSC_io_sec_relative_key_clause", 4);
        TTfunVSC_io_sec_rerun_on = TTbuild_fun("VSC_io_sec_rerun_on", 3);
        TTfunVSC_io_sec_reserve_clause = TTbuild_fun("VSC_io_sec_reserve_clause", 3);
        TTfunVSC_io_sec_same_area = TTbuild_fun("VSC_io_sec_same_area", 6);
        TTfunVSC_io_sec_select_clause = TTbuild_fun("VSC_io_sec_select_clause", 3);
        TTfunVSC_io_sec_sort_merge_i_o_control_entries = TTbuild_fun("VSC_io_sec_sort_merge_i_o_control_entries", 2);
        TTfunVSC_io_sec_with_duplicates = TTbuild_fun("VSC_io_sec_with_duplicates", 2);
        TTfunVSC_main_cobol_source_program = TTbuild_fun("VSC_main_cobol_source_program", 5);
        TTfunVSC_main_common_initial = TTbuild_fun("VSC_main_common_initial", 1);
        TTfunVSC_main_common_initial_1 = TTbuild_fun("VSC_main_common_initial_1", 2);
        TTfunVSC_main_common_initial_2 = TTbuild_fun("VSC_main_common_initial_2", 2);
        TTfunVSC_main_common_initial_program = TTbuild_fun("VSC_main_common_initial_program", 3);
        TTfunVSC_main_nested_cobol_source_program = TTbuild_fun("VSC_main_nested_cobol_source_program", 13);
        TTfunVSC_main_nested_program = TTbuild_fun("VSC_main_nested_program", 5);
        TTfunVSC_main_program_id_nested_cobol_source_program = TTbuild_fun("VSC_main_program_id_nested_cobol_source_program", 5);
        TTfunVSC_main_programs = TTbuild_fun("VSC_main_programs", 1);
        TTfunVSC_proc_div_altered_goto = TTbuild_fun("VSC_proc_div_altered_goto", 5);
        TTfunVSC_proc_div_declaratives = TTbuild_fun("VSC_proc_div_declaratives", 6);
        TTfunVSC_proc_div_declaratives_content = TTbuild_fun("VSC_proc_div_declaratives_content", 5);
        TTfunVSC_proc_div_paragraph = TTbuild_fun("VSC_proc_div_paragraph", 1);
        TTfunVSC_proc_div_paragraph_1 = TTbuild_fun("VSC_proc_div_paragraph_1", 3);
        TTfunVSC_proc_div_paragraphs = TTbuild_fun("VSC_proc_div_paragraphs", 2);
        TTfunVSC_proc_div_procedure_division = TTbuild_fun("VSC_proc_div_procedure_division", 5);
        TTfunVSC_proc_div_section_header = TTbuild_fun("VSC_proc_div_section_header", 3);
        TTfunVSC_proc_div_section_with_header = TTbuild_fun("VSC_proc_div_section_with_header", 3);
        TTfunVSC_proc_div_sections = TTbuild_fun("VSC_proc_div_sections", 2);
        TTfunVSC_proc_div_sentence = TTbuild_fun("VSC_proc_div_sentence", 1);
        TTfunVSC_proc_div_sentence_1 = TTbuild_fun("VSC_proc_div_sentence_1", 2);
        TTfunVSC_proc_div_sentence_2 = TTbuild_fun("VSC_proc_div_sentence_2", 2);
        TTfunVSC_proc_div_using_data_names = TTbuild_fun("VSC_proc_div_using_data_names", 2);
        TTfunVSC_proc_div_using_phrase = TTbuild_fun("VSC_proc_div_using_phrase", 1);
        TTfunVSC_proc_div_using_phrase_1 = TTbuild_fun("VSC_proc_div_using_phrase_1", 2);
        TTfunVSC_proc_div_using_phrase_2 = TTbuild_fun("VSC_proc_div_using_phrase_2", 2);
        TTfunVSC_stat_accept_statement = TTbuild_fun("VSC_stat_accept_statement", 1);
        TTfunVSC_stat_accept_statement_1 = TTbuild_fun("VSC_stat_accept_statement_1", 3);
        TTfunVSC_stat_accept_statement_2 = TTbuild_fun("VSC_stat_accept_statement_2", 4);
        TTfunVSC_stat_add_statement = TTbuild_fun("VSC_stat_add_statement", 1);
        TTfunVSC_stat_add_statement_1 = TTbuild_fun("VSC_stat_add_statement_1", 7);
        TTfunVSC_stat_add_statement_2 = TTbuild_fun("VSC_stat_add_statement_2", 8);
        TTfunVSC_stat_add_statement_3 = TTbuild_fun("VSC_stat_add_statement_3", 9);
        TTfunVSC_stat_advancing_phrase = TTbuild_fun("VSC_stat_advancing_phrase", 3);
        TTfunVSC_stat_all_procedures = TTbuild_fun("VSC_stat_all_procedures", 2);
        TTfunVSC_stat_also_phrase = TTbuild_fun("VSC_stat_also_phrase", 2);
        TTfunVSC_stat_alt_all_leading = TTbuild_fun("VSC_stat_alt_all_leading", 1);
        TTfunVSC_stat_alt_all_leading_first = TTbuild_fun("VSC_stat_alt_all_leading_first", 1);
        TTfunVSC_stat_alt_before_after = TTbuild_fun("VSC_stat_alt_before_after", 1);
        TTfunVSC_stat_alt_beginning_ending = TTbuild_fun("VSC_stat_alt_beginning_ending", 1);
        TTfunVSC_stat_alt_exception_error = TTbuild_fun("VSC_stat_alt_exception_error", 1);
        TTfunVSC_stat_alt_file_names_i_o = TTbuild_fun("VSC_stat_alt_file_names_i_o", 1);
        TTfunVSC_stat_alt_file_reel_unit = TTbuild_fun("VSC_stat_alt_file_reel_unit", 1);
        TTfunVSC_stat_alt_no_rewind_lock = TTbuild_fun("VSC_stat_alt_no_rewind_lock", 1);
        TTfunVSC_stat_alt_procedures_all_procedures = TTbuild_fun("VSC_stat_alt_procedures_all_procedures", 1);
        TTfunVSC_stat_alt_removal_no_rewind = TTbuild_fun("VSC_stat_alt_removal_no_rewind", 1);
        TTfunVSC_stat_alt_reversed_with_no_rewind = TTbuild_fun("VSC_stat_alt_reversed_with_no_rewind", 1);
        TTfunVSC_stat_alt_run_literal = TTbuild_fun("VSC_stat_alt_run_literal", 1);
        TTfunVSC_stat_alt_statement_list_next_sentence = TTbuild_fun("VSC_stat_alt_statement_list_next_sentence", 1);
        TTfunVSC_stat_alt_up_down = TTbuild_fun("VSC_stat_alt_up_down", 1);
        TTfunVSC_stat_alt_up_down_by = TTbuild_fun("VSC_stat_alt_up_down_by", 2);
        TTfunVSC_stat_alter_statement = TTbuild_fun("VSC_stat_alter_statement", 2);
        TTfunVSC_stat_at_end_of_page_statement_list = TTbuild_fun("VSC_stat_at_end_of_page_statement_list", 3);
        TTfunVSC_stat_at_end_statement_list = TTbuild_fun("VSC_stat_at_end_statement_list", 3);
        TTfunVSC_stat_before_after_phrase = TTbuild_fun("VSC_stat_before_after_phrase", 3);
        TTfunVSC_stat_by_reference = TTbuild_fun("VSC_stat_by_reference", 2);
        TTfunVSC_stat_call_rest_phrase = TTbuild_fun("VSC_stat_call_rest_phrase", 3);
        TTfunVSC_stat_call_statement = TTbuild_fun("VSC_stat_call_statement", 5);
        TTfunVSC_stat_cancel_statement = TTbuild_fun("VSC_stat_cancel_statement", 2);
        TTfunVSC_stat_close_statement = TTbuild_fun("VSC_stat_close_statement", 2);
        TTfunVSC_stat_close_statement_file_name = TTbuild_fun("VSC_stat_close_statement_file_name", 2);
        TTfunVSC_stat_close_statement_options = TTbuild_fun("VSC_stat_close_statement_options", 1);
        TTfunVSC_stat_close_statement_options_1 = TTbuild_fun("VSC_stat_close_statement_options_1", 2);
        TTfunVSC_stat_close_statement_options_2 = TTbuild_fun("VSC_stat_close_statement_options_2", 2);
        TTfunVSC_stat_cobword_int = TTbuild_fun("VSC_stat_cobword_int", 1);
        TTfunVSC_stat_cobword_rounded = TTbuild_fun("VSC_stat_cobword_rounded", 2);
        TTfunVSC_stat_collating_sequence = TTbuild_fun("VSC_stat_collating_sequence", 4);
        TTfunVSC_stat_compute_statement = TTbuild_fun("VSC_stat_compute_statement", 7);
        TTfunVSC_stat_content_parameter = TTbuild_fun("VSC_stat_content_parameter", 3);
        TTfunVSC_stat_content_parameter_value = TTbuild_fun("VSC_stat_content_parameter_value", 1);
        TTfunVSC_stat_continue_statement = TTbuild_fun("VSC_stat_continue_statement", 1);
        TTfunVSC_stat_corresponding = TTbuild_fun("VSC_stat_corresponding", 1);
        TTfunVSC_stat_count_in_identifier = TTbuild_fun("VSC_stat_count_in_identifier", 3);
        TTfunVSC_stat_date = TTbuild_fun("VSC_stat_date", 1);
        TTfunVSC_stat_delete_statement = TTbuild_fun("VSC_stat_delete_statement", 6);
        TTfunVSC_stat_delimited_by_all_phrase = TTbuild_fun("VSC_stat_delimited_by_all_phrase", 5);
        TTfunVSC_stat_delimited_by_phrase = TTbuild_fun("VSC_stat_delimited_by_phrase", 4);
        TTfunVSC_stat_delimiter_in_identifier = TTbuild_fun("VSC_stat_delimiter_in_identifier", 3);
        TTfunVSC_stat_display_statement = TTbuild_fun("VSC_stat_display_statement", 4);
        TTfunVSC_stat_divide_statement = TTbuild_fun("VSC_stat_divide_statement", 1);
        TTfunVSC_stat_divide_statement_1 = TTbuild_fun("VSC_stat_divide_statement_1", 7);
        TTfunVSC_stat_divide_statement_2 = TTbuild_fun("VSC_stat_divide_statement_2", 9);
        TTfunVSC_stat_divide_statement_3 = TTbuild_fun("VSC_stat_divide_statement_3", 9);
        TTfunVSC_stat_divide_statement_4 = TTbuild_fun("VSC_stat_divide_statement_4", 12);
        TTfunVSC_stat_divide_statement_5 = TTbuild_fun("VSC_stat_divide_statement_5", 12);
        TTfunVSC_stat_else_phrase = TTbuild_fun("VSC_stat_else_phrase", 2);
        TTfunVSC_stat_end_of_page = TTbuild_fun("VSC_stat_end_of_page", 1);
        TTfunVSC_stat_entry_statement = TTbuild_fun("VSC_stat_entry_statement", 3);
        TTfunVSC_stat_equal = TTbuild_fun("VSC_stat_equal", 1);
        TTfunVSC_stat_evaluate_condition = TTbuild_fun("VSC_stat_evaluate_condition", 1);
        TTfunVSC_stat_evaluate_phrase = TTbuild_fun("VSC_stat_evaluate_phrase", 1);
        TTfunVSC_stat_evaluate_phrase_1 = TTbuild_fun("VSC_stat_evaluate_phrase_1", 2);
        TTfunVSC_stat_evaluate_phrase_2 = TTbuild_fun("VSC_stat_evaluate_phrase_2", 3);
        TTfunVSC_stat_evaluate_statement = TTbuild_fun("VSC_stat_evaluate_statement", 6);
        TTfunVSC_stat_exit_program_statement = TTbuild_fun("VSC_stat_exit_program_statement", 2);
        TTfunVSC_stat_exit_statement = TTbuild_fun("VSC_stat_exit_statement", 1);
        TTfunVSC_stat_file_names = TTbuild_fun("VSC_stat_file_names", 1);
        TTfunVSC_stat_for_removal = TTbuild_fun("VSC_stat_for_removal", 2);
        TTfunVSC_stat_from_environment_name = TTbuild_fun("VSC_stat_from_environment_name", 2);
        TTfunVSC_stat_from_identifier = TTbuild_fun("VSC_stat_from_identifier", 2);
        TTfunVSC_stat_giving_file_names = TTbuild_fun("VSC_stat_giving_file_names", 2);
        TTfunVSC_stat_go_to_statement = TTbuild_fun("VSC_stat_go_to_statement", 1);
        TTfunVSC_stat_go_to_statement_1 = TTbuild_fun("VSC_stat_go_to_statement_1", 3);
        TTfunVSC_stat_go_to_statement_2 = TTbuild_fun("VSC_stat_go_to_statement_2", 6);
        TTfunVSC_stat_go_to_statement_3 = TTbuild_fun("VSC_stat_go_to_statement_3", 3);
        TTfunVSC_stat_goback_statement = TTbuild_fun("VSC_stat_goback_statement", 1);
        TTfunVSC_stat_id_or_lit = TTbuild_fun("VSC_stat_id_or_lit", 1);
        TTfunVSC_stat_id_or_lit_size = TTbuild_fun("VSC_stat_id_or_lit_size", 1);
        TTfunVSC_stat_if_statement = TTbuild_fun("VSC_stat_if_statement", 6);
        TTfunVSC_stat_initialize_replacing_argument = TTbuild_fun("VSC_stat_initialize_replacing_argument", 4);
        TTfunVSC_stat_initialize_replacing_phrase = TTbuild_fun("VSC_stat_initialize_replacing_phrase", 2);
        TTfunVSC_stat_initialize_replacing_type = TTbuild_fun("VSC_stat_initialize_replacing_type", 1);
        TTfunVSC_stat_initialize_statement = TTbuild_fun("VSC_stat_initialize_statement", 3);
        TTfunVSC_stat_input_procedure = TTbuild_fun("VSC_stat_input_procedure", 5);
        TTfunVSC_stat_inspect_by_argument = TTbuild_fun("VSC_stat_inspect_by_argument", 1);
        TTfunVSC_stat_inspect_replacing_argument = TTbuild_fun("VSC_stat_inspect_replacing_argument", 4);
        TTfunVSC_stat_inspect_replacing_phrase = TTbuild_fun("VSC_stat_inspect_replacing_phrase", 1);
        TTfunVSC_stat_inspect_replacing_phrase_1 = TTbuild_fun("VSC_stat_inspect_replacing_phrase_1", 4);
        TTfunVSC_stat_inspect_replacing_phrase_2 = TTbuild_fun("VSC_stat_inspect_replacing_phrase_2", 2);
        TTfunVSC_stat_inspect_statement = TTbuild_fun("VSC_stat_inspect_statement", 1);
        TTfunVSC_stat_inspect_statement_1 = TTbuild_fun("VSC_stat_inspect_statement_1", 4);
        TTfunVSC_stat_inspect_statement_2 = TTbuild_fun("VSC_stat_inspect_statement_2", 7);
        TTfunVSC_stat_inspect_statement_3 = TTbuild_fun("VSC_stat_inspect_statement_3", 6);
        TTfunVSC_stat_inspect_statement_4 = TTbuild_fun("VSC_stat_inspect_statement_4", 4);
        TTfunVSC_stat_into_identifier = TTbuild_fun("VSC_stat_into_identifier", 2);
        TTfunVSC_stat_invalid_key_statement_list = TTbuild_fun("VSC_stat_invalid_key_statement_list", 3);
        TTfunVSC_stat_key_is = TTbuild_fun("VSC_stat_key_is", 2);
        TTfunVSC_stat_key_is_qualified_data_name = TTbuild_fun("VSC_stat_key_is_qualified_data_name", 3);
        TTfunVSC_stat_key_is_rel_op_qualified_data_name = TTbuild_fun("VSC_stat_key_is_rel_op_qualified_data_name", 4);
        TTfunVSC_stat_lines = TTbuild_fun("VSC_stat_lines", 1);
        TTfunVSC_stat_merge_statement = TTbuild_fun("VSC_stat_merge_statement", 8);
        TTfunVSC_stat_merge_statement_tail = TTbuild_fun("VSC_stat_merge_statement_tail", 1);
        TTfunVSC_stat_move_statement = TTbuild_fun("VSC_stat_move_statement", 1);
        TTfunVSC_stat_move_statement_1 = TTbuild_fun("VSC_stat_move_statement_1", 4);
        TTfunVSC_stat_move_statement_2 = TTbuild_fun("VSC_stat_move_statement_2", 5);
        TTfunVSC_stat_multiply_statement = TTbuild_fun("VSC_stat_multiply_statement", 1);
        TTfunVSC_stat_multiply_statement_1 = TTbuild_fun("VSC_stat_multiply_statement_1", 7);
        TTfunVSC_stat_multiply_statement_2 = TTbuild_fun("VSC_stat_multiply_statement_2", 9);
        TTfunVSC_stat_next_sentence = TTbuild_fun("VSC_stat_next_sentence", 2);
        TTfunVSC_stat_no_rewind = TTbuild_fun("VSC_stat_no_rewind", 2);
        TTfunVSC_stat_not_at_end_of_page_statement_list = TTbuild_fun("VSC_stat_not_at_end_of_page_statement_list", 4);
        TTfunVSC_stat_not_at_end_statement_list = TTbuild_fun("VSC_stat_not_at_end_statement_list", 4);
        TTfunVSC_stat_not_invalid_key_statement_list = TTbuild_fun("VSC_stat_not_invalid_key_statement_list", 4);
        TTfunVSC_stat_not_on_exception_statement_list = TTbuild_fun("VSC_stat_not_on_exception_statement_list", 4);
        TTfunVSC_stat_not_on_overflow_statement_list = TTbuild_fun("VSC_stat_not_on_overflow_statement_list", 4);
        TTfunVSC_stat_not_on_size_error_statement_list = TTbuild_fun("VSC_stat_not_on_size_error_statement_list", 5);
        TTfunVSC_stat_nr_lines_phrase = TTbuild_fun("VSC_stat_nr_lines_phrase", 2);
        TTfunVSC_stat_on_exception_statement_list = TTbuild_fun("VSC_stat_on_exception_statement_list", 3);
        TTfunVSC_stat_on_key_is_phrase = TTbuild_fun("VSC_stat_on_key_is_phrase", 4);
        TTfunVSC_stat_on_key_phrase = TTbuild_fun("VSC_stat_on_key_phrase", 4);
        TTfunVSC_stat_on_overflow_statement_list = TTbuild_fun("VSC_stat_on_overflow_statement_list", 3);
        TTfunVSC_stat_on_size_error_statement_list = TTbuild_fun("VSC_stat_on_size_error_statement_list", 4);
        TTfunVSC_stat_open_statement = TTbuild_fun("VSC_stat_open_statement", 2);
        TTfunVSC_stat_open_statement_extend = TTbuild_fun("VSC_stat_open_statement_extend", 2);
        TTfunVSC_stat_open_statement_i_o = TTbuild_fun("VSC_stat_open_statement_i_o", 2);
        TTfunVSC_stat_open_statement_input = TTbuild_fun("VSC_stat_open_statement_input", 2);
        TTfunVSC_stat_open_statement_input_file_name = TTbuild_fun("VSC_stat_open_statement_input_file_name", 2);
        TTfunVSC_stat_open_statement_output = TTbuild_fun("VSC_stat_open_statement_output", 2);
        TTfunVSC_stat_open_statement_output_file_name = TTbuild_fun("VSC_stat_open_statement_output_file_name", 2);
        TTfunVSC_stat_open_statement_phrase = TTbuild_fun("VSC_stat_open_statement_phrase", 1);
        TTfunVSC_stat_or_all_id_or_lit = TTbuild_fun("VSC_stat_or_all_id_or_lit", 3);
        TTfunVSC_stat_output_procedure = TTbuild_fun("VSC_stat_output_procedure", 5);
        TTfunVSC_stat_page_phrase = TTbuild_fun("VSC_stat_page_phrase", 1);
        TTfunVSC_stat_parameter = TTbuild_fun("VSC_stat_parameter", 1);
        TTfunVSC_stat_perform_after_phrase = TTbuild_fun("VSC_stat_perform_after_phrase", 8);
        TTfunVSC_stat_perform_statement = TTbuild_fun("VSC_stat_perform_statement", 1);
        TTfunVSC_stat_perform_statement_1 = TTbuild_fun("VSC_stat_perform_statement_1", 2);
        TTfunVSC_stat_perform_statement_1_alts = TTbuild_fun("VSC_stat_perform_statement_1_alts", 1);
        TTfunVSC_stat_perform_statement_1_procedure = TTbuild_fun("VSC_stat_perform_statement_1_procedure", 2);
        TTfunVSC_stat_perform_statement_1_statement_list = TTbuild_fun("VSC_stat_perform_statement_1_statement_list", 2);
        TTfunVSC_stat_perform_statement_2 = TTbuild_fun("VSC_stat_perform_statement_2", 2);
        TTfunVSC_stat_perform_statement_2_alts = TTbuild_fun("VSC_stat_perform_statement_2_alts", 1);
        TTfunVSC_stat_perform_statement_2_procedure = TTbuild_fun("VSC_stat_perform_statement_2_procedure", 4);
        TTfunVSC_stat_perform_statement_2_statement_list = TTbuild_fun("VSC_stat_perform_statement_2_statement_list", 3);
        TTfunVSC_stat_perform_statement_3 = TTbuild_fun("VSC_stat_perform_statement_3", 2);
        TTfunVSC_stat_perform_statement_3_alts = TTbuild_fun("VSC_stat_perform_statement_3_alts", 1);
        TTfunVSC_stat_perform_statement_3_procedure = TTbuild_fun("VSC_stat_perform_statement_3_procedure", 4);
        TTfunVSC_stat_perform_statement_3_statement_list = TTbuild_fun("VSC_stat_perform_statement_3_statement_list", 4);
        TTfunVSC_stat_perform_statement_4 = TTbuild_fun("VSC_stat_perform_statement_4", 2);
        TTfunVSC_stat_perform_statement_4_alts = TTbuild_fun("VSC_stat_perform_statement_4_alts", 1);
        TTfunVSC_stat_perform_statement_4_procedure = TTbuild_fun("VSC_stat_perform_statement_4_procedure", 3);
        TTfunVSC_stat_perform_statement_4_statement_list = TTbuild_fun("VSC_stat_perform_statement_4_statement_list", 3);
        TTfunVSC_stat_perform_until_phrase = TTbuild_fun("VSC_stat_perform_until_phrase", 3);
        TTfunVSC_stat_perform_varying_phrase = TTbuild_fun("VSC_stat_perform_varying_phrase", 9);
        TTfunVSC_stat_procedure_names = TTbuild_fun("VSC_stat_procedure_names", 1);
        TTfunVSC_stat_procedure_to_procedure = TTbuild_fun("VSC_stat_procedure_to_procedure", 4);
        TTfunVSC_stat_proceed_to = TTbuild_fun("VSC_stat_proceed_to", 2);
        TTfunVSC_stat_read_statement = TTbuild_fun("VSC_stat_read_statement", 11);
        TTfunVSC_stat_reference_parameter = TTbuild_fun("VSC_stat_reference_parameter", 2);
        TTfunVSC_stat_rel_op = TTbuild_fun("VSC_stat_rel_op", 1);
        TTfunVSC_stat_release_statement = TTbuild_fun("VSC_stat_release_statement", 3);
        TTfunVSC_stat_return_statement = TTbuild_fun("VSC_stat_return_statement", 9);
        TTfunVSC_stat_rewrite_statement = TTbuild_fun("VSC_stat_rewrite_statement", 6);
        TTfunVSC_stat_search_statement = TTbuild_fun("VSC_stat_search_statement", 1);
        TTfunVSC_stat_search_statement_1 = TTbuild_fun("VSC_stat_search_statement_1", 6);
        TTfunVSC_stat_search_statement_2 = TTbuild_fun("VSC_stat_search_statement_2", 9);
        TTfunVSC_stat_search_statement_condition = TTbuild_fun("VSC_stat_search_statement_condition", 1);
        TTfunVSC_stat_search_statement_condition_tail = TTbuild_fun("VSC_stat_search_statement_condition_tail", 2);
        TTfunVSC_stat_search_statement_equal_expression = TTbuild_fun("VSC_stat_search_statement_equal_expression", 4);
        TTfunVSC_stat_set_oper = TTbuild_fun("VSC_stat_set_oper", 1);
        TTfunVSC_stat_set_src = TTbuild_fun("VSC_stat_set_src", 1);
        TTfunVSC_stat_set_statement = TTbuild_fun("VSC_stat_set_statement", 2);
        TTfunVSC_stat_set_statement_phrase = TTbuild_fun("VSC_stat_set_statement_phrase", 3);
        TTfunVSC_stat_sort_statement = TTbuild_fun("VSC_stat_sort_statement", 7);
        TTfunVSC_stat_sort_statement_in = TTbuild_fun("VSC_stat_sort_statement_in", 1);
        TTfunVSC_stat_sort_statement_out = TTbuild_fun("VSC_stat_sort_statement_out", 1);
        TTfunVSC_stat_start_statement = TTbuild_fun("VSC_stat_start_statement", 6);
        TTfunVSC_stat_statement = TTbuild_fun("VSC_stat_statement", 1);
        TTfunVSC_stat_statement_list = TTbuild_fun("VSC_stat_statement_list", 1);
        TTfunVSC_stat_stop_statement = TTbuild_fun("VSC_stat_stop_statement", 2);
        TTfunVSC_stat_string_statement = TTbuild_fun("VSC_stat_string_statement", 8);
        TTfunVSC_stat_subtract_statement = TTbuild_fun("VSC_stat_subtract_statement", 1);
        TTfunVSC_stat_subtract_statement_1 = TTbuild_fun("VSC_stat_subtract_statement_1", 7);
        TTfunVSC_stat_subtract_statement_2 = TTbuild_fun("VSC_stat_subtract_statement_2", 9);
        TTfunVSC_stat_subtract_statement_3 = TTbuild_fun("VSC_stat_subtract_statement_3", 9);
        TTfunVSC_stat_tallying_argument = TTbuild_fun("VSC_stat_tallying_argument", 3);
        TTfunVSC_stat_tallying_for_argument = TTbuild_fun("VSC_stat_tallying_for_argument", 1);
        TTfunVSC_stat_tallying_for_argument_1 = TTbuild_fun("VSC_stat_tallying_for_argument_1", 2);
        TTfunVSC_stat_tallying_for_argument_2 = TTbuild_fun("VSC_stat_tallying_for_argument_2", 2);
        TTfunVSC_stat_tallying_for_id_or_lit = TTbuild_fun("VSC_stat_tallying_for_id_or_lit", 2);
        TTfunVSC_stat_tallying_in_identifier = TTbuild_fun("VSC_stat_tallying_in_identifier", 3);
        TTfunVSC_stat_through_procedure_name = TTbuild_fun("VSC_stat_through_procedure_name", 2);
        TTfunVSC_stat_to_id_or_lit = TTbuild_fun("VSC_stat_to_id_or_lit", 2);
        TTfunVSC_stat_unstring_statement = TTbuild_fun("VSC_stat_unstring_statement", 10);
        TTfunVSC_stat_unstring_statement_dst = TTbuild_fun("VSC_stat_unstring_statement_dst", 3);
        TTfunVSC_stat_upon_environment_name = TTbuild_fun("VSC_stat_upon_environment_name", 2);
        TTfunVSC_stat_use_statement = TTbuild_fun("VSC_stat_use_statement", 1);
        TTfunVSC_stat_use_statement_1 = TTbuild_fun("VSC_stat_use_statement_1", 8);
        TTfunVSC_stat_use_statement_2 = TTbuild_fun("VSC_stat_use_statement_2", 10);
        TTfunVSC_stat_use_statement_3 = TTbuild_fun("VSC_stat_use_statement_3", 5);
        TTfunVSC_stat_using_data_name_pluslist = TTbuild_fun("VSC_stat_using_data_name_pluslist", 2);
        TTfunVSC_stat_using_file_names = TTbuild_fun("VSC_stat_using_file_names", 2);
        TTfunVSC_stat_using_parameters = TTbuild_fun("VSC_stat_using_parameters", 2);
        TTfunVSC_stat_varying_identifier = TTbuild_fun("VSC_stat_varying_identifier", 2);
        TTfunVSC_stat_when_condition_stats = TTbuild_fun("VSC_stat_when_condition_stats", 3);
        TTfunVSC_stat_when_other_phrase = TTbuild_fun("VSC_stat_when_other_phrase", 3);
        TTfunVSC_stat_when_phrase = TTbuild_fun("VSC_stat_when_phrase", 3);
        TTfunVSC_stat_when_phrase_also_phrase = TTbuild_fun("VSC_stat_when_phrase_also_phrase", 2);
        TTfunVSC_stat_when_phrases = TTbuild_fun("VSC_stat_when_phrases", 2);
        TTfunVSC_stat_with_duplicates_in_order = TTbuild_fun("VSC_stat_with_duplicates_in_order", 4);
        TTfunVSC_stat_with_no_advancing = TTbuild_fun("VSC_stat_with_no_advancing", 3);
        TTfunVSC_stat_with_no_rewind = TTbuild_fun("VSC_stat_with_no_rewind", 3);
        TTfunVSC_stat_with_pointer_identifier = TTbuild_fun("VSC_stat_with_pointer_identifier", 3);
        TTfunVSC_stat_with_test = TTbuild_fun("VSC_stat_with_test", 3);
        TTfunVSC_stat_write_exceptions = TTbuild_fun("VSC_stat_write_exceptions", 4);
        TTfunVSC_stat_write_statement = TTbuild_fun("VSC_stat_write_statement", 6);
        TTfunVSC_lex_picture_string = TTbuild_fun("VSC_lex_picture_string", 1);
        TTfunVSC_lex_quoted_pseudo_text = TTbuild_fun("VSC_lex_quoted_pseudo_text", 1);
        TTfunVSC_lex_num = TTbuild_fun("VSC_lex_num", 1);
        TTfunVSC_lex_nonnumeric = TTbuild_fun("VSC_lex_nonnumeric", 1);
        TTfunVSC_lex_cobword = TTbuild_fun("VSC_lex_cobword", 1);
    }
    init++;
}

static BOOL TTist_END_WRITE_opt(TTterm t);
static BOOL TTist_END_WRITE(TTterm t);
static BOOL TTisVSC_stat_advancing_phrase_opt(TTterm t);
static BOOL TTist_WRITE(TTterm t);
static BOOL TTisVSC_stat_not_at_end_of_page_statement_list_opt(TTterm t);
static BOOL TTisVSC_stat_at_end_of_page_statement_list_opt(TTterm t);
static BOOL TTist_TEST(TTterm t);
static BOOL TTist_ORDER_opt(TTterm t);
static BOOL TTist_ORDER(TTterm t);
static BOOL TTisVSC_stat_when_phrase_plus(TTterm t);
static BOOL TTisVSC_stat_when_phrase_also_phrase_star(TTterm t);
static BOOL TTist_OTHER(TTterm t);
static BOOL TTisVSC_stat_parameter_plus(TTterm t);
static BOOL TTisVSC_stat_alt_file_reel_unit_opt(TTterm t);
static BOOL TTisVSC_stat_alt_beginning_ending_opt(TTterm t);
static BOOL TTist_STANDARD_opt(TTterm t);
static BOOL TTist_GLOBAL_opt(TTterm t);
static BOOL TTist_USE(TTterm t);
static BOOL TTist_UPON(TTterm t);
static BOOL TTisVSC_stat_count_in_identifier_opt(TTterm t);
static BOOL TTisVSC_stat_delimiter_in_identifier_opt(TTterm t);
static BOOL TTist_END_UNSTRING_opt(TTterm t);
static BOOL TTist_END_UNSTRING(TTterm t);
static BOOL TTisVSC_stat_tallying_in_identifier_opt(TTterm t);
static BOOL TTisVSC_stat_unstring_statement_dst_plus(TTterm t);
static BOOL TTisVSC_stat_delimited_by_all_phrase_opt(TTterm t);
static BOOL TTist_UNSTRING(TTterm t);
static BOOL TTisVSC_stat_tallying_for_id_or_lit_plus(TTterm t);
static BOOL TTisVSC_stat_tallying_for_argument_plus(TTterm t);
static BOOL TTist_END_SUBTRACT_opt(TTterm t);
static BOOL TTist_END_SUBTRACT(TTterm t);
static BOOL TTist_SUBTRACT(TTterm t);
static BOOL TTist_END_STRING_opt(TTterm t);
static BOOL TTist_END_STRING(TTterm t);
static BOOL TTisVSC_stat_not_on_overflow_statement_list_opt(TTterm t);
static BOOL TTisVSC_stat_with_pointer_identifier_opt(TTterm t);
static BOOL TTisVSC_stat_delimited_by_phrase_plus(TTterm t);
static BOOL TTist_STRING(TTterm t);
static BOOL TTist_STOP(TTterm t);
static BOOL TTisVSC_stat_statement_plus(TTterm t);
static BOOL TTist_END_START_opt(TTterm t);
static BOOL TTist_END_START(TTterm t);
static BOOL TTisVSC_stat_key_is_rel_op_qualified_data_name_opt(TTterm t);
static BOOL TTist_START(TTterm t);
static BOOL TTisVSC_stat_with_duplicates_in_order_opt(TTterm t);
static BOOL TTisVSC_stat_on_key_is_phrase_plus(TTterm t);
static BOOL TTisVSC_stat_set_statement_phrase_plus(TTterm t);
static BOOL TTist_SET(TTterm t);
static BOOL TTisVSC_stat_search_statement_condition_tail_star(TTterm t);
static BOOL TTist_END_SEARCH_opt(TTterm t);
static BOOL TTist_END_SEARCH(TTterm t);
static BOOL TTisVSC_stat_when_condition_stats_plus(TTterm t);
static BOOL TTisVSC_stat_varying_identifier_opt(TTterm t);
static BOOL TTist_SEARCH(TTterm t);
static BOOL TTist_END_REWRITE_opt(TTterm t);
static BOOL TTist_END_REWRITE(TTterm t);
static BOOL TTist_REWRITE(TTterm t);
static BOOL TTist_END_RETURN_opt(TTterm t);
static BOOL TTist_END_RETURN(TTterm t);
static BOOL TTist_RETURN(TTterm t);
static BOOL TTisVSC_stat_from_identifier_opt(TTterm t);
static BOOL TTist_RELEASE(TTterm t);
static BOOL TTisVSC_stat_by_reference_opt(TTterm t);
static BOOL TTist_END_READ_opt(TTterm t);
static BOOL TTist_END_READ(TTterm t);
static BOOL TTisVSC_stat_not_at_end_statement_list_opt(TTterm t);
static BOOL TTisVSC_stat_at_end_statement_list_opt(TTterm t);
static BOOL TTisVSC_stat_key_is_qualified_data_name_opt(TTterm t);
static BOOL TTisVSC_stat_into_identifier_opt(TTterm t);
static BOOL TTist_NEXT_opt(TTterm t);
static BOOL TTist_READ(TTterm t);
static BOOL TTist_PROCEED(TTterm t);
static BOOL TTisVSC_stat_proceed_to_opt(TTterm t);
static BOOL TTisVSC_stat_with_test_opt(TTterm t);
static BOOL TTisVSC_stat_perform_after_phrase_star(TTterm t);
static BOOL TTist_END_PERFORM(TTterm t);
static BOOL TTist_PERFORM(TTterm t);
static BOOL TTist_UNTIL(TTterm t);
static BOOL TTist_PAGE(TTterm t);
static BOOL TTisVSC_stat_with_no_rewind_opt(TTterm t);
static BOOL TTisVSC_stat_open_statement_output_file_name_plus(TTterm t);
static BOOL TTisVSC_stat_alt_reversed_with_no_rewind_opt(TTterm t);
static BOOL TTisVSC_stat_open_statement_input_file_name_plus(TTterm t);
static BOOL TTisVSC_stat_open_statement_phrase_plus(TTterm t);
static BOOL TTist_OPEN(TTterm t);
static BOOL TTisVSC_stat_key_is_opt(TTterm t);
static BOOL TTisVSC_stat_lines_opt(TTterm t);
static BOOL TTist_OVERFLOW(TTterm t);
static BOOL TTist_REWIND(TTterm t);
static BOOL TTist_NO(TTterm t);
static BOOL TTist_SENTENCE(TTterm t);
static BOOL TTist_NEXT(TTterm t);
static BOOL TTist_END_MULTIPLY_opt(TTterm t);
static BOOL TTist_END_MULTIPLY(TTterm t);
static BOOL TTist_MULTIPLY(TTterm t);
static BOOL TTist_MOVE(TTterm t);
static BOOL TTisVSC_stat_collating_sequence_opt(TTterm t);
static BOOL TTisVSC_stat_on_key_phrase_plus(TTterm t);
static BOOL TTist_MERGE(TTterm t);
static BOOL TTist_LINE(TTterm t);
static BOOL TTist_INVALID(TTterm t);
static BOOL TTisVSC_stat_inspect_replacing_phrase_plus(TTterm t);
static BOOL TTist_CONVERTING(TTterm t);
static BOOL TTisVSC_stat_tallying_argument_plus(TTterm t);
static BOOL TTist_TALLYING(TTterm t);
static BOOL TTist_INSPECT(TTterm t);
static BOOL TTisVSC_stat_inspect_replacing_argument_plus(TTterm t);
static BOOL TTisVSC_stat_before_after_phrase_star(TTterm t);
static BOOL TTisVSC_stat_through_procedure_name_opt(TTterm t);
static BOOL TTisVSC_stat_initialize_replacing_phrase_opt(TTterm t);
static BOOL TTisVSC_expr_identifier_plus(TTterm t);
static BOOL TTist_INITIALIZE(TTterm t);
static BOOL TTist_EGCS(TTterm t);
static BOOL TTist_NUMERIC_EDITED(TTterm t);
static BOOL TTist_ALPHANUMERIC_EDITED(TTterm t);
static BOOL TTist_ALPHANUMERIC(TTterm t);
static BOOL TTisVSC_stat_initialize_replacing_argument_plus(TTterm t);
static BOOL TTist_DATA_opt(TTterm t);
static BOOL TTist_END_IF_opt(TTterm t);
static BOOL TTist_END_IF(TTterm t);
static BOOL TTisVSC_stat_else_phrase_opt(TTterm t);
static BOOL TTist_IF(TTterm t);
static BOOL TTist_GOBACK(TTterm t);
static BOOL TTist_MORE_LABELS(TTterm t);
static BOOL TTisVSC_expr_procedure_name_plus(TTterm t);
static BOOL TTist_REMOVAL(TTterm t);
static BOOL TTist_EXIT(TTterm t);
static BOOL TTist_END_EVALUATE_opt(TTterm t);
static BOOL TTist_END_EVALUATE(TTterm t);
static BOOL TTisVSC_stat_when_other_phrase_opt(TTterm t);
static BOOL TTisVSC_stat_when_phrases_plus(TTterm t);
static BOOL TTisVSC_stat_also_phrase_star(TTterm t);
static BOOL TTist_EVALUATE(TTterm t);
static BOOL TTist_ANY(TTterm t);
static BOOL TTist_FALSE(TTterm t);
static BOOL TTist_TRUE(TTterm t);
static BOOL TTist_ENTRY(TTterm t);
static BOOL TTist_EOP(TTterm t);
static BOOL TTist_END_OF_PAGE(TTterm t);
static BOOL TTist_ELSE(TTterm t);
static BOOL TTist_REMAINDER(TTterm t);
static BOOL TTist_END_DIVIDE_opt(TTterm t);
static BOOL TTist_END_DIVIDE(TTterm t);
static BOOL TTist_INTO(TTterm t);
static BOOL TTist_DIVIDE(TTterm t);
static BOOL TTisVSC_stat_with_no_advancing_opt(TTterm t);
static BOOL TTisVSC_stat_upon_environment_name_opt(TTterm t);
static BOOL TTisVSC_stat_or_all_id_or_lit_star(TTterm t);
static BOOL TTist_ALL_opt(TTterm t);
static BOOL TTist_DELIMITED(TTterm t);
static BOOL TTist_END_DELETE_opt(TTterm t);
static BOOL TTist_END_DELETE(TTterm t);
static BOOL TTisVSC_stat_not_invalid_key_statement_list_opt(TTterm t);
static BOOL TTisVSC_stat_invalid_key_statement_list_opt(TTterm t);
static BOOL TTist_DELETE(TTterm t);
static BOOL TTist_TIME(TTterm t);
static BOOL TTist_DAY_OF_WEEK(TTterm t);
static BOOL TTist_DAY(TTterm t);
static BOOL TTist_DATE(TTterm t);
static BOOL TTist_COUNT(TTterm t);
static BOOL TTist_CORR(TTterm t);
static BOOL TTist_CORRESPONDING(TTterm t);
static BOOL TTist_CONTINUE(TTterm t);
static BOOL TTisVSC_stat_content_parameter_value_plus(TTterm t);
static BOOL TTist_CONTENT(TTterm t);
static BOOL TTist_END_COMPUTE_opt(TTterm t);
static BOOL TTist_END_COMPUTE(TTterm t);
static BOOL TTist_COMPUTE(TTterm t);
static BOOL TTisVSC_stat_alt_removal_no_rewind_opt(TTterm t);
static BOOL TTisVSC_stat_close_statement_options_opt(TTterm t);
static BOOL TTisVSC_stat_close_statement_file_name_plus(TTterm t);
static BOOL TTist_CLOSE(TTterm t);
static BOOL TTist_CANCEL(TTterm t);
static BOOL TTist_END_CALL_opt(TTterm t);
static BOOL TTist_END_CALL(TTterm t);
static BOOL TTisVSC_stat_using_parameters_opt(TTterm t);
static BOOL TTist_CALL(TTterm t);
static BOOL TTisVSC_stat_on_overflow_statement_list_opt(TTterm t);
static BOOL TTisVSC_stat_not_on_exception_statement_list_opt(TTterm t);
static BOOL TTisVSC_stat_on_exception_statement_list_opt(TTterm t);
static BOOL TTist_REFERENCE(TTterm t);
static BOOL TTisVSC_stat_procedure_to_procedure_plus(TTterm t);
static BOOL TTist_ALTER(TTterm t);
static BOOL TTist_DOWN(TTterm t);
static BOOL TTist_UP(TTterm t);
static BOOL TTist_RUN(TTterm t);
static BOOL TTist_REVERSED(TTterm t);
static BOOL TTist_LOCK(TTterm t);
static BOOL TTist_EXTEND(TTterm t);
static BOOL TTist_I_O(TTterm t);
static BOOL TTist_OUTPUT(TTterm t);
static BOOL TTist_INPUT(TTterm t);
static BOOL TTist_ERROR(TTterm t);
static BOOL TTist_EXCEPTION(TTterm t);
static BOOL TTist_ENDING(TTterm t);
static BOOL TTist_BEGINNING(TTterm t);
static BOOL TTist_AFTER(TTterm t);
static BOOL TTist_BEFORE(TTterm t);
static BOOL TTist_FIRST(TTterm t);
static BOOL TTist_PROCEDURES(TTterm t);
static BOOL TTist_ADVANCING_opt(TTterm t);
static BOOL TTist_ADVANCING(TTterm t);
static BOOL TTist_ROUNDED_opt(TTterm t);
static BOOL TTist_ROUNDED(TTterm t);
static BOOL TTist_GIVING(TTterm t);
static BOOL TTisVSC_stat_to_id_or_lit_opt(TTterm t);
static BOOL TTist_END_ADD_opt(TTterm t);
static BOOL TTist_END_ADD(TTterm t);
static BOOL TTisVSC_stat_not_on_size_error_statement_list_opt(TTterm t);
static BOOL TTisVSC_stat_on_size_error_statement_list_opt(TTterm t);
static BOOL TTisVSC_stat_cobword_rounded_plus(TTterm t);
static BOOL TTisVSC_stat_id_or_lit_plus(TTterm t);
static BOOL TTist_ADD(TTterm t);
static BOOL TTisVSC_stat_from_environment_name_opt(TTterm t);
static BOOL TTist_ACCEPT(TTterm t);
static BOOL TTisVSC_proc_div_using_data_names_opt(TTterm t);
static BOOL TTisVSC_stat_using_data_name_pluslist_opt(TTterm t);
static BOOL TTisVSC_expr_data_name_star(TTterm t);
static BOOL TTist_USING(TTterm t);
static BOOL TTisVSC_stat_statement_list_opt(TTterm t);
static BOOL TTist_qdot_plus(TTterm t);
static BOOL TTisVSC_proc_div_section_with_header_star(TTterm t);
static BOOL TTisVSC_expr_priority_number_opt(TTterm t);
static BOOL TTisVSC_proc_div_declaratives_opt(TTterm t);
static BOOL TTist_PROCEDURE(TTterm t);
static BOOL TTisVSC_proc_div_paragraph_star(TTterm t);
static BOOL TTisVSC_proc_div_sentence_star(TTterm t);
static BOOL TTisVSC_proc_div_declaratives_content_plus(TTterm t);
static BOOL TTist_DECLARATIVES(TTterm t);
static BOOL TTist_GO(TTterm t);
static BOOL TTisVSC_main_cobol_source_program_plus(TTterm t);
static BOOL TTisVSC_main_common_initial_program_opt(TTterm t);
static BOOL TTisVSC_main_nested_cobol_source_program_star(TTterm t);
static BOOL TTisVSC_id_div_identification_division_content_opt(TTterm t);
static BOOL TTist_COMMON_opt(TTterm t);
static BOOL TTist_INITIAL_opt(TTterm t);
static BOOL TTist_COMMON(TTterm t);
static BOOL TTisVSC_main_nested_program_opt(TTterm t);
static BOOL TTisVSC_proc_div_procedure_division_opt(TTterm t);
static BOOL TTisVSC_data_div_data_division_opt(TTterm t);
static BOOL TTisVSC_env_div_environment_division_opt(TTterm t);
static BOOL TTist_DUPLICATES(TTterm t);
static BOOL TTisVSC_io_sec_same_area_plus(TTterm t);
static BOOL TTisVSC_io_sec_rerun_on_opt(TTterm t);
static BOOL TTist_OPTIONAL_opt(TTterm t);
static BOOL TTist_OPTIONAL(TTterm t);
static BOOL TTist_SELECT(TTterm t);
static BOOL TTisVSC_io_sec_areas_opt(TTterm t);
static BOOL TTist_RESERVE(TTterm t);
static BOOL TTist_SORT_MERGE(TTterm t);
static BOOL TTist_SORT(TTterm t);
static BOOL TTist_DELIMITER(TTterm t);
static BOOL TTist_WRITE_ONLY(TTterm t);
static BOOL TTist_APPLY(TTterm t);
static BOOL TTisVSC_io_sec_file_name_position_plus(TTterm t);
static BOOL TTist_TAPE_opt(TTterm t);
static BOOL TTist_TAPE(TTterm t);
static BOOL TTist_MULTIPLE(TTterm t);
static BOOL TTisVSC_expr_file_name_plus(TTterm t);
static BOOL TTist_FOR_opt(TTterm t);
static BOOL TTist_FOR(TTterm t);
static BOOL TTist_AREA_opt(TTterm t);
static BOOL TTist_SAME(TTterm t);
static BOOL TTist_EVERY_opt(TTterm t);
static BOOL TTist_EVERY(TTterm t);
static BOOL TTist_RERUN(TTterm t);
static BOOL TTist_POSITION(TTterm t);
static BOOL TTist_PASSWORD(TTterm t);
static BOOL TTist_PADDING(TTterm t);
static BOOL TTist_ORGANIZATION(TTterm t);
static BOOL TTisVSC_io_sec_i_o_control_paragraph_opt(TTterm t);
static BOOL TTisVSC_io_sec_file_control_paragraph_opt(TTterm t);
static BOOL TTist_INPUT_OUTPUT(TTterm t);
static BOOL TTisVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_plus(TTterm t);
static BOOL TTisVSC_io_sec_i_o_sort_merge_opt(TTterm t);
static BOOL TTisVSC_io_sec_i_o_sam_opt(TTterm t);
static BOOL TTist_I_O_CONTROL(TTterm t);
static BOOL TTisVSC_expr_qualified_data_name_opt(TTterm t);
static BOOL TTist_FILE_opt(TTterm t);
static BOOL TTisVSC_io_sec_position_opt(TTterm t);
static BOOL TTisVSC_io_sec_file_control_entry_star(TTterm t);
static BOOL TTist_FILE_CONTROL(TTterm t);
static BOOL TTisVSC_io_sec_fce_phrase_star(TTterm t);
static BOOL TTisVSC_io_sec_organization_is_opt(TTterm t);
static BOOL TTisVSC_io_sec_relative_key_clause_opt(TTterm t);
static BOOL TTist_ACCESS(TTterm t);
static BOOL TTist_OF_opt(TTterm t);
static BOOL TTist_END(TTterm t);
static BOOL TTisVSC_io_sec_alt_assignment_name_literal_plus(TTterm t);
static BOOL TTist_ASSIGN(TTterm t);
static BOOL TTist_AREAS(TTterm t);
static BOOL TTist_AREA(TTterm t);
static BOOL TTisVSC_io_sec_with_duplicates_opt(TTterm t);
static BOOL TTisVSC_io_sec_password_clause_opt(TTterm t);
static BOOL TTist_RECORD_opt(TTterm t);
static BOOL TTist_ALTERNATE(TTterm t);
static BOOL TTist_DYNAMIC(TTterm t);
static BOOL TTist_RANDOM(TTterm t);
static BOOL TTist_SEQUENTIAL(TTterm t);
static BOOL TTist_RELATIVE(TTterm t);
static BOOL TTist_SECURITY(TTterm t);
static BOOL TTist_REMARKS(TTterm t);
static BOOL TTisVSC_id_div_initial_program_opt(TTterm t);
static BOOL TTist_PROGRAM_ID(TTterm t);
static BOOL TTist_INSTALLATION(TTterm t);
static BOOL TTist_INITIAL(TTterm t);
static BOOL TTisVSC_id_div_identification_division_phrase_star(TTterm t);
static BOOL TTist_ID(TTterm t);
static BOOL TTist_IDENTIFICATION(TTterm t);
static BOOL TTist_DATE_WRITTEN(TTterm t);
static BOOL TTist_DATE_COMPILED(TTterm t);
static BOOL TTist_AUTHOR(TTterm t);
static BOOL TTisVSC_fd_entry_value_of_clause_tail_plus(TTterm t);
static BOOL TTist_MODE_opt(TTterm t);
static BOOL TTist_RECORDING(TTterm t);
static BOOL TTisVSC_fd_entry_to_integer_opt(TTterm t);
static BOOL TTisVSC_fd_entry_from_integer_opt(TTterm t);
static BOOL TTist_IN_opt(TTterm t);
static BOOL TTist_VARYING(TTterm t);
static BOOL TTisVSC_fd_entry_depending_on_opt(TTterm t);
static BOOL TTist_TOP(TTterm t);
static BOOL TTist_BOTTOM(TTterm t);
static BOOL TTisVSC_fd_entry_lines_bottom_opt(TTterm t);
static BOOL TTisVSC_fd_entry_lines_top_opt(TTterm t);
static BOOL TTisVSC_fd_entry_footing_opt(TTterm t);
static BOOL TTist_LINES_opt(TTterm t);
static BOOL TTist_LINES(TTterm t);
static BOOL TTist_LINAGE(TTterm t);
static BOOL TTist_OMITTED(TTterm t);
static BOOL TTist_STANDARD(TTterm t);
static BOOL TTist_LABEL(TTterm t);
static BOOL TTist_FROM_opt(TTterm t);
static BOOL TTist_FROM(TTterm t);
static BOOL TTist_AT_opt(TTterm t);
static BOOL TTist_AT(TTterm t);
static BOOL TTist_FOOTING(TTterm t);
static BOOL TTisVSC_fd_entry_file_and_sort_description_entry_clause_star(TTterm t);
static BOOL TTisVSC_expr_data_name_plus(TTterm t);
static BOOL TTist_CODE_SET(TTterm t);
static BOOL TTisVSC_fd_entry_alt_characters_records_opt(TTterm t);
static BOOL TTist_CONTAINS_opt(TTterm t);
static BOOL TTist_CONTAINS(TTterm t);
static BOOL TTist_BLOCK(TTterm t);
static BOOL TTist_SD(TTterm t);
static BOOL TTist_FD(TTterm t);
static BOOL TTist_VALUES(TTterm t);
static BOOL TTist_VALUE(TTterm t);
static BOOL TTisVSC_expr_times_div_tail_star(TTterm t);
static BOOL TTist_THRU(TTterm t);
static BOOL TTist_THROUGH(TTterm t);
static BOOL TTisVSC_expr_plus_minus_integer_opt(TTterm t);
static BOOL TTisVSC_expr_subscript_expression_plus(TTterm t);
static BOOL TTist_LENGTH(TTterm t);
static BOOL TTist_ADDRESS(TTterm t);
static BOOL TTisVSC_expr_length_opt(TTterm t);
static BOOL TTist_qcolon(TTterm t);
static BOOL TTist_RECORDS(TTterm t);
static BOOL TTist_RECORD(TTterm t);
static BOOL TTisVSC_expr_in_data_or_file_name_star(TTterm t);
static BOOL TTisVSC_expr_in_section_name_opt(TTterm t);
static BOOL TTist_qmultiply_qmultiply(TTterm t);
static BOOL TTisVSC_expr_power_tail_star(TTterm t);
static BOOL TTisVSC_expr_alt_plus_minus_opt(TTterm t);
static BOOL TTisVSC_expr_through_literal_opt(TTterm t);
static BOOL TTist_OF(TTterm t);
static BOOL TTisVSC_expr_in_file_name_opt(TTterm t);
static BOOL TTist_LINAGE_COUNTER(TTterm t);
static BOOL TTisVSC_expr_reference_modification_opt(TTterm t);
static BOOL TTist_NULLS(TTterm t);
static BOOL TTist_NULL(TTterm t);
static BOOL TTist_QUOTES(TTterm t);
static BOOL TTist_QUOTE(TTterm t);
static BOOL TTist_LOW_VALUES(TTterm t);
static BOOL TTist_LOW_VALUE(TTterm t);
static BOOL TTist_HIGH_VALUES(TTterm t);
static BOOL TTist_HIGH_VALUE(TTterm t);
static BOOL TTist_SPACES(TTterm t);
static BOOL TTist_SPACE(TTterm t);
static BOOL TTist_ALL(TTterm t);
static BOOL TTisVSC_expr_copy_statement_by_phrase_plus(TTterm t);
static BOOL TTist_REPLACING(TTterm t);
static BOOL TTisVSC_expr_copy_statement_replacing_phrase_opt(TTterm t);
static BOOL TTist_SUPPRESS_opt(TTterm t);
static BOOL TTist_SUPPRESS(TTterm t);
static BOOL TTisVSC_expr_in_library_opt(TTterm t);
static BOOL TTist_COPY(TTterm t);
static BOOL TTisVSC_expr_arithmetic_expression_tail_star(TTterm t);
static BOOL TTist_qdivide(TTterm t);
static BOOL TTist_qmultiply(TTterm t);
static BOOL TTist_UNIT(TTterm t);
static BOOL TTist_REEL(TTterm t);
static BOOL TTist__(TTterm t);
static BOOL TTist_qplus(TTterm t);
static BOOL TTist_DESCENDING(TTterm t);
static BOOL TTist_ASCENDING(TTterm t);
static BOOL TTisVSC_io_sec_input_output_section_opt(TTterm t);
static BOOL TTisVSC_conf_sec_configuration_section_opt(TTterm t);
static BOOL TTist_ENVIRONMENT(TTterm t);
static BOOL TTist_USAGE(TTterm t);
static BOOL TTisVSC_dd_entry_usage_is_opt(TTterm t);
static BOOL TTist_POINTER(TTterm t);
static BOOL TTist_PACKED_DECIMAL(TTterm t);
static BOOL TTist_INDEX(TTterm t);
static BOOL TTist_DISPLAY_1(TTterm t);
static BOOL TTist_DISPLAY(TTterm t);
static BOOL TTist_COMPUTATIONAL_4(TTterm t);
static BOOL TTist_COMPUTATIONAL_3(TTterm t);
static BOOL TTist_COMPUTATIONAL_2(TTterm t);
static BOOL TTist_COMPUTATIONAL_1(TTterm t);
static BOOL TTist_COMPUTATIONAL(TTterm t);
static BOOL TTist_COMP_4(TTterm t);
static BOOL TTist_COMP_3(TTterm t);
static BOOL TTist_COMP_2(TTterm t);
static BOOL TTist_COMP_1(TTterm t);
static BOOL TTist_COMP(TTterm t);
static BOOL TTist_BINARY(TTterm t);
static BOOL TTisVSC_dd_entry_alt_left_right_opt(TTterm t);
static BOOL TTist_SYNC(TTterm t);
static BOOL TTist_SYNCHRONIZED(TTterm t);
static BOOL TTisVSC_dd_entry_separate_character_opt(TTterm t);
static BOOL TTisVSC_dd_entry_sign_is_opt(TTterm t);
static BOOL TTist_CHARACTER_opt(TTterm t);
static BOOL TTist_CHARACTER(TTterm t);
static BOOL TTist_SEPARATE(TTterm t);
static BOOL TTisVSC_expr_through_qualified_data_name_opt(TTterm t);
static BOOL TTist_RENAMES(TTterm t);
static BOOL TTist_REDEFINES(TTterm t);
static BOOL TTist_PIC(TTterm t);
static BOOL TTist_PICTURE(TTterm t);
static BOOL TTisVSC_expr_qualified_data_name_plus(TTterm t);
static BOOL TTist_KEY_opt(TTterm t);
static BOOL TTist_KEY(TTterm t);
static BOOL TTist_ON_opt(TTterm t);
static BOOL TTist_DEPENDING(TTterm t);
static BOOL TTisVSC_dd_entry_integer_to_opt(TTterm t);
static BOOL TTisVSC_dd_entry_indexed_by_opt(TTterm t);
static BOOL TTisVSC_dd_entry_occurs_clause_key_star(TTterm t);
static BOOL TTist_TIMES_opt(TTterm t);
static BOOL TTist_TIMES(TTterm t);
static BOOL TTist_OCCURS(TTterm t);
static BOOL TTist_RIGHT_opt(TTterm t);
static BOOL TTist_JUST(TTterm t);
static BOOL TTist_JUSTIFIED(TTterm t);
static BOOL TTisVSC_expr_index_name_plus(TTterm t);
static BOOL TTist_BY_opt(TTterm t);
static BOOL TTist_BY(TTterm t);
static BOOL TTist_INDEXED(TTterm t);
static BOOL TTist_GLOBAL(TTterm t);
static BOOL TTist_EXTERNAL(TTterm t);
static BOOL TTisVSC_dd_entry_data_description_entry_clause_star(TTterm t);
static BOOL TTisVSC_dd_entry_alt_data_name_filler_opt(TTterm t);
static BOOL TTist_WHEN_opt(TTterm t);
static BOOL TTist_WHEN(TTterm t);
static BOOL TTist_BLANK(TTterm t);
static BOOL TTist_RIGHT(TTterm t);
static BOOL TTist_LEFT(TTterm t);
static BOOL TTist_TRAILING(TTterm t);
static BOOL TTist_LEADING(TTterm t);
static BOOL TTist_FILLER(TTterm t);
static BOOL TTist_WORKING_STORAGE(TTterm t);
static BOOL TTisVSC_dd_entry_data_description_entry_star(TTterm t);
static BOOL TTist_LINKAGE(TTterm t);
static BOOL TTisVSC_dd_entry_data_description_entry_plus(TTterm t);
static BOOL TTisVSC_data_div_file_section_entry_star(TTterm t);
static BOOL TTist_FILE(TTterm t);
static BOOL TTisVSC_data_div_linkage_section_opt(TTterm t);
static BOOL TTisVSC_data_div_working_storage_section_opt(TTterm t);
static BOOL TTisVSC_data_div_file_section_opt(TTterm t);
static BOOL TTist_DIVISION(TTterm t);
static BOOL TTist_DATA(TTterm t);
static BOOL TTist_MODE(TTterm t);
static BOOL TTist_DEBUGGING(TTterm t);
static BOOL TTist_WITH_opt(TTterm t);
static BOOL TTist_WITH(TTterm t);
static BOOL TTisVSC_conf_sec_in_alphabet_name_opt(TTterm t);
static BOOL TTisVSC_conf_sec_symbolic_character_mapping_plus(TTterm t);
static BOOL TTist_CHARACTERS_opt(TTterm t);
static BOOL TTist_SYMBOLIC(TTterm t);
static BOOL TTisVSC_expr_integer_plus(TTterm t);
static BOOL TTisVSC_conf_sec_are_opt(TTterm t);
static BOOL TTisVSC_expr_symbolic_character_plus(TTterm t);
static BOOL TTisVSC_conf_sec_on_status_opt(TTterm t);
static BOOL TTisVSC_conf_sec_off_status_opt(TTterm t);
static BOOL TTisVSC_conf_sec_special_names_paragraph_clause_star(TTterm t);
static BOOL TTist_qdot_opt(TTterm t);
static BOOL TTisVSC_conf_sec_special_names_paragraph_phrase_star(TTterm t);
static BOOL TTist_SPECIAL_NAMES(TTterm t);
static BOOL TTisVSC_conf_sec_source_computer_name_opt(TTterm t);
static BOOL TTist_SOURCE_COMPUTER(TTterm t);
static BOOL TTisVSC_conf_sec_with_debugging_mode_opt(TTterm t);
static BOOL TTist_SEGMENT_LIMIT(TTterm t);
static BOOL TTist_SEQUENCE(TTterm t);
static BOOL TTist_COLLATING_opt(TTterm t);
static BOOL TTist_COLLATING(TTterm t);
static BOOL TTist_PROGRAM_opt(TTterm t);
static BOOL TTist_PROGRAM(TTterm t);
static BOOL TTist_ON(TTterm t);
static BOOL TTist_STATUS_opt(TTterm t);
static BOOL TTist_STATUS(TTterm t);
static BOOL TTist_OFF(TTterm t);
static BOOL TTisVSC_conf_sec_segment_limit_opt(TTterm t);
static BOOL TTisVSC_conf_sec_program_collating_sequence_opt(TTterm t);
static BOOL TTisVSC_conf_sec_object_computer_name_opt(TTterm t);
static BOOL TTist_OBJECT_COMPUTER(TTterm t);
static BOOL TTisVSC_conf_sec_memory_size_opt(TTterm t);
static BOOL TTist_MODULES(TTterm t);
static BOOL TTist_CHARACTERS(TTterm t);
static BOOL TTist_WORDS(TTterm t);
static BOOL TTist_SIZE_opt(TTterm t);
static BOOL TTist_SIZE(TTterm t);
static BOOL TTist_MEMORY(TTterm t);
static BOOL TTisVSC_conf_sec_special_names_paragraph_status_phrase_opt(TTterm t);
static BOOL TTist_IN(TTterm t);
static BOOL TTist_COMMA(TTterm t);
static BOOL TTist_DECIMAL_POINT(TTterm t);
static BOOL TTist_SIGN_opt(TTterm t);
static BOOL TTist_SIGN(TTterm t);
static BOOL TTist_CURRENCY(TTterm t);
static BOOL TTisVSC_conf_sec_configuration_section_paragraph_star(TTterm t);
static BOOL TTist_qdot(TTterm t);
static BOOL TTist_SECTION(TTterm t);
static BOOL TTist_CONFIGURATION(TTterm t);
static BOOL TTisVSC_expr_literal_through_literal_plus(TTterm t);
static BOOL TTist_CLASS(TTterm t);
static BOOL TTist_ARE(TTterm t);
static BOOL TTisVSC_conf_sec_alphabet_type_other_plus(TTterm t);
static BOOL TTisVSC_conf_sec_alphabet_type_also_through_opt(TTterm t);
static BOOL TTisVSC_conf_sec_alphabet_type_also_plus(TTterm t);
static BOOL TTist_ALSO(TTterm t);
static BOOL TTist_EBCDIC(TTterm t);
static BOOL TTist_NATIVE(TTterm t);
static BOOL TTist_STANDARD_2(TTterm t);
static BOOL TTist_STANDARD_1(TTterm t);
static BOOL TTist_ALPHABET(TTterm t);
static BOOL TTist_THEN_opt(TTterm t);
static BOOL TTist_THEN(TTterm t);
static BOOL TTist_qpclose(TTterm t);
static BOOL TTist_qpopen(TTterm t);
static BOOL TTist_ZEROS(TTterm t);
static BOOL TTist_ZEROES(TTterm t);
static BOOL TTist_ZERO(TTterm t);
static BOOL TTist_NEGATIVE(TTterm t);
static BOOL TTist_POSITIVE(TTterm t);
static BOOL TTist_qequal(TTterm t);
static BOOL TTist_NOT_opt(TTterm t);
static BOOL TTist_IS_opt(TTterm t);
static BOOL TTist_IS(TTterm t);
static BOOL TTist_qlt(TTterm t);
static BOOL TTist_LESS(TTterm t);
static BOOL TTist_NOT(TTterm t);
static BOOL TTist_qgt_qequal(TTterm t);
static BOOL TTist_THAN_opt(TTterm t);
static BOOL TTist_THAN(TTterm t);
static BOOL TTist_qgt(TTterm t);
static BOOL TTist_TO_opt(TTterm t);
static BOOL TTist_TO(TTterm t);
static BOOL TTist_EQUAL(TTterm t);
static BOOL TTist_GREATER(TTterm t);
static BOOL TTisVSC_expr_subscript_parentheses_star(TTterm t);
static BOOL TTisVSC_expr_in_data_or_file_or_mnemonic_name_star(TTterm t);
static BOOL TTisVSC_cond_and_or_combinable_condition_plus(TTterm t);
static BOOL TTist_KANJI(TTterm t);
static BOOL TTist_DBCS(TTterm t);
static BOOL TTist_ALPHABETIC_UPPER(TTterm t);
static BOOL TTist_ALPHABETIC_LOWER(TTterm t);
static BOOL TTist_ALPHABETIC(TTterm t);
static BOOL TTist_NUMERIC(TTterm t);
static BOOL TTisVSC_cond_relational_operator_opt(TTterm t);
static BOOL TTist_OR(TTterm t);
static BOOL TTist_AND(TTterm t);

static BOOL
TTist_END_WRITE_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_WRITE);
}

static BOOL
TTist_END_WRITE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-WRITE");
}

static BOOL
TTisVSC_stat_advancing_phrase_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_advancing_phrase);
}

static BOOL
TTist_WRITE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "WRITE");
}

static BOOL
TTisVSC_stat_not_at_end_of_page_statement_list_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_not_at_end_of_page_statement_list);
}

static BOOL
TTisVSC_stat_at_end_of_page_statement_list_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_at_end_of_page_statement_list);
}

static BOOL
TTist_TEST(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "TEST");
}

static BOOL
TTist_ORDER_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_ORDER);
}

static BOOL
TTist_ORDER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ORDER");
}

static BOOL
TTisVSC_stat_when_phrase_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_when_phrase);
}

static BOOL
TTisVSC_stat_when_phrase_also_phrase_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_stat_when_phrase_also_phrase);
}

static BOOL
TTist_OTHER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "OTHER");
}

static BOOL
TTisVSC_stat_parameter_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_parameter);
}

static BOOL
TTisVSC_stat_alt_file_reel_unit_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_alt_file_reel_unit);
}

static BOOL
TTisVSC_stat_alt_beginning_ending_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_alt_beginning_ending);
}

static BOOL
TTist_STANDARD_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_STANDARD);
}

static BOOL
TTist_GLOBAL_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_GLOBAL);
}

static BOOL
TTist_USE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "USE");
}

static BOOL
TTist_UPON(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "UPON");
}

static BOOL
TTisVSC_stat_count_in_identifier_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_count_in_identifier);
}

static BOOL
TTisVSC_stat_delimiter_in_identifier_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_delimiter_in_identifier);
}

static BOOL
TTist_END_UNSTRING_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_UNSTRING);
}

static BOOL
TTist_END_UNSTRING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-UNSTRING");
}

static BOOL
TTisVSC_stat_tallying_in_identifier_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_tallying_in_identifier);
}

static BOOL
TTisVSC_stat_unstring_statement_dst_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_unstring_statement_dst);
}

static BOOL
TTisVSC_stat_delimited_by_all_phrase_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_delimited_by_all_phrase);
}

static BOOL
TTist_UNSTRING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "UNSTRING");
}

static BOOL
TTisVSC_stat_tallying_for_id_or_lit_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_tallying_for_id_or_lit);
}

static BOOL
TTisVSC_stat_tallying_for_argument_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_tallying_for_argument);
}

static BOOL
TTist_END_SUBTRACT_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_SUBTRACT);
}

static BOOL
TTist_END_SUBTRACT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-SUBTRACT");
}

static BOOL
TTist_SUBTRACT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SUBTRACT");
}

static BOOL
TTist_END_STRING_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_STRING);
}

static BOOL
TTist_END_STRING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-STRING");
}

static BOOL
TTisVSC_stat_not_on_overflow_statement_list_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_not_on_overflow_statement_list);
}

static BOOL
TTisVSC_stat_with_pointer_identifier_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_with_pointer_identifier);
}

static BOOL
TTisVSC_stat_delimited_by_phrase_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_delimited_by_phrase);
}

static BOOL
TTist_STRING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "STRING");
}

static BOOL
TTist_STOP(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "STOP");
}

static BOOL
TTisVSC_stat_statement_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_statement);
}

static BOOL
TTist_END_START_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_START);
}

static BOOL
TTist_END_START(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-START");
}

static BOOL
TTisVSC_stat_key_is_rel_op_qualified_data_name_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_key_is_rel_op_qualified_data_name);
}

static BOOL
TTist_START(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "START");
}

static BOOL
TTisVSC_stat_with_duplicates_in_order_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_with_duplicates_in_order);
}

static BOOL
TTisVSC_stat_on_key_is_phrase_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_on_key_is_phrase);
}

static BOOL
TTisVSC_stat_set_statement_phrase_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_set_statement_phrase);
}

static BOOL
TTist_SET(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SET");
}

static BOOL
TTisVSC_stat_search_statement_condition_tail_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_stat_search_statement_condition_tail);
}

static BOOL
TTist_END_SEARCH_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_SEARCH);
}

static BOOL
TTist_END_SEARCH(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-SEARCH");
}

static BOOL
TTisVSC_stat_when_condition_stats_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_when_condition_stats);
}

static BOOL
TTisVSC_stat_varying_identifier_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_varying_identifier);
}

static BOOL
TTist_SEARCH(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SEARCH");
}

static BOOL
TTist_END_REWRITE_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_REWRITE);
}

static BOOL
TTist_END_REWRITE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-REWRITE");
}

static BOOL
TTist_REWRITE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "REWRITE");
}

static BOOL
TTist_END_RETURN_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_RETURN);
}

static BOOL
TTist_END_RETURN(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-RETURN");
}

static BOOL
TTist_RETURN(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "RETURN");
}

static BOOL
TTisVSC_stat_from_identifier_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_from_identifier);
}

static BOOL
TTist_RELEASE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "RELEASE");
}

static BOOL
TTisVSC_stat_by_reference_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_by_reference);
}

static BOOL
TTist_END_READ_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_READ);
}

static BOOL
TTist_END_READ(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-READ");
}

static BOOL
TTisVSC_stat_not_at_end_statement_list_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_not_at_end_statement_list);
}

static BOOL
TTisVSC_stat_at_end_statement_list_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_at_end_statement_list);
}

static BOOL
TTisVSC_stat_key_is_qualified_data_name_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_key_is_qualified_data_name);
}

static BOOL
TTisVSC_stat_into_identifier_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_into_identifier);
}

static BOOL
TTist_NEXT_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_NEXT);
}

static BOOL
TTist_READ(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "READ");
}

static BOOL
TTist_PROCEED(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "PROCEED");
}

static BOOL
TTisVSC_stat_proceed_to_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_proceed_to);
}

static BOOL
TTisVSC_stat_with_test_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_with_test);
}

static BOOL
TTisVSC_stat_perform_after_phrase_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_stat_perform_after_phrase);
}

static BOOL
TTist_END_PERFORM(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-PERFORM");
}

static BOOL
TTist_PERFORM(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "PERFORM");
}

static BOOL
TTist_UNTIL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "UNTIL");
}

static BOOL
TTist_PAGE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "PAGE");
}

static BOOL
TTisVSC_stat_with_no_rewind_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_with_no_rewind);
}

static BOOL
TTisVSC_stat_open_statement_output_file_name_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_open_statement_output_file_name);
}

static BOOL
TTisVSC_stat_alt_reversed_with_no_rewind_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_alt_reversed_with_no_rewind);
}

static BOOL
TTisVSC_stat_open_statement_input_file_name_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_open_statement_input_file_name);
}

static BOOL
TTisVSC_stat_open_statement_phrase_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_open_statement_phrase);
}

static BOOL
TTist_OPEN(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "OPEN");
}

static BOOL
TTisVSC_stat_key_is_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_key_is);
}

static BOOL
TTisVSC_stat_lines_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_lines);
}

static BOOL
TTist_OVERFLOW(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "OVERFLOW");
}

static BOOL
TTist_REWIND(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "REWIND");
}

static BOOL
TTist_NO(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "NO");
}

static BOOL
TTist_SENTENCE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SENTENCE");
}

static BOOL
TTist_NEXT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "NEXT");
}

static BOOL
TTist_END_MULTIPLY_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_MULTIPLY);
}

static BOOL
TTist_END_MULTIPLY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-MULTIPLY");
}

static BOOL
TTist_MULTIPLY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "MULTIPLY");
}

static BOOL
TTist_MOVE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "MOVE");
}

static BOOL
TTisVSC_stat_collating_sequence_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_collating_sequence);
}

static BOOL
TTisVSC_stat_on_key_phrase_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_on_key_phrase);
}

static BOOL
TTist_MERGE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "MERGE");
}

static BOOL
TTist_LINE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "LINE");
}

static BOOL
TTist_INVALID(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "INVALID");
}

static BOOL
TTisVSC_stat_inspect_replacing_phrase_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_inspect_replacing_phrase);
}

static BOOL
TTist_CONVERTING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CONVERTING");
}

static BOOL
TTisVSC_stat_tallying_argument_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_tallying_argument);
}

static BOOL
TTist_TALLYING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "TALLYING");
}

static BOOL
TTist_INSPECT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "INSPECT");
}

static BOOL
TTisVSC_stat_inspect_replacing_argument_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_inspect_replacing_argument);
}

static BOOL
TTisVSC_stat_before_after_phrase_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_stat_before_after_phrase);
}

static BOOL
TTisVSC_stat_through_procedure_name_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_through_procedure_name);
}

static BOOL
TTisVSC_stat_initialize_replacing_phrase_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_initialize_replacing_phrase);
}

static BOOL
TTisVSC_expr_identifier_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_expr_identifier);
}

static BOOL
TTist_INITIALIZE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "INITIALIZE");
}

static BOOL
TTist_EGCS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "EGCS");
}

static BOOL
TTist_NUMERIC_EDITED(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "NUMERIC-EDITED");
}

static BOOL
TTist_ALPHANUMERIC_EDITED(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ALPHANUMERIC-EDITED");
}

static BOOL
TTist_ALPHANUMERIC(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ALPHANUMERIC");
}

static BOOL
TTisVSC_stat_initialize_replacing_argument_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_initialize_replacing_argument);
}

static BOOL
TTist_DATA_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_DATA);
}

static BOOL
TTist_END_IF_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_IF);
}

static BOOL
TTist_END_IF(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-IF");
}

static BOOL
TTisVSC_stat_else_phrase_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_else_phrase);
}

static BOOL
TTist_IF(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "IF");
}

static BOOL
TTist_GOBACK(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "GOBACK");
}

static BOOL
TTist_MORE_LABELS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "MORE-LABELS");
}

static BOOL
TTisVSC_expr_procedure_name_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_expr_procedure_name);
}

static BOOL
TTist_REMOVAL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "REMOVAL");
}

static BOOL
TTist_EXIT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "EXIT");
}

static BOOL
TTist_END_EVALUATE_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_EVALUATE);
}

static BOOL
TTist_END_EVALUATE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-EVALUATE");
}

static BOOL
TTisVSC_stat_when_other_phrase_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_when_other_phrase);
}

static BOOL
TTisVSC_stat_when_phrases_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_when_phrases);
}

static BOOL
TTisVSC_stat_also_phrase_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_stat_also_phrase);
}

static BOOL
TTist_EVALUATE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "EVALUATE");
}

static BOOL
TTist_ANY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ANY");
}

static BOOL
TTist_FALSE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "FALSE");
}

static BOOL
TTist_TRUE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "TRUE");
}

static BOOL
TTist_ENTRY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ENTRY");
}

static BOOL
TTist_EOP(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "EOP");
}

static BOOL
TTist_END_OF_PAGE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-OF-PAGE");
}

static BOOL
TTist_ELSE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ELSE");
}

static BOOL
TTist_REMAINDER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "REMAINDER");
}

static BOOL
TTist_END_DIVIDE_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_DIVIDE);
}

static BOOL
TTist_END_DIVIDE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-DIVIDE");
}

static BOOL
TTist_INTO(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "INTO");
}

static BOOL
TTist_DIVIDE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DIVIDE");
}

static BOOL
TTisVSC_stat_with_no_advancing_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_with_no_advancing);
}

static BOOL
TTisVSC_stat_upon_environment_name_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_upon_environment_name);
}

static BOOL
TTisVSC_stat_or_all_id_or_lit_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_stat_or_all_id_or_lit);
}

static BOOL
TTist_ALL_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_ALL);
}

static BOOL
TTist_DELIMITED(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DELIMITED");
}

static BOOL
TTist_END_DELETE_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_DELETE);
}

static BOOL
TTist_END_DELETE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-DELETE");
}

static BOOL
TTisVSC_stat_not_invalid_key_statement_list_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_not_invalid_key_statement_list);
}

static BOOL
TTisVSC_stat_invalid_key_statement_list_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_invalid_key_statement_list);
}

static BOOL
TTist_DELETE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DELETE");
}

static BOOL
TTist_TIME(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "TIME");
}

static BOOL
TTist_DAY_OF_WEEK(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DAY-OF-WEEK");
}

static BOOL
TTist_DAY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DAY");
}

static BOOL
TTist_DATE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DATE");
}

static BOOL
TTist_COUNT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COUNT");
}

static BOOL
TTist_CORR(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CORR");
}

static BOOL
TTist_CORRESPONDING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CORRESPONDING");
}

static BOOL
TTist_CONTINUE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CONTINUE");
}

static BOOL
TTisVSC_stat_content_parameter_value_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_content_parameter_value);
}

static BOOL
TTist_CONTENT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CONTENT");
}

static BOOL
TTist_END_COMPUTE_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_COMPUTE);
}

static BOOL
TTist_END_COMPUTE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-COMPUTE");
}

static BOOL
TTist_COMPUTE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COMPUTE");
}

static BOOL
TTisVSC_stat_alt_removal_no_rewind_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_alt_removal_no_rewind);
}

static BOOL
TTisVSC_stat_close_statement_options_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_close_statement_options);
}

static BOOL
TTisVSC_stat_close_statement_file_name_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_close_statement_file_name);
}

static BOOL
TTist_CLOSE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CLOSE");
}

static BOOL
TTist_CANCEL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CANCEL");
}

static BOOL
TTist_END_CALL_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_CALL);
}

static BOOL
TTist_END_CALL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-CALL");
}

static BOOL
TTisVSC_stat_using_parameters_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_using_parameters);
}

static BOOL
TTist_CALL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CALL");
}

static BOOL
TTisVSC_stat_on_overflow_statement_list_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_on_overflow_statement_list);
}

static BOOL
TTisVSC_stat_not_on_exception_statement_list_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_not_on_exception_statement_list);
}

static BOOL
TTisVSC_stat_on_exception_statement_list_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_on_exception_statement_list);
}

static BOOL
TTist_REFERENCE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "REFERENCE");
}

static BOOL
TTisVSC_stat_procedure_to_procedure_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_procedure_to_procedure);
}

static BOOL
TTist_ALTER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ALTER");
}

static BOOL
TTist_DOWN(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DOWN");
}

static BOOL
TTist_UP(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "UP");
}

static BOOL
TTist_RUN(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "RUN");
}

static BOOL
TTist_REVERSED(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "REVERSED");
}

static BOOL
TTist_LOCK(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "LOCK");
}

static BOOL
TTist_EXTEND(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "EXTEND");
}

static BOOL
TTist_I_O(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "I-O");
}

static BOOL
TTist_OUTPUT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "OUTPUT");
}

static BOOL
TTist_INPUT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "INPUT");
}

static BOOL
TTist_ERROR(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ERROR");
}

static BOOL
TTist_EXCEPTION(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "EXCEPTION");
}

static BOOL
TTist_ENDING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ENDING");
}

static BOOL
TTist_BEGINNING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "BEGINNING");
}

static BOOL
TTist_AFTER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "AFTER");
}

static BOOL
TTist_BEFORE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "BEFORE");
}

static BOOL
TTist_FIRST(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "FIRST");
}

static BOOL
TTist_PROCEDURES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "PROCEDURES");
}

static BOOL
TTist_ADVANCING_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_ADVANCING);
}

static BOOL
TTist_ADVANCING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ADVANCING");
}

static BOOL
TTist_ROUNDED_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_ROUNDED);
}

static BOOL
TTist_ROUNDED(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ROUNDED");
}

static BOOL
TTist_GIVING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "GIVING");
}

static BOOL
TTisVSC_stat_to_id_or_lit_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_to_id_or_lit);
}

static BOOL
TTist_END_ADD_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_ADD);
}

static BOOL
TTist_END_ADD(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-ADD");
}

static BOOL
TTisVSC_stat_not_on_size_error_statement_list_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_not_on_size_error_statement_list);
}

static BOOL
TTisVSC_stat_on_size_error_statement_list_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_on_size_error_statement_list);
}

static BOOL
TTisVSC_stat_cobword_rounded_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_cobword_rounded);
}

static BOOL
TTisVSC_stat_id_or_lit_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_id_or_lit);
}

static BOOL
TTist_ADD(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ADD");
}

static BOOL
TTisVSC_stat_from_environment_name_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_from_environment_name);
}

static BOOL
TTist_ACCEPT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ACCEPT");
}

static BOOL
TTisVSC_proc_div_using_data_names_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_proc_div_using_data_names);
}

static BOOL
TTisVSC_stat_using_data_name_pluslist_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_using_data_name_pluslist);
}

static BOOL
TTisVSC_expr_data_name_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_expr_data_name);
}

static BOOL
TTist_USING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "USING");
}

static BOOL
TTisVSC_stat_statement_list_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_statement_list);
}

static BOOL
TTist_qdot_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTist_qdot);
}

static BOOL
TTisVSC_proc_div_section_with_header_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_proc_div_section_with_header);
}

static BOOL
TTisVSC_expr_priority_number_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_expr_priority_number);
}

static BOOL
TTisVSC_proc_div_declaratives_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_proc_div_declaratives);
}

static BOOL
TTist_PROCEDURE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "PROCEDURE");
}

static BOOL
TTisVSC_proc_div_paragraph_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_proc_div_paragraph);
}

static BOOL
TTisVSC_proc_div_sentence_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_proc_div_sentence);
}

static BOOL
TTisVSC_proc_div_declaratives_content_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_proc_div_declaratives_content);
}

static BOOL
TTist_DECLARATIVES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DECLARATIVES");
}

static BOOL
TTist_GO(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "GO");
}

static BOOL
TTisVSC_main_cobol_source_program_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_main_cobol_source_program);
}

static BOOL
TTisVSC_main_common_initial_program_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_main_common_initial_program);
}

static BOOL
TTisVSC_main_nested_cobol_source_program_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_main_nested_cobol_source_program);
}

static BOOL
TTisVSC_id_div_identification_division_content_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_id_div_identification_division_content);
}

static BOOL
TTist_COMMON_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_COMMON);
}

static BOOL
TTist_INITIAL_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_INITIAL);
}

static BOOL
TTist_COMMON(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COMMON");
}

static BOOL
TTisVSC_main_nested_program_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_main_nested_program);
}

static BOOL
TTisVSC_proc_div_procedure_division_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_proc_div_procedure_division);
}

static BOOL
TTisVSC_data_div_data_division_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_data_div_data_division);
}

static BOOL
TTisVSC_env_div_environment_division_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_env_div_environment_division);
}

static BOOL
TTist_DUPLICATES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DUPLICATES");
}

static BOOL
TTisVSC_io_sec_same_area_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_io_sec_same_area);
}

static BOOL
TTisVSC_io_sec_rerun_on_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_io_sec_rerun_on);
}

static BOOL
TTist_OPTIONAL_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_OPTIONAL);
}

static BOOL
TTist_OPTIONAL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "OPTIONAL");
}

static BOOL
TTist_SELECT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SELECT");
}

static BOOL
TTisVSC_io_sec_areas_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_io_sec_areas);
}

static BOOL
TTist_RESERVE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "RESERVE");
}

static BOOL
TTist_SORT_MERGE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SORT-MERGE");
}

static BOOL
TTist_SORT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SORT");
}

static BOOL
TTist_DELIMITER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DELIMITER");
}

static BOOL
TTist_WRITE_ONLY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "WRITE-ONLY");
}

static BOOL
TTist_APPLY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "APPLY");
}

static BOOL
TTisVSC_io_sec_file_name_position_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_io_sec_file_name_position);
}

static BOOL
TTist_TAPE_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_TAPE);
}

static BOOL
TTist_TAPE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "TAPE");
}

static BOOL
TTist_MULTIPLE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "MULTIPLE");
}

static BOOL
TTisVSC_expr_file_name_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_expr_file_name);
}

static BOOL
TTist_FOR_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_FOR);
}

static BOOL
TTist_FOR(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "FOR");
}

static BOOL
TTist_AREA_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_AREA);
}

static BOOL
TTist_SAME(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SAME");
}

static BOOL
TTist_EVERY_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_EVERY);
}

static BOOL
TTist_EVERY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "EVERY");
}

static BOOL
TTist_RERUN(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "RERUN");
}

static BOOL
TTist_POSITION(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "POSITION");
}

static BOOL
TTist_PASSWORD(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "PASSWORD");
}

static BOOL
TTist_PADDING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "PADDING");
}

static BOOL
TTist_ORGANIZATION(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ORGANIZATION");
}

static BOOL
TTisVSC_io_sec_i_o_control_paragraph_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_io_sec_i_o_control_paragraph);
}

static BOOL
TTisVSC_io_sec_file_control_paragraph_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_io_sec_file_control_paragraph);
}

static BOOL
TTist_INPUT_OUTPUT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "INPUT-OUTPUT");
}

static BOOL
TTisVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries);
}

static BOOL
TTisVSC_io_sec_i_o_sort_merge_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_io_sec_i_o_sort_merge);
}

static BOOL
TTisVSC_io_sec_i_o_sam_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_io_sec_i_o_sam);
}

static BOOL
TTist_I_O_CONTROL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "I-O-CONTROL");
}

static BOOL
TTisVSC_expr_qualified_data_name_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_expr_qualified_data_name);
}

static BOOL
TTist_FILE_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_FILE);
}

static BOOL
TTisVSC_io_sec_position_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_io_sec_position);
}

static BOOL
TTisVSC_io_sec_file_control_entry_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_io_sec_file_control_entry);
}

static BOOL
TTist_FILE_CONTROL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "FILE-CONTROL");
}

static BOOL
TTisVSC_io_sec_fce_phrase_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_io_sec_fce_phrase);
}

static BOOL
TTisVSC_io_sec_organization_is_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_io_sec_organization_is);
}

static BOOL
TTisVSC_io_sec_relative_key_clause_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_io_sec_relative_key_clause);
}

static BOOL
TTist_ACCESS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ACCESS");
}

static BOOL
TTist_OF_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_OF);
}

static BOOL
TTist_END(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END");
}

static BOOL
TTisVSC_io_sec_alt_assignment_name_literal_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_io_sec_alt_assignment_name_literal);
}

static BOOL
TTist_ASSIGN(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ASSIGN");
}

static BOOL
TTist_AREAS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "AREAS");
}

static BOOL
TTist_AREA(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "AREA");
}

static BOOL
TTisVSC_io_sec_with_duplicates_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_io_sec_with_duplicates);
}

static BOOL
TTisVSC_io_sec_password_clause_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_io_sec_password_clause);
}

static BOOL
TTist_RECORD_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_RECORD);
}

static BOOL
TTist_ALTERNATE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ALTERNATE");
}

static BOOL
TTist_DYNAMIC(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DYNAMIC");
}

static BOOL
TTist_RANDOM(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "RANDOM");
}

static BOOL
TTist_SEQUENTIAL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SEQUENTIAL");
}

static BOOL
TTist_RELATIVE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "RELATIVE");
}

static BOOL
TTist_SECURITY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SECURITY");
}

static BOOL
TTist_REMARKS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "REMARKS");
}

static BOOL
TTisVSC_id_div_initial_program_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_id_div_initial_program);
}

static BOOL
TTist_PROGRAM_ID(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "PROGRAM-ID");
}

static BOOL
TTist_INSTALLATION(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "INSTALLATION");
}

static BOOL
TTist_INITIAL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "INITIAL");
}

static BOOL
TTisVSC_id_div_identification_division_phrase_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_id_div_identification_division_phrase);
}

static BOOL
TTist_ID(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ID");
}

static BOOL
TTist_IDENTIFICATION(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "IDENTIFICATION");
}

static BOOL
TTist_DATE_WRITTEN(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DATE-WRITTEN");
}

static BOOL
TTist_DATE_COMPILED(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DATE-COMPILED");
}

static BOOL
TTist_AUTHOR(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "AUTHOR");
}

static BOOL
TTisVSC_fd_entry_value_of_clause_tail_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_fd_entry_value_of_clause_tail);
}

static BOOL
TTist_MODE_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_MODE);
}

static BOOL
TTist_RECORDING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "RECORDING");
}

static BOOL
TTisVSC_fd_entry_to_integer_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_fd_entry_to_integer);
}

static BOOL
TTisVSC_fd_entry_from_integer_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_fd_entry_from_integer);
}

static BOOL
TTist_IN_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_IN);
}

static BOOL
TTist_VARYING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "VARYING");
}

static BOOL
TTisVSC_fd_entry_depending_on_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_fd_entry_depending_on);
}

static BOOL
TTist_TOP(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "TOP");
}

static BOOL
TTist_BOTTOM(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "BOTTOM");
}

static BOOL
TTisVSC_fd_entry_lines_bottom_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_fd_entry_lines_bottom);
}

static BOOL
TTisVSC_fd_entry_lines_top_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_fd_entry_lines_top);
}

static BOOL
TTisVSC_fd_entry_footing_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_fd_entry_footing);
}

static BOOL
TTist_LINES_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_LINES);
}

static BOOL
TTist_LINES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "LINES");
}

static BOOL
TTist_LINAGE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "LINAGE");
}

static BOOL
TTist_OMITTED(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "OMITTED");
}

static BOOL
TTist_STANDARD(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "STANDARD");
}

static BOOL
TTist_LABEL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "LABEL");
}

static BOOL
TTist_FROM_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_FROM);
}

static BOOL
TTist_FROM(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "FROM");
}

static BOOL
TTist_AT_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_AT);
}

static BOOL
TTist_AT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "AT");
}

static BOOL
TTist_FOOTING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "FOOTING");
}

static BOOL
TTisVSC_fd_entry_file_and_sort_description_entry_clause_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_fd_entry_file_and_sort_description_entry_clause);
}

static BOOL
TTisVSC_expr_data_name_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_expr_data_name);
}

static BOOL
TTist_CODE_SET(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CODE-SET");
}

static BOOL
TTisVSC_fd_entry_alt_characters_records_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_fd_entry_alt_characters_records);
}

static BOOL
TTist_CONTAINS_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_CONTAINS);
}

static BOOL
TTist_CONTAINS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CONTAINS");
}

static BOOL
TTist_BLOCK(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "BLOCK");
}

static BOOL
TTist_SD(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SD");
}

static BOOL
TTist_FD(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "FD");
}

static BOOL
TTist_VALUES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "VALUES");
}

static BOOL
TTist_VALUE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "VALUE");
}

static BOOL
TTisVSC_expr_times_div_tail_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_expr_times_div_tail);
}

static BOOL
TTist_THRU(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "THRU");
}

static BOOL
TTist_THROUGH(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "THROUGH");
}

static BOOL
TTisVSC_expr_plus_minus_integer_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_expr_plus_minus_integer);
}

static BOOL
TTisVSC_expr_subscript_expression_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_expr_subscript_expression);
}

static BOOL
TTist_LENGTH(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "LENGTH");
}

static BOOL
TTist_ADDRESS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ADDRESS");
}

static BOOL
TTisVSC_expr_length_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_expr_length);
}

static BOOL
TTist_qcolon(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, ":");
}

static BOOL
TTist_RECORDS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "RECORDS");
}

static BOOL
TTist_RECORD(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "RECORD");
}

static BOOL
TTisVSC_expr_in_data_or_file_name_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_expr_in_data_or_file_name);
}

static BOOL
TTisVSC_expr_in_section_name_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_expr_in_section_name);
}

static BOOL
TTist_qmultiply_qmultiply(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "**");
}

static BOOL
TTisVSC_expr_power_tail_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_expr_power_tail);
}

static BOOL
TTisVSC_expr_alt_plus_minus_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_expr_alt_plus_minus);
}

static BOOL
TTisVSC_expr_through_literal_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_expr_through_literal);
}

static BOOL
TTist_OF(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "OF");
}

static BOOL
TTisVSC_expr_in_file_name_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_expr_in_file_name);
}

static BOOL
TTist_LINAGE_COUNTER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "LINAGE-COUNTER");
}

static BOOL
TTisVSC_expr_reference_modification_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_expr_reference_modification);
}

static BOOL
TTist_NULLS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "NULLS");
}

static BOOL
TTist_NULL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "NULL");
}

static BOOL
TTist_QUOTES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "QUOTES");
}

static BOOL
TTist_QUOTE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "QUOTE");
}

static BOOL
TTist_LOW_VALUES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "LOW-VALUES");
}

static BOOL
TTist_LOW_VALUE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "LOW-VALUE");
}

static BOOL
TTist_HIGH_VALUES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "HIGH-VALUES");
}

static BOOL
TTist_HIGH_VALUE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "HIGH-VALUE");
}

static BOOL
TTist_SPACES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SPACES");
}

static BOOL
TTist_SPACE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SPACE");
}

static BOOL
TTist_ALL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ALL");
}

static BOOL
TTisVSC_expr_copy_statement_by_phrase_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_expr_copy_statement_by_phrase);
}

static BOOL
TTist_REPLACING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "REPLACING");
}

static BOOL
TTisVSC_expr_copy_statement_replacing_phrase_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_expr_copy_statement_replacing_phrase);
}

static BOOL
TTist_SUPPRESS_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_SUPPRESS);
}

static BOOL
TTist_SUPPRESS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SUPPRESS");
}

static BOOL
TTisVSC_expr_in_library_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_expr_in_library);
}

static BOOL
TTist_COPY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COPY");
}

static BOOL
TTisVSC_expr_arithmetic_expression_tail_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_expr_arithmetic_expression_tail);
}

static BOOL
TTist_qdivide(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "/");
}

static BOOL
TTist_qmultiply(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "*");
}

static BOOL
TTist_UNIT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "UNIT");
}

static BOOL
TTist_REEL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "REEL");
}

static BOOL
TTist__(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "-");
}

static BOOL
TTist_qplus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "+");
}

static BOOL
TTist_DESCENDING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DESCENDING");
}

static BOOL
TTist_ASCENDING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ASCENDING");
}

static BOOL
TTisVSC_io_sec_input_output_section_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_io_sec_input_output_section);
}

static BOOL
TTisVSC_conf_sec_configuration_section_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_conf_sec_configuration_section);
}

static BOOL
TTist_ENVIRONMENT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ENVIRONMENT");
}

static BOOL
TTist_USAGE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "USAGE");
}

static BOOL
TTisVSC_dd_entry_usage_is_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_dd_entry_usage_is);
}

static BOOL
TTist_POINTER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "POINTER");
}

static BOOL
TTist_PACKED_DECIMAL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "PACKED-DECIMAL");
}

static BOOL
TTist_INDEX(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "INDEX");
}

static BOOL
TTist_DISPLAY_1(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DISPLAY-1");
}

static BOOL
TTist_DISPLAY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DISPLAY");
}

static BOOL
TTist_COMPUTATIONAL_4(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COMPUTATIONAL-4");
}

static BOOL
TTist_COMPUTATIONAL_3(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COMPUTATIONAL-3");
}

static BOOL
TTist_COMPUTATIONAL_2(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COMPUTATIONAL-2");
}

static BOOL
TTist_COMPUTATIONAL_1(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COMPUTATIONAL-1");
}

static BOOL
TTist_COMPUTATIONAL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COMPUTATIONAL");
}

static BOOL
TTist_COMP_4(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COMP-4");
}

static BOOL
TTist_COMP_3(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COMP-3");
}

static BOOL
TTist_COMP_2(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COMP-2");
}

static BOOL
TTist_COMP_1(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COMP-1");
}

static BOOL
TTist_COMP(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COMP");
}

static BOOL
TTist_BINARY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "BINARY");
}

static BOOL
TTisVSC_dd_entry_alt_left_right_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_dd_entry_alt_left_right);
}

static BOOL
TTist_SYNC(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SYNC");
}

static BOOL
TTist_SYNCHRONIZED(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SYNCHRONIZED");
}

static BOOL
TTisVSC_dd_entry_separate_character_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_dd_entry_separate_character);
}

static BOOL
TTisVSC_dd_entry_sign_is_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_dd_entry_sign_is);
}

static BOOL
TTist_CHARACTER_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_CHARACTER);
}

static BOOL
TTist_CHARACTER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CHARACTER");
}

static BOOL
TTist_SEPARATE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SEPARATE");
}

static BOOL
TTisVSC_expr_through_qualified_data_name_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_expr_through_qualified_data_name);
}

static BOOL
TTist_RENAMES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "RENAMES");
}

static BOOL
TTist_REDEFINES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "REDEFINES");
}

static BOOL
TTist_PIC(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "PIC");
}

static BOOL
TTist_PICTURE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "PICTURE");
}

static BOOL
TTisVSC_expr_qualified_data_name_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_expr_qualified_data_name);
}

static BOOL
TTist_KEY_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_KEY);
}

static BOOL
TTist_KEY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "KEY");
}

static BOOL
TTist_ON_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_ON);
}

static BOOL
TTist_DEPENDING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DEPENDING");
}

static BOOL
TTisVSC_dd_entry_integer_to_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_dd_entry_integer_to);
}

static BOOL
TTisVSC_dd_entry_indexed_by_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_dd_entry_indexed_by);
}

static BOOL
TTisVSC_dd_entry_occurs_clause_key_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_dd_entry_occurs_clause_key);
}

static BOOL
TTist_TIMES_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_TIMES);
}

static BOOL
TTist_TIMES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "TIMES");
}

static BOOL
TTist_OCCURS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "OCCURS");
}

static BOOL
TTist_RIGHT_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_RIGHT);
}

static BOOL
TTist_JUST(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "JUST");
}

static BOOL
TTist_JUSTIFIED(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "JUSTIFIED");
}

static BOOL
TTisVSC_expr_index_name_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_expr_index_name);
}

static BOOL
TTist_BY_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_BY);
}

static BOOL
TTist_BY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "BY");
}

static BOOL
TTist_INDEXED(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "INDEXED");
}

static BOOL
TTist_GLOBAL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "GLOBAL");
}

static BOOL
TTist_EXTERNAL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "EXTERNAL");
}

static BOOL
TTisVSC_dd_entry_data_description_entry_clause_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_dd_entry_data_description_entry_clause);
}

static BOOL
TTisVSC_dd_entry_alt_data_name_filler_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_dd_entry_alt_data_name_filler);
}

static BOOL
TTist_WHEN_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_WHEN);
}

static BOOL
TTist_WHEN(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "WHEN");
}

static BOOL
TTist_BLANK(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "BLANK");
}

static BOOL
TTist_RIGHT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "RIGHT");
}

static BOOL
TTist_LEFT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "LEFT");
}

static BOOL
TTist_TRAILING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "TRAILING");
}

static BOOL
TTist_LEADING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "LEADING");
}

static BOOL
TTist_FILLER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "FILLER");
}

static BOOL
TTist_WORKING_STORAGE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "WORKING-STORAGE");
}

static BOOL
TTisVSC_dd_entry_data_description_entry_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_dd_entry_data_description_entry);
}

static BOOL
TTist_LINKAGE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "LINKAGE");
}

static BOOL
TTisVSC_dd_entry_data_description_entry_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_dd_entry_data_description_entry);
}

static BOOL
TTisVSC_data_div_file_section_entry_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_data_div_file_section_entry);
}

static BOOL
TTist_FILE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "FILE");
}

static BOOL
TTisVSC_data_div_linkage_section_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_data_div_linkage_section);
}

static BOOL
TTisVSC_data_div_working_storage_section_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_data_div_working_storage_section);
}

static BOOL
TTisVSC_data_div_file_section_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_data_div_file_section);
}

static BOOL
TTist_DIVISION(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DIVISION");
}

static BOOL
TTist_DATA(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DATA");
}

static BOOL
TTist_MODE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "MODE");
}

static BOOL
TTist_DEBUGGING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DEBUGGING");
}

static BOOL
TTist_WITH_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_WITH);
}

static BOOL
TTist_WITH(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "WITH");
}

static BOOL
TTisVSC_conf_sec_in_alphabet_name_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_conf_sec_in_alphabet_name);
}

static BOOL
TTisVSC_conf_sec_symbolic_character_mapping_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_conf_sec_symbolic_character_mapping);
}

static BOOL
TTist_CHARACTERS_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_CHARACTERS);
}

static BOOL
TTist_SYMBOLIC(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SYMBOLIC");
}

static BOOL
TTisVSC_expr_integer_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_expr_integer);
}

static BOOL
TTisVSC_conf_sec_are_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_conf_sec_are);
}

static BOOL
TTisVSC_expr_symbolic_character_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_expr_symbolic_character);
}

static BOOL
TTisVSC_conf_sec_on_status_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_conf_sec_on_status);
}

static BOOL
TTisVSC_conf_sec_off_status_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_conf_sec_off_status);
}

static BOOL
TTisVSC_conf_sec_special_names_paragraph_clause_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_conf_sec_special_names_paragraph_clause);
}

static BOOL
TTist_qdot_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_qdot);
}

static BOOL
TTisVSC_conf_sec_special_names_paragraph_phrase_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_conf_sec_special_names_paragraph_phrase);
}

static BOOL
TTist_SPECIAL_NAMES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SPECIAL-NAMES");
}

static BOOL
TTisVSC_conf_sec_source_computer_name_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_conf_sec_source_computer_name);
}

static BOOL
TTist_SOURCE_COMPUTER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SOURCE-COMPUTER");
}

static BOOL
TTisVSC_conf_sec_with_debugging_mode_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_conf_sec_with_debugging_mode);
}

static BOOL
TTist_SEGMENT_LIMIT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SEGMENT-LIMIT");
}

static BOOL
TTist_SEQUENCE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SEQUENCE");
}

static BOOL
TTist_COLLATING_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_COLLATING);
}

static BOOL
TTist_COLLATING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COLLATING");
}

static BOOL
TTist_PROGRAM_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_PROGRAM);
}

static BOOL
TTist_PROGRAM(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "PROGRAM");
}

static BOOL
TTist_ON(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ON");
}

static BOOL
TTist_STATUS_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_STATUS);
}

static BOOL
TTist_STATUS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "STATUS");
}

static BOOL
TTist_OFF(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "OFF");
}

static BOOL
TTisVSC_conf_sec_segment_limit_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_conf_sec_segment_limit);
}

static BOOL
TTisVSC_conf_sec_program_collating_sequence_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_conf_sec_program_collating_sequence);
}

static BOOL
TTisVSC_conf_sec_object_computer_name_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_conf_sec_object_computer_name);
}

static BOOL
TTist_OBJECT_COMPUTER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "OBJECT-COMPUTER");
}

static BOOL
TTisVSC_conf_sec_memory_size_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_conf_sec_memory_size);
}

static BOOL
TTist_MODULES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "MODULES");
}

static BOOL
TTist_CHARACTERS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CHARACTERS");
}

static BOOL
TTist_WORDS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "WORDS");
}

static BOOL
TTist_SIZE_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_SIZE);
}

static BOOL
TTist_SIZE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SIZE");
}

static BOOL
TTist_MEMORY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "MEMORY");
}

static BOOL
TTisVSC_conf_sec_special_names_paragraph_status_phrase_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_conf_sec_special_names_paragraph_status_phrase);
}

static BOOL
TTist_IN(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "IN");
}

static BOOL
TTist_COMMA(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COMMA");
}

static BOOL
TTist_DECIMAL_POINT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DECIMAL-POINT");
}

static BOOL
TTist_SIGN_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_SIGN);
}

static BOOL
TTist_SIGN(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SIGN");
}

static BOOL
TTist_CURRENCY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CURRENCY");
}

static BOOL
TTisVSC_conf_sec_configuration_section_paragraph_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_conf_sec_configuration_section_paragraph);
}

static BOOL
TTist_qdot(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, ".");
}

static BOOL
TTist_SECTION(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SECTION");
}

static BOOL
TTist_CONFIGURATION(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CONFIGURATION");
}

static BOOL
TTisVSC_expr_literal_through_literal_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_expr_literal_through_literal);
}

static BOOL
TTist_CLASS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CLASS");
}

static BOOL
TTist_ARE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ARE");
}

static BOOL
TTisVSC_conf_sec_alphabet_type_other_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_conf_sec_alphabet_type_other);
}

static BOOL
TTisVSC_conf_sec_alphabet_type_also_through_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_conf_sec_alphabet_type_also_through);
}

static BOOL
TTisVSC_conf_sec_alphabet_type_also_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_conf_sec_alphabet_type_also);
}

static BOOL
TTist_ALSO(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ALSO");
}

static BOOL
TTist_EBCDIC(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "EBCDIC");
}

static BOOL
TTist_NATIVE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "NATIVE");
}

static BOOL
TTist_STANDARD_2(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "STANDARD-2");
}

static BOOL
TTist_STANDARD_1(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "STANDARD-1");
}

static BOOL
TTist_ALPHABET(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ALPHABET");
}

static BOOL
TTist_THEN_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_THEN);
}

static BOOL
TTist_THEN(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "THEN");
}

static BOOL
TTist_qpclose(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, ")");
}

static BOOL
TTist_qpopen(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "(");
}

static BOOL
TTist_ZEROS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ZEROS");
}

static BOOL
TTist_ZEROES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ZEROES");
}

static BOOL
TTist_ZERO(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ZERO");
}

static BOOL
TTist_NEGATIVE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "NEGATIVE");
}

static BOOL
TTist_POSITIVE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "POSITIVE");
}

static BOOL
TTist_qequal(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "=");
}

static BOOL
TTist_NOT_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_NOT);
}

static BOOL
TTist_IS_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_IS);
}

static BOOL
TTist_IS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "IS");
}

static BOOL
TTist_qlt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "<");
}

static BOOL
TTist_LESS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "LESS");
}

static BOOL
TTist_NOT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "NOT");
}

static BOOL
TTist_qgt_qequal(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, ">=");
}

static BOOL
TTist_THAN_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_THAN);
}

static BOOL
TTist_THAN(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "THAN");
}

static BOOL
TTist_qgt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, ">");
}

static BOOL
TTist_TO_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_TO);
}

static BOOL
TTist_TO(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "TO");
}

static BOOL
TTist_EQUAL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "EQUAL");
}

static BOOL
TTist_GREATER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "GREATER");
}

static BOOL
TTisVSC_expr_subscript_parentheses_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_expr_subscript_parentheses);
}

static BOOL
TTisVSC_expr_in_data_or_file_or_mnemonic_name_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_expr_in_data_or_file_or_mnemonic_name);
}

static BOOL
TTisVSC_cond_and_or_combinable_condition_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_cond_and_or_combinable_condition);
}

static BOOL
TTist_KANJI(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "KANJI");
}

static BOOL
TTist_DBCS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DBCS");
}

static BOOL
TTist_ALPHABETIC_UPPER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ALPHABETIC-UPPER");
}

static BOOL
TTist_ALPHABETIC_LOWER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ALPHABETIC-LOWER");
}

static BOOL
TTist_ALPHABETIC(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ALPHABETIC");
}

static BOOL
TTist_NUMERIC(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "NUMERIC");
}

static BOOL
TTisVSC_cond_relational_operator_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_cond_relational_operator);
}

static BOOL
TTist_OR(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "OR");
}

static BOOL
TTist_AND(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "AND");
}

BOOL
TTisVSC_cond_alt_and_or(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_alt_and_or;
}

BOOL
TTisVSC_cond_and_or_combinable_condition(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_and_or_combinable_condition;
}

BOOL
TTisVSC_cond_class_condition(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_class_condition;
}

BOOL
TTisVSC_cond_class_type(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_class_type;
}

BOOL
TTisVSC_cond_combinable_condition(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_combinable_condition;
}

BOOL
TTisVSC_cond_combined_conditions(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_combined_conditions;
}

BOOL
TTisVSC_cond_condition(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_condition;
}

BOOL
TTisVSC_cond_condition_name_reference(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_condition_name_reference;
}

BOOL
TTisVSC_cond_greater(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_greater;
}

BOOL
TTisVSC_cond_greater_equal(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_greater_equal;
}

BOOL
TTisVSC_cond_greater_than(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_greater_than;
}

BOOL
TTisVSC_cond_greater_than_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_greater_than_1;
}

BOOL
TTisVSC_cond_greater_than_or_equal_to(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_greater_than_or_equal_to;
}

BOOL
TTisVSC_cond_greater_than_or_equal_to_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_greater_than_or_equal_to_1;
}

BOOL
TTisVSC_cond_greater_than_or_equal_to_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_greater_than_or_equal_to_2;
}

BOOL
TTisVSC_cond_greater_than_or_equal_to_3(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_greater_than_or_equal_to_3;
}

BOOL
TTisVSC_cond_is_not(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_is_not;
}

BOOL
TTisVSC_cond_is_or_is_not(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_is_or_is_not;
}

BOOL
TTisVSC_cond_less(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_less;
}

BOOL
TTisVSC_cond_less_equal(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_less_equal;
}

BOOL
TTisVSC_cond_less_equal_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_less_equal_2;
}

BOOL
TTisVSC_cond_negated_simple_conditions(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_negated_simple_conditions;
}

BOOL
TTisVSC_cond_not_is(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_not_is;
}

BOOL
TTisVSC_cond_not_relational_operator_rest(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_not_relational_operator_rest;
}

BOOL
TTisVSC_cond_relation_condition(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_relation_condition;
}

BOOL
TTisVSC_cond_relational_operator(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_relational_operator;
}

BOOL
TTisVSC_cond_relational_operator_rest(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_relational_operator_rest;
}

BOOL
TTisVSC_cond_relational_operator_tail(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_relational_operator_tail;
}

BOOL
TTisVSC_cond_sign_condition(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_sign_condition;
}

BOOL
TTisVSC_cond_sign_type(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_sign_type;
}

BOOL
TTisVSC_cond_simple_condition(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_simple_condition;
}

BOOL
TTisVSC_cond_simple_condition_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_simple_condition_1;
}

BOOL
TTisVSC_cond_than(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_than;
}

BOOL
TTisVSC_conf_sec_alphabet_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_alphabet_clause;
}

BOOL
TTisVSC_conf_sec_alphabet_type(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_alphabet_type;
}

BOOL
TTisVSC_conf_sec_alphabet_type_also(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_alphabet_type_also;
}

BOOL
TTisVSC_conf_sec_alphabet_type_also_through(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_alphabet_type_also_through;
}

BOOL
TTisVSC_conf_sec_alphabet_type_alsos(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_alphabet_type_alsos;
}

BOOL
TTisVSC_conf_sec_alphabet_type_other(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_alphabet_type_other;
}

BOOL
TTisVSC_conf_sec_alphabet_type_others(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_alphabet_type_others;
}

BOOL
TTisVSC_conf_sec_are(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_are;
}

BOOL
TTisVSC_conf_sec_class_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_class_clause;
}

BOOL
TTisVSC_conf_sec_configuration_section(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_configuration_section;
}

BOOL
TTisVSC_conf_sec_configuration_section_paragraph(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_configuration_section_paragraph;
}

BOOL
TTisVSC_conf_sec_configuration_section_paragraphs(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_configuration_section_paragraphs;
}

BOOL
TTisVSC_conf_sec_currency_sign_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_currency_sign_clause;
}

BOOL
TTisVSC_conf_sec_decimal_point_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_decimal_point_clause;
}

BOOL
TTisVSC_conf_sec_in_alphabet_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_in_alphabet_name;
}

BOOL
TTisVSC_conf_sec_is_mnemonic_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_is_mnemonic_name;
}

BOOL
TTisVSC_conf_sec_memory_size(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_memory_size;
}

BOOL
TTisVSC_conf_sec_memory_size_type(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_memory_size_type;
}

BOOL
TTisVSC_conf_sec_object_computer_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_object_computer_name;
}

BOOL
TTisVSC_conf_sec_object_computer_paragraph(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_object_computer_paragraph;
}

BOOL
TTisVSC_conf_sec_object_computer_paragraph_sequence_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_object_computer_paragraph_sequence_phrase;
}

BOOL
TTisVSC_conf_sec_off_status(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_off_status;
}

BOOL
TTisVSC_conf_sec_on_status(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_on_status;
}

BOOL
TTisVSC_conf_sec_program_collating_sequence(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_program_collating_sequence;
}

BOOL
TTisVSC_conf_sec_segment_limit(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_segment_limit;
}

BOOL
TTisVSC_conf_sec_source_computer_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_source_computer_name;
}

BOOL
TTisVSC_conf_sec_source_computer_paragraph(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_source_computer_paragraph;
}

BOOL
TTisVSC_conf_sec_special_names_paragraph(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_special_names_paragraph;
}

BOOL
TTisVSC_conf_sec_special_names_paragraph_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_special_names_paragraph_clause;
}

BOOL
TTisVSC_conf_sec_special_names_paragraph_clauses(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_special_names_paragraph_clauses;
}

BOOL
TTisVSC_conf_sec_special_names_paragraph_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_special_names_paragraph_phrase;
}

BOOL
TTisVSC_conf_sec_special_names_paragraph_phrase_tail(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_special_names_paragraph_phrase_tail;
}

BOOL
TTisVSC_conf_sec_special_names_paragraph_status_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_special_names_paragraph_status_phrase;
}

BOOL
TTisVSC_conf_sec_special_names_paragraph_status_phrase_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_special_names_paragraph_status_phrase_1;
}

BOOL
TTisVSC_conf_sec_special_names_paragraph_status_phrase_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_special_names_paragraph_status_phrase_2;
}

BOOL
TTisVSC_conf_sec_symbolic_character_mapping(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_symbolic_character_mapping;
}

BOOL
TTisVSC_conf_sec_symbolic_characters_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_symbolic_characters_clause;
}

BOOL
TTisVSC_conf_sec_with_debugging_mode(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_with_debugging_mode;
}

BOOL
TTisVSC_data_div_data_division(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_data_div_data_division;
}

BOOL
TTisVSC_data_div_data_division_content(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_data_div_data_division_content;
}

BOOL
TTisVSC_data_div_file_section(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_data_div_file_section;
}

BOOL
TTisVSC_data_div_file_section_entry(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_data_div_file_section_entry;
}

BOOL
TTisVSC_data_div_linkage_section(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_data_div_linkage_section;
}

BOOL
TTisVSC_data_div_working_storage_section(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_data_div_working_storage_section;
}

BOOL
TTisVSC_dd_entry_alt_data_name_filler(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_alt_data_name_filler;
}

BOOL
TTisVSC_dd_entry_alt_leading_trailing(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_alt_leading_trailing;
}

BOOL
TTisVSC_dd_entry_alt_left_right(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_alt_left_right;
}

BOOL
TTisVSC_dd_entry_blank_when_zero_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_blank_when_zero_clause;
}

BOOL
TTisVSC_dd_entry_condition_value_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_condition_value_clause;
}

BOOL
TTisVSC_dd_entry_data_description_entry(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_data_description_entry;
}

BOOL
TTisVSC_dd_entry_data_description_entry_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_data_description_entry_1;
}

BOOL
TTisVSC_dd_entry_data_description_entry_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_data_description_entry_clause;
}

BOOL
TTisVSC_dd_entry_data_description_entry_clauses(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_data_description_entry_clauses;
}

BOOL
TTisVSC_dd_entry_external_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_external_clause;
}

BOOL
TTisVSC_dd_entry_global_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_global_clause;
}

BOOL
TTisVSC_dd_entry_indexed_by(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_indexed_by;
}

BOOL
TTisVSC_dd_entry_integer_to(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_integer_to;
}

BOOL
TTisVSC_dd_entry_justified(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_justified;
}

BOOL
TTisVSC_dd_entry_justified_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_justified_clause;
}

BOOL
TTisVSC_dd_entry_occurs_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_occurs_clause;
}

BOOL
TTisVSC_dd_entry_occurs_clause_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_occurs_clause_1;
}

BOOL
TTisVSC_dd_entry_occurs_clause_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_occurs_clause_2;
}

BOOL
TTisVSC_dd_entry_occurs_clause_key(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_occurs_clause_key;
}

BOOL
TTisVSC_dd_entry_picture(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_picture;
}

BOOL
TTisVSC_dd_entry_picture_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_picture_clause;
}

BOOL
TTisVSC_dd_entry_redefines_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_redefines_clause;
}

BOOL
TTisVSC_dd_entry_renames_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_renames_clause;
}

BOOL
TTisVSC_dd_entry_separate_character(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_separate_character;
}

BOOL
TTisVSC_dd_entry_sign_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_sign_clause;
}

BOOL
TTisVSC_dd_entry_sign_is(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_sign_is;
}

BOOL
TTisVSC_dd_entry_synchronized(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_synchronized;
}

BOOL
TTisVSC_dd_entry_synchronized_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_synchronized_clause;
}

BOOL
TTisVSC_dd_entry_usage(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_usage;
}

BOOL
TTisVSC_dd_entry_usage_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_usage_clause;
}

BOOL
TTisVSC_dd_entry_usage_is(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_usage_is;
}

BOOL
TTisVSC_dd_entry_values_are(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_values_are;
}

BOOL
TTisVSC_dd_entry_zeroes(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_zeroes;
}

BOOL
TTisVSC_env_div_environment_division(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_env_div_environment_division;
}

BOOL
TTisVSC_env_div_environment_division_content(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_env_div_environment_division_content;
}

BOOL
TTisVSC_expr_alphabet_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_alphabet_name;
}

BOOL
TTisVSC_expr_alphabetic_user_defined_word(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_alphabetic_user_defined_word;
}

BOOL
TTisVSC_expr_alt_ascending_descending(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_alt_ascending_descending;
}

BOOL
TTisVSC_expr_alt_library_name_literal(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_alt_library_name_literal;
}

BOOL
TTisVSC_expr_alt_plus_minus(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_alt_plus_minus;
}

BOOL
TTisVSC_expr_alt_reel_unit(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_alt_reel_unit;
}

BOOL
TTisVSC_expr_alt_text_name_literal(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_alt_text_name_literal;
}

BOOL
TTisVSC_expr_alt_times_div(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_alt_times_div;
}

BOOL
TTisVSC_expr_arithmetic_expression(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_arithmetic_expression;
}

BOOL
TTisVSC_expr_arithmetic_expression_tail(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_arithmetic_expression_tail;
}

BOOL
TTisVSC_expr_assignment_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_assignment_name;
}

BOOL
TTisVSC_expr_basis(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_basis;
}

BOOL
TTisVSC_expr_basis_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_basis_1;
}

BOOL
TTisVSC_expr_class_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_class_name;
}

BOOL
TTisVSC_expr_computer_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_computer_name;
}

BOOL
TTisVSC_expr_condition_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_condition_name;
}

BOOL
TTisVSC_expr_copy_operand(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_copy_operand;
}

BOOL
TTisVSC_expr_copy_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_copy_statement;
}

BOOL
TTisVSC_expr_copy_statement_by_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_copy_statement_by_phrase;
}

BOOL
TTisVSC_expr_copy_statement_replacing_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_copy_statement_replacing_phrase;
}

BOOL
TTisVSC_expr_data_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_data_name;
}

BOOL
TTisVSC_expr_data_or_file_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_data_or_file_name;
}

BOOL
TTisVSC_expr_data_or_file_or_mnemonic_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_data_or_file_or_mnemonic_name;
}

BOOL
TTisVSC_expr_environment_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_environment_name;
}

BOOL
TTisVSC_expr_equal_to(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_equal_to;
}

BOOL
TTisVSC_expr_equal_to_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_equal_to_1;
}

BOOL
TTisVSC_expr_figurative_constant(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_figurative_constant;
}

BOOL
TTisVSC_expr_figurative_constant_all(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_figurative_constant_all;
}

BOOL
TTisVSC_expr_figurative_constant_simple(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_figurative_constant_simple;
}

BOOL
TTisVSC_expr_file_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_file_name;
}

BOOL
TTisVSC_expr_identifier(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_identifier;
}

BOOL
TTisVSC_expr_identifier_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_identifier_1;
}

BOOL
TTisVSC_expr_identifier_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_identifier_2;
}

BOOL
TTisVSC_expr_in(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_in;
}

BOOL
TTisVSC_expr_in_data_or_file_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_in_data_or_file_name;
}

BOOL
TTisVSC_expr_in_data_or_file_or_mnemonic_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_in_data_or_file_or_mnemonic_name;
}

BOOL
TTisVSC_expr_in_file_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_in_file_name;
}

BOOL
TTisVSC_expr_in_library(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_in_library;
}

BOOL
TTisVSC_expr_in_section_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_in_section_name;
}

BOOL
TTisVSC_expr_index_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_index_name;
}

BOOL
TTisVSC_expr_integer(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_integer;
}

BOOL
TTisVSC_expr_leftmost_character_position(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_leftmost_character_position;
}

BOOL
TTisVSC_expr_length(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_length;
}

BOOL
TTisVSC_expr_level_number(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_level_number;
}

BOOL
TTisVSC_expr_library_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_library_name;
}

BOOL
TTisVSC_expr_literal(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_literal;
}

BOOL
TTisVSC_expr_literal_through_literal(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_literal_through_literal;
}

BOOL
TTisVSC_expr_mnemonic_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_mnemonic_name;
}

BOOL
TTisVSC_expr_numeric(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_numeric;
}

BOOL
TTisVSC_expr_paragraph_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_paragraph_name;
}

BOOL
TTisVSC_expr_paragraph_or_section_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_paragraph_or_section_name;
}

BOOL
TTisVSC_expr_plus_minus_integer(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_plus_minus_integer;
}

BOOL
TTisVSC_expr_power(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_power;
}

BOOL
TTisVSC_expr_power_tail(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_power_tail;
}

BOOL
TTisVSC_expr_priority_number(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_priority_number;
}

BOOL
TTisVSC_expr_procedure_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_procedure_name;
}

BOOL
TTisVSC_expr_program_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_program_name;
}

BOOL
TTisVSC_expr_qualified_data_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_qualified_data_name;
}

BOOL
TTisVSC_expr_qualified_data_name_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_qualified_data_name_1;
}

BOOL
TTisVSC_expr_record_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_record_name;
}

BOOL
TTisVSC_expr_records(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_records;
}

BOOL
TTisVSC_expr_reference_modification(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_reference_modification;
}

BOOL
TTisVSC_expr_section_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_section_name;
}

BOOL
TTisVSC_expr_special_register_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_special_register_1;
}

BOOL
TTisVSC_expr_special_register_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_special_register_2;
}

BOOL
TTisVSC_expr_subscript(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_subscript;
}

BOOL
TTisVSC_expr_subscript_expression(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_subscript_expression;
}

BOOL
TTisVSC_expr_subscript_expression_ambiguous(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_subscript_expression_ambiguous;
}

BOOL
TTisVSC_expr_subscript_parentheses(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_subscript_parentheses;
}

BOOL
TTisVSC_expr_symbolic_character(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_symbolic_character;
}

BOOL
TTisVSC_expr_system_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_system_name;
}

BOOL
TTisVSC_expr_text_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_text_name;
}

BOOL
TTisVSC_expr_through(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_through;
}

BOOL
TTisVSC_expr_through_arithmetic_expression(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_through_arithmetic_expression;
}

BOOL
TTisVSC_expr_through_literal(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_through_literal;
}

BOOL
TTisVSC_expr_through_qualified_data_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_through_qualified_data_name;
}

BOOL
TTisVSC_expr_times_div(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_times_div;
}

BOOL
TTisVSC_expr_times_div_tail(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_times_div_tail;
}

BOOL
TTisVSC_expr_user_defined_word(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_user_defined_word;
}

BOOL
TTisVSC_expr_values(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_values;
}

BOOL
TTisVSC_fd_entry_alt_characters_records(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_alt_characters_records;
}

BOOL
TTisVSC_fd_entry_alt_data_name_integer(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_alt_data_name_integer;
}

BOOL
TTisVSC_fd_entry_alt_fd_sd(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_alt_fd_sd;
}

BOOL
TTisVSC_fd_entry_alt_qualified_data_name_literal(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_alt_qualified_data_name_literal;
}

BOOL
TTisVSC_fd_entry_block_contains_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_block_contains_clause;
}

BOOL
TTisVSC_fd_entry_code_set_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_code_set_clause;
}

BOOL
TTisVSC_fd_entry_data_names(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_data_names;
}

BOOL
TTisVSC_fd_entry_data_records_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_data_records_clause;
}

BOOL
TTisVSC_fd_entry_depending_on(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_depending_on;
}

BOOL
TTisVSC_fd_entry_file_and_sort_description_entry(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_file_and_sort_description_entry;
}

BOOL
TTisVSC_fd_entry_file_and_sort_description_entry_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_file_and_sort_description_entry_clause;
}

BOOL
TTisVSC_fd_entry_file_and_sort_description_entry_clauses(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_file_and_sort_description_entry_clauses;
}

BOOL
TTisVSC_fd_entry_footing(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_footing;
}

BOOL
TTisVSC_fd_entry_from_integer(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_from_integer;
}

BOOL
TTisVSC_fd_entry_label_records_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_label_records_clause;
}

BOOL
TTisVSC_fd_entry_label_records_clause_tail(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_label_records_clause_tail;
}

BOOL
TTisVSC_fd_entry_linage_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_linage_clause;
}

BOOL
TTisVSC_fd_entry_linage_footing_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_linage_footing_phrase;
}

BOOL
TTisVSC_fd_entry_lines_bottom(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_lines_bottom;
}

BOOL
TTisVSC_fd_entry_lines_top(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_lines_top;
}

BOOL
TTisVSC_fd_entry_record_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_record_clause;
}

BOOL
TTisVSC_fd_entry_record_clause_tail(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_record_clause_tail;
}

BOOL
TTisVSC_fd_entry_record_clause_tail_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_record_clause_tail_1;
}

BOOL
TTisVSC_fd_entry_record_clause_tail_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_record_clause_tail_2;
}

BOOL
TTisVSC_fd_entry_record_clause_tail_3(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_record_clause_tail_3;
}

BOOL
TTisVSC_fd_entry_record_varying_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_record_varying_phrase;
}

BOOL
TTisVSC_fd_entry_recording_mode_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_recording_mode_clause;
}

BOOL
TTisVSC_fd_entry_records_are(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_records_are;
}

BOOL
TTisVSC_fd_entry_to_integer(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_to_integer;
}

BOOL
TTisVSC_fd_entry_value_of_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_value_of_clause;
}

BOOL
TTisVSC_fd_entry_value_of_clause_tail(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_value_of_clause_tail;
}

BOOL
TTisVSC_id_div_author(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_id_div_author;
}

BOOL
TTisVSC_id_div_date_compiled(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_id_div_date_compiled;
}

BOOL
TTisVSC_id_div_date_written(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_id_div_date_written;
}

BOOL
TTisVSC_id_div_identification(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_id_div_identification;
}

BOOL
TTisVSC_id_div_identification_division(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_id_div_identification_division;
}

BOOL
TTisVSC_id_div_identification_division_content(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_id_div_identification_division_content;
}

BOOL
TTisVSC_id_div_identification_division_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_id_div_identification_division_phrase;
}

BOOL
TTisVSC_id_div_initial_program(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_id_div_initial_program;
}

BOOL
TTisVSC_id_div_installation(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_id_div_installation;
}

BOOL
TTisVSC_id_div_program_id_cobol_source_program(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_id_div_program_id_cobol_source_program;
}

BOOL
TTisVSC_id_div_remarks(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_id_div_remarks;
}

BOOL
TTisVSC_id_div_security(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_id_div_security;
}

BOOL
TTisVSC_io_sec_alt_assignment_name_file_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_alt_assignment_name_file_name;
}

BOOL
TTisVSC_io_sec_alt_assignment_name_literal(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_alt_assignment_name_literal;
}

BOOL
TTisVSC_io_sec_alt_indexed_relative_sequential(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_alt_indexed_relative_sequential;
}

BOOL
TTisVSC_io_sec_alt_sequential_random_dynamic(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_alt_sequential_random_dynamic;
}

BOOL
TTisVSC_io_sec_alternate_record_key_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_alternate_record_key_clause;
}

BOOL
TTisVSC_io_sec_areas(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_areas;
}

BOOL
TTisVSC_io_sec_assign_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_assign_clause;
}

BOOL
TTisVSC_io_sec_every_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_every_phrase;
}

BOOL
TTisVSC_io_sec_every_phrase_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_every_phrase_1;
}

BOOL
TTisVSC_io_sec_every_phrase_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_every_phrase_2;
}

BOOL
TTisVSC_io_sec_fce_access_mode(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_fce_access_mode;
}

BOOL
TTisVSC_io_sec_fce_organization(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_fce_organization;
}

BOOL
TTisVSC_io_sec_fce_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_fce_phrase;
}

BOOL
TTisVSC_io_sec_file_control_entry(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_file_control_entry;
}

BOOL
TTisVSC_io_sec_file_control_paragraph(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_file_control_paragraph;
}

BOOL
TTisVSC_io_sec_file_name_position(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_file_name_position;
}

BOOL
TTisVSC_io_sec_file_status_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_file_status_clause;
}

BOOL
TTisVSC_io_sec_i_o_control_paragraph(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_i_o_control_paragraph;
}

BOOL
TTisVSC_io_sec_i_o_sam(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_i_o_sam;
}

BOOL
TTisVSC_io_sec_i_o_sort_merge(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_i_o_sort_merge;
}

BOOL
TTisVSC_io_sec_input_output_section(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_input_output_section;
}

BOOL
TTisVSC_io_sec_organization_is(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_organization_is;
}

BOOL
TTisVSC_io_sec_padding_character_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_padding_character_clause;
}

BOOL
TTisVSC_io_sec_password_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_password_clause;
}

BOOL
TTisVSC_io_sec_position(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_position;
}

BOOL
TTisVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries;
}

BOOL
TTisVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_1;
}

BOOL
TTisVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_2;
}

BOOL
TTisVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_3(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_3;
}

BOOL
TTisVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_4(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_4;
}

BOOL
TTisVSC_io_sec_record_delimiter_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_record_delimiter_clause;
}

BOOL
TTisVSC_io_sec_record_delimiter_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_record_delimiter_name;
}

BOOL
TTisVSC_io_sec_record_key_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_record_key_clause;
}

BOOL
TTisVSC_io_sec_record_sort(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_record_sort;
}

BOOL
TTisVSC_io_sec_relative_key_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_relative_key_clause;
}

BOOL
TTisVSC_io_sec_rerun_on(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_rerun_on;
}

BOOL
TTisVSC_io_sec_reserve_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_reserve_clause;
}

BOOL
TTisVSC_io_sec_same_area(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_same_area;
}

BOOL
TTisVSC_io_sec_select_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_select_clause;
}

BOOL
TTisVSC_io_sec_sort_merge_i_o_control_entries(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_sort_merge_i_o_control_entries;
}

BOOL
TTisVSC_io_sec_with_duplicates(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_with_duplicates;
}

BOOL
TTisVSC_main_cobol_source_program(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_main_cobol_source_program;
}

BOOL
TTisVSC_main_common_initial(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_main_common_initial;
}

BOOL
TTisVSC_main_common_initial_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_main_common_initial_1;
}

BOOL
TTisVSC_main_common_initial_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_main_common_initial_2;
}

BOOL
TTisVSC_main_common_initial_program(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_main_common_initial_program;
}

BOOL
TTisVSC_main_nested_cobol_source_program(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_main_nested_cobol_source_program;
}

BOOL
TTisVSC_main_nested_program(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_main_nested_program;
}

BOOL
TTisVSC_main_program_id_nested_cobol_source_program(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_main_program_id_nested_cobol_source_program;
}

BOOL
TTisVSC_main_programs(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_main_programs;
}

BOOL
TTisVSC_proc_div_altered_goto(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_altered_goto;
}

BOOL
TTisVSC_proc_div_declaratives(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_declaratives;
}

BOOL
TTisVSC_proc_div_declaratives_content(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_declaratives_content;
}

BOOL
TTisVSC_proc_div_paragraph(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_paragraph;
}

BOOL
TTisVSC_proc_div_paragraph_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_paragraph_1;
}

BOOL
TTisVSC_proc_div_paragraphs(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_paragraphs;
}

BOOL
TTisVSC_proc_div_procedure_division(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_procedure_division;
}

BOOL
TTisVSC_proc_div_section_header(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_section_header;
}

BOOL
TTisVSC_proc_div_section_with_header(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_section_with_header;
}

BOOL
TTisVSC_proc_div_sections(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_sections;
}

BOOL
TTisVSC_proc_div_sentence(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_sentence;
}

BOOL
TTisVSC_proc_div_sentence_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_sentence_1;
}

BOOL
TTisVSC_proc_div_sentence_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_sentence_2;
}

BOOL
TTisVSC_proc_div_using_data_names(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_using_data_names;
}

BOOL
TTisVSC_proc_div_using_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_using_phrase;
}

BOOL
TTisVSC_proc_div_using_phrase_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_using_phrase_1;
}

BOOL
TTisVSC_proc_div_using_phrase_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_using_phrase_2;
}

BOOL
TTisVSC_stat_accept_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_accept_statement;
}

BOOL
TTisVSC_stat_accept_statement_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_accept_statement_1;
}

BOOL
TTisVSC_stat_accept_statement_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_accept_statement_2;
}

BOOL
TTisVSC_stat_add_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_add_statement;
}

BOOL
TTisVSC_stat_add_statement_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_add_statement_1;
}

BOOL
TTisVSC_stat_add_statement_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_add_statement_2;
}

BOOL
TTisVSC_stat_add_statement_3(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_add_statement_3;
}

BOOL
TTisVSC_stat_advancing_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_advancing_phrase;
}

BOOL
TTisVSC_stat_all_procedures(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_all_procedures;
}

BOOL
TTisVSC_stat_also_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_also_phrase;
}

BOOL
TTisVSC_stat_alt_all_leading(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_all_leading;
}

BOOL
TTisVSC_stat_alt_all_leading_first(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_all_leading_first;
}

BOOL
TTisVSC_stat_alt_before_after(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_before_after;
}

BOOL
TTisVSC_stat_alt_beginning_ending(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_beginning_ending;
}

BOOL
TTisVSC_stat_alt_exception_error(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_exception_error;
}

BOOL
TTisVSC_stat_alt_file_names_i_o(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_file_names_i_o;
}

BOOL
TTisVSC_stat_alt_file_reel_unit(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_file_reel_unit;
}

BOOL
TTisVSC_stat_alt_no_rewind_lock(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_no_rewind_lock;
}

BOOL
TTisVSC_stat_alt_procedures_all_procedures(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_procedures_all_procedures;
}

BOOL
TTisVSC_stat_alt_removal_no_rewind(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_removal_no_rewind;
}

BOOL
TTisVSC_stat_alt_reversed_with_no_rewind(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_reversed_with_no_rewind;
}

BOOL
TTisVSC_stat_alt_run_literal(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_run_literal;
}

BOOL
TTisVSC_stat_alt_statement_list_next_sentence(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_statement_list_next_sentence;
}

BOOL
TTisVSC_stat_alt_up_down(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_up_down;
}

BOOL
TTisVSC_stat_alt_up_down_by(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_up_down_by;
}

BOOL
TTisVSC_stat_alter_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alter_statement;
}

BOOL
TTisVSC_stat_at_end_of_page_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_at_end_of_page_statement_list;
}

BOOL
TTisVSC_stat_at_end_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_at_end_statement_list;
}

BOOL
TTisVSC_stat_before_after_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_before_after_phrase;
}

BOOL
TTisVSC_stat_by_reference(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_by_reference;
}

BOOL
TTisVSC_stat_call_rest_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_call_rest_phrase;
}

BOOL
TTisVSC_stat_call_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_call_statement;
}

BOOL
TTisVSC_stat_cancel_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_cancel_statement;
}

BOOL
TTisVSC_stat_close_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_close_statement;
}

BOOL
TTisVSC_stat_close_statement_file_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_close_statement_file_name;
}

BOOL
TTisVSC_stat_close_statement_options(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_close_statement_options;
}

BOOL
TTisVSC_stat_close_statement_options_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_close_statement_options_1;
}

BOOL
TTisVSC_stat_close_statement_options_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_close_statement_options_2;
}

BOOL
TTisVSC_stat_cobword_int(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_cobword_int;
}

BOOL
TTisVSC_stat_cobword_rounded(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_cobword_rounded;
}

BOOL
TTisVSC_stat_collating_sequence(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_collating_sequence;
}

BOOL
TTisVSC_stat_compute_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_compute_statement;
}

BOOL
TTisVSC_stat_content_parameter(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_content_parameter;
}

BOOL
TTisVSC_stat_content_parameter_value(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_content_parameter_value;
}

BOOL
TTisVSC_stat_continue_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_continue_statement;
}

BOOL
TTisVSC_stat_corresponding(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_corresponding;
}

BOOL
TTisVSC_stat_count_in_identifier(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_count_in_identifier;
}

BOOL
TTisVSC_stat_date(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_date;
}

BOOL
TTisVSC_stat_delete_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_delete_statement;
}

BOOL
TTisVSC_stat_delimited_by_all_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_delimited_by_all_phrase;
}

BOOL
TTisVSC_stat_delimited_by_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_delimited_by_phrase;
}

BOOL
TTisVSC_stat_delimiter_in_identifier(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_delimiter_in_identifier;
}

BOOL
TTisVSC_stat_display_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_display_statement;
}

BOOL
TTisVSC_stat_divide_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_divide_statement;
}

BOOL
TTisVSC_stat_divide_statement_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_divide_statement_1;
}

BOOL
TTisVSC_stat_divide_statement_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_divide_statement_2;
}

BOOL
TTisVSC_stat_divide_statement_3(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_divide_statement_3;
}

BOOL
TTisVSC_stat_divide_statement_4(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_divide_statement_4;
}

BOOL
TTisVSC_stat_divide_statement_5(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_divide_statement_5;
}

BOOL
TTisVSC_stat_else_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_else_phrase;
}

BOOL
TTisVSC_stat_end_of_page(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_end_of_page;
}

BOOL
TTisVSC_stat_entry_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_entry_statement;
}

BOOL
TTisVSC_stat_equal(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_equal;
}

BOOL
TTisVSC_stat_evaluate_condition(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_evaluate_condition;
}

BOOL
TTisVSC_stat_evaluate_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_evaluate_phrase;
}

BOOL
TTisVSC_stat_evaluate_phrase_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_evaluate_phrase_1;
}

BOOL
TTisVSC_stat_evaluate_phrase_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_evaluate_phrase_2;
}

BOOL
TTisVSC_stat_evaluate_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_evaluate_statement;
}

BOOL
TTisVSC_stat_exit_program_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_exit_program_statement;
}

BOOL
TTisVSC_stat_exit_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_exit_statement;
}

BOOL
TTisVSC_stat_file_names(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_file_names;
}

BOOL
TTisVSC_stat_for_removal(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_for_removal;
}

BOOL
TTisVSC_stat_from_environment_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_from_environment_name;
}

BOOL
TTisVSC_stat_from_identifier(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_from_identifier;
}

BOOL
TTisVSC_stat_giving_file_names(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_giving_file_names;
}

BOOL
TTisVSC_stat_go_to_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_go_to_statement;
}

BOOL
TTisVSC_stat_go_to_statement_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_go_to_statement_1;
}

BOOL
TTisVSC_stat_go_to_statement_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_go_to_statement_2;
}

BOOL
TTisVSC_stat_go_to_statement_3(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_go_to_statement_3;
}

BOOL
TTisVSC_stat_goback_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_goback_statement;
}

BOOL
TTisVSC_stat_id_or_lit(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_id_or_lit;
}

BOOL
TTisVSC_stat_id_or_lit_size(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_id_or_lit_size;
}

BOOL
TTisVSC_stat_if_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_if_statement;
}

BOOL
TTisVSC_stat_initialize_replacing_argument(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_initialize_replacing_argument;
}

BOOL
TTisVSC_stat_initialize_replacing_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_initialize_replacing_phrase;
}

BOOL
TTisVSC_stat_initialize_replacing_type(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_initialize_replacing_type;
}

BOOL
TTisVSC_stat_initialize_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_initialize_statement;
}

BOOL
TTisVSC_stat_input_procedure(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_input_procedure;
}

BOOL
TTisVSC_stat_inspect_by_argument(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_inspect_by_argument;
}

BOOL
TTisVSC_stat_inspect_replacing_argument(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_inspect_replacing_argument;
}

BOOL
TTisVSC_stat_inspect_replacing_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_inspect_replacing_phrase;
}

BOOL
TTisVSC_stat_inspect_replacing_phrase_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_inspect_replacing_phrase_1;
}

BOOL
TTisVSC_stat_inspect_replacing_phrase_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_inspect_replacing_phrase_2;
}

BOOL
TTisVSC_stat_inspect_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_inspect_statement;
}

BOOL
TTisVSC_stat_inspect_statement_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_inspect_statement_1;
}

BOOL
TTisVSC_stat_inspect_statement_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_inspect_statement_2;
}

BOOL
TTisVSC_stat_inspect_statement_3(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_inspect_statement_3;
}

BOOL
TTisVSC_stat_inspect_statement_4(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_inspect_statement_4;
}

BOOL
TTisVSC_stat_into_identifier(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_into_identifier;
}

BOOL
TTisVSC_stat_invalid_key_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_invalid_key_statement_list;
}

BOOL
TTisVSC_stat_key_is(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_key_is;
}

BOOL
TTisVSC_stat_key_is_qualified_data_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_key_is_qualified_data_name;
}

BOOL
TTisVSC_stat_key_is_rel_op_qualified_data_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_key_is_rel_op_qualified_data_name;
}

BOOL
TTisVSC_stat_lines(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_lines;
}

BOOL
TTisVSC_stat_merge_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_merge_statement;
}

BOOL
TTisVSC_stat_merge_statement_tail(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_merge_statement_tail;
}

BOOL
TTisVSC_stat_move_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_move_statement;
}

BOOL
TTisVSC_stat_move_statement_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_move_statement_1;
}

BOOL
TTisVSC_stat_move_statement_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_move_statement_2;
}

BOOL
TTisVSC_stat_multiply_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_multiply_statement;
}

BOOL
TTisVSC_stat_multiply_statement_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_multiply_statement_1;
}

BOOL
TTisVSC_stat_multiply_statement_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_multiply_statement_2;
}

BOOL
TTisVSC_stat_next_sentence(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_next_sentence;
}

BOOL
TTisVSC_stat_no_rewind(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_no_rewind;
}

BOOL
TTisVSC_stat_not_at_end_of_page_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_not_at_end_of_page_statement_list;
}

BOOL
TTisVSC_stat_not_at_end_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_not_at_end_statement_list;
}

BOOL
TTisVSC_stat_not_invalid_key_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_not_invalid_key_statement_list;
}

BOOL
TTisVSC_stat_not_on_exception_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_not_on_exception_statement_list;
}

BOOL
TTisVSC_stat_not_on_overflow_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_not_on_overflow_statement_list;
}

BOOL
TTisVSC_stat_not_on_size_error_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_not_on_size_error_statement_list;
}

BOOL
TTisVSC_stat_nr_lines_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_nr_lines_phrase;
}

BOOL
TTisVSC_stat_on_exception_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_on_exception_statement_list;
}

BOOL
TTisVSC_stat_on_key_is_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_on_key_is_phrase;
}

BOOL
TTisVSC_stat_on_key_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_on_key_phrase;
}

BOOL
TTisVSC_stat_on_overflow_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_on_overflow_statement_list;
}

BOOL
TTisVSC_stat_on_size_error_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_on_size_error_statement_list;
}

BOOL
TTisVSC_stat_open_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_open_statement;
}

BOOL
TTisVSC_stat_open_statement_extend(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_open_statement_extend;
}

BOOL
TTisVSC_stat_open_statement_i_o(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_open_statement_i_o;
}

BOOL
TTisVSC_stat_open_statement_input(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_open_statement_input;
}

BOOL
TTisVSC_stat_open_statement_input_file_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_open_statement_input_file_name;
}

BOOL
TTisVSC_stat_open_statement_output(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_open_statement_output;
}

BOOL
TTisVSC_stat_open_statement_output_file_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_open_statement_output_file_name;
}

BOOL
TTisVSC_stat_open_statement_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_open_statement_phrase;
}

BOOL
TTisVSC_stat_or_all_id_or_lit(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_or_all_id_or_lit;
}

BOOL
TTisVSC_stat_output_procedure(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_output_procedure;
}

BOOL
TTisVSC_stat_page_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_page_phrase;
}

BOOL
TTisVSC_stat_parameter(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_parameter;
}

BOOL
TTisVSC_stat_perform_after_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_after_phrase;
}

BOOL
TTisVSC_stat_perform_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement;
}

BOOL
TTisVSC_stat_perform_statement_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_1;
}

BOOL
TTisVSC_stat_perform_statement_1_alts(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_1_alts;
}

BOOL
TTisVSC_stat_perform_statement_1_procedure(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_1_procedure;
}

BOOL
TTisVSC_stat_perform_statement_1_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_1_statement_list;
}

BOOL
TTisVSC_stat_perform_statement_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_2;
}

BOOL
TTisVSC_stat_perform_statement_2_alts(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_2_alts;
}

BOOL
TTisVSC_stat_perform_statement_2_procedure(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_2_procedure;
}

BOOL
TTisVSC_stat_perform_statement_2_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_2_statement_list;
}

BOOL
TTisVSC_stat_perform_statement_3(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_3;
}

BOOL
TTisVSC_stat_perform_statement_3_alts(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_3_alts;
}

BOOL
TTisVSC_stat_perform_statement_3_procedure(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_3_procedure;
}

BOOL
TTisVSC_stat_perform_statement_3_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_3_statement_list;
}

BOOL
TTisVSC_stat_perform_statement_4(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_4;
}

BOOL
TTisVSC_stat_perform_statement_4_alts(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_4_alts;
}

BOOL
TTisVSC_stat_perform_statement_4_procedure(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_4_procedure;
}

BOOL
TTisVSC_stat_perform_statement_4_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_4_statement_list;
}

BOOL
TTisVSC_stat_perform_until_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_until_phrase;
}

BOOL
TTisVSC_stat_perform_varying_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_varying_phrase;
}

BOOL
TTisVSC_stat_procedure_names(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_procedure_names;
}

BOOL
TTisVSC_stat_procedure_to_procedure(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_procedure_to_procedure;
}

BOOL
TTisVSC_stat_proceed_to(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_proceed_to;
}

BOOL
TTisVSC_stat_read_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_read_statement;
}

BOOL
TTisVSC_stat_reference_parameter(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_reference_parameter;
}

BOOL
TTisVSC_stat_rel_op(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_rel_op;
}

BOOL
TTisVSC_stat_release_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_release_statement;
}

BOOL
TTisVSC_stat_return_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_return_statement;
}

BOOL
TTisVSC_stat_rewrite_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_rewrite_statement;
}

BOOL
TTisVSC_stat_search_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_search_statement;
}

BOOL
TTisVSC_stat_search_statement_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_search_statement_1;
}

BOOL
TTisVSC_stat_search_statement_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_search_statement_2;
}

BOOL
TTisVSC_stat_search_statement_condition(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_search_statement_condition;
}

BOOL
TTisVSC_stat_search_statement_condition_tail(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_search_statement_condition_tail;
}

BOOL
TTisVSC_stat_search_statement_equal_expression(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_search_statement_equal_expression;
}

BOOL
TTisVSC_stat_set_oper(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_set_oper;
}

BOOL
TTisVSC_stat_set_src(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_set_src;
}

BOOL
TTisVSC_stat_set_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_set_statement;
}

BOOL
TTisVSC_stat_set_statement_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_set_statement_phrase;
}

BOOL
TTisVSC_stat_sort_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_sort_statement;
}

BOOL
TTisVSC_stat_sort_statement_in(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_sort_statement_in;
}

BOOL
TTisVSC_stat_sort_statement_out(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_sort_statement_out;
}

BOOL
TTisVSC_stat_start_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_start_statement;
}

BOOL
TTisVSC_stat_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_statement;
}

BOOL
TTisVSC_stat_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_statement_list;
}

BOOL
TTisVSC_stat_stop_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_stop_statement;
}

BOOL
TTisVSC_stat_string_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_string_statement;
}

BOOL
TTisVSC_stat_subtract_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_subtract_statement;
}

BOOL
TTisVSC_stat_subtract_statement_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_subtract_statement_1;
}

BOOL
TTisVSC_stat_subtract_statement_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_subtract_statement_2;
}

BOOL
TTisVSC_stat_subtract_statement_3(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_subtract_statement_3;
}

BOOL
TTisVSC_stat_tallying_argument(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_tallying_argument;
}

BOOL
TTisVSC_stat_tallying_for_argument(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_tallying_for_argument;
}

BOOL
TTisVSC_stat_tallying_for_argument_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_tallying_for_argument_1;
}

BOOL
TTisVSC_stat_tallying_for_argument_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_tallying_for_argument_2;
}

BOOL
TTisVSC_stat_tallying_for_id_or_lit(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_tallying_for_id_or_lit;
}

BOOL
TTisVSC_stat_tallying_in_identifier(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_tallying_in_identifier;
}

BOOL
TTisVSC_stat_through_procedure_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_through_procedure_name;
}

BOOL
TTisVSC_stat_to_id_or_lit(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_to_id_or_lit;
}

BOOL
TTisVSC_stat_unstring_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_unstring_statement;
}

BOOL
TTisVSC_stat_unstring_statement_dst(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_unstring_statement_dst;
}

BOOL
TTisVSC_stat_upon_environment_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_upon_environment_name;
}

BOOL
TTisVSC_stat_use_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_use_statement;
}

BOOL
TTisVSC_stat_use_statement_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_use_statement_1;
}

BOOL
TTisVSC_stat_use_statement_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_use_statement_2;
}

BOOL
TTisVSC_stat_use_statement_3(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_use_statement_3;
}

BOOL
TTisVSC_stat_using_data_name_pluslist(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_using_data_name_pluslist;
}

BOOL
TTisVSC_stat_using_file_names(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_using_file_names;
}

BOOL
TTisVSC_stat_using_parameters(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_using_parameters;
}

BOOL
TTisVSC_stat_varying_identifier(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_varying_identifier;
}

BOOL
TTisVSC_stat_when_condition_stats(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_when_condition_stats;
}

BOOL
TTisVSC_stat_when_other_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_when_other_phrase;
}

BOOL
TTisVSC_stat_when_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_when_phrase;
}

BOOL
TTisVSC_stat_when_phrase_also_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_when_phrase_also_phrase;
}

BOOL
TTisVSC_stat_when_phrases(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_when_phrases;
}

BOOL
TTisVSC_stat_with_duplicates_in_order(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_with_duplicates_in_order;
}

BOOL
TTisVSC_stat_with_no_advancing(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_with_no_advancing;
}

BOOL
TTisVSC_stat_with_no_rewind(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_with_no_rewind;
}

BOOL
TTisVSC_stat_with_pointer_identifier(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_with_pointer_identifier;
}

BOOL
TTisVSC_stat_with_test(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_with_test;
}

BOOL
TTisVSC_stat_write_exceptions(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_write_exceptions;
}

BOOL
TTisVSC_stat_write_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_write_statement;
}

BOOL
TTisVSC_lex_picture_string(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_lex_picture_string;
}

BOOL
TTisVSC_lex_quoted_pseudo_text(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_lex_quoted_pseudo_text;
}

BOOL
TTisVSC_lex_num(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_lex_num;
}

BOOL
TTisVSC_lex_nonnumeric(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_lex_nonnumeric;
}

BOOL
TTisVSC_lex_cobword(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_lex_cobword;
}

TTterm
TTbuildVSC_cond_alt_and_or(TTterm t1)
{
    assert(TTist_AND(t1) || TTist_OR(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_cond_alt_and_or, args);
}

TTterm
TTbuildVSC_cond_and_or_combinable_condition(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_cond_alt_and_or(t1) && TTisVSC_cond_relational_operator_opt(t2) && TTisVSC_cond_combinable_condition(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_cond_and_or_combinable_condition, args);
}

TTterm
TTbuildVSC_cond_class_condition(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_identifier(t1) && TTisVSC_cond_is_or_is_not(t2) && TTisVSC_cond_class_type(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_cond_class_condition, args);
}

TTterm
TTbuildVSC_cond_class_type(TTterm t1)
{
    assert(TTist_NUMERIC(t1) || TTist_ALPHABETIC(t1) || TTist_ALPHABETIC_LOWER(t1) || TTist_ALPHABETIC_UPPER(t1) || TTisVSC_expr_class_name(t1) || TTist_DBCS(t1) || TTist_KANJI(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_cond_class_type, args);
}

TTterm
TTbuildVSC_cond_combinable_condition(TTterm t1)
{
    assert(TTisVSC_cond_simple_condition(t1) || TTisVSC_cond_negated_simple_conditions(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_cond_combinable_condition, args);
}

TTterm
TTbuildVSC_cond_combined_conditions(TTterm t1, TTterm t2)
{
    assert(TTisVSC_cond_combinable_condition(t1) && TTisVSC_cond_and_or_combinable_condition_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_cond_combined_conditions, args);
}

TTterm
TTbuildVSC_cond_condition(TTterm t1)
{
    assert(TTisVSC_cond_combined_conditions(t1) || TTisVSC_cond_combinable_condition(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_cond_condition, args);
}

TTterm
TTbuildVSC_cond_condition_name_reference(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_condition_name(t1) && TTisVSC_expr_in_data_or_file_or_mnemonic_name_star(t2) && TTisVSC_expr_subscript_parentheses_star(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_cond_condition_name_reference, args);
}

TTterm
TTbuildVSC_cond_greater(TTterm t1, TTterm t2)
{
    assert(TTist_GREATER(t1) && TTisVSC_cond_than(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_cond_greater, args);
}

TTterm
TTbuildVSC_cond_greater_equal(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_GREATER(t1) && TTisVSC_cond_than(t2) && TTist_OR(t3) && TTist_EQUAL(t4) && TTist_TO_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_cond_greater_equal, args);
}

TTterm
TTbuildVSC_cond_greater_than(TTterm t1)
{
    assert(TTisVSC_cond_greater_than_1(t1) || TTist_qgt(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_cond_greater_than, args);
}

TTterm
TTbuildVSC_cond_greater_than_1(TTterm t1, TTterm t2)
{
    assert(TTist_GREATER(t1) && TTist_THAN_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_cond_greater_than_1, args);
}

TTterm
TTbuildVSC_cond_greater_than_or_equal_to(TTterm t1)
{
    assert(TTisVSC_cond_greater_than_or_equal_to_1(t1) || TTisVSC_cond_greater_than_or_equal_to_2(t1) || TTisVSC_cond_greater_than_or_equal_to_3(t1) || TTist_qgt_qequal(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_cond_greater_than_or_equal_to, args);
}

TTterm
TTbuildVSC_cond_greater_than_or_equal_to_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_GREATER(t1) && TTist_THAN_opt(t2) && TTist_OR(t3) && TTist_EQUAL(t4) && TTist_TO_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_cond_greater_than_or_equal_to_1, args);
}

TTterm
TTbuildVSC_cond_greater_than_or_equal_to_2(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_NOT(t1) && TTist_LESS(t2) && TTist_THAN_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_cond_greater_than_or_equal_to_2, args);
}

TTterm
TTbuildVSC_cond_greater_than_or_equal_to_3(TTterm t1, TTterm t2)
{
    assert(TTist_NOT(t1) && TTist_qlt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_cond_greater_than_or_equal_to_3, args);
}

TTterm
TTbuildVSC_cond_is_not(TTterm t1, TTterm t2)
{
    assert(TTist_IS_opt(t1) && TTist_NOT_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_cond_is_not, args);
}

TTterm
TTbuildVSC_cond_is_or_is_not(TTterm t1)
{
    assert(TTisVSC_cond_not_is(t1) || TTisVSC_cond_is_not(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_cond_is_or_is_not, args);
}

TTterm
TTbuildVSC_cond_less(TTterm t1, TTterm t2)
{
    assert(TTist_LESS(t1) && TTisVSC_cond_than(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_cond_less, args);
}

TTterm
TTbuildVSC_cond_less_equal(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_LESS(t1) && TTisVSC_cond_than(t2) && TTist_OR(t3) && TTist_EQUAL(t4) && TTist_TO_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_cond_less_equal, args);
}

TTterm
TTbuildVSC_cond_less_equal_2(TTterm t1, TTterm t2)
{
    assert(TTist_qlt(t1) && TTist_qequal(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_cond_less_equal_2, args);
}

TTterm
TTbuildVSC_cond_negated_simple_conditions(TTterm t1, TTterm t2)
{
    assert(TTist_NOT(t1) && TTisVSC_cond_combinable_condition(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_cond_negated_simple_conditions, args);
}

TTterm
TTbuildVSC_cond_not_is(TTterm t1, TTterm t2)
{
    assert(TTist_NOT(t1) && TTist_IS(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_cond_not_is, args);
}

TTterm
TTbuildVSC_cond_not_relational_operator_rest(TTterm t1, TTterm t2)
{
    assert(TTist_NOT_opt(t1) && TTisVSC_cond_relational_operator_rest(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_cond_not_relational_operator_rest, args);
}

TTterm
TTbuildVSC_cond_relation_condition(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_arithmetic_expression(t1) && TTisVSC_cond_relational_operator(t2) && TTisVSC_cond_simple_condition(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_cond_relation_condition, args);
}

TTterm
TTbuildVSC_cond_relational_operator(TTterm t1, TTterm t2)
{
    assert(TTist_IS_opt(t1) && TTisVSC_cond_relational_operator_tail(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_cond_relational_operator, args);
}

TTterm
TTbuildVSC_cond_relational_operator_rest(TTterm t1)
{
    assert(TTisVSC_cond_greater(t1) || TTist_qgt(t1) || TTisVSC_cond_less(t1) || TTist_qlt(t1) || TTisVSC_expr_equal_to(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_cond_relational_operator_rest, args);
}

TTterm
TTbuildVSC_cond_relational_operator_tail(TTterm t1)
{
    assert(TTisVSC_cond_greater_equal(t1) || TTisVSC_cond_less_equal(t1) || TTisVSC_cond_less_equal_2(t1) || TTist_qgt_qequal(t1) || TTisVSC_cond_not_relational_operator_rest(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_cond_relational_operator_tail, args);
}

TTterm
TTbuildVSC_cond_sign_condition(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_arithmetic_expression(t1) && TTisVSC_cond_is_or_is_not(t2) && TTisVSC_cond_sign_type(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_cond_sign_condition, args);
}

TTterm
TTbuildVSC_cond_sign_type(TTterm t1)
{
    assert(TTist_POSITIVE(t1) || TTist_NEGATIVE(t1) || TTist_ZERO(t1) || TTist_ZEROES(t1) || TTist_ZEROS(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_cond_sign_type, args);
}

TTterm
TTbuildVSC_cond_simple_condition(TTterm t1)
{
    assert(TTisVSC_cond_class_condition(t1) || TTisVSC_cond_relation_condition(t1) || TTisVSC_cond_sign_condition(t1) || TTisVSC_cond_simple_condition_1(t1) || TTisVSC_expr_arithmetic_expression(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_cond_simple_condition, args);
}

TTterm
TTbuildVSC_cond_simple_condition_1(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_qpopen(t1) && TTisVSC_cond_condition(t2) && TTist_qpclose(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_cond_simple_condition_1, args);
}

TTterm
TTbuildVSC_cond_than(TTterm t1)
{
    assert(TTist_THAN(t1) || TTist_THEN_opt(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_cond_than, args);
}

TTterm
TTbuildVSC_conf_sec_alphabet_clause(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_ALPHABET(t1) && TTisVSC_expr_alphabet_name(t2) && TTist_IS_opt(t3) && TTisVSC_conf_sec_alphabet_type(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_conf_sec_alphabet_clause, args);
}

TTterm
TTbuildVSC_conf_sec_alphabet_type(TTterm t1)
{
    assert(TTist_STANDARD_1(t1) || TTist_STANDARD_2(t1) || TTist_NATIVE(t1) || TTist_EBCDIC(t1) || TTisVSC_conf_sec_alphabet_type_others(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_conf_sec_alphabet_type, args);
}

TTterm
TTbuildVSC_conf_sec_alphabet_type_also(TTterm t1, TTterm t2)
{
    assert(TTist_ALSO(t1) && TTisVSC_expr_literal(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_conf_sec_alphabet_type_also, args);
}

TTterm
TTbuildVSC_conf_sec_alphabet_type_also_through(TTterm t1)
{
    assert(TTisVSC_expr_through_literal(t1) || TTisVSC_conf_sec_alphabet_type_alsos(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_conf_sec_alphabet_type_also_through, args);
}

TTterm
TTbuildVSC_conf_sec_alphabet_type_alsos(TTterm t1)
{
    assert(TTisVSC_conf_sec_alphabet_type_also_plus(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_conf_sec_alphabet_type_alsos, args);
}

TTterm
TTbuildVSC_conf_sec_alphabet_type_other(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_literal(t1) && TTisVSC_conf_sec_alphabet_type_also_through_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_conf_sec_alphabet_type_other, args);
}

TTterm
TTbuildVSC_conf_sec_alphabet_type_others(TTterm t1)
{
    assert(TTisVSC_conf_sec_alphabet_type_other_plus(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_conf_sec_alphabet_type_others, args);
}

TTterm
TTbuildVSC_conf_sec_are(TTterm t1)
{
    assert(TTist_ARE(t1) || TTist_IS(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_conf_sec_are, args);
}

TTterm
TTbuildVSC_conf_sec_class_clause(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_CLASS(t1) && TTisVSC_expr_class_name(t2) && TTist_IS_opt(t3) && TTisVSC_expr_literal_through_literal_plus(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_conf_sec_class_clause, args);
}

TTterm
TTbuildVSC_conf_sec_configuration_section(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_CONFIGURATION(t1) && TTist_SECTION(t2) && TTist_qdot(t3) && TTisVSC_conf_sec_configuration_section_paragraphs(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_conf_sec_configuration_section, args);
}

TTterm
TTbuildVSC_conf_sec_configuration_section_paragraph(TTterm t1)
{
    assert(TTisVSC_conf_sec_source_computer_paragraph(t1) || TTisVSC_conf_sec_object_computer_paragraph(t1) || TTisVSC_conf_sec_special_names_paragraph(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_conf_sec_configuration_section_paragraph, args);
}

TTterm
TTbuildVSC_conf_sec_configuration_section_paragraphs(TTterm t1)
{
    assert(TTisVSC_conf_sec_configuration_section_paragraph_star(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_conf_sec_configuration_section_paragraphs, args);
}

TTterm
TTbuildVSC_conf_sec_currency_sign_clause(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_CURRENCY(t1) && TTist_SIGN_opt(t2) && TTist_IS_opt(t3) && TTisVSC_expr_literal(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_conf_sec_currency_sign_clause, args);
}

TTterm
TTbuildVSC_conf_sec_decimal_point_clause(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_DECIMAL_POINT(t1) && TTist_IS_opt(t2) && TTist_COMMA(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_conf_sec_decimal_point_clause, args);
}

TTterm
TTbuildVSC_conf_sec_in_alphabet_name(TTterm t1, TTterm t2)
{
    assert(TTist_IN(t1) && TTisVSC_expr_alphabet_name(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_conf_sec_in_alphabet_name, args);
}

TTterm
TTbuildVSC_conf_sec_is_mnemonic_name(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_IS_opt(t1) && TTisVSC_expr_mnemonic_name(t2) && TTisVSC_conf_sec_special_names_paragraph_status_phrase_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_conf_sec_is_mnemonic_name, args);
}

TTterm
TTbuildVSC_conf_sec_memory_size(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_MEMORY(t1) && TTist_SIZE_opt(t2) && TTisVSC_expr_integer(t3) && TTisVSC_conf_sec_memory_size_type(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_conf_sec_memory_size, args);
}

TTterm
TTbuildVSC_conf_sec_memory_size_type(TTterm t1)
{
    assert(TTist_WORDS(t1) || TTist_CHARACTERS(t1) || TTist_MODULES(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_conf_sec_memory_size_type, args);
}

TTterm
TTbuildVSC_conf_sec_object_computer_name(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_expr_computer_name(t1) && TTisVSC_conf_sec_memory_size_opt(t2) && TTisVSC_conf_sec_object_computer_paragraph_sequence_phrase(t3) && TTist_qdot(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_conf_sec_object_computer_name, args);
}

TTterm
TTbuildVSC_conf_sec_object_computer_paragraph(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_OBJECT_COMPUTER(t1) && TTist_qdot(t2) && TTisVSC_conf_sec_object_computer_name_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_conf_sec_object_computer_paragraph, args);
}

TTterm
TTbuildVSC_conf_sec_object_computer_paragraph_sequence_phrase(TTterm t1, TTterm t2)
{
    assert(TTisVSC_conf_sec_program_collating_sequence_opt(t1) && TTisVSC_conf_sec_segment_limit_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_conf_sec_object_computer_paragraph_sequence_phrase, args);
}

TTterm
TTbuildVSC_conf_sec_off_status(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_OFF(t1) && TTist_STATUS_opt(t2) && TTist_IS_opt(t3) && TTisVSC_cond_condition(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_conf_sec_off_status, args);
}

TTterm
TTbuildVSC_conf_sec_on_status(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_ON(t1) && TTist_STATUS_opt(t2) && TTist_IS_opt(t3) && TTisVSC_cond_condition(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_conf_sec_on_status, args);
}

TTterm
TTbuildVSC_conf_sec_program_collating_sequence(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_PROGRAM_opt(t1) && TTist_COLLATING_opt(t2) && TTist_SEQUENCE(t3) && TTist_IS_opt(t4) && TTisVSC_expr_alphabet_name(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_conf_sec_program_collating_sequence, args);
}

TTterm
TTbuildVSC_conf_sec_segment_limit(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_SEGMENT_LIMIT(t1) && TTist_IS_opt(t2) && TTisVSC_expr_priority_number(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_conf_sec_segment_limit, args);
}

TTterm
TTbuildVSC_conf_sec_source_computer_name(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_computer_name(t1) && TTisVSC_conf_sec_with_debugging_mode_opt(t2) && TTist_qdot(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_conf_sec_source_computer_name, args);
}

TTterm
TTbuildVSC_conf_sec_source_computer_paragraph(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_SOURCE_COMPUTER(t1) && TTist_qdot(t2) && TTisVSC_conf_sec_source_computer_name_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_conf_sec_source_computer_paragraph, args);
}

TTterm
TTbuildVSC_conf_sec_special_names_paragraph(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_SPECIAL_NAMES(t1) && TTist_qdot(t2) && TTisVSC_conf_sec_special_names_paragraph_phrase_star(t3) && TTisVSC_conf_sec_special_names_paragraph_clauses(t4) && TTist_qdot_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_conf_sec_special_names_paragraph, args);
}

TTterm
TTbuildVSC_conf_sec_special_names_paragraph_clause(TTterm t1)
{
    assert(TTisVSC_conf_sec_alphabet_clause(t1) || TTisVSC_conf_sec_symbolic_characters_clause(t1) || TTisVSC_conf_sec_class_clause(t1) || TTisVSC_conf_sec_currency_sign_clause(t1) || TTisVSC_conf_sec_decimal_point_clause(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_conf_sec_special_names_paragraph_clause, args);
}

TTterm
TTbuildVSC_conf_sec_special_names_paragraph_clauses(TTterm t1)
{
    assert(TTisVSC_conf_sec_special_names_paragraph_clause_star(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_conf_sec_special_names_paragraph_clauses, args);
}

TTterm
TTbuildVSC_conf_sec_special_names_paragraph_phrase(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_environment_name(t1) && TTisVSC_conf_sec_special_names_paragraph_phrase_tail(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_conf_sec_special_names_paragraph_phrase, args);
}

TTterm
TTbuildVSC_conf_sec_special_names_paragraph_phrase_tail(TTterm t1)
{
    assert(TTisVSC_conf_sec_is_mnemonic_name(t1) || TTisVSC_conf_sec_special_names_paragraph_status_phrase(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_conf_sec_special_names_paragraph_phrase_tail, args);
}

TTterm
TTbuildVSC_conf_sec_special_names_paragraph_status_phrase(TTterm t1)
{
    assert(TTisVSC_conf_sec_special_names_paragraph_status_phrase_1(t1) || TTisVSC_conf_sec_special_names_paragraph_status_phrase_2(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_conf_sec_special_names_paragraph_status_phrase, args);
}

TTterm
TTbuildVSC_conf_sec_special_names_paragraph_status_phrase_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_ON(t1) && TTist_STATUS_opt(t2) && TTist_IS_opt(t3) && TTisVSC_cond_condition(t4) && TTisVSC_conf_sec_off_status_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_conf_sec_special_names_paragraph_status_phrase_1, args);
}

TTterm
TTbuildVSC_conf_sec_special_names_paragraph_status_phrase_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_OFF(t1) && TTist_STATUS_opt(t2) && TTist_IS_opt(t3) && TTisVSC_cond_condition(t4) && TTisVSC_conf_sec_on_status_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_conf_sec_special_names_paragraph_status_phrase_2, args);
}

TTterm
TTbuildVSC_conf_sec_symbolic_character_mapping(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_symbolic_character_plus(t1) && TTisVSC_conf_sec_are_opt(t2) && TTisVSC_expr_integer_plus(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_conf_sec_symbolic_character_mapping, args);
}

TTterm
TTbuildVSC_conf_sec_symbolic_characters_clause(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_SYMBOLIC(t1) && TTist_CHARACTERS_opt(t2) && TTisVSC_conf_sec_symbolic_character_mapping_plus(t3) && TTisVSC_conf_sec_in_alphabet_name_opt(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_conf_sec_symbolic_characters_clause, args);
}

TTterm
TTbuildVSC_conf_sec_with_debugging_mode(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_WITH_opt(t1) && TTist_DEBUGGING(t2) && TTist_MODE(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_conf_sec_with_debugging_mode, args);
}

TTterm
TTbuildVSC_data_div_data_division(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_DATA(t1) && TTist_DIVISION(t2) && TTist_qdot(t3) && TTisVSC_data_div_data_division_content(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_data_div_data_division, args);
}

TTterm
TTbuildVSC_data_div_data_division_content(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_data_div_file_section_opt(t1) && TTisVSC_data_div_working_storage_section_opt(t2) && TTisVSC_data_div_linkage_section_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_data_div_data_division_content, args);
}

TTterm
TTbuildVSC_data_div_file_section(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_FILE(t1) && TTist_SECTION(t2) && TTist_qdot(t3) && TTisVSC_data_div_file_section_entry_star(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_data_div_file_section, args);
}

TTterm
TTbuildVSC_data_div_file_section_entry(TTterm t1, TTterm t2)
{
    assert(TTisVSC_fd_entry_file_and_sort_description_entry(t1) && TTisVSC_dd_entry_data_description_entry_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_data_div_file_section_entry, args);
}

TTterm
TTbuildVSC_data_div_linkage_section(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_LINKAGE(t1) && TTist_SECTION(t2) && TTist_qdot(t3) && TTisVSC_dd_entry_data_description_entry_star(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_data_div_linkage_section, args);
}

TTterm
TTbuildVSC_data_div_working_storage_section(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_WORKING_STORAGE(t1) && TTist_SECTION(t2) && TTist_qdot(t3) && TTisVSC_dd_entry_data_description_entry_star(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_data_div_working_storage_section, args);
}

TTterm
TTbuildVSC_dd_entry_alt_data_name_filler(TTterm t1)
{
    assert(TTisVSC_expr_data_name(t1) || TTist_FILLER(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_dd_entry_alt_data_name_filler, args);
}

TTterm
TTbuildVSC_dd_entry_alt_leading_trailing(TTterm t1)
{
    assert(TTist_LEADING(t1) || TTist_TRAILING(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_dd_entry_alt_leading_trailing, args);
}

TTterm
TTbuildVSC_dd_entry_alt_left_right(TTterm t1)
{
    assert(TTist_LEFT(t1) || TTist_RIGHT(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_dd_entry_alt_left_right, args);
}

TTterm
TTbuildVSC_dd_entry_blank_when_zero_clause(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_BLANK(t1) && TTist_WHEN_opt(t2) && TTisVSC_dd_entry_zeroes(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_dd_entry_blank_when_zero_clause, args);
}

TTterm
TTbuildVSC_dd_entry_condition_value_clause(TTterm t1, TTterm t2)
{
    assert(TTisVSC_dd_entry_values_are(t1) && TTisVSC_expr_literal_through_literal_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_dd_entry_condition_value_clause, args);
}

TTterm
TTbuildVSC_dd_entry_data_description_entry(TTterm t1)
{
    assert(TTisVSC_dd_entry_data_description_entry_1(t1) || TTisVSC_expr_copy_statement(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_dd_entry_data_description_entry, args);
}

TTterm
TTbuildVSC_dd_entry_data_description_entry_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_expr_level_number(t1) && TTisVSC_dd_entry_alt_data_name_filler_opt(t2) && TTisVSC_dd_entry_data_description_entry_clauses(t3) && TTist_qdot_opt(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_dd_entry_data_description_entry_1, args);
}

TTterm
TTbuildVSC_dd_entry_data_description_entry_clause(TTterm t1)
{
    assert(TTisVSC_dd_entry_picture_clause(t1) || TTisVSC_dd_entry_redefines_clause(t1) || TTisVSC_dd_entry_blank_when_zero_clause(t1) || TTisVSC_dd_entry_external_clause(t1) || TTisVSC_dd_entry_global_clause(t1) || TTisVSC_dd_entry_justified_clause(t1) || TTisVSC_dd_entry_occurs_clause(t1) || TTisVSC_dd_entry_sign_clause(t1) || TTisVSC_dd_entry_synchronized_clause(t1) || TTisVSC_dd_entry_usage_clause(t1) || TTisVSC_dd_entry_renames_clause(t1) || TTisVSC_dd_entry_condition_value_clause(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_dd_entry_data_description_entry_clause, args);
}

TTterm
TTbuildVSC_dd_entry_data_description_entry_clauses(TTterm t1)
{
    assert(TTisVSC_dd_entry_data_description_entry_clause_star(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_dd_entry_data_description_entry_clauses, args);
}

TTterm
TTbuildVSC_dd_entry_external_clause(TTterm t1, TTterm t2)
{
    assert(TTist_IS_opt(t1) && TTist_EXTERNAL(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_dd_entry_external_clause, args);
}

TTterm
TTbuildVSC_dd_entry_global_clause(TTterm t1, TTterm t2)
{
    assert(TTist_IS_opt(t1) && TTist_GLOBAL(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_dd_entry_global_clause, args);
}

TTterm
TTbuildVSC_dd_entry_indexed_by(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_INDEXED(t1) && TTist_BY_opt(t2) && TTisVSC_expr_index_name_plus(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_dd_entry_indexed_by, args);
}

TTterm
TTbuildVSC_dd_entry_integer_to(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_integer(t1) && TTist_TO(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_dd_entry_integer_to, args);
}

TTterm
TTbuildVSC_dd_entry_justified(TTterm t1)
{
    assert(TTist_JUSTIFIED(t1) || TTist_JUST(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_dd_entry_justified, args);
}

TTterm
TTbuildVSC_dd_entry_justified_clause(TTterm t1, TTterm t2)
{
    assert(TTisVSC_dd_entry_justified(t1) && TTist_RIGHT_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_dd_entry_justified_clause, args);
}

TTterm
TTbuildVSC_dd_entry_occurs_clause(TTterm t1)
{
    assert(TTisVSC_dd_entry_occurs_clause_2(t1) || TTisVSC_dd_entry_occurs_clause_1(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_dd_entry_occurs_clause, args);
}

TTterm
TTbuildVSC_dd_entry_occurs_clause_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_OCCURS(t1) && TTisVSC_expr_integer(t2) && TTist_TIMES_opt(t3) && TTisVSC_dd_entry_occurs_clause_key_star(t4) && TTisVSC_dd_entry_indexed_by_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_dd_entry_occurs_clause_1, args);
}

TTterm
TTbuildVSC_dd_entry_occurs_clause_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9)
{
    assert(TTist_OCCURS(t1) && TTisVSC_dd_entry_integer_to_opt(t2) && TTisVSC_expr_integer(t3) && TTist_TIMES_opt(t4) && TTist_DEPENDING(t5) && TTist_ON_opt(t6) && TTisVSC_expr_qualified_data_name(t7) && TTisVSC_dd_entry_occurs_clause_key_star(t8) && TTisVSC_dd_entry_indexed_by_opt(t9));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    return TTbuild_term(TTfunVSC_dd_entry_occurs_clause_2, args);
}

TTterm
TTbuildVSC_dd_entry_occurs_clause_key(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_expr_alt_ascending_descending(t1) && TTist_KEY_opt(t2) && TTist_IS_opt(t3) && TTisVSC_expr_qualified_data_name_plus(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_dd_entry_occurs_clause_key, args);
}

TTterm
TTbuildVSC_dd_entry_picture(TTterm t1)
{
    assert(TTist_PICTURE(t1) || TTist_PIC(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_dd_entry_picture, args);
}

TTterm
TTbuildVSC_dd_entry_picture_clause(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_dd_entry_picture(t1) && TTist_IS_opt(t2) && TTisVSC_lex_picture_string(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_dd_entry_picture_clause, args);
}

TTterm
TTbuildVSC_dd_entry_redefines_clause(TTterm t1, TTterm t2)
{
    assert(TTist_REDEFINES(t1) && TTisVSC_expr_data_name(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_dd_entry_redefines_clause, args);
}

TTterm
TTbuildVSC_dd_entry_renames_clause(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_RENAMES(t1) && TTisVSC_expr_qualified_data_name(t2) && TTisVSC_expr_through_qualified_data_name_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_dd_entry_renames_clause, args);
}

TTterm
TTbuildVSC_dd_entry_separate_character(TTterm t1, TTterm t2)
{
    assert(TTist_SEPARATE(t1) && TTist_CHARACTER_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_dd_entry_separate_character, args);
}

TTterm
TTbuildVSC_dd_entry_sign_clause(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_dd_entry_sign_is_opt(t1) && TTisVSC_dd_entry_alt_leading_trailing(t2) && TTisVSC_dd_entry_separate_character_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_dd_entry_sign_clause, args);
}

TTterm
TTbuildVSC_dd_entry_sign_is(TTterm t1, TTterm t2)
{
    assert(TTist_SIGN(t1) && TTist_IS_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_dd_entry_sign_is, args);
}

TTterm
TTbuildVSC_dd_entry_synchronized(TTterm t1)
{
    assert(TTist_SYNCHRONIZED(t1) || TTist_SYNC(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_dd_entry_synchronized, args);
}

TTterm
TTbuildVSC_dd_entry_synchronized_clause(TTterm t1, TTterm t2)
{
    assert(TTisVSC_dd_entry_synchronized(t1) && TTisVSC_dd_entry_alt_left_right_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_dd_entry_synchronized_clause, args);
}

TTterm
TTbuildVSC_dd_entry_usage(TTterm t1)
{
    assert(TTist_BINARY(t1) || TTist_COMP(t1) || TTist_COMP_1(t1) || TTist_COMP_2(t1) || TTist_COMP_3(t1) || TTist_COMP_4(t1) || TTist_COMPUTATIONAL(t1) || TTist_COMPUTATIONAL_1(t1) || TTist_COMPUTATIONAL_2(t1) || TTist_COMPUTATIONAL_3(t1) || TTist_COMPUTATIONAL_4(t1) || TTist_DISPLAY(t1) || TTist_DISPLAY_1(t1) || TTist_INDEX(t1) || TTist_PACKED_DECIMAL(t1) || TTist_POINTER(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_dd_entry_usage, args);
}

TTterm
TTbuildVSC_dd_entry_usage_clause(TTterm t1, TTterm t2)
{
    assert(TTisVSC_dd_entry_usage_is_opt(t1) && TTisVSC_dd_entry_usage(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_dd_entry_usage_clause, args);
}

TTterm
TTbuildVSC_dd_entry_usage_is(TTterm t1, TTterm t2)
{
    assert(TTist_USAGE(t1) && TTist_IS_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_dd_entry_usage_is, args);
}

TTterm
TTbuildVSC_dd_entry_values_are(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_values(t1) && TTisVSC_conf_sec_are_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_dd_entry_values_are, args);
}

TTterm
TTbuildVSC_dd_entry_zeroes(TTterm t1)
{
    assert(TTist_ZERO(t1) || TTist_ZEROS(t1) || TTist_ZEROES(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_dd_entry_zeroes, args);
}

TTterm
TTbuildVSC_env_div_environment_division(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_ENVIRONMENT(t1) && TTist_DIVISION(t2) && TTist_qdot(t3) && TTisVSC_env_div_environment_division_content(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_env_div_environment_division, args);
}

TTterm
TTbuildVSC_env_div_environment_division_content(TTterm t1, TTterm t2)
{
    assert(TTisVSC_conf_sec_configuration_section_opt(t1) && TTisVSC_io_sec_input_output_section_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_env_div_environment_division_content, args);
}

TTterm
TTbuildVSC_expr_alphabet_name(TTterm t1)
{
    assert(TTisVSC_expr_alphabetic_user_defined_word(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_alphabet_name, args);
}

TTterm
TTbuildVSC_expr_alphabetic_user_defined_word(TTterm t1)
{
    assert(TTisVSC_lex_cobword(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_alphabetic_user_defined_word, args);
}

TTterm
TTbuildVSC_expr_alt_ascending_descending(TTterm t1)
{
    assert(TTist_ASCENDING(t1) || TTist_DESCENDING(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_alt_ascending_descending, args);
}

TTterm
TTbuildVSC_expr_alt_library_name_literal(TTterm t1)
{
    assert(TTisVSC_expr_library_name(t1) || TTisVSC_expr_literal(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_alt_library_name_literal, args);
}

TTterm
TTbuildVSC_expr_alt_plus_minus(TTterm t1)
{
    assert(TTist_qplus(t1) || TTist__(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_alt_plus_minus, args);
}

TTterm
TTbuildVSC_expr_alt_reel_unit(TTterm t1)
{
    assert(TTist_REEL(t1) || TTist_UNIT(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_alt_reel_unit, args);
}

TTterm
TTbuildVSC_expr_alt_text_name_literal(TTterm t1)
{
    assert(TTisVSC_expr_text_name(t1) || TTisVSC_expr_literal(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_alt_text_name_literal, args);
}

TTterm
TTbuildVSC_expr_alt_times_div(TTterm t1)
{
    assert(TTist_qmultiply(t1) || TTist_qdivide(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_alt_times_div, args);
}

TTterm
TTbuildVSC_expr_arithmetic_expression(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_times_div(t1) && TTisVSC_expr_arithmetic_expression_tail_star(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_arithmetic_expression, args);
}

TTterm
TTbuildVSC_expr_arithmetic_expression_tail(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_alt_plus_minus(t1) && TTisVSC_expr_times_div(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_arithmetic_expression_tail, args);
}

TTterm
TTbuildVSC_expr_assignment_name(TTterm t1)
{
    assert(TTisVSC_expr_system_name(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_assignment_name, args);
}

TTterm
TTbuildVSC_expr_basis(TTterm t1)
{
    assert(TTisVSC_expr_literal(t1) || TTisVSC_expr_identifier(t1) || TTisVSC_expr_basis_1(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_basis, args);
}

TTterm
TTbuildVSC_expr_basis_1(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_qpopen(t1) && TTisVSC_expr_arithmetic_expression(t2) && TTist_qpclose(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_expr_basis_1, args);
}

TTterm
TTbuildVSC_expr_class_name(TTterm t1)
{
    assert(TTisVSC_expr_alphabetic_user_defined_word(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_class_name, args);
}

TTterm
TTbuildVSC_expr_computer_name(TTterm t1)
{
    assert(TTisVSC_expr_system_name(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_computer_name, args);
}

TTterm
TTbuildVSC_expr_condition_name(TTterm t1)
{
    assert(TTisVSC_expr_alphabetic_user_defined_word(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_condition_name, args);
}

TTterm
TTbuildVSC_expr_copy_operand(TTterm t1)
{
    assert(TTisVSC_lex_quoted_pseudo_text(t1) || TTisVSC_expr_identifier(t1) || TTisVSC_expr_literal(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_copy_operand, args);
}

TTterm
TTbuildVSC_expr_copy_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6)
{
    assert(TTist_COPY(t1) && TTisVSC_expr_alt_text_name_literal(t2) && TTisVSC_expr_in_library_opt(t3) && TTist_SUPPRESS_opt(t4) && TTisVSC_expr_copy_statement_replacing_phrase_opt(t5) && TTist_qdot(t6));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    return TTbuild_term(TTfunVSC_expr_copy_statement, args);
}

TTterm
TTbuildVSC_expr_copy_statement_by_phrase(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_copy_operand(t1) && TTist_BY(t2) && TTisVSC_expr_copy_operand(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_expr_copy_statement_by_phrase, args);
}

TTterm
TTbuildVSC_expr_copy_statement_replacing_phrase(TTterm t1, TTterm t2)
{
    assert(TTist_REPLACING(t1) && TTisVSC_expr_copy_statement_by_phrase_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_copy_statement_replacing_phrase, args);
}

TTterm
TTbuildVSC_expr_data_name(TTterm t1)
{
    assert(TTisVSC_expr_alphabetic_user_defined_word(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_data_name, args);
}

TTterm
TTbuildVSC_expr_data_or_file_name(TTterm t1)
{
    assert(TTisVSC_expr_alphabetic_user_defined_word(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_data_or_file_name, args);
}

TTterm
TTbuildVSC_expr_data_or_file_or_mnemonic_name(TTterm t1)
{
    assert(TTisVSC_expr_alphabetic_user_defined_word(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_data_or_file_or_mnemonic_name, args);
}

TTterm
TTbuildVSC_expr_environment_name(TTterm t1)
{
    assert(TTisVSC_expr_system_name(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_environment_name, args);
}

TTterm
TTbuildVSC_expr_equal_to(TTterm t1)
{
    assert(TTisVSC_expr_equal_to_1(t1) || TTist_qequal(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_equal_to, args);
}

TTterm
TTbuildVSC_expr_equal_to_1(TTterm t1, TTterm t2)
{
    assert(TTist_EQUAL(t1) && TTist_TO_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_equal_to_1, args);
}

TTterm
TTbuildVSC_expr_figurative_constant(TTterm t1)
{
    assert(TTisVSC_expr_figurative_constant_simple(t1) || TTisVSC_expr_figurative_constant_all(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_figurative_constant, args);
}

TTterm
TTbuildVSC_expr_figurative_constant_all(TTterm t1, TTterm t2)
{
    assert(TTist_ALL(t1) && TTisVSC_expr_literal(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_figurative_constant_all, args);
}

TTterm
TTbuildVSC_expr_figurative_constant_simple(TTterm t1)
{
    assert(TTist_ZERO(t1) || TTist_ZEROS(t1) || TTist_ZEROES(t1) || TTist_SPACE(t1) || TTist_SPACES(t1) || TTist_HIGH_VALUE(t1) || TTist_HIGH_VALUES(t1) || TTist_LOW_VALUE(t1) || TTist_LOW_VALUES(t1) || TTist_QUOTE(t1) || TTist_QUOTES(t1) || TTist_NULL(t1) || TTist_NULLS(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_figurative_constant_simple, args);
}

TTterm
TTbuildVSC_expr_file_name(TTterm t1)
{
    assert(TTisVSC_expr_alphabetic_user_defined_word(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_file_name, args);
}

TTterm
TTbuildVSC_expr_identifier(TTterm t1)
{
    assert(TTisVSC_expr_identifier_1(t1) || TTisVSC_expr_identifier_2(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_identifier, args);
}

TTterm
TTbuildVSC_expr_identifier_1(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_qualified_data_name(t1) && TTisVSC_expr_subscript_parentheses_star(t2) && TTisVSC_expr_reference_modification_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_expr_identifier_1, args);
}

TTterm
TTbuildVSC_expr_identifier_2(TTterm t1, TTterm t2)
{
    assert(TTist_LINAGE_COUNTER(t1) && TTisVSC_expr_in_file_name_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_identifier_2, args);
}

TTterm
TTbuildVSC_expr_in(TTterm t1)
{
    assert(TTist_OF(t1) || TTist_IN(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_in, args);
}

TTterm
TTbuildVSC_expr_in_data_or_file_name(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_in(t1) && TTisVSC_expr_data_or_file_name(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_in_data_or_file_name, args);
}

TTterm
TTbuildVSC_expr_in_data_or_file_or_mnemonic_name(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_in(t1) && TTisVSC_expr_data_or_file_or_mnemonic_name(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_in_data_or_file_or_mnemonic_name, args);
}

TTterm
TTbuildVSC_expr_in_file_name(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_in(t1) && TTisVSC_expr_file_name(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_in_file_name, args);
}

TTterm
TTbuildVSC_expr_in_library(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_in(t1) && TTisVSC_expr_alt_library_name_literal(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_in_library, args);
}

TTterm
TTbuildVSC_expr_in_section_name(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_in(t1) && TTisVSC_expr_section_name(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_in_section_name, args);
}

TTterm
TTbuildVSC_expr_index_name(TTterm t1)
{
    assert(TTisVSC_expr_alphabetic_user_defined_word(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_index_name, args);
}

TTterm
TTbuildVSC_expr_integer(TTterm t1)
{
    assert(TTisVSC_lex_num(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_integer, args);
}

TTterm
TTbuildVSC_expr_leftmost_character_position(TTterm t1)
{
    assert(TTisVSC_expr_arithmetic_expression(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_leftmost_character_position, args);
}

TTterm
TTbuildVSC_expr_length(TTterm t1)
{
    assert(TTisVSC_expr_arithmetic_expression(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_length, args);
}

TTterm
TTbuildVSC_expr_level_number(TTterm t1)
{
    assert(TTisVSC_lex_num(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_level_number, args);
}

TTterm
TTbuildVSC_expr_library_name(TTterm t1)
{
    assert(TTisVSC_expr_user_defined_word(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_library_name, args);
}

TTterm
TTbuildVSC_expr_literal(TTterm t1)
{
    assert(TTisVSC_lex_nonnumeric(t1) || TTisVSC_expr_numeric(t1) || TTisVSC_expr_figurative_constant(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_literal, args);
}

TTterm
TTbuildVSC_expr_literal_through_literal(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_literal(t1) && TTisVSC_expr_through_literal_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_literal_through_literal, args);
}

TTterm
TTbuildVSC_expr_mnemonic_name(TTterm t1)
{
    assert(TTisVSC_expr_alphabetic_user_defined_word(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_mnemonic_name, args);
}

TTterm
TTbuildVSC_expr_numeric(TTterm t1)
{
    assert(TTisVSC_lex_num(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_numeric, args);
}

TTterm
TTbuildVSC_expr_paragraph_name(TTterm t1)
{
    assert(TTisVSC_expr_user_defined_word(t1) || TTisVSC_expr_integer(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_paragraph_name, args);
}

TTterm
TTbuildVSC_expr_paragraph_or_section_name(TTterm t1)
{
    assert(TTisVSC_expr_user_defined_word(t1) || TTisVSC_expr_integer(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_paragraph_or_section_name, args);
}

TTterm
TTbuildVSC_expr_plus_minus_integer(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_alt_plus_minus(t1) && TTisVSC_expr_integer(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_plus_minus_integer, args);
}

TTterm
TTbuildVSC_expr_power(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_alt_plus_minus_opt(t1) && TTisVSC_expr_basis(t2) && TTisVSC_expr_power_tail_star(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_expr_power, args);
}

TTterm
TTbuildVSC_expr_power_tail(TTterm t1, TTterm t2)
{
    assert(TTist_qmultiply_qmultiply(t1) && TTisVSC_expr_basis(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_power_tail, args);
}

TTterm
TTbuildVSC_expr_priority_number(TTterm t1)
{
    assert(TTisVSC_lex_num(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_priority_number, args);
}

TTterm
TTbuildVSC_expr_procedure_name(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_paragraph_or_section_name(t1) && TTisVSC_expr_in_section_name_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_procedure_name, args);
}

TTterm
TTbuildVSC_expr_program_name(TTterm t1)
{
    assert(TTisVSC_expr_user_defined_word(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_program_name, args);
}

TTterm
TTbuildVSC_expr_qualified_data_name(TTterm t1)
{
    assert(TTisVSC_expr_qualified_data_name_1(t1) || TTisVSC_expr_special_register_1(t1) || TTisVSC_expr_special_register_2(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_qualified_data_name, args);
}

TTterm
TTbuildVSC_expr_qualified_data_name_1(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_data_name(t1) && TTisVSC_expr_in_data_or_file_name_star(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_qualified_data_name_1, args);
}

TTterm
TTbuildVSC_expr_record_name(TTterm t1)
{
    assert(TTisVSC_expr_qualified_data_name(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_record_name, args);
}

TTterm
TTbuildVSC_expr_records(TTterm t1)
{
    assert(TTist_RECORD(t1) || TTist_RECORDS(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_records, args);
}

TTterm
TTbuildVSC_expr_reference_modification(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_qpopen(t1) && TTisVSC_expr_leftmost_character_position(t2) && TTist_qcolon(t3) && TTisVSC_expr_length_opt(t4) && TTist_qpclose(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_expr_reference_modification, args);
}

TTterm
TTbuildVSC_expr_section_name(TTterm t1)
{
    assert(TTisVSC_expr_user_defined_word(t1) || TTisVSC_expr_integer(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_section_name, args);
}

TTterm
TTbuildVSC_expr_special_register_1(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_ADDRESS(t1) && TTist_OF(t2) && TTisVSC_expr_data_name(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_expr_special_register_1, args);
}

TTterm
TTbuildVSC_expr_special_register_2(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_LENGTH(t1) && TTist_OF(t2) && TTisVSC_expr_identifier(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_expr_special_register_2, args);
}

TTterm
TTbuildVSC_expr_subscript(TTterm t1)
{
    assert(TTisVSC_expr_subscript_expression_plus(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_subscript, args);
}

TTterm
TTbuildVSC_expr_subscript_expression(TTterm t1)
{
    assert(TTisVSC_expr_literal(t1) || TTisVSC_expr_subscript_expression_ambiguous(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_subscript_expression, args);
}

TTterm
TTbuildVSC_expr_subscript_expression_ambiguous(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_qualified_data_name(t1) && TTisVSC_expr_plus_minus_integer_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_subscript_expression_ambiguous, args);
}

TTterm
TTbuildVSC_expr_subscript_parentheses(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_qpopen(t1) && TTisVSC_expr_subscript(t2) && TTist_qpclose(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_expr_subscript_parentheses, args);
}

TTterm
TTbuildVSC_expr_symbolic_character(TTterm t1)
{
    assert(TTisVSC_expr_alphabetic_user_defined_word(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_symbolic_character, args);
}

TTterm
TTbuildVSC_expr_system_name(TTterm t1)
{
    assert(TTisVSC_lex_cobword(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_system_name, args);
}

TTterm
TTbuildVSC_expr_text_name(TTterm t1)
{
    assert(TTisVSC_expr_user_defined_word(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_text_name, args);
}

TTterm
TTbuildVSC_expr_through(TTterm t1)
{
    assert(TTist_THROUGH(t1) || TTist_THRU(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_through, args);
}

TTterm
TTbuildVSC_expr_through_arithmetic_expression(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_through(t1) && TTisVSC_expr_arithmetic_expression(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_through_arithmetic_expression, args);
}

TTterm
TTbuildVSC_expr_through_literal(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_through(t1) && TTisVSC_expr_literal(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_through_literal, args);
}

TTterm
TTbuildVSC_expr_through_qualified_data_name(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_through(t1) && TTisVSC_expr_qualified_data_name(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_through_qualified_data_name, args);
}

TTterm
TTbuildVSC_expr_times_div(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_power(t1) && TTisVSC_expr_times_div_tail_star(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_times_div, args);
}

TTterm
TTbuildVSC_expr_times_div_tail(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_alt_times_div(t1) && TTisVSC_expr_power(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_times_div_tail, args);
}

TTterm
TTbuildVSC_expr_user_defined_word(TTterm t1)
{
    assert(TTisVSC_lex_cobword(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_user_defined_word, args);
}

TTterm
TTbuildVSC_expr_values(TTterm t1)
{
    assert(TTist_VALUE(t1) || TTist_VALUES(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_values, args);
}

TTterm
TTbuildVSC_fd_entry_alt_characters_records(TTterm t1)
{
    assert(TTist_CHARACTERS(t1) || TTist_RECORDS(t1) || TTist_RECORD(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_fd_entry_alt_characters_records, args);
}

TTterm
TTbuildVSC_fd_entry_alt_data_name_integer(TTterm t1)
{
    assert(TTisVSC_expr_data_name(t1) || TTisVSC_expr_integer(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_fd_entry_alt_data_name_integer, args);
}

TTterm
TTbuildVSC_fd_entry_alt_fd_sd(TTterm t1)
{
    assert(TTist_FD(t1) || TTist_SD(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_fd_entry_alt_fd_sd, args);
}

TTterm
TTbuildVSC_fd_entry_alt_qualified_data_name_literal(TTterm t1)
{
    assert(TTisVSC_expr_qualified_data_name(t1) || TTisVSC_expr_literal(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_fd_entry_alt_qualified_data_name_literal, args);
}

TTterm
TTbuildVSC_fd_entry_block_contains_clause(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_BLOCK(t1) && TTist_CONTAINS_opt(t2) && TTisVSC_dd_entry_integer_to_opt(t3) && TTisVSC_expr_integer(t4) && TTisVSC_fd_entry_alt_characters_records_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_fd_entry_block_contains_clause, args);
}

TTterm
TTbuildVSC_fd_entry_code_set_clause(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_CODE_SET(t1) && TTist_IS_opt(t2) && TTisVSC_expr_alphabet_name(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_fd_entry_code_set_clause, args);
}

TTterm
TTbuildVSC_fd_entry_data_names(TTterm t1)
{
    assert(TTisVSC_expr_data_name_plus(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_fd_entry_data_names, args);
}

TTterm
TTbuildVSC_fd_entry_data_records_clause(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_DATA(t1) && TTisVSC_fd_entry_records_are(t2) && TTisVSC_expr_data_name_plus(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_fd_entry_data_records_clause, args);
}

TTterm
TTbuildVSC_fd_entry_depending_on(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_DEPENDING(t1) && TTist_ON_opt(t2) && TTisVSC_expr_data_name(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_fd_entry_depending_on, args);
}

TTterm
TTbuildVSC_fd_entry_file_and_sort_description_entry(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_fd_entry_alt_fd_sd(t1) && TTisVSC_expr_file_name(t2) && TTisVSC_fd_entry_file_and_sort_description_entry_clauses(t3) && TTist_qdot(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_fd_entry_file_and_sort_description_entry, args);
}

TTterm
TTbuildVSC_fd_entry_file_and_sort_description_entry_clause(TTterm t1)
{
    assert(TTisVSC_dd_entry_external_clause(t1) || TTisVSC_dd_entry_global_clause(t1) || TTisVSC_fd_entry_block_contains_clause(t1) || TTisVSC_fd_entry_record_clause(t1) || TTisVSC_fd_entry_label_records_clause(t1) || TTisVSC_fd_entry_value_of_clause(t1) || TTisVSC_fd_entry_data_records_clause(t1) || TTisVSC_fd_entry_linage_clause(t1) || TTisVSC_fd_entry_recording_mode_clause(t1) || TTisVSC_fd_entry_code_set_clause(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_fd_entry_file_and_sort_description_entry_clause, args);
}

TTterm
TTbuildVSC_fd_entry_file_and_sort_description_entry_clauses(TTterm t1)
{
    assert(TTisVSC_fd_entry_file_and_sort_description_entry_clause_star(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_fd_entry_file_and_sort_description_entry_clauses, args);
}

TTterm
TTbuildVSC_fd_entry_footing(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_WITH_opt(t1) && TTist_FOOTING(t2) && TTist_AT_opt(t3) && TTisVSC_fd_entry_alt_data_name_integer(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_fd_entry_footing, args);
}

TTterm
TTbuildVSC_fd_entry_from_integer(TTterm t1, TTterm t2)
{
    assert(TTist_FROM_opt(t1) && TTisVSC_expr_integer(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_fd_entry_from_integer, args);
}

TTterm
TTbuildVSC_fd_entry_label_records_clause(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_LABEL(t1) && TTisVSC_fd_entry_records_are(t2) && TTisVSC_fd_entry_label_records_clause_tail(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_fd_entry_label_records_clause, args);
}

TTterm
TTbuildVSC_fd_entry_label_records_clause_tail(TTterm t1)
{
    assert(TTist_STANDARD(t1) || TTist_OMITTED(t1) || TTisVSC_fd_entry_data_names(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_fd_entry_label_records_clause_tail, args);
}

TTterm
TTbuildVSC_fd_entry_linage_clause(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_LINAGE(t1) && TTist_IS_opt(t2) && TTisVSC_fd_entry_alt_data_name_integer(t3) && TTist_LINES_opt(t4) && TTisVSC_fd_entry_linage_footing_phrase(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_fd_entry_linage_clause, args);
}

TTterm
TTbuildVSC_fd_entry_linage_footing_phrase(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_fd_entry_footing_opt(t1) && TTisVSC_fd_entry_lines_top_opt(t2) && TTisVSC_fd_entry_lines_bottom_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_fd_entry_linage_footing_phrase, args);
}

TTterm
TTbuildVSC_fd_entry_lines_bottom(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_LINES_opt(t1) && TTist_AT_opt(t2) && TTist_BOTTOM(t3) && TTisVSC_fd_entry_alt_data_name_integer(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_fd_entry_lines_bottom, args);
}

TTterm
TTbuildVSC_fd_entry_lines_top(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_LINES_opt(t1) && TTist_AT_opt(t2) && TTist_TOP(t3) && TTisVSC_fd_entry_alt_data_name_integer(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_fd_entry_lines_top, args);
}

TTterm
TTbuildVSC_fd_entry_record_clause(TTterm t1, TTterm t2)
{
    assert(TTist_RECORD(t1) && TTisVSC_fd_entry_record_clause_tail(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_fd_entry_record_clause, args);
}

TTterm
TTbuildVSC_fd_entry_record_clause_tail(TTterm t1)
{
    assert(TTisVSC_fd_entry_record_clause_tail_2(t1) || TTisVSC_fd_entry_record_clause_tail_1(t1) || TTisVSC_fd_entry_record_clause_tail_3(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_fd_entry_record_clause_tail, args);
}

TTterm
TTbuildVSC_fd_entry_record_clause_tail_1(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_CONTAINS_opt(t1) && TTisVSC_expr_integer(t2) && TTist_CHARACTERS_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_fd_entry_record_clause_tail_1, args);
}

TTterm
TTbuildVSC_fd_entry_record_clause_tail_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_CONTAINS_opt(t1) && TTisVSC_expr_integer(t2) && TTist_TO(t3) && TTisVSC_expr_integer(t4) && TTist_CHARACTERS_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_fd_entry_record_clause_tail_2, args);
}

TTterm
TTbuildVSC_fd_entry_record_clause_tail_3(TTterm t1, TTterm t2)
{
    assert(TTisVSC_fd_entry_record_varying_phrase(t1) && TTisVSC_fd_entry_depending_on_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_fd_entry_record_clause_tail_3, args);
}

TTterm
TTbuildVSC_fd_entry_record_varying_phrase(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7)
{
    assert(TTist_IS_opt(t1) && TTist_VARYING(t2) && TTist_IN_opt(t3) && TTist_SIZE_opt(t4) && TTisVSC_fd_entry_from_integer_opt(t5) && TTisVSC_fd_entry_to_integer_opt(t6) && TTist_CHARACTERS_opt(t7));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    return TTbuild_term(TTfunVSC_fd_entry_record_varying_phrase, args);
}

TTterm
TTbuildVSC_fd_entry_recording_mode_clause(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_RECORDING(t1) && TTist_MODE_opt(t2) && TTist_IS_opt(t3) && TTisVSC_lex_cobword(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_fd_entry_recording_mode_clause, args);
}

TTterm
TTbuildVSC_fd_entry_records_are(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_records(t1) && TTisVSC_conf_sec_are_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_fd_entry_records_are, args);
}

TTterm
TTbuildVSC_fd_entry_to_integer(TTterm t1, TTterm t2)
{
    assert(TTist_TO(t1) && TTisVSC_expr_integer(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_fd_entry_to_integer, args);
}

TTterm
TTbuildVSC_fd_entry_value_of_clause(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_VALUE(t1) && TTist_OF(t2) && TTisVSC_fd_entry_value_of_clause_tail_plus(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_fd_entry_value_of_clause, args);
}

TTterm
TTbuildVSC_fd_entry_value_of_clause_tail(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_system_name(t1) && TTist_IS_opt(t2) && TTisVSC_fd_entry_alt_qualified_data_name_literal(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_fd_entry_value_of_clause_tail, args);
}

TTterm
TTbuildVSC_id_div_author(TTterm t1, TTterm t2)
{
    assert(TTist_AUTHOR(t1) && TTist_qdot_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_id_div_author, args);
}

TTterm
TTbuildVSC_id_div_date_compiled(TTterm t1, TTterm t2)
{
    assert(TTist_DATE_COMPILED(t1) && TTist_qdot_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_id_div_date_compiled, args);
}

TTterm
TTbuildVSC_id_div_date_written(TTterm t1, TTterm t2)
{
    assert(TTist_DATE_WRITTEN(t1) && TTist_qdot_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_id_div_date_written, args);
}

TTterm
TTbuildVSC_id_div_identification(TTterm t1)
{
    assert(TTist_IDENTIFICATION(t1) || TTist_ID(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_id_div_identification, args);
}

TTterm
TTbuildVSC_id_div_identification_division(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTisVSC_id_div_identification(t1) && TTist_DIVISION(t2) && TTist_qdot(t3) && TTisVSC_id_div_program_id_cobol_source_program(t4) && TTisVSC_id_div_identification_division_content(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_id_div_identification_division, args);
}

TTterm
TTbuildVSC_id_div_identification_division_content(TTterm t1)
{
    assert(TTisVSC_id_div_identification_division_phrase_star(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_id_div_identification_division_content, args);
}

TTterm
TTbuildVSC_id_div_identification_division_phrase(TTterm t1)
{
    assert(TTisVSC_id_div_author(t1) || TTisVSC_id_div_installation(t1) || TTisVSC_id_div_date_written(t1) || TTisVSC_id_div_date_compiled(t1) || TTisVSC_id_div_security(t1) || TTisVSC_id_div_remarks(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_id_div_identification_division_phrase, args);
}

TTterm
TTbuildVSC_id_div_initial_program(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_IS_opt(t1) && TTist_INITIAL(t2) && TTist_PROGRAM_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_id_div_initial_program, args);
}

TTterm
TTbuildVSC_id_div_installation(TTterm t1, TTterm t2)
{
    assert(TTist_INSTALLATION(t1) && TTist_qdot_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_id_div_installation, args);
}

TTterm
TTbuildVSC_id_div_program_id_cobol_source_program(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_PROGRAM_ID(t1) && TTist_qdot_opt(t2) && TTisVSC_expr_program_name(t3) && TTisVSC_id_div_initial_program_opt(t4) && TTist_qdot_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_id_div_program_id_cobol_source_program, args);
}

TTterm
TTbuildVSC_id_div_remarks(TTterm t1, TTterm t2)
{
    assert(TTist_REMARKS(t1) && TTist_qdot_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_id_div_remarks, args);
}

TTterm
TTbuildVSC_id_div_security(TTterm t1, TTterm t2)
{
    assert(TTist_SECURITY(t1) && TTist_qdot_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_id_div_security, args);
}

TTterm
TTbuildVSC_io_sec_alt_assignment_name_file_name(TTterm t1)
{
    assert(TTisVSC_expr_assignment_name(t1) || TTisVSC_expr_file_name(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_io_sec_alt_assignment_name_file_name, args);
}

TTterm
TTbuildVSC_io_sec_alt_assignment_name_literal(TTterm t1)
{
    assert(TTisVSC_expr_assignment_name(t1) || TTisVSC_expr_literal(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_io_sec_alt_assignment_name_literal, args);
}

TTterm
TTbuildVSC_io_sec_alt_indexed_relative_sequential(TTterm t1)
{
    assert(TTist_INDEXED(t1) || TTist_RELATIVE(t1) || TTist_SEQUENTIAL(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_io_sec_alt_indexed_relative_sequential, args);
}

TTterm
TTbuildVSC_io_sec_alt_sequential_random_dynamic(TTterm t1)
{
    assert(TTist_SEQUENTIAL(t1) || TTist_RANDOM(t1) || TTist_DYNAMIC(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_io_sec_alt_sequential_random_dynamic, args);
}

TTterm
TTbuildVSC_io_sec_alternate_record_key_clause(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7)
{
    assert(TTist_ALTERNATE(t1) && TTist_RECORD_opt(t2) && TTist_KEY_opt(t3) && TTist_IS_opt(t4) && TTisVSC_expr_qualified_data_name(t5) && TTisVSC_io_sec_password_clause_opt(t6) && TTisVSC_io_sec_with_duplicates_opt(t7));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    return TTbuild_term(TTfunVSC_io_sec_alternate_record_key_clause, args);
}

TTterm
TTbuildVSC_io_sec_areas(TTterm t1)
{
    assert(TTist_AREA(t1) || TTist_AREAS(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_io_sec_areas, args);
}

TTterm
TTbuildVSC_io_sec_assign_clause(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_ASSIGN(t1) && TTist_TO_opt(t2) && TTisVSC_io_sec_alt_assignment_name_literal_plus(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_io_sec_assign_clause, args);
}

TTterm
TTbuildVSC_io_sec_every_phrase(TTterm t1)
{
    assert(TTisVSC_io_sec_every_phrase_1(t1) || TTisVSC_io_sec_every_phrase_2(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_io_sec_every_phrase, args);
}

TTterm
TTbuildVSC_io_sec_every_phrase_1(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_integer(t1) && TTist_RECORDS(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_io_sec_every_phrase_1, args);
}

TTterm
TTbuildVSC_io_sec_every_phrase_2(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_END(t1) && TTist_OF_opt(t2) && TTisVSC_expr_alt_reel_unit(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_io_sec_every_phrase_2, args);
}

TTterm
TTbuildVSC_io_sec_fce_access_mode(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_ACCESS(t1) && TTist_MODE_opt(t2) && TTist_IS_opt(t3) && TTisVSC_io_sec_alt_sequential_random_dynamic(t4) && TTisVSC_io_sec_relative_key_clause_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_io_sec_fce_access_mode, args);
}

TTterm
TTbuildVSC_io_sec_fce_organization(TTterm t1, TTterm t2)
{
    assert(TTisVSC_io_sec_organization_is_opt(t1) && TTisVSC_io_sec_alt_indexed_relative_sequential(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_io_sec_fce_organization, args);
}

TTterm
TTbuildVSC_io_sec_fce_phrase(TTterm t1)
{
    assert(TTisVSC_io_sec_reserve_clause(t1) || TTisVSC_io_sec_fce_organization(t1) || TTisVSC_io_sec_fce_access_mode(t1) || TTisVSC_io_sec_record_key_clause(t1) || TTisVSC_io_sec_password_clause(t1) || TTisVSC_io_sec_alternate_record_key_clause(t1) || TTisVSC_io_sec_file_status_clause(t1) || TTisVSC_io_sec_padding_character_clause(t1) || TTisVSC_io_sec_record_delimiter_clause(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_io_sec_fce_phrase, args);
}

TTterm
TTbuildVSC_io_sec_file_control_entry(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_io_sec_select_clause(t1) && TTisVSC_io_sec_assign_clause(t2) && TTisVSC_io_sec_fce_phrase_star(t3) && TTist_qdot(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_io_sec_file_control_entry, args);
}

TTterm
TTbuildVSC_io_sec_file_control_paragraph(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_FILE_CONTROL(t1) && TTist_qdot(t2) && TTisVSC_io_sec_file_control_entry_star(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_io_sec_file_control_paragraph, args);
}

TTterm
TTbuildVSC_io_sec_file_name_position(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_file_name(t1) && TTisVSC_io_sec_position_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_io_sec_file_name_position, args);
}

TTterm
TTbuildVSC_io_sec_file_status_clause(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_FILE_opt(t1) && TTist_STATUS(t2) && TTist_IS_opt(t3) && TTisVSC_expr_qualified_data_name(t4) && TTisVSC_expr_qualified_data_name_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_io_sec_file_status_clause, args);
}

TTterm
TTbuildVSC_io_sec_i_o_control_paragraph(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_I_O_CONTROL(t1) && TTist_qdot(t2) && TTisVSC_io_sec_i_o_sam_opt(t3) && TTisVSC_io_sec_i_o_sort_merge_opt(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_io_sec_i_o_control_paragraph, args);
}

TTterm
TTbuildVSC_io_sec_i_o_sam(TTterm t1, TTterm t2)
{
    assert(TTisVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_plus(t1) && TTist_qdot(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_io_sec_i_o_sam, args);
}

TTterm
TTbuildVSC_io_sec_i_o_sort_merge(TTterm t1, TTterm t2)
{
    assert(TTisVSC_io_sec_sort_merge_i_o_control_entries(t1) && TTist_qdot(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_io_sec_i_o_sort_merge, args);
}

TTterm
TTbuildVSC_io_sec_input_output_section(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_INPUT_OUTPUT(t1) && TTist_SECTION(t2) && TTist_qdot(t3) && TTisVSC_io_sec_file_control_paragraph_opt(t4) && TTisVSC_io_sec_i_o_control_paragraph_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_io_sec_input_output_section, args);
}

TTterm
TTbuildVSC_io_sec_organization_is(TTterm t1, TTterm t2)
{
    assert(TTist_ORGANIZATION(t1) && TTist_IS_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_io_sec_organization_is, args);
}

TTterm
TTbuildVSC_io_sec_padding_character_clause(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_PADDING(t1) && TTist_CHARACTER_opt(t2) && TTist_IS_opt(t3) && TTisVSC_fd_entry_alt_qualified_data_name_literal(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_io_sec_padding_character_clause, args);
}

TTterm
TTbuildVSC_io_sec_password_clause(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_PASSWORD(t1) && TTist_IS_opt(t2) && TTisVSC_expr_data_name(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_io_sec_password_clause, args);
}

TTterm
TTbuildVSC_io_sec_position(TTterm t1, TTterm t2)
{
    assert(TTist_POSITION(t1) && TTisVSC_expr_integer(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_io_sec_position, args);
}

TTterm
TTbuildVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries(TTterm t1)
{
    assert(TTisVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_1(t1) || TTisVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_2(t1) || TTisVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_3(t1) || TTisVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_4(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries, args);
}

TTterm
TTbuildVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7)
{
    assert(TTist_RERUN(t1) && TTist_ON(t2) && TTisVSC_io_sec_alt_assignment_name_file_name(t3) && TTist_EVERY_opt(t4) && TTisVSC_io_sec_every_phrase(t5) && TTist_OF_opt(t6) && TTisVSC_expr_file_name(t7));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    return TTbuild_term(TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_1, args);
}

TTterm
TTbuildVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6)
{
    assert(TTist_SAME(t1) && TTist_RECORD_opt(t2) && TTist_AREA_opt(t3) && TTist_FOR_opt(t4) && TTisVSC_expr_file_name(t5) && TTisVSC_expr_file_name_plus(t6));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    return TTbuild_term(TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_2, args);
}

TTterm
TTbuildVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_3(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_MULTIPLE(t1) && TTist_FILE(t2) && TTist_TAPE_opt(t3) && TTist_CONTAINS_opt(t4) && TTisVSC_io_sec_file_name_position_plus(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_3, args);
}

TTterm
TTbuildVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_4(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_APPLY(t1) && TTist_WRITE_ONLY(t2) && TTist_ON_opt(t3) && TTisVSC_expr_file_name_plus(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_4, args);
}

TTterm
TTbuildVSC_io_sec_record_delimiter_clause(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_RECORD(t1) && TTist_DELIMITER(t2) && TTist_IS_opt(t3) && TTisVSC_io_sec_record_delimiter_name(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_io_sec_record_delimiter_clause, args);
}

TTterm
TTbuildVSC_io_sec_record_delimiter_name(TTterm t1)
{
    assert(TTist_STANDARD_1(t1) || TTisVSC_expr_assignment_name(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_io_sec_record_delimiter_name, args);
}

TTterm
TTbuildVSC_io_sec_record_key_clause(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_RECORD(t1) && TTist_KEY_opt(t2) && TTist_IS_opt(t3) && TTisVSC_expr_qualified_data_name(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_io_sec_record_key_clause, args);
}

TTterm
TTbuildVSC_io_sec_record_sort(TTterm t1)
{
    assert(TTist_RECORD(t1) || TTist_SORT(t1) || TTist_SORT_MERGE(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_io_sec_record_sort, args);
}

TTterm
TTbuildVSC_io_sec_relative_key_clause(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_RELATIVE(t1) && TTist_KEY_opt(t2) && TTist_IS_opt(t3) && TTisVSC_expr_qualified_data_name(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_io_sec_relative_key_clause, args);
}

TTterm
TTbuildVSC_io_sec_rerun_on(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_RERUN(t1) && TTist_ON(t2) && TTisVSC_expr_assignment_name(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_io_sec_rerun_on, args);
}

TTterm
TTbuildVSC_io_sec_reserve_clause(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_RESERVE(t1) && TTisVSC_expr_integer(t2) && TTisVSC_io_sec_areas_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_io_sec_reserve_clause, args);
}

TTterm
TTbuildVSC_io_sec_same_area(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6)
{
    assert(TTist_SAME(t1) && TTisVSC_io_sec_record_sort(t2) && TTist_AREA_opt(t3) && TTist_FOR_opt(t4) && TTisVSC_expr_file_name(t5) && TTisVSC_expr_file_name_plus(t6));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    return TTbuild_term(TTfunVSC_io_sec_same_area, args);
}

TTterm
TTbuildVSC_io_sec_select_clause(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_SELECT(t1) && TTist_OPTIONAL_opt(t2) && TTisVSC_expr_file_name(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_io_sec_select_clause, args);
}

TTterm
TTbuildVSC_io_sec_sort_merge_i_o_control_entries(TTterm t1, TTterm t2)
{
    assert(TTisVSC_io_sec_rerun_on_opt(t1) && TTisVSC_io_sec_same_area_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_io_sec_sort_merge_i_o_control_entries, args);
}

TTterm
TTbuildVSC_io_sec_with_duplicates(TTterm t1, TTterm t2)
{
    assert(TTist_WITH_opt(t1) && TTist_DUPLICATES(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_io_sec_with_duplicates, args);
}

TTterm
TTbuildVSC_main_cobol_source_program(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTisVSC_id_div_identification_division(t1) && TTisVSC_env_div_environment_division_opt(t2) && TTisVSC_data_div_data_division_opt(t3) && TTisVSC_proc_div_procedure_division_opt(t4) && TTisVSC_main_nested_program_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_main_cobol_source_program, args);
}

TTterm
TTbuildVSC_main_common_initial(TTterm t1)
{
    assert(TTisVSC_main_common_initial_1(t1) || TTisVSC_main_common_initial_2(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_main_common_initial, args);
}

TTterm
TTbuildVSC_main_common_initial_1(TTterm t1, TTterm t2)
{
    assert(TTist_COMMON(t1) && TTist_INITIAL_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_main_common_initial_1, args);
}

TTterm
TTbuildVSC_main_common_initial_2(TTterm t1, TTterm t2)
{
    assert(TTist_INITIAL(t1) && TTist_COMMON_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_main_common_initial_2, args);
}

TTterm
TTbuildVSC_main_common_initial_program(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_IS_opt(t1) && TTisVSC_main_common_initial(t2) && TTist_PROGRAM_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_main_common_initial_program, args);
}

TTterm
TTbuildVSC_main_nested_cobol_source_program(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9, TTterm t10, TTterm t11, TTterm t12, TTterm t13)
{
    assert(TTisVSC_id_div_identification(t1) && TTist_DIVISION(t2) && TTist_qdot(t3) && TTisVSC_main_program_id_nested_cobol_source_program(t4) && TTisVSC_id_div_identification_division_content_opt(t5) && TTisVSC_env_div_environment_division_opt(t6) && TTisVSC_data_div_data_division_opt(t7) && TTisVSC_proc_div_procedure_division_opt(t8) && TTisVSC_main_nested_cobol_source_program_star(t9) && TTist_END(t10) && TTist_PROGRAM(t11) && TTisVSC_expr_program_name(t12) && TTist_qdot(t13));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    args[9] = t10;
    args[10] = t11;
    args[11] = t12;
    args[12] = t13;
    return TTbuild_term(TTfunVSC_main_nested_cobol_source_program, args);
}

TTterm
TTbuildVSC_main_nested_program(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTisVSC_main_nested_cobol_source_program_star(t1) && TTist_END(t2) && TTist_PROGRAM(t3) && TTisVSC_expr_program_name(t4) && TTist_qdot(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_main_nested_program, args);
}

TTterm
TTbuildVSC_main_program_id_nested_cobol_source_program(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_PROGRAM_ID(t1) && TTist_qdot_opt(t2) && TTisVSC_expr_program_name(t3) && TTisVSC_main_common_initial_program_opt(t4) && TTist_qdot_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_main_program_id_nested_cobol_source_program, args);
}

TTterm
TTbuildVSC_main_programs(TTterm t1)
{
    assert(TTisVSC_main_cobol_source_program_plus(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_main_programs, args);
}

TTterm
TTbuildVSC_proc_div_altered_goto(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTisVSC_expr_paragraph_name(t1) && TTist_qdot(t2) && TTist_GO(t3) && TTist_TO_opt(t4) && TTist_qdot(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_proc_div_altered_goto, args);
}

TTterm
TTbuildVSC_proc_div_declaratives(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6)
{
    assert(TTist_DECLARATIVES(t1) && TTist_qdot(t2) && TTisVSC_proc_div_declaratives_content_plus(t3) && TTist_END(t4) && TTist_DECLARATIVES(t5) && TTist_qdot(t6));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    return TTbuild_term(TTfunVSC_proc_div_declaratives, args);
}

TTterm
TTbuildVSC_proc_div_declaratives_content(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTisVSC_proc_div_section_header(t1) && TTist_qdot(t2) && TTisVSC_stat_use_statement(t3) && TTist_qdot(t4) && TTisVSC_proc_div_paragraphs(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_proc_div_declaratives_content, args);
}

TTterm
TTbuildVSC_proc_div_paragraph(TTterm t1)
{
    assert(TTisVSC_proc_div_altered_goto(t1) || TTisVSC_proc_div_paragraph_1(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_proc_div_paragraph, args);
}

TTterm
TTbuildVSC_proc_div_paragraph_1(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_paragraph_name(t1) && TTist_qdot(t2) && TTisVSC_proc_div_sentence_star(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_proc_div_paragraph_1, args);
}

TTterm
TTbuildVSC_proc_div_paragraphs(TTterm t1, TTterm t2)
{
    assert(TTisVSC_proc_div_sentence_star(t1) && TTisVSC_proc_div_paragraph_star(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_proc_div_paragraphs, args);
}

TTterm
TTbuildVSC_proc_div_procedure_division(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_PROCEDURE(t1) && TTist_DIVISION(t2) && TTisVSC_proc_div_using_phrase(t3) && TTisVSC_proc_div_declaratives_opt(t4) && TTisVSC_proc_div_sections(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_proc_div_procedure_division, args);
}

TTterm
TTbuildVSC_proc_div_section_header(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_section_name(t1) && TTist_SECTION(t2) && TTisVSC_expr_priority_number_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_proc_div_section_header, args);
}

TTterm
TTbuildVSC_proc_div_section_with_header(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_proc_div_section_header(t1) && TTist_qdot(t2) && TTisVSC_proc_div_paragraphs(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_proc_div_section_with_header, args);
}

TTterm
TTbuildVSC_proc_div_sections(TTterm t1, TTterm t2)
{
    assert(TTisVSC_proc_div_paragraphs(t1) && TTisVSC_proc_div_section_with_header_star(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_proc_div_sections, args);
}

TTterm
TTbuildVSC_proc_div_sentence(TTterm t1)
{
    assert(TTisVSC_proc_div_sentence_1(t1) || TTisVSC_proc_div_sentence_2(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_proc_div_sentence, args);
}

TTterm
TTbuildVSC_proc_div_sentence_1(TTterm t1, TTterm t2)
{
    assert(TTisVSC_stat_statement_list(t1) && TTist_qdot_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_proc_div_sentence_1, args);
}

TTterm
TTbuildVSC_proc_div_sentence_2(TTterm t1, TTterm t2)
{
    assert(TTisVSC_stat_statement_list_opt(t1) && TTisVSC_expr_copy_statement(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_proc_div_sentence_2, args);
}

TTterm
TTbuildVSC_proc_div_using_data_names(TTterm t1, TTterm t2)
{
    assert(TTist_USING(t1) && TTisVSC_expr_data_name_star(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_proc_div_using_data_names, args);
}

TTterm
TTbuildVSC_proc_div_using_phrase(TTterm t1)
{
    assert(TTisVSC_proc_div_using_phrase_1(t1) || TTisVSC_proc_div_using_phrase_2(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_proc_div_using_phrase, args);
}

TTterm
TTbuildVSC_proc_div_using_phrase_1(TTterm t1, TTterm t2)
{
    assert(TTisVSC_stat_using_data_name_pluslist_opt(t1) && TTist_qdot(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_proc_div_using_phrase_1, args);
}

TTterm
TTbuildVSC_proc_div_using_phrase_2(TTterm t1, TTterm t2)
{
    assert(TTisVSC_proc_div_using_data_names_opt(t1) && TTisVSC_expr_copy_statement(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_proc_div_using_phrase_2, args);
}

TTterm
TTbuildVSC_stat_accept_statement(TTterm t1)
{
    assert(TTisVSC_stat_accept_statement_2(t1) || TTisVSC_stat_accept_statement_1(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_accept_statement, args);
}

TTterm
TTbuildVSC_stat_accept_statement_1(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_ACCEPT(t1) && TTisVSC_expr_identifier(t2) && TTisVSC_stat_from_environment_name_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_accept_statement_1, args);
}

TTterm
TTbuildVSC_stat_accept_statement_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_ACCEPT(t1) && TTisVSC_expr_identifier(t2) && TTist_FROM(t3) && TTisVSC_stat_date(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_accept_statement_2, args);
}

TTterm
TTbuildVSC_stat_add_statement(TTterm t1)
{
    assert(TTisVSC_stat_add_statement_2(t1) || TTisVSC_stat_add_statement_1(t1) || TTisVSC_stat_add_statement_3(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_add_statement, args);
}

TTterm
TTbuildVSC_stat_add_statement_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7)
{
    assert(TTist_ADD(t1) && TTisVSC_stat_id_or_lit_plus(t2) && TTist_TO(t3) && TTisVSC_stat_cobword_rounded_plus(t4) && TTisVSC_stat_on_size_error_statement_list_opt(t5) && TTisVSC_stat_not_on_size_error_statement_list_opt(t6) && TTist_END_ADD_opt(t7));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    return TTbuild_term(TTfunVSC_stat_add_statement_1, args);
}

TTterm
TTbuildVSC_stat_add_statement_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8)
{
    assert(TTist_ADD(t1) && TTisVSC_stat_id_or_lit_plus(t2) && TTisVSC_stat_to_id_or_lit_opt(t3) && TTist_GIVING(t4) && TTisVSC_stat_cobword_rounded_plus(t5) && TTisVSC_stat_on_size_error_statement_list_opt(t6) && TTisVSC_stat_not_on_size_error_statement_list_opt(t7) && TTist_END_ADD_opt(t8));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    return TTbuild_term(TTfunVSC_stat_add_statement_2, args);
}

TTterm
TTbuildVSC_stat_add_statement_3(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9)
{
    assert(TTist_ADD(t1) && TTisVSC_stat_corresponding(t2) && TTisVSC_expr_identifier(t3) && TTist_TO(t4) && TTisVSC_expr_identifier(t5) && TTist_ROUNDED_opt(t6) && TTisVSC_stat_on_size_error_statement_list_opt(t7) && TTisVSC_stat_not_on_size_error_statement_list_opt(t8) && TTist_END_ADD_opt(t9));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    return TTbuild_term(TTfunVSC_stat_add_statement_3, args);
}

TTterm
TTbuildVSC_stat_advancing_phrase(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_stat_alt_before_after(t1) && TTist_ADVANCING_opt(t2) && TTisVSC_stat_page_phrase(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_advancing_phrase, args);
}

TTterm
TTbuildVSC_stat_all_procedures(TTterm t1, TTterm t2)
{
    assert(TTist_ALL(t1) && TTist_PROCEDURES(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_all_procedures, args);
}

TTterm
TTbuildVSC_stat_also_phrase(TTterm t1, TTterm t2)
{
    assert(TTist_ALSO(t1) && TTisVSC_stat_evaluate_condition(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_also_phrase, args);
}

TTterm
TTbuildVSC_stat_alt_all_leading(TTterm t1)
{
    assert(TTist_ALL(t1) || TTist_LEADING(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_all_leading, args);
}

TTterm
TTbuildVSC_stat_alt_all_leading_first(TTterm t1)
{
    assert(TTist_ALL(t1) || TTist_LEADING(t1) || TTist_FIRST(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_all_leading_first, args);
}

TTterm
TTbuildVSC_stat_alt_before_after(TTterm t1)
{
    assert(TTist_BEFORE(t1) || TTist_AFTER(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_before_after, args);
}

TTterm
TTbuildVSC_stat_alt_beginning_ending(TTterm t1)
{
    assert(TTist_BEGINNING(t1) || TTist_ENDING(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_beginning_ending, args);
}

TTterm
TTbuildVSC_stat_alt_exception_error(TTterm t1)
{
    assert(TTist_EXCEPTION(t1) || TTist_ERROR(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_exception_error, args);
}

TTterm
TTbuildVSC_stat_alt_file_names_i_o(TTterm t1)
{
    assert(TTisVSC_stat_file_names(t1) || TTist_INPUT(t1) || TTist_OUTPUT(t1) || TTist_I_O(t1) || TTist_EXTEND(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_file_names_i_o, args);
}

TTterm
TTbuildVSC_stat_alt_file_reel_unit(TTterm t1)
{
    assert(TTist_FILE(t1) || TTist_REEL(t1) || TTist_UNIT(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_file_reel_unit, args);
}

TTterm
TTbuildVSC_stat_alt_no_rewind_lock(TTterm t1)
{
    assert(TTisVSC_stat_no_rewind(t1) || TTist_LOCK(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_no_rewind_lock, args);
}

TTterm
TTbuildVSC_stat_alt_procedures_all_procedures(TTterm t1)
{
    assert(TTisVSC_stat_procedure_names(t1) || TTisVSC_stat_all_procedures(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_procedures_all_procedures, args);
}

TTterm
TTbuildVSC_stat_alt_removal_no_rewind(TTterm t1)
{
    assert(TTisVSC_stat_for_removal(t1) || TTisVSC_stat_with_no_rewind(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_removal_no_rewind, args);
}

TTterm
TTbuildVSC_stat_alt_reversed_with_no_rewind(TTterm t1)
{
    assert(TTist_REVERSED(t1) || TTisVSC_stat_with_no_rewind(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_reversed_with_no_rewind, args);
}

TTterm
TTbuildVSC_stat_alt_run_literal(TTterm t1)
{
    assert(TTist_RUN(t1) || TTisVSC_expr_literal(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_run_literal, args);
}

TTterm
TTbuildVSC_stat_alt_statement_list_next_sentence(TTterm t1)
{
    assert(TTisVSC_stat_statement_list(t1) || TTisVSC_stat_next_sentence(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_statement_list_next_sentence, args);
}

TTterm
TTbuildVSC_stat_alt_up_down(TTterm t1)
{
    assert(TTist_UP(t1) || TTist_DOWN(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_up_down, args);
}

TTterm
TTbuildVSC_stat_alt_up_down_by(TTterm t1, TTterm t2)
{
    assert(TTisVSC_stat_alt_up_down(t1) && TTist_BY(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_alt_up_down_by, args);
}

TTterm
TTbuildVSC_stat_alter_statement(TTterm t1, TTterm t2)
{
    assert(TTist_ALTER(t1) && TTisVSC_stat_procedure_to_procedure_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_alter_statement, args);
}

TTterm
TTbuildVSC_stat_at_end_of_page_statement_list(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_AT_opt(t1) && TTisVSC_stat_end_of_page(t2) && TTisVSC_stat_statement_list(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_at_end_of_page_statement_list, args);
}

TTterm
TTbuildVSC_stat_at_end_statement_list(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_AT_opt(t1) && TTist_END(t2) && TTisVSC_stat_statement_list(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_at_end_statement_list, args);
}

TTterm
TTbuildVSC_stat_before_after_phrase(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_stat_alt_before_after(t1) && TTist_INITIAL_opt(t2) && TTisVSC_stat_id_or_lit(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_before_after_phrase, args);
}

TTterm
TTbuildVSC_stat_by_reference(TTterm t1, TTterm t2)
{
    assert(TTist_BY_opt(t1) && TTist_REFERENCE(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_by_reference, args);
}

TTterm
TTbuildVSC_stat_call_rest_phrase(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_stat_on_exception_statement_list_opt(t1) && TTisVSC_stat_not_on_exception_statement_list_opt(t2) && TTisVSC_stat_on_overflow_statement_list_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_call_rest_phrase, args);
}

TTterm
TTbuildVSC_stat_call_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_CALL(t1) && TTisVSC_stat_id_or_lit(t2) && TTisVSC_stat_using_parameters_opt(t3) && TTisVSC_stat_call_rest_phrase(t4) && TTist_END_CALL_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_stat_call_statement, args);
}

TTterm
TTbuildVSC_stat_cancel_statement(TTterm t1, TTterm t2)
{
    assert(TTist_CANCEL(t1) && TTisVSC_stat_id_or_lit_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_cancel_statement, args);
}

TTterm
TTbuildVSC_stat_close_statement(TTterm t1, TTterm t2)
{
    assert(TTist_CLOSE(t1) && TTisVSC_stat_close_statement_file_name_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_close_statement, args);
}

TTterm
TTbuildVSC_stat_close_statement_file_name(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_file_name(t1) && TTisVSC_stat_close_statement_options_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_close_statement_file_name, args);
}

TTterm
TTbuildVSC_stat_close_statement_options(TTterm t1)
{
    assert(TTisVSC_stat_close_statement_options_1(t1) || TTisVSC_stat_close_statement_options_2(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_close_statement_options, args);
}

TTterm
TTbuildVSC_stat_close_statement_options_1(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_alt_reel_unit(t1) && TTisVSC_stat_alt_removal_no_rewind_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_close_statement_options_1, args);
}

TTterm
TTbuildVSC_stat_close_statement_options_2(TTterm t1, TTterm t2)
{
    assert(TTist_WITH_opt(t1) && TTisVSC_stat_alt_no_rewind_lock(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_close_statement_options_2, args);
}

TTterm
TTbuildVSC_stat_cobword_int(TTterm t1)
{
    assert(TTisVSC_expr_identifier(t1) || TTisVSC_expr_integer(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_cobword_int, args);
}

TTterm
TTbuildVSC_stat_cobword_rounded(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_identifier(t1) && TTist_ROUNDED_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_cobword_rounded, args);
}

TTterm
TTbuildVSC_stat_collating_sequence(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_COLLATING_opt(t1) && TTist_SEQUENCE(t2) && TTist_IS_opt(t3) && TTisVSC_expr_alphabet_name(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_collating_sequence, args);
}

TTterm
TTbuildVSC_stat_compute_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7)
{
    assert(TTist_COMPUTE(t1) && TTisVSC_stat_cobword_rounded_plus(t2) && TTisVSC_stat_equal(t3) && TTisVSC_expr_arithmetic_expression(t4) && TTisVSC_stat_on_size_error_statement_list_opt(t5) && TTisVSC_stat_not_on_size_error_statement_list_opt(t6) && TTist_END_COMPUTE_opt(t7));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    return TTbuild_term(TTfunVSC_stat_compute_statement, args);
}

TTterm
TTbuildVSC_stat_content_parameter(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_BY_opt(t1) && TTist_CONTENT(t2) && TTisVSC_stat_content_parameter_value_plus(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_content_parameter, args);
}

TTterm
TTbuildVSC_stat_content_parameter_value(TTterm t1)
{
    assert(TTisVSC_expr_identifier(t1) || TTisVSC_expr_literal(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_content_parameter_value, args);
}

TTterm
TTbuildVSC_stat_continue_statement(TTterm t1)
{
    assert(TTist_CONTINUE(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_continue_statement, args);
}

TTterm
TTbuildVSC_stat_corresponding(TTterm t1)
{
    assert(TTist_CORRESPONDING(t1) || TTist_CORR(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_corresponding, args);
}

TTterm
TTbuildVSC_stat_count_in_identifier(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_COUNT(t1) && TTist_IN_opt(t2) && TTisVSC_expr_identifier(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_count_in_identifier, args);
}

TTterm
TTbuildVSC_stat_date(TTterm t1)
{
    assert(TTist_DATE(t1) || TTist_DAY(t1) || TTist_DAY_OF_WEEK(t1) || TTist_TIME(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_date, args);
}

TTterm
TTbuildVSC_stat_delete_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6)
{
    assert(TTist_DELETE(t1) && TTisVSC_expr_file_name(t2) && TTist_RECORD_opt(t3) && TTisVSC_stat_invalid_key_statement_list_opt(t4) && TTisVSC_stat_not_invalid_key_statement_list_opt(t5) && TTist_END_DELETE_opt(t6));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    return TTbuild_term(TTfunVSC_stat_delete_statement, args);
}

TTterm
TTbuildVSC_stat_delimited_by_all_phrase(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_DELIMITED(t1) && TTist_BY_opt(t2) && TTist_ALL_opt(t3) && TTisVSC_stat_id_or_lit(t4) && TTisVSC_stat_or_all_id_or_lit_star(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_stat_delimited_by_all_phrase, args);
}

TTterm
TTbuildVSC_stat_delimited_by_phrase(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_stat_id_or_lit_plus(t1) && TTist_DELIMITED(t2) && TTist_BY_opt(t3) && TTisVSC_stat_id_or_lit_size(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_delimited_by_phrase, args);
}

TTterm
TTbuildVSC_stat_delimiter_in_identifier(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_DELIMITER(t1) && TTist_IN_opt(t2) && TTisVSC_expr_identifier(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_delimiter_in_identifier, args);
}

TTterm
TTbuildVSC_stat_display_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_DISPLAY(t1) && TTisVSC_stat_id_or_lit_plus(t2) && TTisVSC_stat_upon_environment_name_opt(t3) && TTisVSC_stat_with_no_advancing_opt(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_display_statement, args);
}

TTterm
TTbuildVSC_stat_divide_statement(TTterm t1)
{
    assert(TTisVSC_stat_divide_statement_4(t1) || TTisVSC_stat_divide_statement_5(t1) || TTisVSC_stat_divide_statement_2(t1) || TTisVSC_stat_divide_statement_3(t1) || TTisVSC_stat_divide_statement_1(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_divide_statement, args);
}

TTterm
TTbuildVSC_stat_divide_statement_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7)
{
    assert(TTist_DIVIDE(t1) && TTisVSC_stat_id_or_lit(t2) && TTist_INTO(t3) && TTisVSC_stat_cobword_rounded_plus(t4) && TTisVSC_stat_on_size_error_statement_list_opt(t5) && TTisVSC_stat_not_on_size_error_statement_list_opt(t6) && TTist_END_DIVIDE_opt(t7));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    return TTbuild_term(TTfunVSC_stat_divide_statement_1, args);
}

TTterm
TTbuildVSC_stat_divide_statement_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9)
{
    assert(TTist_DIVIDE(t1) && TTisVSC_stat_id_or_lit(t2) && TTist_INTO(t3) && TTisVSC_stat_id_or_lit(t4) && TTist_GIVING(t5) && TTisVSC_stat_cobword_rounded_plus(t6) && TTisVSC_stat_on_size_error_statement_list_opt(t7) && TTisVSC_stat_not_on_size_error_statement_list_opt(t8) && TTist_END_DIVIDE_opt(t9));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    return TTbuild_term(TTfunVSC_stat_divide_statement_2, args);
}

TTterm
TTbuildVSC_stat_divide_statement_3(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9)
{
    assert(TTist_DIVIDE(t1) && TTisVSC_stat_id_or_lit(t2) && TTist_BY(t3) && TTisVSC_stat_id_or_lit(t4) && TTist_GIVING(t5) && TTisVSC_stat_cobword_rounded_plus(t6) && TTisVSC_stat_on_size_error_statement_list_opt(t7) && TTisVSC_stat_not_on_size_error_statement_list_opt(t8) && TTist_END_DIVIDE_opt(t9));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    return TTbuild_term(TTfunVSC_stat_divide_statement_3, args);
}

TTterm
TTbuildVSC_stat_divide_statement_4(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9, TTterm t10, TTterm t11, TTterm t12)
{
    assert(TTist_DIVIDE(t1) && TTisVSC_stat_id_or_lit(t2) && TTist_INTO(t3) && TTisVSC_stat_id_or_lit(t4) && TTist_GIVING(t5) && TTisVSC_expr_identifier(t6) && TTist_ROUNDED_opt(t7) && TTist_REMAINDER(t8) && TTisVSC_expr_identifier(t9) && TTisVSC_stat_on_size_error_statement_list_opt(t10) && TTisVSC_stat_not_on_size_error_statement_list_opt(t11) && TTist_END_DIVIDE_opt(t12));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    args[9] = t10;
    args[10] = t11;
    args[11] = t12;
    return TTbuild_term(TTfunVSC_stat_divide_statement_4, args);
}

TTterm
TTbuildVSC_stat_divide_statement_5(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9, TTterm t10, TTterm t11, TTterm t12)
{
    assert(TTist_DIVIDE(t1) && TTisVSC_stat_id_or_lit(t2) && TTist_BY(t3) && TTisVSC_stat_id_or_lit(t4) && TTist_GIVING(t5) && TTisVSC_expr_identifier(t6) && TTist_ROUNDED_opt(t7) && TTist_REMAINDER(t8) && TTisVSC_expr_identifier(t9) && TTisVSC_stat_on_size_error_statement_list_opt(t10) && TTisVSC_stat_not_on_size_error_statement_list_opt(t11) && TTist_END_DIVIDE_opt(t12));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    args[9] = t10;
    args[10] = t11;
    args[11] = t12;
    return TTbuild_term(TTfunVSC_stat_divide_statement_5, args);
}

TTterm
TTbuildVSC_stat_else_phrase(TTterm t1, TTterm t2)
{
    assert(TTist_ELSE(t1) && TTisVSC_stat_alt_statement_list_next_sentence(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_else_phrase, args);
}

TTterm
TTbuildVSC_stat_end_of_page(TTterm t1)
{
    assert(TTist_END_OF_PAGE(t1) || TTist_EOP(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_end_of_page, args);
}

TTterm
TTbuildVSC_stat_entry_statement(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_ENTRY(t1) && TTisVSC_expr_literal(t2) && TTisVSC_stat_using_data_name_pluslist_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_entry_statement, args);
}

TTterm
TTbuildVSC_stat_equal(TTterm t1)
{
    assert(TTist_qequal(t1) || TTist_EQUAL(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_equal, args);
}

TTterm
TTbuildVSC_stat_evaluate_condition(TTterm t1)
{
    assert(TTisVSC_cond_condition(t1) || TTist_TRUE(t1) || TTist_FALSE(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_evaluate_condition, args);
}

TTterm
TTbuildVSC_stat_evaluate_phrase(TTterm t1)
{
    assert(TTist_ANY(t1) || TTist_TRUE(t1) || TTist_FALSE(t1) || TTisVSC_stat_evaluate_phrase_2(t1) || TTisVSC_cond_condition(t1) || TTisVSC_stat_evaluate_phrase_1(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_evaluate_phrase, args);
}

TTterm
TTbuildVSC_stat_evaluate_phrase_1(TTterm t1, TTterm t2)
{
    assert(TTist_NOT_opt(t1) && TTisVSC_expr_arithmetic_expression(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_evaluate_phrase_1, args);
}

TTterm
TTbuildVSC_stat_evaluate_phrase_2(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_NOT_opt(t1) && TTisVSC_expr_arithmetic_expression(t2) && TTisVSC_expr_through_arithmetic_expression(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_evaluate_phrase_2, args);
}

TTterm
TTbuildVSC_stat_evaluate_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6)
{
    assert(TTist_EVALUATE(t1) && TTisVSC_stat_evaluate_condition(t2) && TTisVSC_stat_also_phrase_star(t3) && TTisVSC_stat_when_phrases_plus(t4) && TTisVSC_stat_when_other_phrase_opt(t5) && TTist_END_EVALUATE_opt(t6));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    return TTbuild_term(TTfunVSC_stat_evaluate_statement, args);
}

TTterm
TTbuildVSC_stat_exit_program_statement(TTterm t1, TTterm t2)
{
    assert(TTist_EXIT(t1) && TTist_PROGRAM(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_exit_program_statement, args);
}

TTterm
TTbuildVSC_stat_exit_statement(TTterm t1)
{
    assert(TTist_EXIT(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_exit_statement, args);
}

TTterm
TTbuildVSC_stat_file_names(TTterm t1)
{
    assert(TTisVSC_expr_file_name_plus(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_file_names, args);
}

TTterm
TTbuildVSC_stat_for_removal(TTterm t1, TTterm t2)
{
    assert(TTist_FOR_opt(t1) && TTist_REMOVAL(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_for_removal, args);
}

TTterm
TTbuildVSC_stat_from_environment_name(TTterm t1, TTterm t2)
{
    assert(TTist_FROM(t1) && TTisVSC_lex_cobword(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_from_environment_name, args);
}

TTterm
TTbuildVSC_stat_from_identifier(TTterm t1, TTterm t2)
{
    assert(TTist_FROM(t1) && TTisVSC_expr_identifier(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_from_identifier, args);
}

TTterm
TTbuildVSC_stat_giving_file_names(TTterm t1, TTterm t2)
{
    assert(TTist_GIVING(t1) && TTisVSC_expr_file_name_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_giving_file_names, args);
}

TTterm
TTbuildVSC_stat_go_to_statement(TTterm t1)
{
    assert(TTisVSC_stat_go_to_statement_2(t1) || TTisVSC_stat_go_to_statement_1(t1) || TTisVSC_stat_go_to_statement_3(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_go_to_statement, args);
}

TTterm
TTbuildVSC_stat_go_to_statement_1(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_GO(t1) && TTist_TO_opt(t2) && TTisVSC_expr_procedure_name(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_go_to_statement_1, args);
}

TTterm
TTbuildVSC_stat_go_to_statement_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6)
{
    assert(TTist_GO(t1) && TTist_TO_opt(t2) && TTisVSC_expr_procedure_name_plus(t3) && TTist_DEPENDING(t4) && TTist_ON_opt(t5) && TTisVSC_expr_identifier(t6));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    return TTbuild_term(TTfunVSC_stat_go_to_statement_2, args);
}

TTterm
TTbuildVSC_stat_go_to_statement_3(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_GO(t1) && TTist_TO_opt(t2) && TTist_MORE_LABELS(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_go_to_statement_3, args);
}

TTterm
TTbuildVSC_stat_goback_statement(TTterm t1)
{
    assert(TTist_GOBACK(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_goback_statement, args);
}

TTterm
TTbuildVSC_stat_id_or_lit(TTterm t1)
{
    assert(TTisVSC_expr_literal(t1) || TTisVSC_expr_identifier(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_id_or_lit, args);
}

TTterm
TTbuildVSC_stat_id_or_lit_size(TTterm t1)
{
    assert(TTisVSC_expr_literal(t1) || TTisVSC_expr_identifier(t1) || TTist_SIZE(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_id_or_lit_size, args);
}

TTterm
TTbuildVSC_stat_if_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6)
{
    assert(TTist_IF(t1) && TTisVSC_cond_condition(t2) && TTist_THEN_opt(t3) && TTisVSC_stat_alt_statement_list_next_sentence(t4) && TTisVSC_stat_else_phrase_opt(t5) && TTist_END_IF_opt(t6));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    return TTbuild_term(TTfunVSC_stat_if_statement, args);
}

TTterm
TTbuildVSC_stat_initialize_replacing_argument(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_stat_initialize_replacing_type(t1) && TTist_DATA_opt(t2) && TTist_BY(t3) && TTisVSC_stat_id_or_lit(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_initialize_replacing_argument, args);
}

TTterm
TTbuildVSC_stat_initialize_replacing_phrase(TTterm t1, TTterm t2)
{
    assert(TTist_REPLACING(t1) && TTisVSC_stat_initialize_replacing_argument_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_initialize_replacing_phrase, args);
}

TTterm
TTbuildVSC_stat_initialize_replacing_type(TTterm t1)
{
    assert(TTist_ALPHABETIC(t1) || TTist_ALPHANUMERIC(t1) || TTist_NUMERIC(t1) || TTist_ALPHANUMERIC_EDITED(t1) || TTist_NUMERIC_EDITED(t1) || TTist_DBCS(t1) || TTist_EGCS(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_initialize_replacing_type, args);
}

TTterm
TTbuildVSC_stat_initialize_statement(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_INITIALIZE(t1) && TTisVSC_expr_identifier_plus(t2) && TTisVSC_stat_initialize_replacing_phrase_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_initialize_statement, args);
}

TTterm
TTbuildVSC_stat_input_procedure(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_INPUT(t1) && TTist_PROCEDURE(t2) && TTist_IS_opt(t3) && TTisVSC_expr_procedure_name(t4) && TTisVSC_stat_through_procedure_name_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_stat_input_procedure, args);
}

TTterm
TTbuildVSC_stat_inspect_by_argument(TTterm t1)
{
    assert(TTisVSC_expr_identifier(t1) || TTisVSC_lex_nonnumeric(t1) || TTisVSC_expr_figurative_constant_simple(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_inspect_by_argument, args);
}

TTterm
TTbuildVSC_stat_inspect_replacing_argument(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_stat_inspect_by_argument(t1) && TTist_BY(t2) && TTisVSC_stat_inspect_by_argument(t3) && TTisVSC_stat_before_after_phrase_star(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_inspect_replacing_argument, args);
}

TTterm
TTbuildVSC_stat_inspect_replacing_phrase(TTterm t1)
{
    assert(TTisVSC_stat_inspect_replacing_phrase_1(t1) || TTisVSC_stat_inspect_replacing_phrase_2(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_inspect_replacing_phrase, args);
}

TTterm
TTbuildVSC_stat_inspect_replacing_phrase_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_CHARACTERS(t1) && TTist_BY(t2) && TTisVSC_stat_id_or_lit(t3) && TTisVSC_stat_before_after_phrase_star(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_inspect_replacing_phrase_1, args);
}

TTterm
TTbuildVSC_stat_inspect_replacing_phrase_2(TTterm t1, TTterm t2)
{
    assert(TTisVSC_stat_alt_all_leading_first(t1) && TTisVSC_stat_inspect_replacing_argument_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_inspect_replacing_phrase_2, args);
}

TTterm
TTbuildVSC_stat_inspect_statement(TTterm t1)
{
    assert(TTisVSC_stat_inspect_statement_3(t1) || TTisVSC_stat_inspect_statement_1(t1) || TTisVSC_stat_inspect_statement_2(t1) || TTisVSC_stat_inspect_statement_4(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_inspect_statement, args);
}

TTterm
TTbuildVSC_stat_inspect_statement_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_INSPECT(t1) && TTisVSC_expr_identifier(t2) && TTist_TALLYING(t3) && TTisVSC_stat_tallying_argument_plus(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_inspect_statement_1, args);
}

TTterm
TTbuildVSC_stat_inspect_statement_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7)
{
    assert(TTist_INSPECT(t1) && TTisVSC_expr_identifier(t2) && TTist_CONVERTING(t3) && TTisVSC_stat_id_or_lit(t4) && TTist_TO(t5) && TTisVSC_stat_id_or_lit(t6) && TTisVSC_stat_before_after_phrase_star(t7));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    return TTbuild_term(TTfunVSC_stat_inspect_statement_2, args);
}

TTterm
TTbuildVSC_stat_inspect_statement_3(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6)
{
    assert(TTist_INSPECT(t1) && TTisVSC_expr_identifier(t2) && TTist_TALLYING(t3) && TTisVSC_stat_tallying_argument_plus(t4) && TTist_REPLACING(t5) && TTisVSC_stat_inspect_replacing_phrase_plus(t6));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    return TTbuild_term(TTfunVSC_stat_inspect_statement_3, args);
}

TTterm
TTbuildVSC_stat_inspect_statement_4(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_INSPECT(t1) && TTisVSC_expr_identifier(t2) && TTist_REPLACING(t3) && TTisVSC_stat_inspect_replacing_phrase_plus(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_inspect_statement_4, args);
}

TTterm
TTbuildVSC_stat_into_identifier(TTterm t1, TTterm t2)
{
    assert(TTist_INTO(t1) && TTisVSC_expr_identifier(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_into_identifier, args);
}

TTterm
TTbuildVSC_stat_invalid_key_statement_list(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_INVALID(t1) && TTist_KEY_opt(t2) && TTisVSC_stat_statement_list(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_invalid_key_statement_list, args);
}

TTterm
TTbuildVSC_stat_key_is(TTterm t1, TTterm t2)
{
    assert(TTist_KEY(t1) && TTist_IS_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_key_is, args);
}

TTterm
TTbuildVSC_stat_key_is_qualified_data_name(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_KEY(t1) && TTist_IS_opt(t2) && TTisVSC_expr_qualified_data_name(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_key_is_qualified_data_name, args);
}

TTterm
TTbuildVSC_stat_key_is_rel_op_qualified_data_name(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_KEY(t1) && TTist_IS_opt(t2) && TTisVSC_stat_rel_op(t3) && TTisVSC_expr_qualified_data_name(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_key_is_rel_op_qualified_data_name, args);
}

TTterm
TTbuildVSC_stat_lines(TTterm t1)
{
    assert(TTist_LINE(t1) || TTist_LINES(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_lines, args);
}

TTterm
TTbuildVSC_stat_merge_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8)
{
    assert(TTist_MERGE(t1) && TTisVSC_expr_file_name(t2) && TTisVSC_stat_on_key_phrase_plus(t3) && TTisVSC_stat_collating_sequence_opt(t4) && TTist_USING(t5) && TTisVSC_expr_file_name(t6) && TTisVSC_expr_file_name_plus(t7) && TTisVSC_stat_merge_statement_tail(t8));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    return TTbuild_term(TTfunVSC_stat_merge_statement, args);
}

TTterm
TTbuildVSC_stat_merge_statement_tail(TTterm t1)
{
    assert(TTisVSC_stat_output_procedure(t1) || TTisVSC_stat_giving_file_names(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_merge_statement_tail, args);
}

TTterm
TTbuildVSC_stat_move_statement(TTterm t1)
{
    assert(TTisVSC_stat_move_statement_1(t1) || TTisVSC_stat_move_statement_2(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_move_statement, args);
}

TTterm
TTbuildVSC_stat_move_statement_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_MOVE(t1) && TTisVSC_stat_id_or_lit(t2) && TTist_TO(t3) && TTisVSC_expr_identifier_plus(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_move_statement_1, args);
}

TTterm
TTbuildVSC_stat_move_statement_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_MOVE(t1) && TTisVSC_stat_corresponding(t2) && TTisVSC_expr_identifier(t3) && TTist_TO(t4) && TTisVSC_expr_identifier_plus(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_stat_move_statement_2, args);
}

TTterm
TTbuildVSC_stat_multiply_statement(TTterm t1)
{
    assert(TTisVSC_stat_multiply_statement_2(t1) || TTisVSC_stat_multiply_statement_1(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_multiply_statement, args);
}

TTterm
TTbuildVSC_stat_multiply_statement_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7)
{
    assert(TTist_MULTIPLY(t1) && TTisVSC_stat_id_or_lit(t2) && TTist_BY(t3) && TTisVSC_stat_cobword_rounded_plus(t4) && TTisVSC_stat_on_size_error_statement_list_opt(t5) && TTisVSC_stat_not_on_size_error_statement_list_opt(t6) && TTist_END_MULTIPLY_opt(t7));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    return TTbuild_term(TTfunVSC_stat_multiply_statement_1, args);
}

TTterm
TTbuildVSC_stat_multiply_statement_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9)
{
    assert(TTist_MULTIPLY(t1) && TTisVSC_stat_id_or_lit(t2) && TTist_BY(t3) && TTisVSC_stat_id_or_lit(t4) && TTist_GIVING(t5) && TTisVSC_stat_cobword_rounded_plus(t6) && TTisVSC_stat_on_size_error_statement_list_opt(t7) && TTisVSC_stat_not_on_size_error_statement_list_opt(t8) && TTist_END_MULTIPLY_opt(t9));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    return TTbuild_term(TTfunVSC_stat_multiply_statement_2, args);
}

TTterm
TTbuildVSC_stat_next_sentence(TTterm t1, TTterm t2)
{
    assert(TTist_NEXT(t1) && TTist_SENTENCE(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_next_sentence, args);
}

TTterm
TTbuildVSC_stat_no_rewind(TTterm t1, TTterm t2)
{
    assert(TTist_NO(t1) && TTist_REWIND(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_no_rewind, args);
}

TTterm
TTbuildVSC_stat_not_at_end_of_page_statement_list(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_NOT(t1) && TTist_AT_opt(t2) && TTisVSC_stat_end_of_page(t3) && TTisVSC_stat_statement_list(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_not_at_end_of_page_statement_list, args);
}

TTterm
TTbuildVSC_stat_not_at_end_statement_list(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_NOT(t1) && TTist_AT_opt(t2) && TTist_END(t3) && TTisVSC_stat_statement_list(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_not_at_end_statement_list, args);
}

TTterm
TTbuildVSC_stat_not_invalid_key_statement_list(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_NOT(t1) && TTist_INVALID(t2) && TTist_KEY_opt(t3) && TTisVSC_stat_statement_list(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_not_invalid_key_statement_list, args);
}

TTterm
TTbuildVSC_stat_not_on_exception_statement_list(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_NOT(t1) && TTist_ON_opt(t2) && TTist_EXCEPTION(t3) && TTisVSC_stat_statement_list(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_not_on_exception_statement_list, args);
}

TTterm
TTbuildVSC_stat_not_on_overflow_statement_list(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_NOT(t1) && TTist_ON_opt(t2) && TTist_OVERFLOW(t3) && TTisVSC_stat_statement_list(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_not_on_overflow_statement_list, args);
}

TTterm
TTbuildVSC_stat_not_on_size_error_statement_list(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_NOT(t1) && TTist_ON_opt(t2) && TTist_SIZE(t3) && TTist_ERROR(t4) && TTisVSC_stat_statement_list(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_stat_not_on_size_error_statement_list, args);
}

TTterm
TTbuildVSC_stat_nr_lines_phrase(TTterm t1, TTterm t2)
{
    assert(TTisVSC_stat_cobword_int(t1) && TTisVSC_stat_lines_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_nr_lines_phrase, args);
}

TTterm
TTbuildVSC_stat_on_exception_statement_list(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_ON_opt(t1) && TTist_EXCEPTION(t2) && TTisVSC_stat_statement_list(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_on_exception_statement_list, args);
}

TTterm
TTbuildVSC_stat_on_key_is_phrase(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_ON_opt(t1) && TTisVSC_expr_alt_ascending_descending(t2) && TTisVSC_stat_key_is_opt(t3) && TTisVSC_expr_qualified_data_name_plus(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_on_key_is_phrase, args);
}

TTterm
TTbuildVSC_stat_on_key_phrase(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_ON_opt(t1) && TTisVSC_expr_alt_ascending_descending(t2) && TTist_KEY_opt(t3) && TTisVSC_expr_qualified_data_name_plus(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_on_key_phrase, args);
}

TTterm
TTbuildVSC_stat_on_overflow_statement_list(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_ON_opt(t1) && TTist_OVERFLOW(t2) && TTisVSC_stat_statement_list(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_on_overflow_statement_list, args);
}

TTterm
TTbuildVSC_stat_on_size_error_statement_list(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_ON_opt(t1) && TTist_SIZE(t2) && TTist_ERROR(t3) && TTisVSC_stat_statement_list(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_on_size_error_statement_list, args);
}

TTterm
TTbuildVSC_stat_open_statement(TTterm t1, TTterm t2)
{
    assert(TTist_OPEN(t1) && TTisVSC_stat_open_statement_phrase_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_open_statement, args);
}

TTterm
TTbuildVSC_stat_open_statement_extend(TTterm t1, TTterm t2)
{
    assert(TTist_EXTEND(t1) && TTisVSC_expr_file_name_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_open_statement_extend, args);
}

TTterm
TTbuildVSC_stat_open_statement_i_o(TTterm t1, TTterm t2)
{
    assert(TTist_I_O(t1) && TTisVSC_expr_file_name_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_open_statement_i_o, args);
}

TTterm
TTbuildVSC_stat_open_statement_input(TTterm t1, TTterm t2)
{
    assert(TTist_INPUT(t1) && TTisVSC_stat_open_statement_input_file_name_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_open_statement_input, args);
}

TTterm
TTbuildVSC_stat_open_statement_input_file_name(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_file_name(t1) && TTisVSC_stat_alt_reversed_with_no_rewind_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_open_statement_input_file_name, args);
}

TTterm
TTbuildVSC_stat_open_statement_output(TTterm t1, TTterm t2)
{
    assert(TTist_OUTPUT(t1) && TTisVSC_stat_open_statement_output_file_name_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_open_statement_output, args);
}

TTterm
TTbuildVSC_stat_open_statement_output_file_name(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_file_name(t1) && TTisVSC_stat_with_no_rewind_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_open_statement_output_file_name, args);
}

TTterm
TTbuildVSC_stat_open_statement_phrase(TTterm t1)
{
    assert(TTisVSC_stat_open_statement_input(t1) || TTisVSC_stat_open_statement_output(t1) || TTisVSC_stat_open_statement_i_o(t1) || TTisVSC_stat_open_statement_extend(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_open_statement_phrase, args);
}

TTterm
TTbuildVSC_stat_or_all_id_or_lit(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_OR(t1) && TTist_ALL_opt(t2) && TTisVSC_stat_id_or_lit(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_or_all_id_or_lit, args);
}

TTterm
TTbuildVSC_stat_output_procedure(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_OUTPUT(t1) && TTist_PROCEDURE(t2) && TTist_IS_opt(t3) && TTisVSC_expr_procedure_name(t4) && TTisVSC_stat_through_procedure_name_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_stat_output_procedure, args);
}

TTterm
TTbuildVSC_stat_page_phrase(TTterm t1)
{
    assert(TTisVSC_stat_nr_lines_phrase(t1) || TTist_PAGE(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_page_phrase, args);
}

TTterm
TTbuildVSC_stat_parameter(TTterm t1)
{
    assert(TTisVSC_stat_reference_parameter(t1) || TTisVSC_stat_content_parameter(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_parameter, args);
}

TTterm
TTbuildVSC_stat_perform_after_phrase(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8)
{
    assert(TTist_AFTER(t1) && TTisVSC_expr_identifier(t2) && TTist_FROM(t3) && TTisVSC_stat_id_or_lit(t4) && TTist_BY(t5) && TTisVSC_stat_id_or_lit(t6) && TTist_UNTIL(t7) && TTisVSC_cond_condition(t8));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    return TTbuild_term(TTfunVSC_stat_perform_after_phrase, args);
}

TTterm
TTbuildVSC_stat_perform_statement(TTterm t1)
{
    assert(TTisVSC_stat_perform_statement_4(t1) || TTisVSC_stat_perform_statement_2(t1) || TTisVSC_stat_perform_statement_3(t1) || TTisVSC_stat_perform_statement_1(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_perform_statement, args);
}

TTterm
TTbuildVSC_stat_perform_statement_1(TTterm t1, TTterm t2)
{
    assert(TTist_PERFORM(t1) && TTisVSC_stat_perform_statement_1_alts(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_perform_statement_1, args);
}

TTterm
TTbuildVSC_stat_perform_statement_1_alts(TTterm t1)
{
    assert(TTisVSC_stat_perform_statement_1_procedure(t1) || TTisVSC_stat_perform_statement_1_statement_list(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_perform_statement_1_alts, args);
}

TTterm
TTbuildVSC_stat_perform_statement_1_procedure(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_procedure_name(t1) && TTisVSC_stat_through_procedure_name_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_perform_statement_1_procedure, args);
}

TTterm
TTbuildVSC_stat_perform_statement_1_statement_list(TTterm t1, TTterm t2)
{
    assert(TTisVSC_stat_statement_list(t1) && TTist_END_PERFORM(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_perform_statement_1_statement_list, args);
}

TTterm
TTbuildVSC_stat_perform_statement_2(TTterm t1, TTterm t2)
{
    assert(TTist_PERFORM(t1) && TTisVSC_stat_perform_statement_2_alts(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_perform_statement_2, args);
}

TTterm
TTbuildVSC_stat_perform_statement_2_alts(TTterm t1)
{
    assert(TTisVSC_stat_perform_statement_2_procedure(t1) || TTisVSC_stat_perform_statement_2_statement_list(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_perform_statement_2_alts, args);
}

TTterm
TTbuildVSC_stat_perform_statement_2_procedure(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_expr_procedure_name(t1) && TTisVSC_stat_through_procedure_name_opt(t2) && TTisVSC_stat_perform_varying_phrase(t3) && TTisVSC_stat_perform_after_phrase_star(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_perform_statement_2_procedure, args);
}

TTterm
TTbuildVSC_stat_perform_statement_2_statement_list(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_stat_perform_varying_phrase(t1) && TTisVSC_stat_statement_list(t2) && TTist_END_PERFORM(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_perform_statement_2_statement_list, args);
}

TTterm
TTbuildVSC_stat_perform_statement_3(TTterm t1, TTterm t2)
{
    assert(TTist_PERFORM(t1) && TTisVSC_stat_perform_statement_3_alts(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_perform_statement_3, args);
}

TTterm
TTbuildVSC_stat_perform_statement_3_alts(TTterm t1)
{
    assert(TTisVSC_stat_perform_statement_3_procedure(t1) || TTisVSC_stat_perform_statement_3_statement_list(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_perform_statement_3_alts, args);
}

TTterm
TTbuildVSC_stat_perform_statement_3_procedure(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_expr_procedure_name(t1) && TTisVSC_stat_through_procedure_name_opt(t2) && TTisVSC_stat_cobword_int(t3) && TTist_TIMES(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_perform_statement_3_procedure, args);
}

TTterm
TTbuildVSC_stat_perform_statement_3_statement_list(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_stat_cobword_int(t1) && TTist_TIMES(t2) && TTisVSC_stat_statement_list(t3) && TTist_END_PERFORM(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_perform_statement_3_statement_list, args);
}

TTterm
TTbuildVSC_stat_perform_statement_4(TTterm t1, TTterm t2)
{
    assert(TTist_PERFORM(t1) && TTisVSC_stat_perform_statement_4_alts(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_perform_statement_4, args);
}

TTterm
TTbuildVSC_stat_perform_statement_4_alts(TTterm t1)
{
    assert(TTisVSC_stat_perform_statement_4_procedure(t1) || TTisVSC_stat_perform_statement_4_statement_list(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_perform_statement_4_alts, args);
}

TTterm
TTbuildVSC_stat_perform_statement_4_procedure(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_procedure_name(t1) && TTisVSC_stat_through_procedure_name_opt(t2) && TTisVSC_stat_perform_until_phrase(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_perform_statement_4_procedure, args);
}

TTterm
TTbuildVSC_stat_perform_statement_4_statement_list(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_stat_perform_until_phrase(t1) && TTisVSC_stat_statement_list(t2) && TTist_END_PERFORM(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_perform_statement_4_statement_list, args);
}

TTterm
TTbuildVSC_stat_perform_until_phrase(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_stat_with_test_opt(t1) && TTist_UNTIL(t2) && TTisVSC_cond_condition(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_perform_until_phrase, args);
}

TTterm
TTbuildVSC_stat_perform_varying_phrase(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9)
{
    assert(TTisVSC_stat_with_test_opt(t1) && TTist_VARYING(t2) && TTisVSC_expr_identifier(t3) && TTist_FROM(t4) && TTisVSC_stat_id_or_lit(t5) && TTist_BY(t6) && TTisVSC_stat_id_or_lit(t7) && TTist_UNTIL(t8) && TTisVSC_cond_condition(t9));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    return TTbuild_term(TTfunVSC_stat_perform_varying_phrase, args);
}

TTterm
TTbuildVSC_stat_procedure_names(TTterm t1)
{
    assert(TTisVSC_expr_procedure_name_plus(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_procedure_names, args);
}

TTterm
TTbuildVSC_stat_procedure_to_procedure(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_expr_procedure_name(t1) && TTist_TO(t2) && TTisVSC_stat_proceed_to_opt(t3) && TTisVSC_expr_procedure_name(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_procedure_to_procedure, args);
}

TTterm
TTbuildVSC_stat_proceed_to(TTterm t1, TTterm t2)
{
    assert(TTist_PROCEED(t1) && TTist_TO(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_proceed_to, args);
}

TTterm
TTbuildVSC_stat_read_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9, TTterm t10, TTterm t11)
{
    assert(TTist_READ(t1) && TTisVSC_expr_file_name(t2) && TTist_NEXT_opt(t3) && TTist_RECORD_opt(t4) && TTisVSC_stat_into_identifier_opt(t5) && TTisVSC_stat_key_is_qualified_data_name_opt(t6) && TTisVSC_stat_invalid_key_statement_list_opt(t7) && TTisVSC_stat_not_invalid_key_statement_list_opt(t8) && TTisVSC_stat_at_end_statement_list_opt(t9) && TTisVSC_stat_not_at_end_statement_list_opt(t10) && TTist_END_READ_opt(t11));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    args[9] = t10;
    args[10] = t11;
    return TTbuild_term(TTfunVSC_stat_read_statement, args);
}

TTterm
TTbuildVSC_stat_reference_parameter(TTterm t1, TTterm t2)
{
    assert(TTisVSC_stat_by_reference_opt(t1) && TTisVSC_expr_identifier(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_reference_parameter, args);
}

TTterm
TTbuildVSC_stat_rel_op(TTterm t1)
{
    assert(TTisVSC_expr_equal_to(t1) || TTisVSC_cond_greater_than_or_equal_to(t1) || TTisVSC_cond_greater_than(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_rel_op, args);
}

TTterm
TTbuildVSC_stat_release_statement(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_RELEASE(t1) && TTisVSC_expr_record_name(t2) && TTisVSC_stat_from_identifier_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_release_statement, args);
}

TTterm
TTbuildVSC_stat_return_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9)
{
    assert(TTist_RETURN(t1) && TTisVSC_expr_file_name(t2) && TTist_RECORD_opt(t3) && TTisVSC_stat_into_identifier_opt(t4) && TTist_AT_opt(t5) && TTist_END(t6) && TTisVSC_stat_statement_list(t7) && TTisVSC_stat_not_at_end_statement_list_opt(t8) && TTist_END_RETURN_opt(t9));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    return TTbuild_term(TTfunVSC_stat_return_statement, args);
}

TTterm
TTbuildVSC_stat_rewrite_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6)
{
    assert(TTist_REWRITE(t1) && TTisVSC_expr_record_name(t2) && TTisVSC_stat_from_identifier_opt(t3) && TTisVSC_stat_invalid_key_statement_list_opt(t4) && TTisVSC_stat_not_invalid_key_statement_list_opt(t5) && TTist_END_REWRITE_opt(t6));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    return TTbuild_term(TTfunVSC_stat_rewrite_statement, args);
}

TTterm
TTbuildVSC_stat_search_statement(TTterm t1)
{
    assert(TTisVSC_stat_search_statement_1(t1) || TTisVSC_stat_search_statement_2(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_search_statement, args);
}

TTterm
TTbuildVSC_stat_search_statement_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6)
{
    assert(TTist_SEARCH(t1) && TTisVSC_expr_identifier(t2) && TTisVSC_stat_varying_identifier_opt(t3) && TTisVSC_stat_at_end_statement_list_opt(t4) && TTisVSC_stat_when_condition_stats_plus(t5) && TTist_END_SEARCH_opt(t6));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    return TTbuild_term(TTfunVSC_stat_search_statement_1, args);
}

TTterm
TTbuildVSC_stat_search_statement_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9)
{
    assert(TTist_SEARCH(t1) && TTist_ALL(t2) && TTisVSC_expr_identifier(t3) && TTisVSC_stat_at_end_statement_list_opt(t4) && TTist_WHEN(t5) && TTisVSC_stat_search_statement_condition(t6) && TTisVSC_stat_search_statement_condition_tail_star(t7) && TTisVSC_stat_alt_statement_list_next_sentence(t8) && TTist_END_SEARCH_opt(t9));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    return TTbuild_term(TTfunVSC_stat_search_statement_2, args);
}

TTterm
TTbuildVSC_stat_search_statement_condition(TTterm t1)
{
    assert(TTisVSC_stat_search_statement_equal_expression(t1) || TTisVSC_cond_condition_name_reference(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_search_statement_condition, args);
}

TTterm
TTbuildVSC_stat_search_statement_condition_tail(TTterm t1, TTterm t2)
{
    assert(TTist_AND(t1) && TTisVSC_stat_search_statement_condition(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_search_statement_condition_tail, args);
}

TTterm
TTbuildVSC_stat_search_statement_equal_expression(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_expr_identifier(t1) && TTist_IS_opt(t2) && TTisVSC_expr_equal_to(t3) && TTisVSC_expr_arithmetic_expression(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_search_statement_equal_expression, args);
}

TTterm
TTbuildVSC_stat_set_oper(TTterm t1)
{
    assert(TTist_TO(t1) || TTisVSC_stat_alt_up_down_by(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_set_oper, args);
}

TTterm
TTbuildVSC_stat_set_src(TTterm t1)
{
    assert(TTisVSC_expr_identifier(t1) || TTisVSC_expr_literal(t1) || TTist_TRUE(t1) || TTist_ON(t1) || TTist_OFF(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_set_src, args);
}

TTterm
TTbuildVSC_stat_set_statement(TTterm t1, TTterm t2)
{
    assert(TTist_SET(t1) && TTisVSC_stat_set_statement_phrase_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_set_statement, args);
}

TTterm
TTbuildVSC_stat_set_statement_phrase(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_identifier_plus(t1) && TTisVSC_stat_set_oper(t2) && TTisVSC_stat_set_src(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_set_statement_phrase, args);
}

TTterm
TTbuildVSC_stat_sort_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7)
{
    assert(TTist_SORT(t1) && TTisVSC_expr_file_name(t2) && TTisVSC_stat_on_key_is_phrase_plus(t3) && TTisVSC_stat_with_duplicates_in_order_opt(t4) && TTisVSC_stat_collating_sequence_opt(t5) && TTisVSC_stat_sort_statement_in(t6) && TTisVSC_stat_sort_statement_out(t7));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    return TTbuild_term(TTfunVSC_stat_sort_statement, args);
}

TTterm
TTbuildVSC_stat_sort_statement_in(TTterm t1)
{
    assert(TTisVSC_stat_using_file_names(t1) || TTisVSC_stat_input_procedure(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_sort_statement_in, args);
}

TTterm
TTbuildVSC_stat_sort_statement_out(TTterm t1)
{
    assert(TTisVSC_stat_giving_file_names(t1) || TTisVSC_stat_output_procedure(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_sort_statement_out, args);
}

TTterm
TTbuildVSC_stat_start_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6)
{
    assert(TTist_START(t1) && TTisVSC_expr_file_name(t2) && TTisVSC_stat_key_is_rel_op_qualified_data_name_opt(t3) && TTisVSC_stat_invalid_key_statement_list_opt(t4) && TTisVSC_stat_not_invalid_key_statement_list_opt(t5) && TTist_END_START_opt(t6));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    return TTbuild_term(TTfunVSC_stat_start_statement, args);
}

TTterm
TTbuildVSC_stat_statement(TTterm t1)
{
    assert(TTisVSC_stat_move_statement(t1) || TTisVSC_stat_if_statement(t1) || TTisVSC_stat_perform_statement(t1) || TTisVSC_stat_go_to_statement(t1) || TTisVSC_stat_accept_statement(t1) || TTisVSC_stat_add_statement(t1) || TTisVSC_stat_alter_statement(t1) || TTisVSC_stat_call_statement(t1) || TTisVSC_stat_cancel_statement(t1) || TTisVSC_stat_close_statement(t1) || TTisVSC_stat_compute_statement(t1) || TTisVSC_stat_continue_statement(t1) || TTisVSC_stat_delete_statement(t1) || TTisVSC_stat_display_statement(t1) || TTisVSC_stat_divide_statement(t1) || TTisVSC_stat_entry_statement(t1) || TTisVSC_stat_evaluate_statement(t1) || TTisVSC_stat_exit_program_statement(t1) || TTisVSC_stat_exit_statement(t1) || TTisVSC_stat_goback_statement(t1) || TTisVSC_stat_initialize_statement(t1) || TTisVSC_stat_inspect_statement(t1) || TTisVSC_stat_merge_statement(t1) || TTisVSC_stat_multiply_statement(t1) || TTisVSC_stat_open_statement(t1) || TTisVSC_stat_read_statement(t1) || TTisVSC_stat_release_statement(t1) || TTisVSC_stat_return_statement(t1) || TTisVSC_stat_rewrite_statement(t1) || TTisVSC_stat_search_statement(t1) || TTisVSC_stat_set_statement(t1) || TTisVSC_stat_sort_statement(t1) || TTisVSC_stat_start_statement(t1) || TTisVSC_stat_stop_statement(t1) || TTisVSC_stat_string_statement(t1) || TTisVSC_stat_subtract_statement(t1) || TTisVSC_stat_unstring_statement(t1) || TTisVSC_stat_write_statement(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_statement, args);
}

TTterm
TTbuildVSC_stat_statement_list(TTterm t1)
{
    assert(TTisVSC_stat_statement_plus(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_statement_list, args);
}

TTterm
TTbuildVSC_stat_stop_statement(TTterm t1, TTterm t2)
{
    assert(TTist_STOP(t1) && TTisVSC_stat_alt_run_literal(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_stop_statement, args);
}

TTterm
TTbuildVSC_stat_string_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8)
{
    assert(TTist_STRING(t1) && TTisVSC_stat_delimited_by_phrase_plus(t2) && TTist_INTO(t3) && TTisVSC_expr_identifier(t4) && TTisVSC_stat_with_pointer_identifier_opt(t5) && TTisVSC_stat_on_overflow_statement_list_opt(t6) && TTisVSC_stat_not_on_overflow_statement_list_opt(t7) && TTist_END_STRING_opt(t8));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    return TTbuild_term(TTfunVSC_stat_string_statement, args);
}

TTterm
TTbuildVSC_stat_subtract_statement(TTterm t1)
{
    assert(TTisVSC_stat_subtract_statement_2(t1) || TTisVSC_stat_subtract_statement_1(t1) || TTisVSC_stat_subtract_statement_3(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_subtract_statement, args);
}

TTterm
TTbuildVSC_stat_subtract_statement_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7)
{
    assert(TTist_SUBTRACT(t1) && TTisVSC_stat_id_or_lit_plus(t2) && TTist_FROM(t3) && TTisVSC_stat_cobword_rounded_plus(t4) && TTisVSC_stat_on_size_error_statement_list_opt(t5) && TTisVSC_stat_not_on_size_error_statement_list_opt(t6) && TTist_END_SUBTRACT_opt(t7));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    return TTbuild_term(TTfunVSC_stat_subtract_statement_1, args);
}

TTterm
TTbuildVSC_stat_subtract_statement_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9)
{
    assert(TTist_SUBTRACT(t1) && TTisVSC_stat_id_or_lit_plus(t2) && TTist_FROM(t3) && TTisVSC_stat_id_or_lit(t4) && TTist_GIVING(t5) && TTisVSC_stat_cobword_rounded_plus(t6) && TTisVSC_stat_on_size_error_statement_list_opt(t7) && TTisVSC_stat_not_on_size_error_statement_list_opt(t8) && TTist_END_SUBTRACT_opt(t9));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    return TTbuild_term(TTfunVSC_stat_subtract_statement_2, args);
}

TTterm
TTbuildVSC_stat_subtract_statement_3(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9)
{
    assert(TTist_SUBTRACT(t1) && TTisVSC_stat_corresponding(t2) && TTisVSC_expr_identifier(t3) && TTist_FROM(t4) && TTisVSC_expr_identifier(t5) && TTist_ROUNDED_opt(t6) && TTisVSC_stat_on_size_error_statement_list_opt(t7) && TTisVSC_stat_not_on_size_error_statement_list_opt(t8) && TTist_END_SUBTRACT_opt(t9));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    return TTbuild_term(TTfunVSC_stat_subtract_statement_3, args);
}

TTterm
TTbuildVSC_stat_tallying_argument(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_identifier(t1) && TTist_FOR(t2) && TTisVSC_stat_tallying_for_argument_plus(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_tallying_argument, args);
}

TTterm
TTbuildVSC_stat_tallying_for_argument(TTterm t1)
{
    assert(TTisVSC_stat_tallying_for_argument_1(t1) || TTisVSC_stat_tallying_for_argument_2(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_tallying_for_argument, args);
}

TTterm
TTbuildVSC_stat_tallying_for_argument_1(TTterm t1, TTterm t2)
{
    assert(TTist_CHARACTERS(t1) && TTisVSC_stat_before_after_phrase_star(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_tallying_for_argument_1, args);
}

TTterm
TTbuildVSC_stat_tallying_for_argument_2(TTterm t1, TTterm t2)
{
    assert(TTisVSC_stat_alt_all_leading(t1) && TTisVSC_stat_tallying_for_id_or_lit_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_tallying_for_argument_2, args);
}

TTterm
TTbuildVSC_stat_tallying_for_id_or_lit(TTterm t1, TTterm t2)
{
    assert(TTisVSC_stat_id_or_lit(t1) && TTisVSC_stat_before_after_phrase_star(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_tallying_for_id_or_lit, args);
}

TTterm
TTbuildVSC_stat_tallying_in_identifier(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_TALLYING(t1) && TTist_IN_opt(t2) && TTisVSC_expr_identifier(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_tallying_in_identifier, args);
}

TTterm
TTbuildVSC_stat_through_procedure_name(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_through(t1) && TTisVSC_expr_procedure_name(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_through_procedure_name, args);
}

TTterm
TTbuildVSC_stat_to_id_or_lit(TTterm t1, TTterm t2)
{
    assert(TTist_TO(t1) && TTisVSC_stat_id_or_lit(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_to_id_or_lit, args);
}

TTterm
TTbuildVSC_stat_unstring_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9, TTterm t10)
{
    assert(TTist_UNSTRING(t1) && TTisVSC_expr_identifier(t2) && TTisVSC_stat_delimited_by_all_phrase_opt(t3) && TTist_INTO(t4) && TTisVSC_stat_unstring_statement_dst_plus(t5) && TTisVSC_stat_with_pointer_identifier_opt(t6) && TTisVSC_stat_tallying_in_identifier_opt(t7) && TTisVSC_stat_on_overflow_statement_list_opt(t8) && TTisVSC_stat_not_on_overflow_statement_list_opt(t9) && TTist_END_UNSTRING_opt(t10));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    args[9] = t10;
    return TTbuild_term(TTfunVSC_stat_unstring_statement, args);
}

TTterm
TTbuildVSC_stat_unstring_statement_dst(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_identifier(t1) && TTisVSC_stat_delimiter_in_identifier_opt(t2) && TTisVSC_stat_count_in_identifier_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_unstring_statement_dst, args);
}

TTterm
TTbuildVSC_stat_upon_environment_name(TTterm t1, TTterm t2)
{
    assert(TTist_UPON(t1) && TTisVSC_lex_cobword(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_upon_environment_name, args);
}

TTterm
TTbuildVSC_stat_use_statement(TTterm t1)
{
    assert(TTisVSC_stat_use_statement_1(t1) || TTisVSC_stat_use_statement_2(t1) || TTisVSC_stat_use_statement_3(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_use_statement, args);
}

TTterm
TTbuildVSC_stat_use_statement_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8)
{
    assert(TTist_USE(t1) && TTist_GLOBAL_opt(t2) && TTist_AFTER(t3) && TTist_STANDARD_opt(t4) && TTisVSC_stat_alt_exception_error(t5) && TTist_PROCEDURE(t6) && TTist_ON_opt(t7) && TTisVSC_stat_alt_file_names_i_o(t8));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    return TTbuild_term(TTfunVSC_stat_use_statement_1, args);
}

TTterm
TTbuildVSC_stat_use_statement_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9, TTterm t10)
{
    assert(TTist_USE(t1) && TTist_GLOBAL_opt(t2) && TTist_AFTER(t3) && TTist_STANDARD_opt(t4) && TTisVSC_stat_alt_beginning_ending_opt(t5) && TTisVSC_stat_alt_file_reel_unit_opt(t6) && TTist_LABEL(t7) && TTist_PROCEDURE(t8) && TTist_ON_opt(t9) && TTisVSC_stat_alt_file_names_i_o(t10));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    args[9] = t10;
    return TTbuild_term(TTfunVSC_stat_use_statement_2, args);
}

TTterm
TTbuildVSC_stat_use_statement_3(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_USE(t1) && TTist_FOR_opt(t2) && TTist_DEBUGGING(t3) && TTist_ON_opt(t4) && TTisVSC_stat_alt_procedures_all_procedures(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_stat_use_statement_3, args);
}

TTterm
TTbuildVSC_stat_using_data_name_pluslist(TTterm t1, TTterm t2)
{
    assert(TTist_USING(t1) && TTisVSC_expr_data_name_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_using_data_name_pluslist, args);
}

TTterm
TTbuildVSC_stat_using_file_names(TTterm t1, TTterm t2)
{
    assert(TTist_USING(t1) && TTisVSC_expr_file_name_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_using_file_names, args);
}

TTterm
TTbuildVSC_stat_using_parameters(TTterm t1, TTterm t2)
{
    assert(TTist_USING(t1) && TTisVSC_stat_parameter_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_using_parameters, args);
}

TTterm
TTbuildVSC_stat_varying_identifier(TTterm t1, TTterm t2)
{
    assert(TTist_VARYING(t1) && TTisVSC_expr_identifier(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_varying_identifier, args);
}

TTterm
TTbuildVSC_stat_when_condition_stats(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_WHEN(t1) && TTisVSC_cond_condition(t2) && TTisVSC_stat_alt_statement_list_next_sentence(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_when_condition_stats, args);
}

TTterm
TTbuildVSC_stat_when_other_phrase(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_WHEN(t1) && TTist_OTHER(t2) && TTisVSC_stat_statement_list(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_when_other_phrase, args);
}

TTterm
TTbuildVSC_stat_when_phrase(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_WHEN(t1) && TTisVSC_stat_evaluate_phrase(t2) && TTisVSC_stat_when_phrase_also_phrase_star(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_when_phrase, args);
}

TTterm
TTbuildVSC_stat_when_phrase_also_phrase(TTterm t1, TTterm t2)
{
    assert(TTist_ALSO(t1) && TTisVSC_stat_evaluate_phrase(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_when_phrase_also_phrase, args);
}

TTterm
TTbuildVSC_stat_when_phrases(TTterm t1, TTterm t2)
{
    assert(TTisVSC_stat_when_phrase_plus(t1) && TTisVSC_stat_statement_list(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_when_phrases, args);
}

TTterm
TTbuildVSC_stat_with_duplicates_in_order(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_WITH_opt(t1) && TTist_DUPLICATES(t2) && TTist_IN_opt(t3) && TTist_ORDER_opt(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_with_duplicates_in_order, args);
}

TTterm
TTbuildVSC_stat_with_no_advancing(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_WITH_opt(t1) && TTist_NO(t2) && TTist_ADVANCING(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_with_no_advancing, args);
}

TTterm
TTbuildVSC_stat_with_no_rewind(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_WITH_opt(t1) && TTist_NO(t2) && TTist_REWIND(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_with_no_rewind, args);
}

TTterm
TTbuildVSC_stat_with_pointer_identifier(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_WITH_opt(t1) && TTist_POINTER(t2) && TTisVSC_expr_identifier(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_with_pointer_identifier, args);
}

TTterm
TTbuildVSC_stat_with_test(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_WITH_opt(t1) && TTist_TEST(t2) && TTisVSC_stat_alt_before_after(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_with_test, args);
}

TTterm
TTbuildVSC_stat_write_exceptions(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_stat_at_end_of_page_statement_list_opt(t1) && TTisVSC_stat_not_at_end_of_page_statement_list_opt(t2) && TTisVSC_stat_invalid_key_statement_list_opt(t3) && TTisVSC_stat_not_invalid_key_statement_list_opt(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_write_exceptions, args);
}

TTterm
TTbuildVSC_stat_write_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6)
{
    assert(TTist_WRITE(t1) && TTisVSC_expr_record_name(t2) && TTisVSC_stat_from_identifier_opt(t3) && TTisVSC_stat_advancing_phrase_opt(t4) && TTisVSC_stat_write_exceptions(t5) && TTist_END_WRITE_opt(t6));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    return TTbuild_term(TTfunVSC_stat_write_statement, args);
}

TTterm
TTbuildVSC_lex_picture_string(TTtype_string t)
{
    args[0] = (TTterm)t;
    return TTbuild_term(TTfunVSC_lex_picture_string, args);
}

TTterm
TTbuildVSC_lex_quoted_pseudo_text(TTtype_string t)
{
    args[0] = (TTterm)t;
    return TTbuild_term(TTfunVSC_lex_quoted_pseudo_text, args);
}

TTterm
TTbuildVSC_lex_num(TTtype_string t)
{
    args[0] = (TTterm)t;
    return TTbuild_term(TTfunVSC_lex_num, args);
}

TTterm
TTbuildVSC_lex_nonnumeric(TTtype_string t)
{
    args[0] = (TTterm)t;
    return TTbuild_term(TTfunVSC_lex_nonnumeric, args);
}

TTterm
TTbuildVSC_lex_cobword(TTtype_string t)
{
    args[0] = (TTterm)t;
    return TTbuild_term(TTfunVSC_lex_cobword, args);
}

BOOL
TTmatchVSC_cond_alt_and_or(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_cond_alt_and_or)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_and_or_combinable_condition(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_cond_and_or_combinable_condition)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_class_condition(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_cond_class_condition)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_class_type(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_cond_class_type)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_combinable_condition(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_cond_combinable_condition)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_combined_conditions(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_cond_combined_conditions)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_condition(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_cond_condition)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_condition_name_reference(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_cond_condition_name_reference)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_greater(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_cond_greater)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_greater_equal(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_cond_greater_equal)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_greater_than(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_cond_greater_than)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_greater_than_1(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_cond_greater_than_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_greater_than_or_equal_to(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_cond_greater_than_or_equal_to)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_greater_than_or_equal_to_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_cond_greater_than_or_equal_to_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_greater_than_or_equal_to_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_cond_greater_than_or_equal_to_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_greater_than_or_equal_to_3(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_cond_greater_than_or_equal_to_3)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_is_not(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_cond_is_not)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_is_or_is_not(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_cond_is_or_is_not)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_less(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_cond_less)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_less_equal(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_cond_less_equal)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_less_equal_2(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_cond_less_equal_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_negated_simple_conditions(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_cond_negated_simple_conditions)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_not_is(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_cond_not_is)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_not_relational_operator_rest(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_cond_not_relational_operator_rest)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_relation_condition(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_cond_relation_condition)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_relational_operator(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_cond_relational_operator)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_relational_operator_rest(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_cond_relational_operator_rest)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_relational_operator_tail(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_cond_relational_operator_tail)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_sign_condition(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_cond_sign_condition)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_sign_type(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_cond_sign_type)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_simple_condition(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_cond_simple_condition)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_simple_condition_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_cond_simple_condition_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_than(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_cond_than)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_alphabet_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_conf_sec_alphabet_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_alphabet_type(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_conf_sec_alphabet_type)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_alphabet_type_also(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_conf_sec_alphabet_type_also)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_alphabet_type_also_through(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_conf_sec_alphabet_type_also_through)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_alphabet_type_alsos(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_conf_sec_alphabet_type_alsos)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_alphabet_type_other(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_conf_sec_alphabet_type_other)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_alphabet_type_others(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_conf_sec_alphabet_type_others)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_are(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_conf_sec_are)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_class_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_conf_sec_class_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_configuration_section(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_conf_sec_configuration_section)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_configuration_section_paragraph(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_conf_sec_configuration_section_paragraph)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_configuration_section_paragraphs(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_conf_sec_configuration_section_paragraphs)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_currency_sign_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_conf_sec_currency_sign_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_decimal_point_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_conf_sec_decimal_point_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_in_alphabet_name(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_conf_sec_in_alphabet_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_is_mnemonic_name(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_conf_sec_is_mnemonic_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_memory_size(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_conf_sec_memory_size)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_memory_size_type(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_conf_sec_memory_size_type)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_object_computer_name(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_conf_sec_object_computer_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_object_computer_paragraph(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_conf_sec_object_computer_paragraph)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_object_computer_paragraph_sequence_phrase(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_conf_sec_object_computer_paragraph_sequence_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_off_status(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_conf_sec_off_status)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_on_status(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_conf_sec_on_status)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_program_collating_sequence(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_conf_sec_program_collating_sequence)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_segment_limit(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_conf_sec_segment_limit)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_source_computer_name(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_conf_sec_source_computer_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_source_computer_paragraph(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_conf_sec_source_computer_paragraph)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_special_names_paragraph(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_conf_sec_special_names_paragraph)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_special_names_paragraph_clause(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_conf_sec_special_names_paragraph_clause)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_special_names_paragraph_clauses(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_conf_sec_special_names_paragraph_clauses)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_special_names_paragraph_phrase(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_conf_sec_special_names_paragraph_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_special_names_paragraph_phrase_tail(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_conf_sec_special_names_paragraph_phrase_tail)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_special_names_paragraph_status_phrase(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_conf_sec_special_names_paragraph_status_phrase)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_special_names_paragraph_status_phrase_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_conf_sec_special_names_paragraph_status_phrase_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_special_names_paragraph_status_phrase_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_conf_sec_special_names_paragraph_status_phrase_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_symbolic_character_mapping(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_conf_sec_symbolic_character_mapping)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_symbolic_characters_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_conf_sec_symbolic_characters_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_with_debugging_mode(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_conf_sec_with_debugging_mode)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_data_div_data_division(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_data_div_data_division)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_data_div_data_division_content(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_data_div_data_division_content)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_data_div_file_section(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_data_div_file_section)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_data_div_file_section_entry(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_data_div_file_section_entry)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_data_div_linkage_section(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_data_div_linkage_section)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_data_div_working_storage_section(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_data_div_working_storage_section)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_alt_data_name_filler(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_dd_entry_alt_data_name_filler)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_alt_leading_trailing(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_dd_entry_alt_leading_trailing)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_alt_left_right(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_dd_entry_alt_left_right)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_blank_when_zero_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_dd_entry_blank_when_zero_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_condition_value_clause(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_dd_entry_condition_value_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_data_description_entry(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_dd_entry_data_description_entry)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_data_description_entry_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_dd_entry_data_description_entry_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_data_description_entry_clause(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_dd_entry_data_description_entry_clause)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_data_description_entry_clauses(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_dd_entry_data_description_entry_clauses)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_external_clause(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_dd_entry_external_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_global_clause(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_dd_entry_global_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_indexed_by(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_dd_entry_indexed_by)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_integer_to(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_dd_entry_integer_to)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_justified(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_dd_entry_justified)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_justified_clause(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_dd_entry_justified_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_occurs_clause(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_dd_entry_occurs_clause)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_occurs_clause_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_dd_entry_occurs_clause_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_occurs_clause_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9)
{
    if (t->fun == TTfunVSC_dd_entry_occurs_clause_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_occurs_clause_key(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_dd_entry_occurs_clause_key)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_picture(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_dd_entry_picture)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_picture_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_dd_entry_picture_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_redefines_clause(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_dd_entry_redefines_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_renames_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_dd_entry_renames_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_separate_character(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_dd_entry_separate_character)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_sign_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_dd_entry_sign_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_sign_is(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_dd_entry_sign_is)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_synchronized(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_dd_entry_synchronized)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_synchronized_clause(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_dd_entry_synchronized_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_usage(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_dd_entry_usage)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_usage_clause(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_dd_entry_usage_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_usage_is(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_dd_entry_usage_is)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_values_are(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_dd_entry_values_are)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_zeroes(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_dd_entry_zeroes)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_env_div_environment_division(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_env_div_environment_division)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_env_div_environment_division_content(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_env_div_environment_division_content)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_alphabet_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_alphabet_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_alphabetic_user_defined_word(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_alphabetic_user_defined_word)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_alt_ascending_descending(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_alt_ascending_descending)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_alt_library_name_literal(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_alt_library_name_literal)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_alt_plus_minus(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_alt_plus_minus)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_alt_reel_unit(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_alt_reel_unit)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_alt_text_name_literal(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_alt_text_name_literal)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_alt_times_div(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_alt_times_div)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_arithmetic_expression(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_arithmetic_expression)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_arithmetic_expression_tail(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_arithmetic_expression_tail)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_assignment_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_assignment_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_basis(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_basis)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_basis_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_expr_basis_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_class_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_class_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_computer_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_computer_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_condition_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_condition_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_copy_operand(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_copy_operand)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_copy_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6)
{
    if (t->fun == TTfunVSC_expr_copy_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_copy_statement_by_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_expr_copy_statement_by_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_copy_statement_replacing_phrase(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_copy_statement_replacing_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_data_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_data_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_data_or_file_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_data_or_file_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_data_or_file_or_mnemonic_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_data_or_file_or_mnemonic_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_environment_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_environment_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_equal_to(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_equal_to)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_equal_to_1(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_equal_to_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_figurative_constant(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_figurative_constant)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_figurative_constant_all(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_figurative_constant_all)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_figurative_constant_simple(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_figurative_constant_simple)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_file_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_file_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_identifier(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_identifier)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_identifier_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_expr_identifier_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_identifier_2(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_identifier_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_in(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_in)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_in_data_or_file_name(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_in_data_or_file_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_in_data_or_file_or_mnemonic_name(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_in_data_or_file_or_mnemonic_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_in_file_name(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_in_file_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_in_library(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_in_library)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_in_section_name(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_in_section_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_index_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_index_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_integer(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_integer)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_leftmost_character_position(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_leftmost_character_position)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_length(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_length)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_level_number(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_level_number)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_library_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_library_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_literal(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_literal)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_literal_through_literal(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_literal_through_literal)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_mnemonic_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_mnemonic_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_numeric(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_numeric)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_paragraph_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_paragraph_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_paragraph_or_section_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_paragraph_or_section_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_plus_minus_integer(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_plus_minus_integer)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_power(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_expr_power)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_power_tail(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_power_tail)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_priority_number(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_priority_number)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_procedure_name(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_procedure_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_program_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_program_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_qualified_data_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_qualified_data_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_qualified_data_name_1(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_qualified_data_name_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_record_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_record_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_records(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_records)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_reference_modification(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_expr_reference_modification)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_section_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_section_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_special_register_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_expr_special_register_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_special_register_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_expr_special_register_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_subscript(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_subscript)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_subscript_expression(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_subscript_expression)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_subscript_expression_ambiguous(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_subscript_expression_ambiguous)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_subscript_parentheses(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_expr_subscript_parentheses)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_symbolic_character(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_symbolic_character)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_system_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_system_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_text_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_text_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_through(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_through)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_through_arithmetic_expression(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_through_arithmetic_expression)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_through_literal(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_through_literal)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_through_qualified_data_name(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_through_qualified_data_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_times_div(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_times_div)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_times_div_tail(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_times_div_tail)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_user_defined_word(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_user_defined_word)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_values(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_values)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_alt_characters_records(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_fd_entry_alt_characters_records)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_alt_data_name_integer(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_fd_entry_alt_data_name_integer)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_alt_fd_sd(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_fd_entry_alt_fd_sd)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_alt_qualified_data_name_literal(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_fd_entry_alt_qualified_data_name_literal)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_block_contains_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_fd_entry_block_contains_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_code_set_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_fd_entry_code_set_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_data_names(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_fd_entry_data_names)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_data_records_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_fd_entry_data_records_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_depending_on(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_fd_entry_depending_on)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_file_and_sort_description_entry(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_fd_entry_file_and_sort_description_entry)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_file_and_sort_description_entry_clause(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_fd_entry_file_and_sort_description_entry_clause)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_file_and_sort_description_entry_clauses(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_fd_entry_file_and_sort_description_entry_clauses)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_footing(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_fd_entry_footing)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_from_integer(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_fd_entry_from_integer)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_label_records_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_fd_entry_label_records_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_label_records_clause_tail(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_fd_entry_label_records_clause_tail)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_linage_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_fd_entry_linage_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_linage_footing_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_fd_entry_linage_footing_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_lines_bottom(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_fd_entry_lines_bottom)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_lines_top(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_fd_entry_lines_top)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_record_clause(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_fd_entry_record_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_record_clause_tail(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_fd_entry_record_clause_tail)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_record_clause_tail_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_fd_entry_record_clause_tail_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_record_clause_tail_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_fd_entry_record_clause_tail_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_record_clause_tail_3(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_fd_entry_record_clause_tail_3)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_record_varying_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7)
{
    if (t->fun == TTfunVSC_fd_entry_record_varying_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_recording_mode_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_fd_entry_recording_mode_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_records_are(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_fd_entry_records_are)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_to_integer(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_fd_entry_to_integer)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_value_of_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_fd_entry_value_of_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_value_of_clause_tail(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_fd_entry_value_of_clause_tail)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_id_div_author(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_id_div_author)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_id_div_date_compiled(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_id_div_date_compiled)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_id_div_date_written(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_id_div_date_written)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_id_div_identification(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_id_div_identification)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_id_div_identification_division(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_id_div_identification_division)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_id_div_identification_division_content(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_id_div_identification_division_content)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_id_div_identification_division_phrase(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_id_div_identification_division_phrase)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_id_div_initial_program(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_id_div_initial_program)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_id_div_installation(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_id_div_installation)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_id_div_program_id_cobol_source_program(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_id_div_program_id_cobol_source_program)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_id_div_remarks(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_id_div_remarks)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_id_div_security(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_id_div_security)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_alt_assignment_name_file_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_io_sec_alt_assignment_name_file_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_alt_assignment_name_literal(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_io_sec_alt_assignment_name_literal)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_alt_indexed_relative_sequential(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_io_sec_alt_indexed_relative_sequential)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_alt_sequential_random_dynamic(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_io_sec_alt_sequential_random_dynamic)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_alternate_record_key_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7)
{
    if (t->fun == TTfunVSC_io_sec_alternate_record_key_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_areas(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_io_sec_areas)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_assign_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_io_sec_assign_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_every_phrase(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_io_sec_every_phrase)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_every_phrase_1(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_io_sec_every_phrase_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_every_phrase_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_io_sec_every_phrase_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_fce_access_mode(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_io_sec_fce_access_mode)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_fce_organization(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_io_sec_fce_organization)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_fce_phrase(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_io_sec_fce_phrase)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_file_control_entry(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_io_sec_file_control_entry)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_file_control_paragraph(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_io_sec_file_control_paragraph)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_file_name_position(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_io_sec_file_name_position)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_file_status_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_io_sec_file_status_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_i_o_control_paragraph(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_io_sec_i_o_control_paragraph)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_i_o_sam(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_io_sec_i_o_sam)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_i_o_sort_merge(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_io_sec_i_o_sort_merge)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_input_output_section(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_io_sec_input_output_section)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_organization_is(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_io_sec_organization_is)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_padding_character_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_io_sec_padding_character_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_password_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_io_sec_password_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_position(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_io_sec_position)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7)
{
    if (t->fun == TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6)
{
    if (t->fun == TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_3(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_3)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_4(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_4)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_record_delimiter_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_io_sec_record_delimiter_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_record_delimiter_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_io_sec_record_delimiter_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_record_key_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_io_sec_record_key_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_record_sort(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_io_sec_record_sort)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_relative_key_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_io_sec_relative_key_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_rerun_on(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_io_sec_rerun_on)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_reserve_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_io_sec_reserve_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_same_area(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6)
{
    if (t->fun == TTfunVSC_io_sec_same_area)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_select_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_io_sec_select_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_sort_merge_i_o_control_entries(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_io_sec_sort_merge_i_o_control_entries)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_with_duplicates(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_io_sec_with_duplicates)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_main_cobol_source_program(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_main_cobol_source_program)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_main_common_initial(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_main_common_initial)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_main_common_initial_1(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_main_common_initial_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_main_common_initial_2(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_main_common_initial_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_main_common_initial_program(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_main_common_initial_program)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_main_nested_cobol_source_program(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9, TTterm *t10, TTterm *t11, TTterm *t12, TTterm *t13)
{
    if (t->fun == TTfunVSC_main_nested_cobol_source_program)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        *t10 = t->u.args[9];
        *t11 = t->u.args[10];
        *t12 = t->u.args[11];
        *t13 = t->u.args[12];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_main_nested_program(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_main_nested_program)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_main_program_id_nested_cobol_source_program(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_main_program_id_nested_cobol_source_program)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_main_programs(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_main_programs)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_altered_goto(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_proc_div_altered_goto)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_declaratives(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6)
{
    if (t->fun == TTfunVSC_proc_div_declaratives)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_declaratives_content(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_proc_div_declaratives_content)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_paragraph(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_proc_div_paragraph)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_paragraph_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_proc_div_paragraph_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_paragraphs(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_proc_div_paragraphs)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_procedure_division(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_proc_div_procedure_division)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_section_header(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_proc_div_section_header)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_section_with_header(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_proc_div_section_with_header)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_sections(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_proc_div_sections)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_sentence(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_proc_div_sentence)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_sentence_1(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_proc_div_sentence_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_sentence_2(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_proc_div_sentence_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_using_data_names(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_proc_div_using_data_names)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_using_phrase(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_proc_div_using_phrase)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_using_phrase_1(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_proc_div_using_phrase_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_using_phrase_2(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_proc_div_using_phrase_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_accept_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_accept_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_accept_statement_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_accept_statement_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_accept_statement_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_accept_statement_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_add_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_add_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_add_statement_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7)
{
    if (t->fun == TTfunVSC_stat_add_statement_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_add_statement_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8)
{
    if (t->fun == TTfunVSC_stat_add_statement_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_add_statement_3(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9)
{
    if (t->fun == TTfunVSC_stat_add_statement_3)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_advancing_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_advancing_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_all_procedures(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_all_procedures)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_also_phrase(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_also_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_all_leading(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_all_leading)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_all_leading_first(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_all_leading_first)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_before_after(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_before_after)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_beginning_ending(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_beginning_ending)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_exception_error(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_exception_error)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_file_names_i_o(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_file_names_i_o)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_file_reel_unit(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_file_reel_unit)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_no_rewind_lock(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_no_rewind_lock)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_procedures_all_procedures(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_procedures_all_procedures)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_removal_no_rewind(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_removal_no_rewind)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_reversed_with_no_rewind(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_reversed_with_no_rewind)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_run_literal(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_run_literal)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_statement_list_next_sentence(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_statement_list_next_sentence)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_up_down(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_up_down)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_up_down_by(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_alt_up_down_by)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alter_statement(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_alter_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_at_end_of_page_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_at_end_of_page_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_at_end_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_at_end_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_before_after_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_before_after_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_by_reference(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_by_reference)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_call_rest_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_call_rest_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_call_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_stat_call_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_cancel_statement(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_cancel_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_close_statement(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_close_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_close_statement_file_name(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_close_statement_file_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_close_statement_options(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_close_statement_options)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_close_statement_options_1(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_close_statement_options_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_close_statement_options_2(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_close_statement_options_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_cobword_int(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_cobword_int)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_cobword_rounded(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_cobword_rounded)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_collating_sequence(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_collating_sequence)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_compute_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7)
{
    if (t->fun == TTfunVSC_stat_compute_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_content_parameter(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_content_parameter)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_content_parameter_value(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_content_parameter_value)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_continue_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_continue_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_corresponding(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_corresponding)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_count_in_identifier(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_count_in_identifier)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_date(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_date)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_delete_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6)
{
    if (t->fun == TTfunVSC_stat_delete_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_delimited_by_all_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_stat_delimited_by_all_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_delimited_by_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_delimited_by_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_delimiter_in_identifier(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_delimiter_in_identifier)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_display_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_display_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_divide_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_divide_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_divide_statement_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7)
{
    if (t->fun == TTfunVSC_stat_divide_statement_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_divide_statement_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9)
{
    if (t->fun == TTfunVSC_stat_divide_statement_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_divide_statement_3(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9)
{
    if (t->fun == TTfunVSC_stat_divide_statement_3)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_divide_statement_4(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9, TTterm *t10, TTterm *t11, TTterm *t12)
{
    if (t->fun == TTfunVSC_stat_divide_statement_4)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        *t10 = t->u.args[9];
        *t11 = t->u.args[10];
        *t12 = t->u.args[11];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_divide_statement_5(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9, TTterm *t10, TTterm *t11, TTterm *t12)
{
    if (t->fun == TTfunVSC_stat_divide_statement_5)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        *t10 = t->u.args[9];
        *t11 = t->u.args[10];
        *t12 = t->u.args[11];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_else_phrase(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_else_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_end_of_page(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_end_of_page)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_entry_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_entry_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_equal(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_equal)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_evaluate_condition(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_evaluate_condition)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_evaluate_phrase(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_evaluate_phrase)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_evaluate_phrase_1(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_evaluate_phrase_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_evaluate_phrase_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_evaluate_phrase_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_evaluate_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6)
{
    if (t->fun == TTfunVSC_stat_evaluate_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_exit_program_statement(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_exit_program_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_exit_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_exit_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_file_names(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_file_names)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_for_removal(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_for_removal)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_from_environment_name(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_from_environment_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_from_identifier(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_from_identifier)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_giving_file_names(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_giving_file_names)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_go_to_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_go_to_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_go_to_statement_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_go_to_statement_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_go_to_statement_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6)
{
    if (t->fun == TTfunVSC_stat_go_to_statement_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_go_to_statement_3(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_go_to_statement_3)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_goback_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_goback_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_id_or_lit(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_id_or_lit)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_id_or_lit_size(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_id_or_lit_size)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_if_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6)
{
    if (t->fun == TTfunVSC_stat_if_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_initialize_replacing_argument(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_initialize_replacing_argument)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_initialize_replacing_phrase(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_initialize_replacing_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_initialize_replacing_type(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_initialize_replacing_type)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_initialize_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_initialize_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_input_procedure(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_stat_input_procedure)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_inspect_by_argument(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_inspect_by_argument)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_inspect_replacing_argument(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_inspect_replacing_argument)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_inspect_replacing_phrase(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_inspect_replacing_phrase)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_inspect_replacing_phrase_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_inspect_replacing_phrase_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_inspect_replacing_phrase_2(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_inspect_replacing_phrase_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_inspect_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_inspect_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_inspect_statement_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_inspect_statement_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_inspect_statement_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7)
{
    if (t->fun == TTfunVSC_stat_inspect_statement_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_inspect_statement_3(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6)
{
    if (t->fun == TTfunVSC_stat_inspect_statement_3)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_inspect_statement_4(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_inspect_statement_4)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_into_identifier(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_into_identifier)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_invalid_key_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_invalid_key_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_key_is(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_key_is)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_key_is_qualified_data_name(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_key_is_qualified_data_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_key_is_rel_op_qualified_data_name(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_key_is_rel_op_qualified_data_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_lines(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_lines)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_merge_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8)
{
    if (t->fun == TTfunVSC_stat_merge_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_merge_statement_tail(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_merge_statement_tail)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_move_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_move_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_move_statement_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_move_statement_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_move_statement_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_stat_move_statement_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_multiply_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_multiply_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_multiply_statement_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7)
{
    if (t->fun == TTfunVSC_stat_multiply_statement_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_multiply_statement_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9)
{
    if (t->fun == TTfunVSC_stat_multiply_statement_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_next_sentence(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_next_sentence)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_no_rewind(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_no_rewind)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_not_at_end_of_page_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_not_at_end_of_page_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_not_at_end_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_not_at_end_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_not_invalid_key_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_not_invalid_key_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_not_on_exception_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_not_on_exception_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_not_on_overflow_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_not_on_overflow_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_not_on_size_error_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_stat_not_on_size_error_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_nr_lines_phrase(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_nr_lines_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_on_exception_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_on_exception_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_on_key_is_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_on_key_is_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_on_key_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_on_key_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_on_overflow_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_on_overflow_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_on_size_error_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_on_size_error_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_open_statement(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_open_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_open_statement_extend(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_open_statement_extend)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_open_statement_i_o(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_open_statement_i_o)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_open_statement_input(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_open_statement_input)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_open_statement_input_file_name(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_open_statement_input_file_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_open_statement_output(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_open_statement_output)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_open_statement_output_file_name(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_open_statement_output_file_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_open_statement_phrase(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_open_statement_phrase)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_or_all_id_or_lit(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_or_all_id_or_lit)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_output_procedure(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_stat_output_procedure)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_page_phrase(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_page_phrase)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_parameter(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_parameter)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_after_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8)
{
    if (t->fun == TTfunVSC_stat_perform_after_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_perform_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_1(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_perform_statement_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_1_alts(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_perform_statement_1_alts)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_1_procedure(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_perform_statement_1_procedure)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_1_statement_list(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_perform_statement_1_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_2(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_perform_statement_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_2_alts(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_perform_statement_2_alts)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_2_procedure(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_perform_statement_2_procedure)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_2_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_perform_statement_2_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_3(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_perform_statement_3)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_3_alts(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_perform_statement_3_alts)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_3_procedure(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_perform_statement_3_procedure)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_3_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_perform_statement_3_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_4(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_perform_statement_4)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_4_alts(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_perform_statement_4_alts)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_4_procedure(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_perform_statement_4_procedure)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_4_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_perform_statement_4_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_until_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_perform_until_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_varying_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9)
{
    if (t->fun == TTfunVSC_stat_perform_varying_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_procedure_names(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_procedure_names)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_procedure_to_procedure(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_procedure_to_procedure)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_proceed_to(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_proceed_to)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_read_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9, TTterm *t10, TTterm *t11)
{
    if (t->fun == TTfunVSC_stat_read_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        *t10 = t->u.args[9];
        *t11 = t->u.args[10];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_reference_parameter(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_reference_parameter)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_rel_op(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_rel_op)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_release_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_release_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_return_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9)
{
    if (t->fun == TTfunVSC_stat_return_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_rewrite_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6)
{
    if (t->fun == TTfunVSC_stat_rewrite_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_search_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_search_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_search_statement_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6)
{
    if (t->fun == TTfunVSC_stat_search_statement_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_search_statement_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9)
{
    if (t->fun == TTfunVSC_stat_search_statement_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_search_statement_condition(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_search_statement_condition)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_search_statement_condition_tail(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_search_statement_condition_tail)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_search_statement_equal_expression(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_search_statement_equal_expression)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_set_oper(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_set_oper)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_set_src(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_set_src)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_set_statement(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_set_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_set_statement_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_set_statement_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_sort_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7)
{
    if (t->fun == TTfunVSC_stat_sort_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_sort_statement_in(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_sort_statement_in)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_sort_statement_out(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_sort_statement_out)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_start_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6)
{
    if (t->fun == TTfunVSC_stat_start_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_statement_list(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_statement_list)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_stop_statement(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_stop_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_string_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8)
{
    if (t->fun == TTfunVSC_stat_string_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_subtract_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_subtract_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_subtract_statement_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7)
{
    if (t->fun == TTfunVSC_stat_subtract_statement_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_subtract_statement_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9)
{
    if (t->fun == TTfunVSC_stat_subtract_statement_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_subtract_statement_3(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9)
{
    if (t->fun == TTfunVSC_stat_subtract_statement_3)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_tallying_argument(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_tallying_argument)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_tallying_for_argument(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_tallying_for_argument)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_tallying_for_argument_1(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_tallying_for_argument_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_tallying_for_argument_2(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_tallying_for_argument_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_tallying_for_id_or_lit(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_tallying_for_id_or_lit)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_tallying_in_identifier(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_tallying_in_identifier)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_through_procedure_name(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_through_procedure_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_to_id_or_lit(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_to_id_or_lit)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_unstring_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9, TTterm *t10)
{
    if (t->fun == TTfunVSC_stat_unstring_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        *t10 = t->u.args[9];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_unstring_statement_dst(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_unstring_statement_dst)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_upon_environment_name(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_upon_environment_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_use_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_use_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_use_statement_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8)
{
    if (t->fun == TTfunVSC_stat_use_statement_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_use_statement_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9, TTterm *t10)
{
    if (t->fun == TTfunVSC_stat_use_statement_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        *t10 = t->u.args[9];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_use_statement_3(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_stat_use_statement_3)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_using_data_name_pluslist(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_using_data_name_pluslist)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_using_file_names(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_using_file_names)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_using_parameters(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_using_parameters)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_varying_identifier(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_varying_identifier)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_when_condition_stats(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_when_condition_stats)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_when_other_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_when_other_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_when_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_when_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_when_phrase_also_phrase(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_when_phrase_also_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_when_phrases(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_when_phrases)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_with_duplicates_in_order(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_with_duplicates_in_order)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_with_no_advancing(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_with_no_advancing)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_with_no_rewind(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_with_no_rewind)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_with_pointer_identifier(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_with_pointer_identifier)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_with_test(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_with_test)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_write_exceptions(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_write_exceptions)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_write_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6)
{
    if (t->fun == TTfunVSC_stat_write_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_lex_picture_string(TTterm t, TTtype_string *t1)
{
    if (t->fun == TTfunVSC_lex_picture_string)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_lex_quoted_pseudo_text(TTterm t, TTtype_string *t1)
{
    if (t->fun == TTfunVSC_lex_quoted_pseudo_text)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_lex_num(TTterm t, TTtype_string *t1)
{
    if (t->fun == TTfunVSC_lex_num)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_lex_nonnumeric(TTterm t, TTtype_string *t1)
{
    if (t->fun == TTfunVSC_lex_nonnumeric)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_lex_cobword(TTterm t, TTtype_string *t1)
{
    if (t->fun == TTfunVSC_lex_cobword)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

