#include <stdio.h>
#include <assert.h>
#include <sys/types.h>
#include "ttterm.h"
#include "ttbuffer.h"
#include "ttutils.h"
#include "ttparse.h"
#include "VSCScan.h"
#include "VSCParse.h"

typedef TTterm(*fparse)(void);

static int init = 0;
static TTterm args[1000];


static TTterm TTparset_END_WRITE_opt(void);
static TTterm TTparset_END_WRITE(void);
static TTterm TTparseVSC_stat_advancing_phrase_opt(void);
static TTterm TTparset_WRITE(void);
static TTterm TTparseVSC_stat_not_at_end_of_page_statement_list_opt(void);
static TTterm TTparseVSC_stat_at_end_of_page_statement_list_opt(void);
static TTterm TTparset_TEST(void);
static TTterm TTparset_ORDER_opt(void);
static TTterm TTparset_ORDER(void);
static TTterm TTparseVSC_stat_when_phrase_plus(void);
static TTterm TTparseVSC_stat_when_phrase_also_phrase_star(void);
static TTterm TTparset_OTHER(void);
static TTterm TTparseVSC_stat_parameter_plus(void);
static TTterm TTparseVSC_stat_alt_file_reel_unit_opt(void);
static TTterm TTparseVSC_stat_alt_beginning_ending_opt(void);
static TTterm TTparset_STANDARD_opt(void);
static TTterm TTparset_GLOBAL_opt(void);
static TTterm TTparset_USE(void);
static TTterm TTparset_UPON(void);
static TTterm TTparseVSC_stat_count_in_identifier_opt(void);
static TTterm TTparseVSC_stat_delimiter_in_identifier_opt(void);
static TTterm TTparset_END_UNSTRING_opt(void);
static TTterm TTparset_END_UNSTRING(void);
static TTterm TTparseVSC_stat_tallying_in_identifier_opt(void);
static TTterm TTparseVSC_stat_unstring_statement_dst_plus(void);
static TTterm TTparseVSC_stat_delimited_by_all_phrase_opt(void);
static TTterm TTparset_UNSTRING(void);
static TTterm TTparseVSC_stat_tallying_for_id_or_lit_plus(void);
static TTterm TTparseVSC_stat_tallying_for_argument_plus(void);
static TTterm TTparset_END_SUBTRACT_opt(void);
static TTterm TTparset_END_SUBTRACT(void);
static TTterm TTparset_SUBTRACT(void);
static TTterm TTparset_END_STRING_opt(void);
static TTterm TTparset_END_STRING(void);
static TTterm TTparseVSC_stat_not_on_overflow_statement_list_opt(void);
static TTterm TTparseVSC_stat_with_pointer_identifier_opt(void);
static TTterm TTparseVSC_stat_delimited_by_phrase_plus(void);
static TTterm TTparset_STRING(void);
static TTterm TTparset_STOP(void);
static TTterm TTparseVSC_stat_statement_plus(void);
static TTterm TTparset_END_START_opt(void);
static TTterm TTparset_END_START(void);
static TTterm TTparseVSC_stat_key_is_rel_op_qualified_data_name_opt(void);
static TTterm TTparset_START(void);
static TTterm TTparseVSC_stat_with_duplicates_in_order_opt(void);
static TTterm TTparseVSC_stat_on_key_is_phrase_plus(void);
static TTterm TTparseVSC_stat_set_statement_phrase_plus(void);
static TTterm TTparset_SET(void);
static TTterm TTparseVSC_stat_search_statement_condition_tail_star(void);
static TTterm TTparset_END_SEARCH_opt(void);
static TTterm TTparset_END_SEARCH(void);
static TTterm TTparseVSC_stat_when_condition_stats_plus(void);
static TTterm TTparseVSC_stat_varying_identifier_opt(void);
static TTterm TTparset_SEARCH(void);
static TTterm TTparset_END_REWRITE_opt(void);
static TTterm TTparset_END_REWRITE(void);
static TTterm TTparset_REWRITE(void);
static TTterm TTparset_END_RETURN_opt(void);
static TTterm TTparset_END_RETURN(void);
static TTterm TTparset_RETURN(void);
static TTterm TTparseVSC_stat_from_identifier_opt(void);
static TTterm TTparset_RELEASE(void);
static TTterm TTparseVSC_stat_by_reference_opt(void);
static TTterm TTparset_END_READ_opt(void);
static TTterm TTparset_END_READ(void);
static TTterm TTparseVSC_stat_not_at_end_statement_list_opt(void);
static TTterm TTparseVSC_stat_at_end_statement_list_opt(void);
static TTterm TTparseVSC_stat_key_is_qualified_data_name_opt(void);
static TTterm TTparseVSC_stat_into_identifier_opt(void);
static TTterm TTparset_NEXT_opt(void);
static TTterm TTparset_READ(void);
static TTterm TTparset_PROCEED(void);
static TTterm TTparseVSC_stat_proceed_to_opt(void);
static TTterm TTparseVSC_stat_with_test_opt(void);
static TTterm TTparseVSC_stat_perform_after_phrase_star(void);
static TTterm TTparset_END_PERFORM(void);
static TTterm TTparset_PERFORM(void);
static TTterm TTparset_UNTIL(void);
static TTterm TTparset_PAGE(void);
static TTterm TTparseVSC_stat_with_no_rewind_opt(void);
static TTterm TTparseVSC_stat_open_statement_output_file_name_plus(void);
static TTterm TTparseVSC_stat_alt_reversed_with_no_rewind_opt(void);
static TTterm TTparseVSC_stat_open_statement_input_file_name_plus(void);
static TTterm TTparseVSC_stat_open_statement_phrase_plus(void);
static TTterm TTparset_OPEN(void);
static TTterm TTparseVSC_stat_key_is_opt(void);
static TTterm TTparseVSC_stat_lines_opt(void);
static TTterm TTparset_OVERFLOW(void);
static TTterm TTparset_REWIND(void);
static TTterm TTparset_NO(void);
static TTterm TTparset_SENTENCE(void);
static TTterm TTparset_NEXT(void);
static TTterm TTparset_END_MULTIPLY_opt(void);
static TTterm TTparset_END_MULTIPLY(void);
static TTterm TTparset_MULTIPLY(void);
static TTterm TTparset_MOVE(void);
static TTterm TTparseVSC_stat_collating_sequence_opt(void);
static TTterm TTparseVSC_stat_on_key_phrase_plus(void);
static TTterm TTparset_MERGE(void);
static TTterm TTparset_LINE(void);
static TTterm TTparset_INVALID(void);
static TTterm TTparseVSC_stat_inspect_replacing_phrase_plus(void);
static TTterm TTparset_CONVERTING(void);
static TTterm TTparseVSC_stat_tallying_argument_plus(void);
static TTterm TTparset_TALLYING(void);
static TTterm TTparset_INSPECT(void);
static TTterm TTparseVSC_stat_inspect_replacing_argument_plus(void);
static TTterm TTparseVSC_stat_before_after_phrase_star(void);
static TTterm TTparseVSC_stat_through_procedure_name_opt(void);
static TTterm TTparseVSC_stat_initialize_replacing_phrase_opt(void);
static TTterm TTparseVSC_expr_identifier_plus(void);
static TTterm TTparset_INITIALIZE(void);
static TTterm TTparset_EGCS(void);
static TTterm TTparset_NUMERIC_EDITED(void);
static TTterm TTparset_ALPHANUMERIC_EDITED(void);
static TTterm TTparset_ALPHANUMERIC(void);
static TTterm TTparseVSC_stat_initialize_replacing_argument_plus(void);
static TTterm TTparset_DATA_opt(void);
static TTterm TTparset_END_IF_opt(void);
static TTterm TTparset_END_IF(void);
static TTterm TTparseVSC_stat_else_phrase_opt(void);
static TTterm TTparset_IF(void);
static TTterm TTparset_GOBACK(void);
static TTterm TTparset_MORE_LABELS(void);
static TTterm TTparseVSC_expr_procedure_name_plus(void);
static TTterm TTparset_REMOVAL(void);
static TTterm TTparset_EXIT(void);
static TTterm TTparset_END_EVALUATE_opt(void);
static TTterm TTparset_END_EVALUATE(void);
static TTterm TTparseVSC_stat_when_other_phrase_opt(void);
static TTterm TTparseVSC_stat_when_phrases_plus(void);
static TTterm TTparseVSC_stat_also_phrase_star(void);
static TTterm TTparset_EVALUATE(void);
static TTterm TTparset_ANY(void);
static TTterm TTparset_FALSE(void);
static TTterm TTparset_TRUE(void);
static TTterm TTparset_ENTRY(void);
static TTterm TTparset_EOP(void);
static TTterm TTparset_END_OF_PAGE(void);
static TTterm TTparset_ELSE(void);
static TTterm TTparset_REMAINDER(void);
static TTterm TTparset_END_DIVIDE_opt(void);
static TTterm TTparset_END_DIVIDE(void);
static TTterm TTparset_INTO(void);
static TTterm TTparset_DIVIDE(void);
static TTterm TTparseVSC_stat_with_no_advancing_opt(void);
static TTterm TTparseVSC_stat_upon_environment_name_opt(void);
static TTterm TTparseVSC_stat_or_all_id_or_lit_star(void);
static TTterm TTparset_ALL_opt(void);
static TTterm TTparset_DELIMITED(void);
static TTterm TTparset_END_DELETE_opt(void);
static TTterm TTparset_END_DELETE(void);
static TTterm TTparseVSC_stat_not_invalid_key_statement_list_opt(void);
static TTterm TTparseVSC_stat_invalid_key_statement_list_opt(void);
static TTterm TTparset_DELETE(void);
static TTterm TTparset_TIME(void);
static TTterm TTparset_DAY_OF_WEEK(void);
static TTterm TTparset_DAY(void);
static TTterm TTparset_DATE(void);
static TTterm TTparset_COUNT(void);
static TTterm TTparset_CORR(void);
static TTterm TTparset_CORRESPONDING(void);
static TTterm TTparset_CONTINUE(void);
static TTterm TTparseVSC_stat_content_parameter_value_plus(void);
static TTterm TTparset_CONTENT(void);
static TTterm TTparset_END_COMPUTE_opt(void);
static TTterm TTparset_END_COMPUTE(void);
static TTterm TTparset_COMPUTE(void);
static TTterm TTparseVSC_stat_alt_removal_no_rewind_opt(void);
static TTterm TTparseVSC_stat_close_statement_options_opt(void);
static TTterm TTparseVSC_stat_close_statement_file_name_plus(void);
static TTterm TTparset_CLOSE(void);
static TTterm TTparset_CANCEL(void);
static TTterm TTparset_END_CALL_opt(void);
static TTterm TTparset_END_CALL(void);
static TTterm TTparseVSC_stat_using_parameters_opt(void);
static TTterm TTparset_CALL(void);
static TTterm TTparseVSC_stat_on_overflow_statement_list_opt(void);
static TTterm TTparseVSC_stat_not_on_exception_statement_list_opt(void);
static TTterm TTparseVSC_stat_on_exception_statement_list_opt(void);
static TTterm TTparset_REFERENCE(void);
static TTterm TTparseVSC_stat_procedure_to_procedure_plus(void);
static TTterm TTparset_ALTER(void);
static TTterm TTparset_DOWN(void);
static TTterm TTparset_UP(void);
static TTterm TTparset_RUN(void);
static TTterm TTparset_REVERSED(void);
static TTterm TTparset_LOCK(void);
static TTterm TTparset_EXTEND(void);
static TTterm TTparset_I_O(void);
static TTterm TTparset_OUTPUT(void);
static TTterm TTparset_INPUT(void);
static TTterm TTparset_ERROR(void);
static TTterm TTparset_EXCEPTION(void);
static TTterm TTparset_ENDING(void);
static TTterm TTparset_BEGINNING(void);
static TTterm TTparset_AFTER(void);
static TTterm TTparset_BEFORE(void);
static TTterm TTparset_FIRST(void);
static TTterm TTparset_PROCEDURES(void);
static TTterm TTparset_ADVANCING_opt(void);
static TTterm TTparset_ADVANCING(void);
static TTterm TTparset_ROUNDED_opt(void);
static TTterm TTparset_ROUNDED(void);
static TTterm TTparset_GIVING(void);
static TTterm TTparseVSC_stat_to_id_or_lit_opt(void);
static TTterm TTparset_END_ADD_opt(void);
static TTterm TTparset_END_ADD(void);
static TTterm TTparseVSC_stat_not_on_size_error_statement_list_opt(void);
static TTterm TTparseVSC_stat_on_size_error_statement_list_opt(void);
static TTterm TTparseVSC_stat_cobword_rounded_plus(void);
static TTterm TTparseVSC_stat_id_or_lit_plus(void);
static TTterm TTparset_ADD(void);
static TTterm TTparseVSC_stat_from_environment_name_opt(void);
static TTterm TTparset_ACCEPT(void);
static TTterm TTparseVSC_proc_div_using_data_names_opt(void);
static TTterm TTparseVSC_stat_using_data_name_pluslist_opt(void);
static TTterm TTparseVSC_expr_data_name_star(void);
static TTterm TTparset_USING(void);
static TTterm TTparseVSC_stat_statement_list_opt(void);
static TTterm TTparset_qdot_plus(void);
static TTterm TTparseVSC_proc_div_section_with_header_star(void);
static TTterm TTparseVSC_expr_priority_number_opt(void);
static TTterm TTparseVSC_proc_div_declaratives_opt(void);
static TTterm TTparset_PROCEDURE(void);
static TTterm TTparseVSC_proc_div_paragraph_star(void);
static TTterm TTparseVSC_proc_div_sentence_star(void);
static TTterm TTparseVSC_proc_div_declaratives_content_plus(void);
static TTterm TTparset_DECLARATIVES(void);
static TTterm TTparset_GO(void);
static TTterm TTparseVSC_main_cobol_source_program_plus(void);
static TTterm TTparseVSC_main_common_initial_program_opt(void);
static TTterm TTparseVSC_main_nested_cobol_source_program_star(void);
static TTterm TTparseVSC_id_div_identification_division_content_opt(void);
static TTterm TTparset_COMMON_opt(void);
static TTterm TTparset_INITIAL_opt(void);
static TTterm TTparset_COMMON(void);
static TTterm TTparseVSC_main_nested_program_opt(void);
static TTterm TTparseVSC_proc_div_procedure_division_opt(void);
static TTterm TTparseVSC_data_div_data_division_opt(void);
static TTterm TTparseVSC_env_div_environment_division_opt(void);
static TTterm TTparset_DUPLICATES(void);
static TTterm TTparseVSC_io_sec_same_area_plus(void);
static TTterm TTparseVSC_io_sec_rerun_on_opt(void);
static TTterm TTparset_OPTIONAL_opt(void);
static TTterm TTparset_OPTIONAL(void);
static TTterm TTparset_SELECT(void);
static TTterm TTparseVSC_io_sec_areas_opt(void);
static TTterm TTparset_RESERVE(void);
static TTterm TTparset_SORT_MERGE(void);
static TTterm TTparset_SORT(void);
static TTterm TTparset_DELIMITER(void);
static TTterm TTparset_WRITE_ONLY(void);
static TTterm TTparset_APPLY(void);
static TTterm TTparseVSC_io_sec_file_name_position_plus(void);
static TTterm TTparset_TAPE_opt(void);
static TTterm TTparset_TAPE(void);
static TTterm TTparset_MULTIPLE(void);
static TTterm TTparseVSC_expr_file_name_plus(void);
static TTterm TTparset_FOR_opt(void);
static TTterm TTparset_FOR(void);
static TTterm TTparset_AREA_opt(void);
static TTterm TTparset_SAME(void);
static TTterm TTparset_EVERY_opt(void);
static TTterm TTparset_EVERY(void);
static TTterm TTparset_RERUN(void);
static TTterm TTparset_POSITION(void);
static TTterm TTparset_PASSWORD(void);
static TTterm TTparset_PADDING(void);
static TTterm TTparset_ORGANIZATION(void);
static TTterm TTparseVSC_io_sec_i_o_control_paragraph_opt(void);
static TTterm TTparseVSC_io_sec_file_control_paragraph_opt(void);
static TTterm TTparset_INPUT_OUTPUT(void);
static TTterm TTparseVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_plus(void);
static TTterm TTparseVSC_io_sec_i_o_sort_merge_opt(void);
static TTterm TTparseVSC_io_sec_i_o_sam_opt(void);
static TTterm TTparset_I_O_CONTROL(void);
static TTterm TTparseVSC_expr_qualified_data_name_opt(void);
static TTterm TTparset_FILE_opt(void);
static TTterm TTparseVSC_io_sec_position_opt(void);
static TTterm TTparseVSC_io_sec_file_control_entry_star(void);
static TTterm TTparset_FILE_CONTROL(void);
static TTterm TTparseVSC_io_sec_fce_phrase_star(void);
static TTterm TTparseVSC_io_sec_organization_is_opt(void);
static TTterm TTparseVSC_io_sec_relative_key_clause_opt(void);
static TTterm TTparset_ACCESS(void);
static TTterm TTparset_OF_opt(void);
static TTterm TTparset_END(void);
static TTterm TTparseVSC_io_sec_alt_assignment_name_literal_plus(void);
static TTterm TTparset_ASSIGN(void);
static TTterm TTparset_AREAS(void);
static TTterm TTparset_AREA(void);
static TTterm TTparseVSC_io_sec_with_duplicates_opt(void);
static TTterm TTparseVSC_io_sec_password_clause_opt(void);
static TTterm TTparset_RECORD_opt(void);
static TTterm TTparset_ALTERNATE(void);
static TTterm TTparset_DYNAMIC(void);
static TTterm TTparset_RANDOM(void);
static TTterm TTparset_SEQUENTIAL(void);
static TTterm TTparset_RELATIVE(void);
static TTterm TTparset_SECURITY(void);
static TTterm TTparset_REMARKS(void);
static TTterm TTparseVSC_id_div_initial_program_opt(void);
static TTterm TTparset_PROGRAM_ID(void);
static TTterm TTparset_INSTALLATION(void);
static TTterm TTparset_INITIAL(void);
static TTterm TTparseVSC_id_div_identification_division_phrase_star(void);
static TTterm TTparset_ID(void);
static TTterm TTparset_IDENTIFICATION(void);
static TTterm TTparset_DATE_WRITTEN(void);
static TTterm TTparset_DATE_COMPILED(void);
static TTterm TTparset_AUTHOR(void);
static TTterm TTparseVSC_fd_entry_value_of_clause_tail_plus(void);
static TTterm TTparset_MODE_opt(void);
static TTterm TTparset_RECORDING(void);
static TTterm TTparseVSC_fd_entry_to_integer_opt(void);
static TTterm TTparseVSC_fd_entry_from_integer_opt(void);
static TTterm TTparset_IN_opt(void);
static TTterm TTparset_VARYING(void);
static TTterm TTparseVSC_fd_entry_depending_on_opt(void);
static TTterm TTparset_TOP(void);
static TTterm TTparset_BOTTOM(void);
static TTterm TTparseVSC_fd_entry_lines_bottom_opt(void);
static TTterm TTparseVSC_fd_entry_lines_top_opt(void);
static TTterm TTparseVSC_fd_entry_footing_opt(void);
static TTterm TTparset_LINES_opt(void);
static TTterm TTparset_LINES(void);
static TTterm TTparset_LINAGE(void);
static TTterm TTparset_OMITTED(void);
static TTterm TTparset_STANDARD(void);
static TTterm TTparset_LABEL(void);
static TTterm TTparset_FROM_opt(void);
static TTterm TTparset_FROM(void);
static TTterm TTparset_AT_opt(void);
static TTterm TTparset_AT(void);
static TTterm TTparset_FOOTING(void);
static TTterm TTparseVSC_fd_entry_file_and_sort_description_entry_clause_star(void);
static TTterm TTparseVSC_expr_data_name_plus(void);
static TTterm TTparset_CODE_SET(void);
static TTterm TTparseVSC_fd_entry_alt_characters_records_opt(void);
static TTterm TTparset_CONTAINS_opt(void);
static TTterm TTparset_CONTAINS(void);
static TTterm TTparset_BLOCK(void);
static TTterm TTparset_SD(void);
static TTterm TTparset_FD(void);
static TTterm TTparset_VALUES(void);
static TTterm TTparset_VALUE(void);
static TTterm TTparseVSC_expr_times_div_tail_star(void);
static TTterm TTparset_THRU(void);
static TTterm TTparset_THROUGH(void);
static TTterm TTparseVSC_expr_plus_minus_integer_opt(void);
static TTterm TTparseVSC_expr_subscript_expression_plus(void);
static TTterm TTparset_LENGTH(void);
static TTterm TTparset_ADDRESS(void);
static TTterm TTparseVSC_expr_length_opt(void);
static TTterm TTparset_qcolon(void);
static TTterm TTparset_RECORDS(void);
static TTterm TTparset_RECORD(void);
static TTterm TTparseVSC_expr_in_data_or_file_name_star(void);
static TTterm TTparseVSC_expr_in_section_name_opt(void);
static TTterm TTparset_qmultiply_qmultiply(void);
static TTterm TTparseVSC_expr_power_tail_star(void);
static TTterm TTparseVSC_expr_alt_plus_minus_opt(void);
static TTterm TTparseVSC_expr_through_literal_opt(void);
static TTterm TTparset_OF(void);
static TTterm TTparseVSC_expr_in_file_name_opt(void);
static TTterm TTparset_LINAGE_COUNTER(void);
static TTterm TTparseVSC_expr_reference_modification_opt(void);
static TTterm TTparset_NULLS(void);
static TTterm TTparset_NULL(void);
static TTterm TTparset_QUOTES(void);
static TTterm TTparset_QUOTE(void);
static TTterm TTparset_LOW_VALUES(void);
static TTterm TTparset_LOW_VALUE(void);
static TTterm TTparset_HIGH_VALUES(void);
static TTterm TTparset_HIGH_VALUE(void);
static TTterm TTparset_SPACES(void);
static TTterm TTparset_SPACE(void);
static TTterm TTparset_ALL(void);
static TTterm TTparseVSC_expr_copy_statement_by_phrase_plus(void);
static TTterm TTparset_REPLACING(void);
static TTterm TTparseVSC_expr_copy_statement_replacing_phrase_opt(void);
static TTterm TTparset_SUPPRESS_opt(void);
static TTterm TTparset_SUPPRESS(void);
static TTterm TTparseVSC_expr_in_library_opt(void);
static TTterm TTparset_COPY(void);
static TTterm TTparseVSC_expr_arithmetic_expression_tail_star(void);
static TTterm TTparset_qdivide(void);
static TTterm TTparset_qmultiply(void);
static TTterm TTparset_UNIT(void);
static TTterm TTparset_REEL(void);
static TTterm TTparset__(void);
static TTterm TTparset_qplus(void);
static TTterm TTparset_DESCENDING(void);
static TTterm TTparset_ASCENDING(void);
static TTterm TTparseVSC_io_sec_input_output_section_opt(void);
static TTterm TTparseVSC_conf_sec_configuration_section_opt(void);
static TTterm TTparset_ENVIRONMENT(void);
static TTterm TTparset_USAGE(void);
static TTterm TTparseVSC_dd_entry_usage_is_opt(void);
static TTterm TTparset_POINTER(void);
static TTterm TTparset_PACKED_DECIMAL(void);
static TTterm TTparset_INDEX(void);
static TTterm TTparset_DISPLAY_1(void);
static TTterm TTparset_DISPLAY(void);
static TTterm TTparset_COMPUTATIONAL_4(void);
static TTterm TTparset_COMPUTATIONAL_3(void);
static TTterm TTparset_COMPUTATIONAL_2(void);
static TTterm TTparset_COMPUTATIONAL_1(void);
static TTterm TTparset_COMPUTATIONAL(void);
static TTterm TTparset_COMP_4(void);
static TTterm TTparset_COMP_3(void);
static TTterm TTparset_COMP_2(void);
static TTterm TTparset_COMP_1(void);
static TTterm TTparset_COMP(void);
static TTterm TTparset_BINARY(void);
static TTterm TTparseVSC_dd_entry_alt_left_right_opt(void);
static TTterm TTparset_SYNC(void);
static TTterm TTparset_SYNCHRONIZED(void);
static TTterm TTparseVSC_dd_entry_separate_character_opt(void);
static TTterm TTparseVSC_dd_entry_sign_is_opt(void);
static TTterm TTparset_CHARACTER_opt(void);
static TTterm TTparset_CHARACTER(void);
static TTterm TTparset_SEPARATE(void);
static TTterm TTparseVSC_expr_through_qualified_data_name_opt(void);
static TTterm TTparset_RENAMES(void);
static TTterm TTparset_REDEFINES(void);
static TTterm TTparset_PIC(void);
static TTterm TTparset_PICTURE(void);
static TTterm TTparseVSC_expr_qualified_data_name_plus(void);
static TTterm TTparset_KEY_opt(void);
static TTterm TTparset_KEY(void);
static TTterm TTparset_ON_opt(void);
static TTterm TTparset_DEPENDING(void);
static TTterm TTparseVSC_dd_entry_integer_to_opt(void);
static TTterm TTparseVSC_dd_entry_indexed_by_opt(void);
static TTterm TTparseVSC_dd_entry_occurs_clause_key_star(void);
static TTterm TTparset_TIMES_opt(void);
static TTterm TTparset_TIMES(void);
static TTterm TTparset_OCCURS(void);
static TTterm TTparset_RIGHT_opt(void);
static TTterm TTparset_JUST(void);
static TTterm TTparset_JUSTIFIED(void);
static TTterm TTparseVSC_expr_index_name_plus(void);
static TTterm TTparset_BY_opt(void);
static TTterm TTparset_BY(void);
static TTterm TTparset_INDEXED(void);
static TTterm TTparset_GLOBAL(void);
static TTterm TTparset_EXTERNAL(void);
static TTterm TTparseVSC_dd_entry_data_description_entry_clause_star(void);
static TTterm TTparseVSC_dd_entry_alt_data_name_filler_opt(void);
static TTterm TTparset_WHEN_opt(void);
static TTterm TTparset_WHEN(void);
static TTterm TTparset_BLANK(void);
static TTterm TTparset_RIGHT(void);
static TTterm TTparset_LEFT(void);
static TTterm TTparset_TRAILING(void);
static TTterm TTparset_LEADING(void);
static TTterm TTparset_FILLER(void);
static TTterm TTparset_WORKING_STORAGE(void);
static TTterm TTparseVSC_dd_entry_data_description_entry_star(void);
static TTterm TTparset_LINKAGE(void);
static TTterm TTparseVSC_dd_entry_data_description_entry_plus(void);
static TTterm TTparseVSC_data_div_file_section_entry_star(void);
static TTterm TTparset_FILE(void);
static TTterm TTparseVSC_data_div_linkage_section_opt(void);
static TTterm TTparseVSC_data_div_working_storage_section_opt(void);
static TTterm TTparseVSC_data_div_file_section_opt(void);
static TTterm TTparset_DIVISION(void);
static TTterm TTparset_DATA(void);
static TTterm TTparset_MODE(void);
static TTterm TTparset_DEBUGGING(void);
static TTterm TTparset_WITH_opt(void);
static TTterm TTparset_WITH(void);
static TTterm TTparseVSC_conf_sec_in_alphabet_name_opt(void);
static TTterm TTparseVSC_conf_sec_symbolic_character_mapping_plus(void);
static TTterm TTparset_CHARACTERS_opt(void);
static TTterm TTparset_SYMBOLIC(void);
static TTterm TTparseVSC_expr_integer_plus(void);
static TTterm TTparseVSC_conf_sec_are_opt(void);
static TTterm TTparseVSC_expr_symbolic_character_plus(void);
static TTterm TTparseVSC_conf_sec_on_status_opt(void);
static TTterm TTparseVSC_conf_sec_off_status_opt(void);
static TTterm TTparseVSC_conf_sec_special_names_paragraph_clause_star(void);
static TTterm TTparset_qdot_opt(void);
static TTterm TTparseVSC_conf_sec_special_names_paragraph_phrase_star(void);
static TTterm TTparset_SPECIAL_NAMES(void);
static TTterm TTparseVSC_conf_sec_source_computer_name_opt(void);
static TTterm TTparset_SOURCE_COMPUTER(void);
static TTterm TTparseVSC_conf_sec_with_debugging_mode_opt(void);
static TTterm TTparset_SEGMENT_LIMIT(void);
static TTterm TTparset_SEQUENCE(void);
static TTterm TTparset_COLLATING_opt(void);
static TTterm TTparset_COLLATING(void);
static TTterm TTparset_PROGRAM_opt(void);
static TTterm TTparset_PROGRAM(void);
static TTterm TTparset_ON(void);
static TTterm TTparset_STATUS_opt(void);
static TTterm TTparset_STATUS(void);
static TTterm TTparset_OFF(void);
static TTterm TTparseVSC_conf_sec_segment_limit_opt(void);
static TTterm TTparseVSC_conf_sec_program_collating_sequence_opt(void);
static TTterm TTparseVSC_conf_sec_object_computer_name_opt(void);
static TTterm TTparset_OBJECT_COMPUTER(void);
static TTterm TTparseVSC_conf_sec_memory_size_opt(void);
static TTterm TTparset_MODULES(void);
static TTterm TTparset_CHARACTERS(void);
static TTterm TTparset_WORDS(void);
static TTterm TTparset_SIZE_opt(void);
static TTterm TTparset_SIZE(void);
static TTterm TTparset_MEMORY(void);
static TTterm TTparseVSC_conf_sec_special_names_paragraph_status_phrase_opt(void);
static TTterm TTparset_IN(void);
static TTterm TTparset_COMMA(void);
static TTterm TTparset_DECIMAL_POINT(void);
static TTterm TTparset_SIGN_opt(void);
static TTterm TTparset_SIGN(void);
static TTterm TTparset_CURRENCY(void);
static TTterm TTparseVSC_conf_sec_configuration_section_paragraph_star(void);
static TTterm TTparset_qdot(void);
static TTterm TTparset_SECTION(void);
static TTterm TTparset_CONFIGURATION(void);
static TTterm TTparseVSC_expr_literal_through_literal_plus(void);
static TTterm TTparset_CLASS(void);
static TTterm TTparset_ARE(void);
static TTterm TTparseVSC_conf_sec_alphabet_type_other_plus(void);
static TTterm TTparseVSC_conf_sec_alphabet_type_also_through_opt(void);
static TTterm TTparseVSC_conf_sec_alphabet_type_also_plus(void);
static TTterm TTparset_ALSO(void);
static TTterm TTparset_EBCDIC(void);
static TTterm TTparset_NATIVE(void);
static TTterm TTparset_STANDARD_2(void);
static TTterm TTparset_STANDARD_1(void);
static TTterm TTparset_ALPHABET(void);
static TTterm TTparset_THEN_opt(void);
static TTterm TTparset_THEN(void);
static TTterm TTparset_qpclose(void);
static TTterm TTparset_qpopen(void);
static TTterm TTparset_ZEROS(void);
static TTterm TTparset_ZEROES(void);
static TTterm TTparset_ZERO(void);
static TTterm TTparset_NEGATIVE(void);
static TTterm TTparset_POSITIVE(void);
static TTterm TTparset_qequal(void);
static TTterm TTparset_NOT_opt(void);
static TTterm TTparset_IS_opt(void);
static TTterm TTparset_IS(void);
static TTterm TTparset_qlt(void);
static TTterm TTparset_LESS(void);
static TTterm TTparset_NOT(void);
static TTterm TTparset_qgt_qequal(void);
static TTterm TTparset_THAN_opt(void);
static TTterm TTparset_THAN(void);
static TTterm TTparset_qgt(void);
static TTterm TTparset_TO_opt(void);
static TTterm TTparset_TO(void);
static TTterm TTparset_EQUAL(void);
static TTterm TTparset_GREATER(void);
static TTterm TTparseVSC_expr_subscript_parentheses_star(void);
static TTterm TTparseVSC_expr_in_data_or_file_or_mnemonic_name_star(void);
static TTterm TTparseVSC_cond_and_or_combinable_condition_plus(void);
static TTterm TTparset_KANJI(void);
static TTterm TTparset_DBCS(void);
static TTterm TTparset_ALPHABETIC_UPPER(void);
static TTterm TTparset_ALPHABETIC_LOWER(void);
static TTterm TTparset_ALPHABETIC(void);
static TTterm TTparset_NUMERIC(void);
static TTterm TTparseVSC_cond_relational_operator_opt(void);
static TTterm TTparset_OR(void);
static TTterm TTparset_AND(void);

TTterm
TTparseVSC_cond_alt_and_or( void )
{
    fparse fs[2];
    fs[0] = TTparset_AND;
    fs[1] = TTparset_OR;
    return TTparseVSC_DISJUNCTION(TTfunVSC_cond_alt_and_or, 2, fs);
}

TTterm
TTparseVSC_cond_and_or_combinable_condition( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_cond_alt_and_or;
    fs[1] = TTparseVSC_cond_relational_operator_opt;
    fs[2] = TTparseVSC_cond_combinable_condition;
    return TTparseVSC_CONJUNCTION(TTfunVSC_cond_and_or_combinable_condition, fs);
}

TTterm
TTparseVSC_cond_class_condition( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_expr_identifier;
    fs[1] = TTparseVSC_cond_is_or_is_not;
    fs[2] = TTparseVSC_cond_class_type;
    return TTparseVSC_CONJUNCTION(TTfunVSC_cond_class_condition, fs);
}

TTterm
TTparseVSC_cond_class_type( void )
{
    fparse fs[7];
    fs[0] = TTparset_NUMERIC;
    fs[1] = TTparset_ALPHABETIC;
    fs[2] = TTparset_ALPHABETIC_LOWER;
    fs[3] = TTparset_ALPHABETIC_UPPER;
    fs[4] = TTparseVSC_expr_class_name;
    fs[5] = TTparset_DBCS;
    fs[6] = TTparset_KANJI;
    return TTparseVSC_DISJUNCTION(TTfunVSC_cond_class_type, 7, fs);
}

TTterm
TTparseVSC_cond_combinable_condition( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_cond_simple_condition;
    fs[1] = TTparseVSC_cond_negated_simple_conditions;
    return TTparseVSC_DISJUNCTION(TTfunVSC_cond_combinable_condition, 2, fs);
}

TTterm
TTparseVSC_cond_combined_conditions( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_cond_combinable_condition;
    fs[1] = TTparseVSC_cond_and_or_combinable_condition_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_cond_combined_conditions, fs);
}

TTterm
TTparseVSC_cond_condition( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_cond_combined_conditions;
    fs[1] = TTparseVSC_cond_combinable_condition;
    return TTparseVSC_DISJUNCTION(TTfunVSC_cond_condition, 2, fs);
}

TTterm
TTparseVSC_cond_condition_name_reference( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_expr_condition_name;
    fs[1] = TTparseVSC_expr_in_data_or_file_or_mnemonic_name_star;
    fs[2] = TTparseVSC_expr_subscript_parentheses_star;
    return TTparseVSC_CONJUNCTION(TTfunVSC_cond_condition_name_reference, fs);
}

TTterm
TTparseVSC_cond_greater( void )
{
    fparse fs[2];

    fs[0] = TTparset_GREATER;
    fs[1] = TTparseVSC_cond_than;
    return TTparseVSC_CONJUNCTION(TTfunVSC_cond_greater, fs);
}

TTterm
TTparseVSC_cond_greater_equal( void )
{
    fparse fs[5];

    fs[0] = TTparset_GREATER;
    fs[1] = TTparseVSC_cond_than;
    fs[2] = TTparset_OR;
    fs[3] = TTparset_EQUAL;
    fs[4] = TTparset_TO_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_cond_greater_equal, fs);
}

TTterm
TTparseVSC_cond_greater_than( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_cond_greater_than_1;
    fs[1] = TTparset_qgt;
    return TTparseVSC_DISJUNCTION(TTfunVSC_cond_greater_than, 2, fs);
}

TTterm
TTparseVSC_cond_greater_than_1( void )
{
    fparse fs[2];

    fs[0] = TTparset_GREATER;
    fs[1] = TTparset_THAN_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_cond_greater_than_1, fs);
}

TTterm
TTparseVSC_cond_greater_than_or_equal_to( void )
{
    fparse fs[4];
    fs[0] = TTparseVSC_cond_greater_than_or_equal_to_1;
    fs[1] = TTparseVSC_cond_greater_than_or_equal_to_2;
    fs[2] = TTparseVSC_cond_greater_than_or_equal_to_3;
    fs[3] = TTparset_qgt_qequal;
    return TTparseVSC_DISJUNCTION(TTfunVSC_cond_greater_than_or_equal_to, 4, fs);
}

TTterm
TTparseVSC_cond_greater_than_or_equal_to_1( void )
{
    fparse fs[5];

    fs[0] = TTparset_GREATER;
    fs[1] = TTparset_THAN_opt;
    fs[2] = TTparset_OR;
    fs[3] = TTparset_EQUAL;
    fs[4] = TTparset_TO_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_cond_greater_than_or_equal_to_1, fs);
}

TTterm
TTparseVSC_cond_greater_than_or_equal_to_2( void )
{
    fparse fs[3];

    fs[0] = TTparset_NOT;
    fs[1] = TTparset_LESS;
    fs[2] = TTparset_THAN_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_cond_greater_than_or_equal_to_2, fs);
}

TTterm
TTparseVSC_cond_greater_than_or_equal_to_3( void )
{
    fparse fs[2];

    fs[0] = TTparset_NOT;
    fs[1] = TTparset_qlt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_cond_greater_than_or_equal_to_3, fs);
}

TTterm
TTparseVSC_cond_is_not( void )
{
    fparse fs[2];

    fs[0] = TTparset_IS_opt;
    fs[1] = TTparset_NOT_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_cond_is_not, fs);
}

TTterm
TTparseVSC_cond_is_or_is_not( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_cond_not_is;
    fs[1] = TTparseVSC_cond_is_not;
    return TTparseVSC_DISJUNCTION(TTfunVSC_cond_is_or_is_not, 2, fs);
}

TTterm
TTparseVSC_cond_less( void )
{
    fparse fs[2];

    fs[0] = TTparset_LESS;
    fs[1] = TTparseVSC_cond_than;
    return TTparseVSC_CONJUNCTION(TTfunVSC_cond_less, fs);
}

TTterm
TTparseVSC_cond_less_equal( void )
{
    fparse fs[5];

    fs[0] = TTparset_LESS;
    fs[1] = TTparseVSC_cond_than;
    fs[2] = TTparset_OR;
    fs[3] = TTparset_EQUAL;
    fs[4] = TTparset_TO_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_cond_less_equal, fs);
}

TTterm
TTparseVSC_cond_less_equal_2( void )
{
    fparse fs[2];

    fs[0] = TTparset_qlt;
    fs[1] = TTparset_qequal;
    return TTparseVSC_CONJUNCTION(TTfunVSC_cond_less_equal_2, fs);
}

TTterm
TTparseVSC_cond_negated_simple_conditions( void )
{
    fparse fs[2];

    fs[0] = TTparset_NOT;
    fs[1] = TTparseVSC_cond_combinable_condition;
    return TTparseVSC_CONJUNCTION(TTfunVSC_cond_negated_simple_conditions, fs);
}

TTterm
TTparseVSC_cond_not_is( void )
{
    fparse fs[2];

    fs[0] = TTparset_NOT;
    fs[1] = TTparset_IS;
    return TTparseVSC_CONJUNCTION(TTfunVSC_cond_not_is, fs);
}

TTterm
TTparseVSC_cond_not_relational_operator_rest( void )
{
    fparse fs[2];

    fs[0] = TTparset_NOT_opt;
    fs[1] = TTparseVSC_cond_relational_operator_rest;
    return TTparseVSC_CONJUNCTION(TTfunVSC_cond_not_relational_operator_rest, fs);
}

TTterm
TTparseVSC_cond_relation_condition( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_expr_arithmetic_expression;
    fs[1] = TTparseVSC_cond_relational_operator;
    fs[2] = TTparseVSC_cond_simple_condition;
    return TTparseVSC_CONJUNCTION(TTfunVSC_cond_relation_condition, fs);
}

TTterm
TTparseVSC_cond_relational_operator( void )
{
    fparse fs[2];

    fs[0] = TTparset_IS_opt;
    fs[1] = TTparseVSC_cond_relational_operator_tail;
    return TTparseVSC_CONJUNCTION(TTfunVSC_cond_relational_operator, fs);
}

TTterm
TTparseVSC_cond_relational_operator_rest( void )
{
    fparse fs[5];
    fs[0] = TTparseVSC_cond_greater;
    fs[1] = TTparset_qgt;
    fs[2] = TTparseVSC_cond_less;
    fs[3] = TTparset_qlt;
    fs[4] = TTparseVSC_expr_equal_to;
    return TTparseVSC_DISJUNCTION(TTfunVSC_cond_relational_operator_rest, 5, fs);
}

TTterm
TTparseVSC_cond_relational_operator_tail( void )
{
    fparse fs[5];
    fs[0] = TTparseVSC_cond_greater_equal;
    fs[1] = TTparseVSC_cond_less_equal;
    fs[2] = TTparseVSC_cond_less_equal_2;
    fs[3] = TTparset_qgt_qequal;
    fs[4] = TTparseVSC_cond_not_relational_operator_rest;
    return TTparseVSC_DISJUNCTION(TTfunVSC_cond_relational_operator_tail, 5, fs);
}

TTterm
TTparseVSC_cond_sign_condition( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_expr_arithmetic_expression;
    fs[1] = TTparseVSC_cond_is_or_is_not;
    fs[2] = TTparseVSC_cond_sign_type;
    return TTparseVSC_CONJUNCTION(TTfunVSC_cond_sign_condition, fs);
}

TTterm
TTparseVSC_cond_sign_type( void )
{
    fparse fs[5];
    fs[0] = TTparset_POSITIVE;
    fs[1] = TTparset_NEGATIVE;
    fs[2] = TTparset_ZERO;
    fs[3] = TTparset_ZEROES;
    fs[4] = TTparset_ZEROS;
    return TTparseVSC_DISJUNCTION(TTfunVSC_cond_sign_type, 5, fs);
}

TTterm
TTparseVSC_cond_simple_condition( void )
{
    fparse fs[5];
    fs[0] = TTparseVSC_cond_class_condition;
    fs[1] = TTparseVSC_cond_relation_condition;
    fs[2] = TTparseVSC_cond_sign_condition;
    fs[3] = TTparseVSC_cond_simple_condition_1;
    fs[4] = TTparseVSC_expr_arithmetic_expression;
    return TTparseVSC_DISJUNCTION(TTfunVSC_cond_simple_condition, 5, fs);
}

TTterm
TTparseVSC_cond_simple_condition_1( void )
{
    fparse fs[3];

    fs[0] = TTparset_qpopen;
    fs[1] = TTparseVSC_cond_condition;
    fs[2] = TTparset_qpclose;
    return TTparseVSC_CONJUNCTION(TTfunVSC_cond_simple_condition_1, fs);
}

TTterm
TTparseVSC_cond_than( void )
{
    fparse fs[2];
    fs[0] = TTparset_THAN;
    fs[1] = TTparset_THEN_opt;
    return TTparseVSC_DISJUNCTION(TTfunVSC_cond_than, 2, fs);
}

TTterm
TTparseVSC_conf_sec_alphabet_clause( void )
{
    fparse fs[4];

    fs[0] = TTparset_ALPHABET;
    fs[1] = TTparseVSC_expr_alphabet_name;
    fs[2] = TTparset_IS_opt;
    fs[3] = TTparseVSC_conf_sec_alphabet_type;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_alphabet_clause, fs);
}

TTterm
TTparseVSC_conf_sec_alphabet_type( void )
{
    fparse fs[5];
    fs[0] = TTparset_STANDARD_1;
    fs[1] = TTparset_STANDARD_2;
    fs[2] = TTparset_NATIVE;
    fs[3] = TTparset_EBCDIC;
    fs[4] = TTparseVSC_conf_sec_alphabet_type_others;
    return TTparseVSC_DISJUNCTION(TTfunVSC_conf_sec_alphabet_type, 5, fs);
}

TTterm
TTparseVSC_conf_sec_alphabet_type_also( void )
{
    fparse fs[2];

    fs[0] = TTparset_ALSO;
    fs[1] = TTparseVSC_expr_literal;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_alphabet_type_also, fs);
}

TTterm
TTparseVSC_conf_sec_alphabet_type_also_through( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_expr_through_literal;
    fs[1] = TTparseVSC_conf_sec_alphabet_type_alsos;
    return TTparseVSC_DISJUNCTION(TTfunVSC_conf_sec_alphabet_type_also_through, 2, fs);
}

TTterm
TTparseVSC_conf_sec_alphabet_type_alsos( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_conf_sec_alphabet_type_also_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_alphabet_type_alsos, fs);
}

TTterm
TTparseVSC_conf_sec_alphabet_type_other( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_literal;
    fs[1] = TTparseVSC_conf_sec_alphabet_type_also_through_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_alphabet_type_other, fs);
}

TTterm
TTparseVSC_conf_sec_alphabet_type_others( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_conf_sec_alphabet_type_other_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_alphabet_type_others, fs);
}

TTterm
TTparseVSC_conf_sec_are( void )
{
    fparse fs[2];
    fs[0] = TTparset_ARE;
    fs[1] = TTparset_IS;
    return TTparseVSC_DISJUNCTION(TTfunVSC_conf_sec_are, 2, fs);
}

TTterm
TTparseVSC_conf_sec_class_clause( void )
{
    fparse fs[4];

    fs[0] = TTparset_CLASS;
    fs[1] = TTparseVSC_expr_class_name;
    fs[2] = TTparset_IS_opt;
    fs[3] = TTparseVSC_expr_literal_through_literal_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_class_clause, fs);
}

TTterm
TTparseVSC_conf_sec_configuration_section( void )
{
    fparse fs[4];

    fs[0] = TTparset_CONFIGURATION;
    fs[1] = TTparset_SECTION;
    fs[2] = TTparset_qdot;
    fs[3] = TTparseVSC_conf_sec_configuration_section_paragraphs;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_configuration_section, fs);
}

TTterm
TTparseVSC_conf_sec_configuration_section_paragraph( void )
{
    fparse fs[3];
    fs[0] = TTparseVSC_conf_sec_source_computer_paragraph;
    fs[1] = TTparseVSC_conf_sec_object_computer_paragraph;
    fs[2] = TTparseVSC_conf_sec_special_names_paragraph;
    return TTparseVSC_DISJUNCTION(TTfunVSC_conf_sec_configuration_section_paragraph, 3, fs);
}

TTterm
TTparseVSC_conf_sec_configuration_section_paragraphs( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_conf_sec_configuration_section_paragraph_star;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_configuration_section_paragraphs, fs);
}

TTterm
TTparseVSC_conf_sec_currency_sign_clause( void )
{
    fparse fs[4];

    fs[0] = TTparset_CURRENCY;
    fs[1] = TTparset_SIGN_opt;
    fs[2] = TTparset_IS_opt;
    fs[3] = TTparseVSC_expr_literal;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_currency_sign_clause, fs);
}

TTterm
TTparseVSC_conf_sec_decimal_point_clause( void )
{
    fparse fs[3];

    fs[0] = TTparset_DECIMAL_POINT;
    fs[1] = TTparset_IS_opt;
    fs[2] = TTparset_COMMA;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_decimal_point_clause, fs);
}

TTterm
TTparseVSC_conf_sec_in_alphabet_name( void )
{
    fparse fs[2];

    fs[0] = TTparset_IN;
    fs[1] = TTparseVSC_expr_alphabet_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_in_alphabet_name, fs);
}

TTterm
TTparseVSC_conf_sec_is_mnemonic_name( void )
{
    fparse fs[3];

    fs[0] = TTparset_IS_opt;
    fs[1] = TTparseVSC_expr_mnemonic_name;
    fs[2] = TTparseVSC_conf_sec_special_names_paragraph_status_phrase_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_is_mnemonic_name, fs);
}

TTterm
TTparseVSC_conf_sec_memory_size( void )
{
    fparse fs[4];

    fs[0] = TTparset_MEMORY;
    fs[1] = TTparset_SIZE_opt;
    fs[2] = TTparseVSC_expr_integer;
    fs[3] = TTparseVSC_conf_sec_memory_size_type;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_memory_size, fs);
}

TTterm
TTparseVSC_conf_sec_memory_size_type( void )
{
    fparse fs[3];
    fs[0] = TTparset_WORDS;
    fs[1] = TTparset_CHARACTERS;
    fs[2] = TTparset_MODULES;
    return TTparseVSC_DISJUNCTION(TTfunVSC_conf_sec_memory_size_type, 3, fs);
}

TTterm
TTparseVSC_conf_sec_object_computer_name( void )
{
    fparse fs[4];

    fs[0] = TTparseVSC_expr_computer_name;
    fs[1] = TTparseVSC_conf_sec_memory_size_opt;
    fs[2] = TTparseVSC_conf_sec_object_computer_paragraph_sequence_phrase;
    fs[3] = TTparset_qdot;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_object_computer_name, fs);
}

TTterm
TTparseVSC_conf_sec_object_computer_paragraph( void )
{
    fparse fs[3];

    fs[0] = TTparset_OBJECT_COMPUTER;
    fs[1] = TTparset_qdot;
    fs[2] = TTparseVSC_conf_sec_object_computer_name_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_object_computer_paragraph, fs);
}

TTterm
TTparseVSC_conf_sec_object_computer_paragraph_sequence_phrase( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_conf_sec_program_collating_sequence_opt;
    fs[1] = TTparseVSC_conf_sec_segment_limit_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_object_computer_paragraph_sequence_phrase, fs);
}

TTterm
TTparseVSC_conf_sec_off_status( void )
{
    fparse fs[4];

    fs[0] = TTparset_OFF;
    fs[1] = TTparset_STATUS_opt;
    fs[2] = TTparset_IS_opt;
    fs[3] = TTparseVSC_cond_condition;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_off_status, fs);
}

TTterm
TTparseVSC_conf_sec_on_status( void )
{
    fparse fs[4];

    fs[0] = TTparset_ON;
    fs[1] = TTparset_STATUS_opt;
    fs[2] = TTparset_IS_opt;
    fs[3] = TTparseVSC_cond_condition;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_on_status, fs);
}

TTterm
TTparseVSC_conf_sec_program_collating_sequence( void )
{
    fparse fs[5];

    fs[0] = TTparset_PROGRAM_opt;
    fs[1] = TTparset_COLLATING_opt;
    fs[2] = TTparset_SEQUENCE;
    fs[3] = TTparset_IS_opt;
    fs[4] = TTparseVSC_expr_alphabet_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_program_collating_sequence, fs);
}

TTterm
TTparseVSC_conf_sec_segment_limit( void )
{
    fparse fs[3];

    fs[0] = TTparset_SEGMENT_LIMIT;
    fs[1] = TTparset_IS_opt;
    fs[2] = TTparseVSC_expr_priority_number;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_segment_limit, fs);
}

TTterm
TTparseVSC_conf_sec_source_computer_name( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_expr_computer_name;
    fs[1] = TTparseVSC_conf_sec_with_debugging_mode_opt;
    fs[2] = TTparset_qdot;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_source_computer_name, fs);
}

TTterm
TTparseVSC_conf_sec_source_computer_paragraph( void )
{
    fparse fs[3];

    fs[0] = TTparset_SOURCE_COMPUTER;
    fs[1] = TTparset_qdot;
    fs[2] = TTparseVSC_conf_sec_source_computer_name_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_source_computer_paragraph, fs);
}

TTterm
TTparseVSC_conf_sec_special_names_paragraph( void )
{
    fparse fs[5];

    fs[0] = TTparset_SPECIAL_NAMES;
    fs[1] = TTparset_qdot;
    fs[2] = TTparseVSC_conf_sec_special_names_paragraph_phrase_star;
    fs[3] = TTparseVSC_conf_sec_special_names_paragraph_clauses;
    fs[4] = TTparset_qdot_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_special_names_paragraph, fs);
}

TTterm
TTparseVSC_conf_sec_special_names_paragraph_clause( void )
{
    fparse fs[5];
    fs[0] = TTparseVSC_conf_sec_alphabet_clause;
    fs[1] = TTparseVSC_conf_sec_symbolic_characters_clause;
    fs[2] = TTparseVSC_conf_sec_class_clause;
    fs[3] = TTparseVSC_conf_sec_currency_sign_clause;
    fs[4] = TTparseVSC_conf_sec_decimal_point_clause;
    return TTparseVSC_DISJUNCTION(TTfunVSC_conf_sec_special_names_paragraph_clause, 5, fs);
}

TTterm
TTparseVSC_conf_sec_special_names_paragraph_clauses( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_conf_sec_special_names_paragraph_clause_star;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_special_names_paragraph_clauses, fs);
}

TTterm
TTparseVSC_conf_sec_special_names_paragraph_phrase( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_environment_name;
    fs[1] = TTparseVSC_conf_sec_special_names_paragraph_phrase_tail;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_special_names_paragraph_phrase, fs);
}

TTterm
TTparseVSC_conf_sec_special_names_paragraph_phrase_tail( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_conf_sec_is_mnemonic_name;
    fs[1] = TTparseVSC_conf_sec_special_names_paragraph_status_phrase;
    return TTparseVSC_DISJUNCTION(TTfunVSC_conf_sec_special_names_paragraph_phrase_tail, 2, fs);
}

TTterm
TTparseVSC_conf_sec_special_names_paragraph_status_phrase( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_conf_sec_special_names_paragraph_status_phrase_1;
    fs[1] = TTparseVSC_conf_sec_special_names_paragraph_status_phrase_2;
    return TTparseVSC_DISJUNCTION(TTfunVSC_conf_sec_special_names_paragraph_status_phrase, 2, fs);
}

TTterm
TTparseVSC_conf_sec_special_names_paragraph_status_phrase_1( void )
{
    fparse fs[5];

    fs[0] = TTparset_ON;
    fs[1] = TTparset_STATUS_opt;
    fs[2] = TTparset_IS_opt;
    fs[3] = TTparseVSC_cond_condition;
    fs[4] = TTparseVSC_conf_sec_off_status_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_special_names_paragraph_status_phrase_1, fs);
}

TTterm
TTparseVSC_conf_sec_special_names_paragraph_status_phrase_2( void )
{
    fparse fs[5];

    fs[0] = TTparset_OFF;
    fs[1] = TTparset_STATUS_opt;
    fs[2] = TTparset_IS_opt;
    fs[3] = TTparseVSC_cond_condition;
    fs[4] = TTparseVSC_conf_sec_on_status_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_special_names_paragraph_status_phrase_2, fs);
}

TTterm
TTparseVSC_conf_sec_symbolic_character_mapping( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_expr_symbolic_character_plus;
    fs[1] = TTparseVSC_conf_sec_are_opt;
    fs[2] = TTparseVSC_expr_integer_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_symbolic_character_mapping, fs);
}

TTterm
TTparseVSC_conf_sec_symbolic_characters_clause( void )
{
    fparse fs[4];

    fs[0] = TTparset_SYMBOLIC;
    fs[1] = TTparset_CHARACTERS_opt;
    fs[2] = TTparseVSC_conf_sec_symbolic_character_mapping_plus;
    fs[3] = TTparseVSC_conf_sec_in_alphabet_name_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_symbolic_characters_clause, fs);
}

TTterm
TTparseVSC_conf_sec_with_debugging_mode( void )
{
    fparse fs[3];

    fs[0] = TTparset_WITH_opt;
    fs[1] = TTparset_DEBUGGING;
    fs[2] = TTparset_MODE;
    return TTparseVSC_CONJUNCTION(TTfunVSC_conf_sec_with_debugging_mode, fs);
}

TTterm
TTparseVSC_data_div_data_division( void )
{
    fparse fs[4];

    fs[0] = TTparset_DATA;
    fs[1] = TTparset_DIVISION;
    fs[2] = TTparset_qdot;
    fs[3] = TTparseVSC_data_div_data_division_content;
    return TTparseVSC_CONJUNCTION(TTfunVSC_data_div_data_division, fs);
}

TTterm
TTparseVSC_data_div_data_division_content( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_data_div_file_section_opt;
    fs[1] = TTparseVSC_data_div_working_storage_section_opt;
    fs[2] = TTparseVSC_data_div_linkage_section_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_data_div_data_division_content, fs);
}

TTterm
TTparseVSC_data_div_file_section( void )
{
    fparse fs[4];

    fs[0] = TTparset_FILE;
    fs[1] = TTparset_SECTION;
    fs[2] = TTparset_qdot;
    fs[3] = TTparseVSC_data_div_file_section_entry_star;
    return TTparseVSC_CONJUNCTION(TTfunVSC_data_div_file_section, fs);
}

TTterm
TTparseVSC_data_div_file_section_entry( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_fd_entry_file_and_sort_description_entry;
    fs[1] = TTparseVSC_dd_entry_data_description_entry_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_data_div_file_section_entry, fs);
}

TTterm
TTparseVSC_data_div_linkage_section( void )
{
    fparse fs[4];

    fs[0] = TTparset_LINKAGE;
    fs[1] = TTparset_SECTION;
    fs[2] = TTparset_qdot;
    fs[3] = TTparseVSC_dd_entry_data_description_entry_star;
    return TTparseVSC_CONJUNCTION(TTfunVSC_data_div_linkage_section, fs);
}

TTterm
TTparseVSC_data_div_working_storage_section( void )
{
    fparse fs[4];

    fs[0] = TTparset_WORKING_STORAGE;
    fs[1] = TTparset_SECTION;
    fs[2] = TTparset_qdot;
    fs[3] = TTparseVSC_dd_entry_data_description_entry_star;
    return TTparseVSC_CONJUNCTION(TTfunVSC_data_div_working_storage_section, fs);
}

TTterm
TTparseVSC_dd_entry_alt_data_name_filler( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_expr_data_name;
    fs[1] = TTparset_FILLER;
    return TTparseVSC_DISJUNCTION(TTfunVSC_dd_entry_alt_data_name_filler, 2, fs);
}

TTterm
TTparseVSC_dd_entry_alt_leading_trailing( void )
{
    fparse fs[2];
    fs[0] = TTparset_LEADING;
    fs[1] = TTparset_TRAILING;
    return TTparseVSC_DISJUNCTION(TTfunVSC_dd_entry_alt_leading_trailing, 2, fs);
}

TTterm
TTparseVSC_dd_entry_alt_left_right( void )
{
    fparse fs[2];
    fs[0] = TTparset_LEFT;
    fs[1] = TTparset_RIGHT;
    return TTparseVSC_DISJUNCTION(TTfunVSC_dd_entry_alt_left_right, 2, fs);
}

TTterm
TTparseVSC_dd_entry_blank_when_zero_clause( void )
{
    fparse fs[3];

    fs[0] = TTparset_BLANK;
    fs[1] = TTparset_WHEN_opt;
    fs[2] = TTparseVSC_dd_entry_zeroes;
    return TTparseVSC_CONJUNCTION(TTfunVSC_dd_entry_blank_when_zero_clause, fs);
}

TTterm
TTparseVSC_dd_entry_condition_value_clause( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_dd_entry_values_are;
    fs[1] = TTparseVSC_expr_literal_through_literal_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_dd_entry_condition_value_clause, fs);
}

TTterm
TTparseVSC_dd_entry_data_description_entry( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_dd_entry_data_description_entry_1;
    fs[1] = TTparseVSC_expr_copy_statement;
    return TTparseVSC_DISJUNCTION(TTfunVSC_dd_entry_data_description_entry, 2, fs);
}

TTterm
TTparseVSC_dd_entry_data_description_entry_1( void )
{
    fparse fs[4];

    fs[0] = TTparseVSC_expr_level_number;
    fs[1] = TTparseVSC_dd_entry_alt_data_name_filler_opt;
    fs[2] = TTparseVSC_dd_entry_data_description_entry_clauses;
    fs[3] = TTparset_qdot_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_dd_entry_data_description_entry_1, fs);
}

TTterm
TTparseVSC_dd_entry_data_description_entry_clause( void )
{
    fparse fs[12];
    fs[0] = TTparseVSC_dd_entry_picture_clause;
    fs[1] = TTparseVSC_dd_entry_redefines_clause;
    fs[2] = TTparseVSC_dd_entry_blank_when_zero_clause;
    fs[3] = TTparseVSC_dd_entry_external_clause;
    fs[4] = TTparseVSC_dd_entry_global_clause;
    fs[5] = TTparseVSC_dd_entry_justified_clause;
    fs[6] = TTparseVSC_dd_entry_occurs_clause;
    fs[7] = TTparseVSC_dd_entry_sign_clause;
    fs[8] = TTparseVSC_dd_entry_synchronized_clause;
    fs[9] = TTparseVSC_dd_entry_usage_clause;
    fs[10] = TTparseVSC_dd_entry_renames_clause;
    fs[11] = TTparseVSC_dd_entry_condition_value_clause;
    return TTparseVSC_DISJUNCTION(TTfunVSC_dd_entry_data_description_entry_clause, 12, fs);
}

TTterm
TTparseVSC_dd_entry_data_description_entry_clauses( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_dd_entry_data_description_entry_clause_star;
    return TTparseVSC_CONJUNCTION(TTfunVSC_dd_entry_data_description_entry_clauses, fs);
}

TTterm
TTparseVSC_dd_entry_external_clause( void )
{
    fparse fs[2];

    fs[0] = TTparset_IS_opt;
    fs[1] = TTparset_EXTERNAL;
    return TTparseVSC_CONJUNCTION(TTfunVSC_dd_entry_external_clause, fs);
}

TTterm
TTparseVSC_dd_entry_global_clause( void )
{
    fparse fs[2];

    fs[0] = TTparset_IS_opt;
    fs[1] = TTparset_GLOBAL;
    return TTparseVSC_CONJUNCTION(TTfunVSC_dd_entry_global_clause, fs);
}

TTterm
TTparseVSC_dd_entry_indexed_by( void )
{
    fparse fs[3];

    fs[0] = TTparset_INDEXED;
    fs[1] = TTparset_BY_opt;
    fs[2] = TTparseVSC_expr_index_name_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_dd_entry_indexed_by, fs);
}

TTterm
TTparseVSC_dd_entry_integer_to( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_integer;
    fs[1] = TTparset_TO;
    return TTparseVSC_CONJUNCTION(TTfunVSC_dd_entry_integer_to, fs);
}

TTterm
TTparseVSC_dd_entry_justified( void )
{
    fparse fs[2];
    fs[0] = TTparset_JUSTIFIED;
    fs[1] = TTparset_JUST;
    return TTparseVSC_DISJUNCTION(TTfunVSC_dd_entry_justified, 2, fs);
}

TTterm
TTparseVSC_dd_entry_justified_clause( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_dd_entry_justified;
    fs[1] = TTparset_RIGHT_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_dd_entry_justified_clause, fs);
}

TTterm
TTparseVSC_dd_entry_occurs_clause( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_dd_entry_occurs_clause_2;
    fs[1] = TTparseVSC_dd_entry_occurs_clause_1;
    return TTparseVSC_DISJUNCTION(TTfunVSC_dd_entry_occurs_clause, 2, fs);
}

TTterm
TTparseVSC_dd_entry_occurs_clause_1( void )
{
    fparse fs[5];

    fs[0] = TTparset_OCCURS;
    fs[1] = TTparseVSC_expr_integer;
    fs[2] = TTparset_TIMES_opt;
    fs[3] = TTparseVSC_dd_entry_occurs_clause_key_star;
    fs[4] = TTparseVSC_dd_entry_indexed_by_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_dd_entry_occurs_clause_1, fs);
}

TTterm
TTparseVSC_dd_entry_occurs_clause_2( void )
{
    fparse fs[9];

    fs[0] = TTparset_OCCURS;
    fs[1] = TTparseVSC_dd_entry_integer_to_opt;
    fs[2] = TTparseVSC_expr_integer;
    fs[3] = TTparset_TIMES_opt;
    fs[4] = TTparset_DEPENDING;
    fs[5] = TTparset_ON_opt;
    fs[6] = TTparseVSC_expr_qualified_data_name;
    fs[7] = TTparseVSC_dd_entry_occurs_clause_key_star;
    fs[8] = TTparseVSC_dd_entry_indexed_by_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_dd_entry_occurs_clause_2, fs);
}

TTterm
TTparseVSC_dd_entry_occurs_clause_key( void )
{
    fparse fs[4];

    fs[0] = TTparseVSC_expr_alt_ascending_descending;
    fs[1] = TTparset_KEY_opt;
    fs[2] = TTparset_IS_opt;
    fs[3] = TTparseVSC_expr_qualified_data_name_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_dd_entry_occurs_clause_key, fs);
}

TTterm
TTparseVSC_dd_entry_picture( void )
{
    fparse fs[2];
    fs[0] = TTparset_PICTURE;
    fs[1] = TTparset_PIC;
    return TTparseVSC_DISJUNCTION(TTfunVSC_dd_entry_picture, 2, fs);
}

TTterm
TTparseVSC_dd_entry_picture_clause( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_dd_entry_picture;
    fs[1] = TTparset_IS_opt;
    fs[2] = TTparseVSC_lex_picture_string;
    return TTparseVSC_CONJUNCTION(TTfunVSC_dd_entry_picture_clause, fs);
}

TTterm
TTparseVSC_dd_entry_redefines_clause( void )
{
    fparse fs[2];

    fs[0] = TTparset_REDEFINES;
    fs[1] = TTparseVSC_expr_data_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_dd_entry_redefines_clause, fs);
}

TTterm
TTparseVSC_dd_entry_renames_clause( void )
{
    fparse fs[3];

    fs[0] = TTparset_RENAMES;
    fs[1] = TTparseVSC_expr_qualified_data_name;
    fs[2] = TTparseVSC_expr_through_qualified_data_name_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_dd_entry_renames_clause, fs);
}

TTterm
TTparseVSC_dd_entry_separate_character( void )
{
    fparse fs[2];

    fs[0] = TTparset_SEPARATE;
    fs[1] = TTparset_CHARACTER_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_dd_entry_separate_character, fs);
}

TTterm
TTparseVSC_dd_entry_sign_clause( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_dd_entry_sign_is_opt;
    fs[1] = TTparseVSC_dd_entry_alt_leading_trailing;
    fs[2] = TTparseVSC_dd_entry_separate_character_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_dd_entry_sign_clause, fs);
}

TTterm
TTparseVSC_dd_entry_sign_is( void )
{
    fparse fs[2];

    fs[0] = TTparset_SIGN;
    fs[1] = TTparset_IS_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_dd_entry_sign_is, fs);
}

TTterm
TTparseVSC_dd_entry_synchronized( void )
{
    fparse fs[2];
    fs[0] = TTparset_SYNCHRONIZED;
    fs[1] = TTparset_SYNC;
    return TTparseVSC_DISJUNCTION(TTfunVSC_dd_entry_synchronized, 2, fs);
}

TTterm
TTparseVSC_dd_entry_synchronized_clause( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_dd_entry_synchronized;
    fs[1] = TTparseVSC_dd_entry_alt_left_right_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_dd_entry_synchronized_clause, fs);
}

TTterm
TTparseVSC_dd_entry_usage( void )
{
    fparse fs[16];
    fs[0] = TTparset_BINARY;
    fs[1] = TTparset_COMP;
    fs[2] = TTparset_COMP_1;
    fs[3] = TTparset_COMP_2;
    fs[4] = TTparset_COMP_3;
    fs[5] = TTparset_COMP_4;
    fs[6] = TTparset_COMPUTATIONAL;
    fs[7] = TTparset_COMPUTATIONAL_1;
    fs[8] = TTparset_COMPUTATIONAL_2;
    fs[9] = TTparset_COMPUTATIONAL_3;
    fs[10] = TTparset_COMPUTATIONAL_4;
    fs[11] = TTparset_DISPLAY;
    fs[12] = TTparset_DISPLAY_1;
    fs[13] = TTparset_INDEX;
    fs[14] = TTparset_PACKED_DECIMAL;
    fs[15] = TTparset_POINTER;
    return TTparseVSC_DISJUNCTION(TTfunVSC_dd_entry_usage, 16, fs);
}

TTterm
TTparseVSC_dd_entry_usage_clause( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_dd_entry_usage_is_opt;
    fs[1] = TTparseVSC_dd_entry_usage;
    return TTparseVSC_CONJUNCTION(TTfunVSC_dd_entry_usage_clause, fs);
}

TTterm
TTparseVSC_dd_entry_usage_is( void )
{
    fparse fs[2];

    fs[0] = TTparset_USAGE;
    fs[1] = TTparset_IS_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_dd_entry_usage_is, fs);
}

TTterm
TTparseVSC_dd_entry_values_are( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_values;
    fs[1] = TTparseVSC_conf_sec_are_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_dd_entry_values_are, fs);
}

TTterm
TTparseVSC_dd_entry_zeroes( void )
{
    fparse fs[3];
    fs[0] = TTparset_ZERO;
    fs[1] = TTparset_ZEROS;
    fs[2] = TTparset_ZEROES;
    return TTparseVSC_DISJUNCTION(TTfunVSC_dd_entry_zeroes, 3, fs);
}

TTterm
TTparseVSC_env_div_environment_division( void )
{
    fparse fs[4];

    fs[0] = TTparset_ENVIRONMENT;
    fs[1] = TTparset_DIVISION;
    fs[2] = TTparset_qdot;
    fs[3] = TTparseVSC_env_div_environment_division_content;
    return TTparseVSC_CONJUNCTION(TTfunVSC_env_div_environment_division, fs);
}

TTterm
TTparseVSC_env_div_environment_division_content( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_conf_sec_configuration_section_opt;
    fs[1] = TTparseVSC_io_sec_input_output_section_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_env_div_environment_division_content, fs);
}

TTterm
TTparseVSC_expr_alphabet_name( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_expr_alphabetic_user_defined_word;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_alphabet_name, fs);
}

TTterm
TTparseVSC_expr_alphabetic_user_defined_word( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_lex_cobword;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_alphabetic_user_defined_word, fs);
}

TTterm
TTparseVSC_expr_alt_ascending_descending( void )
{
    fparse fs[2];
    fs[0] = TTparset_ASCENDING;
    fs[1] = TTparset_DESCENDING;
    return TTparseVSC_DISJUNCTION(TTfunVSC_expr_alt_ascending_descending, 2, fs);
}

TTterm
TTparseVSC_expr_alt_library_name_literal( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_expr_library_name;
    fs[1] = TTparseVSC_expr_literal;
    return TTparseVSC_DISJUNCTION(TTfunVSC_expr_alt_library_name_literal, 2, fs);
}

TTterm
TTparseVSC_expr_alt_plus_minus( void )
{
    fparse fs[2];
    fs[0] = TTparset_qplus;
    fs[1] = TTparset__;
    return TTparseVSC_DISJUNCTION(TTfunVSC_expr_alt_plus_minus, 2, fs);
}

TTterm
TTparseVSC_expr_alt_reel_unit( void )
{
    fparse fs[2];
    fs[0] = TTparset_REEL;
    fs[1] = TTparset_UNIT;
    return TTparseVSC_DISJUNCTION(TTfunVSC_expr_alt_reel_unit, 2, fs);
}

TTterm
TTparseVSC_expr_alt_text_name_literal( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_expr_text_name;
    fs[1] = TTparseVSC_expr_literal;
    return TTparseVSC_DISJUNCTION(TTfunVSC_expr_alt_text_name_literal, 2, fs);
}

TTterm
TTparseVSC_expr_alt_times_div( void )
{
    fparse fs[2];
    fs[0] = TTparset_qmultiply;
    fs[1] = TTparset_qdivide;
    return TTparseVSC_DISJUNCTION(TTfunVSC_expr_alt_times_div, 2, fs);
}

TTterm
TTparseVSC_expr_arithmetic_expression( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_times_div;
    fs[1] = TTparseVSC_expr_arithmetic_expression_tail_star;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_arithmetic_expression, fs);
}

TTterm
TTparseVSC_expr_arithmetic_expression_tail( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_alt_plus_minus;
    fs[1] = TTparseVSC_expr_times_div;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_arithmetic_expression_tail, fs);
}

TTterm
TTparseVSC_expr_assignment_name( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_expr_system_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_assignment_name, fs);
}

TTterm
TTparseVSC_expr_basis( void )
{
    fparse fs[3];
    fs[0] = TTparseVSC_expr_literal;
    fs[1] = TTparseVSC_expr_identifier;
    fs[2] = TTparseVSC_expr_basis_1;
    return TTparseVSC_DISJUNCTION(TTfunVSC_expr_basis, 3, fs);
}

TTterm
TTparseVSC_expr_basis_1( void )
{
    fparse fs[3];

    fs[0] = TTparset_qpopen;
    fs[1] = TTparseVSC_expr_arithmetic_expression;
    fs[2] = TTparset_qpclose;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_basis_1, fs);
}

TTterm
TTparseVSC_expr_class_name( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_expr_alphabetic_user_defined_word;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_class_name, fs);
}

TTterm
TTparseVSC_expr_computer_name( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_expr_system_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_computer_name, fs);
}

TTterm
TTparseVSC_expr_condition_name( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_expr_alphabetic_user_defined_word;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_condition_name, fs);
}

TTterm
TTparseVSC_expr_copy_operand( void )
{
    fparse fs[3];
    fs[0] = TTparseVSC_lex_quoted_pseudo_text;
    fs[1] = TTparseVSC_expr_identifier;
    fs[2] = TTparseVSC_expr_literal;
    return TTparseVSC_DISJUNCTION(TTfunVSC_expr_copy_operand, 3, fs);
}

TTterm
TTparseVSC_expr_copy_statement( void )
{
    fparse fs[6];

    fs[0] = TTparset_COPY;
    fs[1] = TTparseVSC_expr_alt_text_name_literal;
    fs[2] = TTparseVSC_expr_in_library_opt;
    fs[3] = TTparset_SUPPRESS_opt;
    fs[4] = TTparseVSC_expr_copy_statement_replacing_phrase_opt;
    fs[5] = TTparset_qdot;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_copy_statement, fs);
}

TTterm
TTparseVSC_expr_copy_statement_by_phrase( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_expr_copy_operand;
    fs[1] = TTparset_BY;
    fs[2] = TTparseVSC_expr_copy_operand;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_copy_statement_by_phrase, fs);
}

TTterm
TTparseVSC_expr_copy_statement_replacing_phrase( void )
{
    fparse fs[2];

    fs[0] = TTparset_REPLACING;
    fs[1] = TTparseVSC_expr_copy_statement_by_phrase_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_copy_statement_replacing_phrase, fs);
}

TTterm
TTparseVSC_expr_data_name( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_expr_alphabetic_user_defined_word;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_data_name, fs);
}

TTterm
TTparseVSC_expr_data_or_file_name( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_expr_alphabetic_user_defined_word;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_data_or_file_name, fs);
}

TTterm
TTparseVSC_expr_data_or_file_or_mnemonic_name( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_expr_alphabetic_user_defined_word;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_data_or_file_or_mnemonic_name, fs);
}

TTterm
TTparseVSC_expr_environment_name( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_expr_system_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_environment_name, fs);
}

TTterm
TTparseVSC_expr_equal_to( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_expr_equal_to_1;
    fs[1] = TTparset_qequal;
    return TTparseVSC_DISJUNCTION(TTfunVSC_expr_equal_to, 2, fs);
}

TTterm
TTparseVSC_expr_equal_to_1( void )
{
    fparse fs[2];

    fs[0] = TTparset_EQUAL;
    fs[1] = TTparset_TO_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_equal_to_1, fs);
}

TTterm
TTparseVSC_expr_figurative_constant( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_expr_figurative_constant_simple;
    fs[1] = TTparseVSC_expr_figurative_constant_all;
    return TTparseVSC_DISJUNCTION(TTfunVSC_expr_figurative_constant, 2, fs);
}

TTterm
TTparseVSC_expr_figurative_constant_all( void )
{
    fparse fs[2];

    fs[0] = TTparset_ALL;
    fs[1] = TTparseVSC_expr_literal;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_figurative_constant_all, fs);
}

TTterm
TTparseVSC_expr_figurative_constant_simple( void )
{
    fparse fs[13];
    fs[0] = TTparset_ZERO;
    fs[1] = TTparset_ZEROS;
    fs[2] = TTparset_ZEROES;
    fs[3] = TTparset_SPACE;
    fs[4] = TTparset_SPACES;
    fs[5] = TTparset_HIGH_VALUE;
    fs[6] = TTparset_HIGH_VALUES;
    fs[7] = TTparset_LOW_VALUE;
    fs[8] = TTparset_LOW_VALUES;
    fs[9] = TTparset_QUOTE;
    fs[10] = TTparset_QUOTES;
    fs[11] = TTparset_NULL;
    fs[12] = TTparset_NULLS;
    return TTparseVSC_DISJUNCTION(TTfunVSC_expr_figurative_constant_simple, 13, fs);
}

TTterm
TTparseVSC_expr_file_name( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_expr_alphabetic_user_defined_word;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_file_name, fs);
}

TTterm
TTparseVSC_expr_identifier( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_expr_identifier_1;
    fs[1] = TTparseVSC_expr_identifier_2;
    return TTparseVSC_DISJUNCTION(TTfunVSC_expr_identifier, 2, fs);
}

TTterm
TTparseVSC_expr_identifier_1( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_expr_qualified_data_name;
    fs[1] = TTparseVSC_expr_subscript_parentheses_star;
    fs[2] = TTparseVSC_expr_reference_modification_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_identifier_1, fs);
}

TTterm
TTparseVSC_expr_identifier_2( void )
{
    fparse fs[2];

    fs[0] = TTparset_LINAGE_COUNTER;
    fs[1] = TTparseVSC_expr_in_file_name_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_identifier_2, fs);
}

TTterm
TTparseVSC_expr_in( void )
{
    fparse fs[2];
    fs[0] = TTparset_OF;
    fs[1] = TTparset_IN;
    return TTparseVSC_DISJUNCTION(TTfunVSC_expr_in, 2, fs);
}

TTterm
TTparseVSC_expr_in_data_or_file_name( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_in;
    fs[1] = TTparseVSC_expr_data_or_file_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_in_data_or_file_name, fs);
}

TTterm
TTparseVSC_expr_in_data_or_file_or_mnemonic_name( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_in;
    fs[1] = TTparseVSC_expr_data_or_file_or_mnemonic_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_in_data_or_file_or_mnemonic_name, fs);
}

TTterm
TTparseVSC_expr_in_file_name( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_in;
    fs[1] = TTparseVSC_expr_file_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_in_file_name, fs);
}

TTterm
TTparseVSC_expr_in_library( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_in;
    fs[1] = TTparseVSC_expr_alt_library_name_literal;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_in_library, fs);
}

TTterm
TTparseVSC_expr_in_section_name( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_in;
    fs[1] = TTparseVSC_expr_section_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_in_section_name, fs);
}

TTterm
TTparseVSC_expr_index_name( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_expr_alphabetic_user_defined_word;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_index_name, fs);
}

TTterm
TTparseVSC_expr_integer( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_lex_num;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_integer, fs);
}

TTterm
TTparseVSC_expr_leftmost_character_position( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_expr_arithmetic_expression;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_leftmost_character_position, fs);
}

TTterm
TTparseVSC_expr_length( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_expr_arithmetic_expression;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_length, fs);
}

TTterm
TTparseVSC_expr_level_number( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_lex_num;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_level_number, fs);
}

TTterm
TTparseVSC_expr_library_name( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_expr_user_defined_word;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_library_name, fs);
}

TTterm
TTparseVSC_expr_literal( void )
{
    fparse fs[3];
    fs[0] = TTparseVSC_lex_nonnumeric;
    fs[1] = TTparseVSC_expr_numeric;
    fs[2] = TTparseVSC_expr_figurative_constant;
    return TTparseVSC_DISJUNCTION(TTfunVSC_expr_literal, 3, fs);
}

TTterm
TTparseVSC_expr_literal_through_literal( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_literal;
    fs[1] = TTparseVSC_expr_through_literal_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_literal_through_literal, fs);
}

TTterm
TTparseVSC_expr_mnemonic_name( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_expr_alphabetic_user_defined_word;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_mnemonic_name, fs);
}

TTterm
TTparseVSC_expr_numeric( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_lex_num;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_numeric, fs);
}

TTterm
TTparseVSC_expr_paragraph_name( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_expr_user_defined_word;
    fs[1] = TTparseVSC_expr_integer;
    return TTparseVSC_DISJUNCTION(TTfunVSC_expr_paragraph_name, 2, fs);
}

TTterm
TTparseVSC_expr_paragraph_or_section_name( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_expr_user_defined_word;
    fs[1] = TTparseVSC_expr_integer;
    return TTparseVSC_DISJUNCTION(TTfunVSC_expr_paragraph_or_section_name, 2, fs);
}

TTterm
TTparseVSC_expr_plus_minus_integer( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_alt_plus_minus;
    fs[1] = TTparseVSC_expr_integer;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_plus_minus_integer, fs);
}

TTterm
TTparseVSC_expr_power( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_expr_alt_plus_minus_opt;
    fs[1] = TTparseVSC_expr_basis;
    fs[2] = TTparseVSC_expr_power_tail_star;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_power, fs);
}

TTterm
TTparseVSC_expr_power_tail( void )
{
    fparse fs[2];

    fs[0] = TTparset_qmultiply_qmultiply;
    fs[1] = TTparseVSC_expr_basis;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_power_tail, fs);
}

TTterm
TTparseVSC_expr_priority_number( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_lex_num;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_priority_number, fs);
}

TTterm
TTparseVSC_expr_procedure_name( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_paragraph_or_section_name;
    fs[1] = TTparseVSC_expr_in_section_name_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_procedure_name, fs);
}

TTterm
TTparseVSC_expr_program_name( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_expr_user_defined_word;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_program_name, fs);
}

TTterm
TTparseVSC_expr_qualified_data_name( void )
{
    fparse fs[3];
    fs[0] = TTparseVSC_expr_qualified_data_name_1;
    fs[1] = TTparseVSC_expr_special_register_1;
    fs[2] = TTparseVSC_expr_special_register_2;
    return TTparseVSC_DISJUNCTION(TTfunVSC_expr_qualified_data_name, 3, fs);
}

TTterm
TTparseVSC_expr_qualified_data_name_1( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_data_name;
    fs[1] = TTparseVSC_expr_in_data_or_file_name_star;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_qualified_data_name_1, fs);
}

TTterm
TTparseVSC_expr_record_name( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_expr_qualified_data_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_record_name, fs);
}

TTterm
TTparseVSC_expr_records( void )
{
    fparse fs[2];
    fs[0] = TTparset_RECORD;
    fs[1] = TTparset_RECORDS;
    return TTparseVSC_DISJUNCTION(TTfunVSC_expr_records, 2, fs);
}

TTterm
TTparseVSC_expr_reference_modification( void )
{
    fparse fs[5];

    fs[0] = TTparset_qpopen;
    fs[1] = TTparseVSC_expr_leftmost_character_position;
    fs[2] = TTparset_qcolon;
    fs[3] = TTparseVSC_expr_length_opt;
    fs[4] = TTparset_qpclose;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_reference_modification, fs);
}

TTterm
TTparseVSC_expr_section_name( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_expr_user_defined_word;
    fs[1] = TTparseVSC_expr_integer;
    return TTparseVSC_DISJUNCTION(TTfunVSC_expr_section_name, 2, fs);
}

TTterm
TTparseVSC_expr_special_register_1( void )
{
    fparse fs[3];

    fs[0] = TTparset_ADDRESS;
    fs[1] = TTparset_OF;
    fs[2] = TTparseVSC_expr_data_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_special_register_1, fs);
}

TTterm
TTparseVSC_expr_special_register_2( void )
{
    fparse fs[3];

    fs[0] = TTparset_LENGTH;
    fs[1] = TTparset_OF;
    fs[2] = TTparseVSC_expr_identifier;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_special_register_2, fs);
}

TTterm
TTparseVSC_expr_subscript( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_expr_subscript_expression_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_subscript, fs);
}

TTterm
TTparseVSC_expr_subscript_expression( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_expr_literal;
    fs[1] = TTparseVSC_expr_subscript_expression_ambiguous;
    return TTparseVSC_DISJUNCTION(TTfunVSC_expr_subscript_expression, 2, fs);
}

TTterm
TTparseVSC_expr_subscript_expression_ambiguous( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_qualified_data_name;
    fs[1] = TTparseVSC_expr_plus_minus_integer_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_subscript_expression_ambiguous, fs);
}

TTterm
TTparseVSC_expr_subscript_parentheses( void )
{
    fparse fs[3];

    fs[0] = TTparset_qpopen;
    fs[1] = TTparseVSC_expr_subscript;
    fs[2] = TTparset_qpclose;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_subscript_parentheses, fs);
}

TTterm
TTparseVSC_expr_symbolic_character( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_expr_alphabetic_user_defined_word;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_symbolic_character, fs);
}

TTterm
TTparseVSC_expr_system_name( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_lex_cobword;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_system_name, fs);
}

TTterm
TTparseVSC_expr_text_name( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_expr_user_defined_word;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_text_name, fs);
}

TTterm
TTparseVSC_expr_through( void )
{
    fparse fs[2];
    fs[0] = TTparset_THROUGH;
    fs[1] = TTparset_THRU;
    return TTparseVSC_DISJUNCTION(TTfunVSC_expr_through, 2, fs);
}

TTterm
TTparseVSC_expr_through_arithmetic_expression( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_through;
    fs[1] = TTparseVSC_expr_arithmetic_expression;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_through_arithmetic_expression, fs);
}

TTterm
TTparseVSC_expr_through_literal( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_through;
    fs[1] = TTparseVSC_expr_literal;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_through_literal, fs);
}

TTterm
TTparseVSC_expr_through_qualified_data_name( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_through;
    fs[1] = TTparseVSC_expr_qualified_data_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_through_qualified_data_name, fs);
}

TTterm
TTparseVSC_expr_times_div( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_power;
    fs[1] = TTparseVSC_expr_times_div_tail_star;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_times_div, fs);
}

TTterm
TTparseVSC_expr_times_div_tail( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_alt_times_div;
    fs[1] = TTparseVSC_expr_power;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_times_div_tail, fs);
}

TTterm
TTparseVSC_expr_user_defined_word( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_lex_cobword;
    return TTparseVSC_CONJUNCTION(TTfunVSC_expr_user_defined_word, fs);
}

TTterm
TTparseVSC_expr_values( void )
{
    fparse fs[2];
    fs[0] = TTparset_VALUE;
    fs[1] = TTparset_VALUES;
    return TTparseVSC_DISJUNCTION(TTfunVSC_expr_values, 2, fs);
}

TTterm
TTparseVSC_fd_entry_alt_characters_records( void )
{
    fparse fs[3];
    fs[0] = TTparset_CHARACTERS;
    fs[1] = TTparset_RECORDS;
    fs[2] = TTparset_RECORD;
    return TTparseVSC_DISJUNCTION(TTfunVSC_fd_entry_alt_characters_records, 3, fs);
}

TTterm
TTparseVSC_fd_entry_alt_data_name_integer( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_expr_data_name;
    fs[1] = TTparseVSC_expr_integer;
    return TTparseVSC_DISJUNCTION(TTfunVSC_fd_entry_alt_data_name_integer, 2, fs);
}

TTterm
TTparseVSC_fd_entry_alt_fd_sd( void )
{
    fparse fs[2];
    fs[0] = TTparset_FD;
    fs[1] = TTparset_SD;
    return TTparseVSC_DISJUNCTION(TTfunVSC_fd_entry_alt_fd_sd, 2, fs);
}

TTterm
TTparseVSC_fd_entry_alt_qualified_data_name_literal( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_expr_qualified_data_name;
    fs[1] = TTparseVSC_expr_literal;
    return TTparseVSC_DISJUNCTION(TTfunVSC_fd_entry_alt_qualified_data_name_literal, 2, fs);
}

TTterm
TTparseVSC_fd_entry_block_contains_clause( void )
{
    fparse fs[5];

    fs[0] = TTparset_BLOCK;
    fs[1] = TTparset_CONTAINS_opt;
    fs[2] = TTparseVSC_dd_entry_integer_to_opt;
    fs[3] = TTparseVSC_expr_integer;
    fs[4] = TTparseVSC_fd_entry_alt_characters_records_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_fd_entry_block_contains_clause, fs);
}

TTterm
TTparseVSC_fd_entry_code_set_clause( void )
{
    fparse fs[3];

    fs[0] = TTparset_CODE_SET;
    fs[1] = TTparset_IS_opt;
    fs[2] = TTparseVSC_expr_alphabet_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_fd_entry_code_set_clause, fs);
}

TTterm
TTparseVSC_fd_entry_data_names( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_expr_data_name_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_fd_entry_data_names, fs);
}

TTterm
TTparseVSC_fd_entry_data_records_clause( void )
{
    fparse fs[3];

    fs[0] = TTparset_DATA;
    fs[1] = TTparseVSC_fd_entry_records_are;
    fs[2] = TTparseVSC_expr_data_name_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_fd_entry_data_records_clause, fs);
}

TTterm
TTparseVSC_fd_entry_depending_on( void )
{
    fparse fs[3];

    fs[0] = TTparset_DEPENDING;
    fs[1] = TTparset_ON_opt;
    fs[2] = TTparseVSC_expr_data_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_fd_entry_depending_on, fs);
}

TTterm
TTparseVSC_fd_entry_file_and_sort_description_entry( void )
{
    fparse fs[4];

    fs[0] = TTparseVSC_fd_entry_alt_fd_sd;
    fs[1] = TTparseVSC_expr_file_name;
    fs[2] = TTparseVSC_fd_entry_file_and_sort_description_entry_clauses;
    fs[3] = TTparset_qdot;
    return TTparseVSC_CONJUNCTION(TTfunVSC_fd_entry_file_and_sort_description_entry, fs);
}

TTterm
TTparseVSC_fd_entry_file_and_sort_description_entry_clause( void )
{
    fparse fs[10];
    fs[0] = TTparseVSC_dd_entry_external_clause;
    fs[1] = TTparseVSC_dd_entry_global_clause;
    fs[2] = TTparseVSC_fd_entry_block_contains_clause;
    fs[3] = TTparseVSC_fd_entry_record_clause;
    fs[4] = TTparseVSC_fd_entry_label_records_clause;
    fs[5] = TTparseVSC_fd_entry_value_of_clause;
    fs[6] = TTparseVSC_fd_entry_data_records_clause;
    fs[7] = TTparseVSC_fd_entry_linage_clause;
    fs[8] = TTparseVSC_fd_entry_recording_mode_clause;
    fs[9] = TTparseVSC_fd_entry_code_set_clause;
    return TTparseVSC_DISJUNCTION(TTfunVSC_fd_entry_file_and_sort_description_entry_clause, 10, fs);
}

TTterm
TTparseVSC_fd_entry_file_and_sort_description_entry_clauses( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_fd_entry_file_and_sort_description_entry_clause_star;
    return TTparseVSC_CONJUNCTION(TTfunVSC_fd_entry_file_and_sort_description_entry_clauses, fs);
}

TTterm
TTparseVSC_fd_entry_footing( void )
{
    fparse fs[4];

    fs[0] = TTparset_WITH_opt;
    fs[1] = TTparset_FOOTING;
    fs[2] = TTparset_AT_opt;
    fs[3] = TTparseVSC_fd_entry_alt_data_name_integer;
    return TTparseVSC_CONJUNCTION(TTfunVSC_fd_entry_footing, fs);
}

TTterm
TTparseVSC_fd_entry_from_integer( void )
{
    fparse fs[2];

    fs[0] = TTparset_FROM_opt;
    fs[1] = TTparseVSC_expr_integer;
    return TTparseVSC_CONJUNCTION(TTfunVSC_fd_entry_from_integer, fs);
}

TTterm
TTparseVSC_fd_entry_label_records_clause( void )
{
    fparse fs[3];

    fs[0] = TTparset_LABEL;
    fs[1] = TTparseVSC_fd_entry_records_are;
    fs[2] = TTparseVSC_fd_entry_label_records_clause_tail;
    return TTparseVSC_CONJUNCTION(TTfunVSC_fd_entry_label_records_clause, fs);
}

TTterm
TTparseVSC_fd_entry_label_records_clause_tail( void )
{
    fparse fs[3];
    fs[0] = TTparset_STANDARD;
    fs[1] = TTparset_OMITTED;
    fs[2] = TTparseVSC_fd_entry_data_names;
    return TTparseVSC_DISJUNCTION(TTfunVSC_fd_entry_label_records_clause_tail, 3, fs);
}

TTterm
TTparseVSC_fd_entry_linage_clause( void )
{
    fparse fs[5];

    fs[0] = TTparset_LINAGE;
    fs[1] = TTparset_IS_opt;
    fs[2] = TTparseVSC_fd_entry_alt_data_name_integer;
    fs[3] = TTparset_LINES_opt;
    fs[4] = TTparseVSC_fd_entry_linage_footing_phrase;
    return TTparseVSC_CONJUNCTION(TTfunVSC_fd_entry_linage_clause, fs);
}

TTterm
TTparseVSC_fd_entry_linage_footing_phrase( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_fd_entry_footing_opt;
    fs[1] = TTparseVSC_fd_entry_lines_top_opt;
    fs[2] = TTparseVSC_fd_entry_lines_bottom_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_fd_entry_linage_footing_phrase, fs);
}

TTterm
TTparseVSC_fd_entry_lines_bottom( void )
{
    fparse fs[4];

    fs[0] = TTparset_LINES_opt;
    fs[1] = TTparset_AT_opt;
    fs[2] = TTparset_BOTTOM;
    fs[3] = TTparseVSC_fd_entry_alt_data_name_integer;
    return TTparseVSC_CONJUNCTION(TTfunVSC_fd_entry_lines_bottom, fs);
}

TTterm
TTparseVSC_fd_entry_lines_top( void )
{
    fparse fs[4];

    fs[0] = TTparset_LINES_opt;
    fs[1] = TTparset_AT_opt;
    fs[2] = TTparset_TOP;
    fs[3] = TTparseVSC_fd_entry_alt_data_name_integer;
    return TTparseVSC_CONJUNCTION(TTfunVSC_fd_entry_lines_top, fs);
}

TTterm
TTparseVSC_fd_entry_record_clause( void )
{
    fparse fs[2];

    fs[0] = TTparset_RECORD;
    fs[1] = TTparseVSC_fd_entry_record_clause_tail;
    return TTparseVSC_CONJUNCTION(TTfunVSC_fd_entry_record_clause, fs);
}

TTterm
TTparseVSC_fd_entry_record_clause_tail( void )
{
    fparse fs[3];
    fs[0] = TTparseVSC_fd_entry_record_clause_tail_2;
    fs[1] = TTparseVSC_fd_entry_record_clause_tail_1;
    fs[2] = TTparseVSC_fd_entry_record_clause_tail_3;
    return TTparseVSC_DISJUNCTION(TTfunVSC_fd_entry_record_clause_tail, 3, fs);
}

TTterm
TTparseVSC_fd_entry_record_clause_tail_1( void )
{
    fparse fs[3];

    fs[0] = TTparset_CONTAINS_opt;
    fs[1] = TTparseVSC_expr_integer;
    fs[2] = TTparset_CHARACTERS_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_fd_entry_record_clause_tail_1, fs);
}

TTterm
TTparseVSC_fd_entry_record_clause_tail_2( void )
{
    fparse fs[5];

    fs[0] = TTparset_CONTAINS_opt;
    fs[1] = TTparseVSC_expr_integer;
    fs[2] = TTparset_TO;
    fs[3] = TTparseVSC_expr_integer;
    fs[4] = TTparset_CHARACTERS_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_fd_entry_record_clause_tail_2, fs);
}

TTterm
TTparseVSC_fd_entry_record_clause_tail_3( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_fd_entry_record_varying_phrase;
    fs[1] = TTparseVSC_fd_entry_depending_on_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_fd_entry_record_clause_tail_3, fs);
}

TTterm
TTparseVSC_fd_entry_record_varying_phrase( void )
{
    fparse fs[7];

    fs[0] = TTparset_IS_opt;
    fs[1] = TTparset_VARYING;
    fs[2] = TTparset_IN_opt;
    fs[3] = TTparset_SIZE_opt;
    fs[4] = TTparseVSC_fd_entry_from_integer_opt;
    fs[5] = TTparseVSC_fd_entry_to_integer_opt;
    fs[6] = TTparset_CHARACTERS_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_fd_entry_record_varying_phrase, fs);
}

TTterm
TTparseVSC_fd_entry_recording_mode_clause( void )
{
    fparse fs[4];

    fs[0] = TTparset_RECORDING;
    fs[1] = TTparset_MODE_opt;
    fs[2] = TTparset_IS_opt;
    fs[3] = TTparseVSC_lex_cobword;
    return TTparseVSC_CONJUNCTION(TTfunVSC_fd_entry_recording_mode_clause, fs);
}

TTterm
TTparseVSC_fd_entry_records_are( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_records;
    fs[1] = TTparseVSC_conf_sec_are_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_fd_entry_records_are, fs);
}

TTterm
TTparseVSC_fd_entry_to_integer( void )
{
    fparse fs[2];

    fs[0] = TTparset_TO;
    fs[1] = TTparseVSC_expr_integer;
    return TTparseVSC_CONJUNCTION(TTfunVSC_fd_entry_to_integer, fs);
}

TTterm
TTparseVSC_fd_entry_value_of_clause( void )
{
    fparse fs[3];

    fs[0] = TTparset_VALUE;
    fs[1] = TTparset_OF;
    fs[2] = TTparseVSC_fd_entry_value_of_clause_tail_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_fd_entry_value_of_clause, fs);
}

TTterm
TTparseVSC_fd_entry_value_of_clause_tail( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_expr_system_name;
    fs[1] = TTparset_IS_opt;
    fs[2] = TTparseVSC_fd_entry_alt_qualified_data_name_literal;
    return TTparseVSC_CONJUNCTION(TTfunVSC_fd_entry_value_of_clause_tail, fs);
}

TTterm
TTparseVSC_id_div_author( void )
{
    fparse fs[2];

    fs[0] = TTparset_AUTHOR;
    fs[1] = TTparset_qdot_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_id_div_author, fs);
}

TTterm
TTparseVSC_id_div_date_compiled( void )
{
    fparse fs[2];

    fs[0] = TTparset_DATE_COMPILED;
    fs[1] = TTparset_qdot_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_id_div_date_compiled, fs);
}

TTterm
TTparseVSC_id_div_date_written( void )
{
    fparse fs[2];

    fs[0] = TTparset_DATE_WRITTEN;
    fs[1] = TTparset_qdot_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_id_div_date_written, fs);
}

TTterm
TTparseVSC_id_div_identification( void )
{
    fparse fs[2];
    fs[0] = TTparset_IDENTIFICATION;
    fs[1] = TTparset_ID;
    return TTparseVSC_DISJUNCTION(TTfunVSC_id_div_identification, 2, fs);
}

TTterm
TTparseVSC_id_div_identification_division( void )
{
    fparse fs[5];

    fs[0] = TTparseVSC_id_div_identification;
    fs[1] = TTparset_DIVISION;
    fs[2] = TTparset_qdot;
    fs[3] = TTparseVSC_id_div_program_id_cobol_source_program;
    fs[4] = TTparseVSC_id_div_identification_division_content;
    return TTparseVSC_CONJUNCTION(TTfunVSC_id_div_identification_division, fs);
}

TTterm
TTparseVSC_id_div_identification_division_content( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_id_div_identification_division_phrase_star;
    return TTparseVSC_CONJUNCTION(TTfunVSC_id_div_identification_division_content, fs);
}

TTterm
TTparseVSC_id_div_identification_division_phrase( void )
{
    fparse fs[6];
    fs[0] = TTparseVSC_id_div_author;
    fs[1] = TTparseVSC_id_div_installation;
    fs[2] = TTparseVSC_id_div_date_written;
    fs[3] = TTparseVSC_id_div_date_compiled;
    fs[4] = TTparseVSC_id_div_security;
    fs[5] = TTparseVSC_id_div_remarks;
    return TTparseVSC_DISJUNCTION(TTfunVSC_id_div_identification_division_phrase, 6, fs);
}

TTterm
TTparseVSC_id_div_initial_program( void )
{
    fparse fs[3];

    fs[0] = TTparset_IS_opt;
    fs[1] = TTparset_INITIAL;
    fs[2] = TTparset_PROGRAM_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_id_div_initial_program, fs);
}

TTterm
TTparseVSC_id_div_installation( void )
{
    fparse fs[2];

    fs[0] = TTparset_INSTALLATION;
    fs[1] = TTparset_qdot_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_id_div_installation, fs);
}

TTterm
TTparseVSC_id_div_program_id_cobol_source_program( void )
{
    fparse fs[5];

    fs[0] = TTparset_PROGRAM_ID;
    fs[1] = TTparset_qdot_opt;
    fs[2] = TTparseVSC_expr_program_name;
    fs[3] = TTparseVSC_id_div_initial_program_opt;
    fs[4] = TTparset_qdot_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_id_div_program_id_cobol_source_program, fs);
}

TTterm
TTparseVSC_id_div_remarks( void )
{
    fparse fs[2];

    fs[0] = TTparset_REMARKS;
    fs[1] = TTparset_qdot_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_id_div_remarks, fs);
}

TTterm
TTparseVSC_id_div_security( void )
{
    fparse fs[2];

    fs[0] = TTparset_SECURITY;
    fs[1] = TTparset_qdot_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_id_div_security, fs);
}

TTterm
TTparseVSC_io_sec_alt_assignment_name_file_name( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_expr_assignment_name;
    fs[1] = TTparseVSC_expr_file_name;
    return TTparseVSC_DISJUNCTION(TTfunVSC_io_sec_alt_assignment_name_file_name, 2, fs);
}

TTterm
TTparseVSC_io_sec_alt_assignment_name_literal( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_expr_assignment_name;
    fs[1] = TTparseVSC_expr_literal;
    return TTparseVSC_DISJUNCTION(TTfunVSC_io_sec_alt_assignment_name_literal, 2, fs);
}

TTterm
TTparseVSC_io_sec_alt_indexed_relative_sequential( void )
{
    fparse fs[3];
    fs[0] = TTparset_INDEXED;
    fs[1] = TTparset_RELATIVE;
    fs[2] = TTparset_SEQUENTIAL;
    return TTparseVSC_DISJUNCTION(TTfunVSC_io_sec_alt_indexed_relative_sequential, 3, fs);
}

TTterm
TTparseVSC_io_sec_alt_sequential_random_dynamic( void )
{
    fparse fs[3];
    fs[0] = TTparset_SEQUENTIAL;
    fs[1] = TTparset_RANDOM;
    fs[2] = TTparset_DYNAMIC;
    return TTparseVSC_DISJUNCTION(TTfunVSC_io_sec_alt_sequential_random_dynamic, 3, fs);
}

TTterm
TTparseVSC_io_sec_alternate_record_key_clause( void )
{
    fparse fs[7];

    fs[0] = TTparset_ALTERNATE;
    fs[1] = TTparset_RECORD_opt;
    fs[2] = TTparset_KEY_opt;
    fs[3] = TTparset_IS_opt;
    fs[4] = TTparseVSC_expr_qualified_data_name;
    fs[5] = TTparseVSC_io_sec_password_clause_opt;
    fs[6] = TTparseVSC_io_sec_with_duplicates_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_alternate_record_key_clause, fs);
}

TTterm
TTparseVSC_io_sec_areas( void )
{
    fparse fs[2];
    fs[0] = TTparset_AREA;
    fs[1] = TTparset_AREAS;
    return TTparseVSC_DISJUNCTION(TTfunVSC_io_sec_areas, 2, fs);
}

TTterm
TTparseVSC_io_sec_assign_clause( void )
{
    fparse fs[3];

    fs[0] = TTparset_ASSIGN;
    fs[1] = TTparset_TO_opt;
    fs[2] = TTparseVSC_io_sec_alt_assignment_name_literal_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_assign_clause, fs);
}

TTterm
TTparseVSC_io_sec_every_phrase( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_io_sec_every_phrase_1;
    fs[1] = TTparseVSC_io_sec_every_phrase_2;
    return TTparseVSC_DISJUNCTION(TTfunVSC_io_sec_every_phrase, 2, fs);
}

TTterm
TTparseVSC_io_sec_every_phrase_1( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_integer;
    fs[1] = TTparset_RECORDS;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_every_phrase_1, fs);
}

TTterm
TTparseVSC_io_sec_every_phrase_2( void )
{
    fparse fs[3];

    fs[0] = TTparset_END;
    fs[1] = TTparset_OF_opt;
    fs[2] = TTparseVSC_expr_alt_reel_unit;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_every_phrase_2, fs);
}

TTterm
TTparseVSC_io_sec_fce_access_mode( void )
{
    fparse fs[5];

    fs[0] = TTparset_ACCESS;
    fs[1] = TTparset_MODE_opt;
    fs[2] = TTparset_IS_opt;
    fs[3] = TTparseVSC_io_sec_alt_sequential_random_dynamic;
    fs[4] = TTparseVSC_io_sec_relative_key_clause_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_fce_access_mode, fs);
}

TTterm
TTparseVSC_io_sec_fce_organization( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_io_sec_organization_is_opt;
    fs[1] = TTparseVSC_io_sec_alt_indexed_relative_sequential;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_fce_organization, fs);
}

TTterm
TTparseVSC_io_sec_fce_phrase( void )
{
    fparse fs[9];
    fs[0] = TTparseVSC_io_sec_reserve_clause;
    fs[1] = TTparseVSC_io_sec_fce_organization;
    fs[2] = TTparseVSC_io_sec_fce_access_mode;
    fs[3] = TTparseVSC_io_sec_record_key_clause;
    fs[4] = TTparseVSC_io_sec_password_clause;
    fs[5] = TTparseVSC_io_sec_alternate_record_key_clause;
    fs[6] = TTparseVSC_io_sec_file_status_clause;
    fs[7] = TTparseVSC_io_sec_padding_character_clause;
    fs[8] = TTparseVSC_io_sec_record_delimiter_clause;
    return TTparseVSC_DISJUNCTION(TTfunVSC_io_sec_fce_phrase, 9, fs);
}

TTterm
TTparseVSC_io_sec_file_control_entry( void )
{
    fparse fs[4];

    fs[0] = TTparseVSC_io_sec_select_clause;
    fs[1] = TTparseVSC_io_sec_assign_clause;
    fs[2] = TTparseVSC_io_sec_fce_phrase_star;
    fs[3] = TTparset_qdot;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_file_control_entry, fs);
}

TTterm
TTparseVSC_io_sec_file_control_paragraph( void )
{
    fparse fs[3];

    fs[0] = TTparset_FILE_CONTROL;
    fs[1] = TTparset_qdot;
    fs[2] = TTparseVSC_io_sec_file_control_entry_star;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_file_control_paragraph, fs);
}

TTterm
TTparseVSC_io_sec_file_name_position( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_file_name;
    fs[1] = TTparseVSC_io_sec_position_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_file_name_position, fs);
}

TTterm
TTparseVSC_io_sec_file_status_clause( void )
{
    fparse fs[5];

    fs[0] = TTparset_FILE_opt;
    fs[1] = TTparset_STATUS;
    fs[2] = TTparset_IS_opt;
    fs[3] = TTparseVSC_expr_qualified_data_name;
    fs[4] = TTparseVSC_expr_qualified_data_name_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_file_status_clause, fs);
}

TTterm
TTparseVSC_io_sec_i_o_control_paragraph( void )
{
    fparse fs[4];

    fs[0] = TTparset_I_O_CONTROL;
    fs[1] = TTparset_qdot;
    fs[2] = TTparseVSC_io_sec_i_o_sam_opt;
    fs[3] = TTparseVSC_io_sec_i_o_sort_merge_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_i_o_control_paragraph, fs);
}

TTterm
TTparseVSC_io_sec_i_o_sam( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_plus;
    fs[1] = TTparset_qdot;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_i_o_sam, fs);
}

TTterm
TTparseVSC_io_sec_i_o_sort_merge( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_io_sec_sort_merge_i_o_control_entries;
    fs[1] = TTparset_qdot;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_i_o_sort_merge, fs);
}

TTterm
TTparseVSC_io_sec_input_output_section( void )
{
    fparse fs[5];

    fs[0] = TTparset_INPUT_OUTPUT;
    fs[1] = TTparset_SECTION;
    fs[2] = TTparset_qdot;
    fs[3] = TTparseVSC_io_sec_file_control_paragraph_opt;
    fs[4] = TTparseVSC_io_sec_i_o_control_paragraph_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_input_output_section, fs);
}

TTterm
TTparseVSC_io_sec_organization_is( void )
{
    fparse fs[2];

    fs[0] = TTparset_ORGANIZATION;
    fs[1] = TTparset_IS_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_organization_is, fs);
}

TTterm
TTparseVSC_io_sec_padding_character_clause( void )
{
    fparse fs[4];

    fs[0] = TTparset_PADDING;
    fs[1] = TTparset_CHARACTER_opt;
    fs[2] = TTparset_IS_opt;
    fs[3] = TTparseVSC_fd_entry_alt_qualified_data_name_literal;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_padding_character_clause, fs);
}

TTterm
TTparseVSC_io_sec_password_clause( void )
{
    fparse fs[3];

    fs[0] = TTparset_PASSWORD;
    fs[1] = TTparset_IS_opt;
    fs[2] = TTparseVSC_expr_data_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_password_clause, fs);
}

TTterm
TTparseVSC_io_sec_position( void )
{
    fparse fs[2];

    fs[0] = TTparset_POSITION;
    fs[1] = TTparseVSC_expr_integer;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_position, fs);
}

TTterm
TTparseVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries( void )
{
    fparse fs[4];
    fs[0] = TTparseVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_1;
    fs[1] = TTparseVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_2;
    fs[2] = TTparseVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_3;
    fs[3] = TTparseVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_4;
    return TTparseVSC_DISJUNCTION(TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries, 4, fs);
}

TTterm
TTparseVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_1( void )
{
    fparse fs[7];

    fs[0] = TTparset_RERUN;
    fs[1] = TTparset_ON;
    fs[2] = TTparseVSC_io_sec_alt_assignment_name_file_name;
    fs[3] = TTparset_EVERY_opt;
    fs[4] = TTparseVSC_io_sec_every_phrase;
    fs[5] = TTparset_OF_opt;
    fs[6] = TTparseVSC_expr_file_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_1, fs);
}

TTterm
TTparseVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_2( void )
{
    fparse fs[6];

    fs[0] = TTparset_SAME;
    fs[1] = TTparset_RECORD_opt;
    fs[2] = TTparset_AREA_opt;
    fs[3] = TTparset_FOR_opt;
    fs[4] = TTparseVSC_expr_file_name;
    fs[5] = TTparseVSC_expr_file_name_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_2, fs);
}

TTterm
TTparseVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_3( void )
{
    fparse fs[5];

    fs[0] = TTparset_MULTIPLE;
    fs[1] = TTparset_FILE;
    fs[2] = TTparset_TAPE_opt;
    fs[3] = TTparset_CONTAINS_opt;
    fs[4] = TTparseVSC_io_sec_file_name_position_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_3, fs);
}

TTterm
TTparseVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_4( void )
{
    fparse fs[4];

    fs[0] = TTparset_APPLY;
    fs[1] = TTparset_WRITE_ONLY;
    fs[2] = TTparset_ON_opt;
    fs[3] = TTparseVSC_expr_file_name_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_4, fs);
}

TTterm
TTparseVSC_io_sec_record_delimiter_clause( void )
{
    fparse fs[4];

    fs[0] = TTparset_RECORD;
    fs[1] = TTparset_DELIMITER;
    fs[2] = TTparset_IS_opt;
    fs[3] = TTparseVSC_io_sec_record_delimiter_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_record_delimiter_clause, fs);
}

TTterm
TTparseVSC_io_sec_record_delimiter_name( void )
{
    fparse fs[2];
    fs[0] = TTparset_STANDARD_1;
    fs[1] = TTparseVSC_expr_assignment_name;
    return TTparseVSC_DISJUNCTION(TTfunVSC_io_sec_record_delimiter_name, 2, fs);
}

TTterm
TTparseVSC_io_sec_record_key_clause( void )
{
    fparse fs[4];

    fs[0] = TTparset_RECORD;
    fs[1] = TTparset_KEY_opt;
    fs[2] = TTparset_IS_opt;
    fs[3] = TTparseVSC_expr_qualified_data_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_record_key_clause, fs);
}

TTterm
TTparseVSC_io_sec_record_sort( void )
{
    fparse fs[3];
    fs[0] = TTparset_RECORD;
    fs[1] = TTparset_SORT;
    fs[2] = TTparset_SORT_MERGE;
    return TTparseVSC_DISJUNCTION(TTfunVSC_io_sec_record_sort, 3, fs);
}

TTterm
TTparseVSC_io_sec_relative_key_clause( void )
{
    fparse fs[4];

    fs[0] = TTparset_RELATIVE;
    fs[1] = TTparset_KEY_opt;
    fs[2] = TTparset_IS_opt;
    fs[3] = TTparseVSC_expr_qualified_data_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_relative_key_clause, fs);
}

TTterm
TTparseVSC_io_sec_rerun_on( void )
{
    fparse fs[3];

    fs[0] = TTparset_RERUN;
    fs[1] = TTparset_ON;
    fs[2] = TTparseVSC_expr_assignment_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_rerun_on, fs);
}

TTterm
TTparseVSC_io_sec_reserve_clause( void )
{
    fparse fs[3];

    fs[0] = TTparset_RESERVE;
    fs[1] = TTparseVSC_expr_integer;
    fs[2] = TTparseVSC_io_sec_areas_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_reserve_clause, fs);
}

TTterm
TTparseVSC_io_sec_same_area( void )
{
    fparse fs[6];

    fs[0] = TTparset_SAME;
    fs[1] = TTparseVSC_io_sec_record_sort;
    fs[2] = TTparset_AREA_opt;
    fs[3] = TTparset_FOR_opt;
    fs[4] = TTparseVSC_expr_file_name;
    fs[5] = TTparseVSC_expr_file_name_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_same_area, fs);
}

TTterm
TTparseVSC_io_sec_select_clause( void )
{
    fparse fs[3];

    fs[0] = TTparset_SELECT;
    fs[1] = TTparset_OPTIONAL_opt;
    fs[2] = TTparseVSC_expr_file_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_select_clause, fs);
}

TTterm
TTparseVSC_io_sec_sort_merge_i_o_control_entries( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_io_sec_rerun_on_opt;
    fs[1] = TTparseVSC_io_sec_same_area_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_sort_merge_i_o_control_entries, fs);
}

TTterm
TTparseVSC_io_sec_with_duplicates( void )
{
    fparse fs[2];

    fs[0] = TTparset_WITH_opt;
    fs[1] = TTparset_DUPLICATES;
    return TTparseVSC_CONJUNCTION(TTfunVSC_io_sec_with_duplicates, fs);
}

TTterm
TTparseVSC_main_cobol_source_program( void )
{
    fparse fs[5];

    fs[0] = TTparseVSC_id_div_identification_division;
    fs[1] = TTparseVSC_env_div_environment_division_opt;
    fs[2] = TTparseVSC_data_div_data_division_opt;
    fs[3] = TTparseVSC_proc_div_procedure_division_opt;
    fs[4] = TTparseVSC_main_nested_program_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_main_cobol_source_program, fs);
}

TTterm
TTparseVSC_main_common_initial( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_main_common_initial_1;
    fs[1] = TTparseVSC_main_common_initial_2;
    return TTparseVSC_DISJUNCTION(TTfunVSC_main_common_initial, 2, fs);
}

TTterm
TTparseVSC_main_common_initial_1( void )
{
    fparse fs[2];

    fs[0] = TTparset_COMMON;
    fs[1] = TTparset_INITIAL_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_main_common_initial_1, fs);
}

TTterm
TTparseVSC_main_common_initial_2( void )
{
    fparse fs[2];

    fs[0] = TTparset_INITIAL;
    fs[1] = TTparset_COMMON_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_main_common_initial_2, fs);
}

TTterm
TTparseVSC_main_common_initial_program( void )
{
    fparse fs[3];

    fs[0] = TTparset_IS_opt;
    fs[1] = TTparseVSC_main_common_initial;
    fs[2] = TTparset_PROGRAM_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_main_common_initial_program, fs);
}

TTterm
TTparseVSC_main_nested_cobol_source_program( void )
{
    fparse fs[13];

    fs[0] = TTparseVSC_id_div_identification;
    fs[1] = TTparset_DIVISION;
    fs[2] = TTparset_qdot;
    fs[3] = TTparseVSC_main_program_id_nested_cobol_source_program;
    fs[4] = TTparseVSC_id_div_identification_division_content_opt;
    fs[5] = TTparseVSC_env_div_environment_division_opt;
    fs[6] = TTparseVSC_data_div_data_division_opt;
    fs[7] = TTparseVSC_proc_div_procedure_division_opt;
    fs[8] = TTparseVSC_main_nested_cobol_source_program_star;
    fs[9] = TTparset_END;
    fs[10] = TTparset_PROGRAM;
    fs[11] = TTparseVSC_expr_program_name;
    fs[12] = TTparset_qdot;
    return TTparseVSC_CONJUNCTION(TTfunVSC_main_nested_cobol_source_program, fs);
}

TTterm
TTparseVSC_main_nested_program( void )
{
    fparse fs[5];

    fs[0] = TTparseVSC_main_nested_cobol_source_program_star;
    fs[1] = TTparset_END;
    fs[2] = TTparset_PROGRAM;
    fs[3] = TTparseVSC_expr_program_name;
    fs[4] = TTparset_qdot;
    return TTparseVSC_CONJUNCTION(TTfunVSC_main_nested_program, fs);
}

TTterm
TTparseVSC_main_program_id_nested_cobol_source_program( void )
{
    fparse fs[5];

    fs[0] = TTparset_PROGRAM_ID;
    fs[1] = TTparset_qdot_opt;
    fs[2] = TTparseVSC_expr_program_name;
    fs[3] = TTparseVSC_main_common_initial_program_opt;
    fs[4] = TTparset_qdot_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_main_program_id_nested_cobol_source_program, fs);
}

TTterm
TTparseVSC_main_programs( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_main_cobol_source_program_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_main_programs, fs);
}

TTterm
TTparseVSC_proc_div_altered_goto( void )
{
    fparse fs[5];

    fs[0] = TTparseVSC_expr_paragraph_name;
    fs[1] = TTparset_qdot;
    fs[2] = TTparset_GO;
    fs[3] = TTparset_TO_opt;
    fs[4] = TTparset_qdot;
    return TTparseVSC_CONJUNCTION(TTfunVSC_proc_div_altered_goto, fs);
}

TTterm
TTparseVSC_proc_div_declaratives( void )
{
    fparse fs[6];

    fs[0] = TTparset_DECLARATIVES;
    fs[1] = TTparset_qdot;
    fs[2] = TTparseVSC_proc_div_declaratives_content_plus;
    fs[3] = TTparset_END;
    fs[4] = TTparset_DECLARATIVES;
    fs[5] = TTparset_qdot;
    return TTparseVSC_CONJUNCTION(TTfunVSC_proc_div_declaratives, fs);
}

TTterm
TTparseVSC_proc_div_declaratives_content( void )
{
    fparse fs[5];

    fs[0] = TTparseVSC_proc_div_section_header;
    fs[1] = TTparset_qdot;
    fs[2] = TTparseVSC_stat_use_statement;
    fs[3] = TTparset_qdot;
    fs[4] = TTparseVSC_proc_div_paragraphs;
    return TTparseVSC_CONJUNCTION(TTfunVSC_proc_div_declaratives_content, fs);
}

TTterm
TTparseVSC_proc_div_paragraph( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_proc_div_altered_goto;
    fs[1] = TTparseVSC_proc_div_paragraph_1;
    return TTparseVSC_DISJUNCTION(TTfunVSC_proc_div_paragraph, 2, fs);
}

TTterm
TTparseVSC_proc_div_paragraph_1( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_expr_paragraph_name;
    fs[1] = TTparset_qdot;
    fs[2] = TTparseVSC_proc_div_sentence_star;
    return TTparseVSC_CONJUNCTION(TTfunVSC_proc_div_paragraph_1, fs);
}

TTterm
TTparseVSC_proc_div_paragraphs( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_proc_div_sentence_star;
    fs[1] = TTparseVSC_proc_div_paragraph_star;
    return TTparseVSC_CONJUNCTION(TTfunVSC_proc_div_paragraphs, fs);
}

TTterm
TTparseVSC_proc_div_procedure_division( void )
{
    fparse fs[5];

    fs[0] = TTparset_PROCEDURE;
    fs[1] = TTparset_DIVISION;
    fs[2] = TTparseVSC_proc_div_using_phrase;
    fs[3] = TTparseVSC_proc_div_declaratives_opt;
    fs[4] = TTparseVSC_proc_div_sections;
    return TTparseVSC_CONJUNCTION(TTfunVSC_proc_div_procedure_division, fs);
}

TTterm
TTparseVSC_proc_div_section_header( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_expr_section_name;
    fs[1] = TTparset_SECTION;
    fs[2] = TTparseVSC_expr_priority_number_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_proc_div_section_header, fs);
}

TTterm
TTparseVSC_proc_div_section_with_header( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_proc_div_section_header;
    fs[1] = TTparset_qdot;
    fs[2] = TTparseVSC_proc_div_paragraphs;
    return TTparseVSC_CONJUNCTION(TTfunVSC_proc_div_section_with_header, fs);
}

TTterm
TTparseVSC_proc_div_sections( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_proc_div_paragraphs;
    fs[1] = TTparseVSC_proc_div_section_with_header_star;
    return TTparseVSC_CONJUNCTION(TTfunVSC_proc_div_sections, fs);
}

TTterm
TTparseVSC_proc_div_sentence( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_proc_div_sentence_1;
    fs[1] = TTparseVSC_proc_div_sentence_2;
    return TTparseVSC_DISJUNCTION(TTfunVSC_proc_div_sentence, 2, fs);
}

TTterm
TTparseVSC_proc_div_sentence_1( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_stat_statement_list;
    fs[1] = TTparset_qdot_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_proc_div_sentence_1, fs);
}

TTterm
TTparseVSC_proc_div_sentence_2( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_stat_statement_list_opt;
    fs[1] = TTparseVSC_expr_copy_statement;
    return TTparseVSC_CONJUNCTION(TTfunVSC_proc_div_sentence_2, fs);
}

TTterm
TTparseVSC_proc_div_using_data_names( void )
{
    fparse fs[2];

    fs[0] = TTparset_USING;
    fs[1] = TTparseVSC_expr_data_name_star;
    return TTparseVSC_CONJUNCTION(TTfunVSC_proc_div_using_data_names, fs);
}

TTterm
TTparseVSC_proc_div_using_phrase( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_proc_div_using_phrase_1;
    fs[1] = TTparseVSC_proc_div_using_phrase_2;
    return TTparseVSC_DISJUNCTION(TTfunVSC_proc_div_using_phrase, 2, fs);
}

TTterm
TTparseVSC_proc_div_using_phrase_1( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_stat_using_data_name_pluslist_opt;
    fs[1] = TTparset_qdot;
    return TTparseVSC_CONJUNCTION(TTfunVSC_proc_div_using_phrase_1, fs);
}

TTterm
TTparseVSC_proc_div_using_phrase_2( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_proc_div_using_data_names_opt;
    fs[1] = TTparseVSC_expr_copy_statement;
    return TTparseVSC_CONJUNCTION(TTfunVSC_proc_div_using_phrase_2, fs);
}

TTterm
TTparseVSC_stat_accept_statement( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_stat_accept_statement_2;
    fs[1] = TTparseVSC_stat_accept_statement_1;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_accept_statement, 2, fs);
}

TTterm
TTparseVSC_stat_accept_statement_1( void )
{
    fparse fs[3];

    fs[0] = TTparset_ACCEPT;
    fs[1] = TTparseVSC_expr_identifier;
    fs[2] = TTparseVSC_stat_from_environment_name_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_accept_statement_1, fs);
}

TTterm
TTparseVSC_stat_accept_statement_2( void )
{
    fparse fs[4];

    fs[0] = TTparset_ACCEPT;
    fs[1] = TTparseVSC_expr_identifier;
    fs[2] = TTparset_FROM;
    fs[3] = TTparseVSC_stat_date;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_accept_statement_2, fs);
}

TTterm
TTparseVSC_stat_add_statement( void )
{
    fparse fs[3];
    fs[0] = TTparseVSC_stat_add_statement_2;
    fs[1] = TTparseVSC_stat_add_statement_1;
    fs[2] = TTparseVSC_stat_add_statement_3;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_add_statement, 3, fs);
}

TTterm
TTparseVSC_stat_add_statement_1( void )
{
    fparse fs[7];

    fs[0] = TTparset_ADD;
    fs[1] = TTparseVSC_stat_id_or_lit_plus;
    fs[2] = TTparset_TO;
    fs[3] = TTparseVSC_stat_cobword_rounded_plus;
    fs[4] = TTparseVSC_stat_on_size_error_statement_list_opt;
    fs[5] = TTparseVSC_stat_not_on_size_error_statement_list_opt;
    fs[6] = TTparset_END_ADD_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_add_statement_1, fs);
}

TTterm
TTparseVSC_stat_add_statement_2( void )
{
    fparse fs[8];

    fs[0] = TTparset_ADD;
    fs[1] = TTparseVSC_stat_id_or_lit_plus;
    fs[2] = TTparseVSC_stat_to_id_or_lit_opt;
    fs[3] = TTparset_GIVING;
    fs[4] = TTparseVSC_stat_cobword_rounded_plus;
    fs[5] = TTparseVSC_stat_on_size_error_statement_list_opt;
    fs[6] = TTparseVSC_stat_not_on_size_error_statement_list_opt;
    fs[7] = TTparset_END_ADD_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_add_statement_2, fs);
}

TTterm
TTparseVSC_stat_add_statement_3( void )
{
    fparse fs[9];

    fs[0] = TTparset_ADD;
    fs[1] = TTparseVSC_stat_corresponding;
    fs[2] = TTparseVSC_expr_identifier;
    fs[3] = TTparset_TO;
    fs[4] = TTparseVSC_expr_identifier;
    fs[5] = TTparset_ROUNDED_opt;
    fs[6] = TTparseVSC_stat_on_size_error_statement_list_opt;
    fs[7] = TTparseVSC_stat_not_on_size_error_statement_list_opt;
    fs[8] = TTparset_END_ADD_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_add_statement_3, fs);
}

TTterm
TTparseVSC_stat_advancing_phrase( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_stat_alt_before_after;
    fs[1] = TTparset_ADVANCING_opt;
    fs[2] = TTparseVSC_stat_page_phrase;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_advancing_phrase, fs);
}

TTterm
TTparseVSC_stat_all_procedures( void )
{
    fparse fs[2];

    fs[0] = TTparset_ALL;
    fs[1] = TTparset_PROCEDURES;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_all_procedures, fs);
}

TTterm
TTparseVSC_stat_also_phrase( void )
{
    fparse fs[2];

    fs[0] = TTparset_ALSO;
    fs[1] = TTparseVSC_stat_evaluate_condition;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_also_phrase, fs);
}

TTterm
TTparseVSC_stat_alt_all_leading( void )
{
    fparse fs[2];
    fs[0] = TTparset_ALL;
    fs[1] = TTparset_LEADING;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_alt_all_leading, 2, fs);
}

TTterm
TTparseVSC_stat_alt_all_leading_first( void )
{
    fparse fs[3];
    fs[0] = TTparset_ALL;
    fs[1] = TTparset_LEADING;
    fs[2] = TTparset_FIRST;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_alt_all_leading_first, 3, fs);
}

TTterm
TTparseVSC_stat_alt_before_after( void )
{
    fparse fs[2];
    fs[0] = TTparset_BEFORE;
    fs[1] = TTparset_AFTER;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_alt_before_after, 2, fs);
}

TTterm
TTparseVSC_stat_alt_beginning_ending( void )
{
    fparse fs[2];
    fs[0] = TTparset_BEGINNING;
    fs[1] = TTparset_ENDING;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_alt_beginning_ending, 2, fs);
}

TTterm
TTparseVSC_stat_alt_exception_error( void )
{
    fparse fs[2];
    fs[0] = TTparset_EXCEPTION;
    fs[1] = TTparset_ERROR;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_alt_exception_error, 2, fs);
}

TTterm
TTparseVSC_stat_alt_file_names_i_o( void )
{
    fparse fs[5];
    fs[0] = TTparseVSC_stat_file_names;
    fs[1] = TTparset_INPUT;
    fs[2] = TTparset_OUTPUT;
    fs[3] = TTparset_I_O;
    fs[4] = TTparset_EXTEND;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_alt_file_names_i_o, 5, fs);
}

TTterm
TTparseVSC_stat_alt_file_reel_unit( void )
{
    fparse fs[3];
    fs[0] = TTparset_FILE;
    fs[1] = TTparset_REEL;
    fs[2] = TTparset_UNIT;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_alt_file_reel_unit, 3, fs);
}

TTterm
TTparseVSC_stat_alt_no_rewind_lock( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_stat_no_rewind;
    fs[1] = TTparset_LOCK;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_alt_no_rewind_lock, 2, fs);
}

TTterm
TTparseVSC_stat_alt_procedures_all_procedures( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_stat_procedure_names;
    fs[1] = TTparseVSC_stat_all_procedures;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_alt_procedures_all_procedures, 2, fs);
}

TTterm
TTparseVSC_stat_alt_removal_no_rewind( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_stat_for_removal;
    fs[1] = TTparseVSC_stat_with_no_rewind;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_alt_removal_no_rewind, 2, fs);
}

TTterm
TTparseVSC_stat_alt_reversed_with_no_rewind( void )
{
    fparse fs[2];
    fs[0] = TTparset_REVERSED;
    fs[1] = TTparseVSC_stat_with_no_rewind;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_alt_reversed_with_no_rewind, 2, fs);
}

TTterm
TTparseVSC_stat_alt_run_literal( void )
{
    fparse fs[2];
    fs[0] = TTparset_RUN;
    fs[1] = TTparseVSC_expr_literal;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_alt_run_literal, 2, fs);
}

TTterm
TTparseVSC_stat_alt_statement_list_next_sentence( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_stat_statement_list;
    fs[1] = TTparseVSC_stat_next_sentence;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_alt_statement_list_next_sentence, 2, fs);
}

TTterm
TTparseVSC_stat_alt_up_down( void )
{
    fparse fs[2];
    fs[0] = TTparset_UP;
    fs[1] = TTparset_DOWN;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_alt_up_down, 2, fs);
}

TTterm
TTparseVSC_stat_alt_up_down_by( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_stat_alt_up_down;
    fs[1] = TTparset_BY;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_alt_up_down_by, fs);
}

TTterm
TTparseVSC_stat_alter_statement( void )
{
    fparse fs[2];

    fs[0] = TTparset_ALTER;
    fs[1] = TTparseVSC_stat_procedure_to_procedure_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_alter_statement, fs);
}

TTterm
TTparseVSC_stat_at_end_of_page_statement_list( void )
{
    fparse fs[3];

    fs[0] = TTparset_AT_opt;
    fs[1] = TTparseVSC_stat_end_of_page;
    fs[2] = TTparseVSC_stat_statement_list;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_at_end_of_page_statement_list, fs);
}

TTterm
TTparseVSC_stat_at_end_statement_list( void )
{
    fparse fs[3];

    fs[0] = TTparset_AT_opt;
    fs[1] = TTparset_END;
    fs[2] = TTparseVSC_stat_statement_list;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_at_end_statement_list, fs);
}

TTterm
TTparseVSC_stat_before_after_phrase( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_stat_alt_before_after;
    fs[1] = TTparset_INITIAL_opt;
    fs[2] = TTparseVSC_stat_id_or_lit;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_before_after_phrase, fs);
}

TTterm
TTparseVSC_stat_by_reference( void )
{
    fparse fs[2];

    fs[0] = TTparset_BY_opt;
    fs[1] = TTparset_REFERENCE;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_by_reference, fs);
}

TTterm
TTparseVSC_stat_call_rest_phrase( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_stat_on_exception_statement_list_opt;
    fs[1] = TTparseVSC_stat_not_on_exception_statement_list_opt;
    fs[2] = TTparseVSC_stat_on_overflow_statement_list_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_call_rest_phrase, fs);
}

TTterm
TTparseVSC_stat_call_statement( void )
{
    fparse fs[5];

    fs[0] = TTparset_CALL;
    fs[1] = TTparseVSC_stat_id_or_lit;
    fs[2] = TTparseVSC_stat_using_parameters_opt;
    fs[3] = TTparseVSC_stat_call_rest_phrase;
    fs[4] = TTparset_END_CALL_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_call_statement, fs);
}

TTterm
TTparseVSC_stat_cancel_statement( void )
{
    fparse fs[2];

    fs[0] = TTparset_CANCEL;
    fs[1] = TTparseVSC_stat_id_or_lit_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_cancel_statement, fs);
}

TTterm
TTparseVSC_stat_close_statement( void )
{
    fparse fs[2];

    fs[0] = TTparset_CLOSE;
    fs[1] = TTparseVSC_stat_close_statement_file_name_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_close_statement, fs);
}

TTterm
TTparseVSC_stat_close_statement_file_name( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_file_name;
    fs[1] = TTparseVSC_stat_close_statement_options_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_close_statement_file_name, fs);
}

TTterm
TTparseVSC_stat_close_statement_options( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_stat_close_statement_options_1;
    fs[1] = TTparseVSC_stat_close_statement_options_2;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_close_statement_options, 2, fs);
}

TTterm
TTparseVSC_stat_close_statement_options_1( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_alt_reel_unit;
    fs[1] = TTparseVSC_stat_alt_removal_no_rewind_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_close_statement_options_1, fs);
}

TTterm
TTparseVSC_stat_close_statement_options_2( void )
{
    fparse fs[2];

    fs[0] = TTparset_WITH_opt;
    fs[1] = TTparseVSC_stat_alt_no_rewind_lock;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_close_statement_options_2, fs);
}

TTterm
TTparseVSC_stat_cobword_int( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_expr_identifier;
    fs[1] = TTparseVSC_expr_integer;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_cobword_int, 2, fs);
}

TTterm
TTparseVSC_stat_cobword_rounded( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_identifier;
    fs[1] = TTparset_ROUNDED_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_cobword_rounded, fs);
}

TTterm
TTparseVSC_stat_collating_sequence( void )
{
    fparse fs[4];

    fs[0] = TTparset_COLLATING_opt;
    fs[1] = TTparset_SEQUENCE;
    fs[2] = TTparset_IS_opt;
    fs[3] = TTparseVSC_expr_alphabet_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_collating_sequence, fs);
}

TTterm
TTparseVSC_stat_compute_statement( void )
{
    fparse fs[7];

    fs[0] = TTparset_COMPUTE;
    fs[1] = TTparseVSC_stat_cobword_rounded_plus;
    fs[2] = TTparseVSC_stat_equal;
    fs[3] = TTparseVSC_expr_arithmetic_expression;
    fs[4] = TTparseVSC_stat_on_size_error_statement_list_opt;
    fs[5] = TTparseVSC_stat_not_on_size_error_statement_list_opt;
    fs[6] = TTparset_END_COMPUTE_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_compute_statement, fs);
}

TTterm
TTparseVSC_stat_content_parameter( void )
{
    fparse fs[3];

    fs[0] = TTparset_BY_opt;
    fs[1] = TTparset_CONTENT;
    fs[2] = TTparseVSC_stat_content_parameter_value_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_content_parameter, fs);
}

TTterm
TTparseVSC_stat_content_parameter_value( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_expr_identifier;
    fs[1] = TTparseVSC_expr_literal;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_content_parameter_value, 2, fs);
}

TTterm
TTparseVSC_stat_continue_statement( void )
{
    fparse fs[1];

    fs[0] = TTparset_CONTINUE;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_continue_statement, fs);
}

TTterm
TTparseVSC_stat_corresponding( void )
{
    fparse fs[2];
    fs[0] = TTparset_CORRESPONDING;
    fs[1] = TTparset_CORR;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_corresponding, 2, fs);
}

TTterm
TTparseVSC_stat_count_in_identifier( void )
{
    fparse fs[3];

    fs[0] = TTparset_COUNT;
    fs[1] = TTparset_IN_opt;
    fs[2] = TTparseVSC_expr_identifier;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_count_in_identifier, fs);
}

TTterm
TTparseVSC_stat_date( void )
{
    fparse fs[4];
    fs[0] = TTparset_DATE;
    fs[1] = TTparset_DAY;
    fs[2] = TTparset_DAY_OF_WEEK;
    fs[3] = TTparset_TIME;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_date, 4, fs);
}

TTterm
TTparseVSC_stat_delete_statement( void )
{
    fparse fs[6];

    fs[0] = TTparset_DELETE;
    fs[1] = TTparseVSC_expr_file_name;
    fs[2] = TTparset_RECORD_opt;
    fs[3] = TTparseVSC_stat_invalid_key_statement_list_opt;
    fs[4] = TTparseVSC_stat_not_invalid_key_statement_list_opt;
    fs[5] = TTparset_END_DELETE_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_delete_statement, fs);
}

TTterm
TTparseVSC_stat_delimited_by_all_phrase( void )
{
    fparse fs[5];

    fs[0] = TTparset_DELIMITED;
    fs[1] = TTparset_BY_opt;
    fs[2] = TTparset_ALL_opt;
    fs[3] = TTparseVSC_stat_id_or_lit;
    fs[4] = TTparseVSC_stat_or_all_id_or_lit_star;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_delimited_by_all_phrase, fs);
}

TTterm
TTparseVSC_stat_delimited_by_phrase( void )
{
    fparse fs[4];

    fs[0] = TTparseVSC_stat_id_or_lit_plus;
    fs[1] = TTparset_DELIMITED;
    fs[2] = TTparset_BY_opt;
    fs[3] = TTparseVSC_stat_id_or_lit_size;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_delimited_by_phrase, fs);
}

TTterm
TTparseVSC_stat_delimiter_in_identifier( void )
{
    fparse fs[3];

    fs[0] = TTparset_DELIMITER;
    fs[1] = TTparset_IN_opt;
    fs[2] = TTparseVSC_expr_identifier;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_delimiter_in_identifier, fs);
}

TTterm
TTparseVSC_stat_display_statement( void )
{
    fparse fs[4];

    fs[0] = TTparset_DISPLAY;
    fs[1] = TTparseVSC_stat_id_or_lit_plus;
    fs[2] = TTparseVSC_stat_upon_environment_name_opt;
    fs[3] = TTparseVSC_stat_with_no_advancing_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_display_statement, fs);
}

TTterm
TTparseVSC_stat_divide_statement( void )
{
    fparse fs[5];
    fs[0] = TTparseVSC_stat_divide_statement_4;
    fs[1] = TTparseVSC_stat_divide_statement_5;
    fs[2] = TTparseVSC_stat_divide_statement_2;
    fs[3] = TTparseVSC_stat_divide_statement_3;
    fs[4] = TTparseVSC_stat_divide_statement_1;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_divide_statement, 5, fs);
}

TTterm
TTparseVSC_stat_divide_statement_1( void )
{
    fparse fs[7];

    fs[0] = TTparset_DIVIDE;
    fs[1] = TTparseVSC_stat_id_or_lit;
    fs[2] = TTparset_INTO;
    fs[3] = TTparseVSC_stat_cobword_rounded_plus;
    fs[4] = TTparseVSC_stat_on_size_error_statement_list_opt;
    fs[5] = TTparseVSC_stat_not_on_size_error_statement_list_opt;
    fs[6] = TTparset_END_DIVIDE_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_divide_statement_1, fs);
}

TTterm
TTparseVSC_stat_divide_statement_2( void )
{
    fparse fs[9];

    fs[0] = TTparset_DIVIDE;
    fs[1] = TTparseVSC_stat_id_or_lit;
    fs[2] = TTparset_INTO;
    fs[3] = TTparseVSC_stat_id_or_lit;
    fs[4] = TTparset_GIVING;
    fs[5] = TTparseVSC_stat_cobword_rounded_plus;
    fs[6] = TTparseVSC_stat_on_size_error_statement_list_opt;
    fs[7] = TTparseVSC_stat_not_on_size_error_statement_list_opt;
    fs[8] = TTparset_END_DIVIDE_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_divide_statement_2, fs);
}

TTterm
TTparseVSC_stat_divide_statement_3( void )
{
    fparse fs[9];

    fs[0] = TTparset_DIVIDE;
    fs[1] = TTparseVSC_stat_id_or_lit;
    fs[2] = TTparset_BY;
    fs[3] = TTparseVSC_stat_id_or_lit;
    fs[4] = TTparset_GIVING;
    fs[5] = TTparseVSC_stat_cobword_rounded_plus;
    fs[6] = TTparseVSC_stat_on_size_error_statement_list_opt;
    fs[7] = TTparseVSC_stat_not_on_size_error_statement_list_opt;
    fs[8] = TTparset_END_DIVIDE_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_divide_statement_3, fs);
}

TTterm
TTparseVSC_stat_divide_statement_4( void )
{
    fparse fs[12];

    fs[0] = TTparset_DIVIDE;
    fs[1] = TTparseVSC_stat_id_or_lit;
    fs[2] = TTparset_INTO;
    fs[3] = TTparseVSC_stat_id_or_lit;
    fs[4] = TTparset_GIVING;
    fs[5] = TTparseVSC_expr_identifier;
    fs[6] = TTparset_ROUNDED_opt;
    fs[7] = TTparset_REMAINDER;
    fs[8] = TTparseVSC_expr_identifier;
    fs[9] = TTparseVSC_stat_on_size_error_statement_list_opt;
    fs[10] = TTparseVSC_stat_not_on_size_error_statement_list_opt;
    fs[11] = TTparset_END_DIVIDE_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_divide_statement_4, fs);
}

TTterm
TTparseVSC_stat_divide_statement_5( void )
{
    fparse fs[12];

    fs[0] = TTparset_DIVIDE;
    fs[1] = TTparseVSC_stat_id_or_lit;
    fs[2] = TTparset_BY;
    fs[3] = TTparseVSC_stat_id_or_lit;
    fs[4] = TTparset_GIVING;
    fs[5] = TTparseVSC_expr_identifier;
    fs[6] = TTparset_ROUNDED_opt;
    fs[7] = TTparset_REMAINDER;
    fs[8] = TTparseVSC_expr_identifier;
    fs[9] = TTparseVSC_stat_on_size_error_statement_list_opt;
    fs[10] = TTparseVSC_stat_not_on_size_error_statement_list_opt;
    fs[11] = TTparset_END_DIVIDE_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_divide_statement_5, fs);
}

TTterm
TTparseVSC_stat_else_phrase( void )
{
    fparse fs[2];

    fs[0] = TTparset_ELSE;
    fs[1] = TTparseVSC_stat_alt_statement_list_next_sentence;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_else_phrase, fs);
}

TTterm
TTparseVSC_stat_end_of_page( void )
{
    fparse fs[2];
    fs[0] = TTparset_END_OF_PAGE;
    fs[1] = TTparset_EOP;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_end_of_page, 2, fs);
}

TTterm
TTparseVSC_stat_entry_statement( void )
{
    fparse fs[3];

    fs[0] = TTparset_ENTRY;
    fs[1] = TTparseVSC_expr_literal;
    fs[2] = TTparseVSC_stat_using_data_name_pluslist_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_entry_statement, fs);
}

TTterm
TTparseVSC_stat_equal( void )
{
    fparse fs[2];
    fs[0] = TTparset_qequal;
    fs[1] = TTparset_EQUAL;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_equal, 2, fs);
}

TTterm
TTparseVSC_stat_evaluate_condition( void )
{
    fparse fs[3];
    fs[0] = TTparseVSC_cond_condition;
    fs[1] = TTparset_TRUE;
    fs[2] = TTparset_FALSE;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_evaluate_condition, 3, fs);
}

TTterm
TTparseVSC_stat_evaluate_phrase( void )
{
    fparse fs[6];
    fs[0] = TTparset_ANY;
    fs[1] = TTparset_TRUE;
    fs[2] = TTparset_FALSE;
    fs[3] = TTparseVSC_stat_evaluate_phrase_2;
    fs[4] = TTparseVSC_cond_condition;
    fs[5] = TTparseVSC_stat_evaluate_phrase_1;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_evaluate_phrase, 6, fs);
}

TTterm
TTparseVSC_stat_evaluate_phrase_1( void )
{
    fparse fs[2];

    fs[0] = TTparset_NOT_opt;
    fs[1] = TTparseVSC_expr_arithmetic_expression;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_evaluate_phrase_1, fs);
}

TTterm
TTparseVSC_stat_evaluate_phrase_2( void )
{
    fparse fs[3];

    fs[0] = TTparset_NOT_opt;
    fs[1] = TTparseVSC_expr_arithmetic_expression;
    fs[2] = TTparseVSC_expr_through_arithmetic_expression;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_evaluate_phrase_2, fs);
}

TTterm
TTparseVSC_stat_evaluate_statement( void )
{
    fparse fs[6];

    fs[0] = TTparset_EVALUATE;
    fs[1] = TTparseVSC_stat_evaluate_condition;
    fs[2] = TTparseVSC_stat_also_phrase_star;
    fs[3] = TTparseVSC_stat_when_phrases_plus;
    fs[4] = TTparseVSC_stat_when_other_phrase_opt;
    fs[5] = TTparset_END_EVALUATE_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_evaluate_statement, fs);
}

TTterm
TTparseVSC_stat_exit_program_statement( void )
{
    fparse fs[2];

    fs[0] = TTparset_EXIT;
    fs[1] = TTparset_PROGRAM;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_exit_program_statement, fs);
}

TTterm
TTparseVSC_stat_exit_statement( void )
{
    fparse fs[1];

    fs[0] = TTparset_EXIT;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_exit_statement, fs);
}

TTterm
TTparseVSC_stat_file_names( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_expr_file_name_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_file_names, fs);
}

TTterm
TTparseVSC_stat_for_removal( void )
{
    fparse fs[2];

    fs[0] = TTparset_FOR_opt;
    fs[1] = TTparset_REMOVAL;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_for_removal, fs);
}

TTterm
TTparseVSC_stat_from_environment_name( void )
{
    fparse fs[2];

    fs[0] = TTparset_FROM;
    fs[1] = TTparseVSC_lex_cobword;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_from_environment_name, fs);
}

TTterm
TTparseVSC_stat_from_identifier( void )
{
    fparse fs[2];

    fs[0] = TTparset_FROM;
    fs[1] = TTparseVSC_expr_identifier;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_from_identifier, fs);
}

TTterm
TTparseVSC_stat_giving_file_names( void )
{
    fparse fs[2];

    fs[0] = TTparset_GIVING;
    fs[1] = TTparseVSC_expr_file_name_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_giving_file_names, fs);
}

TTterm
TTparseVSC_stat_go_to_statement( void )
{
    fparse fs[3];
    fs[0] = TTparseVSC_stat_go_to_statement_2;
    fs[1] = TTparseVSC_stat_go_to_statement_1;
    fs[2] = TTparseVSC_stat_go_to_statement_3;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_go_to_statement, 3, fs);
}

TTterm
TTparseVSC_stat_go_to_statement_1( void )
{
    fparse fs[3];

    fs[0] = TTparset_GO;
    fs[1] = TTparset_TO_opt;
    fs[2] = TTparseVSC_expr_procedure_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_go_to_statement_1, fs);
}

TTterm
TTparseVSC_stat_go_to_statement_2( void )
{
    fparse fs[6];

    fs[0] = TTparset_GO;
    fs[1] = TTparset_TO_opt;
    fs[2] = TTparseVSC_expr_procedure_name_plus;
    fs[3] = TTparset_DEPENDING;
    fs[4] = TTparset_ON_opt;
    fs[5] = TTparseVSC_expr_identifier;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_go_to_statement_2, fs);
}

TTterm
TTparseVSC_stat_go_to_statement_3( void )
{
    fparse fs[3];

    fs[0] = TTparset_GO;
    fs[1] = TTparset_TO_opt;
    fs[2] = TTparset_MORE_LABELS;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_go_to_statement_3, fs);
}

TTterm
TTparseVSC_stat_goback_statement( void )
{
    fparse fs[1];

    fs[0] = TTparset_GOBACK;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_goback_statement, fs);
}

TTterm
TTparseVSC_stat_id_or_lit( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_expr_literal;
    fs[1] = TTparseVSC_expr_identifier;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_id_or_lit, 2, fs);
}

TTterm
TTparseVSC_stat_id_or_lit_size( void )
{
    fparse fs[3];
    fs[0] = TTparseVSC_expr_literal;
    fs[1] = TTparseVSC_expr_identifier;
    fs[2] = TTparset_SIZE;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_id_or_lit_size, 3, fs);
}

TTterm
TTparseVSC_stat_if_statement( void )
{
    fparse fs[6];

    fs[0] = TTparset_IF;
    fs[1] = TTparseVSC_cond_condition;
    fs[2] = TTparset_THEN_opt;
    fs[3] = TTparseVSC_stat_alt_statement_list_next_sentence;
    fs[4] = TTparseVSC_stat_else_phrase_opt;
    fs[5] = TTparset_END_IF_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_if_statement, fs);
}

TTterm
TTparseVSC_stat_initialize_replacing_argument( void )
{
    fparse fs[4];

    fs[0] = TTparseVSC_stat_initialize_replacing_type;
    fs[1] = TTparset_DATA_opt;
    fs[2] = TTparset_BY;
    fs[3] = TTparseVSC_stat_id_or_lit;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_initialize_replacing_argument, fs);
}

TTterm
TTparseVSC_stat_initialize_replacing_phrase( void )
{
    fparse fs[2];

    fs[0] = TTparset_REPLACING;
    fs[1] = TTparseVSC_stat_initialize_replacing_argument_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_initialize_replacing_phrase, fs);
}

TTterm
TTparseVSC_stat_initialize_replacing_type( void )
{
    fparse fs[7];
    fs[0] = TTparset_ALPHABETIC;
    fs[1] = TTparset_ALPHANUMERIC;
    fs[2] = TTparset_NUMERIC;
    fs[3] = TTparset_ALPHANUMERIC_EDITED;
    fs[4] = TTparset_NUMERIC_EDITED;
    fs[5] = TTparset_DBCS;
    fs[6] = TTparset_EGCS;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_initialize_replacing_type, 7, fs);
}

TTterm
TTparseVSC_stat_initialize_statement( void )
{
    fparse fs[3];

    fs[0] = TTparset_INITIALIZE;
    fs[1] = TTparseVSC_expr_identifier_plus;
    fs[2] = TTparseVSC_stat_initialize_replacing_phrase_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_initialize_statement, fs);
}

TTterm
TTparseVSC_stat_input_procedure( void )
{
    fparse fs[5];

    fs[0] = TTparset_INPUT;
    fs[1] = TTparset_PROCEDURE;
    fs[2] = TTparset_IS_opt;
    fs[3] = TTparseVSC_expr_procedure_name;
    fs[4] = TTparseVSC_stat_through_procedure_name_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_input_procedure, fs);
}

TTterm
TTparseVSC_stat_inspect_by_argument( void )
{
    fparse fs[3];
    fs[0] = TTparseVSC_expr_identifier;
    fs[1] = TTparseVSC_lex_nonnumeric;
    fs[2] = TTparseVSC_expr_figurative_constant_simple;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_inspect_by_argument, 3, fs);
}

TTterm
TTparseVSC_stat_inspect_replacing_argument( void )
{
    fparse fs[4];

    fs[0] = TTparseVSC_stat_inspect_by_argument;
    fs[1] = TTparset_BY;
    fs[2] = TTparseVSC_stat_inspect_by_argument;
    fs[3] = TTparseVSC_stat_before_after_phrase_star;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_inspect_replacing_argument, fs);
}

TTterm
TTparseVSC_stat_inspect_replacing_phrase( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_stat_inspect_replacing_phrase_1;
    fs[1] = TTparseVSC_stat_inspect_replacing_phrase_2;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_inspect_replacing_phrase, 2, fs);
}

TTterm
TTparseVSC_stat_inspect_replacing_phrase_1( void )
{
    fparse fs[4];

    fs[0] = TTparset_CHARACTERS;
    fs[1] = TTparset_BY;
    fs[2] = TTparseVSC_stat_id_or_lit;
    fs[3] = TTparseVSC_stat_before_after_phrase_star;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_inspect_replacing_phrase_1, fs);
}

TTterm
TTparseVSC_stat_inspect_replacing_phrase_2( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_stat_alt_all_leading_first;
    fs[1] = TTparseVSC_stat_inspect_replacing_argument_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_inspect_replacing_phrase_2, fs);
}

TTterm
TTparseVSC_stat_inspect_statement( void )
{
    fparse fs[4];
    fs[0] = TTparseVSC_stat_inspect_statement_3;
    fs[1] = TTparseVSC_stat_inspect_statement_1;
    fs[2] = TTparseVSC_stat_inspect_statement_2;
    fs[3] = TTparseVSC_stat_inspect_statement_4;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_inspect_statement, 4, fs);
}

TTterm
TTparseVSC_stat_inspect_statement_1( void )
{
    fparse fs[4];

    fs[0] = TTparset_INSPECT;
    fs[1] = TTparseVSC_expr_identifier;
    fs[2] = TTparset_TALLYING;
    fs[3] = TTparseVSC_stat_tallying_argument_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_inspect_statement_1, fs);
}

TTterm
TTparseVSC_stat_inspect_statement_2( void )
{
    fparse fs[7];

    fs[0] = TTparset_INSPECT;
    fs[1] = TTparseVSC_expr_identifier;
    fs[2] = TTparset_CONVERTING;
    fs[3] = TTparseVSC_stat_id_or_lit;
    fs[4] = TTparset_TO;
    fs[5] = TTparseVSC_stat_id_or_lit;
    fs[6] = TTparseVSC_stat_before_after_phrase_star;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_inspect_statement_2, fs);
}

TTterm
TTparseVSC_stat_inspect_statement_3( void )
{
    fparse fs[6];

    fs[0] = TTparset_INSPECT;
    fs[1] = TTparseVSC_expr_identifier;
    fs[2] = TTparset_TALLYING;
    fs[3] = TTparseVSC_stat_tallying_argument_plus;
    fs[4] = TTparset_REPLACING;
    fs[5] = TTparseVSC_stat_inspect_replacing_phrase_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_inspect_statement_3, fs);
}

TTterm
TTparseVSC_stat_inspect_statement_4( void )
{
    fparse fs[4];

    fs[0] = TTparset_INSPECT;
    fs[1] = TTparseVSC_expr_identifier;
    fs[2] = TTparset_REPLACING;
    fs[3] = TTparseVSC_stat_inspect_replacing_phrase_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_inspect_statement_4, fs);
}

TTterm
TTparseVSC_stat_into_identifier( void )
{
    fparse fs[2];

    fs[0] = TTparset_INTO;
    fs[1] = TTparseVSC_expr_identifier;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_into_identifier, fs);
}

TTterm
TTparseVSC_stat_invalid_key_statement_list( void )
{
    fparse fs[3];

    fs[0] = TTparset_INVALID;
    fs[1] = TTparset_KEY_opt;
    fs[2] = TTparseVSC_stat_statement_list;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_invalid_key_statement_list, fs);
}

TTterm
TTparseVSC_stat_key_is( void )
{
    fparse fs[2];

    fs[0] = TTparset_KEY;
    fs[1] = TTparset_IS_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_key_is, fs);
}

TTterm
TTparseVSC_stat_key_is_qualified_data_name( void )
{
    fparse fs[3];

    fs[0] = TTparset_KEY;
    fs[1] = TTparset_IS_opt;
    fs[2] = TTparseVSC_expr_qualified_data_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_key_is_qualified_data_name, fs);
}

TTterm
TTparseVSC_stat_key_is_rel_op_qualified_data_name( void )
{
    fparse fs[4];

    fs[0] = TTparset_KEY;
    fs[1] = TTparset_IS_opt;
    fs[2] = TTparseVSC_stat_rel_op;
    fs[3] = TTparseVSC_expr_qualified_data_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_key_is_rel_op_qualified_data_name, fs);
}

TTterm
TTparseVSC_stat_lines( void )
{
    fparse fs[2];
    fs[0] = TTparset_LINE;
    fs[1] = TTparset_LINES;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_lines, 2, fs);
}

TTterm
TTparseVSC_stat_merge_statement( void )
{
    fparse fs[8];

    fs[0] = TTparset_MERGE;
    fs[1] = TTparseVSC_expr_file_name;
    fs[2] = TTparseVSC_stat_on_key_phrase_plus;
    fs[3] = TTparseVSC_stat_collating_sequence_opt;
    fs[4] = TTparset_USING;
    fs[5] = TTparseVSC_expr_file_name;
    fs[6] = TTparseVSC_expr_file_name_plus;
    fs[7] = TTparseVSC_stat_merge_statement_tail;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_merge_statement, fs);
}

TTterm
TTparseVSC_stat_merge_statement_tail( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_stat_output_procedure;
    fs[1] = TTparseVSC_stat_giving_file_names;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_merge_statement_tail, 2, fs);
}

TTterm
TTparseVSC_stat_move_statement( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_stat_move_statement_1;
    fs[1] = TTparseVSC_stat_move_statement_2;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_move_statement, 2, fs);
}

TTterm
TTparseVSC_stat_move_statement_1( void )
{
    fparse fs[4];

    fs[0] = TTparset_MOVE;
    fs[1] = TTparseVSC_stat_id_or_lit;
    fs[2] = TTparset_TO;
    fs[3] = TTparseVSC_expr_identifier_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_move_statement_1, fs);
}

TTterm
TTparseVSC_stat_move_statement_2( void )
{
    fparse fs[5];

    fs[0] = TTparset_MOVE;
    fs[1] = TTparseVSC_stat_corresponding;
    fs[2] = TTparseVSC_expr_identifier;
    fs[3] = TTparset_TO;
    fs[4] = TTparseVSC_expr_identifier_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_move_statement_2, fs);
}

TTterm
TTparseVSC_stat_multiply_statement( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_stat_multiply_statement_2;
    fs[1] = TTparseVSC_stat_multiply_statement_1;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_multiply_statement, 2, fs);
}

TTterm
TTparseVSC_stat_multiply_statement_1( void )
{
    fparse fs[7];

    fs[0] = TTparset_MULTIPLY;
    fs[1] = TTparseVSC_stat_id_or_lit;
    fs[2] = TTparset_BY;
    fs[3] = TTparseVSC_stat_cobword_rounded_plus;
    fs[4] = TTparseVSC_stat_on_size_error_statement_list_opt;
    fs[5] = TTparseVSC_stat_not_on_size_error_statement_list_opt;
    fs[6] = TTparset_END_MULTIPLY_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_multiply_statement_1, fs);
}

TTterm
TTparseVSC_stat_multiply_statement_2( void )
{
    fparse fs[9];

    fs[0] = TTparset_MULTIPLY;
    fs[1] = TTparseVSC_stat_id_or_lit;
    fs[2] = TTparset_BY;
    fs[3] = TTparseVSC_stat_id_or_lit;
    fs[4] = TTparset_GIVING;
    fs[5] = TTparseVSC_stat_cobword_rounded_plus;
    fs[6] = TTparseVSC_stat_on_size_error_statement_list_opt;
    fs[7] = TTparseVSC_stat_not_on_size_error_statement_list_opt;
    fs[8] = TTparset_END_MULTIPLY_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_multiply_statement_2, fs);
}

TTterm
TTparseVSC_stat_next_sentence( void )
{
    fparse fs[2];

    fs[0] = TTparset_NEXT;
    fs[1] = TTparset_SENTENCE;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_next_sentence, fs);
}

TTterm
TTparseVSC_stat_no_rewind( void )
{
    fparse fs[2];

    fs[0] = TTparset_NO;
    fs[1] = TTparset_REWIND;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_no_rewind, fs);
}

TTterm
TTparseVSC_stat_not_at_end_of_page_statement_list( void )
{
    fparse fs[4];

    fs[0] = TTparset_NOT;
    fs[1] = TTparset_AT_opt;
    fs[2] = TTparseVSC_stat_end_of_page;
    fs[3] = TTparseVSC_stat_statement_list;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_not_at_end_of_page_statement_list, fs);
}

TTterm
TTparseVSC_stat_not_at_end_statement_list( void )
{
    fparse fs[4];

    fs[0] = TTparset_NOT;
    fs[1] = TTparset_AT_opt;
    fs[2] = TTparset_END;
    fs[3] = TTparseVSC_stat_statement_list;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_not_at_end_statement_list, fs);
}

TTterm
TTparseVSC_stat_not_invalid_key_statement_list( void )
{
    fparse fs[4];

    fs[0] = TTparset_NOT;
    fs[1] = TTparset_INVALID;
    fs[2] = TTparset_KEY_opt;
    fs[3] = TTparseVSC_stat_statement_list;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_not_invalid_key_statement_list, fs);
}

TTterm
TTparseVSC_stat_not_on_exception_statement_list( void )
{
    fparse fs[4];

    fs[0] = TTparset_NOT;
    fs[1] = TTparset_ON_opt;
    fs[2] = TTparset_EXCEPTION;
    fs[3] = TTparseVSC_stat_statement_list;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_not_on_exception_statement_list, fs);
}

TTterm
TTparseVSC_stat_not_on_overflow_statement_list( void )
{
    fparse fs[4];

    fs[0] = TTparset_NOT;
    fs[1] = TTparset_ON_opt;
    fs[2] = TTparset_OVERFLOW;
    fs[3] = TTparseVSC_stat_statement_list;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_not_on_overflow_statement_list, fs);
}

TTterm
TTparseVSC_stat_not_on_size_error_statement_list( void )
{
    fparse fs[5];

    fs[0] = TTparset_NOT;
    fs[1] = TTparset_ON_opt;
    fs[2] = TTparset_SIZE;
    fs[3] = TTparset_ERROR;
    fs[4] = TTparseVSC_stat_statement_list;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_not_on_size_error_statement_list, fs);
}

TTterm
TTparseVSC_stat_nr_lines_phrase( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_stat_cobword_int;
    fs[1] = TTparseVSC_stat_lines_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_nr_lines_phrase, fs);
}

TTterm
TTparseVSC_stat_on_exception_statement_list( void )
{
    fparse fs[3];

    fs[0] = TTparset_ON_opt;
    fs[1] = TTparset_EXCEPTION;
    fs[2] = TTparseVSC_stat_statement_list;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_on_exception_statement_list, fs);
}

TTterm
TTparseVSC_stat_on_key_is_phrase( void )
{
    fparse fs[4];

    fs[0] = TTparset_ON_opt;
    fs[1] = TTparseVSC_expr_alt_ascending_descending;
    fs[2] = TTparseVSC_stat_key_is_opt;
    fs[3] = TTparseVSC_expr_qualified_data_name_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_on_key_is_phrase, fs);
}

TTterm
TTparseVSC_stat_on_key_phrase( void )
{
    fparse fs[4];

    fs[0] = TTparset_ON_opt;
    fs[1] = TTparseVSC_expr_alt_ascending_descending;
    fs[2] = TTparset_KEY_opt;
    fs[3] = TTparseVSC_expr_qualified_data_name_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_on_key_phrase, fs);
}

TTterm
TTparseVSC_stat_on_overflow_statement_list( void )
{
    fparse fs[3];

    fs[0] = TTparset_ON_opt;
    fs[1] = TTparset_OVERFLOW;
    fs[2] = TTparseVSC_stat_statement_list;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_on_overflow_statement_list, fs);
}

TTterm
TTparseVSC_stat_on_size_error_statement_list( void )
{
    fparse fs[4];

    fs[0] = TTparset_ON_opt;
    fs[1] = TTparset_SIZE;
    fs[2] = TTparset_ERROR;
    fs[3] = TTparseVSC_stat_statement_list;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_on_size_error_statement_list, fs);
}

TTterm
TTparseVSC_stat_open_statement( void )
{
    fparse fs[2];

    fs[0] = TTparset_OPEN;
    fs[1] = TTparseVSC_stat_open_statement_phrase_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_open_statement, fs);
}

TTterm
TTparseVSC_stat_open_statement_extend( void )
{
    fparse fs[2];

    fs[0] = TTparset_EXTEND;
    fs[1] = TTparseVSC_expr_file_name_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_open_statement_extend, fs);
}

TTterm
TTparseVSC_stat_open_statement_i_o( void )
{
    fparse fs[2];

    fs[0] = TTparset_I_O;
    fs[1] = TTparseVSC_expr_file_name_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_open_statement_i_o, fs);
}

TTterm
TTparseVSC_stat_open_statement_input( void )
{
    fparse fs[2];

    fs[0] = TTparset_INPUT;
    fs[1] = TTparseVSC_stat_open_statement_input_file_name_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_open_statement_input, fs);
}

TTterm
TTparseVSC_stat_open_statement_input_file_name( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_file_name;
    fs[1] = TTparseVSC_stat_alt_reversed_with_no_rewind_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_open_statement_input_file_name, fs);
}

TTterm
TTparseVSC_stat_open_statement_output( void )
{
    fparse fs[2];

    fs[0] = TTparset_OUTPUT;
    fs[1] = TTparseVSC_stat_open_statement_output_file_name_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_open_statement_output, fs);
}

TTterm
TTparseVSC_stat_open_statement_output_file_name( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_file_name;
    fs[1] = TTparseVSC_stat_with_no_rewind_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_open_statement_output_file_name, fs);
}

TTterm
TTparseVSC_stat_open_statement_phrase( void )
{
    fparse fs[4];
    fs[0] = TTparseVSC_stat_open_statement_input;
    fs[1] = TTparseVSC_stat_open_statement_output;
    fs[2] = TTparseVSC_stat_open_statement_i_o;
    fs[3] = TTparseVSC_stat_open_statement_extend;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_open_statement_phrase, 4, fs);
}

TTterm
TTparseVSC_stat_or_all_id_or_lit( void )
{
    fparse fs[3];

    fs[0] = TTparset_OR;
    fs[1] = TTparset_ALL_opt;
    fs[2] = TTparseVSC_stat_id_or_lit;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_or_all_id_or_lit, fs);
}

TTterm
TTparseVSC_stat_output_procedure( void )
{
    fparse fs[5];

    fs[0] = TTparset_OUTPUT;
    fs[1] = TTparset_PROCEDURE;
    fs[2] = TTparset_IS_opt;
    fs[3] = TTparseVSC_expr_procedure_name;
    fs[4] = TTparseVSC_stat_through_procedure_name_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_output_procedure, fs);
}

TTterm
TTparseVSC_stat_page_phrase( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_stat_nr_lines_phrase;
    fs[1] = TTparset_PAGE;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_page_phrase, 2, fs);
}

TTterm
TTparseVSC_stat_parameter( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_stat_reference_parameter;
    fs[1] = TTparseVSC_stat_content_parameter;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_parameter, 2, fs);
}

TTterm
TTparseVSC_stat_perform_after_phrase( void )
{
    fparse fs[8];

    fs[0] = TTparset_AFTER;
    fs[1] = TTparseVSC_expr_identifier;
    fs[2] = TTparset_FROM;
    fs[3] = TTparseVSC_stat_id_or_lit;
    fs[4] = TTparset_BY;
    fs[5] = TTparseVSC_stat_id_or_lit;
    fs[6] = TTparset_UNTIL;
    fs[7] = TTparseVSC_cond_condition;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_perform_after_phrase, fs);
}

TTterm
TTparseVSC_stat_perform_statement( void )
{
    fparse fs[4];
    fs[0] = TTparseVSC_stat_perform_statement_4;
    fs[1] = TTparseVSC_stat_perform_statement_2;
    fs[2] = TTparseVSC_stat_perform_statement_3;
    fs[3] = TTparseVSC_stat_perform_statement_1;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_perform_statement, 4, fs);
}

TTterm
TTparseVSC_stat_perform_statement_1( void )
{
    fparse fs[2];

    fs[0] = TTparset_PERFORM;
    fs[1] = TTparseVSC_stat_perform_statement_1_alts;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_perform_statement_1, fs);
}

TTterm
TTparseVSC_stat_perform_statement_1_alts( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_stat_perform_statement_1_procedure;
    fs[1] = TTparseVSC_stat_perform_statement_1_statement_list;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_perform_statement_1_alts, 2, fs);
}

TTterm
TTparseVSC_stat_perform_statement_1_procedure( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_procedure_name;
    fs[1] = TTparseVSC_stat_through_procedure_name_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_perform_statement_1_procedure, fs);
}

TTterm
TTparseVSC_stat_perform_statement_1_statement_list( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_stat_statement_list;
    fs[1] = TTparset_END_PERFORM;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_perform_statement_1_statement_list, fs);
}

TTterm
TTparseVSC_stat_perform_statement_2( void )
{
    fparse fs[2];

    fs[0] = TTparset_PERFORM;
    fs[1] = TTparseVSC_stat_perform_statement_2_alts;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_perform_statement_2, fs);
}

TTterm
TTparseVSC_stat_perform_statement_2_alts( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_stat_perform_statement_2_procedure;
    fs[1] = TTparseVSC_stat_perform_statement_2_statement_list;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_perform_statement_2_alts, 2, fs);
}

TTterm
TTparseVSC_stat_perform_statement_2_procedure( void )
{
    fparse fs[4];

    fs[0] = TTparseVSC_expr_procedure_name;
    fs[1] = TTparseVSC_stat_through_procedure_name_opt;
    fs[2] = TTparseVSC_stat_perform_varying_phrase;
    fs[3] = TTparseVSC_stat_perform_after_phrase_star;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_perform_statement_2_procedure, fs);
}

TTterm
TTparseVSC_stat_perform_statement_2_statement_list( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_stat_perform_varying_phrase;
    fs[1] = TTparseVSC_stat_statement_list;
    fs[2] = TTparset_END_PERFORM;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_perform_statement_2_statement_list, fs);
}

TTterm
TTparseVSC_stat_perform_statement_3( void )
{
    fparse fs[2];

    fs[0] = TTparset_PERFORM;
    fs[1] = TTparseVSC_stat_perform_statement_3_alts;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_perform_statement_3, fs);
}

TTterm
TTparseVSC_stat_perform_statement_3_alts( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_stat_perform_statement_3_procedure;
    fs[1] = TTparseVSC_stat_perform_statement_3_statement_list;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_perform_statement_3_alts, 2, fs);
}

TTterm
TTparseVSC_stat_perform_statement_3_procedure( void )
{
    fparse fs[4];

    fs[0] = TTparseVSC_expr_procedure_name;
    fs[1] = TTparseVSC_stat_through_procedure_name_opt;
    fs[2] = TTparseVSC_stat_cobword_int;
    fs[3] = TTparset_TIMES;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_perform_statement_3_procedure, fs);
}

TTterm
TTparseVSC_stat_perform_statement_3_statement_list( void )
{
    fparse fs[4];

    fs[0] = TTparseVSC_stat_cobword_int;
    fs[1] = TTparset_TIMES;
    fs[2] = TTparseVSC_stat_statement_list;
    fs[3] = TTparset_END_PERFORM;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_perform_statement_3_statement_list, fs);
}

TTterm
TTparseVSC_stat_perform_statement_4( void )
{
    fparse fs[2];

    fs[0] = TTparset_PERFORM;
    fs[1] = TTparseVSC_stat_perform_statement_4_alts;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_perform_statement_4, fs);
}

TTterm
TTparseVSC_stat_perform_statement_4_alts( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_stat_perform_statement_4_procedure;
    fs[1] = TTparseVSC_stat_perform_statement_4_statement_list;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_perform_statement_4_alts, 2, fs);
}

TTterm
TTparseVSC_stat_perform_statement_4_procedure( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_expr_procedure_name;
    fs[1] = TTparseVSC_stat_through_procedure_name_opt;
    fs[2] = TTparseVSC_stat_perform_until_phrase;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_perform_statement_4_procedure, fs);
}

TTterm
TTparseVSC_stat_perform_statement_4_statement_list( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_stat_perform_until_phrase;
    fs[1] = TTparseVSC_stat_statement_list;
    fs[2] = TTparset_END_PERFORM;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_perform_statement_4_statement_list, fs);
}

TTterm
TTparseVSC_stat_perform_until_phrase( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_stat_with_test_opt;
    fs[1] = TTparset_UNTIL;
    fs[2] = TTparseVSC_cond_condition;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_perform_until_phrase, fs);
}

TTterm
TTparseVSC_stat_perform_varying_phrase( void )
{
    fparse fs[9];

    fs[0] = TTparseVSC_stat_with_test_opt;
    fs[1] = TTparset_VARYING;
    fs[2] = TTparseVSC_expr_identifier;
    fs[3] = TTparset_FROM;
    fs[4] = TTparseVSC_stat_id_or_lit;
    fs[5] = TTparset_BY;
    fs[6] = TTparseVSC_stat_id_or_lit;
    fs[7] = TTparset_UNTIL;
    fs[8] = TTparseVSC_cond_condition;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_perform_varying_phrase, fs);
}

TTterm
TTparseVSC_stat_procedure_names( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_expr_procedure_name_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_procedure_names, fs);
}

TTterm
TTparseVSC_stat_procedure_to_procedure( void )
{
    fparse fs[4];

    fs[0] = TTparseVSC_expr_procedure_name;
    fs[1] = TTparset_TO;
    fs[2] = TTparseVSC_stat_proceed_to_opt;
    fs[3] = TTparseVSC_expr_procedure_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_procedure_to_procedure, fs);
}

TTterm
TTparseVSC_stat_proceed_to( void )
{
    fparse fs[2];

    fs[0] = TTparset_PROCEED;
    fs[1] = TTparset_TO;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_proceed_to, fs);
}

TTterm
TTparseVSC_stat_read_statement( void )
{
    fparse fs[11];

    fs[0] = TTparset_READ;
    fs[1] = TTparseVSC_expr_file_name;
    fs[2] = TTparset_NEXT_opt;
    fs[3] = TTparset_RECORD_opt;
    fs[4] = TTparseVSC_stat_into_identifier_opt;
    fs[5] = TTparseVSC_stat_key_is_qualified_data_name_opt;
    fs[6] = TTparseVSC_stat_invalid_key_statement_list_opt;
    fs[7] = TTparseVSC_stat_not_invalid_key_statement_list_opt;
    fs[8] = TTparseVSC_stat_at_end_statement_list_opt;
    fs[9] = TTparseVSC_stat_not_at_end_statement_list_opt;
    fs[10] = TTparset_END_READ_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_read_statement, fs);
}

TTterm
TTparseVSC_stat_reference_parameter( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_stat_by_reference_opt;
    fs[1] = TTparseVSC_expr_identifier;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_reference_parameter, fs);
}

TTterm
TTparseVSC_stat_rel_op( void )
{
    fparse fs[3];
    fs[0] = TTparseVSC_expr_equal_to;
    fs[1] = TTparseVSC_cond_greater_than_or_equal_to;
    fs[2] = TTparseVSC_cond_greater_than;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_rel_op, 3, fs);
}

TTterm
TTparseVSC_stat_release_statement( void )
{
    fparse fs[3];

    fs[0] = TTparset_RELEASE;
    fs[1] = TTparseVSC_expr_record_name;
    fs[2] = TTparseVSC_stat_from_identifier_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_release_statement, fs);
}

TTterm
TTparseVSC_stat_return_statement( void )
{
    fparse fs[9];

    fs[0] = TTparset_RETURN;
    fs[1] = TTparseVSC_expr_file_name;
    fs[2] = TTparset_RECORD_opt;
    fs[3] = TTparseVSC_stat_into_identifier_opt;
    fs[4] = TTparset_AT_opt;
    fs[5] = TTparset_END;
    fs[6] = TTparseVSC_stat_statement_list;
    fs[7] = TTparseVSC_stat_not_at_end_statement_list_opt;
    fs[8] = TTparset_END_RETURN_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_return_statement, fs);
}

TTterm
TTparseVSC_stat_rewrite_statement( void )
{
    fparse fs[6];

    fs[0] = TTparset_REWRITE;
    fs[1] = TTparseVSC_expr_record_name;
    fs[2] = TTparseVSC_stat_from_identifier_opt;
    fs[3] = TTparseVSC_stat_invalid_key_statement_list_opt;
    fs[4] = TTparseVSC_stat_not_invalid_key_statement_list_opt;
    fs[5] = TTparset_END_REWRITE_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_rewrite_statement, fs);
}

TTterm
TTparseVSC_stat_search_statement( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_stat_search_statement_1;
    fs[1] = TTparseVSC_stat_search_statement_2;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_search_statement, 2, fs);
}

TTterm
TTparseVSC_stat_search_statement_1( void )
{
    fparse fs[6];

    fs[0] = TTparset_SEARCH;
    fs[1] = TTparseVSC_expr_identifier;
    fs[2] = TTparseVSC_stat_varying_identifier_opt;
    fs[3] = TTparseVSC_stat_at_end_statement_list_opt;
    fs[4] = TTparseVSC_stat_when_condition_stats_plus;
    fs[5] = TTparset_END_SEARCH_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_search_statement_1, fs);
}

TTterm
TTparseVSC_stat_search_statement_2( void )
{
    fparse fs[9];

    fs[0] = TTparset_SEARCH;
    fs[1] = TTparset_ALL;
    fs[2] = TTparseVSC_expr_identifier;
    fs[3] = TTparseVSC_stat_at_end_statement_list_opt;
    fs[4] = TTparset_WHEN;
    fs[5] = TTparseVSC_stat_search_statement_condition;
    fs[6] = TTparseVSC_stat_search_statement_condition_tail_star;
    fs[7] = TTparseVSC_stat_alt_statement_list_next_sentence;
    fs[8] = TTparset_END_SEARCH_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_search_statement_2, fs);
}

TTterm
TTparseVSC_stat_search_statement_condition( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_stat_search_statement_equal_expression;
    fs[1] = TTparseVSC_cond_condition_name_reference;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_search_statement_condition, 2, fs);
}

TTterm
TTparseVSC_stat_search_statement_condition_tail( void )
{
    fparse fs[2];

    fs[0] = TTparset_AND;
    fs[1] = TTparseVSC_stat_search_statement_condition;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_search_statement_condition_tail, fs);
}

TTterm
TTparseVSC_stat_search_statement_equal_expression( void )
{
    fparse fs[4];

    fs[0] = TTparseVSC_expr_identifier;
    fs[1] = TTparset_IS_opt;
    fs[2] = TTparseVSC_expr_equal_to;
    fs[3] = TTparseVSC_expr_arithmetic_expression;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_search_statement_equal_expression, fs);
}

TTterm
TTparseVSC_stat_set_oper( void )
{
    fparse fs[2];
    fs[0] = TTparset_TO;
    fs[1] = TTparseVSC_stat_alt_up_down_by;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_set_oper, 2, fs);
}

TTterm
TTparseVSC_stat_set_src( void )
{
    fparse fs[5];
    fs[0] = TTparseVSC_expr_identifier;
    fs[1] = TTparseVSC_expr_literal;
    fs[2] = TTparset_TRUE;
    fs[3] = TTparset_ON;
    fs[4] = TTparset_OFF;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_set_src, 5, fs);
}

TTterm
TTparseVSC_stat_set_statement( void )
{
    fparse fs[2];

    fs[0] = TTparset_SET;
    fs[1] = TTparseVSC_stat_set_statement_phrase_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_set_statement, fs);
}

TTterm
TTparseVSC_stat_set_statement_phrase( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_expr_identifier_plus;
    fs[1] = TTparseVSC_stat_set_oper;
    fs[2] = TTparseVSC_stat_set_src;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_set_statement_phrase, fs);
}

TTterm
TTparseVSC_stat_sort_statement( void )
{
    fparse fs[7];

    fs[0] = TTparset_SORT;
    fs[1] = TTparseVSC_expr_file_name;
    fs[2] = TTparseVSC_stat_on_key_is_phrase_plus;
    fs[3] = TTparseVSC_stat_with_duplicates_in_order_opt;
    fs[4] = TTparseVSC_stat_collating_sequence_opt;
    fs[5] = TTparseVSC_stat_sort_statement_in;
    fs[6] = TTparseVSC_stat_sort_statement_out;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_sort_statement, fs);
}

TTterm
TTparseVSC_stat_sort_statement_in( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_stat_using_file_names;
    fs[1] = TTparseVSC_stat_input_procedure;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_sort_statement_in, 2, fs);
}

TTterm
TTparseVSC_stat_sort_statement_out( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_stat_giving_file_names;
    fs[1] = TTparseVSC_stat_output_procedure;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_sort_statement_out, 2, fs);
}

TTterm
TTparseVSC_stat_start_statement( void )
{
    fparse fs[6];

    fs[0] = TTparset_START;
    fs[1] = TTparseVSC_expr_file_name;
    fs[2] = TTparseVSC_stat_key_is_rel_op_qualified_data_name_opt;
    fs[3] = TTparseVSC_stat_invalid_key_statement_list_opt;
    fs[4] = TTparseVSC_stat_not_invalid_key_statement_list_opt;
    fs[5] = TTparset_END_START_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_start_statement, fs);
}

TTterm
TTparseVSC_stat_statement( void )
{
    fparse fs[38];
    fs[0] = TTparseVSC_stat_move_statement;
    fs[1] = TTparseVSC_stat_if_statement;
    fs[2] = TTparseVSC_stat_perform_statement;
    fs[3] = TTparseVSC_stat_go_to_statement;
    fs[4] = TTparseVSC_stat_accept_statement;
    fs[5] = TTparseVSC_stat_add_statement;
    fs[6] = TTparseVSC_stat_alter_statement;
    fs[7] = TTparseVSC_stat_call_statement;
    fs[8] = TTparseVSC_stat_cancel_statement;
    fs[9] = TTparseVSC_stat_close_statement;
    fs[10] = TTparseVSC_stat_compute_statement;
    fs[11] = TTparseVSC_stat_continue_statement;
    fs[12] = TTparseVSC_stat_delete_statement;
    fs[13] = TTparseVSC_stat_display_statement;
    fs[14] = TTparseVSC_stat_divide_statement;
    fs[15] = TTparseVSC_stat_entry_statement;
    fs[16] = TTparseVSC_stat_evaluate_statement;
    fs[17] = TTparseVSC_stat_exit_program_statement;
    fs[18] = TTparseVSC_stat_exit_statement;
    fs[19] = TTparseVSC_stat_goback_statement;
    fs[20] = TTparseVSC_stat_initialize_statement;
    fs[21] = TTparseVSC_stat_inspect_statement;
    fs[22] = TTparseVSC_stat_merge_statement;
    fs[23] = TTparseVSC_stat_multiply_statement;
    fs[24] = TTparseVSC_stat_open_statement;
    fs[25] = TTparseVSC_stat_read_statement;
    fs[26] = TTparseVSC_stat_release_statement;
    fs[27] = TTparseVSC_stat_return_statement;
    fs[28] = TTparseVSC_stat_rewrite_statement;
    fs[29] = TTparseVSC_stat_search_statement;
    fs[30] = TTparseVSC_stat_set_statement;
    fs[31] = TTparseVSC_stat_sort_statement;
    fs[32] = TTparseVSC_stat_start_statement;
    fs[33] = TTparseVSC_stat_stop_statement;
    fs[34] = TTparseVSC_stat_string_statement;
    fs[35] = TTparseVSC_stat_subtract_statement;
    fs[36] = TTparseVSC_stat_unstring_statement;
    fs[37] = TTparseVSC_stat_write_statement;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_statement, 38, fs);
}

TTterm
TTparseVSC_stat_statement_list( void )
{
    fparse fs[1];

    fs[0] = TTparseVSC_stat_statement_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_statement_list, fs);
}

TTterm
TTparseVSC_stat_stop_statement( void )
{
    fparse fs[2];

    fs[0] = TTparset_STOP;
    fs[1] = TTparseVSC_stat_alt_run_literal;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_stop_statement, fs);
}

TTterm
TTparseVSC_stat_string_statement( void )
{
    fparse fs[8];

    fs[0] = TTparset_STRING;
    fs[1] = TTparseVSC_stat_delimited_by_phrase_plus;
    fs[2] = TTparset_INTO;
    fs[3] = TTparseVSC_expr_identifier;
    fs[4] = TTparseVSC_stat_with_pointer_identifier_opt;
    fs[5] = TTparseVSC_stat_on_overflow_statement_list_opt;
    fs[6] = TTparseVSC_stat_not_on_overflow_statement_list_opt;
    fs[7] = TTparset_END_STRING_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_string_statement, fs);
}

TTterm
TTparseVSC_stat_subtract_statement( void )
{
    fparse fs[3];
    fs[0] = TTparseVSC_stat_subtract_statement_2;
    fs[1] = TTparseVSC_stat_subtract_statement_1;
    fs[2] = TTparseVSC_stat_subtract_statement_3;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_subtract_statement, 3, fs);
}

TTterm
TTparseVSC_stat_subtract_statement_1( void )
{
    fparse fs[7];

    fs[0] = TTparset_SUBTRACT;
    fs[1] = TTparseVSC_stat_id_or_lit_plus;
    fs[2] = TTparset_FROM;
    fs[3] = TTparseVSC_stat_cobword_rounded_plus;
    fs[4] = TTparseVSC_stat_on_size_error_statement_list_opt;
    fs[5] = TTparseVSC_stat_not_on_size_error_statement_list_opt;
    fs[6] = TTparset_END_SUBTRACT_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_subtract_statement_1, fs);
}

TTterm
TTparseVSC_stat_subtract_statement_2( void )
{
    fparse fs[9];

    fs[0] = TTparset_SUBTRACT;
    fs[1] = TTparseVSC_stat_id_or_lit_plus;
    fs[2] = TTparset_FROM;
    fs[3] = TTparseVSC_stat_id_or_lit;
    fs[4] = TTparset_GIVING;
    fs[5] = TTparseVSC_stat_cobword_rounded_plus;
    fs[6] = TTparseVSC_stat_on_size_error_statement_list_opt;
    fs[7] = TTparseVSC_stat_not_on_size_error_statement_list_opt;
    fs[8] = TTparset_END_SUBTRACT_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_subtract_statement_2, fs);
}

TTterm
TTparseVSC_stat_subtract_statement_3( void )
{
    fparse fs[9];

    fs[0] = TTparset_SUBTRACT;
    fs[1] = TTparseVSC_stat_corresponding;
    fs[2] = TTparseVSC_expr_identifier;
    fs[3] = TTparset_FROM;
    fs[4] = TTparseVSC_expr_identifier;
    fs[5] = TTparset_ROUNDED_opt;
    fs[6] = TTparseVSC_stat_on_size_error_statement_list_opt;
    fs[7] = TTparseVSC_stat_not_on_size_error_statement_list_opt;
    fs[8] = TTparset_END_SUBTRACT_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_subtract_statement_3, fs);
}

TTterm
TTparseVSC_stat_tallying_argument( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_expr_identifier;
    fs[1] = TTparset_FOR;
    fs[2] = TTparseVSC_stat_tallying_for_argument_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_tallying_argument, fs);
}

TTterm
TTparseVSC_stat_tallying_for_argument( void )
{
    fparse fs[2];
    fs[0] = TTparseVSC_stat_tallying_for_argument_1;
    fs[1] = TTparseVSC_stat_tallying_for_argument_2;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_tallying_for_argument, 2, fs);
}

TTterm
TTparseVSC_stat_tallying_for_argument_1( void )
{
    fparse fs[2];

    fs[0] = TTparset_CHARACTERS;
    fs[1] = TTparseVSC_stat_before_after_phrase_star;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_tallying_for_argument_1, fs);
}

TTterm
TTparseVSC_stat_tallying_for_argument_2( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_stat_alt_all_leading;
    fs[1] = TTparseVSC_stat_tallying_for_id_or_lit_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_tallying_for_argument_2, fs);
}

TTterm
TTparseVSC_stat_tallying_for_id_or_lit( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_stat_id_or_lit;
    fs[1] = TTparseVSC_stat_before_after_phrase_star;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_tallying_for_id_or_lit, fs);
}

TTterm
TTparseVSC_stat_tallying_in_identifier( void )
{
    fparse fs[3];

    fs[0] = TTparset_TALLYING;
    fs[1] = TTparset_IN_opt;
    fs[2] = TTparseVSC_expr_identifier;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_tallying_in_identifier, fs);
}

TTterm
TTparseVSC_stat_through_procedure_name( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_expr_through;
    fs[1] = TTparseVSC_expr_procedure_name;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_through_procedure_name, fs);
}

TTterm
TTparseVSC_stat_to_id_or_lit( void )
{
    fparse fs[2];

    fs[0] = TTparset_TO;
    fs[1] = TTparseVSC_stat_id_or_lit;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_to_id_or_lit, fs);
}

TTterm
TTparseVSC_stat_unstring_statement( void )
{
    fparse fs[10];

    fs[0] = TTparset_UNSTRING;
    fs[1] = TTparseVSC_expr_identifier;
    fs[2] = TTparseVSC_stat_delimited_by_all_phrase_opt;
    fs[3] = TTparset_INTO;
    fs[4] = TTparseVSC_stat_unstring_statement_dst_plus;
    fs[5] = TTparseVSC_stat_with_pointer_identifier_opt;
    fs[6] = TTparseVSC_stat_tallying_in_identifier_opt;
    fs[7] = TTparseVSC_stat_on_overflow_statement_list_opt;
    fs[8] = TTparseVSC_stat_not_on_overflow_statement_list_opt;
    fs[9] = TTparset_END_UNSTRING_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_unstring_statement, fs);
}

TTterm
TTparseVSC_stat_unstring_statement_dst( void )
{
    fparse fs[3];

    fs[0] = TTparseVSC_expr_identifier;
    fs[1] = TTparseVSC_stat_delimiter_in_identifier_opt;
    fs[2] = TTparseVSC_stat_count_in_identifier_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_unstring_statement_dst, fs);
}

TTterm
TTparseVSC_stat_upon_environment_name( void )
{
    fparse fs[2];

    fs[0] = TTparset_UPON;
    fs[1] = TTparseVSC_lex_cobword;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_upon_environment_name, fs);
}

TTterm
TTparseVSC_stat_use_statement( void )
{
    fparse fs[3];
    fs[0] = TTparseVSC_stat_use_statement_1;
    fs[1] = TTparseVSC_stat_use_statement_2;
    fs[2] = TTparseVSC_stat_use_statement_3;
    return TTparseVSC_DISJUNCTION(TTfunVSC_stat_use_statement, 3, fs);
}

TTterm
TTparseVSC_stat_use_statement_1( void )
{
    fparse fs[8];

    fs[0] = TTparset_USE;
    fs[1] = TTparset_GLOBAL_opt;
    fs[2] = TTparset_AFTER;
    fs[3] = TTparset_STANDARD_opt;
    fs[4] = TTparseVSC_stat_alt_exception_error;
    fs[5] = TTparset_PROCEDURE;
    fs[6] = TTparset_ON_opt;
    fs[7] = TTparseVSC_stat_alt_file_names_i_o;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_use_statement_1, fs);
}

TTterm
TTparseVSC_stat_use_statement_2( void )
{
    fparse fs[10];

    fs[0] = TTparset_USE;
    fs[1] = TTparset_GLOBAL_opt;
    fs[2] = TTparset_AFTER;
    fs[3] = TTparset_STANDARD_opt;
    fs[4] = TTparseVSC_stat_alt_beginning_ending_opt;
    fs[5] = TTparseVSC_stat_alt_file_reel_unit_opt;
    fs[6] = TTparset_LABEL;
    fs[7] = TTparset_PROCEDURE;
    fs[8] = TTparset_ON_opt;
    fs[9] = TTparseVSC_stat_alt_file_names_i_o;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_use_statement_2, fs);
}

TTterm
TTparseVSC_stat_use_statement_3( void )
{
    fparse fs[5];

    fs[0] = TTparset_USE;
    fs[1] = TTparset_FOR_opt;
    fs[2] = TTparset_DEBUGGING;
    fs[3] = TTparset_ON_opt;
    fs[4] = TTparseVSC_stat_alt_procedures_all_procedures;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_use_statement_3, fs);
}

TTterm
TTparseVSC_stat_using_data_name_pluslist( void )
{
    fparse fs[2];

    fs[0] = TTparset_USING;
    fs[1] = TTparseVSC_expr_data_name_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_using_data_name_pluslist, fs);
}

TTterm
TTparseVSC_stat_using_file_names( void )
{
    fparse fs[2];

    fs[0] = TTparset_USING;
    fs[1] = TTparseVSC_expr_file_name_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_using_file_names, fs);
}

TTterm
TTparseVSC_stat_using_parameters( void )
{
    fparse fs[2];

    fs[0] = TTparset_USING;
    fs[1] = TTparseVSC_stat_parameter_plus;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_using_parameters, fs);
}

TTterm
TTparseVSC_stat_varying_identifier( void )
{
    fparse fs[2];

    fs[0] = TTparset_VARYING;
    fs[1] = TTparseVSC_expr_identifier;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_varying_identifier, fs);
}

TTterm
TTparseVSC_stat_when_condition_stats( void )
{
    fparse fs[3];

    fs[0] = TTparset_WHEN;
    fs[1] = TTparseVSC_cond_condition;
    fs[2] = TTparseVSC_stat_alt_statement_list_next_sentence;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_when_condition_stats, fs);
}

TTterm
TTparseVSC_stat_when_other_phrase( void )
{
    fparse fs[3];

    fs[0] = TTparset_WHEN;
    fs[1] = TTparset_OTHER;
    fs[2] = TTparseVSC_stat_statement_list;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_when_other_phrase, fs);
}

TTterm
TTparseVSC_stat_when_phrase( void )
{
    fparse fs[3];

    fs[0] = TTparset_WHEN;
    fs[1] = TTparseVSC_stat_evaluate_phrase;
    fs[2] = TTparseVSC_stat_when_phrase_also_phrase_star;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_when_phrase, fs);
}

TTterm
TTparseVSC_stat_when_phrase_also_phrase( void )
{
    fparse fs[2];

    fs[0] = TTparset_ALSO;
    fs[1] = TTparseVSC_stat_evaluate_phrase;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_when_phrase_also_phrase, fs);
}

TTterm
TTparseVSC_stat_when_phrases( void )
{
    fparse fs[2];

    fs[0] = TTparseVSC_stat_when_phrase_plus;
    fs[1] = TTparseVSC_stat_statement_list;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_when_phrases, fs);
}

TTterm
TTparseVSC_stat_with_duplicates_in_order( void )
{
    fparse fs[4];

    fs[0] = TTparset_WITH_opt;
    fs[1] = TTparset_DUPLICATES;
    fs[2] = TTparset_IN_opt;
    fs[3] = TTparset_ORDER_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_with_duplicates_in_order, fs);
}

TTterm
TTparseVSC_stat_with_no_advancing( void )
{
    fparse fs[3];

    fs[0] = TTparset_WITH_opt;
    fs[1] = TTparset_NO;
    fs[2] = TTparset_ADVANCING;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_with_no_advancing, fs);
}

TTterm
TTparseVSC_stat_with_no_rewind( void )
{
    fparse fs[3];

    fs[0] = TTparset_WITH_opt;
    fs[1] = TTparset_NO;
    fs[2] = TTparset_REWIND;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_with_no_rewind, fs);
}

TTterm
TTparseVSC_stat_with_pointer_identifier( void )
{
    fparse fs[3];

    fs[0] = TTparset_WITH_opt;
    fs[1] = TTparset_POINTER;
    fs[2] = TTparseVSC_expr_identifier;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_with_pointer_identifier, fs);
}

TTterm
TTparseVSC_stat_with_test( void )
{
    fparse fs[3];

    fs[0] = TTparset_WITH_opt;
    fs[1] = TTparset_TEST;
    fs[2] = TTparseVSC_stat_alt_before_after;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_with_test, fs);
}

TTterm
TTparseVSC_stat_write_exceptions( void )
{
    fparse fs[4];

    fs[0] = TTparseVSC_stat_at_end_of_page_statement_list_opt;
    fs[1] = TTparseVSC_stat_not_at_end_of_page_statement_list_opt;
    fs[2] = TTparseVSC_stat_invalid_key_statement_list_opt;
    fs[3] = TTparseVSC_stat_not_invalid_key_statement_list_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_write_exceptions, fs);
}

TTterm
TTparseVSC_stat_write_statement( void )
{
    fparse fs[6];

    fs[0] = TTparset_WRITE;
    fs[1] = TTparseVSC_expr_record_name;
    fs[2] = TTparseVSC_stat_from_identifier_opt;
    fs[3] = TTparseVSC_stat_advancing_phrase_opt;
    fs[4] = TTparseVSC_stat_write_exceptions;
    fs[5] = TTparset_END_WRITE_opt;
    return TTparseVSC_CONJUNCTION(TTfunVSC_stat_write_statement, fs);
}

static TTterm
TTparset_END_WRITE_opt( void )
{
    return TTparse_optional(TTparset_END_WRITE);
}

static TTterm
TTparset_END_WRITE( void )
{
    return TTparseVSC_KEYWORD("END-WRITE");
}

static TTterm
TTparseVSC_stat_advancing_phrase_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_advancing_phrase);
}

static TTterm
TTparset_WRITE( void )
{
    return TTparseVSC_KEYWORD("WRITE");
}

static TTterm
TTparseVSC_stat_not_at_end_of_page_statement_list_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_not_at_end_of_page_statement_list);
}

static TTterm
TTparseVSC_stat_at_end_of_page_statement_list_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_at_end_of_page_statement_list);
}

static TTterm
TTparset_TEST( void )
{
    return TTparseVSC_KEYWORD("TEST");
}

static TTterm
TTparset_ORDER_opt( void )
{
    return TTparse_optional(TTparset_ORDER);
}

static TTterm
TTparset_ORDER( void )
{
    return TTparseVSC_KEYWORD("ORDER");
}

static TTterm
TTparseVSC_stat_when_phrase_plus( void )
{
    return TTparse_plus(TTparseVSC_stat_when_phrase);
}

static TTterm
TTparseVSC_stat_when_phrase_also_phrase_star( void )
{
    return TTparse_star(TTparseVSC_stat_when_phrase_also_phrase);
}

static TTterm
TTparset_OTHER( void )
{
    return TTparseVSC_KEYWORD("OTHER");
}

static TTterm
TTparseVSC_stat_parameter_plus( void )
{
    return TTparse_plus(TTparseVSC_stat_parameter);
}

static TTterm
TTparseVSC_stat_alt_file_reel_unit_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_alt_file_reel_unit);
}

static TTterm
TTparseVSC_stat_alt_beginning_ending_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_alt_beginning_ending);
}

static TTterm
TTparset_STANDARD_opt( void )
{
    return TTparse_optional(TTparset_STANDARD);
}

static TTterm
TTparset_GLOBAL_opt( void )
{
    return TTparse_optional(TTparset_GLOBAL);
}

static TTterm
TTparset_USE( void )
{
    return TTparseVSC_KEYWORD("USE");
}

static TTterm
TTparset_UPON( void )
{
    return TTparseVSC_KEYWORD("UPON");
}

static TTterm
TTparseVSC_stat_count_in_identifier_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_count_in_identifier);
}

static TTterm
TTparseVSC_stat_delimiter_in_identifier_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_delimiter_in_identifier);
}

static TTterm
TTparset_END_UNSTRING_opt( void )
{
    return TTparse_optional(TTparset_END_UNSTRING);
}

static TTterm
TTparset_END_UNSTRING( void )
{
    return TTparseVSC_KEYWORD("END-UNSTRING");
}

static TTterm
TTparseVSC_stat_tallying_in_identifier_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_tallying_in_identifier);
}

static TTterm
TTparseVSC_stat_unstring_statement_dst_plus( void )
{
    return TTparse_plus(TTparseVSC_stat_unstring_statement_dst);
}

static TTterm
TTparseVSC_stat_delimited_by_all_phrase_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_delimited_by_all_phrase);
}

static TTterm
TTparset_UNSTRING( void )
{
    return TTparseVSC_KEYWORD("UNSTRING");
}

static TTterm
TTparseVSC_stat_tallying_for_id_or_lit_plus( void )
{
    return TTparse_plus(TTparseVSC_stat_tallying_for_id_or_lit);
}

static TTterm
TTparseVSC_stat_tallying_for_argument_plus( void )
{
    return TTparse_plus(TTparseVSC_stat_tallying_for_argument);
}

static TTterm
TTparset_END_SUBTRACT_opt( void )
{
    return TTparse_optional(TTparset_END_SUBTRACT);
}

static TTterm
TTparset_END_SUBTRACT( void )
{
    return TTparseVSC_KEYWORD("END-SUBTRACT");
}

static TTterm
TTparset_SUBTRACT( void )
{
    return TTparseVSC_KEYWORD("SUBTRACT");
}

static TTterm
TTparset_END_STRING_opt( void )
{
    return TTparse_optional(TTparset_END_STRING);
}

static TTterm
TTparset_END_STRING( void )
{
    return TTparseVSC_KEYWORD("END-STRING");
}

static TTterm
TTparseVSC_stat_not_on_overflow_statement_list_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_not_on_overflow_statement_list);
}

static TTterm
TTparseVSC_stat_with_pointer_identifier_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_with_pointer_identifier);
}

static TTterm
TTparseVSC_stat_delimited_by_phrase_plus( void )
{
    return TTparse_plus(TTparseVSC_stat_delimited_by_phrase);
}

static TTterm
TTparset_STRING( void )
{
    return TTparseVSC_KEYWORD("STRING");
}

static TTterm
TTparset_STOP( void )
{
    return TTparseVSC_KEYWORD("STOP");
}

static TTterm
TTparseVSC_stat_statement_plus( void )
{
    return TTparse_plus(TTparseVSC_stat_statement);
}

static TTterm
TTparset_END_START_opt( void )
{
    return TTparse_optional(TTparset_END_START);
}

static TTterm
TTparset_END_START( void )
{
    return TTparseVSC_KEYWORD("END-START");
}

static TTterm
TTparseVSC_stat_key_is_rel_op_qualified_data_name_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_key_is_rel_op_qualified_data_name);
}

static TTterm
TTparset_START( void )
{
    return TTparseVSC_KEYWORD("START");
}

static TTterm
TTparseVSC_stat_with_duplicates_in_order_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_with_duplicates_in_order);
}

static TTterm
TTparseVSC_stat_on_key_is_phrase_plus( void )
{
    return TTparse_plus(TTparseVSC_stat_on_key_is_phrase);
}

static TTterm
TTparseVSC_stat_set_statement_phrase_plus( void )
{
    return TTparse_plus(TTparseVSC_stat_set_statement_phrase);
}

static TTterm
TTparset_SET( void )
{
    return TTparseVSC_KEYWORD("SET");
}

static TTterm
TTparseVSC_stat_search_statement_condition_tail_star( void )
{
    return TTparse_star(TTparseVSC_stat_search_statement_condition_tail);
}

static TTterm
TTparset_END_SEARCH_opt( void )
{
    return TTparse_optional(TTparset_END_SEARCH);
}

static TTterm
TTparset_END_SEARCH( void )
{
    return TTparseVSC_KEYWORD("END-SEARCH");
}

static TTterm
TTparseVSC_stat_when_condition_stats_plus( void )
{
    return TTparse_plus(TTparseVSC_stat_when_condition_stats);
}

static TTterm
TTparseVSC_stat_varying_identifier_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_varying_identifier);
}

static TTterm
TTparset_SEARCH( void )
{
    return TTparseVSC_KEYWORD("SEARCH");
}

static TTterm
TTparset_END_REWRITE_opt( void )
{
    return TTparse_optional(TTparset_END_REWRITE);
}

static TTterm
TTparset_END_REWRITE( void )
{
    return TTparseVSC_KEYWORD("END-REWRITE");
}

static TTterm
TTparset_REWRITE( void )
{
    return TTparseVSC_KEYWORD("REWRITE");
}

static TTterm
TTparset_END_RETURN_opt( void )
{
    return TTparse_optional(TTparset_END_RETURN);
}

static TTterm
TTparset_END_RETURN( void )
{
    return TTparseVSC_KEYWORD("END-RETURN");
}

static TTterm
TTparset_RETURN( void )
{
    return TTparseVSC_KEYWORD("RETURN");
}

static TTterm
TTparseVSC_stat_from_identifier_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_from_identifier);
}

static TTterm
TTparset_RELEASE( void )
{
    return TTparseVSC_KEYWORD("RELEASE");
}

static TTterm
TTparseVSC_stat_by_reference_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_by_reference);
}

static TTterm
TTparset_END_READ_opt( void )
{
    return TTparse_optional(TTparset_END_READ);
}

static TTterm
TTparset_END_READ( void )
{
    return TTparseVSC_KEYWORD("END-READ");
}

static TTterm
TTparseVSC_stat_not_at_end_statement_list_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_not_at_end_statement_list);
}

static TTterm
TTparseVSC_stat_at_end_statement_list_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_at_end_statement_list);
}

static TTterm
TTparseVSC_stat_key_is_qualified_data_name_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_key_is_qualified_data_name);
}

static TTterm
TTparseVSC_stat_into_identifier_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_into_identifier);
}

static TTterm
TTparset_NEXT_opt( void )
{
    return TTparse_optional(TTparset_NEXT);
}

static TTterm
TTparset_READ( void )
{
    return TTparseVSC_KEYWORD("READ");
}

static TTterm
TTparset_PROCEED( void )
{
    return TTparseVSC_KEYWORD("PROCEED");
}

static TTterm
TTparseVSC_stat_proceed_to_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_proceed_to);
}

static TTterm
TTparseVSC_stat_with_test_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_with_test);
}

static TTterm
TTparseVSC_stat_perform_after_phrase_star( void )
{
    return TTparse_star(TTparseVSC_stat_perform_after_phrase);
}

static TTterm
TTparset_END_PERFORM( void )
{
    return TTparseVSC_KEYWORD("END-PERFORM");
}

static TTterm
TTparset_PERFORM( void )
{
    return TTparseVSC_KEYWORD("PERFORM");
}

static TTterm
TTparset_UNTIL( void )
{
    return TTparseVSC_KEYWORD("UNTIL");
}

static TTterm
TTparset_PAGE( void )
{
    return TTparseVSC_KEYWORD("PAGE");
}

static TTterm
TTparseVSC_stat_with_no_rewind_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_with_no_rewind);
}

static TTterm
TTparseVSC_stat_open_statement_output_file_name_plus( void )
{
    return TTparse_plus(TTparseVSC_stat_open_statement_output_file_name);
}

static TTterm
TTparseVSC_stat_alt_reversed_with_no_rewind_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_alt_reversed_with_no_rewind);
}

static TTterm
TTparseVSC_stat_open_statement_input_file_name_plus( void )
{
    return TTparse_plus(TTparseVSC_stat_open_statement_input_file_name);
}

static TTterm
TTparseVSC_stat_open_statement_phrase_plus( void )
{
    return TTparse_plus(TTparseVSC_stat_open_statement_phrase);
}

static TTterm
TTparset_OPEN( void )
{
    return TTparseVSC_KEYWORD("OPEN");
}

static TTterm
TTparseVSC_stat_key_is_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_key_is);
}

static TTterm
TTparseVSC_stat_lines_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_lines);
}

static TTterm
TTparset_OVERFLOW( void )
{
    return TTparseVSC_KEYWORD("OVERFLOW");
}

static TTterm
TTparset_REWIND( void )
{
    return TTparseVSC_KEYWORD("REWIND");
}

static TTterm
TTparset_NO( void )
{
    return TTparseVSC_KEYWORD("NO");
}

static TTterm
TTparset_SENTENCE( void )
{
    return TTparseVSC_KEYWORD("SENTENCE");
}

static TTterm
TTparset_NEXT( void )
{
    return TTparseVSC_KEYWORD("NEXT");
}

static TTterm
TTparset_END_MULTIPLY_opt( void )
{
    return TTparse_optional(TTparset_END_MULTIPLY);
}

static TTterm
TTparset_END_MULTIPLY( void )
{
    return TTparseVSC_KEYWORD("END-MULTIPLY");
}

static TTterm
TTparset_MULTIPLY( void )
{
    return TTparseVSC_KEYWORD("MULTIPLY");
}

static TTterm
TTparset_MOVE( void )
{
    return TTparseVSC_KEYWORD("MOVE");
}

static TTterm
TTparseVSC_stat_collating_sequence_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_collating_sequence);
}

static TTterm
TTparseVSC_stat_on_key_phrase_plus( void )
{
    return TTparse_plus(TTparseVSC_stat_on_key_phrase);
}

static TTterm
TTparset_MERGE( void )
{
    return TTparseVSC_KEYWORD("MERGE");
}

static TTterm
TTparset_LINE( void )
{
    return TTparseVSC_KEYWORD("LINE");
}

static TTterm
TTparset_INVALID( void )
{
    return TTparseVSC_KEYWORD("INVALID");
}

static TTterm
TTparseVSC_stat_inspect_replacing_phrase_plus( void )
{
    return TTparse_plus(TTparseVSC_stat_inspect_replacing_phrase);
}

static TTterm
TTparset_CONVERTING( void )
{
    return TTparseVSC_KEYWORD("CONVERTING");
}

static TTterm
TTparseVSC_stat_tallying_argument_plus( void )
{
    return TTparse_plus(TTparseVSC_stat_tallying_argument);
}

static TTterm
TTparset_TALLYING( void )
{
    return TTparseVSC_KEYWORD("TALLYING");
}

static TTterm
TTparset_INSPECT( void )
{
    return TTparseVSC_KEYWORD("INSPECT");
}

static TTterm
TTparseVSC_stat_inspect_replacing_argument_plus( void )
{
    return TTparse_plus(TTparseVSC_stat_inspect_replacing_argument);
}

static TTterm
TTparseVSC_stat_before_after_phrase_star( void )
{
    return TTparse_star(TTparseVSC_stat_before_after_phrase);
}

static TTterm
TTparseVSC_stat_through_procedure_name_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_through_procedure_name);
}

static TTterm
TTparseVSC_stat_initialize_replacing_phrase_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_initialize_replacing_phrase);
}

static TTterm
TTparseVSC_expr_identifier_plus( void )
{
    return TTparse_plus(TTparseVSC_expr_identifier);
}

static TTterm
TTparset_INITIALIZE( void )
{
    return TTparseVSC_KEYWORD("INITIALIZE");
}

static TTterm
TTparset_EGCS( void )
{
    return TTparseVSC_KEYWORD("EGCS");
}

static TTterm
TTparset_NUMERIC_EDITED( void )
{
    return TTparseVSC_KEYWORD("NUMERIC-EDITED");
}

static TTterm
TTparset_ALPHANUMERIC_EDITED( void )
{
    return TTparseVSC_KEYWORD("ALPHANUMERIC-EDITED");
}

static TTterm
TTparset_ALPHANUMERIC( void )
{
    return TTparseVSC_KEYWORD("ALPHANUMERIC");
}

static TTterm
TTparseVSC_stat_initialize_replacing_argument_plus( void )
{
    return TTparse_plus(TTparseVSC_stat_initialize_replacing_argument);
}

static TTterm
TTparset_DATA_opt( void )
{
    return TTparse_optional(TTparset_DATA);
}

static TTterm
TTparset_END_IF_opt( void )
{
    return TTparse_optional(TTparset_END_IF);
}

static TTterm
TTparset_END_IF( void )
{
    return TTparseVSC_KEYWORD("END-IF");
}

static TTterm
TTparseVSC_stat_else_phrase_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_else_phrase);
}

static TTterm
TTparset_IF( void )
{
    return TTparseVSC_KEYWORD("IF");
}

static TTterm
TTparset_GOBACK( void )
{
    return TTparseVSC_KEYWORD("GOBACK");
}

static TTterm
TTparset_MORE_LABELS( void )
{
    return TTparseVSC_KEYWORD("MORE-LABELS");
}

static TTterm
TTparseVSC_expr_procedure_name_plus( void )
{
    return TTparse_plus(TTparseVSC_expr_procedure_name);
}

static TTterm
TTparset_REMOVAL( void )
{
    return TTparseVSC_KEYWORD("REMOVAL");
}

static TTterm
TTparset_EXIT( void )
{
    return TTparseVSC_KEYWORD("EXIT");
}

static TTterm
TTparset_END_EVALUATE_opt( void )
{
    return TTparse_optional(TTparset_END_EVALUATE);
}

static TTterm
TTparset_END_EVALUATE( void )
{
    return TTparseVSC_KEYWORD("END-EVALUATE");
}

static TTterm
TTparseVSC_stat_when_other_phrase_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_when_other_phrase);
}

static TTterm
TTparseVSC_stat_when_phrases_plus( void )
{
    return TTparse_plus(TTparseVSC_stat_when_phrases);
}

static TTterm
TTparseVSC_stat_also_phrase_star( void )
{
    return TTparse_star(TTparseVSC_stat_also_phrase);
}

static TTterm
TTparset_EVALUATE( void )
{
    return TTparseVSC_KEYWORD("EVALUATE");
}

static TTterm
TTparset_ANY( void )
{
    return TTparseVSC_KEYWORD("ANY");
}

static TTterm
TTparset_FALSE( void )
{
    return TTparseVSC_KEYWORD("FALSE");
}

static TTterm
TTparset_TRUE( void )
{
    return TTparseVSC_KEYWORD("TRUE");
}

static TTterm
TTparset_ENTRY( void )
{
    return TTparseVSC_KEYWORD("ENTRY");
}

static TTterm
TTparset_EOP( void )
{
    return TTparseVSC_KEYWORD("EOP");
}

static TTterm
TTparset_END_OF_PAGE( void )
{
    return TTparseVSC_KEYWORD("END-OF-PAGE");
}

static TTterm
TTparset_ELSE( void )
{
    return TTparseVSC_KEYWORD("ELSE");
}

static TTterm
TTparset_REMAINDER( void )
{
    return TTparseVSC_KEYWORD("REMAINDER");
}

static TTterm
TTparset_END_DIVIDE_opt( void )
{
    return TTparse_optional(TTparset_END_DIVIDE);
}

static TTterm
TTparset_END_DIVIDE( void )
{
    return TTparseVSC_KEYWORD("END-DIVIDE");
}

static TTterm
TTparset_INTO( void )
{
    return TTparseVSC_KEYWORD("INTO");
}

static TTterm
TTparset_DIVIDE( void )
{
    return TTparseVSC_KEYWORD("DIVIDE");
}

static TTterm
TTparseVSC_stat_with_no_advancing_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_with_no_advancing);
}

static TTterm
TTparseVSC_stat_upon_environment_name_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_upon_environment_name);
}

static TTterm
TTparseVSC_stat_or_all_id_or_lit_star( void )
{
    return TTparse_star(TTparseVSC_stat_or_all_id_or_lit);
}

static TTterm
TTparset_ALL_opt( void )
{
    return TTparse_optional(TTparset_ALL);
}

static TTterm
TTparset_DELIMITED( void )
{
    return TTparseVSC_KEYWORD("DELIMITED");
}

static TTterm
TTparset_END_DELETE_opt( void )
{
    return TTparse_optional(TTparset_END_DELETE);
}

static TTterm
TTparset_END_DELETE( void )
{
    return TTparseVSC_KEYWORD("END-DELETE");
}

static TTterm
TTparseVSC_stat_not_invalid_key_statement_list_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_not_invalid_key_statement_list);
}

static TTterm
TTparseVSC_stat_invalid_key_statement_list_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_invalid_key_statement_list);
}

static TTterm
TTparset_DELETE( void )
{
    return TTparseVSC_KEYWORD("DELETE");
}

static TTterm
TTparset_TIME( void )
{
    return TTparseVSC_KEYWORD("TIME");
}

static TTterm
TTparset_DAY_OF_WEEK( void )
{
    return TTparseVSC_KEYWORD("DAY-OF-WEEK");
}

static TTterm
TTparset_DAY( void )
{
    return TTparseVSC_KEYWORD("DAY");
}

static TTterm
TTparset_DATE( void )
{
    return TTparseVSC_KEYWORD("DATE");
}

static TTterm
TTparset_COUNT( void )
{
    return TTparseVSC_KEYWORD("COUNT");
}

static TTterm
TTparset_CORR( void )
{
    return TTparseVSC_KEYWORD("CORR");
}

static TTterm
TTparset_CORRESPONDING( void )
{
    return TTparseVSC_KEYWORD("CORRESPONDING");
}

static TTterm
TTparset_CONTINUE( void )
{
    return TTparseVSC_KEYWORD("CONTINUE");
}

static TTterm
TTparseVSC_stat_content_parameter_value_plus( void )
{
    return TTparse_plus(TTparseVSC_stat_content_parameter_value);
}

static TTterm
TTparset_CONTENT( void )
{
    return TTparseVSC_KEYWORD("CONTENT");
}

static TTterm
TTparset_END_COMPUTE_opt( void )
{
    return TTparse_optional(TTparset_END_COMPUTE);
}

static TTterm
TTparset_END_COMPUTE( void )
{
    return TTparseVSC_KEYWORD("END-COMPUTE");
}

static TTterm
TTparset_COMPUTE( void )
{
    return TTparseVSC_KEYWORD("COMPUTE");
}

static TTterm
TTparseVSC_stat_alt_removal_no_rewind_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_alt_removal_no_rewind);
}

static TTterm
TTparseVSC_stat_close_statement_options_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_close_statement_options);
}

static TTterm
TTparseVSC_stat_close_statement_file_name_plus( void )
{
    return TTparse_plus(TTparseVSC_stat_close_statement_file_name);
}

static TTterm
TTparset_CLOSE( void )
{
    return TTparseVSC_KEYWORD("CLOSE");
}

static TTterm
TTparset_CANCEL( void )
{
    return TTparseVSC_KEYWORD("CANCEL");
}

static TTterm
TTparset_END_CALL_opt( void )
{
    return TTparse_optional(TTparset_END_CALL);
}

static TTterm
TTparset_END_CALL( void )
{
    return TTparseVSC_KEYWORD("END-CALL");
}

static TTterm
TTparseVSC_stat_using_parameters_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_using_parameters);
}

static TTterm
TTparset_CALL( void )
{
    return TTparseVSC_KEYWORD("CALL");
}

static TTterm
TTparseVSC_stat_on_overflow_statement_list_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_on_overflow_statement_list);
}

static TTterm
TTparseVSC_stat_not_on_exception_statement_list_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_not_on_exception_statement_list);
}

static TTterm
TTparseVSC_stat_on_exception_statement_list_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_on_exception_statement_list);
}

static TTterm
TTparset_REFERENCE( void )
{
    return TTparseVSC_KEYWORD("REFERENCE");
}

static TTterm
TTparseVSC_stat_procedure_to_procedure_plus( void )
{
    return TTparse_plus(TTparseVSC_stat_procedure_to_procedure);
}

static TTterm
TTparset_ALTER( void )
{
    return TTparseVSC_KEYWORD("ALTER");
}

static TTterm
TTparset_DOWN( void )
{
    return TTparseVSC_KEYWORD("DOWN");
}

static TTterm
TTparset_UP( void )
{
    return TTparseVSC_KEYWORD("UP");
}

static TTterm
TTparset_RUN( void )
{
    return TTparseVSC_KEYWORD("RUN");
}

static TTterm
TTparset_REVERSED( void )
{
    return TTparseVSC_KEYWORD("REVERSED");
}

static TTterm
TTparset_LOCK( void )
{
    return TTparseVSC_KEYWORD("LOCK");
}

static TTterm
TTparset_EXTEND( void )
{
    return TTparseVSC_KEYWORD("EXTEND");
}

static TTterm
TTparset_I_O( void )
{
    return TTparseVSC_KEYWORD("I-O");
}

static TTterm
TTparset_OUTPUT( void )
{
    return TTparseVSC_KEYWORD("OUTPUT");
}

static TTterm
TTparset_INPUT( void )
{
    return TTparseVSC_KEYWORD("INPUT");
}

static TTterm
TTparset_ERROR( void )
{
    return TTparseVSC_KEYWORD("ERROR");
}

static TTterm
TTparset_EXCEPTION( void )
{
    return TTparseVSC_KEYWORD("EXCEPTION");
}

static TTterm
TTparset_ENDING( void )
{
    return TTparseVSC_KEYWORD("ENDING");
}

static TTterm
TTparset_BEGINNING( void )
{
    return TTparseVSC_KEYWORD("BEGINNING");
}

static TTterm
TTparset_AFTER( void )
{
    return TTparseVSC_KEYWORD("AFTER");
}

static TTterm
TTparset_BEFORE( void )
{
    return TTparseVSC_KEYWORD("BEFORE");
}

static TTterm
TTparset_FIRST( void )
{
    return TTparseVSC_KEYWORD("FIRST");
}

static TTterm
TTparset_PROCEDURES( void )
{
    return TTparseVSC_KEYWORD("PROCEDURES");
}

static TTterm
TTparset_ADVANCING_opt( void )
{
    return TTparse_optional(TTparset_ADVANCING);
}

static TTterm
TTparset_ADVANCING( void )
{
    return TTparseVSC_KEYWORD("ADVANCING");
}

static TTterm
TTparset_ROUNDED_opt( void )
{
    return TTparse_optional(TTparset_ROUNDED);
}

static TTterm
TTparset_ROUNDED( void )
{
    return TTparseVSC_KEYWORD("ROUNDED");
}

static TTterm
TTparset_GIVING( void )
{
    return TTparseVSC_KEYWORD("GIVING");
}

static TTterm
TTparseVSC_stat_to_id_or_lit_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_to_id_or_lit);
}

static TTterm
TTparset_END_ADD_opt( void )
{
    return TTparse_optional(TTparset_END_ADD);
}

static TTterm
TTparset_END_ADD( void )
{
    return TTparseVSC_KEYWORD("END-ADD");
}

static TTterm
TTparseVSC_stat_not_on_size_error_statement_list_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_not_on_size_error_statement_list);
}

static TTterm
TTparseVSC_stat_on_size_error_statement_list_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_on_size_error_statement_list);
}

static TTterm
TTparseVSC_stat_cobword_rounded_plus( void )
{
    return TTparse_plus(TTparseVSC_stat_cobword_rounded);
}

static TTterm
TTparseVSC_stat_id_or_lit_plus( void )
{
    return TTparse_plus(TTparseVSC_stat_id_or_lit);
}

static TTterm
TTparset_ADD( void )
{
    return TTparseVSC_KEYWORD("ADD");
}

static TTterm
TTparseVSC_stat_from_environment_name_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_from_environment_name);
}

static TTterm
TTparset_ACCEPT( void )
{
    return TTparseVSC_KEYWORD("ACCEPT");
}

static TTterm
TTparseVSC_proc_div_using_data_names_opt( void )
{
    return TTparse_optional(TTparseVSC_proc_div_using_data_names);
}

static TTterm
TTparseVSC_stat_using_data_name_pluslist_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_using_data_name_pluslist);
}

static TTterm
TTparseVSC_expr_data_name_star( void )
{
    return TTparse_star(TTparseVSC_expr_data_name);
}

static TTterm
TTparset_USING( void )
{
    return TTparseVSC_KEYWORD("USING");
}

static TTterm
TTparseVSC_stat_statement_list_opt( void )
{
    return TTparse_optional(TTparseVSC_stat_statement_list);
}

static TTterm
TTparset_qdot_plus( void )
{
    return TTparse_plus(TTparset_qdot);
}

static TTterm
TTparseVSC_proc_div_section_with_header_star( void )
{
    return TTparse_star(TTparseVSC_proc_div_section_with_header);
}

static TTterm
TTparseVSC_expr_priority_number_opt( void )
{
    return TTparse_optional(TTparseVSC_expr_priority_number);
}

static TTterm
TTparseVSC_proc_div_declaratives_opt( void )
{
    return TTparse_optional(TTparseVSC_proc_div_declaratives);
}

static TTterm
TTparset_PROCEDURE( void )
{
    return TTparseVSC_KEYWORD("PROCEDURE");
}

static TTterm
TTparseVSC_proc_div_paragraph_star( void )
{
    return TTparse_star(TTparseVSC_proc_div_paragraph);
}

static TTterm
TTparseVSC_proc_div_sentence_star( void )
{
    return TTparse_star(TTparseVSC_proc_div_sentence);
}

static TTterm
TTparseVSC_proc_div_declaratives_content_plus( void )
{
    return TTparse_plus(TTparseVSC_proc_div_declaratives_content);
}

static TTterm
TTparset_DECLARATIVES( void )
{
    return TTparseVSC_KEYWORD("DECLARATIVES");
}

static TTterm
TTparset_GO( void )
{
    return TTparseVSC_KEYWORD("GO");
}

static TTterm
TTparseVSC_main_cobol_source_program_plus( void )
{
    return TTparse_plus(TTparseVSC_main_cobol_source_program);
}

static TTterm
TTparseVSC_main_common_initial_program_opt( void )
{
    return TTparse_optional(TTparseVSC_main_common_initial_program);
}

static TTterm
TTparseVSC_main_nested_cobol_source_program_star( void )
{
    return TTparse_star(TTparseVSC_main_nested_cobol_source_program);
}

static TTterm
TTparseVSC_id_div_identification_division_content_opt( void )
{
    return TTparse_optional(TTparseVSC_id_div_identification_division_content);
}

static TTterm
TTparset_COMMON_opt( void )
{
    return TTparse_optional(TTparset_COMMON);
}

static TTterm
TTparset_INITIAL_opt( void )
{
    return TTparse_optional(TTparset_INITIAL);
}

static TTterm
TTparset_COMMON( void )
{
    return TTparseVSC_KEYWORD("COMMON");
}

static TTterm
TTparseVSC_main_nested_program_opt( void )
{
    return TTparse_optional(TTparseVSC_main_nested_program);
}

static TTterm
TTparseVSC_proc_div_procedure_division_opt( void )
{
    return TTparse_optional(TTparseVSC_proc_div_procedure_division);
}

static TTterm
TTparseVSC_data_div_data_division_opt( void )
{
    return TTparse_optional(TTparseVSC_data_div_data_division);
}

static TTterm
TTparseVSC_env_div_environment_division_opt( void )
{
    return TTparse_optional(TTparseVSC_env_div_environment_division);
}

static TTterm
TTparset_DUPLICATES( void )
{
    return TTparseVSC_KEYWORD("DUPLICATES");
}

static TTterm
TTparseVSC_io_sec_same_area_plus( void )
{
    return TTparse_plus(TTparseVSC_io_sec_same_area);
}

static TTterm
TTparseVSC_io_sec_rerun_on_opt( void )
{
    return TTparse_optional(TTparseVSC_io_sec_rerun_on);
}

static TTterm
TTparset_OPTIONAL_opt( void )
{
    return TTparse_optional(TTparset_OPTIONAL);
}

static TTterm
TTparset_OPTIONAL( void )
{
    return TTparseVSC_KEYWORD("OPTIONAL");
}

static TTterm
TTparset_SELECT( void )
{
    return TTparseVSC_KEYWORD("SELECT");
}

static TTterm
TTparseVSC_io_sec_areas_opt( void )
{
    return TTparse_optional(TTparseVSC_io_sec_areas);
}

static TTterm
TTparset_RESERVE( void )
{
    return TTparseVSC_KEYWORD("RESERVE");
}

static TTterm
TTparset_SORT_MERGE( void )
{
    return TTparseVSC_KEYWORD("SORT-MERGE");
}

static TTterm
TTparset_SORT( void )
{
    return TTparseVSC_KEYWORD("SORT");
}

static TTterm
TTparset_DELIMITER( void )
{
    return TTparseVSC_KEYWORD("DELIMITER");
}

static TTterm
TTparset_WRITE_ONLY( void )
{
    return TTparseVSC_KEYWORD("WRITE-ONLY");
}

static TTterm
TTparset_APPLY( void )
{
    return TTparseVSC_KEYWORD("APPLY");
}

static TTterm
TTparseVSC_io_sec_file_name_position_plus( void )
{
    return TTparse_plus(TTparseVSC_io_sec_file_name_position);
}

static TTterm
TTparset_TAPE_opt( void )
{
    return TTparse_optional(TTparset_TAPE);
}

static TTterm
TTparset_TAPE( void )
{
    return TTparseVSC_KEYWORD("TAPE");
}

static TTterm
TTparset_MULTIPLE( void )
{
    return TTparseVSC_KEYWORD("MULTIPLE");
}

static TTterm
TTparseVSC_expr_file_name_plus( void )
{
    return TTparse_plus(TTparseVSC_expr_file_name);
}

static TTterm
TTparset_FOR_opt( void )
{
    return TTparse_optional(TTparset_FOR);
}

static TTterm
TTparset_FOR( void )
{
    return TTparseVSC_KEYWORD("FOR");
}

static TTterm
TTparset_AREA_opt( void )
{
    return TTparse_optional(TTparset_AREA);
}

static TTterm
TTparset_SAME( void )
{
    return TTparseVSC_KEYWORD("SAME");
}

static TTterm
TTparset_EVERY_opt( void )
{
    return TTparse_optional(TTparset_EVERY);
}

static TTterm
TTparset_EVERY( void )
{
    return TTparseVSC_KEYWORD("EVERY");
}

static TTterm
TTparset_RERUN( void )
{
    return TTparseVSC_KEYWORD("RERUN");
}

static TTterm
TTparset_POSITION( void )
{
    return TTparseVSC_KEYWORD("POSITION");
}

static TTterm
TTparset_PASSWORD( void )
{
    return TTparseVSC_KEYWORD("PASSWORD");
}

static TTterm
TTparset_PADDING( void )
{
    return TTparseVSC_KEYWORD("PADDING");
}

static TTterm
TTparset_ORGANIZATION( void )
{
    return TTparseVSC_KEYWORD("ORGANIZATION");
}

static TTterm
TTparseVSC_io_sec_i_o_control_paragraph_opt( void )
{
    return TTparse_optional(TTparseVSC_io_sec_i_o_control_paragraph);
}

static TTterm
TTparseVSC_io_sec_file_control_paragraph_opt( void )
{
    return TTparse_optional(TTparseVSC_io_sec_file_control_paragraph);
}

static TTterm
TTparset_INPUT_OUTPUT( void )
{
    return TTparseVSC_KEYWORD("INPUT-OUTPUT");
}

static TTterm
TTparseVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_plus( void )
{
    return TTparse_plus(TTparseVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries);
}

static TTterm
TTparseVSC_io_sec_i_o_sort_merge_opt( void )
{
    return TTparse_optional(TTparseVSC_io_sec_i_o_sort_merge);
}

static TTterm
TTparseVSC_io_sec_i_o_sam_opt( void )
{
    return TTparse_optional(TTparseVSC_io_sec_i_o_sam);
}

static TTterm
TTparset_I_O_CONTROL( void )
{
    return TTparseVSC_KEYWORD("I-O-CONTROL");
}

static TTterm
TTparseVSC_expr_qualified_data_name_opt( void )
{
    return TTparse_optional(TTparseVSC_expr_qualified_data_name);
}

static TTterm
TTparset_FILE_opt( void )
{
    return TTparse_optional(TTparset_FILE);
}

static TTterm
TTparseVSC_io_sec_position_opt( void )
{
    return TTparse_optional(TTparseVSC_io_sec_position);
}

static TTterm
TTparseVSC_io_sec_file_control_entry_star( void )
{
    return TTparse_star(TTparseVSC_io_sec_file_control_entry);
}

static TTterm
TTparset_FILE_CONTROL( void )
{
    return TTparseVSC_KEYWORD("FILE-CONTROL");
}

static TTterm
TTparseVSC_io_sec_fce_phrase_star( void )
{
    return TTparse_star(TTparseVSC_io_sec_fce_phrase);
}

static TTterm
TTparseVSC_io_sec_organization_is_opt( void )
{
    return TTparse_optional(TTparseVSC_io_sec_organization_is);
}

static TTterm
TTparseVSC_io_sec_relative_key_clause_opt( void )
{
    return TTparse_optional(TTparseVSC_io_sec_relative_key_clause);
}

static TTterm
TTparset_ACCESS( void )
{
    return TTparseVSC_KEYWORD("ACCESS");
}

static TTterm
TTparset_OF_opt( void )
{
    return TTparse_optional(TTparset_OF);
}

static TTterm
TTparset_END( void )
{
    return TTparseVSC_KEYWORD("END");
}

static TTterm
TTparseVSC_io_sec_alt_assignment_name_literal_plus( void )
{
    return TTparse_plus(TTparseVSC_io_sec_alt_assignment_name_literal);
}

static TTterm
TTparset_ASSIGN( void )
{
    return TTparseVSC_KEYWORD("ASSIGN");
}

static TTterm
TTparset_AREAS( void )
{
    return TTparseVSC_KEYWORD("AREAS");
}

static TTterm
TTparset_AREA( void )
{
    return TTparseVSC_KEYWORD("AREA");
}

static TTterm
TTparseVSC_io_sec_with_duplicates_opt( void )
{
    return TTparse_optional(TTparseVSC_io_sec_with_duplicates);
}

static TTterm
TTparseVSC_io_sec_password_clause_opt( void )
{
    return TTparse_optional(TTparseVSC_io_sec_password_clause);
}

static TTterm
TTparset_RECORD_opt( void )
{
    return TTparse_optional(TTparset_RECORD);
}

static TTterm
TTparset_ALTERNATE( void )
{
    return TTparseVSC_KEYWORD("ALTERNATE");
}

static TTterm
TTparset_DYNAMIC( void )
{
    return TTparseVSC_KEYWORD("DYNAMIC");
}

static TTterm
TTparset_RANDOM( void )
{
    return TTparseVSC_KEYWORD("RANDOM");
}

static TTterm
TTparset_SEQUENTIAL( void )
{
    return TTparseVSC_KEYWORD("SEQUENTIAL");
}

static TTterm
TTparset_RELATIVE( void )
{
    return TTparseVSC_KEYWORD("RELATIVE");
}

static TTterm
TTparset_SECURITY( void )
{
    return TTparseVSC_KEYWORD("SECURITY");
}

static TTterm
TTparset_REMARKS( void )
{
    return TTparseVSC_KEYWORD("REMARKS");
}

static TTterm
TTparseVSC_id_div_initial_program_opt( void )
{
    return TTparse_optional(TTparseVSC_id_div_initial_program);
}

static TTterm
TTparset_PROGRAM_ID( void )
{
    return TTparseVSC_KEYWORD("PROGRAM-ID");
}

static TTterm
TTparset_INSTALLATION( void )
{
    return TTparseVSC_KEYWORD("INSTALLATION");
}

static TTterm
TTparset_INITIAL( void )
{
    return TTparseVSC_KEYWORD("INITIAL");
}

static TTterm
TTparseVSC_id_div_identification_division_phrase_star( void )
{
    return TTparse_star(TTparseVSC_id_div_identification_division_phrase);
}

static TTterm
TTparset_ID( void )
{
    return TTparseVSC_KEYWORD("ID");
}

static TTterm
TTparset_IDENTIFICATION( void )
{
    return TTparseVSC_KEYWORD("IDENTIFICATION");
}

static TTterm
TTparset_DATE_WRITTEN( void )
{
    return TTparseVSC_KEYWORD("DATE-WRITTEN");
}

static TTterm
TTparset_DATE_COMPILED( void )
{
    return TTparseVSC_KEYWORD("DATE-COMPILED");
}

static TTterm
TTparset_AUTHOR( void )
{
    return TTparseVSC_KEYWORD("AUTHOR");
}

static TTterm
TTparseVSC_fd_entry_value_of_clause_tail_plus( void )
{
    return TTparse_plus(TTparseVSC_fd_entry_value_of_clause_tail);
}

static TTterm
TTparset_MODE_opt( void )
{
    return TTparse_optional(TTparset_MODE);
}

static TTterm
TTparset_RECORDING( void )
{
    return TTparseVSC_KEYWORD("RECORDING");
}

static TTterm
TTparseVSC_fd_entry_to_integer_opt( void )
{
    return TTparse_optional(TTparseVSC_fd_entry_to_integer);
}

static TTterm
TTparseVSC_fd_entry_from_integer_opt( void )
{
    return TTparse_optional(TTparseVSC_fd_entry_from_integer);
}

static TTterm
TTparset_IN_opt( void )
{
    return TTparse_optional(TTparset_IN);
}

static TTterm
TTparset_VARYING( void )
{
    return TTparseVSC_KEYWORD("VARYING");
}

static TTterm
TTparseVSC_fd_entry_depending_on_opt( void )
{
    return TTparse_optional(TTparseVSC_fd_entry_depending_on);
}

static TTterm
TTparset_TOP( void )
{
    return TTparseVSC_KEYWORD("TOP");
}

static TTterm
TTparset_BOTTOM( void )
{
    return TTparseVSC_KEYWORD("BOTTOM");
}

static TTterm
TTparseVSC_fd_entry_lines_bottom_opt( void )
{
    return TTparse_optional(TTparseVSC_fd_entry_lines_bottom);
}

static TTterm
TTparseVSC_fd_entry_lines_top_opt( void )
{
    return TTparse_optional(TTparseVSC_fd_entry_lines_top);
}

static TTterm
TTparseVSC_fd_entry_footing_opt( void )
{
    return TTparse_optional(TTparseVSC_fd_entry_footing);
}

static TTterm
TTparset_LINES_opt( void )
{
    return TTparse_optional(TTparset_LINES);
}

static TTterm
TTparset_LINES( void )
{
    return TTparseVSC_KEYWORD("LINES");
}

static TTterm
TTparset_LINAGE( void )
{
    return TTparseVSC_KEYWORD("LINAGE");
}

static TTterm
TTparset_OMITTED( void )
{
    return TTparseVSC_KEYWORD("OMITTED");
}

static TTterm
TTparset_STANDARD( void )
{
    return TTparseVSC_KEYWORD("STANDARD");
}

static TTterm
TTparset_LABEL( void )
{
    return TTparseVSC_KEYWORD("LABEL");
}

static TTterm
TTparset_FROM_opt( void )
{
    return TTparse_optional(TTparset_FROM);
}

static TTterm
TTparset_FROM( void )
{
    return TTparseVSC_KEYWORD("FROM");
}

static TTterm
TTparset_AT_opt( void )
{
    return TTparse_optional(TTparset_AT);
}

static TTterm
TTparset_AT( void )
{
    return TTparseVSC_KEYWORD("AT");
}

static TTterm
TTparset_FOOTING( void )
{
    return TTparseVSC_KEYWORD("FOOTING");
}

static TTterm
TTparseVSC_fd_entry_file_and_sort_description_entry_clause_star( void )
{
    return TTparse_star(TTparseVSC_fd_entry_file_and_sort_description_entry_clause);
}

static TTterm
TTparseVSC_expr_data_name_plus( void )
{
    return TTparse_plus(TTparseVSC_expr_data_name);
}

static TTterm
TTparset_CODE_SET( void )
{
    return TTparseVSC_KEYWORD("CODE-SET");
}

static TTterm
TTparseVSC_fd_entry_alt_characters_records_opt( void )
{
    return TTparse_optional(TTparseVSC_fd_entry_alt_characters_records);
}

static TTterm
TTparset_CONTAINS_opt( void )
{
    return TTparse_optional(TTparset_CONTAINS);
}

static TTterm
TTparset_CONTAINS( void )
{
    return TTparseVSC_KEYWORD("CONTAINS");
}

static TTterm
TTparset_BLOCK( void )
{
    return TTparseVSC_KEYWORD("BLOCK");
}

static TTterm
TTparset_SD( void )
{
    return TTparseVSC_KEYWORD("SD");
}

static TTterm
TTparset_FD( void )
{
    return TTparseVSC_KEYWORD("FD");
}

static TTterm
TTparset_VALUES( void )
{
    return TTparseVSC_KEYWORD("VALUES");
}

static TTterm
TTparset_VALUE( void )
{
    return TTparseVSC_KEYWORD("VALUE");
}

static TTterm
TTparseVSC_expr_times_div_tail_star( void )
{
    return TTparse_star(TTparseVSC_expr_times_div_tail);
}

static TTterm
TTparset_THRU( void )
{
    return TTparseVSC_KEYWORD("THRU");
}

static TTterm
TTparset_THROUGH( void )
{
    return TTparseVSC_KEYWORD("THROUGH");
}

static TTterm
TTparseVSC_expr_plus_minus_integer_opt( void )
{
    return TTparse_optional(TTparseVSC_expr_plus_minus_integer);
}

static TTterm
TTparseVSC_expr_subscript_expression_plus( void )
{
    return TTparse_plus(TTparseVSC_expr_subscript_expression);
}

static TTterm
TTparset_LENGTH( void )
{
    return TTparseVSC_KEYWORD("LENGTH");
}

static TTterm
TTparset_ADDRESS( void )
{
    return TTparseVSC_KEYWORD("ADDRESS");
}

static TTterm
TTparseVSC_expr_length_opt( void )
{
    return TTparse_optional(TTparseVSC_expr_length);
}

static TTterm
TTparset_qcolon( void )
{
    return TTparseVSC_KEYWORD(":");
}

static TTterm
TTparset_RECORDS( void )
{
    return TTparseVSC_KEYWORD("RECORDS");
}

static TTterm
TTparset_RECORD( void )
{
    return TTparseVSC_KEYWORD("RECORD");
}

static TTterm
TTparseVSC_expr_in_data_or_file_name_star( void )
{
    return TTparse_star(TTparseVSC_expr_in_data_or_file_name);
}

static TTterm
TTparseVSC_expr_in_section_name_opt( void )
{
    return TTparse_optional(TTparseVSC_expr_in_section_name);
}

static TTterm
TTparset_qmultiply_qmultiply( void )
{
    return TTparseVSC_KEYWORD("**");
}

static TTterm
TTparseVSC_expr_power_tail_star( void )
{
    return TTparse_star(TTparseVSC_expr_power_tail);
}

static TTterm
TTparseVSC_expr_alt_plus_minus_opt( void )
{
    return TTparse_optional(TTparseVSC_expr_alt_plus_minus);
}

static TTterm
TTparseVSC_expr_through_literal_opt( void )
{
    return TTparse_optional(TTparseVSC_expr_through_literal);
}

static TTterm
TTparset_OF( void )
{
    return TTparseVSC_KEYWORD("OF");
}

static TTterm
TTparseVSC_expr_in_file_name_opt( void )
{
    return TTparse_optional(TTparseVSC_expr_in_file_name);
}

static TTterm
TTparset_LINAGE_COUNTER( void )
{
    return TTparseVSC_KEYWORD("LINAGE-COUNTER");
}

static TTterm
TTparseVSC_expr_reference_modification_opt( void )
{
    return TTparse_optional(TTparseVSC_expr_reference_modification);
}

static TTterm
TTparset_NULLS( void )
{
    return TTparseVSC_KEYWORD("NULLS");
}

static TTterm
TTparset_NULL( void )
{
    return TTparseVSC_KEYWORD("NULL");
}

static TTterm
TTparset_QUOTES( void )
{
    return TTparseVSC_KEYWORD("QUOTES");
}

static TTterm
TTparset_QUOTE( void )
{
    return TTparseVSC_KEYWORD("QUOTE");
}

static TTterm
TTparset_LOW_VALUES( void )
{
    return TTparseVSC_KEYWORD("LOW-VALUES");
}

static TTterm
TTparset_LOW_VALUE( void )
{
    return TTparseVSC_KEYWORD("LOW-VALUE");
}

static TTterm
TTparset_HIGH_VALUES( void )
{
    return TTparseVSC_KEYWORD("HIGH-VALUES");
}

static TTterm
TTparset_HIGH_VALUE( void )
{
    return TTparseVSC_KEYWORD("HIGH-VALUE");
}

static TTterm
TTparset_SPACES( void )
{
    return TTparseVSC_KEYWORD("SPACES");
}

static TTterm
TTparset_SPACE( void )
{
    return TTparseVSC_KEYWORD("SPACE");
}

static TTterm
TTparset_ALL( void )
{
    return TTparseVSC_KEYWORD("ALL");
}

static TTterm
TTparseVSC_expr_copy_statement_by_phrase_plus( void )
{
    return TTparse_plus(TTparseVSC_expr_copy_statement_by_phrase);
}

static TTterm
TTparset_REPLACING( void )
{
    return TTparseVSC_KEYWORD("REPLACING");
}

static TTterm
TTparseVSC_expr_copy_statement_replacing_phrase_opt( void )
{
    return TTparse_optional(TTparseVSC_expr_copy_statement_replacing_phrase);
}

static TTterm
TTparset_SUPPRESS_opt( void )
{
    return TTparse_optional(TTparset_SUPPRESS);
}

static TTterm
TTparset_SUPPRESS( void )
{
    return TTparseVSC_KEYWORD("SUPPRESS");
}

static TTterm
TTparseVSC_expr_in_library_opt( void )
{
    return TTparse_optional(TTparseVSC_expr_in_library);
}

static TTterm
TTparset_COPY( void )
{
    return TTparseVSC_KEYWORD("COPY");
}

static TTterm
TTparseVSC_expr_arithmetic_expression_tail_star( void )
{
    return TTparse_star(TTparseVSC_expr_arithmetic_expression_tail);
}

static TTterm
TTparset_qdivide( void )
{
    return TTparseVSC_KEYWORD("/");
}

static TTterm
TTparset_qmultiply( void )
{
    return TTparseVSC_KEYWORD("*");
}

static TTterm
TTparset_UNIT( void )
{
    return TTparseVSC_KEYWORD("UNIT");
}

static TTterm
TTparset_REEL( void )
{
    return TTparseVSC_KEYWORD("REEL");
}

static TTterm
TTparset__( void )
{
    return TTparseVSC_KEYWORD("-");
}

static TTterm
TTparset_qplus( void )
{
    return TTparseVSC_KEYWORD("+");
}

static TTterm
TTparset_DESCENDING( void )
{
    return TTparseVSC_KEYWORD("DESCENDING");
}

static TTterm
TTparset_ASCENDING( void )
{
    return TTparseVSC_KEYWORD("ASCENDING");
}

static TTterm
TTparseVSC_io_sec_input_output_section_opt( void )
{
    return TTparse_optional(TTparseVSC_io_sec_input_output_section);
}

static TTterm
TTparseVSC_conf_sec_configuration_section_opt( void )
{
    return TTparse_optional(TTparseVSC_conf_sec_configuration_section);
}

static TTterm
TTparset_ENVIRONMENT( void )
{
    return TTparseVSC_KEYWORD("ENVIRONMENT");
}

static TTterm
TTparset_USAGE( void )
{
    return TTparseVSC_KEYWORD("USAGE");
}

static TTterm
TTparseVSC_dd_entry_usage_is_opt( void )
{
    return TTparse_optional(TTparseVSC_dd_entry_usage_is);
}

static TTterm
TTparset_POINTER( void )
{
    return TTparseVSC_KEYWORD("POINTER");
}

static TTterm
TTparset_PACKED_DECIMAL( void )
{
    return TTparseVSC_KEYWORD("PACKED-DECIMAL");
}

static TTterm
TTparset_INDEX( void )
{
    return TTparseVSC_KEYWORD("INDEX");
}

static TTterm
TTparset_DISPLAY_1( void )
{
    return TTparseVSC_KEYWORD("DISPLAY-1");
}

static TTterm
TTparset_DISPLAY( void )
{
    return TTparseVSC_KEYWORD("DISPLAY");
}

static TTterm
TTparset_COMPUTATIONAL_4( void )
{
    return TTparseVSC_KEYWORD("COMPUTATIONAL-4");
}

static TTterm
TTparset_COMPUTATIONAL_3( void )
{
    return TTparseVSC_KEYWORD("COMPUTATIONAL-3");
}

static TTterm
TTparset_COMPUTATIONAL_2( void )
{
    return TTparseVSC_KEYWORD("COMPUTATIONAL-2");
}

static TTterm
TTparset_COMPUTATIONAL_1( void )
{
    return TTparseVSC_KEYWORD("COMPUTATIONAL-1");
}

static TTterm
TTparset_COMPUTATIONAL( void )
{
    return TTparseVSC_KEYWORD("COMPUTATIONAL");
}

static TTterm
TTparset_COMP_4( void )
{
    return TTparseVSC_KEYWORD("COMP-4");
}

static TTterm
TTparset_COMP_3( void )
{
    return TTparseVSC_KEYWORD("COMP-3");
}

static TTterm
TTparset_COMP_2( void )
{
    return TTparseVSC_KEYWORD("COMP-2");
}

static TTterm
TTparset_COMP_1( void )
{
    return TTparseVSC_KEYWORD("COMP-1");
}

static TTterm
TTparset_COMP( void )
{
    return TTparseVSC_KEYWORD("COMP");
}

static TTterm
TTparset_BINARY( void )
{
    return TTparseVSC_KEYWORD("BINARY");
}

static TTterm
TTparseVSC_dd_entry_alt_left_right_opt( void )
{
    return TTparse_optional(TTparseVSC_dd_entry_alt_left_right);
}

static TTterm
TTparset_SYNC( void )
{
    return TTparseVSC_KEYWORD("SYNC");
}

static TTterm
TTparset_SYNCHRONIZED( void )
{
    return TTparseVSC_KEYWORD("SYNCHRONIZED");
}

static TTterm
TTparseVSC_dd_entry_separate_character_opt( void )
{
    return TTparse_optional(TTparseVSC_dd_entry_separate_character);
}

static TTterm
TTparseVSC_dd_entry_sign_is_opt( void )
{
    return TTparse_optional(TTparseVSC_dd_entry_sign_is);
}

static TTterm
TTparset_CHARACTER_opt( void )
{
    return TTparse_optional(TTparset_CHARACTER);
}

static TTterm
TTparset_CHARACTER( void )
{
    return TTparseVSC_KEYWORD("CHARACTER");
}

static TTterm
TTparset_SEPARATE( void )
{
    return TTparseVSC_KEYWORD("SEPARATE");
}

static TTterm
TTparseVSC_expr_through_qualified_data_name_opt( void )
{
    return TTparse_optional(TTparseVSC_expr_through_qualified_data_name);
}

static TTterm
TTparset_RENAMES( void )
{
    return TTparseVSC_KEYWORD("RENAMES");
}

static TTterm
TTparset_REDEFINES( void )
{
    return TTparseVSC_KEYWORD("REDEFINES");
}

static TTterm
TTparset_PIC( void )
{
    return TTparseVSC_KEYWORD("PIC");
}

static TTterm
TTparset_PICTURE( void )
{
    return TTparseVSC_KEYWORD("PICTURE");
}

static TTterm
TTparseVSC_expr_qualified_data_name_plus( void )
{
    return TTparse_plus(TTparseVSC_expr_qualified_data_name);
}

static TTterm
TTparset_KEY_opt( void )
{
    return TTparse_optional(TTparset_KEY);
}

static TTterm
TTparset_KEY( void )
{
    return TTparseVSC_KEYWORD("KEY");
}

static TTterm
TTparset_ON_opt( void )
{
    return TTparse_optional(TTparset_ON);
}

static TTterm
TTparset_DEPENDING( void )
{
    return TTparseVSC_KEYWORD("DEPENDING");
}

static TTterm
TTparseVSC_dd_entry_integer_to_opt( void )
{
    return TTparse_optional(TTparseVSC_dd_entry_integer_to);
}

static TTterm
TTparseVSC_dd_entry_indexed_by_opt( void )
{
    return TTparse_optional(TTparseVSC_dd_entry_indexed_by);
}

static TTterm
TTparseVSC_dd_entry_occurs_clause_key_star( void )
{
    return TTparse_star(TTparseVSC_dd_entry_occurs_clause_key);
}

static TTterm
TTparset_TIMES_opt( void )
{
    return TTparse_optional(TTparset_TIMES);
}

static TTterm
TTparset_TIMES( void )
{
    return TTparseVSC_KEYWORD("TIMES");
}

static TTterm
TTparset_OCCURS( void )
{
    return TTparseVSC_KEYWORD("OCCURS");
}

static TTterm
TTparset_RIGHT_opt( void )
{
    return TTparse_optional(TTparset_RIGHT);
}

static TTterm
TTparset_JUST( void )
{
    return TTparseVSC_KEYWORD("JUST");
}

static TTterm
TTparset_JUSTIFIED( void )
{
    return TTparseVSC_KEYWORD("JUSTIFIED");
}

static TTterm
TTparseVSC_expr_index_name_plus( void )
{
    return TTparse_plus(TTparseVSC_expr_index_name);
}

static TTterm
TTparset_BY_opt( void )
{
    return TTparse_optional(TTparset_BY);
}

static TTterm
TTparset_BY( void )
{
    return TTparseVSC_KEYWORD("BY");
}

static TTterm
TTparset_INDEXED( void )
{
    return TTparseVSC_KEYWORD("INDEXED");
}

static TTterm
TTparset_GLOBAL( void )
{
    return TTparseVSC_KEYWORD("GLOBAL");
}

static TTterm
TTparset_EXTERNAL( void )
{
    return TTparseVSC_KEYWORD("EXTERNAL");
}

static TTterm
TTparseVSC_dd_entry_data_description_entry_clause_star( void )
{
    return TTparse_star(TTparseVSC_dd_entry_data_description_entry_clause);
}

static TTterm
TTparseVSC_dd_entry_alt_data_name_filler_opt( void )
{
    return TTparse_optional(TTparseVSC_dd_entry_alt_data_name_filler);
}

static TTterm
TTparset_WHEN_opt( void )
{
    return TTparse_optional(TTparset_WHEN);
}

static TTterm
TTparset_WHEN( void )
{
    return TTparseVSC_KEYWORD("WHEN");
}

static TTterm
TTparset_BLANK( void )
{
    return TTparseVSC_KEYWORD("BLANK");
}

static TTterm
TTparset_RIGHT( void )
{
    return TTparseVSC_KEYWORD("RIGHT");
}

static TTterm
TTparset_LEFT( void )
{
    return TTparseVSC_KEYWORD("LEFT");
}

static TTterm
TTparset_TRAILING( void )
{
    return TTparseVSC_KEYWORD("TRAILING");
}

static TTterm
TTparset_LEADING( void )
{
    return TTparseVSC_KEYWORD("LEADING");
}

static TTterm
TTparset_FILLER( void )
{
    return TTparseVSC_KEYWORD("FILLER");
}

static TTterm
TTparset_WORKING_STORAGE( void )
{
    return TTparseVSC_KEYWORD("WORKING-STORAGE");
}

static TTterm
TTparseVSC_dd_entry_data_description_entry_star( void )
{
    return TTparse_star(TTparseVSC_dd_entry_data_description_entry);
}

static TTterm
TTparset_LINKAGE( void )
{
    return TTparseVSC_KEYWORD("LINKAGE");
}

static TTterm
TTparseVSC_dd_entry_data_description_entry_plus( void )
{
    return TTparse_plus(TTparseVSC_dd_entry_data_description_entry);
}

static TTterm
TTparseVSC_data_div_file_section_entry_star( void )
{
    return TTparse_star(TTparseVSC_data_div_file_section_entry);
}

static TTterm
TTparset_FILE( void )
{
    return TTparseVSC_KEYWORD("FILE");
}

static TTterm
TTparseVSC_data_div_linkage_section_opt( void )
{
    return TTparse_optional(TTparseVSC_data_div_linkage_section);
}

static TTterm
TTparseVSC_data_div_working_storage_section_opt( void )
{
    return TTparse_optional(TTparseVSC_data_div_working_storage_section);
}

static TTterm
TTparseVSC_data_div_file_section_opt( void )
{
    return TTparse_optional(TTparseVSC_data_div_file_section);
}

static TTterm
TTparset_DIVISION( void )
{
    return TTparseVSC_KEYWORD("DIVISION");
}

static TTterm
TTparset_DATA( void )
{
    return TTparseVSC_KEYWORD("DATA");
}

static TTterm
TTparset_MODE( void )
{
    return TTparseVSC_KEYWORD("MODE");
}

static TTterm
TTparset_DEBUGGING( void )
{
    return TTparseVSC_KEYWORD("DEBUGGING");
}

static TTterm
TTparset_WITH_opt( void )
{
    return TTparse_optional(TTparset_WITH);
}

static TTterm
TTparset_WITH( void )
{
    return TTparseVSC_KEYWORD("WITH");
}

static TTterm
TTparseVSC_conf_sec_in_alphabet_name_opt( void )
{
    return TTparse_optional(TTparseVSC_conf_sec_in_alphabet_name);
}

static TTterm
TTparseVSC_conf_sec_symbolic_character_mapping_plus( void )
{
    return TTparse_plus(TTparseVSC_conf_sec_symbolic_character_mapping);
}

static TTterm
TTparset_CHARACTERS_opt( void )
{
    return TTparse_optional(TTparset_CHARACTERS);
}

static TTterm
TTparset_SYMBOLIC( void )
{
    return TTparseVSC_KEYWORD("SYMBOLIC");
}

static TTterm
TTparseVSC_expr_integer_plus( void )
{
    return TTparse_plus(TTparseVSC_expr_integer);
}

static TTterm
TTparseVSC_conf_sec_are_opt( void )
{
    return TTparse_optional(TTparseVSC_conf_sec_are);
}

static TTterm
TTparseVSC_expr_symbolic_character_plus( void )
{
    return TTparse_plus(TTparseVSC_expr_symbolic_character);
}

static TTterm
TTparseVSC_conf_sec_on_status_opt( void )
{
    return TTparse_optional(TTparseVSC_conf_sec_on_status);
}

static TTterm
TTparseVSC_conf_sec_off_status_opt( void )
{
    return TTparse_optional(TTparseVSC_conf_sec_off_status);
}

static TTterm
TTparseVSC_conf_sec_special_names_paragraph_clause_star( void )
{
    return TTparse_star(TTparseVSC_conf_sec_special_names_paragraph_clause);
}

static TTterm
TTparset_qdot_opt( void )
{
    return TTparse_optional(TTparset_qdot);
}

static TTterm
TTparseVSC_conf_sec_special_names_paragraph_phrase_star( void )
{
    return TTparse_star(TTparseVSC_conf_sec_special_names_paragraph_phrase);
}

static TTterm
TTparset_SPECIAL_NAMES( void )
{
    return TTparseVSC_KEYWORD("SPECIAL-NAMES");
}

static TTterm
TTparseVSC_conf_sec_source_computer_name_opt( void )
{
    return TTparse_optional(TTparseVSC_conf_sec_source_computer_name);
}

static TTterm
TTparset_SOURCE_COMPUTER( void )
{
    return TTparseVSC_KEYWORD("SOURCE-COMPUTER");
}

static TTterm
TTparseVSC_conf_sec_with_debugging_mode_opt( void )
{
    return TTparse_optional(TTparseVSC_conf_sec_with_debugging_mode);
}

static TTterm
TTparset_SEGMENT_LIMIT( void )
{
    return TTparseVSC_KEYWORD("SEGMENT-LIMIT");
}

static TTterm
TTparset_SEQUENCE( void )
{
    return TTparseVSC_KEYWORD("SEQUENCE");
}

static TTterm
TTparset_COLLATING_opt( void )
{
    return TTparse_optional(TTparset_COLLATING);
}

static TTterm
TTparset_COLLATING( void )
{
    return TTparseVSC_KEYWORD("COLLATING");
}

static TTterm
TTparset_PROGRAM_opt( void )
{
    return TTparse_optional(TTparset_PROGRAM);
}

static TTterm
TTparset_PROGRAM( void )
{
    return TTparseVSC_KEYWORD("PROGRAM");
}

static TTterm
TTparset_ON( void )
{
    return TTparseVSC_KEYWORD("ON");
}

static TTterm
TTparset_STATUS_opt( void )
{
    return TTparse_optional(TTparset_STATUS);
}

static TTterm
TTparset_STATUS( void )
{
    return TTparseVSC_KEYWORD("STATUS");
}

static TTterm
TTparset_OFF( void )
{
    return TTparseVSC_KEYWORD("OFF");
}

static TTterm
TTparseVSC_conf_sec_segment_limit_opt( void )
{
    return TTparse_optional(TTparseVSC_conf_sec_segment_limit);
}

static TTterm
TTparseVSC_conf_sec_program_collating_sequence_opt( void )
{
    return TTparse_optional(TTparseVSC_conf_sec_program_collating_sequence);
}

static TTterm
TTparseVSC_conf_sec_object_computer_name_opt( void )
{
    return TTparse_optional(TTparseVSC_conf_sec_object_computer_name);
}

static TTterm
TTparset_OBJECT_COMPUTER( void )
{
    return TTparseVSC_KEYWORD("OBJECT-COMPUTER");
}

static TTterm
TTparseVSC_conf_sec_memory_size_opt( void )
{
    return TTparse_optional(TTparseVSC_conf_sec_memory_size);
}

static TTterm
TTparset_MODULES( void )
{
    return TTparseVSC_KEYWORD("MODULES");
}

static TTterm
TTparset_CHARACTERS( void )
{
    return TTparseVSC_KEYWORD("CHARACTERS");
}

static TTterm
TTparset_WORDS( void )
{
    return TTparseVSC_KEYWORD("WORDS");
}

static TTterm
TTparset_SIZE_opt( void )
{
    return TTparse_optional(TTparset_SIZE);
}

static TTterm
TTparset_SIZE( void )
{
    return TTparseVSC_KEYWORD("SIZE");
}

static TTterm
TTparset_MEMORY( void )
{
    return TTparseVSC_KEYWORD("MEMORY");
}

static TTterm
TTparseVSC_conf_sec_special_names_paragraph_status_phrase_opt( void )
{
    return TTparse_optional(TTparseVSC_conf_sec_special_names_paragraph_status_phrase);
}

static TTterm
TTparset_IN( void )
{
    return TTparseVSC_KEYWORD("IN");
}

static TTterm
TTparset_COMMA( void )
{
    return TTparseVSC_KEYWORD("COMMA");
}

static TTterm
TTparset_DECIMAL_POINT( void )
{
    return TTparseVSC_KEYWORD("DECIMAL-POINT");
}

static TTterm
TTparset_SIGN_opt( void )
{
    return TTparse_optional(TTparset_SIGN);
}

static TTterm
TTparset_SIGN( void )
{
    return TTparseVSC_KEYWORD("SIGN");
}

static TTterm
TTparset_CURRENCY( void )
{
    return TTparseVSC_KEYWORD("CURRENCY");
}

static TTterm
TTparseVSC_conf_sec_configuration_section_paragraph_star( void )
{
    return TTparse_star(TTparseVSC_conf_sec_configuration_section_paragraph);
}

static TTterm
TTparset_qdot( void )
{
    return TTparseVSC_KEYWORD(".");
}

static TTterm
TTparset_SECTION( void )
{
    return TTparseVSC_KEYWORD("SECTION");
}

static TTterm
TTparset_CONFIGURATION( void )
{
    return TTparseVSC_KEYWORD("CONFIGURATION");
}

static TTterm
TTparseVSC_expr_literal_through_literal_plus( void )
{
    return TTparse_plus(TTparseVSC_expr_literal_through_literal);
}

static TTterm
TTparset_CLASS( void )
{
    return TTparseVSC_KEYWORD("CLASS");
}

static TTterm
TTparset_ARE( void )
{
    return TTparseVSC_KEYWORD("ARE");
}

static TTterm
TTparseVSC_conf_sec_alphabet_type_other_plus( void )
{
    return TTparse_plus(TTparseVSC_conf_sec_alphabet_type_other);
}

static TTterm
TTparseVSC_conf_sec_alphabet_type_also_through_opt( void )
{
    return TTparse_optional(TTparseVSC_conf_sec_alphabet_type_also_through);
}

static TTterm
TTparseVSC_conf_sec_alphabet_type_also_plus( void )
{
    return TTparse_plus(TTparseVSC_conf_sec_alphabet_type_also);
}

static TTterm
TTparset_ALSO( void )
{
    return TTparseVSC_KEYWORD("ALSO");
}

static TTterm
TTparset_EBCDIC( void )
{
    return TTparseVSC_KEYWORD("EBCDIC");
}

static TTterm
TTparset_NATIVE( void )
{
    return TTparseVSC_KEYWORD("NATIVE");
}

static TTterm
TTparset_STANDARD_2( void )
{
    return TTparseVSC_KEYWORD("STANDARD-2");
}

static TTterm
TTparset_STANDARD_1( void )
{
    return TTparseVSC_KEYWORD("STANDARD-1");
}

static TTterm
TTparset_ALPHABET( void )
{
    return TTparseVSC_KEYWORD("ALPHABET");
}

static TTterm
TTparset_THEN_opt( void )
{
    return TTparse_optional(TTparset_THEN);
}

static TTterm
TTparset_THEN( void )
{
    return TTparseVSC_KEYWORD("THEN");
}

static TTterm
TTparset_qpclose( void )
{
    return TTparseVSC_KEYWORD(")");
}

static TTterm
TTparset_qpopen( void )
{
    return TTparseVSC_KEYWORD("(");
}

static TTterm
TTparset_ZEROS( void )
{
    return TTparseVSC_KEYWORD("ZEROS");
}

static TTterm
TTparset_ZEROES( void )
{
    return TTparseVSC_KEYWORD("ZEROES");
}

static TTterm
TTparset_ZERO( void )
{
    return TTparseVSC_KEYWORD("ZERO");
}

static TTterm
TTparset_NEGATIVE( void )
{
    return TTparseVSC_KEYWORD("NEGATIVE");
}

static TTterm
TTparset_POSITIVE( void )
{
    return TTparseVSC_KEYWORD("POSITIVE");
}

static TTterm
TTparset_qequal( void )
{
    return TTparseVSC_KEYWORD("=");
}

static TTterm
TTparset_NOT_opt( void )
{
    return TTparse_optional(TTparset_NOT);
}

static TTterm
TTparset_IS_opt( void )
{
    return TTparse_optional(TTparset_IS);
}

static TTterm
TTparset_IS( void )
{
    return TTparseVSC_KEYWORD("IS");
}

static TTterm
TTparset_qlt( void )
{
    return TTparseVSC_KEYWORD("<");
}

static TTterm
TTparset_LESS( void )
{
    return TTparseVSC_KEYWORD("LESS");
}

static TTterm
TTparset_NOT( void )
{
    return TTparseVSC_KEYWORD("NOT");
}

static TTterm
TTparset_qgt_qequal( void )
{
    return TTparseVSC_KEYWORD(">=");
}

static TTterm
TTparset_THAN_opt( void )
{
    return TTparse_optional(TTparset_THAN);
}

static TTterm
TTparset_THAN( void )
{
    return TTparseVSC_KEYWORD("THAN");
}

static TTterm
TTparset_qgt( void )
{
    return TTparseVSC_KEYWORD(">");
}

static TTterm
TTparset_TO_opt( void )
{
    return TTparse_optional(TTparset_TO);
}

static TTterm
TTparset_TO( void )
{
    return TTparseVSC_KEYWORD("TO");
}

static TTterm
TTparset_EQUAL( void )
{
    return TTparseVSC_KEYWORD("EQUAL");
}

static TTterm
TTparset_GREATER( void )
{
    return TTparseVSC_KEYWORD("GREATER");
}

static TTterm
TTparseVSC_expr_subscript_parentheses_star( void )
{
    return TTparse_star(TTparseVSC_expr_subscript_parentheses);
}

static TTterm
TTparseVSC_expr_in_data_or_file_or_mnemonic_name_star( void )
{
    return TTparse_star(TTparseVSC_expr_in_data_or_file_or_mnemonic_name);
}

static TTterm
TTparseVSC_cond_and_or_combinable_condition_plus( void )
{
    return TTparse_plus(TTparseVSC_cond_and_or_combinable_condition);
}

static TTterm
TTparset_KANJI( void )
{
    return TTparseVSC_KEYWORD("KANJI");
}

static TTterm
TTparset_DBCS( void )
{
    return TTparseVSC_KEYWORD("DBCS");
}

static TTterm
TTparset_ALPHABETIC_UPPER( void )
{
    return TTparseVSC_KEYWORD("ALPHABETIC-UPPER");
}

static TTterm
TTparset_ALPHABETIC_LOWER( void )
{
    return TTparseVSC_KEYWORD("ALPHABETIC-LOWER");
}

static TTterm
TTparset_ALPHABETIC( void )
{
    return TTparseVSC_KEYWORD("ALPHABETIC");
}

static TTterm
TTparset_NUMERIC( void )
{
    return TTparseVSC_KEYWORD("NUMERIC");
}

static TTterm
TTparseVSC_cond_relational_operator_opt( void )
{
    return TTparse_optional(TTparseVSC_cond_relational_operator);
}

static TTterm
TTparset_OR( void )
{
    return TTparseVSC_KEYWORD("OR");
}

static TTterm
TTparset_AND( void )
{
    return TTparseVSC_KEYWORD("AND");
}


BOOL
VSCisKeyword(const char * name)
{
    if (strcmp(name, "INPUT") < 0) {
    if (strcmp(name, "DATE-WRITTEN") < 0) {
    if (strcmp(name, "BEGINNING") < 0) {
    if (strcmp(name, "ALPHABET") < 0) {
    if (strcmp(name, "=") < 0) {
    if (strcmp(name, "-") < 0) {
    if (strcmp(name, "*") < 0) {
    if (strcmp(name, ")") < 0) {
        return strcmp(name, "(") == 0;
    } else {
        return strcmp(name, ")") == 0;
    }
    } else {
    if (strcmp(name, "**") < 0) {
        return strcmp(name, "*") == 0;
    } else {
    if (strcmp(name, "+") < 0) {
        return strcmp(name, "**") == 0;
    } else {
        return strcmp(name, "+") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "/") < 0) {
    if (strcmp(name, ".") < 0) {
        return strcmp(name, "-") == 0;
    } else {
        return strcmp(name, ".") == 0;
    }
    } else {
    if (strcmp(name, ":") < 0) {
        return strcmp(name, "/") == 0;
    } else {
    if (strcmp(name, "<") < 0) {
        return strcmp(name, ":") == 0;
    } else {
        return strcmp(name, "<") == 0;
    }
    }
    }
    }
    } else {
    if (strcmp(name, "ADD") < 0) {
    if (strcmp(name, ">=") < 0) {
    if (strcmp(name, ">") < 0) {
        return strcmp(name, "=") == 0;
    } else {
        return strcmp(name, ">") == 0;
    }
    } else {
    if (strcmp(name, "ACCEPT") < 0) {
        return strcmp(name, ">=") == 0;
    } else {
    if (strcmp(name, "ACCESS") < 0) {
        return strcmp(name, "ACCEPT") == 0;
    } else {
        return strcmp(name, "ACCESS") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "ADVANCING") < 0) {
    if (strcmp(name, "ADDRESS") < 0) {
        return strcmp(name, "ADD") == 0;
    } else {
        return strcmp(name, "ADDRESS") == 0;
    }
    } else {
    if (strcmp(name, "AFTER") < 0) {
        return strcmp(name, "ADVANCING") == 0;
    } else {
    if (strcmp(name, "ALL") < 0) {
        return strcmp(name, "AFTER") == 0;
    } else {
        return strcmp(name, "ALL") == 0;
    }
    }
    }
    }
    }
    } else {
    if (strcmp(name, "ANY") < 0) {
    if (strcmp(name, "ALPHANUMERIC-EDITED") < 0) {
    if (strcmp(name, "ALPHABETIC-LOWER") < 0) {
    if (strcmp(name, "ALPHABETIC") < 0) {
        return strcmp(name, "ALPHABET") == 0;
    } else {
        return strcmp(name, "ALPHABETIC") == 0;
    }
    } else {
    if (strcmp(name, "ALPHABETIC-UPPER") < 0) {
        return strcmp(name, "ALPHABETIC-LOWER") == 0;
    } else {
    if (strcmp(name, "ALPHANUMERIC") < 0) {
        return strcmp(name, "ALPHABETIC-UPPER") == 0;
    } else {
        return strcmp(name, "ALPHANUMERIC") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "ALTER") < 0) {
    if (strcmp(name, "ALSO") < 0) {
        return strcmp(name, "ALPHANUMERIC-EDITED") == 0;
    } else {
        return strcmp(name, "ALSO") == 0;
    }
    } else {
    if (strcmp(name, "ALTERNATE") < 0) {
        return strcmp(name, "ALTER") == 0;
    } else {
    if (strcmp(name, "AND") < 0) {
        return strcmp(name, "ALTERNATE") == 0;
    } else {
        return strcmp(name, "AND") == 0;
    }
    }
    }
    }
    } else {
    if (strcmp(name, "ASCENDING") < 0) {
    if (strcmp(name, "ARE") < 0) {
    if (strcmp(name, "APPLY") < 0) {
        return strcmp(name, "ANY") == 0;
    } else {
        return strcmp(name, "APPLY") == 0;
    }
    } else {
    if (strcmp(name, "AREA") < 0) {
        return strcmp(name, "ARE") == 0;
    } else {
    if (strcmp(name, "AREAS") < 0) {
        return strcmp(name, "AREA") == 0;
    } else {
        return strcmp(name, "AREAS") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "AT") < 0) {
    if (strcmp(name, "ASSIGN") < 0) {
        return strcmp(name, "ASCENDING") == 0;
    } else {
        return strcmp(name, "ASSIGN") == 0;
    }
    } else {
    if (strcmp(name, "AUTHOR") < 0) {
        return strcmp(name, "AT") == 0;
    } else {
    if (strcmp(name, "BEFORE") < 0) {
        return strcmp(name, "AUTHOR") == 0;
    } else {
        return strcmp(name, "BEFORE") == 0;
    }
    }
    }
    }
    }
    }
    } else {
    if (strcmp(name, "COMP-4") < 0) {
    if (strcmp(name, "CLASS") < 0) {
    if (strcmp(name, "BY") < 0) {
    if (strcmp(name, "BLANK") < 0) {
    if (strcmp(name, "BINARY") < 0) {
        return strcmp(name, "BEGINNING") == 0;
    } else {
        return strcmp(name, "BINARY") == 0;
    }
    } else {
    if (strcmp(name, "BLOCK") < 0) {
        return strcmp(name, "BLANK") == 0;
    } else {
    if (strcmp(name, "BOTTOM") < 0) {
        return strcmp(name, "BLOCK") == 0;
    } else {
        return strcmp(name, "BOTTOM") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "CANCEL") < 0) {
    if (strcmp(name, "CALL") < 0) {
        return strcmp(name, "BY") == 0;
    } else {
        return strcmp(name, "CALL") == 0;
    }
    } else {
    if (strcmp(name, "CHARACTER") < 0) {
        return strcmp(name, "CANCEL") == 0;
    } else {
    if (strcmp(name, "CHARACTERS") < 0) {
        return strcmp(name, "CHARACTER") == 0;
    } else {
        return strcmp(name, "CHARACTERS") == 0;
    }
    }
    }
    }
    } else {
    if (strcmp(name, "COMMON") < 0) {
    if (strcmp(name, "CODE-SET") < 0) {
    if (strcmp(name, "CLOSE") < 0) {
        return strcmp(name, "CLASS") == 0;
    } else {
        return strcmp(name, "CLOSE") == 0;
    }
    } else {
    if (strcmp(name, "COLLATING") < 0) {
        return strcmp(name, "CODE-SET") == 0;
    } else {
    if (strcmp(name, "COMMA") < 0) {
        return strcmp(name, "COLLATING") == 0;
    } else {
        return strcmp(name, "COMMA") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "COMP-1") < 0) {
    if (strcmp(name, "COMP") < 0) {
        return strcmp(name, "COMMON") == 0;
    } else {
        return strcmp(name, "COMP") == 0;
    }
    } else {
    if (strcmp(name, "COMP-2") < 0) {
        return strcmp(name, "COMP-1") == 0;
    } else {
    if (strcmp(name, "COMP-3") < 0) {
        return strcmp(name, "COMP-2") == 0;
    } else {
        return strcmp(name, "COMP-3") == 0;
    }
    }
    }
    }
    }
    } else {
    if (strcmp(name, "CONTINUE") < 0) {
    if (strcmp(name, "COMPUTATIONAL-4") < 0) {
    if (strcmp(name, "COMPUTATIONAL-1") < 0) {
    if (strcmp(name, "COMPUTATIONAL") < 0) {
        return strcmp(name, "COMP-4") == 0;
    } else {
        return strcmp(name, "COMPUTATIONAL") == 0;
    }
    } else {
    if (strcmp(name, "COMPUTATIONAL-2") < 0) {
        return strcmp(name, "COMPUTATIONAL-1") == 0;
    } else {
    if (strcmp(name, "COMPUTATIONAL-3") < 0) {
        return strcmp(name, "COMPUTATIONAL-2") == 0;
    } else {
        return strcmp(name, "COMPUTATIONAL-3") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "CONFIGURATION") < 0) {
    if (strcmp(name, "COMPUTE") < 0) {
        return strcmp(name, "COMPUTATIONAL-4") == 0;
    } else {
        return strcmp(name, "COMPUTE") == 0;
    }
    } else {
    if (strcmp(name, "CONTAINS") < 0) {
        return strcmp(name, "CONFIGURATION") == 0;
    } else {
    if (strcmp(name, "CONTENT") < 0) {
        return strcmp(name, "CONTAINS") == 0;
    } else {
        return strcmp(name, "CONTENT") == 0;
    }
    }
    }
    }
    } else {
    if (strcmp(name, "COUNT") < 0) {
    if (strcmp(name, "COPY") < 0) {
    if (strcmp(name, "CONVERTING") < 0) {
        return strcmp(name, "CONTINUE") == 0;
    } else {
        return strcmp(name, "CONVERTING") == 0;
    }
    } else {
    if (strcmp(name, "CORR") < 0) {
        return strcmp(name, "COPY") == 0;
    } else {
    if (strcmp(name, "CORRESPONDING") < 0) {
        return strcmp(name, "CORR") == 0;
    } else {
        return strcmp(name, "CORRESPONDING") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "DATA") < 0) {
    if (strcmp(name, "CURRENCY") < 0) {
        return strcmp(name, "COUNT") == 0;
    } else {
        return strcmp(name, "CURRENCY") == 0;
    }
    } else {
    if (strcmp(name, "DATE") < 0) {
        return strcmp(name, "DATA") == 0;
    } else {
    if (strcmp(name, "DATE-COMPILED") < 0) {
        return strcmp(name, "DATE") == 0;
    } else {
        return strcmp(name, "DATE-COMPILED") == 0;
    }
    }
    }
    }
    }
    }
    }
    } else {
    if (strcmp(name, "END-UNSTRING") < 0) {
    if (strcmp(name, "EGCS") < 0) {
    if (strcmp(name, "DEPENDING") < 0) {
    if (strcmp(name, "DECIMAL-POINT") < 0) {
    if (strcmp(name, "DAY-OF-WEEK") < 0) {
    if (strcmp(name, "DAY") < 0) {
        return strcmp(name, "DATE-WRITTEN") == 0;
    } else {
        return strcmp(name, "DAY") == 0;
    }
    } else {
    if (strcmp(name, "DBCS") < 0) {
        return strcmp(name, "DAY-OF-WEEK") == 0;
    } else {
    if (strcmp(name, "DEBUGGING") < 0) {
        return strcmp(name, "DBCS") == 0;
    } else {
        return strcmp(name, "DEBUGGING") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "DELETE") < 0) {
    if (strcmp(name, "DECLARATIVES") < 0) {
        return strcmp(name, "DECIMAL-POINT") == 0;
    } else {
        return strcmp(name, "DECLARATIVES") == 0;
    }
    } else {
    if (strcmp(name, "DELIMITED") < 0) {
        return strcmp(name, "DELETE") == 0;
    } else {
    if (strcmp(name, "DELIMITER") < 0) {
        return strcmp(name, "DELIMITED") == 0;
    } else {
        return strcmp(name, "DELIMITER") == 0;
    }
    }
    }
    }
    } else {
    if (strcmp(name, "DIVISION") < 0) {
    if (strcmp(name, "DISPLAY") < 0) {
    if (strcmp(name, "DESCENDING") < 0) {
        return strcmp(name, "DEPENDING") == 0;
    } else {
        return strcmp(name, "DESCENDING") == 0;
    }
    } else {
    if (strcmp(name, "DISPLAY-1") < 0) {
        return strcmp(name, "DISPLAY") == 0;
    } else {
    if (strcmp(name, "DIVIDE") < 0) {
        return strcmp(name, "DISPLAY-1") == 0;
    } else {
        return strcmp(name, "DIVIDE") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "DUPLICATES") < 0) {
    if (strcmp(name, "DOWN") < 0) {
        return strcmp(name, "DIVISION") == 0;
    } else {
        return strcmp(name, "DOWN") == 0;
    }
    } else {
    if (strcmp(name, "DYNAMIC") < 0) {
        return strcmp(name, "DUPLICATES") == 0;
    } else {
    if (strcmp(name, "EBCDIC") < 0) {
        return strcmp(name, "DYNAMIC") == 0;
    } else {
        return strcmp(name, "EBCDIC") == 0;
    }
    }
    }
    }
    }
    } else {
    if (strcmp(name, "END-MULTIPLY") < 0) {
    if (strcmp(name, "END-COMPUTE") < 0) {
    if (strcmp(name, "END") < 0) {
    if (strcmp(name, "ELSE") < 0) {
        return strcmp(name, "EGCS") == 0;
    } else {
        return strcmp(name, "ELSE") == 0;
    }
    } else {
    if (strcmp(name, "END-ADD") < 0) {
        return strcmp(name, "END") == 0;
    } else {
    if (strcmp(name, "END-CALL") < 0) {
        return strcmp(name, "END-ADD") == 0;
    } else {
        return strcmp(name, "END-CALL") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "END-DIVIDE") < 0) {
    if (strcmp(name, "END-DELETE") < 0) {
        return strcmp(name, "END-COMPUTE") == 0;
    } else {
        return strcmp(name, "END-DELETE") == 0;
    }
    } else {
    if (strcmp(name, "END-EVALUATE") < 0) {
        return strcmp(name, "END-DIVIDE") == 0;
    } else {
    if (strcmp(name, "END-IF") < 0) {
        return strcmp(name, "END-EVALUATE") == 0;
    } else {
        return strcmp(name, "END-IF") == 0;
    }
    }
    }
    }
    } else {
    if (strcmp(name, "END-REWRITE") < 0) {
    if (strcmp(name, "END-PERFORM") < 0) {
    if (strcmp(name, "END-OF-PAGE") < 0) {
        return strcmp(name, "END-MULTIPLY") == 0;
    } else {
        return strcmp(name, "END-OF-PAGE") == 0;
    }
    } else {
    if (strcmp(name, "END-READ") < 0) {
        return strcmp(name, "END-PERFORM") == 0;
    } else {
    if (strcmp(name, "END-RETURN") < 0) {
        return strcmp(name, "END-READ") == 0;
    } else {
        return strcmp(name, "END-RETURN") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "END-START") < 0) {
    if (strcmp(name, "END-SEARCH") < 0) {
        return strcmp(name, "END-REWRITE") == 0;
    } else {
        return strcmp(name, "END-SEARCH") == 0;
    }
    } else {
    if (strcmp(name, "END-STRING") < 0) {
        return strcmp(name, "END-START") == 0;
    } else {
    if (strcmp(name, "END-SUBTRACT") < 0) {
        return strcmp(name, "END-STRING") == 0;
    } else {
        return strcmp(name, "END-SUBTRACT") == 0;
    }
    }
    }
    }
    }
    }
    } else {
    if (strcmp(name, "FOOTING") < 0) {
    if (strcmp(name, "EXCEPTION") < 0) {
    if (strcmp(name, "EOP") < 0) {
    if (strcmp(name, "ENDING") < 0) {
    if (strcmp(name, "END-WRITE") < 0) {
        return strcmp(name, "END-UNSTRING") == 0;
    } else {
        return strcmp(name, "END-WRITE") == 0;
    }
    } else {
    if (strcmp(name, "ENTRY") < 0) {
        return strcmp(name, "ENDING") == 0;
    } else {
    if (strcmp(name, "ENVIRONMENT") < 0) {
        return strcmp(name, "ENTRY") == 0;
    } else {
        return strcmp(name, "ENVIRONMENT") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "ERROR") < 0) {
    if (strcmp(name, "EQUAL") < 0) {
        return strcmp(name, "EOP") == 0;
    } else {
        return strcmp(name, "EQUAL") == 0;
    }
    } else {
    if (strcmp(name, "EVALUATE") < 0) {
        return strcmp(name, "ERROR") == 0;
    } else {
    if (strcmp(name, "EVERY") < 0) {
        return strcmp(name, "EVALUATE") == 0;
    } else {
        return strcmp(name, "EVERY") == 0;
    }
    }
    }
    }
    } else {
    if (strcmp(name, "FD") < 0) {
    if (strcmp(name, "EXTEND") < 0) {
    if (strcmp(name, "EXIT") < 0) {
        return strcmp(name, "EXCEPTION") == 0;
    } else {
        return strcmp(name, "EXIT") == 0;
    }
    } else {
    if (strcmp(name, "EXTERNAL") < 0) {
        return strcmp(name, "EXTEND") == 0;
    } else {
    if (strcmp(name, "FALSE") < 0) {
        return strcmp(name, "EXTERNAL") == 0;
    } else {
        return strcmp(name, "FALSE") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "FILE-CONTROL") < 0) {
    if (strcmp(name, "FILE") < 0) {
        return strcmp(name, "FD") == 0;
    } else {
        return strcmp(name, "FILE") == 0;
    }
    } else {
    if (strcmp(name, "FILLER") < 0) {
        return strcmp(name, "FILE-CONTROL") == 0;
    } else {
    if (strcmp(name, "FIRST") < 0) {
        return strcmp(name, "FILLER") == 0;
    } else {
        return strcmp(name, "FIRST") == 0;
    }
    }
    }
    }
    }
    } else {
    if (strcmp(name, "I-O") < 0) {
    if (strcmp(name, "GO") < 0) {
    if (strcmp(name, "FROM") < 0) {
    if (strcmp(name, "FOR") < 0) {
        return strcmp(name, "FOOTING") == 0;
    } else {
        return strcmp(name, "FOR") == 0;
    }
    } else {
    if (strcmp(name, "GIVING") < 0) {
        return strcmp(name, "FROM") == 0;
    } else {
    if (strcmp(name, "GLOBAL") < 0) {
        return strcmp(name, "GIVING") == 0;
    } else {
        return strcmp(name, "GLOBAL") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "GREATER") < 0) {
    if (strcmp(name, "GOBACK") < 0) {
        return strcmp(name, "GO") == 0;
    } else {
        return strcmp(name, "GOBACK") == 0;
    }
    } else {
    if (strcmp(name, "HIGH-VALUE") < 0) {
        return strcmp(name, "GREATER") == 0;
    } else {
    if (strcmp(name, "HIGH-VALUES") < 0) {
        return strcmp(name, "HIGH-VALUE") == 0;
    } else {
        return strcmp(name, "HIGH-VALUES") == 0;
    }
    }
    }
    }
    } else {
    if (strcmp(name, "IN") < 0) {
    if (strcmp(name, "ID") < 0) {
    if (strcmp(name, "I-O-CONTROL") < 0) {
        return strcmp(name, "I-O") == 0;
    } else {
        return strcmp(name, "I-O-CONTROL") == 0;
    }
    } else {
    if (strcmp(name, "IDENTIFICATION") < 0) {
        return strcmp(name, "ID") == 0;
    } else {
    if (strcmp(name, "IF") < 0) {
        return strcmp(name, "IDENTIFICATION") == 0;
    } else {
        return strcmp(name, "IF") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "INDEXED") < 0) {
    if (strcmp(name, "INDEX") < 0) {
        return strcmp(name, "IN") == 0;
    } else {
        return strcmp(name, "INDEX") == 0;
    }
    } else {
    if (strcmp(name, "INITIAL") < 0) {
        return strcmp(name, "INDEXED") == 0;
    } else {
    if (strcmp(name, "INITIALIZE") < 0) {
        return strcmp(name, "INITIAL") == 0;
    } else {
        return strcmp(name, "INITIALIZE") == 0;
    }
    }
    }
    }
    }
    }
    }
    }
    } else {
    if (strcmp(name, "RELATIVE") < 0) {
    if (strcmp(name, "NUMERIC-EDITED") < 0) {
    if (strcmp(name, "LINKAGE") < 0) {
    if (strcmp(name, "KEY") < 0) {
    if (strcmp(name, "INVALID") < 0) {
    if (strcmp(name, "INSPECT") < 0) {
    if (strcmp(name, "INPUT-OUTPUT") < 0) {
        return strcmp(name, "INPUT") == 0;
    } else {
        return strcmp(name, "INPUT-OUTPUT") == 0;
    }
    } else {
    if (strcmp(name, "INSTALLATION") < 0) {
        return strcmp(name, "INSPECT") == 0;
    } else {
    if (strcmp(name, "INTO") < 0) {
        return strcmp(name, "INSTALLATION") == 0;
    } else {
        return strcmp(name, "INTO") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "JUST") < 0) {
    if (strcmp(name, "IS") < 0) {
        return strcmp(name, "INVALID") == 0;
    } else {
        return strcmp(name, "IS") == 0;
    }
    } else {
    if (strcmp(name, "JUSTIFIED") < 0) {
        return strcmp(name, "JUST") == 0;
    } else {
    if (strcmp(name, "KANJI") < 0) {
        return strcmp(name, "JUSTIFIED") == 0;
    } else {
        return strcmp(name, "KANJI") == 0;
    }
    }
    }
    }
    } else {
    if (strcmp(name, "LESS") < 0) {
    if (strcmp(name, "LEADING") < 0) {
    if (strcmp(name, "LABEL") < 0) {
        return strcmp(name, "KEY") == 0;
    } else {
        return strcmp(name, "LABEL") == 0;
    }
    } else {
    if (strcmp(name, "LEFT") < 0) {
        return strcmp(name, "LEADING") == 0;
    } else {
    if (strcmp(name, "LENGTH") < 0) {
        return strcmp(name, "LEFT") == 0;
    } else {
        return strcmp(name, "LENGTH") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "LINAGE-COUNTER") < 0) {
    if (strcmp(name, "LINAGE") < 0) {
        return strcmp(name, "LESS") == 0;
    } else {
        return strcmp(name, "LINAGE") == 0;
    }
    } else {
    if (strcmp(name, "LINE") < 0) {
        return strcmp(name, "LINAGE-COUNTER") == 0;
    } else {
    if (strcmp(name, "LINES") < 0) {
        return strcmp(name, "LINE") == 0;
    } else {
        return strcmp(name, "LINES") == 0;
    }
    }
    }
    }
    }
    } else {
    if (strcmp(name, "MULTIPLE") < 0) {
    if (strcmp(name, "MERGE") < 0) {
    if (strcmp(name, "LOW-VALUE") < 0) {
    if (strcmp(name, "LOCK") < 0) {
        return strcmp(name, "LINKAGE") == 0;
    } else {
        return strcmp(name, "LOCK") == 0;
    }
    } else {
    if (strcmp(name, "LOW-VALUES") < 0) {
        return strcmp(name, "LOW-VALUE") == 0;
    } else {
    if (strcmp(name, "MEMORY") < 0) {
        return strcmp(name, "LOW-VALUES") == 0;
    } else {
        return strcmp(name, "MEMORY") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "MODULES") < 0) {
    if (strcmp(name, "MODE") < 0) {
        return strcmp(name, "MERGE") == 0;
    } else {
        return strcmp(name, "MODE") == 0;
    }
    } else {
    if (strcmp(name, "MORE-LABELS") < 0) {
        return strcmp(name, "MODULES") == 0;
    } else {
    if (strcmp(name, "MOVE") < 0) {
        return strcmp(name, "MORE-LABELS") == 0;
    } else {
        return strcmp(name, "MOVE") == 0;
    }
    }
    }
    }
    } else {
    if (strcmp(name, "NO") < 0) {
    if (strcmp(name, "NATIVE") < 0) {
    if (strcmp(name, "MULTIPLY") < 0) {
        return strcmp(name, "MULTIPLE") == 0;
    } else {
        return strcmp(name, "MULTIPLY") == 0;
    }
    } else {
    if (strcmp(name, "NEGATIVE") < 0) {
        return strcmp(name, "NATIVE") == 0;
    } else {
    if (strcmp(name, "NEXT") < 0) {
        return strcmp(name, "NEGATIVE") == 0;
    } else {
        return strcmp(name, "NEXT") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "NULL") < 0) {
    if (strcmp(name, "NOT") < 0) {
        return strcmp(name, "NO") == 0;
    } else {
        return strcmp(name, "NOT") == 0;
    }
    } else {
    if (strcmp(name, "NULLS") < 0) {
        return strcmp(name, "NULL") == 0;
    } else {
    if (strcmp(name, "NUMERIC") < 0) {
        return strcmp(name, "NULLS") == 0;
    } else {
        return strcmp(name, "NUMERIC") == 0;
    }
    }
    }
    }
    }
    }
    } else {
    if (strcmp(name, "PIC") < 0) {
    if (strcmp(name, "ORDER") < 0) {
    if (strcmp(name, "OMITTED") < 0) {
    if (strcmp(name, "OCCURS") < 0) {
    if (strcmp(name, "OBJECT-COMPUTER") < 0) {
        return strcmp(name, "NUMERIC-EDITED") == 0;
    } else {
        return strcmp(name, "OBJECT-COMPUTER") == 0;
    }
    } else {
    if (strcmp(name, "OF") < 0) {
        return strcmp(name, "OCCURS") == 0;
    } else {
    if (strcmp(name, "OFF") < 0) {
        return strcmp(name, "OF") == 0;
    } else {
        return strcmp(name, "OFF") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "OPEN") < 0) {
    if (strcmp(name, "ON") < 0) {
        return strcmp(name, "OMITTED") == 0;
    } else {
        return strcmp(name, "ON") == 0;
    }
    } else {
    if (strcmp(name, "OPTIONAL") < 0) {
        return strcmp(name, "OPEN") == 0;
    } else {
    if (strcmp(name, "OR") < 0) {
        return strcmp(name, "OPTIONAL") == 0;
    } else {
        return strcmp(name, "OR") == 0;
    }
    }
    }
    }
    } else {
    if (strcmp(name, "PACKED-DECIMAL") < 0) {
    if (strcmp(name, "OTHER") < 0) {
    if (strcmp(name, "ORGANIZATION") < 0) {
        return strcmp(name, "ORDER") == 0;
    } else {
        return strcmp(name, "ORGANIZATION") == 0;
    }
    } else {
    if (strcmp(name, "OUTPUT") < 0) {
        return strcmp(name, "OTHER") == 0;
    } else {
    if (strcmp(name, "OVERFLOW") < 0) {
        return strcmp(name, "OUTPUT") == 0;
    } else {
        return strcmp(name, "OVERFLOW") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "PAGE") < 0) {
    if (strcmp(name, "PADDING") < 0) {
        return strcmp(name, "PACKED-DECIMAL") == 0;
    } else {
        return strcmp(name, "PADDING") == 0;
    }
    } else {
    if (strcmp(name, "PASSWORD") < 0) {
        return strcmp(name, "PAGE") == 0;
    } else {
    if (strcmp(name, "PERFORM") < 0) {
        return strcmp(name, "PASSWORD") == 0;
    } else {
        return strcmp(name, "PERFORM") == 0;
    }
    }
    }
    }
    }
    } else {
    if (strcmp(name, "QUOTE") < 0) {
    if (strcmp(name, "PROCEDURE") < 0) {
    if (strcmp(name, "POINTER") < 0) {
    if (strcmp(name, "PICTURE") < 0) {
        return strcmp(name, "PIC") == 0;
    } else {
        return strcmp(name, "PICTURE") == 0;
    }
    } else {
    if (strcmp(name, "POSITION") < 0) {
        return strcmp(name, "POINTER") == 0;
    } else {
    if (strcmp(name, "POSITIVE") < 0) {
        return strcmp(name, "POSITION") == 0;
    } else {
        return strcmp(name, "POSITIVE") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "PROCEED") < 0) {
    if (strcmp(name, "PROCEDURES") < 0) {
        return strcmp(name, "PROCEDURE") == 0;
    } else {
        return strcmp(name, "PROCEDURES") == 0;
    }
    } else {
    if (strcmp(name, "PROGRAM") < 0) {
        return strcmp(name, "PROCEED") == 0;
    } else {
    if (strcmp(name, "PROGRAM-ID") < 0) {
        return strcmp(name, "PROGRAM") == 0;
    } else {
        return strcmp(name, "PROGRAM-ID") == 0;
    }
    }
    }
    }
    } else {
    if (strcmp(name, "RECORDING") < 0) {
    if (strcmp(name, "RANDOM") < 0) {
    if (strcmp(name, "QUOTES") < 0) {
        return strcmp(name, "QUOTE") == 0;
    } else {
        return strcmp(name, "QUOTES") == 0;
    }
    } else {
    if (strcmp(name, "READ") < 0) {
        return strcmp(name, "RANDOM") == 0;
    } else {
    if (strcmp(name, "RECORD") < 0) {
        return strcmp(name, "READ") == 0;
    } else {
        return strcmp(name, "RECORD") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "REDEFINES") < 0) {
    if (strcmp(name, "RECORDS") < 0) {
        return strcmp(name, "RECORDING") == 0;
    } else {
        return strcmp(name, "RECORDS") == 0;
    }
    } else {
    if (strcmp(name, "REEL") < 0) {
        return strcmp(name, "REDEFINES") == 0;
    } else {
    if (strcmp(name, "REFERENCE") < 0) {
        return strcmp(name, "REEL") == 0;
    } else {
        return strcmp(name, "REFERENCE") == 0;
    }
    }
    }
    }
    }
    }
    }
    } else {
    if (strcmp(name, "STATUS") < 0) {
    if (strcmp(name, "SECURITY") < 0) {
    if (strcmp(name, "REVERSED") < 0) {
    if (strcmp(name, "RENAMES") < 0) {
    if (strcmp(name, "REMAINDER") < 0) {
    if (strcmp(name, "RELEASE") < 0) {
        return strcmp(name, "RELATIVE") == 0;
    } else {
        return strcmp(name, "RELEASE") == 0;
    }
    } else {
    if (strcmp(name, "REMARKS") < 0) {
        return strcmp(name, "REMAINDER") == 0;
    } else {
    if (strcmp(name, "REMOVAL") < 0) {
        return strcmp(name, "REMARKS") == 0;
    } else {
        return strcmp(name, "REMOVAL") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "RERUN") < 0) {
    if (strcmp(name, "REPLACING") < 0) {
        return strcmp(name, "RENAMES") == 0;
    } else {
        return strcmp(name, "REPLACING") == 0;
    }
    } else {
    if (strcmp(name, "RESERVE") < 0) {
        return strcmp(name, "RERUN") == 0;
    } else {
    if (strcmp(name, "RETURN") < 0) {
        return strcmp(name, "RESERVE") == 0;
    } else {
        return strcmp(name, "RETURN") == 0;
    }
    }
    }
    }
    } else {
    if (strcmp(name, "RUN") < 0) {
    if (strcmp(name, "REWRITE") < 0) {
    if (strcmp(name, "REWIND") < 0) {
        return strcmp(name, "REVERSED") == 0;
    } else {
        return strcmp(name, "REWIND") == 0;
    }
    } else {
    if (strcmp(name, "RIGHT") < 0) {
        return strcmp(name, "REWRITE") == 0;
    } else {
    if (strcmp(name, "ROUNDED") < 0) {
        return strcmp(name, "RIGHT") == 0;
    } else {
        return strcmp(name, "ROUNDED") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "SD") < 0) {
    if (strcmp(name, "SAME") < 0) {
        return strcmp(name, "RUN") == 0;
    } else {
        return strcmp(name, "SAME") == 0;
    }
    } else {
    if (strcmp(name, "SEARCH") < 0) {
        return strcmp(name, "SD") == 0;
    } else {
    if (strcmp(name, "SECTION") < 0) {
        return strcmp(name, "SEARCH") == 0;
    } else {
        return strcmp(name, "SECTION") == 0;
    }
    }
    }
    }
    }
    } else {
    if (strcmp(name, "SORT") < 0) {
    if (strcmp(name, "SEQUENCE") < 0) {
    if (strcmp(name, "SELECT") < 0) {
    if (strcmp(name, "SEGMENT-LIMIT") < 0) {
        return strcmp(name, "SECURITY") == 0;
    } else {
        return strcmp(name, "SEGMENT-LIMIT") == 0;
    }
    } else {
    if (strcmp(name, "SENTENCE") < 0) {
        return strcmp(name, "SELECT") == 0;
    } else {
    if (strcmp(name, "SEPARATE") < 0) {
        return strcmp(name, "SENTENCE") == 0;
    } else {
        return strcmp(name, "SEPARATE") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "SET") < 0) {
    if (strcmp(name, "SEQUENTIAL") < 0) {
        return strcmp(name, "SEQUENCE") == 0;
    } else {
        return strcmp(name, "SEQUENTIAL") == 0;
    }
    } else {
    if (strcmp(name, "SIGN") < 0) {
        return strcmp(name, "SET") == 0;
    } else {
    if (strcmp(name, "SIZE") < 0) {
        return strcmp(name, "SIGN") == 0;
    } else {
        return strcmp(name, "SIZE") == 0;
    }
    }
    }
    }
    } else {
    if (strcmp(name, "SPECIAL-NAMES") < 0) {
    if (strcmp(name, "SOURCE-COMPUTER") < 0) {
    if (strcmp(name, "SORT-MERGE") < 0) {
        return strcmp(name, "SORT") == 0;
    } else {
        return strcmp(name, "SORT-MERGE") == 0;
    }
    } else {
    if (strcmp(name, "SPACE") < 0) {
        return strcmp(name, "SOURCE-COMPUTER") == 0;
    } else {
    if (strcmp(name, "SPACES") < 0) {
        return strcmp(name, "SPACE") == 0;
    } else {
        return strcmp(name, "SPACES") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "STANDARD-1") < 0) {
    if (strcmp(name, "STANDARD") < 0) {
        return strcmp(name, "SPECIAL-NAMES") == 0;
    } else {
        return strcmp(name, "STANDARD") == 0;
    }
    } else {
    if (strcmp(name, "STANDARD-2") < 0) {
        return strcmp(name, "STANDARD-1") == 0;
    } else {
    if (strcmp(name, "START") < 0) {
        return strcmp(name, "STANDARD-2") == 0;
    } else {
        return strcmp(name, "START") == 0;
    }
    }
    }
    }
    }
    }
    } else {
    if (strcmp(name, "TRUE") < 0) {
    if (strcmp(name, "TEST") < 0) {
    if (strcmp(name, "SYMBOLIC") < 0) {
    if (strcmp(name, "STRING") < 0) {
    if (strcmp(name, "STOP") < 0) {
        return strcmp(name, "STATUS") == 0;
    } else {
        return strcmp(name, "STOP") == 0;
    }
    } else {
    if (strcmp(name, "SUBTRACT") < 0) {
        return strcmp(name, "STRING") == 0;
    } else {
    if (strcmp(name, "SUPPRESS") < 0) {
        return strcmp(name, "SUBTRACT") == 0;
    } else {
        return strcmp(name, "SUPPRESS") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "SYNCHRONIZED") < 0) {
    if (strcmp(name, "SYNC") < 0) {
        return strcmp(name, "SYMBOLIC") == 0;
    } else {
        return strcmp(name, "SYNC") == 0;
    }
    } else {
    if (strcmp(name, "TALLYING") < 0) {
        return strcmp(name, "SYNCHRONIZED") == 0;
    } else {
    if (strcmp(name, "TAPE") < 0) {
        return strcmp(name, "TALLYING") == 0;
    } else {
        return strcmp(name, "TAPE") == 0;
    }
    }
    }
    }
    } else {
    if (strcmp(name, "TIME") < 0) {
    if (strcmp(name, "THEN") < 0) {
    if (strcmp(name, "THAN") < 0) {
        return strcmp(name, "TEST") == 0;
    } else {
        return strcmp(name, "THAN") == 0;
    }
    } else {
    if (strcmp(name, "THROUGH") < 0) {
        return strcmp(name, "THEN") == 0;
    } else {
    if (strcmp(name, "THRU") < 0) {
        return strcmp(name, "THROUGH") == 0;
    } else {
        return strcmp(name, "THRU") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "TO") < 0) {
    if (strcmp(name, "TIMES") < 0) {
        return strcmp(name, "TIME") == 0;
    } else {
        return strcmp(name, "TIMES") == 0;
    }
    } else {
    if (strcmp(name, "TOP") < 0) {
        return strcmp(name, "TO") == 0;
    } else {
    if (strcmp(name, "TRAILING") < 0) {
        return strcmp(name, "TOP") == 0;
    } else {
        return strcmp(name, "TRAILING") == 0;
    }
    }
    }
    }
    }
    } else {
    if (strcmp(name, "VALUES") < 0) {
    if (strcmp(name, "UPON") < 0) {
    if (strcmp(name, "UNSTRING") < 0) {
    if (strcmp(name, "UNIT") < 0) {
        return strcmp(name, "TRUE") == 0;
    } else {
        return strcmp(name, "UNIT") == 0;
    }
    } else {
    if (strcmp(name, "UNTIL") < 0) {
        return strcmp(name, "UNSTRING") == 0;
    } else {
    if (strcmp(name, "UP") < 0) {
        return strcmp(name, "UNTIL") == 0;
    } else {
        return strcmp(name, "UP") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "USE") < 0) {
    if (strcmp(name, "USAGE") < 0) {
        return strcmp(name, "UPON") == 0;
    } else {
        return strcmp(name, "USAGE") == 0;
    }
    } else {
    if (strcmp(name, "USING") < 0) {
        return strcmp(name, "USE") == 0;
    } else {
    if (strcmp(name, "VALUE") < 0) {
        return strcmp(name, "USING") == 0;
    } else {
        return strcmp(name, "VALUE") == 0;
    }
    }
    }
    }
    } else {
    if (strcmp(name, "WORKING-STORAGE") < 0) {
    if (strcmp(name, "WHEN") < 0) {
    if (strcmp(name, "VARYING") < 0) {
        return strcmp(name, "VALUES") == 0;
    } else {
        return strcmp(name, "VARYING") == 0;
    }
    } else {
    if (strcmp(name, "WITH") < 0) {
        return strcmp(name, "WHEN") == 0;
    } else {
    if (strcmp(name, "WORDS") < 0) {
        return strcmp(name, "WITH") == 0;
    } else {
        return strcmp(name, "WORDS") == 0;
    }
    }
    }
    } else {
    if (strcmp(name, "ZERO") < 0) {
    if (strcmp(name, "WRITE") < 0) {
        return strcmp(name, "WORKING-STORAGE") == 0;
    } else {
    if (strcmp(name, "WRITE-ONLY") < 0) {
        return strcmp(name, "WRITE") == 0;
    } else {
        return strcmp(name, "WRITE-ONLY") == 0;
    }
    }
    } else {
    if (strcmp(name, "ZEROES") < 0) {
        return strcmp(name, "ZERO") == 0;
    } else {
    if (strcmp(name, "ZEROS") < 0) {
        return strcmp(name, "ZEROES") == 0;
    } else {
        return strcmp(name, "ZEROS") == 0;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return FALSE;
}
void
VSCinit( void )
{
    if(init == 0)
    {
        TTutils_init();
        TTfunVSC_cond_alt_and_or = TTbuild_fun("VSC_cond_alt_and_or", 1);
        TTfunVSC_cond_and_or_combinable_condition = TTbuild_fun("VSC_cond_and_or_combinable_condition", 3);
        TTfunVSC_cond_class_condition = TTbuild_fun("VSC_cond_class_condition", 3);
        TTfunVSC_cond_class_type = TTbuild_fun("VSC_cond_class_type", 1);
        TTfunVSC_cond_combinable_condition = TTbuild_fun("VSC_cond_combinable_condition", 1);
        TTfunVSC_cond_combined_conditions = TTbuild_fun("VSC_cond_combined_conditions", 2);
        TTfunVSC_cond_condition = TTbuild_fun("VSC_cond_condition", 1);
        TTfunVSC_cond_condition_name_reference = TTbuild_fun("VSC_cond_condition_name_reference", 3);
        TTfunVSC_cond_greater = TTbuild_fun("VSC_cond_greater", 2);
        TTfunVSC_cond_greater_equal = TTbuild_fun("VSC_cond_greater_equal", 5);
        TTfunVSC_cond_greater_than = TTbuild_fun("VSC_cond_greater_than", 1);
        TTfunVSC_cond_greater_than_1 = TTbuild_fun("VSC_cond_greater_than_1", 2);
        TTfunVSC_cond_greater_than_or_equal_to = TTbuild_fun("VSC_cond_greater_than_or_equal_to", 1);
        TTfunVSC_cond_greater_than_or_equal_to_1 = TTbuild_fun("VSC_cond_greater_than_or_equal_to_1", 5);
        TTfunVSC_cond_greater_than_or_equal_to_2 = TTbuild_fun("VSC_cond_greater_than_or_equal_to_2", 3);
        TTfunVSC_cond_greater_than_or_equal_to_3 = TTbuild_fun("VSC_cond_greater_than_or_equal_to_3", 2);
        TTfunVSC_cond_is_not = TTbuild_fun("VSC_cond_is_not", 2);
        TTfunVSC_cond_is_or_is_not = TTbuild_fun("VSC_cond_is_or_is_not", 1);
        TTfunVSC_cond_less = TTbuild_fun("VSC_cond_less", 2);
        TTfunVSC_cond_less_equal = TTbuild_fun("VSC_cond_less_equal", 5);
        TTfunVSC_cond_less_equal_2 = TTbuild_fun("VSC_cond_less_equal_2", 2);
        TTfunVSC_cond_negated_simple_conditions = TTbuild_fun("VSC_cond_negated_simple_conditions", 2);
        TTfunVSC_cond_not_is = TTbuild_fun("VSC_cond_not_is", 2);
        TTfunVSC_cond_not_relational_operator_rest = TTbuild_fun("VSC_cond_not_relational_operator_rest", 2);
        TTfunVSC_cond_relation_condition = TTbuild_fun("VSC_cond_relation_condition", 3);
        TTfunVSC_cond_relational_operator = TTbuild_fun("VSC_cond_relational_operator", 2);
        TTfunVSC_cond_relational_operator_rest = TTbuild_fun("VSC_cond_relational_operator_rest", 1);
        TTfunVSC_cond_relational_operator_tail = TTbuild_fun("VSC_cond_relational_operator_tail", 1);
        TTfunVSC_cond_sign_condition = TTbuild_fun("VSC_cond_sign_condition", 3);
        TTfunVSC_cond_sign_type = TTbuild_fun("VSC_cond_sign_type", 1);
        TTfunVSC_cond_simple_condition = TTbuild_fun("VSC_cond_simple_condition", 1);
        TTfunVSC_cond_simple_condition_1 = TTbuild_fun("VSC_cond_simple_condition_1", 3);
        TTfunVSC_cond_than = TTbuild_fun("VSC_cond_than", 1);
        TTfunVSC_conf_sec_alphabet_clause = TTbuild_fun("VSC_conf_sec_alphabet_clause", 4);
        TTfunVSC_conf_sec_alphabet_type = TTbuild_fun("VSC_conf_sec_alphabet_type", 1);
        TTfunVSC_conf_sec_alphabet_type_also = TTbuild_fun("VSC_conf_sec_alphabet_type_also", 2);
        TTfunVSC_conf_sec_alphabet_type_also_through = TTbuild_fun("VSC_conf_sec_alphabet_type_also_through", 1);
        TTfunVSC_conf_sec_alphabet_type_alsos = TTbuild_fun("VSC_conf_sec_alphabet_type_alsos", 1);
        TTfunVSC_conf_sec_alphabet_type_other = TTbuild_fun("VSC_conf_sec_alphabet_type_other", 2);
        TTfunVSC_conf_sec_alphabet_type_others = TTbuild_fun("VSC_conf_sec_alphabet_type_others", 1);
        TTfunVSC_conf_sec_are = TTbuild_fun("VSC_conf_sec_are", 1);
        TTfunVSC_conf_sec_class_clause = TTbuild_fun("VSC_conf_sec_class_clause", 4);
        TTfunVSC_conf_sec_configuration_section = TTbuild_fun("VSC_conf_sec_configuration_section", 4);
        TTfunVSC_conf_sec_configuration_section_paragraph = TTbuild_fun("VSC_conf_sec_configuration_section_paragraph", 1);
        TTfunVSC_conf_sec_configuration_section_paragraphs = TTbuild_fun("VSC_conf_sec_configuration_section_paragraphs", 1);
        TTfunVSC_conf_sec_currency_sign_clause = TTbuild_fun("VSC_conf_sec_currency_sign_clause", 4);
        TTfunVSC_conf_sec_decimal_point_clause = TTbuild_fun("VSC_conf_sec_decimal_point_clause", 3);
        TTfunVSC_conf_sec_in_alphabet_name = TTbuild_fun("VSC_conf_sec_in_alphabet_name", 2);
        TTfunVSC_conf_sec_is_mnemonic_name = TTbuild_fun("VSC_conf_sec_is_mnemonic_name", 3);
        TTfunVSC_conf_sec_memory_size = TTbuild_fun("VSC_conf_sec_memory_size", 4);
        TTfunVSC_conf_sec_memory_size_type = TTbuild_fun("VSC_conf_sec_memory_size_type", 1);
        TTfunVSC_conf_sec_object_computer_name = TTbuild_fun("VSC_conf_sec_object_computer_name", 4);
        TTfunVSC_conf_sec_object_computer_paragraph = TTbuild_fun("VSC_conf_sec_object_computer_paragraph", 3);
        TTfunVSC_conf_sec_object_computer_paragraph_sequence_phrase = TTbuild_fun("VSC_conf_sec_object_computer_paragraph_sequence_phrase", 2);
        TTfunVSC_conf_sec_off_status = TTbuild_fun("VSC_conf_sec_off_status", 4);
        TTfunVSC_conf_sec_on_status = TTbuild_fun("VSC_conf_sec_on_status", 4);
        TTfunVSC_conf_sec_program_collating_sequence = TTbuild_fun("VSC_conf_sec_program_collating_sequence", 5);
        TTfunVSC_conf_sec_segment_limit = TTbuild_fun("VSC_conf_sec_segment_limit", 3);
        TTfunVSC_conf_sec_source_computer_name = TTbuild_fun("VSC_conf_sec_source_computer_name", 3);
        TTfunVSC_conf_sec_source_computer_paragraph = TTbuild_fun("VSC_conf_sec_source_computer_paragraph", 3);
        TTfunVSC_conf_sec_special_names_paragraph = TTbuild_fun("VSC_conf_sec_special_names_paragraph", 5);
        TTfunVSC_conf_sec_special_names_paragraph_clause = TTbuild_fun("VSC_conf_sec_special_names_paragraph_clause", 1);
        TTfunVSC_conf_sec_special_names_paragraph_clauses = TTbuild_fun("VSC_conf_sec_special_names_paragraph_clauses", 1);
        TTfunVSC_conf_sec_special_names_paragraph_phrase = TTbuild_fun("VSC_conf_sec_special_names_paragraph_phrase", 2);
        TTfunVSC_conf_sec_special_names_paragraph_phrase_tail = TTbuild_fun("VSC_conf_sec_special_names_paragraph_phrase_tail", 1);
        TTfunVSC_conf_sec_special_names_paragraph_status_phrase = TTbuild_fun("VSC_conf_sec_special_names_paragraph_status_phrase", 1);
        TTfunVSC_conf_sec_special_names_paragraph_status_phrase_1 = TTbuild_fun("VSC_conf_sec_special_names_paragraph_status_phrase_1", 5);
        TTfunVSC_conf_sec_special_names_paragraph_status_phrase_2 = TTbuild_fun("VSC_conf_sec_special_names_paragraph_status_phrase_2", 5);
        TTfunVSC_conf_sec_symbolic_character_mapping = TTbuild_fun("VSC_conf_sec_symbolic_character_mapping", 3);
        TTfunVSC_conf_sec_symbolic_characters_clause = TTbuild_fun("VSC_conf_sec_symbolic_characters_clause", 4);
        TTfunVSC_conf_sec_with_debugging_mode = TTbuild_fun("VSC_conf_sec_with_debugging_mode", 3);
        TTfunVSC_data_div_data_division = TTbuild_fun("VSC_data_div_data_division", 4);
        TTfunVSC_data_div_data_division_content = TTbuild_fun("VSC_data_div_data_division_content", 3);
        TTfunVSC_data_div_file_section = TTbuild_fun("VSC_data_div_file_section", 4);
        TTfunVSC_data_div_file_section_entry = TTbuild_fun("VSC_data_div_file_section_entry", 2);
        TTfunVSC_data_div_linkage_section = TTbuild_fun("VSC_data_div_linkage_section", 4);
        TTfunVSC_data_div_working_storage_section = TTbuild_fun("VSC_data_div_working_storage_section", 4);
        TTfunVSC_dd_entry_alt_data_name_filler = TTbuild_fun("VSC_dd_entry_alt_data_name_filler", 1);
        TTfunVSC_dd_entry_alt_leading_trailing = TTbuild_fun("VSC_dd_entry_alt_leading_trailing", 1);
        TTfunVSC_dd_entry_alt_left_right = TTbuild_fun("VSC_dd_entry_alt_left_right", 1);
        TTfunVSC_dd_entry_blank_when_zero_clause = TTbuild_fun("VSC_dd_entry_blank_when_zero_clause", 3);
        TTfunVSC_dd_entry_condition_value_clause = TTbuild_fun("VSC_dd_entry_condition_value_clause", 2);
        TTfunVSC_dd_entry_data_description_entry = TTbuild_fun("VSC_dd_entry_data_description_entry", 1);
        TTfunVSC_dd_entry_data_description_entry_1 = TTbuild_fun("VSC_dd_entry_data_description_entry_1", 4);
        TTfunVSC_dd_entry_data_description_entry_clause = TTbuild_fun("VSC_dd_entry_data_description_entry_clause", 1);
        TTfunVSC_dd_entry_data_description_entry_clauses = TTbuild_fun("VSC_dd_entry_data_description_entry_clauses", 1);
        TTfunVSC_dd_entry_external_clause = TTbuild_fun("VSC_dd_entry_external_clause", 2);
        TTfunVSC_dd_entry_global_clause = TTbuild_fun("VSC_dd_entry_global_clause", 2);
        TTfunVSC_dd_entry_indexed_by = TTbuild_fun("VSC_dd_entry_indexed_by", 3);
        TTfunVSC_dd_entry_integer_to = TTbuild_fun("VSC_dd_entry_integer_to", 2);
        TTfunVSC_dd_entry_justified = TTbuild_fun("VSC_dd_entry_justified", 1);
        TTfunVSC_dd_entry_justified_clause = TTbuild_fun("VSC_dd_entry_justified_clause", 2);
        TTfunVSC_dd_entry_occurs_clause = TTbuild_fun("VSC_dd_entry_occurs_clause", 1);
        TTfunVSC_dd_entry_occurs_clause_1 = TTbuild_fun("VSC_dd_entry_occurs_clause_1", 5);
        TTfunVSC_dd_entry_occurs_clause_2 = TTbuild_fun("VSC_dd_entry_occurs_clause_2", 9);
        TTfunVSC_dd_entry_occurs_clause_key = TTbuild_fun("VSC_dd_entry_occurs_clause_key", 4);
        TTfunVSC_dd_entry_picture = TTbuild_fun("VSC_dd_entry_picture", 1);
        TTfunVSC_dd_entry_picture_clause = TTbuild_fun("VSC_dd_entry_picture_clause", 3);
        TTfunVSC_dd_entry_redefines_clause = TTbuild_fun("VSC_dd_entry_redefines_clause", 2);
        TTfunVSC_dd_entry_renames_clause = TTbuild_fun("VSC_dd_entry_renames_clause", 3);
        TTfunVSC_dd_entry_separate_character = TTbuild_fun("VSC_dd_entry_separate_character", 2);
        TTfunVSC_dd_entry_sign_clause = TTbuild_fun("VSC_dd_entry_sign_clause", 3);
        TTfunVSC_dd_entry_sign_is = TTbuild_fun("VSC_dd_entry_sign_is", 2);
        TTfunVSC_dd_entry_synchronized = TTbuild_fun("VSC_dd_entry_synchronized", 1);
        TTfunVSC_dd_entry_synchronized_clause = TTbuild_fun("VSC_dd_entry_synchronized_clause", 2);
        TTfunVSC_dd_entry_usage = TTbuild_fun("VSC_dd_entry_usage", 1);
        TTfunVSC_dd_entry_usage_clause = TTbuild_fun("VSC_dd_entry_usage_clause", 2);
        TTfunVSC_dd_entry_usage_is = TTbuild_fun("VSC_dd_entry_usage_is", 2);
        TTfunVSC_dd_entry_values_are = TTbuild_fun("VSC_dd_entry_values_are", 2);
        TTfunVSC_dd_entry_zeroes = TTbuild_fun("VSC_dd_entry_zeroes", 1);
        TTfunVSC_env_div_environment_division = TTbuild_fun("VSC_env_div_environment_division", 4);
        TTfunVSC_env_div_environment_division_content = TTbuild_fun("VSC_env_div_environment_division_content", 2);
        TTfunVSC_expr_alphabet_name = TTbuild_fun("VSC_expr_alphabet_name", 1);
        TTfunVSC_expr_alphabetic_user_defined_word = TTbuild_fun("VSC_expr_alphabetic_user_defined_word", 1);
        TTfunVSC_expr_alt_ascending_descending = TTbuild_fun("VSC_expr_alt_ascending_descending", 1);
        TTfunVSC_expr_alt_library_name_literal = TTbuild_fun("VSC_expr_alt_library_name_literal", 1);
        TTfunVSC_expr_alt_plus_minus = TTbuild_fun("VSC_expr_alt_plus_minus", 1);
        TTfunVSC_expr_alt_reel_unit = TTbuild_fun("VSC_expr_alt_reel_unit", 1);
        TTfunVSC_expr_alt_text_name_literal = TTbuild_fun("VSC_expr_alt_text_name_literal", 1);
        TTfunVSC_expr_alt_times_div = TTbuild_fun("VSC_expr_alt_times_div", 1);
        TTfunVSC_expr_arithmetic_expression = TTbuild_fun("VSC_expr_arithmetic_expression", 2);
        TTfunVSC_expr_arithmetic_expression_tail = TTbuild_fun("VSC_expr_arithmetic_expression_tail", 2);
        TTfunVSC_expr_assignment_name = TTbuild_fun("VSC_expr_assignment_name", 1);
        TTfunVSC_expr_basis = TTbuild_fun("VSC_expr_basis", 1);
        TTfunVSC_expr_basis_1 = TTbuild_fun("VSC_expr_basis_1", 3);
        TTfunVSC_expr_class_name = TTbuild_fun("VSC_expr_class_name", 1);
        TTfunVSC_expr_computer_name = TTbuild_fun("VSC_expr_computer_name", 1);
        TTfunVSC_expr_condition_name = TTbuild_fun("VSC_expr_condition_name", 1);
        TTfunVSC_expr_copy_operand = TTbuild_fun("VSC_expr_copy_operand", 1);
        TTfunVSC_expr_copy_statement = TTbuild_fun("VSC_expr_copy_statement", 6);
        TTfunVSC_expr_copy_statement_by_phrase = TTbuild_fun("VSC_expr_copy_statement_by_phrase", 3);
        TTfunVSC_expr_copy_statement_replacing_phrase = TTbuild_fun("VSC_expr_copy_statement_replacing_phrase", 2);
        TTfunVSC_expr_data_name = TTbuild_fun("VSC_expr_data_name", 1);
        TTfunVSC_expr_data_or_file_name = TTbuild_fun("VSC_expr_data_or_file_name", 1);
        TTfunVSC_expr_data_or_file_or_mnemonic_name = TTbuild_fun("VSC_expr_data_or_file_or_mnemonic_name", 1);
        TTfunVSC_expr_environment_name = TTbuild_fun("VSC_expr_environment_name", 1);
        TTfunVSC_expr_equal_to = TTbuild_fun("VSC_expr_equal_to", 1);
        TTfunVSC_expr_equal_to_1 = TTbuild_fun("VSC_expr_equal_to_1", 2);
        TTfunVSC_expr_figurative_constant = TTbuild_fun("VSC_expr_figurative_constant", 1);
        TTfunVSC_expr_figurative_constant_all = TTbuild_fun("VSC_expr_figurative_constant_all", 2);
        TTfunVSC_expr_figurative_constant_simple = TTbuild_fun("VSC_expr_figurative_constant_simple", 1);
        TTfunVSC_expr_file_name = TTbuild_fun("VSC_expr_file_name", 1);
        TTfunVSC_expr_identifier = TTbuild_fun("VSC_expr_identifier", 1);
        TTfunVSC_expr_identifier_1 = TTbuild_fun("VSC_expr_identifier_1", 3);
        TTfunVSC_expr_identifier_2 = TTbuild_fun("VSC_expr_identifier_2", 2);
        TTfunVSC_expr_in = TTbuild_fun("VSC_expr_in", 1);
        TTfunVSC_expr_in_data_or_file_name = TTbuild_fun("VSC_expr_in_data_or_file_name", 2);
        TTfunVSC_expr_in_data_or_file_or_mnemonic_name = TTbuild_fun("VSC_expr_in_data_or_file_or_mnemonic_name", 2);
        TTfunVSC_expr_in_file_name = TTbuild_fun("VSC_expr_in_file_name", 2);
        TTfunVSC_expr_in_library = TTbuild_fun("VSC_expr_in_library", 2);
        TTfunVSC_expr_in_section_name = TTbuild_fun("VSC_expr_in_section_name", 2);
        TTfunVSC_expr_index_name = TTbuild_fun("VSC_expr_index_name", 1);
        TTfunVSC_expr_integer = TTbuild_fun("VSC_expr_integer", 1);
        TTfunVSC_expr_leftmost_character_position = TTbuild_fun("VSC_expr_leftmost_character_position", 1);
        TTfunVSC_expr_length = TTbuild_fun("VSC_expr_length", 1);
        TTfunVSC_expr_level_number = TTbuild_fun("VSC_expr_level_number", 1);
        TTfunVSC_expr_library_name = TTbuild_fun("VSC_expr_library_name", 1);
        TTfunVSC_expr_literal = TTbuild_fun("VSC_expr_literal", 1);
        TTfunVSC_expr_literal_through_literal = TTbuild_fun("VSC_expr_literal_through_literal", 2);
        TTfunVSC_expr_mnemonic_name = TTbuild_fun("VSC_expr_mnemonic_name", 1);
        TTfunVSC_expr_numeric = TTbuild_fun("VSC_expr_numeric", 1);
        TTfunVSC_expr_paragraph_name = TTbuild_fun("VSC_expr_paragraph_name", 1);
        TTfunVSC_expr_paragraph_or_section_name = TTbuild_fun("VSC_expr_paragraph_or_section_name", 1);
        TTfunVSC_expr_plus_minus_integer = TTbuild_fun("VSC_expr_plus_minus_integer", 2);
        TTfunVSC_expr_power = TTbuild_fun("VSC_expr_power", 3);
        TTfunVSC_expr_power_tail = TTbuild_fun("VSC_expr_power_tail", 2);
        TTfunVSC_expr_priority_number = TTbuild_fun("VSC_expr_priority_number", 1);
        TTfunVSC_expr_procedure_name = TTbuild_fun("VSC_expr_procedure_name", 2);
        TTfunVSC_expr_program_name = TTbuild_fun("VSC_expr_program_name", 1);
        TTfunVSC_expr_qualified_data_name = TTbuild_fun("VSC_expr_qualified_data_name", 1);
        TTfunVSC_expr_qualified_data_name_1 = TTbuild_fun("VSC_expr_qualified_data_name_1", 2);
        TTfunVSC_expr_record_name = TTbuild_fun("VSC_expr_record_name", 1);
        TTfunVSC_expr_records = TTbuild_fun("VSC_expr_records", 1);
        TTfunVSC_expr_reference_modification = TTbuild_fun("VSC_expr_reference_modification", 5);
        TTfunVSC_expr_section_name = TTbuild_fun("VSC_expr_section_name", 1);
        TTfunVSC_expr_special_register_1 = TTbuild_fun("VSC_expr_special_register_1", 3);
        TTfunVSC_expr_special_register_2 = TTbuild_fun("VSC_expr_special_register_2", 3);
        TTfunVSC_expr_subscript = TTbuild_fun("VSC_expr_subscript", 1);
        TTfunVSC_expr_subscript_expression = TTbuild_fun("VSC_expr_subscript_expression", 1);
        TTfunVSC_expr_subscript_expression_ambiguous = TTbuild_fun("VSC_expr_subscript_expression_ambiguous", 2);
        TTfunVSC_expr_subscript_parentheses = TTbuild_fun("VSC_expr_subscript_parentheses", 3);
        TTfunVSC_expr_symbolic_character = TTbuild_fun("VSC_expr_symbolic_character", 1);
        TTfunVSC_expr_system_name = TTbuild_fun("VSC_expr_system_name", 1);
        TTfunVSC_expr_text_name = TTbuild_fun("VSC_expr_text_name", 1);
        TTfunVSC_expr_through = TTbuild_fun("VSC_expr_through", 1);
        TTfunVSC_expr_through_arithmetic_expression = TTbuild_fun("VSC_expr_through_arithmetic_expression", 2);
        TTfunVSC_expr_through_literal = TTbuild_fun("VSC_expr_through_literal", 2);
        TTfunVSC_expr_through_qualified_data_name = TTbuild_fun("VSC_expr_through_qualified_data_name", 2);
        TTfunVSC_expr_times_div = TTbuild_fun("VSC_expr_times_div", 2);
        TTfunVSC_expr_times_div_tail = TTbuild_fun("VSC_expr_times_div_tail", 2);
        TTfunVSC_expr_user_defined_word = TTbuild_fun("VSC_expr_user_defined_word", 1);
        TTfunVSC_expr_values = TTbuild_fun("VSC_expr_values", 1);
        TTfunVSC_fd_entry_alt_characters_records = TTbuild_fun("VSC_fd_entry_alt_characters_records", 1);
        TTfunVSC_fd_entry_alt_data_name_integer = TTbuild_fun("VSC_fd_entry_alt_data_name_integer", 1);
        TTfunVSC_fd_entry_alt_fd_sd = TTbuild_fun("VSC_fd_entry_alt_fd_sd", 1);
        TTfunVSC_fd_entry_alt_qualified_data_name_literal = TTbuild_fun("VSC_fd_entry_alt_qualified_data_name_literal", 1);
        TTfunVSC_fd_entry_block_contains_clause = TTbuild_fun("VSC_fd_entry_block_contains_clause", 5);
        TTfunVSC_fd_entry_code_set_clause = TTbuild_fun("VSC_fd_entry_code_set_clause", 3);
        TTfunVSC_fd_entry_data_names = TTbuild_fun("VSC_fd_entry_data_names", 1);
        TTfunVSC_fd_entry_data_records_clause = TTbuild_fun("VSC_fd_entry_data_records_clause", 3);
        TTfunVSC_fd_entry_depending_on = TTbuild_fun("VSC_fd_entry_depending_on", 3);
        TTfunVSC_fd_entry_file_and_sort_description_entry = TTbuild_fun("VSC_fd_entry_file_and_sort_description_entry", 4);
        TTfunVSC_fd_entry_file_and_sort_description_entry_clause = TTbuild_fun("VSC_fd_entry_file_and_sort_description_entry_clause", 1);
        TTfunVSC_fd_entry_file_and_sort_description_entry_clauses = TTbuild_fun("VSC_fd_entry_file_and_sort_description_entry_clauses", 1);
        TTfunVSC_fd_entry_footing = TTbuild_fun("VSC_fd_entry_footing", 4);
        TTfunVSC_fd_entry_from_integer = TTbuild_fun("VSC_fd_entry_from_integer", 2);
        TTfunVSC_fd_entry_label_records_clause = TTbuild_fun("VSC_fd_entry_label_records_clause", 3);
        TTfunVSC_fd_entry_label_records_clause_tail = TTbuild_fun("VSC_fd_entry_label_records_clause_tail", 1);
        TTfunVSC_fd_entry_linage_clause = TTbuild_fun("VSC_fd_entry_linage_clause", 5);
        TTfunVSC_fd_entry_linage_footing_phrase = TTbuild_fun("VSC_fd_entry_linage_footing_phrase", 3);
        TTfunVSC_fd_entry_lines_bottom = TTbuild_fun("VSC_fd_entry_lines_bottom", 4);
        TTfunVSC_fd_entry_lines_top = TTbuild_fun("VSC_fd_entry_lines_top", 4);
        TTfunVSC_fd_entry_record_clause = TTbuild_fun("VSC_fd_entry_record_clause", 2);
        TTfunVSC_fd_entry_record_clause_tail = TTbuild_fun("VSC_fd_entry_record_clause_tail", 1);
        TTfunVSC_fd_entry_record_clause_tail_1 = TTbuild_fun("VSC_fd_entry_record_clause_tail_1", 3);
        TTfunVSC_fd_entry_record_clause_tail_2 = TTbuild_fun("VSC_fd_entry_record_clause_tail_2", 5);
        TTfunVSC_fd_entry_record_clause_tail_3 = TTbuild_fun("VSC_fd_entry_record_clause_tail_3", 2);
        TTfunVSC_fd_entry_record_varying_phrase = TTbuild_fun("VSC_fd_entry_record_varying_phrase", 7);
        TTfunVSC_fd_entry_recording_mode_clause = TTbuild_fun("VSC_fd_entry_recording_mode_clause", 4);
        TTfunVSC_fd_entry_records_are = TTbuild_fun("VSC_fd_entry_records_are", 2);
        TTfunVSC_fd_entry_to_integer = TTbuild_fun("VSC_fd_entry_to_integer", 2);
        TTfunVSC_fd_entry_value_of_clause = TTbuild_fun("VSC_fd_entry_value_of_clause", 3);
        TTfunVSC_fd_entry_value_of_clause_tail = TTbuild_fun("VSC_fd_entry_value_of_clause_tail", 3);
        TTfunVSC_id_div_author = TTbuild_fun("VSC_id_div_author", 2);
        TTfunVSC_id_div_date_compiled = TTbuild_fun("VSC_id_div_date_compiled", 2);
        TTfunVSC_id_div_date_written = TTbuild_fun("VSC_id_div_date_written", 2);
        TTfunVSC_id_div_identification = TTbuild_fun("VSC_id_div_identification", 1);
        TTfunVSC_id_div_identification_division = TTbuild_fun("VSC_id_div_identification_division", 5);
        TTfunVSC_id_div_identification_division_content = TTbuild_fun("VSC_id_div_identification_division_content", 1);
        TTfunVSC_id_div_identification_division_phrase = TTbuild_fun("VSC_id_div_identification_division_phrase", 1);
        TTfunVSC_id_div_initial_program = TTbuild_fun("VSC_id_div_initial_program", 3);
        TTfunVSC_id_div_installation = TTbuild_fun("VSC_id_div_installation", 2);
        TTfunVSC_id_div_program_id_cobol_source_program = TTbuild_fun("VSC_id_div_program_id_cobol_source_program", 5);
        TTfunVSC_id_div_remarks = TTbuild_fun("VSC_id_div_remarks", 2);
        TTfunVSC_id_div_security = TTbuild_fun("VSC_id_div_security", 2);
        TTfunVSC_io_sec_alt_assignment_name_file_name = TTbuild_fun("VSC_io_sec_alt_assignment_name_file_name", 1);
        TTfunVSC_io_sec_alt_assignment_name_literal = TTbuild_fun("VSC_io_sec_alt_assignment_name_literal", 1);
        TTfunVSC_io_sec_alt_indexed_relative_sequential = TTbuild_fun("VSC_io_sec_alt_indexed_relative_sequential", 1);
        TTfunVSC_io_sec_alt_sequential_random_dynamic = TTbuild_fun("VSC_io_sec_alt_sequential_random_dynamic", 1);
        TTfunVSC_io_sec_alternate_record_key_clause = TTbuild_fun("VSC_io_sec_alternate_record_key_clause", 7);
        TTfunVSC_io_sec_areas = TTbuild_fun("VSC_io_sec_areas", 1);
        TTfunVSC_io_sec_assign_clause = TTbuild_fun("VSC_io_sec_assign_clause", 3);
        TTfunVSC_io_sec_every_phrase = TTbuild_fun("VSC_io_sec_every_phrase", 1);
        TTfunVSC_io_sec_every_phrase_1 = TTbuild_fun("VSC_io_sec_every_phrase_1", 2);
        TTfunVSC_io_sec_every_phrase_2 = TTbuild_fun("VSC_io_sec_every_phrase_2", 3);
        TTfunVSC_io_sec_fce_access_mode = TTbuild_fun("VSC_io_sec_fce_access_mode", 5);
        TTfunVSC_io_sec_fce_organization = TTbuild_fun("VSC_io_sec_fce_organization", 2);
        TTfunVSC_io_sec_fce_phrase = TTbuild_fun("VSC_io_sec_fce_phrase", 1);
        TTfunVSC_io_sec_file_control_entry = TTbuild_fun("VSC_io_sec_file_control_entry", 4);
        TTfunVSC_io_sec_file_control_paragraph = TTbuild_fun("VSC_io_sec_file_control_paragraph", 3);
        TTfunVSC_io_sec_file_name_position = TTbuild_fun("VSC_io_sec_file_name_position", 2);
        TTfunVSC_io_sec_file_status_clause = TTbuild_fun("VSC_io_sec_file_status_clause", 5);
        TTfunVSC_io_sec_i_o_control_paragraph = TTbuild_fun("VSC_io_sec_i_o_control_paragraph", 4);
        TTfunVSC_io_sec_i_o_sam = TTbuild_fun("VSC_io_sec_i_o_sam", 2);
        TTfunVSC_io_sec_i_o_sort_merge = TTbuild_fun("VSC_io_sec_i_o_sort_merge", 2);
        TTfunVSC_io_sec_input_output_section = TTbuild_fun("VSC_io_sec_input_output_section", 5);
        TTfunVSC_io_sec_organization_is = TTbuild_fun("VSC_io_sec_organization_is", 2);
        TTfunVSC_io_sec_padding_character_clause = TTbuild_fun("VSC_io_sec_padding_character_clause", 4);
        TTfunVSC_io_sec_password_clause = TTbuild_fun("VSC_io_sec_password_clause", 3);
        TTfunVSC_io_sec_position = TTbuild_fun("VSC_io_sec_position", 2);
        TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries = TTbuild_fun("VSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries", 1);
        TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_1 = TTbuild_fun("VSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_1", 7);
        TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_2 = TTbuild_fun("VSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_2", 6);
        TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_3 = TTbuild_fun("VSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_3", 5);
        TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_4 = TTbuild_fun("VSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_4", 4);
        TTfunVSC_io_sec_record_delimiter_clause = TTbuild_fun("VSC_io_sec_record_delimiter_clause", 4);
        TTfunVSC_io_sec_record_delimiter_name = TTbuild_fun("VSC_io_sec_record_delimiter_name", 1);
        TTfunVSC_io_sec_record_key_clause = TTbuild_fun("VSC_io_sec_record_key_clause", 4);
        TTfunVSC_io_sec_record_sort = TTbuild_fun("VSC_io_sec_record_sort", 1);
        TTfunVSC_io_sec_relative_key_clause = TTbuild_fun("VSC_io_sec_relative_key_clause", 4);
        TTfunVSC_io_sec_rerun_on = TTbuild_fun("VSC_io_sec_rerun_on", 3);
        TTfunVSC_io_sec_reserve_clause = TTbuild_fun("VSC_io_sec_reserve_clause", 3);
        TTfunVSC_io_sec_same_area = TTbuild_fun("VSC_io_sec_same_area", 6);
        TTfunVSC_io_sec_select_clause = TTbuild_fun("VSC_io_sec_select_clause", 3);
        TTfunVSC_io_sec_sort_merge_i_o_control_entries = TTbuild_fun("VSC_io_sec_sort_merge_i_o_control_entries", 2);
        TTfunVSC_io_sec_with_duplicates = TTbuild_fun("VSC_io_sec_with_duplicates", 2);
        TTfunVSC_main_cobol_source_program = TTbuild_fun("VSC_main_cobol_source_program", 5);
        TTfunVSC_main_common_initial = TTbuild_fun("VSC_main_common_initial", 1);
        TTfunVSC_main_common_initial_1 = TTbuild_fun("VSC_main_common_initial_1", 2);
        TTfunVSC_main_common_initial_2 = TTbuild_fun("VSC_main_common_initial_2", 2);
        TTfunVSC_main_common_initial_program = TTbuild_fun("VSC_main_common_initial_program", 3);
        TTfunVSC_main_nested_cobol_source_program = TTbuild_fun("VSC_main_nested_cobol_source_program", 13);
        TTfunVSC_main_nested_program = TTbuild_fun("VSC_main_nested_program", 5);
        TTfunVSC_main_program_id_nested_cobol_source_program = TTbuild_fun("VSC_main_program_id_nested_cobol_source_program", 5);
        TTfunVSC_main_programs = TTbuild_fun("VSC_main_programs", 1);
        TTfunVSC_proc_div_altered_goto = TTbuild_fun("VSC_proc_div_altered_goto", 5);
        TTfunVSC_proc_div_declaratives = TTbuild_fun("VSC_proc_div_declaratives", 6);
        TTfunVSC_proc_div_declaratives_content = TTbuild_fun("VSC_proc_div_declaratives_content", 5);
        TTfunVSC_proc_div_paragraph = TTbuild_fun("VSC_proc_div_paragraph", 1);
        TTfunVSC_proc_div_paragraph_1 = TTbuild_fun("VSC_proc_div_paragraph_1", 3);
        TTfunVSC_proc_div_paragraphs = TTbuild_fun("VSC_proc_div_paragraphs", 2);
        TTfunVSC_proc_div_procedure_division = TTbuild_fun("VSC_proc_div_procedure_division", 5);
        TTfunVSC_proc_div_section_header = TTbuild_fun("VSC_proc_div_section_header", 3);
        TTfunVSC_proc_div_section_with_header = TTbuild_fun("VSC_proc_div_section_with_header", 3);
        TTfunVSC_proc_div_sections = TTbuild_fun("VSC_proc_div_sections", 2);
        TTfunVSC_proc_div_sentence = TTbuild_fun("VSC_proc_div_sentence", 1);
        TTfunVSC_proc_div_sentence_1 = TTbuild_fun("VSC_proc_div_sentence_1", 2);
        TTfunVSC_proc_div_sentence_2 = TTbuild_fun("VSC_proc_div_sentence_2", 2);
        TTfunVSC_proc_div_using_data_names = TTbuild_fun("VSC_proc_div_using_data_names", 2);
        TTfunVSC_proc_div_using_phrase = TTbuild_fun("VSC_proc_div_using_phrase", 1);
        TTfunVSC_proc_div_using_phrase_1 = TTbuild_fun("VSC_proc_div_using_phrase_1", 2);
        TTfunVSC_proc_div_using_phrase_2 = TTbuild_fun("VSC_proc_div_using_phrase_2", 2);
        TTfunVSC_stat_accept_statement = TTbuild_fun("VSC_stat_accept_statement", 1);
        TTfunVSC_stat_accept_statement_1 = TTbuild_fun("VSC_stat_accept_statement_1", 3);
        TTfunVSC_stat_accept_statement_2 = TTbuild_fun("VSC_stat_accept_statement_2", 4);
        TTfunVSC_stat_add_statement = TTbuild_fun("VSC_stat_add_statement", 1);
        TTfunVSC_stat_add_statement_1 = TTbuild_fun("VSC_stat_add_statement_1", 7);
        TTfunVSC_stat_add_statement_2 = TTbuild_fun("VSC_stat_add_statement_2", 8);
        TTfunVSC_stat_add_statement_3 = TTbuild_fun("VSC_stat_add_statement_3", 9);
        TTfunVSC_stat_advancing_phrase = TTbuild_fun("VSC_stat_advancing_phrase", 3);
        TTfunVSC_stat_all_procedures = TTbuild_fun("VSC_stat_all_procedures", 2);
        TTfunVSC_stat_also_phrase = TTbuild_fun("VSC_stat_also_phrase", 2);
        TTfunVSC_stat_alt_all_leading = TTbuild_fun("VSC_stat_alt_all_leading", 1);
        TTfunVSC_stat_alt_all_leading_first = TTbuild_fun("VSC_stat_alt_all_leading_first", 1);
        TTfunVSC_stat_alt_before_after = TTbuild_fun("VSC_stat_alt_before_after", 1);
        TTfunVSC_stat_alt_beginning_ending = TTbuild_fun("VSC_stat_alt_beginning_ending", 1);
        TTfunVSC_stat_alt_exception_error = TTbuild_fun("VSC_stat_alt_exception_error", 1);
        TTfunVSC_stat_alt_file_names_i_o = TTbuild_fun("VSC_stat_alt_file_names_i_o", 1);
        TTfunVSC_stat_alt_file_reel_unit = TTbuild_fun("VSC_stat_alt_file_reel_unit", 1);
        TTfunVSC_stat_alt_no_rewind_lock = TTbuild_fun("VSC_stat_alt_no_rewind_lock", 1);
        TTfunVSC_stat_alt_procedures_all_procedures = TTbuild_fun("VSC_stat_alt_procedures_all_procedures", 1);
        TTfunVSC_stat_alt_removal_no_rewind = TTbuild_fun("VSC_stat_alt_removal_no_rewind", 1);
        TTfunVSC_stat_alt_reversed_with_no_rewind = TTbuild_fun("VSC_stat_alt_reversed_with_no_rewind", 1);
        TTfunVSC_stat_alt_run_literal = TTbuild_fun("VSC_stat_alt_run_literal", 1);
        TTfunVSC_stat_alt_statement_list_next_sentence = TTbuild_fun("VSC_stat_alt_statement_list_next_sentence", 1);
        TTfunVSC_stat_alt_up_down = TTbuild_fun("VSC_stat_alt_up_down", 1);
        TTfunVSC_stat_alt_up_down_by = TTbuild_fun("VSC_stat_alt_up_down_by", 2);
        TTfunVSC_stat_alter_statement = TTbuild_fun("VSC_stat_alter_statement", 2);
        TTfunVSC_stat_at_end_of_page_statement_list = TTbuild_fun("VSC_stat_at_end_of_page_statement_list", 3);
        TTfunVSC_stat_at_end_statement_list = TTbuild_fun("VSC_stat_at_end_statement_list", 3);
        TTfunVSC_stat_before_after_phrase = TTbuild_fun("VSC_stat_before_after_phrase", 3);
        TTfunVSC_stat_by_reference = TTbuild_fun("VSC_stat_by_reference", 2);
        TTfunVSC_stat_call_rest_phrase = TTbuild_fun("VSC_stat_call_rest_phrase", 3);
        TTfunVSC_stat_call_statement = TTbuild_fun("VSC_stat_call_statement", 5);
        TTfunVSC_stat_cancel_statement = TTbuild_fun("VSC_stat_cancel_statement", 2);
        TTfunVSC_stat_close_statement = TTbuild_fun("VSC_stat_close_statement", 2);
        TTfunVSC_stat_close_statement_file_name = TTbuild_fun("VSC_stat_close_statement_file_name", 2);
        TTfunVSC_stat_close_statement_options = TTbuild_fun("VSC_stat_close_statement_options", 1);
        TTfunVSC_stat_close_statement_options_1 = TTbuild_fun("VSC_stat_close_statement_options_1", 2);
        TTfunVSC_stat_close_statement_options_2 = TTbuild_fun("VSC_stat_close_statement_options_2", 2);
        TTfunVSC_stat_cobword_int = TTbuild_fun("VSC_stat_cobword_int", 1);
        TTfunVSC_stat_cobword_rounded = TTbuild_fun("VSC_stat_cobword_rounded", 2);
        TTfunVSC_stat_collating_sequence = TTbuild_fun("VSC_stat_collating_sequence", 4);
        TTfunVSC_stat_compute_statement = TTbuild_fun("VSC_stat_compute_statement", 7);
        TTfunVSC_stat_content_parameter = TTbuild_fun("VSC_stat_content_parameter", 3);
        TTfunVSC_stat_content_parameter_value = TTbuild_fun("VSC_stat_content_parameter_value", 1);
        TTfunVSC_stat_continue_statement = TTbuild_fun("VSC_stat_continue_statement", 1);
        TTfunVSC_stat_corresponding = TTbuild_fun("VSC_stat_corresponding", 1);
        TTfunVSC_stat_count_in_identifier = TTbuild_fun("VSC_stat_count_in_identifier", 3);
        TTfunVSC_stat_date = TTbuild_fun("VSC_stat_date", 1);
        TTfunVSC_stat_delete_statement = TTbuild_fun("VSC_stat_delete_statement", 6);
        TTfunVSC_stat_delimited_by_all_phrase = TTbuild_fun("VSC_stat_delimited_by_all_phrase", 5);
        TTfunVSC_stat_delimited_by_phrase = TTbuild_fun("VSC_stat_delimited_by_phrase", 4);
        TTfunVSC_stat_delimiter_in_identifier = TTbuild_fun("VSC_stat_delimiter_in_identifier", 3);
        TTfunVSC_stat_display_statement = TTbuild_fun("VSC_stat_display_statement", 4);
        TTfunVSC_stat_divide_statement = TTbuild_fun("VSC_stat_divide_statement", 1);
        TTfunVSC_stat_divide_statement_1 = TTbuild_fun("VSC_stat_divide_statement_1", 7);
        TTfunVSC_stat_divide_statement_2 = TTbuild_fun("VSC_stat_divide_statement_2", 9);
        TTfunVSC_stat_divide_statement_3 = TTbuild_fun("VSC_stat_divide_statement_3", 9);
        TTfunVSC_stat_divide_statement_4 = TTbuild_fun("VSC_stat_divide_statement_4", 12);
        TTfunVSC_stat_divide_statement_5 = TTbuild_fun("VSC_stat_divide_statement_5", 12);
        TTfunVSC_stat_else_phrase = TTbuild_fun("VSC_stat_else_phrase", 2);
        TTfunVSC_stat_end_of_page = TTbuild_fun("VSC_stat_end_of_page", 1);
        TTfunVSC_stat_entry_statement = TTbuild_fun("VSC_stat_entry_statement", 3);
        TTfunVSC_stat_equal = TTbuild_fun("VSC_stat_equal", 1);
        TTfunVSC_stat_evaluate_condition = TTbuild_fun("VSC_stat_evaluate_condition", 1);
        TTfunVSC_stat_evaluate_phrase = TTbuild_fun("VSC_stat_evaluate_phrase", 1);
        TTfunVSC_stat_evaluate_phrase_1 = TTbuild_fun("VSC_stat_evaluate_phrase_1", 2);
        TTfunVSC_stat_evaluate_phrase_2 = TTbuild_fun("VSC_stat_evaluate_phrase_2", 3);
        TTfunVSC_stat_evaluate_statement = TTbuild_fun("VSC_stat_evaluate_statement", 6);
        TTfunVSC_stat_exit_program_statement = TTbuild_fun("VSC_stat_exit_program_statement", 2);
        TTfunVSC_stat_exit_statement = TTbuild_fun("VSC_stat_exit_statement", 1);
        TTfunVSC_stat_file_names = TTbuild_fun("VSC_stat_file_names", 1);
        TTfunVSC_stat_for_removal = TTbuild_fun("VSC_stat_for_removal", 2);
        TTfunVSC_stat_from_environment_name = TTbuild_fun("VSC_stat_from_environment_name", 2);
        TTfunVSC_stat_from_identifier = TTbuild_fun("VSC_stat_from_identifier", 2);
        TTfunVSC_stat_giving_file_names = TTbuild_fun("VSC_stat_giving_file_names", 2);
        TTfunVSC_stat_go_to_statement = TTbuild_fun("VSC_stat_go_to_statement", 1);
        TTfunVSC_stat_go_to_statement_1 = TTbuild_fun("VSC_stat_go_to_statement_1", 3);
        TTfunVSC_stat_go_to_statement_2 = TTbuild_fun("VSC_stat_go_to_statement_2", 6);
        TTfunVSC_stat_go_to_statement_3 = TTbuild_fun("VSC_stat_go_to_statement_3", 3);
        TTfunVSC_stat_goback_statement = TTbuild_fun("VSC_stat_goback_statement", 1);
        TTfunVSC_stat_id_or_lit = TTbuild_fun("VSC_stat_id_or_lit", 1);
        TTfunVSC_stat_id_or_lit_size = TTbuild_fun("VSC_stat_id_or_lit_size", 1);
        TTfunVSC_stat_if_statement = TTbuild_fun("VSC_stat_if_statement", 6);
        TTfunVSC_stat_initialize_replacing_argument = TTbuild_fun("VSC_stat_initialize_replacing_argument", 4);
        TTfunVSC_stat_initialize_replacing_phrase = TTbuild_fun("VSC_stat_initialize_replacing_phrase", 2);
        TTfunVSC_stat_initialize_replacing_type = TTbuild_fun("VSC_stat_initialize_replacing_type", 1);
        TTfunVSC_stat_initialize_statement = TTbuild_fun("VSC_stat_initialize_statement", 3);
        TTfunVSC_stat_input_procedure = TTbuild_fun("VSC_stat_input_procedure", 5);
        TTfunVSC_stat_inspect_by_argument = TTbuild_fun("VSC_stat_inspect_by_argument", 1);
        TTfunVSC_stat_inspect_replacing_argument = TTbuild_fun("VSC_stat_inspect_replacing_argument", 4);
        TTfunVSC_stat_inspect_replacing_phrase = TTbuild_fun("VSC_stat_inspect_replacing_phrase", 1);
        TTfunVSC_stat_inspect_replacing_phrase_1 = TTbuild_fun("VSC_stat_inspect_replacing_phrase_1", 4);
        TTfunVSC_stat_inspect_replacing_phrase_2 = TTbuild_fun("VSC_stat_inspect_replacing_phrase_2", 2);
        TTfunVSC_stat_inspect_statement = TTbuild_fun("VSC_stat_inspect_statement", 1);
        TTfunVSC_stat_inspect_statement_1 = TTbuild_fun("VSC_stat_inspect_statement_1", 4);
        TTfunVSC_stat_inspect_statement_2 = TTbuild_fun("VSC_stat_inspect_statement_2", 7);
        TTfunVSC_stat_inspect_statement_3 = TTbuild_fun("VSC_stat_inspect_statement_3", 6);
        TTfunVSC_stat_inspect_statement_4 = TTbuild_fun("VSC_stat_inspect_statement_4", 4);
        TTfunVSC_stat_into_identifier = TTbuild_fun("VSC_stat_into_identifier", 2);
        TTfunVSC_stat_invalid_key_statement_list = TTbuild_fun("VSC_stat_invalid_key_statement_list", 3);
        TTfunVSC_stat_key_is = TTbuild_fun("VSC_stat_key_is", 2);
        TTfunVSC_stat_key_is_qualified_data_name = TTbuild_fun("VSC_stat_key_is_qualified_data_name", 3);
        TTfunVSC_stat_key_is_rel_op_qualified_data_name = TTbuild_fun("VSC_stat_key_is_rel_op_qualified_data_name", 4);
        TTfunVSC_stat_lines = TTbuild_fun("VSC_stat_lines", 1);
        TTfunVSC_stat_merge_statement = TTbuild_fun("VSC_stat_merge_statement", 8);
        TTfunVSC_stat_merge_statement_tail = TTbuild_fun("VSC_stat_merge_statement_tail", 1);
        TTfunVSC_stat_move_statement = TTbuild_fun("VSC_stat_move_statement", 1);
        TTfunVSC_stat_move_statement_1 = TTbuild_fun("VSC_stat_move_statement_1", 4);
        TTfunVSC_stat_move_statement_2 = TTbuild_fun("VSC_stat_move_statement_2", 5);
        TTfunVSC_stat_multiply_statement = TTbuild_fun("VSC_stat_multiply_statement", 1);
        TTfunVSC_stat_multiply_statement_1 = TTbuild_fun("VSC_stat_multiply_statement_1", 7);
        TTfunVSC_stat_multiply_statement_2 = TTbuild_fun("VSC_stat_multiply_statement_2", 9);
        TTfunVSC_stat_next_sentence = TTbuild_fun("VSC_stat_next_sentence", 2);
        TTfunVSC_stat_no_rewind = TTbuild_fun("VSC_stat_no_rewind", 2);
        TTfunVSC_stat_not_at_end_of_page_statement_list = TTbuild_fun("VSC_stat_not_at_end_of_page_statement_list", 4);
        TTfunVSC_stat_not_at_end_statement_list = TTbuild_fun("VSC_stat_not_at_end_statement_list", 4);
        TTfunVSC_stat_not_invalid_key_statement_list = TTbuild_fun("VSC_stat_not_invalid_key_statement_list", 4);
        TTfunVSC_stat_not_on_exception_statement_list = TTbuild_fun("VSC_stat_not_on_exception_statement_list", 4);
        TTfunVSC_stat_not_on_overflow_statement_list = TTbuild_fun("VSC_stat_not_on_overflow_statement_list", 4);
        TTfunVSC_stat_not_on_size_error_statement_list = TTbuild_fun("VSC_stat_not_on_size_error_statement_list", 5);
        TTfunVSC_stat_nr_lines_phrase = TTbuild_fun("VSC_stat_nr_lines_phrase", 2);
        TTfunVSC_stat_on_exception_statement_list = TTbuild_fun("VSC_stat_on_exception_statement_list", 3);
        TTfunVSC_stat_on_key_is_phrase = TTbuild_fun("VSC_stat_on_key_is_phrase", 4);
        TTfunVSC_stat_on_key_phrase = TTbuild_fun("VSC_stat_on_key_phrase", 4);
        TTfunVSC_stat_on_overflow_statement_list = TTbuild_fun("VSC_stat_on_overflow_statement_list", 3);
        TTfunVSC_stat_on_size_error_statement_list = TTbuild_fun("VSC_stat_on_size_error_statement_list", 4);
        TTfunVSC_stat_open_statement = TTbuild_fun("VSC_stat_open_statement", 2);
        TTfunVSC_stat_open_statement_extend = TTbuild_fun("VSC_stat_open_statement_extend", 2);
        TTfunVSC_stat_open_statement_i_o = TTbuild_fun("VSC_stat_open_statement_i_o", 2);
        TTfunVSC_stat_open_statement_input = TTbuild_fun("VSC_stat_open_statement_input", 2);
        TTfunVSC_stat_open_statement_input_file_name = TTbuild_fun("VSC_stat_open_statement_input_file_name", 2);
        TTfunVSC_stat_open_statement_output = TTbuild_fun("VSC_stat_open_statement_output", 2);
        TTfunVSC_stat_open_statement_output_file_name = TTbuild_fun("VSC_stat_open_statement_output_file_name", 2);
        TTfunVSC_stat_open_statement_phrase = TTbuild_fun("VSC_stat_open_statement_phrase", 1);
        TTfunVSC_stat_or_all_id_or_lit = TTbuild_fun("VSC_stat_or_all_id_or_lit", 3);
        TTfunVSC_stat_output_procedure = TTbuild_fun("VSC_stat_output_procedure", 5);
        TTfunVSC_stat_page_phrase = TTbuild_fun("VSC_stat_page_phrase", 1);
        TTfunVSC_stat_parameter = TTbuild_fun("VSC_stat_parameter", 1);
        TTfunVSC_stat_perform_after_phrase = TTbuild_fun("VSC_stat_perform_after_phrase", 8);
        TTfunVSC_stat_perform_statement = TTbuild_fun("VSC_stat_perform_statement", 1);
        TTfunVSC_stat_perform_statement_1 = TTbuild_fun("VSC_stat_perform_statement_1", 2);
        TTfunVSC_stat_perform_statement_1_alts = TTbuild_fun("VSC_stat_perform_statement_1_alts", 1);
        TTfunVSC_stat_perform_statement_1_procedure = TTbuild_fun("VSC_stat_perform_statement_1_procedure", 2);
        TTfunVSC_stat_perform_statement_1_statement_list = TTbuild_fun("VSC_stat_perform_statement_1_statement_list", 2);
        TTfunVSC_stat_perform_statement_2 = TTbuild_fun("VSC_stat_perform_statement_2", 2);
        TTfunVSC_stat_perform_statement_2_alts = TTbuild_fun("VSC_stat_perform_statement_2_alts", 1);
        TTfunVSC_stat_perform_statement_2_procedure = TTbuild_fun("VSC_stat_perform_statement_2_procedure", 4);
        TTfunVSC_stat_perform_statement_2_statement_list = TTbuild_fun("VSC_stat_perform_statement_2_statement_list", 3);
        TTfunVSC_stat_perform_statement_3 = TTbuild_fun("VSC_stat_perform_statement_3", 2);
        TTfunVSC_stat_perform_statement_3_alts = TTbuild_fun("VSC_stat_perform_statement_3_alts", 1);
        TTfunVSC_stat_perform_statement_3_procedure = TTbuild_fun("VSC_stat_perform_statement_3_procedure", 4);
        TTfunVSC_stat_perform_statement_3_statement_list = TTbuild_fun("VSC_stat_perform_statement_3_statement_list", 4);
        TTfunVSC_stat_perform_statement_4 = TTbuild_fun("VSC_stat_perform_statement_4", 2);
        TTfunVSC_stat_perform_statement_4_alts = TTbuild_fun("VSC_stat_perform_statement_4_alts", 1);
        TTfunVSC_stat_perform_statement_4_procedure = TTbuild_fun("VSC_stat_perform_statement_4_procedure", 3);
        TTfunVSC_stat_perform_statement_4_statement_list = TTbuild_fun("VSC_stat_perform_statement_4_statement_list", 3);
        TTfunVSC_stat_perform_until_phrase = TTbuild_fun("VSC_stat_perform_until_phrase", 3);
        TTfunVSC_stat_perform_varying_phrase = TTbuild_fun("VSC_stat_perform_varying_phrase", 9);
        TTfunVSC_stat_procedure_names = TTbuild_fun("VSC_stat_procedure_names", 1);
        TTfunVSC_stat_procedure_to_procedure = TTbuild_fun("VSC_stat_procedure_to_procedure", 4);
        TTfunVSC_stat_proceed_to = TTbuild_fun("VSC_stat_proceed_to", 2);
        TTfunVSC_stat_read_statement = TTbuild_fun("VSC_stat_read_statement", 11);
        TTfunVSC_stat_reference_parameter = TTbuild_fun("VSC_stat_reference_parameter", 2);
        TTfunVSC_stat_rel_op = TTbuild_fun("VSC_stat_rel_op", 1);
        TTfunVSC_stat_release_statement = TTbuild_fun("VSC_stat_release_statement", 3);
        TTfunVSC_stat_return_statement = TTbuild_fun("VSC_stat_return_statement", 9);
        TTfunVSC_stat_rewrite_statement = TTbuild_fun("VSC_stat_rewrite_statement", 6);
        TTfunVSC_stat_search_statement = TTbuild_fun("VSC_stat_search_statement", 1);
        TTfunVSC_stat_search_statement_1 = TTbuild_fun("VSC_stat_search_statement_1", 6);
        TTfunVSC_stat_search_statement_2 = TTbuild_fun("VSC_stat_search_statement_2", 9);
        TTfunVSC_stat_search_statement_condition = TTbuild_fun("VSC_stat_search_statement_condition", 1);
        TTfunVSC_stat_search_statement_condition_tail = TTbuild_fun("VSC_stat_search_statement_condition_tail", 2);
        TTfunVSC_stat_search_statement_equal_expression = TTbuild_fun("VSC_stat_search_statement_equal_expression", 4);
        TTfunVSC_stat_set_oper = TTbuild_fun("VSC_stat_set_oper", 1);
        TTfunVSC_stat_set_src = TTbuild_fun("VSC_stat_set_src", 1);
        TTfunVSC_stat_set_statement = TTbuild_fun("VSC_stat_set_statement", 2);
        TTfunVSC_stat_set_statement_phrase = TTbuild_fun("VSC_stat_set_statement_phrase", 3);
        TTfunVSC_stat_sort_statement = TTbuild_fun("VSC_stat_sort_statement", 7);
        TTfunVSC_stat_sort_statement_in = TTbuild_fun("VSC_stat_sort_statement_in", 1);
        TTfunVSC_stat_sort_statement_out = TTbuild_fun("VSC_stat_sort_statement_out", 1);
        TTfunVSC_stat_start_statement = TTbuild_fun("VSC_stat_start_statement", 6);
        TTfunVSC_stat_statement = TTbuild_fun("VSC_stat_statement", 1);
        TTfunVSC_stat_statement_list = TTbuild_fun("VSC_stat_statement_list", 1);
        TTfunVSC_stat_stop_statement = TTbuild_fun("VSC_stat_stop_statement", 2);
        TTfunVSC_stat_string_statement = TTbuild_fun("VSC_stat_string_statement", 8);
        TTfunVSC_stat_subtract_statement = TTbuild_fun("VSC_stat_subtract_statement", 1);
        TTfunVSC_stat_subtract_statement_1 = TTbuild_fun("VSC_stat_subtract_statement_1", 7);
        TTfunVSC_stat_subtract_statement_2 = TTbuild_fun("VSC_stat_subtract_statement_2", 9);
        TTfunVSC_stat_subtract_statement_3 = TTbuild_fun("VSC_stat_subtract_statement_3", 9);
        TTfunVSC_stat_tallying_argument = TTbuild_fun("VSC_stat_tallying_argument", 3);
        TTfunVSC_stat_tallying_for_argument = TTbuild_fun("VSC_stat_tallying_for_argument", 1);
        TTfunVSC_stat_tallying_for_argument_1 = TTbuild_fun("VSC_stat_tallying_for_argument_1", 2);
        TTfunVSC_stat_tallying_for_argument_2 = TTbuild_fun("VSC_stat_tallying_for_argument_2", 2);
        TTfunVSC_stat_tallying_for_id_or_lit = TTbuild_fun("VSC_stat_tallying_for_id_or_lit", 2);
        TTfunVSC_stat_tallying_in_identifier = TTbuild_fun("VSC_stat_tallying_in_identifier", 3);
        TTfunVSC_stat_through_procedure_name = TTbuild_fun("VSC_stat_through_procedure_name", 2);
        TTfunVSC_stat_to_id_or_lit = TTbuild_fun("VSC_stat_to_id_or_lit", 2);
        TTfunVSC_stat_unstring_statement = TTbuild_fun("VSC_stat_unstring_statement", 10);
        TTfunVSC_stat_unstring_statement_dst = TTbuild_fun("VSC_stat_unstring_statement_dst", 3);
        TTfunVSC_stat_upon_environment_name = TTbuild_fun("VSC_stat_upon_environment_name", 2);
        TTfunVSC_stat_use_statement = TTbuild_fun("VSC_stat_use_statement", 1);
        TTfunVSC_stat_use_statement_1 = TTbuild_fun("VSC_stat_use_statement_1", 8);
        TTfunVSC_stat_use_statement_2 = TTbuild_fun("VSC_stat_use_statement_2", 10);
        TTfunVSC_stat_use_statement_3 = TTbuild_fun("VSC_stat_use_statement_3", 5);
        TTfunVSC_stat_using_data_name_pluslist = TTbuild_fun("VSC_stat_using_data_name_pluslist", 2);
        TTfunVSC_stat_using_file_names = TTbuild_fun("VSC_stat_using_file_names", 2);
        TTfunVSC_stat_using_parameters = TTbuild_fun("VSC_stat_using_parameters", 2);
        TTfunVSC_stat_varying_identifier = TTbuild_fun("VSC_stat_varying_identifier", 2);
        TTfunVSC_stat_when_condition_stats = TTbuild_fun("VSC_stat_when_condition_stats", 3);
        TTfunVSC_stat_when_other_phrase = TTbuild_fun("VSC_stat_when_other_phrase", 3);
        TTfunVSC_stat_when_phrase = TTbuild_fun("VSC_stat_when_phrase", 3);
        TTfunVSC_stat_when_phrase_also_phrase = TTbuild_fun("VSC_stat_when_phrase_also_phrase", 2);
        TTfunVSC_stat_when_phrases = TTbuild_fun("VSC_stat_when_phrases", 2);
        TTfunVSC_stat_with_duplicates_in_order = TTbuild_fun("VSC_stat_with_duplicates_in_order", 4);
        TTfunVSC_stat_with_no_advancing = TTbuild_fun("VSC_stat_with_no_advancing", 3);
        TTfunVSC_stat_with_no_rewind = TTbuild_fun("VSC_stat_with_no_rewind", 3);
        TTfunVSC_stat_with_pointer_identifier = TTbuild_fun("VSC_stat_with_pointer_identifier", 3);
        TTfunVSC_stat_with_test = TTbuild_fun("VSC_stat_with_test", 3);
        TTfunVSC_stat_write_exceptions = TTbuild_fun("VSC_stat_write_exceptions", 4);
        TTfunVSC_stat_write_statement = TTbuild_fun("VSC_stat_write_statement", 6);
        TTfunVSC_lex_picture_string = TTbuild_fun("VSC_lex_picture_string", 1);
        TTfunVSC_lex_quoted_pseudo_text = TTbuild_fun("VSC_lex_quoted_pseudo_text", 1);
        TTfunVSC_lex_num = TTbuild_fun("VSC_lex_num", 1);
        TTfunVSC_lex_nonnumeric = TTbuild_fun("VSC_lex_nonnumeric", 1);
        TTfunVSC_lex_cobword = TTbuild_fun("VSC_lex_cobword", 1);
    }
    init++;
}

static BOOL TTist_END_WRITE_opt(TTterm t);
static BOOL TTist_END_WRITE(TTterm t);
static BOOL TTisVSC_stat_advancing_phrase_opt(TTterm t);
static BOOL TTist_WRITE(TTterm t);
static BOOL TTisVSC_stat_not_at_end_of_page_statement_list_opt(TTterm t);
static BOOL TTisVSC_stat_at_end_of_page_statement_list_opt(TTterm t);
static BOOL TTist_TEST(TTterm t);
static BOOL TTist_ORDER_opt(TTterm t);
static BOOL TTist_ORDER(TTterm t);
static BOOL TTisVSC_stat_when_phrase_plus(TTterm t);
static BOOL TTisVSC_stat_when_phrase_also_phrase_star(TTterm t);
static BOOL TTist_OTHER(TTterm t);
static BOOL TTisVSC_stat_parameter_plus(TTterm t);
static BOOL TTisVSC_stat_alt_file_reel_unit_opt(TTterm t);
static BOOL TTisVSC_stat_alt_beginning_ending_opt(TTterm t);
static BOOL TTist_STANDARD_opt(TTterm t);
static BOOL TTist_GLOBAL_opt(TTterm t);
static BOOL TTist_USE(TTterm t);
static BOOL TTist_UPON(TTterm t);
static BOOL TTisVSC_stat_count_in_identifier_opt(TTterm t);
static BOOL TTisVSC_stat_delimiter_in_identifier_opt(TTterm t);
static BOOL TTist_END_UNSTRING_opt(TTterm t);
static BOOL TTist_END_UNSTRING(TTterm t);
static BOOL TTisVSC_stat_tallying_in_identifier_opt(TTterm t);
static BOOL TTisVSC_stat_unstring_statement_dst_plus(TTterm t);
static BOOL TTisVSC_stat_delimited_by_all_phrase_opt(TTterm t);
static BOOL TTist_UNSTRING(TTterm t);
static BOOL TTisVSC_stat_tallying_for_id_or_lit_plus(TTterm t);
static BOOL TTisVSC_stat_tallying_for_argument_plus(TTterm t);
static BOOL TTist_END_SUBTRACT_opt(TTterm t);
static BOOL TTist_END_SUBTRACT(TTterm t);
static BOOL TTist_SUBTRACT(TTterm t);
static BOOL TTist_END_STRING_opt(TTterm t);
static BOOL TTist_END_STRING(TTterm t);
static BOOL TTisVSC_stat_not_on_overflow_statement_list_opt(TTterm t);
static BOOL TTisVSC_stat_with_pointer_identifier_opt(TTterm t);
static BOOL TTisVSC_stat_delimited_by_phrase_plus(TTterm t);
static BOOL TTist_STRING(TTterm t);
static BOOL TTist_STOP(TTterm t);
static BOOL TTisVSC_stat_statement_plus(TTterm t);
static BOOL TTist_END_START_opt(TTterm t);
static BOOL TTist_END_START(TTterm t);
static BOOL TTisVSC_stat_key_is_rel_op_qualified_data_name_opt(TTterm t);
static BOOL TTist_START(TTterm t);
static BOOL TTisVSC_stat_with_duplicates_in_order_opt(TTterm t);
static BOOL TTisVSC_stat_on_key_is_phrase_plus(TTterm t);
static BOOL TTisVSC_stat_set_statement_phrase_plus(TTterm t);
static BOOL TTist_SET(TTterm t);
static BOOL TTisVSC_stat_search_statement_condition_tail_star(TTterm t);
static BOOL TTist_END_SEARCH_opt(TTterm t);
static BOOL TTist_END_SEARCH(TTterm t);
static BOOL TTisVSC_stat_when_condition_stats_plus(TTterm t);
static BOOL TTisVSC_stat_varying_identifier_opt(TTterm t);
static BOOL TTist_SEARCH(TTterm t);
static BOOL TTist_END_REWRITE_opt(TTterm t);
static BOOL TTist_END_REWRITE(TTterm t);
static BOOL TTist_REWRITE(TTterm t);
static BOOL TTist_END_RETURN_opt(TTterm t);
static BOOL TTist_END_RETURN(TTterm t);
static BOOL TTist_RETURN(TTterm t);
static BOOL TTisVSC_stat_from_identifier_opt(TTterm t);
static BOOL TTist_RELEASE(TTterm t);
static BOOL TTisVSC_stat_by_reference_opt(TTterm t);
static BOOL TTist_END_READ_opt(TTterm t);
static BOOL TTist_END_READ(TTterm t);
static BOOL TTisVSC_stat_not_at_end_statement_list_opt(TTterm t);
static BOOL TTisVSC_stat_at_end_statement_list_opt(TTterm t);
static BOOL TTisVSC_stat_key_is_qualified_data_name_opt(TTterm t);
static BOOL TTisVSC_stat_into_identifier_opt(TTterm t);
static BOOL TTist_NEXT_opt(TTterm t);
static BOOL TTist_READ(TTterm t);
static BOOL TTist_PROCEED(TTterm t);
static BOOL TTisVSC_stat_proceed_to_opt(TTterm t);
static BOOL TTisVSC_stat_with_test_opt(TTterm t);
static BOOL TTisVSC_stat_perform_after_phrase_star(TTterm t);
static BOOL TTist_END_PERFORM(TTterm t);
static BOOL TTist_PERFORM(TTterm t);
static BOOL TTist_UNTIL(TTterm t);
static BOOL TTist_PAGE(TTterm t);
static BOOL TTisVSC_stat_with_no_rewind_opt(TTterm t);
static BOOL TTisVSC_stat_open_statement_output_file_name_plus(TTterm t);
static BOOL TTisVSC_stat_alt_reversed_with_no_rewind_opt(TTterm t);
static BOOL TTisVSC_stat_open_statement_input_file_name_plus(TTterm t);
static BOOL TTisVSC_stat_open_statement_phrase_plus(TTterm t);
static BOOL TTist_OPEN(TTterm t);
static BOOL TTisVSC_stat_key_is_opt(TTterm t);
static BOOL TTisVSC_stat_lines_opt(TTterm t);
static BOOL TTist_OVERFLOW(TTterm t);
static BOOL TTist_REWIND(TTterm t);
static BOOL TTist_NO(TTterm t);
static BOOL TTist_SENTENCE(TTterm t);
static BOOL TTist_NEXT(TTterm t);
static BOOL TTist_END_MULTIPLY_opt(TTterm t);
static BOOL TTist_END_MULTIPLY(TTterm t);
static BOOL TTist_MULTIPLY(TTterm t);
static BOOL TTist_MOVE(TTterm t);
static BOOL TTisVSC_stat_collating_sequence_opt(TTterm t);
static BOOL TTisVSC_stat_on_key_phrase_plus(TTterm t);
static BOOL TTist_MERGE(TTterm t);
static BOOL TTist_LINE(TTterm t);
static BOOL TTist_INVALID(TTterm t);
static BOOL TTisVSC_stat_inspect_replacing_phrase_plus(TTterm t);
static BOOL TTist_CONVERTING(TTterm t);
static BOOL TTisVSC_stat_tallying_argument_plus(TTterm t);
static BOOL TTist_TALLYING(TTterm t);
static BOOL TTist_INSPECT(TTterm t);
static BOOL TTisVSC_stat_inspect_replacing_argument_plus(TTterm t);
static BOOL TTisVSC_stat_before_after_phrase_star(TTterm t);
static BOOL TTisVSC_stat_through_procedure_name_opt(TTterm t);
static BOOL TTisVSC_stat_initialize_replacing_phrase_opt(TTterm t);
static BOOL TTisVSC_expr_identifier_plus(TTterm t);
static BOOL TTist_INITIALIZE(TTterm t);
static BOOL TTist_EGCS(TTterm t);
static BOOL TTist_NUMERIC_EDITED(TTterm t);
static BOOL TTist_ALPHANUMERIC_EDITED(TTterm t);
static BOOL TTist_ALPHANUMERIC(TTterm t);
static BOOL TTisVSC_stat_initialize_replacing_argument_plus(TTterm t);
static BOOL TTist_DATA_opt(TTterm t);
static BOOL TTist_END_IF_opt(TTterm t);
static BOOL TTist_END_IF(TTterm t);
static BOOL TTisVSC_stat_else_phrase_opt(TTterm t);
static BOOL TTist_IF(TTterm t);
static BOOL TTist_GOBACK(TTterm t);
static BOOL TTist_MORE_LABELS(TTterm t);
static BOOL TTisVSC_expr_procedure_name_plus(TTterm t);
static BOOL TTist_REMOVAL(TTterm t);
static BOOL TTist_EXIT(TTterm t);
static BOOL TTist_END_EVALUATE_opt(TTterm t);
static BOOL TTist_END_EVALUATE(TTterm t);
static BOOL TTisVSC_stat_when_other_phrase_opt(TTterm t);
static BOOL TTisVSC_stat_when_phrases_plus(TTterm t);
static BOOL TTisVSC_stat_also_phrase_star(TTterm t);
static BOOL TTist_EVALUATE(TTterm t);
static BOOL TTist_ANY(TTterm t);
static BOOL TTist_FALSE(TTterm t);
static BOOL TTist_TRUE(TTterm t);
static BOOL TTist_ENTRY(TTterm t);
static BOOL TTist_EOP(TTterm t);
static BOOL TTist_END_OF_PAGE(TTterm t);
static BOOL TTist_ELSE(TTterm t);
static BOOL TTist_REMAINDER(TTterm t);
static BOOL TTist_END_DIVIDE_opt(TTterm t);
static BOOL TTist_END_DIVIDE(TTterm t);
static BOOL TTist_INTO(TTterm t);
static BOOL TTist_DIVIDE(TTterm t);
static BOOL TTisVSC_stat_with_no_advancing_opt(TTterm t);
static BOOL TTisVSC_stat_upon_environment_name_opt(TTterm t);
static BOOL TTisVSC_stat_or_all_id_or_lit_star(TTterm t);
static BOOL TTist_ALL_opt(TTterm t);
static BOOL TTist_DELIMITED(TTterm t);
static BOOL TTist_END_DELETE_opt(TTterm t);
static BOOL TTist_END_DELETE(TTterm t);
static BOOL TTisVSC_stat_not_invalid_key_statement_list_opt(TTterm t);
static BOOL TTisVSC_stat_invalid_key_statement_list_opt(TTterm t);
static BOOL TTist_DELETE(TTterm t);
static BOOL TTist_TIME(TTterm t);
static BOOL TTist_DAY_OF_WEEK(TTterm t);
static BOOL TTist_DAY(TTterm t);
static BOOL TTist_DATE(TTterm t);
static BOOL TTist_COUNT(TTterm t);
static BOOL TTist_CORR(TTterm t);
static BOOL TTist_CORRESPONDING(TTterm t);
static BOOL TTist_CONTINUE(TTterm t);
static BOOL TTisVSC_stat_content_parameter_value_plus(TTterm t);
static BOOL TTist_CONTENT(TTterm t);
static BOOL TTist_END_COMPUTE_opt(TTterm t);
static BOOL TTist_END_COMPUTE(TTterm t);
static BOOL TTist_COMPUTE(TTterm t);
static BOOL TTisVSC_stat_alt_removal_no_rewind_opt(TTterm t);
static BOOL TTisVSC_stat_close_statement_options_opt(TTterm t);
static BOOL TTisVSC_stat_close_statement_file_name_plus(TTterm t);
static BOOL TTist_CLOSE(TTterm t);
static BOOL TTist_CANCEL(TTterm t);
static BOOL TTist_END_CALL_opt(TTterm t);
static BOOL TTist_END_CALL(TTterm t);
static BOOL TTisVSC_stat_using_parameters_opt(TTterm t);
static BOOL TTist_CALL(TTterm t);
static BOOL TTisVSC_stat_on_overflow_statement_list_opt(TTterm t);
static BOOL TTisVSC_stat_not_on_exception_statement_list_opt(TTterm t);
static BOOL TTisVSC_stat_on_exception_statement_list_opt(TTterm t);
static BOOL TTist_REFERENCE(TTterm t);
static BOOL TTisVSC_stat_procedure_to_procedure_plus(TTterm t);
static BOOL TTist_ALTER(TTterm t);
static BOOL TTist_DOWN(TTterm t);
static BOOL TTist_UP(TTterm t);
static BOOL TTist_RUN(TTterm t);
static BOOL TTist_REVERSED(TTterm t);
static BOOL TTist_LOCK(TTterm t);
static BOOL TTist_EXTEND(TTterm t);
static BOOL TTist_I_O(TTterm t);
static BOOL TTist_OUTPUT(TTterm t);
static BOOL TTist_INPUT(TTterm t);
static BOOL TTist_ERROR(TTterm t);
static BOOL TTist_EXCEPTION(TTterm t);
static BOOL TTist_ENDING(TTterm t);
static BOOL TTist_BEGINNING(TTterm t);
static BOOL TTist_AFTER(TTterm t);
static BOOL TTist_BEFORE(TTterm t);
static BOOL TTist_FIRST(TTterm t);
static BOOL TTist_PROCEDURES(TTterm t);
static BOOL TTist_ADVANCING_opt(TTterm t);
static BOOL TTist_ADVANCING(TTterm t);
static BOOL TTist_ROUNDED_opt(TTterm t);
static BOOL TTist_ROUNDED(TTterm t);
static BOOL TTist_GIVING(TTterm t);
static BOOL TTisVSC_stat_to_id_or_lit_opt(TTterm t);
static BOOL TTist_END_ADD_opt(TTterm t);
static BOOL TTist_END_ADD(TTterm t);
static BOOL TTisVSC_stat_not_on_size_error_statement_list_opt(TTterm t);
static BOOL TTisVSC_stat_on_size_error_statement_list_opt(TTterm t);
static BOOL TTisVSC_stat_cobword_rounded_plus(TTterm t);
static BOOL TTisVSC_stat_id_or_lit_plus(TTterm t);
static BOOL TTist_ADD(TTterm t);
static BOOL TTisVSC_stat_from_environment_name_opt(TTterm t);
static BOOL TTist_ACCEPT(TTterm t);
static BOOL TTisVSC_proc_div_using_data_names_opt(TTterm t);
static BOOL TTisVSC_stat_using_data_name_pluslist_opt(TTterm t);
static BOOL TTisVSC_expr_data_name_star(TTterm t);
static BOOL TTist_USING(TTterm t);
static BOOL TTisVSC_stat_statement_list_opt(TTterm t);
static BOOL TTist_qdot_plus(TTterm t);
static BOOL TTisVSC_proc_div_section_with_header_star(TTterm t);
static BOOL TTisVSC_expr_priority_number_opt(TTterm t);
static BOOL TTisVSC_proc_div_declaratives_opt(TTterm t);
static BOOL TTist_PROCEDURE(TTterm t);
static BOOL TTisVSC_proc_div_paragraph_star(TTterm t);
static BOOL TTisVSC_proc_div_sentence_star(TTterm t);
static BOOL TTisVSC_proc_div_declaratives_content_plus(TTterm t);
static BOOL TTist_DECLARATIVES(TTterm t);
static BOOL TTist_GO(TTterm t);
static BOOL TTisVSC_main_cobol_source_program_plus(TTterm t);
static BOOL TTisVSC_main_common_initial_program_opt(TTterm t);
static BOOL TTisVSC_main_nested_cobol_source_program_star(TTterm t);
static BOOL TTisVSC_id_div_identification_division_content_opt(TTterm t);
static BOOL TTist_COMMON_opt(TTterm t);
static BOOL TTist_INITIAL_opt(TTterm t);
static BOOL TTist_COMMON(TTterm t);
static BOOL TTisVSC_main_nested_program_opt(TTterm t);
static BOOL TTisVSC_proc_div_procedure_division_opt(TTterm t);
static BOOL TTisVSC_data_div_data_division_opt(TTterm t);
static BOOL TTisVSC_env_div_environment_division_opt(TTterm t);
static BOOL TTist_DUPLICATES(TTterm t);
static BOOL TTisVSC_io_sec_same_area_plus(TTterm t);
static BOOL TTisVSC_io_sec_rerun_on_opt(TTterm t);
static BOOL TTist_OPTIONAL_opt(TTterm t);
static BOOL TTist_OPTIONAL(TTterm t);
static BOOL TTist_SELECT(TTterm t);
static BOOL TTisVSC_io_sec_areas_opt(TTterm t);
static BOOL TTist_RESERVE(TTterm t);
static BOOL TTist_SORT_MERGE(TTterm t);
static BOOL TTist_SORT(TTterm t);
static BOOL TTist_DELIMITER(TTterm t);
static BOOL TTist_WRITE_ONLY(TTterm t);
static BOOL TTist_APPLY(TTterm t);
static BOOL TTisVSC_io_sec_file_name_position_plus(TTterm t);
static BOOL TTist_TAPE_opt(TTterm t);
static BOOL TTist_TAPE(TTterm t);
static BOOL TTist_MULTIPLE(TTterm t);
static BOOL TTisVSC_expr_file_name_plus(TTterm t);
static BOOL TTist_FOR_opt(TTterm t);
static BOOL TTist_FOR(TTterm t);
static BOOL TTist_AREA_opt(TTterm t);
static BOOL TTist_SAME(TTterm t);
static BOOL TTist_EVERY_opt(TTterm t);
static BOOL TTist_EVERY(TTterm t);
static BOOL TTist_RERUN(TTterm t);
static BOOL TTist_POSITION(TTterm t);
static BOOL TTist_PASSWORD(TTterm t);
static BOOL TTist_PADDING(TTterm t);
static BOOL TTist_ORGANIZATION(TTterm t);
static BOOL TTisVSC_io_sec_i_o_control_paragraph_opt(TTterm t);
static BOOL TTisVSC_io_sec_file_control_paragraph_opt(TTterm t);
static BOOL TTist_INPUT_OUTPUT(TTterm t);
static BOOL TTisVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_plus(TTterm t);
static BOOL TTisVSC_io_sec_i_o_sort_merge_opt(TTterm t);
static BOOL TTisVSC_io_sec_i_o_sam_opt(TTterm t);
static BOOL TTist_I_O_CONTROL(TTterm t);
static BOOL TTisVSC_expr_qualified_data_name_opt(TTterm t);
static BOOL TTist_FILE_opt(TTterm t);
static BOOL TTisVSC_io_sec_position_opt(TTterm t);
static BOOL TTisVSC_io_sec_file_control_entry_star(TTterm t);
static BOOL TTist_FILE_CONTROL(TTterm t);
static BOOL TTisVSC_io_sec_fce_phrase_star(TTterm t);
static BOOL TTisVSC_io_sec_organization_is_opt(TTterm t);
static BOOL TTisVSC_io_sec_relative_key_clause_opt(TTterm t);
static BOOL TTist_ACCESS(TTterm t);
static BOOL TTist_OF_opt(TTterm t);
static BOOL TTist_END(TTterm t);
static BOOL TTisVSC_io_sec_alt_assignment_name_literal_plus(TTterm t);
static BOOL TTist_ASSIGN(TTterm t);
static BOOL TTist_AREAS(TTterm t);
static BOOL TTist_AREA(TTterm t);
static BOOL TTisVSC_io_sec_with_duplicates_opt(TTterm t);
static BOOL TTisVSC_io_sec_password_clause_opt(TTterm t);
static BOOL TTist_RECORD_opt(TTterm t);
static BOOL TTist_ALTERNATE(TTterm t);
static BOOL TTist_DYNAMIC(TTterm t);
static BOOL TTist_RANDOM(TTterm t);
static BOOL TTist_SEQUENTIAL(TTterm t);
static BOOL TTist_RELATIVE(TTterm t);
static BOOL TTist_SECURITY(TTterm t);
static BOOL TTist_REMARKS(TTterm t);
static BOOL TTisVSC_id_div_initial_program_opt(TTterm t);
static BOOL TTist_PROGRAM_ID(TTterm t);
static BOOL TTist_INSTALLATION(TTterm t);
static BOOL TTist_INITIAL(TTterm t);
static BOOL TTisVSC_id_div_identification_division_phrase_star(TTterm t);
static BOOL TTist_ID(TTterm t);
static BOOL TTist_IDENTIFICATION(TTterm t);
static BOOL TTist_DATE_WRITTEN(TTterm t);
static BOOL TTist_DATE_COMPILED(TTterm t);
static BOOL TTist_AUTHOR(TTterm t);
static BOOL TTisVSC_fd_entry_value_of_clause_tail_plus(TTterm t);
static BOOL TTist_MODE_opt(TTterm t);
static BOOL TTist_RECORDING(TTterm t);
static BOOL TTisVSC_fd_entry_to_integer_opt(TTterm t);
static BOOL TTisVSC_fd_entry_from_integer_opt(TTterm t);
static BOOL TTist_IN_opt(TTterm t);
static BOOL TTist_VARYING(TTterm t);
static BOOL TTisVSC_fd_entry_depending_on_opt(TTterm t);
static BOOL TTist_TOP(TTterm t);
static BOOL TTist_BOTTOM(TTterm t);
static BOOL TTisVSC_fd_entry_lines_bottom_opt(TTterm t);
static BOOL TTisVSC_fd_entry_lines_top_opt(TTterm t);
static BOOL TTisVSC_fd_entry_footing_opt(TTterm t);
static BOOL TTist_LINES_opt(TTterm t);
static BOOL TTist_LINES(TTterm t);
static BOOL TTist_LINAGE(TTterm t);
static BOOL TTist_OMITTED(TTterm t);
static BOOL TTist_STANDARD(TTterm t);
static BOOL TTist_LABEL(TTterm t);
static BOOL TTist_FROM_opt(TTterm t);
static BOOL TTist_FROM(TTterm t);
static BOOL TTist_AT_opt(TTterm t);
static BOOL TTist_AT(TTterm t);
static BOOL TTist_FOOTING(TTterm t);
static BOOL TTisVSC_fd_entry_file_and_sort_description_entry_clause_star(TTterm t);
static BOOL TTisVSC_expr_data_name_plus(TTterm t);
static BOOL TTist_CODE_SET(TTterm t);
static BOOL TTisVSC_fd_entry_alt_characters_records_opt(TTterm t);
static BOOL TTist_CONTAINS_opt(TTterm t);
static BOOL TTist_CONTAINS(TTterm t);
static BOOL TTist_BLOCK(TTterm t);
static BOOL TTist_SD(TTterm t);
static BOOL TTist_FD(TTterm t);
static BOOL TTist_VALUES(TTterm t);
static BOOL TTist_VALUE(TTterm t);
static BOOL TTisVSC_expr_times_div_tail_star(TTterm t);
static BOOL TTist_THRU(TTterm t);
static BOOL TTist_THROUGH(TTterm t);
static BOOL TTisVSC_expr_plus_minus_integer_opt(TTterm t);
static BOOL TTisVSC_expr_subscript_expression_plus(TTterm t);
static BOOL TTist_LENGTH(TTterm t);
static BOOL TTist_ADDRESS(TTterm t);
static BOOL TTisVSC_expr_length_opt(TTterm t);
static BOOL TTist_qcolon(TTterm t);
static BOOL TTist_RECORDS(TTterm t);
static BOOL TTist_RECORD(TTterm t);
static BOOL TTisVSC_expr_in_data_or_file_name_star(TTterm t);
static BOOL TTisVSC_expr_in_section_name_opt(TTterm t);
static BOOL TTist_qmultiply_qmultiply(TTterm t);
static BOOL TTisVSC_expr_power_tail_star(TTterm t);
static BOOL TTisVSC_expr_alt_plus_minus_opt(TTterm t);
static BOOL TTisVSC_expr_through_literal_opt(TTterm t);
static BOOL TTist_OF(TTterm t);
static BOOL TTisVSC_expr_in_file_name_opt(TTterm t);
static BOOL TTist_LINAGE_COUNTER(TTterm t);
static BOOL TTisVSC_expr_reference_modification_opt(TTterm t);
static BOOL TTist_NULLS(TTterm t);
static BOOL TTist_NULL(TTterm t);
static BOOL TTist_QUOTES(TTterm t);
static BOOL TTist_QUOTE(TTterm t);
static BOOL TTist_LOW_VALUES(TTterm t);
static BOOL TTist_LOW_VALUE(TTterm t);
static BOOL TTist_HIGH_VALUES(TTterm t);
static BOOL TTist_HIGH_VALUE(TTterm t);
static BOOL TTist_SPACES(TTterm t);
static BOOL TTist_SPACE(TTterm t);
static BOOL TTist_ALL(TTterm t);
static BOOL TTisVSC_expr_copy_statement_by_phrase_plus(TTterm t);
static BOOL TTist_REPLACING(TTterm t);
static BOOL TTisVSC_expr_copy_statement_replacing_phrase_opt(TTterm t);
static BOOL TTist_SUPPRESS_opt(TTterm t);
static BOOL TTist_SUPPRESS(TTterm t);
static BOOL TTisVSC_expr_in_library_opt(TTterm t);
static BOOL TTist_COPY(TTterm t);
static BOOL TTisVSC_expr_arithmetic_expression_tail_star(TTterm t);
static BOOL TTist_qdivide(TTterm t);
static BOOL TTist_qmultiply(TTterm t);
static BOOL TTist_UNIT(TTterm t);
static BOOL TTist_REEL(TTterm t);
static BOOL TTist__(TTterm t);
static BOOL TTist_qplus(TTterm t);
static BOOL TTist_DESCENDING(TTterm t);
static BOOL TTist_ASCENDING(TTterm t);
static BOOL TTisVSC_io_sec_input_output_section_opt(TTterm t);
static BOOL TTisVSC_conf_sec_configuration_section_opt(TTterm t);
static BOOL TTist_ENVIRONMENT(TTterm t);
static BOOL TTist_USAGE(TTterm t);
static BOOL TTisVSC_dd_entry_usage_is_opt(TTterm t);
static BOOL TTist_POINTER(TTterm t);
static BOOL TTist_PACKED_DECIMAL(TTterm t);
static BOOL TTist_INDEX(TTterm t);
static BOOL TTist_DISPLAY_1(TTterm t);
static BOOL TTist_DISPLAY(TTterm t);
static BOOL TTist_COMPUTATIONAL_4(TTterm t);
static BOOL TTist_COMPUTATIONAL_3(TTterm t);
static BOOL TTist_COMPUTATIONAL_2(TTterm t);
static BOOL TTist_COMPUTATIONAL_1(TTterm t);
static BOOL TTist_COMPUTATIONAL(TTterm t);
static BOOL TTist_COMP_4(TTterm t);
static BOOL TTist_COMP_3(TTterm t);
static BOOL TTist_COMP_2(TTterm t);
static BOOL TTist_COMP_1(TTterm t);
static BOOL TTist_COMP(TTterm t);
static BOOL TTist_BINARY(TTterm t);
static BOOL TTisVSC_dd_entry_alt_left_right_opt(TTterm t);
static BOOL TTist_SYNC(TTterm t);
static BOOL TTist_SYNCHRONIZED(TTterm t);
static BOOL TTisVSC_dd_entry_separate_character_opt(TTterm t);
static BOOL TTisVSC_dd_entry_sign_is_opt(TTterm t);
static BOOL TTist_CHARACTER_opt(TTterm t);
static BOOL TTist_CHARACTER(TTterm t);
static BOOL TTist_SEPARATE(TTterm t);
static BOOL TTisVSC_expr_through_qualified_data_name_opt(TTterm t);
static BOOL TTist_RENAMES(TTterm t);
static BOOL TTist_REDEFINES(TTterm t);
static BOOL TTist_PIC(TTterm t);
static BOOL TTist_PICTURE(TTterm t);
static BOOL TTisVSC_expr_qualified_data_name_plus(TTterm t);
static BOOL TTist_KEY_opt(TTterm t);
static BOOL TTist_KEY(TTterm t);
static BOOL TTist_ON_opt(TTterm t);
static BOOL TTist_DEPENDING(TTterm t);
static BOOL TTisVSC_dd_entry_integer_to_opt(TTterm t);
static BOOL TTisVSC_dd_entry_indexed_by_opt(TTterm t);
static BOOL TTisVSC_dd_entry_occurs_clause_key_star(TTterm t);
static BOOL TTist_TIMES_opt(TTterm t);
static BOOL TTist_TIMES(TTterm t);
static BOOL TTist_OCCURS(TTterm t);
static BOOL TTist_RIGHT_opt(TTterm t);
static BOOL TTist_JUST(TTterm t);
static BOOL TTist_JUSTIFIED(TTterm t);
static BOOL TTisVSC_expr_index_name_plus(TTterm t);
static BOOL TTist_BY_opt(TTterm t);
static BOOL TTist_BY(TTterm t);
static BOOL TTist_INDEXED(TTterm t);
static BOOL TTist_GLOBAL(TTterm t);
static BOOL TTist_EXTERNAL(TTterm t);
static BOOL TTisVSC_dd_entry_data_description_entry_clause_star(TTterm t);
static BOOL TTisVSC_dd_entry_alt_data_name_filler_opt(TTterm t);
static BOOL TTist_WHEN_opt(TTterm t);
static BOOL TTist_WHEN(TTterm t);
static BOOL TTist_BLANK(TTterm t);
static BOOL TTist_RIGHT(TTterm t);
static BOOL TTist_LEFT(TTterm t);
static BOOL TTist_TRAILING(TTterm t);
static BOOL TTist_LEADING(TTterm t);
static BOOL TTist_FILLER(TTterm t);
static BOOL TTist_WORKING_STORAGE(TTterm t);
static BOOL TTisVSC_dd_entry_data_description_entry_star(TTterm t);
static BOOL TTist_LINKAGE(TTterm t);
static BOOL TTisVSC_dd_entry_data_description_entry_plus(TTterm t);
static BOOL TTisVSC_data_div_file_section_entry_star(TTterm t);
static BOOL TTist_FILE(TTterm t);
static BOOL TTisVSC_data_div_linkage_section_opt(TTterm t);
static BOOL TTisVSC_data_div_working_storage_section_opt(TTterm t);
static BOOL TTisVSC_data_div_file_section_opt(TTterm t);
static BOOL TTist_DIVISION(TTterm t);
static BOOL TTist_DATA(TTterm t);
static BOOL TTist_MODE(TTterm t);
static BOOL TTist_DEBUGGING(TTterm t);
static BOOL TTist_WITH_opt(TTterm t);
static BOOL TTist_WITH(TTterm t);
static BOOL TTisVSC_conf_sec_in_alphabet_name_opt(TTterm t);
static BOOL TTisVSC_conf_sec_symbolic_character_mapping_plus(TTterm t);
static BOOL TTist_CHARACTERS_opt(TTterm t);
static BOOL TTist_SYMBOLIC(TTterm t);
static BOOL TTisVSC_expr_integer_plus(TTterm t);
static BOOL TTisVSC_conf_sec_are_opt(TTterm t);
static BOOL TTisVSC_expr_symbolic_character_plus(TTterm t);
static BOOL TTisVSC_conf_sec_on_status_opt(TTterm t);
static BOOL TTisVSC_conf_sec_off_status_opt(TTterm t);
static BOOL TTisVSC_conf_sec_special_names_paragraph_clause_star(TTterm t);
static BOOL TTist_qdot_opt(TTterm t);
static BOOL TTisVSC_conf_sec_special_names_paragraph_phrase_star(TTterm t);
static BOOL TTist_SPECIAL_NAMES(TTterm t);
static BOOL TTisVSC_conf_sec_source_computer_name_opt(TTterm t);
static BOOL TTist_SOURCE_COMPUTER(TTterm t);
static BOOL TTisVSC_conf_sec_with_debugging_mode_opt(TTterm t);
static BOOL TTist_SEGMENT_LIMIT(TTterm t);
static BOOL TTist_SEQUENCE(TTterm t);
static BOOL TTist_COLLATING_opt(TTterm t);
static BOOL TTist_COLLATING(TTterm t);
static BOOL TTist_PROGRAM_opt(TTterm t);
static BOOL TTist_PROGRAM(TTterm t);
static BOOL TTist_ON(TTterm t);
static BOOL TTist_STATUS_opt(TTterm t);
static BOOL TTist_STATUS(TTterm t);
static BOOL TTist_OFF(TTterm t);
static BOOL TTisVSC_conf_sec_segment_limit_opt(TTterm t);
static BOOL TTisVSC_conf_sec_program_collating_sequence_opt(TTterm t);
static BOOL TTisVSC_conf_sec_object_computer_name_opt(TTterm t);
static BOOL TTist_OBJECT_COMPUTER(TTterm t);
static BOOL TTisVSC_conf_sec_memory_size_opt(TTterm t);
static BOOL TTist_MODULES(TTterm t);
static BOOL TTist_CHARACTERS(TTterm t);
static BOOL TTist_WORDS(TTterm t);
static BOOL TTist_SIZE_opt(TTterm t);
static BOOL TTist_SIZE(TTterm t);
static BOOL TTist_MEMORY(TTterm t);
static BOOL TTisVSC_conf_sec_special_names_paragraph_status_phrase_opt(TTterm t);
static BOOL TTist_IN(TTterm t);
static BOOL TTist_COMMA(TTterm t);
static BOOL TTist_DECIMAL_POINT(TTterm t);
static BOOL TTist_SIGN_opt(TTterm t);
static BOOL TTist_SIGN(TTterm t);
static BOOL TTist_CURRENCY(TTterm t);
static BOOL TTisVSC_conf_sec_configuration_section_paragraph_star(TTterm t);
static BOOL TTist_qdot(TTterm t);
static BOOL TTist_SECTION(TTterm t);
static BOOL TTist_CONFIGURATION(TTterm t);
static BOOL TTisVSC_expr_literal_through_literal_plus(TTterm t);
static BOOL TTist_CLASS(TTterm t);
static BOOL TTist_ARE(TTterm t);
static BOOL TTisVSC_conf_sec_alphabet_type_other_plus(TTterm t);
static BOOL TTisVSC_conf_sec_alphabet_type_also_through_opt(TTterm t);
static BOOL TTisVSC_conf_sec_alphabet_type_also_plus(TTterm t);
static BOOL TTist_ALSO(TTterm t);
static BOOL TTist_EBCDIC(TTterm t);
static BOOL TTist_NATIVE(TTterm t);
static BOOL TTist_STANDARD_2(TTterm t);
static BOOL TTist_STANDARD_1(TTterm t);
static BOOL TTist_ALPHABET(TTterm t);
static BOOL TTist_THEN_opt(TTterm t);
static BOOL TTist_THEN(TTterm t);
static BOOL TTist_qpclose(TTterm t);
static BOOL TTist_qpopen(TTterm t);
static BOOL TTist_ZEROS(TTterm t);
static BOOL TTist_ZEROES(TTterm t);
static BOOL TTist_ZERO(TTterm t);
static BOOL TTist_NEGATIVE(TTterm t);
static BOOL TTist_POSITIVE(TTterm t);
static BOOL TTist_qequal(TTterm t);
static BOOL TTist_NOT_opt(TTterm t);
static BOOL TTist_IS_opt(TTterm t);
static BOOL TTist_IS(TTterm t);
static BOOL TTist_qlt(TTterm t);
static BOOL TTist_LESS(TTterm t);
static BOOL TTist_NOT(TTterm t);
static BOOL TTist_qgt_qequal(TTterm t);
static BOOL TTist_THAN_opt(TTterm t);
static BOOL TTist_THAN(TTterm t);
static BOOL TTist_qgt(TTterm t);
static BOOL TTist_TO_opt(TTterm t);
static BOOL TTist_TO(TTterm t);
static BOOL TTist_EQUAL(TTterm t);
static BOOL TTist_GREATER(TTterm t);
static BOOL TTisVSC_expr_subscript_parentheses_star(TTterm t);
static BOOL TTisVSC_expr_in_data_or_file_or_mnemonic_name_star(TTterm t);
static BOOL TTisVSC_cond_and_or_combinable_condition_plus(TTterm t);
static BOOL TTist_KANJI(TTterm t);
static BOOL TTist_DBCS(TTterm t);
static BOOL TTist_ALPHABETIC_UPPER(TTterm t);
static BOOL TTist_ALPHABETIC_LOWER(TTterm t);
static BOOL TTist_ALPHABETIC(TTterm t);
static BOOL TTist_NUMERIC(TTterm t);
static BOOL TTisVSC_cond_relational_operator_opt(TTterm t);
static BOOL TTist_OR(TTterm t);
static BOOL TTist_AND(TTterm t);

static BOOL
TTist_END_WRITE_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_WRITE);
}

static BOOL
TTist_END_WRITE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-WRITE");
}

static BOOL
TTisVSC_stat_advancing_phrase_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_advancing_phrase);
}

static BOOL
TTist_WRITE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "WRITE");
}

static BOOL
TTisVSC_stat_not_at_end_of_page_statement_list_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_not_at_end_of_page_statement_list);
}

static BOOL
TTisVSC_stat_at_end_of_page_statement_list_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_at_end_of_page_statement_list);
}

static BOOL
TTist_TEST(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "TEST");
}

static BOOL
TTist_ORDER_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_ORDER);
}

static BOOL
TTist_ORDER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ORDER");
}

static BOOL
TTisVSC_stat_when_phrase_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_when_phrase);
}

static BOOL
TTisVSC_stat_when_phrase_also_phrase_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_stat_when_phrase_also_phrase);
}

static BOOL
TTist_OTHER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "OTHER");
}

static BOOL
TTisVSC_stat_parameter_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_parameter);
}

static BOOL
TTisVSC_stat_alt_file_reel_unit_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_alt_file_reel_unit);
}

static BOOL
TTisVSC_stat_alt_beginning_ending_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_alt_beginning_ending);
}

static BOOL
TTist_STANDARD_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_STANDARD);
}

static BOOL
TTist_GLOBAL_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_GLOBAL);
}

static BOOL
TTist_USE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "USE");
}

static BOOL
TTist_UPON(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "UPON");
}

static BOOL
TTisVSC_stat_count_in_identifier_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_count_in_identifier);
}

static BOOL
TTisVSC_stat_delimiter_in_identifier_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_delimiter_in_identifier);
}

static BOOL
TTist_END_UNSTRING_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_UNSTRING);
}

static BOOL
TTist_END_UNSTRING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-UNSTRING");
}

static BOOL
TTisVSC_stat_tallying_in_identifier_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_tallying_in_identifier);
}

static BOOL
TTisVSC_stat_unstring_statement_dst_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_unstring_statement_dst);
}

static BOOL
TTisVSC_stat_delimited_by_all_phrase_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_delimited_by_all_phrase);
}

static BOOL
TTist_UNSTRING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "UNSTRING");
}

static BOOL
TTisVSC_stat_tallying_for_id_or_lit_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_tallying_for_id_or_lit);
}

static BOOL
TTisVSC_stat_tallying_for_argument_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_tallying_for_argument);
}

static BOOL
TTist_END_SUBTRACT_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_SUBTRACT);
}

static BOOL
TTist_END_SUBTRACT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-SUBTRACT");
}

static BOOL
TTist_SUBTRACT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SUBTRACT");
}

static BOOL
TTist_END_STRING_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_STRING);
}

static BOOL
TTist_END_STRING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-STRING");
}

static BOOL
TTisVSC_stat_not_on_overflow_statement_list_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_not_on_overflow_statement_list);
}

static BOOL
TTisVSC_stat_with_pointer_identifier_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_with_pointer_identifier);
}

static BOOL
TTisVSC_stat_delimited_by_phrase_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_delimited_by_phrase);
}

static BOOL
TTist_STRING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "STRING");
}

static BOOL
TTist_STOP(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "STOP");
}

static BOOL
TTisVSC_stat_statement_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_statement);
}

static BOOL
TTist_END_START_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_START);
}

static BOOL
TTist_END_START(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-START");
}

static BOOL
TTisVSC_stat_key_is_rel_op_qualified_data_name_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_key_is_rel_op_qualified_data_name);
}

static BOOL
TTist_START(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "START");
}

static BOOL
TTisVSC_stat_with_duplicates_in_order_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_with_duplicates_in_order);
}

static BOOL
TTisVSC_stat_on_key_is_phrase_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_on_key_is_phrase);
}

static BOOL
TTisVSC_stat_set_statement_phrase_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_set_statement_phrase);
}

static BOOL
TTist_SET(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SET");
}

static BOOL
TTisVSC_stat_search_statement_condition_tail_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_stat_search_statement_condition_tail);
}

static BOOL
TTist_END_SEARCH_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_SEARCH);
}

static BOOL
TTist_END_SEARCH(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-SEARCH");
}

static BOOL
TTisVSC_stat_when_condition_stats_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_when_condition_stats);
}

static BOOL
TTisVSC_stat_varying_identifier_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_varying_identifier);
}

static BOOL
TTist_SEARCH(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SEARCH");
}

static BOOL
TTist_END_REWRITE_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_REWRITE);
}

static BOOL
TTist_END_REWRITE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-REWRITE");
}

static BOOL
TTist_REWRITE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "REWRITE");
}

static BOOL
TTist_END_RETURN_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_RETURN);
}

static BOOL
TTist_END_RETURN(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-RETURN");
}

static BOOL
TTist_RETURN(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "RETURN");
}

static BOOL
TTisVSC_stat_from_identifier_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_from_identifier);
}

static BOOL
TTist_RELEASE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "RELEASE");
}

static BOOL
TTisVSC_stat_by_reference_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_by_reference);
}

static BOOL
TTist_END_READ_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_READ);
}

static BOOL
TTist_END_READ(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-READ");
}

static BOOL
TTisVSC_stat_not_at_end_statement_list_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_not_at_end_statement_list);
}

static BOOL
TTisVSC_stat_at_end_statement_list_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_at_end_statement_list);
}

static BOOL
TTisVSC_stat_key_is_qualified_data_name_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_key_is_qualified_data_name);
}

static BOOL
TTisVSC_stat_into_identifier_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_into_identifier);
}

static BOOL
TTist_NEXT_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_NEXT);
}

static BOOL
TTist_READ(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "READ");
}

static BOOL
TTist_PROCEED(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "PROCEED");
}

static BOOL
TTisVSC_stat_proceed_to_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_proceed_to);
}

static BOOL
TTisVSC_stat_with_test_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_with_test);
}

static BOOL
TTisVSC_stat_perform_after_phrase_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_stat_perform_after_phrase);
}

static BOOL
TTist_END_PERFORM(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-PERFORM");
}

static BOOL
TTist_PERFORM(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "PERFORM");
}

static BOOL
TTist_UNTIL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "UNTIL");
}

static BOOL
TTist_PAGE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "PAGE");
}

static BOOL
TTisVSC_stat_with_no_rewind_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_with_no_rewind);
}

static BOOL
TTisVSC_stat_open_statement_output_file_name_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_open_statement_output_file_name);
}

static BOOL
TTisVSC_stat_alt_reversed_with_no_rewind_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_alt_reversed_with_no_rewind);
}

static BOOL
TTisVSC_stat_open_statement_input_file_name_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_open_statement_input_file_name);
}

static BOOL
TTisVSC_stat_open_statement_phrase_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_open_statement_phrase);
}

static BOOL
TTist_OPEN(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "OPEN");
}

static BOOL
TTisVSC_stat_key_is_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_key_is);
}

static BOOL
TTisVSC_stat_lines_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_lines);
}

static BOOL
TTist_OVERFLOW(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "OVERFLOW");
}

static BOOL
TTist_REWIND(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "REWIND");
}

static BOOL
TTist_NO(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "NO");
}

static BOOL
TTist_SENTENCE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SENTENCE");
}

static BOOL
TTist_NEXT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "NEXT");
}

static BOOL
TTist_END_MULTIPLY_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_MULTIPLY);
}

static BOOL
TTist_END_MULTIPLY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-MULTIPLY");
}

static BOOL
TTist_MULTIPLY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "MULTIPLY");
}

static BOOL
TTist_MOVE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "MOVE");
}

static BOOL
TTisVSC_stat_collating_sequence_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_collating_sequence);
}

static BOOL
TTisVSC_stat_on_key_phrase_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_on_key_phrase);
}

static BOOL
TTist_MERGE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "MERGE");
}

static BOOL
TTist_LINE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "LINE");
}

static BOOL
TTist_INVALID(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "INVALID");
}

static BOOL
TTisVSC_stat_inspect_replacing_phrase_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_inspect_replacing_phrase);
}

static BOOL
TTist_CONVERTING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CONVERTING");
}

static BOOL
TTisVSC_stat_tallying_argument_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_tallying_argument);
}

static BOOL
TTist_TALLYING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "TALLYING");
}

static BOOL
TTist_INSPECT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "INSPECT");
}

static BOOL
TTisVSC_stat_inspect_replacing_argument_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_inspect_replacing_argument);
}

static BOOL
TTisVSC_stat_before_after_phrase_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_stat_before_after_phrase);
}

static BOOL
TTisVSC_stat_through_procedure_name_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_through_procedure_name);
}

static BOOL
TTisVSC_stat_initialize_replacing_phrase_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_initialize_replacing_phrase);
}

static BOOL
TTisVSC_expr_identifier_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_expr_identifier);
}

static BOOL
TTist_INITIALIZE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "INITIALIZE");
}

static BOOL
TTist_EGCS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "EGCS");
}

static BOOL
TTist_NUMERIC_EDITED(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "NUMERIC-EDITED");
}

static BOOL
TTist_ALPHANUMERIC_EDITED(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ALPHANUMERIC-EDITED");
}

static BOOL
TTist_ALPHANUMERIC(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ALPHANUMERIC");
}

static BOOL
TTisVSC_stat_initialize_replacing_argument_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_initialize_replacing_argument);
}

static BOOL
TTist_DATA_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_DATA);
}

static BOOL
TTist_END_IF_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_IF);
}

static BOOL
TTist_END_IF(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-IF");
}

static BOOL
TTisVSC_stat_else_phrase_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_else_phrase);
}

static BOOL
TTist_IF(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "IF");
}

static BOOL
TTist_GOBACK(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "GOBACK");
}

static BOOL
TTist_MORE_LABELS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "MORE-LABELS");
}

static BOOL
TTisVSC_expr_procedure_name_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_expr_procedure_name);
}

static BOOL
TTist_REMOVAL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "REMOVAL");
}

static BOOL
TTist_EXIT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "EXIT");
}

static BOOL
TTist_END_EVALUATE_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_EVALUATE);
}

static BOOL
TTist_END_EVALUATE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-EVALUATE");
}

static BOOL
TTisVSC_stat_when_other_phrase_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_when_other_phrase);
}

static BOOL
TTisVSC_stat_when_phrases_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_when_phrases);
}

static BOOL
TTisVSC_stat_also_phrase_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_stat_also_phrase);
}

static BOOL
TTist_EVALUATE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "EVALUATE");
}

static BOOL
TTist_ANY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ANY");
}

static BOOL
TTist_FALSE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "FALSE");
}

static BOOL
TTist_TRUE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "TRUE");
}

static BOOL
TTist_ENTRY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ENTRY");
}

static BOOL
TTist_EOP(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "EOP");
}

static BOOL
TTist_END_OF_PAGE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-OF-PAGE");
}

static BOOL
TTist_ELSE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ELSE");
}

static BOOL
TTist_REMAINDER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "REMAINDER");
}

static BOOL
TTist_END_DIVIDE_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_DIVIDE);
}

static BOOL
TTist_END_DIVIDE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-DIVIDE");
}

static BOOL
TTist_INTO(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "INTO");
}

static BOOL
TTist_DIVIDE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DIVIDE");
}

static BOOL
TTisVSC_stat_with_no_advancing_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_with_no_advancing);
}

static BOOL
TTisVSC_stat_upon_environment_name_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_upon_environment_name);
}

static BOOL
TTisVSC_stat_or_all_id_or_lit_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_stat_or_all_id_or_lit);
}

static BOOL
TTist_ALL_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_ALL);
}

static BOOL
TTist_DELIMITED(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DELIMITED");
}

static BOOL
TTist_END_DELETE_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_DELETE);
}

static BOOL
TTist_END_DELETE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-DELETE");
}

static BOOL
TTisVSC_stat_not_invalid_key_statement_list_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_not_invalid_key_statement_list);
}

static BOOL
TTisVSC_stat_invalid_key_statement_list_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_invalid_key_statement_list);
}

static BOOL
TTist_DELETE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DELETE");
}

static BOOL
TTist_TIME(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "TIME");
}

static BOOL
TTist_DAY_OF_WEEK(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DAY-OF-WEEK");
}

static BOOL
TTist_DAY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DAY");
}

static BOOL
TTist_DATE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DATE");
}

static BOOL
TTist_COUNT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COUNT");
}

static BOOL
TTist_CORR(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CORR");
}

static BOOL
TTist_CORRESPONDING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CORRESPONDING");
}

static BOOL
TTist_CONTINUE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CONTINUE");
}

static BOOL
TTisVSC_stat_content_parameter_value_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_content_parameter_value);
}

static BOOL
TTist_CONTENT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CONTENT");
}

static BOOL
TTist_END_COMPUTE_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_COMPUTE);
}

static BOOL
TTist_END_COMPUTE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-COMPUTE");
}

static BOOL
TTist_COMPUTE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COMPUTE");
}

static BOOL
TTisVSC_stat_alt_removal_no_rewind_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_alt_removal_no_rewind);
}

static BOOL
TTisVSC_stat_close_statement_options_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_close_statement_options);
}

static BOOL
TTisVSC_stat_close_statement_file_name_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_close_statement_file_name);
}

static BOOL
TTist_CLOSE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CLOSE");
}

static BOOL
TTist_CANCEL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CANCEL");
}

static BOOL
TTist_END_CALL_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_CALL);
}

static BOOL
TTist_END_CALL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-CALL");
}

static BOOL
TTisVSC_stat_using_parameters_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_using_parameters);
}

static BOOL
TTist_CALL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CALL");
}

static BOOL
TTisVSC_stat_on_overflow_statement_list_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_on_overflow_statement_list);
}

static BOOL
TTisVSC_stat_not_on_exception_statement_list_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_not_on_exception_statement_list);
}

static BOOL
TTisVSC_stat_on_exception_statement_list_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_on_exception_statement_list);
}

static BOOL
TTist_REFERENCE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "REFERENCE");
}

static BOOL
TTisVSC_stat_procedure_to_procedure_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_procedure_to_procedure);
}

static BOOL
TTist_ALTER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ALTER");
}

static BOOL
TTist_DOWN(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DOWN");
}

static BOOL
TTist_UP(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "UP");
}

static BOOL
TTist_RUN(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "RUN");
}

static BOOL
TTist_REVERSED(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "REVERSED");
}

static BOOL
TTist_LOCK(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "LOCK");
}

static BOOL
TTist_EXTEND(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "EXTEND");
}

static BOOL
TTist_I_O(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "I-O");
}

static BOOL
TTist_OUTPUT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "OUTPUT");
}

static BOOL
TTist_INPUT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "INPUT");
}

static BOOL
TTist_ERROR(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ERROR");
}

static BOOL
TTist_EXCEPTION(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "EXCEPTION");
}

static BOOL
TTist_ENDING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ENDING");
}

static BOOL
TTist_BEGINNING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "BEGINNING");
}

static BOOL
TTist_AFTER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "AFTER");
}

static BOOL
TTist_BEFORE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "BEFORE");
}

static BOOL
TTist_FIRST(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "FIRST");
}

static BOOL
TTist_PROCEDURES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "PROCEDURES");
}

static BOOL
TTist_ADVANCING_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_ADVANCING);
}

static BOOL
TTist_ADVANCING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ADVANCING");
}

static BOOL
TTist_ROUNDED_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_ROUNDED);
}

static BOOL
TTist_ROUNDED(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ROUNDED");
}

static BOOL
TTist_GIVING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "GIVING");
}

static BOOL
TTisVSC_stat_to_id_or_lit_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_to_id_or_lit);
}

static BOOL
TTist_END_ADD_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_END_ADD);
}

static BOOL
TTist_END_ADD(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END-ADD");
}

static BOOL
TTisVSC_stat_not_on_size_error_statement_list_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_not_on_size_error_statement_list);
}

static BOOL
TTisVSC_stat_on_size_error_statement_list_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_on_size_error_statement_list);
}

static BOOL
TTisVSC_stat_cobword_rounded_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_cobword_rounded);
}

static BOOL
TTisVSC_stat_id_or_lit_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_stat_id_or_lit);
}

static BOOL
TTist_ADD(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ADD");
}

static BOOL
TTisVSC_stat_from_environment_name_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_from_environment_name);
}

static BOOL
TTist_ACCEPT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ACCEPT");
}

static BOOL
TTisVSC_proc_div_using_data_names_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_proc_div_using_data_names);
}

static BOOL
TTisVSC_stat_using_data_name_pluslist_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_using_data_name_pluslist);
}

static BOOL
TTisVSC_expr_data_name_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_expr_data_name);
}

static BOOL
TTist_USING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "USING");
}

static BOOL
TTisVSC_stat_statement_list_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_stat_statement_list);
}

static BOOL
TTist_qdot_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTist_qdot);
}

static BOOL
TTisVSC_proc_div_section_with_header_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_proc_div_section_with_header);
}

static BOOL
TTisVSC_expr_priority_number_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_expr_priority_number);
}

static BOOL
TTisVSC_proc_div_declaratives_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_proc_div_declaratives);
}

static BOOL
TTist_PROCEDURE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "PROCEDURE");
}

static BOOL
TTisVSC_proc_div_paragraph_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_proc_div_paragraph);
}

static BOOL
TTisVSC_proc_div_sentence_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_proc_div_sentence);
}

static BOOL
TTisVSC_proc_div_declaratives_content_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_proc_div_declaratives_content);
}

static BOOL
TTist_DECLARATIVES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DECLARATIVES");
}

static BOOL
TTist_GO(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "GO");
}

static BOOL
TTisVSC_main_cobol_source_program_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_main_cobol_source_program);
}

static BOOL
TTisVSC_main_common_initial_program_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_main_common_initial_program);
}

static BOOL
TTisVSC_main_nested_cobol_source_program_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_main_nested_cobol_source_program);
}

static BOOL
TTisVSC_id_div_identification_division_content_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_id_div_identification_division_content);
}

static BOOL
TTist_COMMON_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_COMMON);
}

static BOOL
TTist_INITIAL_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_INITIAL);
}

static BOOL
TTist_COMMON(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COMMON");
}

static BOOL
TTisVSC_main_nested_program_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_main_nested_program);
}

static BOOL
TTisVSC_proc_div_procedure_division_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_proc_div_procedure_division);
}

static BOOL
TTisVSC_data_div_data_division_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_data_div_data_division);
}

static BOOL
TTisVSC_env_div_environment_division_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_env_div_environment_division);
}

static BOOL
TTist_DUPLICATES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DUPLICATES");
}

static BOOL
TTisVSC_io_sec_same_area_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_io_sec_same_area);
}

static BOOL
TTisVSC_io_sec_rerun_on_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_io_sec_rerun_on);
}

static BOOL
TTist_OPTIONAL_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_OPTIONAL);
}

static BOOL
TTist_OPTIONAL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "OPTIONAL");
}

static BOOL
TTist_SELECT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SELECT");
}

static BOOL
TTisVSC_io_sec_areas_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_io_sec_areas);
}

static BOOL
TTist_RESERVE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "RESERVE");
}

static BOOL
TTist_SORT_MERGE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SORT-MERGE");
}

static BOOL
TTist_SORT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SORT");
}

static BOOL
TTist_DELIMITER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DELIMITER");
}

static BOOL
TTist_WRITE_ONLY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "WRITE-ONLY");
}

static BOOL
TTist_APPLY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "APPLY");
}

static BOOL
TTisVSC_io_sec_file_name_position_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_io_sec_file_name_position);
}

static BOOL
TTist_TAPE_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_TAPE);
}

static BOOL
TTist_TAPE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "TAPE");
}

static BOOL
TTist_MULTIPLE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "MULTIPLE");
}

static BOOL
TTisVSC_expr_file_name_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_expr_file_name);
}

static BOOL
TTist_FOR_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_FOR);
}

static BOOL
TTist_FOR(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "FOR");
}

static BOOL
TTist_AREA_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_AREA);
}

static BOOL
TTist_SAME(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SAME");
}

static BOOL
TTist_EVERY_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_EVERY);
}

static BOOL
TTist_EVERY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "EVERY");
}

static BOOL
TTist_RERUN(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "RERUN");
}

static BOOL
TTist_POSITION(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "POSITION");
}

static BOOL
TTist_PASSWORD(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "PASSWORD");
}

static BOOL
TTist_PADDING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "PADDING");
}

static BOOL
TTist_ORGANIZATION(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ORGANIZATION");
}

static BOOL
TTisVSC_io_sec_i_o_control_paragraph_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_io_sec_i_o_control_paragraph);
}

static BOOL
TTisVSC_io_sec_file_control_paragraph_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_io_sec_file_control_paragraph);
}

static BOOL
TTist_INPUT_OUTPUT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "INPUT-OUTPUT");
}

static BOOL
TTisVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries);
}

static BOOL
TTisVSC_io_sec_i_o_sort_merge_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_io_sec_i_o_sort_merge);
}

static BOOL
TTisVSC_io_sec_i_o_sam_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_io_sec_i_o_sam);
}

static BOOL
TTist_I_O_CONTROL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "I-O-CONTROL");
}

static BOOL
TTisVSC_expr_qualified_data_name_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_expr_qualified_data_name);
}

static BOOL
TTist_FILE_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_FILE);
}

static BOOL
TTisVSC_io_sec_position_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_io_sec_position);
}

static BOOL
TTisVSC_io_sec_file_control_entry_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_io_sec_file_control_entry);
}

static BOOL
TTist_FILE_CONTROL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "FILE-CONTROL");
}

static BOOL
TTisVSC_io_sec_fce_phrase_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_io_sec_fce_phrase);
}

static BOOL
TTisVSC_io_sec_organization_is_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_io_sec_organization_is);
}

static BOOL
TTisVSC_io_sec_relative_key_clause_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_io_sec_relative_key_clause);
}

static BOOL
TTist_ACCESS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ACCESS");
}

static BOOL
TTist_OF_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_OF);
}

static BOOL
TTist_END(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "END");
}

static BOOL
TTisVSC_io_sec_alt_assignment_name_literal_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_io_sec_alt_assignment_name_literal);
}

static BOOL
TTist_ASSIGN(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ASSIGN");
}

static BOOL
TTist_AREAS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "AREAS");
}

static BOOL
TTist_AREA(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "AREA");
}

static BOOL
TTisVSC_io_sec_with_duplicates_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_io_sec_with_duplicates);
}

static BOOL
TTisVSC_io_sec_password_clause_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_io_sec_password_clause);
}

static BOOL
TTist_RECORD_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_RECORD);
}

static BOOL
TTist_ALTERNATE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ALTERNATE");
}

static BOOL
TTist_DYNAMIC(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DYNAMIC");
}

static BOOL
TTist_RANDOM(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "RANDOM");
}

static BOOL
TTist_SEQUENTIAL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SEQUENTIAL");
}

static BOOL
TTist_RELATIVE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "RELATIVE");
}

static BOOL
TTist_SECURITY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SECURITY");
}

static BOOL
TTist_REMARKS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "REMARKS");
}

static BOOL
TTisVSC_id_div_initial_program_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_id_div_initial_program);
}

static BOOL
TTist_PROGRAM_ID(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "PROGRAM-ID");
}

static BOOL
TTist_INSTALLATION(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "INSTALLATION");
}

static BOOL
TTist_INITIAL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "INITIAL");
}

static BOOL
TTisVSC_id_div_identification_division_phrase_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_id_div_identification_division_phrase);
}

static BOOL
TTist_ID(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ID");
}

static BOOL
TTist_IDENTIFICATION(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "IDENTIFICATION");
}

static BOOL
TTist_DATE_WRITTEN(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DATE-WRITTEN");
}

static BOOL
TTist_DATE_COMPILED(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DATE-COMPILED");
}

static BOOL
TTist_AUTHOR(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "AUTHOR");
}

static BOOL
TTisVSC_fd_entry_value_of_clause_tail_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_fd_entry_value_of_clause_tail);
}

static BOOL
TTist_MODE_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_MODE);
}

static BOOL
TTist_RECORDING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "RECORDING");
}

static BOOL
TTisVSC_fd_entry_to_integer_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_fd_entry_to_integer);
}

static BOOL
TTisVSC_fd_entry_from_integer_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_fd_entry_from_integer);
}

static BOOL
TTist_IN_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_IN);
}

static BOOL
TTist_VARYING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "VARYING");
}

static BOOL
TTisVSC_fd_entry_depending_on_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_fd_entry_depending_on);
}

static BOOL
TTist_TOP(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "TOP");
}

static BOOL
TTist_BOTTOM(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "BOTTOM");
}

static BOOL
TTisVSC_fd_entry_lines_bottom_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_fd_entry_lines_bottom);
}

static BOOL
TTisVSC_fd_entry_lines_top_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_fd_entry_lines_top);
}

static BOOL
TTisVSC_fd_entry_footing_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_fd_entry_footing);
}

static BOOL
TTist_LINES_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_LINES);
}

static BOOL
TTist_LINES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "LINES");
}

static BOOL
TTist_LINAGE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "LINAGE");
}

static BOOL
TTist_OMITTED(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "OMITTED");
}

static BOOL
TTist_STANDARD(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "STANDARD");
}

static BOOL
TTist_LABEL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "LABEL");
}

static BOOL
TTist_FROM_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_FROM);
}

static BOOL
TTist_FROM(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "FROM");
}

static BOOL
TTist_AT_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_AT);
}

static BOOL
TTist_AT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "AT");
}

static BOOL
TTist_FOOTING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "FOOTING");
}

static BOOL
TTisVSC_fd_entry_file_and_sort_description_entry_clause_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_fd_entry_file_and_sort_description_entry_clause);
}

static BOOL
TTisVSC_expr_data_name_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_expr_data_name);
}

static BOOL
TTist_CODE_SET(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CODE-SET");
}

static BOOL
TTisVSC_fd_entry_alt_characters_records_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_fd_entry_alt_characters_records);
}

static BOOL
TTist_CONTAINS_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_CONTAINS);
}

static BOOL
TTist_CONTAINS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CONTAINS");
}

static BOOL
TTist_BLOCK(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "BLOCK");
}

static BOOL
TTist_SD(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SD");
}

static BOOL
TTist_FD(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "FD");
}

static BOOL
TTist_VALUES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "VALUES");
}

static BOOL
TTist_VALUE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "VALUE");
}

static BOOL
TTisVSC_expr_times_div_tail_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_expr_times_div_tail);
}

static BOOL
TTist_THRU(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "THRU");
}

static BOOL
TTist_THROUGH(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "THROUGH");
}

static BOOL
TTisVSC_expr_plus_minus_integer_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_expr_plus_minus_integer);
}

static BOOL
TTisVSC_expr_subscript_expression_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_expr_subscript_expression);
}

static BOOL
TTist_LENGTH(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "LENGTH");
}

static BOOL
TTist_ADDRESS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ADDRESS");
}

static BOOL
TTisVSC_expr_length_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_expr_length);
}

static BOOL
TTist_qcolon(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, ":");
}

static BOOL
TTist_RECORDS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "RECORDS");
}

static BOOL
TTist_RECORD(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "RECORD");
}

static BOOL
TTisVSC_expr_in_data_or_file_name_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_expr_in_data_or_file_name);
}

static BOOL
TTisVSC_expr_in_section_name_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_expr_in_section_name);
}

static BOOL
TTist_qmultiply_qmultiply(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "**");
}

static BOOL
TTisVSC_expr_power_tail_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_expr_power_tail);
}

static BOOL
TTisVSC_expr_alt_plus_minus_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_expr_alt_plus_minus);
}

static BOOL
TTisVSC_expr_through_literal_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_expr_through_literal);
}

static BOOL
TTist_OF(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "OF");
}

static BOOL
TTisVSC_expr_in_file_name_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_expr_in_file_name);
}

static BOOL
TTist_LINAGE_COUNTER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "LINAGE-COUNTER");
}

static BOOL
TTisVSC_expr_reference_modification_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_expr_reference_modification);
}

static BOOL
TTist_NULLS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "NULLS");
}

static BOOL
TTist_NULL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "NULL");
}

static BOOL
TTist_QUOTES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "QUOTES");
}

static BOOL
TTist_QUOTE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "QUOTE");
}

static BOOL
TTist_LOW_VALUES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "LOW-VALUES");
}

static BOOL
TTist_LOW_VALUE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "LOW-VALUE");
}

static BOOL
TTist_HIGH_VALUES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "HIGH-VALUES");
}

static BOOL
TTist_HIGH_VALUE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "HIGH-VALUE");
}

static BOOL
TTist_SPACES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SPACES");
}

static BOOL
TTist_SPACE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SPACE");
}

static BOOL
TTist_ALL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ALL");
}

static BOOL
TTisVSC_expr_copy_statement_by_phrase_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_expr_copy_statement_by_phrase);
}

static BOOL
TTist_REPLACING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "REPLACING");
}

static BOOL
TTisVSC_expr_copy_statement_replacing_phrase_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_expr_copy_statement_replacing_phrase);
}

static BOOL
TTist_SUPPRESS_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_SUPPRESS);
}

static BOOL
TTist_SUPPRESS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SUPPRESS");
}

static BOOL
TTisVSC_expr_in_library_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_expr_in_library);
}

static BOOL
TTist_COPY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COPY");
}

static BOOL
TTisVSC_expr_arithmetic_expression_tail_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_expr_arithmetic_expression_tail);
}

static BOOL
TTist_qdivide(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "/");
}

static BOOL
TTist_qmultiply(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "*");
}

static BOOL
TTist_UNIT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "UNIT");
}

static BOOL
TTist_REEL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "REEL");
}

static BOOL
TTist__(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "-");
}

static BOOL
TTist_qplus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "+");
}

static BOOL
TTist_DESCENDING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DESCENDING");
}

static BOOL
TTist_ASCENDING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ASCENDING");
}

static BOOL
TTisVSC_io_sec_input_output_section_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_io_sec_input_output_section);
}

static BOOL
TTisVSC_conf_sec_configuration_section_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_conf_sec_configuration_section);
}

static BOOL
TTist_ENVIRONMENT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ENVIRONMENT");
}

static BOOL
TTist_USAGE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "USAGE");
}

static BOOL
TTisVSC_dd_entry_usage_is_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_dd_entry_usage_is);
}

static BOOL
TTist_POINTER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "POINTER");
}

static BOOL
TTist_PACKED_DECIMAL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "PACKED-DECIMAL");
}

static BOOL
TTist_INDEX(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "INDEX");
}

static BOOL
TTist_DISPLAY_1(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DISPLAY-1");
}

static BOOL
TTist_DISPLAY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DISPLAY");
}

static BOOL
TTist_COMPUTATIONAL_4(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COMPUTATIONAL-4");
}

static BOOL
TTist_COMPUTATIONAL_3(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COMPUTATIONAL-3");
}

static BOOL
TTist_COMPUTATIONAL_2(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COMPUTATIONAL-2");
}

static BOOL
TTist_COMPUTATIONAL_1(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COMPUTATIONAL-1");
}

static BOOL
TTist_COMPUTATIONAL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COMPUTATIONAL");
}

static BOOL
TTist_COMP_4(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COMP-4");
}

static BOOL
TTist_COMP_3(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COMP-3");
}

static BOOL
TTist_COMP_2(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COMP-2");
}

static BOOL
TTist_COMP_1(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COMP-1");
}

static BOOL
TTist_COMP(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COMP");
}

static BOOL
TTist_BINARY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "BINARY");
}

static BOOL
TTisVSC_dd_entry_alt_left_right_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_dd_entry_alt_left_right);
}

static BOOL
TTist_SYNC(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SYNC");
}

static BOOL
TTist_SYNCHRONIZED(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SYNCHRONIZED");
}

static BOOL
TTisVSC_dd_entry_separate_character_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_dd_entry_separate_character);
}

static BOOL
TTisVSC_dd_entry_sign_is_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_dd_entry_sign_is);
}

static BOOL
TTist_CHARACTER_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_CHARACTER);
}

static BOOL
TTist_CHARACTER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CHARACTER");
}

static BOOL
TTist_SEPARATE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SEPARATE");
}

static BOOL
TTisVSC_expr_through_qualified_data_name_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_expr_through_qualified_data_name);
}

static BOOL
TTist_RENAMES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "RENAMES");
}

static BOOL
TTist_REDEFINES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "REDEFINES");
}

static BOOL
TTist_PIC(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "PIC");
}

static BOOL
TTist_PICTURE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "PICTURE");
}

static BOOL
TTisVSC_expr_qualified_data_name_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_expr_qualified_data_name);
}

static BOOL
TTist_KEY_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_KEY);
}

static BOOL
TTist_KEY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "KEY");
}

static BOOL
TTist_ON_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_ON);
}

static BOOL
TTist_DEPENDING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DEPENDING");
}

static BOOL
TTisVSC_dd_entry_integer_to_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_dd_entry_integer_to);
}

static BOOL
TTisVSC_dd_entry_indexed_by_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_dd_entry_indexed_by);
}

static BOOL
TTisVSC_dd_entry_occurs_clause_key_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_dd_entry_occurs_clause_key);
}

static BOOL
TTist_TIMES_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_TIMES);
}

static BOOL
TTist_TIMES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "TIMES");
}

static BOOL
TTist_OCCURS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "OCCURS");
}

static BOOL
TTist_RIGHT_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_RIGHT);
}

static BOOL
TTist_JUST(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "JUST");
}

static BOOL
TTist_JUSTIFIED(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "JUSTIFIED");
}

static BOOL
TTisVSC_expr_index_name_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_expr_index_name);
}

static BOOL
TTist_BY_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_BY);
}

static BOOL
TTist_BY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "BY");
}

static BOOL
TTist_INDEXED(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "INDEXED");
}

static BOOL
TTist_GLOBAL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "GLOBAL");
}

static BOOL
TTist_EXTERNAL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "EXTERNAL");
}

static BOOL
TTisVSC_dd_entry_data_description_entry_clause_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_dd_entry_data_description_entry_clause);
}

static BOOL
TTisVSC_dd_entry_alt_data_name_filler_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_dd_entry_alt_data_name_filler);
}

static BOOL
TTist_WHEN_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_WHEN);
}

static BOOL
TTist_WHEN(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "WHEN");
}

static BOOL
TTist_BLANK(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "BLANK");
}

static BOOL
TTist_RIGHT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "RIGHT");
}

static BOOL
TTist_LEFT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "LEFT");
}

static BOOL
TTist_TRAILING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "TRAILING");
}

static BOOL
TTist_LEADING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "LEADING");
}

static BOOL
TTist_FILLER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "FILLER");
}

static BOOL
TTist_WORKING_STORAGE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "WORKING-STORAGE");
}

static BOOL
TTisVSC_dd_entry_data_description_entry_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_dd_entry_data_description_entry);
}

static BOOL
TTist_LINKAGE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "LINKAGE");
}

static BOOL
TTisVSC_dd_entry_data_description_entry_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_dd_entry_data_description_entry);
}

static BOOL
TTisVSC_data_div_file_section_entry_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_data_div_file_section_entry);
}

static BOOL
TTist_FILE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "FILE");
}

static BOOL
TTisVSC_data_div_linkage_section_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_data_div_linkage_section);
}

static BOOL
TTisVSC_data_div_working_storage_section_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_data_div_working_storage_section);
}

static BOOL
TTisVSC_data_div_file_section_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_data_div_file_section);
}

static BOOL
TTist_DIVISION(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DIVISION");
}

static BOOL
TTist_DATA(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DATA");
}

static BOOL
TTist_MODE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "MODE");
}

static BOOL
TTist_DEBUGGING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DEBUGGING");
}

static BOOL
TTist_WITH_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_WITH);
}

static BOOL
TTist_WITH(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "WITH");
}

static BOOL
TTisVSC_conf_sec_in_alphabet_name_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_conf_sec_in_alphabet_name);
}

static BOOL
TTisVSC_conf_sec_symbolic_character_mapping_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_conf_sec_symbolic_character_mapping);
}

static BOOL
TTist_CHARACTERS_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_CHARACTERS);
}

static BOOL
TTist_SYMBOLIC(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SYMBOLIC");
}

static BOOL
TTisVSC_expr_integer_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_expr_integer);
}

static BOOL
TTisVSC_conf_sec_are_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_conf_sec_are);
}

static BOOL
TTisVSC_expr_symbolic_character_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_expr_symbolic_character);
}

static BOOL
TTisVSC_conf_sec_on_status_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_conf_sec_on_status);
}

static BOOL
TTisVSC_conf_sec_off_status_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_conf_sec_off_status);
}

static BOOL
TTisVSC_conf_sec_special_names_paragraph_clause_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_conf_sec_special_names_paragraph_clause);
}

static BOOL
TTist_qdot_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_qdot);
}

static BOOL
TTisVSC_conf_sec_special_names_paragraph_phrase_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_conf_sec_special_names_paragraph_phrase);
}

static BOOL
TTist_SPECIAL_NAMES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SPECIAL-NAMES");
}

static BOOL
TTisVSC_conf_sec_source_computer_name_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_conf_sec_source_computer_name);
}

static BOOL
TTist_SOURCE_COMPUTER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SOURCE-COMPUTER");
}

static BOOL
TTisVSC_conf_sec_with_debugging_mode_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_conf_sec_with_debugging_mode);
}

static BOOL
TTist_SEGMENT_LIMIT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SEGMENT-LIMIT");
}

static BOOL
TTist_SEQUENCE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SEQUENCE");
}

static BOOL
TTist_COLLATING_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_COLLATING);
}

static BOOL
TTist_COLLATING(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COLLATING");
}

static BOOL
TTist_PROGRAM_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_PROGRAM);
}

static BOOL
TTist_PROGRAM(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "PROGRAM");
}

static BOOL
TTist_ON(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ON");
}

static BOOL
TTist_STATUS_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_STATUS);
}

static BOOL
TTist_STATUS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "STATUS");
}

static BOOL
TTist_OFF(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "OFF");
}

static BOOL
TTisVSC_conf_sec_segment_limit_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_conf_sec_segment_limit);
}

static BOOL
TTisVSC_conf_sec_program_collating_sequence_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_conf_sec_program_collating_sequence);
}

static BOOL
TTisVSC_conf_sec_object_computer_name_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_conf_sec_object_computer_name);
}

static BOOL
TTist_OBJECT_COMPUTER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "OBJECT-COMPUTER");
}

static BOOL
TTisVSC_conf_sec_memory_size_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_conf_sec_memory_size);
}

static BOOL
TTist_MODULES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "MODULES");
}

static BOOL
TTist_CHARACTERS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CHARACTERS");
}

static BOOL
TTist_WORDS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "WORDS");
}

static BOOL
TTist_SIZE_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_SIZE);
}

static BOOL
TTist_SIZE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SIZE");
}

static BOOL
TTist_MEMORY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "MEMORY");
}

static BOOL
TTisVSC_conf_sec_special_names_paragraph_status_phrase_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_conf_sec_special_names_paragraph_status_phrase);
}

static BOOL
TTist_IN(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "IN");
}

static BOOL
TTist_COMMA(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "COMMA");
}

static BOOL
TTist_DECIMAL_POINT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DECIMAL-POINT");
}

static BOOL
TTist_SIGN_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_SIGN);
}

static BOOL
TTist_SIGN(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SIGN");
}

static BOOL
TTist_CURRENCY(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CURRENCY");
}

static BOOL
TTisVSC_conf_sec_configuration_section_paragraph_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_conf_sec_configuration_section_paragraph);
}

static BOOL
TTist_qdot(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, ".");
}

static BOOL
TTist_SECTION(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "SECTION");
}

static BOOL
TTist_CONFIGURATION(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CONFIGURATION");
}

static BOOL
TTisVSC_expr_literal_through_literal_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_expr_literal_through_literal);
}

static BOOL
TTist_CLASS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "CLASS");
}

static BOOL
TTist_ARE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ARE");
}

static BOOL
TTisVSC_conf_sec_alphabet_type_other_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_conf_sec_alphabet_type_other);
}

static BOOL
TTisVSC_conf_sec_alphabet_type_also_through_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_conf_sec_alphabet_type_also_through);
}

static BOOL
TTisVSC_conf_sec_alphabet_type_also_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_conf_sec_alphabet_type_also);
}

static BOOL
TTist_ALSO(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ALSO");
}

static BOOL
TTist_EBCDIC(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "EBCDIC");
}

static BOOL
TTist_NATIVE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "NATIVE");
}

static BOOL
TTist_STANDARD_2(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "STANDARD-2");
}

static BOOL
TTist_STANDARD_1(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "STANDARD-1");
}

static BOOL
TTist_ALPHABET(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ALPHABET");
}

static BOOL
TTist_THEN_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_THEN);
}

static BOOL
TTist_THEN(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "THEN");
}

static BOOL
TTist_qpclose(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, ")");
}

static BOOL
TTist_qpopen(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "(");
}

static BOOL
TTist_ZEROS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ZEROS");
}

static BOOL
TTist_ZEROES(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ZEROES");
}

static BOOL
TTist_ZERO(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ZERO");
}

static BOOL
TTist_NEGATIVE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "NEGATIVE");
}

static BOOL
TTist_POSITIVE(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "POSITIVE");
}

static BOOL
TTist_qequal(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "=");
}

static BOOL
TTist_NOT_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_NOT);
}

static BOOL
TTist_IS_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_IS);
}

static BOOL
TTist_IS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "IS");
}

static BOOL
TTist_qlt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "<");
}

static BOOL
TTist_LESS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "LESS");
}

static BOOL
TTist_NOT(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "NOT");
}

static BOOL
TTist_qgt_qequal(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, ">=");
}

static BOOL
TTist_THAN_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_THAN);
}

static BOOL
TTist_THAN(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "THAN");
}

static BOOL
TTist_qgt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, ">");
}

static BOOL
TTist_TO_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTist_TO);
}

static BOOL
TTist_TO(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "TO");
}

static BOOL
TTist_EQUAL(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "EQUAL");
}

static BOOL
TTist_GREATER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "GREATER");
}

static BOOL
TTisVSC_expr_subscript_parentheses_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_expr_subscript_parentheses);
}

static BOOL
TTisVSC_expr_in_data_or_file_or_mnemonic_name_star(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_star(t, TTisVSC_expr_in_data_or_file_or_mnemonic_name);
}

static BOOL
TTisVSC_cond_and_or_combinable_condition_plus(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_plus(t, TTisVSC_cond_and_or_combinable_condition);
}

static BOOL
TTist_KANJI(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "KANJI");
}

static BOOL
TTist_DBCS(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "DBCS");
}

static BOOL
TTist_ALPHABETIC_UPPER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ALPHABETIC-UPPER");
}

static BOOL
TTist_ALPHABETIC_LOWER(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ALPHABETIC-LOWER");
}

static BOOL
TTist_ALPHABETIC(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "ALPHABETIC");
}

static BOOL
TTist_NUMERIC(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "NUMERIC");
}

static BOOL
TTisVSC_cond_relational_operator_opt(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_optional(t, TTisVSC_cond_relational_operator);
}

static BOOL
TTist_OR(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "OR");
}

static BOOL
TTist_AND(TTterm t)
{
    t = TTunsandwich(t);
    return TTtypecheck_literal(t, "AND");
}

BOOL
TTisVSC_cond_alt_and_or(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_alt_and_or;
}

BOOL
TTisVSC_cond_and_or_combinable_condition(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_and_or_combinable_condition;
}

BOOL
TTisVSC_cond_class_condition(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_class_condition;
}

BOOL
TTisVSC_cond_class_type(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_class_type;
}

BOOL
TTisVSC_cond_combinable_condition(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_combinable_condition;
}

BOOL
TTisVSC_cond_combined_conditions(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_combined_conditions;
}

BOOL
TTisVSC_cond_condition(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_condition;
}

BOOL
TTisVSC_cond_condition_name_reference(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_condition_name_reference;
}

BOOL
TTisVSC_cond_greater(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_greater;
}

BOOL
TTisVSC_cond_greater_equal(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_greater_equal;
}

BOOL
TTisVSC_cond_greater_than(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_greater_than;
}

BOOL
TTisVSC_cond_greater_than_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_greater_than_1;
}

BOOL
TTisVSC_cond_greater_than_or_equal_to(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_greater_than_or_equal_to;
}

BOOL
TTisVSC_cond_greater_than_or_equal_to_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_greater_than_or_equal_to_1;
}

BOOL
TTisVSC_cond_greater_than_or_equal_to_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_greater_than_or_equal_to_2;
}

BOOL
TTisVSC_cond_greater_than_or_equal_to_3(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_greater_than_or_equal_to_3;
}

BOOL
TTisVSC_cond_is_not(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_is_not;
}

BOOL
TTisVSC_cond_is_or_is_not(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_is_or_is_not;
}

BOOL
TTisVSC_cond_less(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_less;
}

BOOL
TTisVSC_cond_less_equal(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_less_equal;
}

BOOL
TTisVSC_cond_less_equal_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_less_equal_2;
}

BOOL
TTisVSC_cond_negated_simple_conditions(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_negated_simple_conditions;
}

BOOL
TTisVSC_cond_not_is(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_not_is;
}

BOOL
TTisVSC_cond_not_relational_operator_rest(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_not_relational_operator_rest;
}

BOOL
TTisVSC_cond_relation_condition(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_relation_condition;
}

BOOL
TTisVSC_cond_relational_operator(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_relational_operator;
}

BOOL
TTisVSC_cond_relational_operator_rest(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_relational_operator_rest;
}

BOOL
TTisVSC_cond_relational_operator_tail(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_relational_operator_tail;
}

BOOL
TTisVSC_cond_sign_condition(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_sign_condition;
}

BOOL
TTisVSC_cond_sign_type(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_sign_type;
}

BOOL
TTisVSC_cond_simple_condition(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_simple_condition;
}

BOOL
TTisVSC_cond_simple_condition_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_simple_condition_1;
}

BOOL
TTisVSC_cond_than(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_cond_than;
}

BOOL
TTisVSC_conf_sec_alphabet_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_alphabet_clause;
}

BOOL
TTisVSC_conf_sec_alphabet_type(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_alphabet_type;
}

BOOL
TTisVSC_conf_sec_alphabet_type_also(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_alphabet_type_also;
}

BOOL
TTisVSC_conf_sec_alphabet_type_also_through(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_alphabet_type_also_through;
}

BOOL
TTisVSC_conf_sec_alphabet_type_alsos(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_alphabet_type_alsos;
}

BOOL
TTisVSC_conf_sec_alphabet_type_other(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_alphabet_type_other;
}

BOOL
TTisVSC_conf_sec_alphabet_type_others(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_alphabet_type_others;
}

BOOL
TTisVSC_conf_sec_are(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_are;
}

BOOL
TTisVSC_conf_sec_class_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_class_clause;
}

BOOL
TTisVSC_conf_sec_configuration_section(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_configuration_section;
}

BOOL
TTisVSC_conf_sec_configuration_section_paragraph(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_configuration_section_paragraph;
}

BOOL
TTisVSC_conf_sec_configuration_section_paragraphs(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_configuration_section_paragraphs;
}

BOOL
TTisVSC_conf_sec_currency_sign_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_currency_sign_clause;
}

BOOL
TTisVSC_conf_sec_decimal_point_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_decimal_point_clause;
}

BOOL
TTisVSC_conf_sec_in_alphabet_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_in_alphabet_name;
}

BOOL
TTisVSC_conf_sec_is_mnemonic_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_is_mnemonic_name;
}

BOOL
TTisVSC_conf_sec_memory_size(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_memory_size;
}

BOOL
TTisVSC_conf_sec_memory_size_type(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_memory_size_type;
}

BOOL
TTisVSC_conf_sec_object_computer_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_object_computer_name;
}

BOOL
TTisVSC_conf_sec_object_computer_paragraph(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_object_computer_paragraph;
}

BOOL
TTisVSC_conf_sec_object_computer_paragraph_sequence_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_object_computer_paragraph_sequence_phrase;
}

BOOL
TTisVSC_conf_sec_off_status(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_off_status;
}

BOOL
TTisVSC_conf_sec_on_status(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_on_status;
}

BOOL
TTisVSC_conf_sec_program_collating_sequence(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_program_collating_sequence;
}

BOOL
TTisVSC_conf_sec_segment_limit(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_segment_limit;
}

BOOL
TTisVSC_conf_sec_source_computer_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_source_computer_name;
}

BOOL
TTisVSC_conf_sec_source_computer_paragraph(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_source_computer_paragraph;
}

BOOL
TTisVSC_conf_sec_special_names_paragraph(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_special_names_paragraph;
}

BOOL
TTisVSC_conf_sec_special_names_paragraph_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_special_names_paragraph_clause;
}

BOOL
TTisVSC_conf_sec_special_names_paragraph_clauses(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_special_names_paragraph_clauses;
}

BOOL
TTisVSC_conf_sec_special_names_paragraph_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_special_names_paragraph_phrase;
}

BOOL
TTisVSC_conf_sec_special_names_paragraph_phrase_tail(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_special_names_paragraph_phrase_tail;
}

BOOL
TTisVSC_conf_sec_special_names_paragraph_status_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_special_names_paragraph_status_phrase;
}

BOOL
TTisVSC_conf_sec_special_names_paragraph_status_phrase_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_special_names_paragraph_status_phrase_1;
}

BOOL
TTisVSC_conf_sec_special_names_paragraph_status_phrase_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_special_names_paragraph_status_phrase_2;
}

BOOL
TTisVSC_conf_sec_symbolic_character_mapping(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_symbolic_character_mapping;
}

BOOL
TTisVSC_conf_sec_symbolic_characters_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_symbolic_characters_clause;
}

BOOL
TTisVSC_conf_sec_with_debugging_mode(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_conf_sec_with_debugging_mode;
}

BOOL
TTisVSC_data_div_data_division(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_data_div_data_division;
}

BOOL
TTisVSC_data_div_data_division_content(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_data_div_data_division_content;
}

BOOL
TTisVSC_data_div_file_section(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_data_div_file_section;
}

BOOL
TTisVSC_data_div_file_section_entry(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_data_div_file_section_entry;
}

BOOL
TTisVSC_data_div_linkage_section(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_data_div_linkage_section;
}

BOOL
TTisVSC_data_div_working_storage_section(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_data_div_working_storage_section;
}

BOOL
TTisVSC_dd_entry_alt_data_name_filler(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_alt_data_name_filler;
}

BOOL
TTisVSC_dd_entry_alt_leading_trailing(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_alt_leading_trailing;
}

BOOL
TTisVSC_dd_entry_alt_left_right(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_alt_left_right;
}

BOOL
TTisVSC_dd_entry_blank_when_zero_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_blank_when_zero_clause;
}

BOOL
TTisVSC_dd_entry_condition_value_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_condition_value_clause;
}

BOOL
TTisVSC_dd_entry_data_description_entry(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_data_description_entry;
}

BOOL
TTisVSC_dd_entry_data_description_entry_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_data_description_entry_1;
}

BOOL
TTisVSC_dd_entry_data_description_entry_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_data_description_entry_clause;
}

BOOL
TTisVSC_dd_entry_data_description_entry_clauses(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_data_description_entry_clauses;
}

BOOL
TTisVSC_dd_entry_external_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_external_clause;
}

BOOL
TTisVSC_dd_entry_global_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_global_clause;
}

BOOL
TTisVSC_dd_entry_indexed_by(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_indexed_by;
}

BOOL
TTisVSC_dd_entry_integer_to(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_integer_to;
}

BOOL
TTisVSC_dd_entry_justified(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_justified;
}

BOOL
TTisVSC_dd_entry_justified_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_justified_clause;
}

BOOL
TTisVSC_dd_entry_occurs_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_occurs_clause;
}

BOOL
TTisVSC_dd_entry_occurs_clause_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_occurs_clause_1;
}

BOOL
TTisVSC_dd_entry_occurs_clause_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_occurs_clause_2;
}

BOOL
TTisVSC_dd_entry_occurs_clause_key(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_occurs_clause_key;
}

BOOL
TTisVSC_dd_entry_picture(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_picture;
}

BOOL
TTisVSC_dd_entry_picture_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_picture_clause;
}

BOOL
TTisVSC_dd_entry_redefines_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_redefines_clause;
}

BOOL
TTisVSC_dd_entry_renames_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_renames_clause;
}

BOOL
TTisVSC_dd_entry_separate_character(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_separate_character;
}

BOOL
TTisVSC_dd_entry_sign_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_sign_clause;
}

BOOL
TTisVSC_dd_entry_sign_is(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_sign_is;
}

BOOL
TTisVSC_dd_entry_synchronized(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_synchronized;
}

BOOL
TTisVSC_dd_entry_synchronized_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_synchronized_clause;
}

BOOL
TTisVSC_dd_entry_usage(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_usage;
}

BOOL
TTisVSC_dd_entry_usage_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_usage_clause;
}

BOOL
TTisVSC_dd_entry_usage_is(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_usage_is;
}

BOOL
TTisVSC_dd_entry_values_are(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_values_are;
}

BOOL
TTisVSC_dd_entry_zeroes(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_dd_entry_zeroes;
}

BOOL
TTisVSC_env_div_environment_division(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_env_div_environment_division;
}

BOOL
TTisVSC_env_div_environment_division_content(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_env_div_environment_division_content;
}

BOOL
TTisVSC_expr_alphabet_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_alphabet_name;
}

BOOL
TTisVSC_expr_alphabetic_user_defined_word(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_alphabetic_user_defined_word;
}

BOOL
TTisVSC_expr_alt_ascending_descending(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_alt_ascending_descending;
}

BOOL
TTisVSC_expr_alt_library_name_literal(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_alt_library_name_literal;
}

BOOL
TTisVSC_expr_alt_plus_minus(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_alt_plus_minus;
}

BOOL
TTisVSC_expr_alt_reel_unit(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_alt_reel_unit;
}

BOOL
TTisVSC_expr_alt_text_name_literal(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_alt_text_name_literal;
}

BOOL
TTisVSC_expr_alt_times_div(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_alt_times_div;
}

BOOL
TTisVSC_expr_arithmetic_expression(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_arithmetic_expression;
}

BOOL
TTisVSC_expr_arithmetic_expression_tail(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_arithmetic_expression_tail;
}

BOOL
TTisVSC_expr_assignment_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_assignment_name;
}

BOOL
TTisVSC_expr_basis(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_basis;
}

BOOL
TTisVSC_expr_basis_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_basis_1;
}

BOOL
TTisVSC_expr_class_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_class_name;
}

BOOL
TTisVSC_expr_computer_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_computer_name;
}

BOOL
TTisVSC_expr_condition_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_condition_name;
}

BOOL
TTisVSC_expr_copy_operand(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_copy_operand;
}

BOOL
TTisVSC_expr_copy_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_copy_statement;
}

BOOL
TTisVSC_expr_copy_statement_by_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_copy_statement_by_phrase;
}

BOOL
TTisVSC_expr_copy_statement_replacing_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_copy_statement_replacing_phrase;
}

BOOL
TTisVSC_expr_data_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_data_name;
}

BOOL
TTisVSC_expr_data_or_file_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_data_or_file_name;
}

BOOL
TTisVSC_expr_data_or_file_or_mnemonic_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_data_or_file_or_mnemonic_name;
}

BOOL
TTisVSC_expr_environment_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_environment_name;
}

BOOL
TTisVSC_expr_equal_to(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_equal_to;
}

BOOL
TTisVSC_expr_equal_to_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_equal_to_1;
}

BOOL
TTisVSC_expr_figurative_constant(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_figurative_constant;
}

BOOL
TTisVSC_expr_figurative_constant_all(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_figurative_constant_all;
}

BOOL
TTisVSC_expr_figurative_constant_simple(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_figurative_constant_simple;
}

BOOL
TTisVSC_expr_file_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_file_name;
}

BOOL
TTisVSC_expr_identifier(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_identifier;
}

BOOL
TTisVSC_expr_identifier_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_identifier_1;
}

BOOL
TTisVSC_expr_identifier_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_identifier_2;
}

BOOL
TTisVSC_expr_in(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_in;
}

BOOL
TTisVSC_expr_in_data_or_file_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_in_data_or_file_name;
}

BOOL
TTisVSC_expr_in_data_or_file_or_mnemonic_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_in_data_or_file_or_mnemonic_name;
}

BOOL
TTisVSC_expr_in_file_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_in_file_name;
}

BOOL
TTisVSC_expr_in_library(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_in_library;
}

BOOL
TTisVSC_expr_in_section_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_in_section_name;
}

BOOL
TTisVSC_expr_index_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_index_name;
}

BOOL
TTisVSC_expr_integer(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_integer;
}

BOOL
TTisVSC_expr_leftmost_character_position(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_leftmost_character_position;
}

BOOL
TTisVSC_expr_length(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_length;
}

BOOL
TTisVSC_expr_level_number(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_level_number;
}

BOOL
TTisVSC_expr_library_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_library_name;
}

BOOL
TTisVSC_expr_literal(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_literal;
}

BOOL
TTisVSC_expr_literal_through_literal(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_literal_through_literal;
}

BOOL
TTisVSC_expr_mnemonic_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_mnemonic_name;
}

BOOL
TTisVSC_expr_numeric(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_numeric;
}

BOOL
TTisVSC_expr_paragraph_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_paragraph_name;
}

BOOL
TTisVSC_expr_paragraph_or_section_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_paragraph_or_section_name;
}

BOOL
TTisVSC_expr_plus_minus_integer(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_plus_minus_integer;
}

BOOL
TTisVSC_expr_power(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_power;
}

BOOL
TTisVSC_expr_power_tail(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_power_tail;
}

BOOL
TTisVSC_expr_priority_number(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_priority_number;
}

BOOL
TTisVSC_expr_procedure_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_procedure_name;
}

BOOL
TTisVSC_expr_program_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_program_name;
}

BOOL
TTisVSC_expr_qualified_data_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_qualified_data_name;
}

BOOL
TTisVSC_expr_qualified_data_name_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_qualified_data_name_1;
}

BOOL
TTisVSC_expr_record_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_record_name;
}

BOOL
TTisVSC_expr_records(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_records;
}

BOOL
TTisVSC_expr_reference_modification(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_reference_modification;
}

BOOL
TTisVSC_expr_section_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_section_name;
}

BOOL
TTisVSC_expr_special_register_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_special_register_1;
}

BOOL
TTisVSC_expr_special_register_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_special_register_2;
}

BOOL
TTisVSC_expr_subscript(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_subscript;
}

BOOL
TTisVSC_expr_subscript_expression(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_subscript_expression;
}

BOOL
TTisVSC_expr_subscript_expression_ambiguous(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_subscript_expression_ambiguous;
}

BOOL
TTisVSC_expr_subscript_parentheses(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_subscript_parentheses;
}

BOOL
TTisVSC_expr_symbolic_character(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_symbolic_character;
}

BOOL
TTisVSC_expr_system_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_system_name;
}

BOOL
TTisVSC_expr_text_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_text_name;
}

BOOL
TTisVSC_expr_through(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_through;
}

BOOL
TTisVSC_expr_through_arithmetic_expression(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_through_arithmetic_expression;
}

BOOL
TTisVSC_expr_through_literal(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_through_literal;
}

BOOL
TTisVSC_expr_through_qualified_data_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_through_qualified_data_name;
}

BOOL
TTisVSC_expr_times_div(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_times_div;
}

BOOL
TTisVSC_expr_times_div_tail(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_times_div_tail;
}

BOOL
TTisVSC_expr_user_defined_word(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_user_defined_word;
}

BOOL
TTisVSC_expr_values(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_expr_values;
}

BOOL
TTisVSC_fd_entry_alt_characters_records(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_alt_characters_records;
}

BOOL
TTisVSC_fd_entry_alt_data_name_integer(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_alt_data_name_integer;
}

BOOL
TTisVSC_fd_entry_alt_fd_sd(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_alt_fd_sd;
}

BOOL
TTisVSC_fd_entry_alt_qualified_data_name_literal(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_alt_qualified_data_name_literal;
}

BOOL
TTisVSC_fd_entry_block_contains_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_block_contains_clause;
}

BOOL
TTisVSC_fd_entry_code_set_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_code_set_clause;
}

BOOL
TTisVSC_fd_entry_data_names(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_data_names;
}

BOOL
TTisVSC_fd_entry_data_records_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_data_records_clause;
}

BOOL
TTisVSC_fd_entry_depending_on(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_depending_on;
}

BOOL
TTisVSC_fd_entry_file_and_sort_description_entry(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_file_and_sort_description_entry;
}

BOOL
TTisVSC_fd_entry_file_and_sort_description_entry_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_file_and_sort_description_entry_clause;
}

BOOL
TTisVSC_fd_entry_file_and_sort_description_entry_clauses(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_file_and_sort_description_entry_clauses;
}

BOOL
TTisVSC_fd_entry_footing(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_footing;
}

BOOL
TTisVSC_fd_entry_from_integer(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_from_integer;
}

BOOL
TTisVSC_fd_entry_label_records_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_label_records_clause;
}

BOOL
TTisVSC_fd_entry_label_records_clause_tail(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_label_records_clause_tail;
}

BOOL
TTisVSC_fd_entry_linage_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_linage_clause;
}

BOOL
TTisVSC_fd_entry_linage_footing_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_linage_footing_phrase;
}

BOOL
TTisVSC_fd_entry_lines_bottom(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_lines_bottom;
}

BOOL
TTisVSC_fd_entry_lines_top(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_lines_top;
}

BOOL
TTisVSC_fd_entry_record_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_record_clause;
}

BOOL
TTisVSC_fd_entry_record_clause_tail(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_record_clause_tail;
}

BOOL
TTisVSC_fd_entry_record_clause_tail_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_record_clause_tail_1;
}

BOOL
TTisVSC_fd_entry_record_clause_tail_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_record_clause_tail_2;
}

BOOL
TTisVSC_fd_entry_record_clause_tail_3(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_record_clause_tail_3;
}

BOOL
TTisVSC_fd_entry_record_varying_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_record_varying_phrase;
}

BOOL
TTisVSC_fd_entry_recording_mode_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_recording_mode_clause;
}

BOOL
TTisVSC_fd_entry_records_are(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_records_are;
}

BOOL
TTisVSC_fd_entry_to_integer(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_to_integer;
}

BOOL
TTisVSC_fd_entry_value_of_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_value_of_clause;
}

BOOL
TTisVSC_fd_entry_value_of_clause_tail(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_fd_entry_value_of_clause_tail;
}

BOOL
TTisVSC_id_div_author(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_id_div_author;
}

BOOL
TTisVSC_id_div_date_compiled(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_id_div_date_compiled;
}

BOOL
TTisVSC_id_div_date_written(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_id_div_date_written;
}

BOOL
TTisVSC_id_div_identification(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_id_div_identification;
}

BOOL
TTisVSC_id_div_identification_division(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_id_div_identification_division;
}

BOOL
TTisVSC_id_div_identification_division_content(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_id_div_identification_division_content;
}

BOOL
TTisVSC_id_div_identification_division_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_id_div_identification_division_phrase;
}

BOOL
TTisVSC_id_div_initial_program(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_id_div_initial_program;
}

BOOL
TTisVSC_id_div_installation(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_id_div_installation;
}

BOOL
TTisVSC_id_div_program_id_cobol_source_program(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_id_div_program_id_cobol_source_program;
}

BOOL
TTisVSC_id_div_remarks(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_id_div_remarks;
}

BOOL
TTisVSC_id_div_security(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_id_div_security;
}

BOOL
TTisVSC_io_sec_alt_assignment_name_file_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_alt_assignment_name_file_name;
}

BOOL
TTisVSC_io_sec_alt_assignment_name_literal(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_alt_assignment_name_literal;
}

BOOL
TTisVSC_io_sec_alt_indexed_relative_sequential(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_alt_indexed_relative_sequential;
}

BOOL
TTisVSC_io_sec_alt_sequential_random_dynamic(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_alt_sequential_random_dynamic;
}

BOOL
TTisVSC_io_sec_alternate_record_key_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_alternate_record_key_clause;
}

BOOL
TTisVSC_io_sec_areas(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_areas;
}

BOOL
TTisVSC_io_sec_assign_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_assign_clause;
}

BOOL
TTisVSC_io_sec_every_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_every_phrase;
}

BOOL
TTisVSC_io_sec_every_phrase_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_every_phrase_1;
}

BOOL
TTisVSC_io_sec_every_phrase_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_every_phrase_2;
}

BOOL
TTisVSC_io_sec_fce_access_mode(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_fce_access_mode;
}

BOOL
TTisVSC_io_sec_fce_organization(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_fce_organization;
}

BOOL
TTisVSC_io_sec_fce_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_fce_phrase;
}

BOOL
TTisVSC_io_sec_file_control_entry(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_file_control_entry;
}

BOOL
TTisVSC_io_sec_file_control_paragraph(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_file_control_paragraph;
}

BOOL
TTisVSC_io_sec_file_name_position(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_file_name_position;
}

BOOL
TTisVSC_io_sec_file_status_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_file_status_clause;
}

BOOL
TTisVSC_io_sec_i_o_control_paragraph(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_i_o_control_paragraph;
}

BOOL
TTisVSC_io_sec_i_o_sam(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_i_o_sam;
}

BOOL
TTisVSC_io_sec_i_o_sort_merge(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_i_o_sort_merge;
}

BOOL
TTisVSC_io_sec_input_output_section(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_input_output_section;
}

BOOL
TTisVSC_io_sec_organization_is(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_organization_is;
}

BOOL
TTisVSC_io_sec_padding_character_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_padding_character_clause;
}

BOOL
TTisVSC_io_sec_password_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_password_clause;
}

BOOL
TTisVSC_io_sec_position(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_position;
}

BOOL
TTisVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries;
}

BOOL
TTisVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_1;
}

BOOL
TTisVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_2;
}

BOOL
TTisVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_3(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_3;
}

BOOL
TTisVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_4(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_4;
}

BOOL
TTisVSC_io_sec_record_delimiter_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_record_delimiter_clause;
}

BOOL
TTisVSC_io_sec_record_delimiter_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_record_delimiter_name;
}

BOOL
TTisVSC_io_sec_record_key_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_record_key_clause;
}

BOOL
TTisVSC_io_sec_record_sort(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_record_sort;
}

BOOL
TTisVSC_io_sec_relative_key_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_relative_key_clause;
}

BOOL
TTisVSC_io_sec_rerun_on(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_rerun_on;
}

BOOL
TTisVSC_io_sec_reserve_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_reserve_clause;
}

BOOL
TTisVSC_io_sec_same_area(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_same_area;
}

BOOL
TTisVSC_io_sec_select_clause(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_select_clause;
}

BOOL
TTisVSC_io_sec_sort_merge_i_o_control_entries(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_sort_merge_i_o_control_entries;
}

BOOL
TTisVSC_io_sec_with_duplicates(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_io_sec_with_duplicates;
}

BOOL
TTisVSC_main_cobol_source_program(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_main_cobol_source_program;
}

BOOL
TTisVSC_main_common_initial(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_main_common_initial;
}

BOOL
TTisVSC_main_common_initial_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_main_common_initial_1;
}

BOOL
TTisVSC_main_common_initial_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_main_common_initial_2;
}

BOOL
TTisVSC_main_common_initial_program(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_main_common_initial_program;
}

BOOL
TTisVSC_main_nested_cobol_source_program(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_main_nested_cobol_source_program;
}

BOOL
TTisVSC_main_nested_program(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_main_nested_program;
}

BOOL
TTisVSC_main_program_id_nested_cobol_source_program(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_main_program_id_nested_cobol_source_program;
}

BOOL
TTisVSC_main_programs(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_main_programs;
}

BOOL
TTisVSC_proc_div_altered_goto(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_altered_goto;
}

BOOL
TTisVSC_proc_div_declaratives(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_declaratives;
}

BOOL
TTisVSC_proc_div_declaratives_content(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_declaratives_content;
}

BOOL
TTisVSC_proc_div_paragraph(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_paragraph;
}

BOOL
TTisVSC_proc_div_paragraph_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_paragraph_1;
}

BOOL
TTisVSC_proc_div_paragraphs(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_paragraphs;
}

BOOL
TTisVSC_proc_div_procedure_division(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_procedure_division;
}

BOOL
TTisVSC_proc_div_section_header(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_section_header;
}

BOOL
TTisVSC_proc_div_section_with_header(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_section_with_header;
}

BOOL
TTisVSC_proc_div_sections(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_sections;
}

BOOL
TTisVSC_proc_div_sentence(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_sentence;
}

BOOL
TTisVSC_proc_div_sentence_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_sentence_1;
}

BOOL
TTisVSC_proc_div_sentence_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_sentence_2;
}

BOOL
TTisVSC_proc_div_using_data_names(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_using_data_names;
}

BOOL
TTisVSC_proc_div_using_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_using_phrase;
}

BOOL
TTisVSC_proc_div_using_phrase_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_using_phrase_1;
}

BOOL
TTisVSC_proc_div_using_phrase_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_proc_div_using_phrase_2;
}

BOOL
TTisVSC_stat_accept_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_accept_statement;
}

BOOL
TTisVSC_stat_accept_statement_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_accept_statement_1;
}

BOOL
TTisVSC_stat_accept_statement_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_accept_statement_2;
}

BOOL
TTisVSC_stat_add_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_add_statement;
}

BOOL
TTisVSC_stat_add_statement_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_add_statement_1;
}

BOOL
TTisVSC_stat_add_statement_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_add_statement_2;
}

BOOL
TTisVSC_stat_add_statement_3(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_add_statement_3;
}

BOOL
TTisVSC_stat_advancing_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_advancing_phrase;
}

BOOL
TTisVSC_stat_all_procedures(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_all_procedures;
}

BOOL
TTisVSC_stat_also_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_also_phrase;
}

BOOL
TTisVSC_stat_alt_all_leading(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_all_leading;
}

BOOL
TTisVSC_stat_alt_all_leading_first(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_all_leading_first;
}

BOOL
TTisVSC_stat_alt_before_after(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_before_after;
}

BOOL
TTisVSC_stat_alt_beginning_ending(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_beginning_ending;
}

BOOL
TTisVSC_stat_alt_exception_error(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_exception_error;
}

BOOL
TTisVSC_stat_alt_file_names_i_o(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_file_names_i_o;
}

BOOL
TTisVSC_stat_alt_file_reel_unit(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_file_reel_unit;
}

BOOL
TTisVSC_stat_alt_no_rewind_lock(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_no_rewind_lock;
}

BOOL
TTisVSC_stat_alt_procedures_all_procedures(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_procedures_all_procedures;
}

BOOL
TTisVSC_stat_alt_removal_no_rewind(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_removal_no_rewind;
}

BOOL
TTisVSC_stat_alt_reversed_with_no_rewind(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_reversed_with_no_rewind;
}

BOOL
TTisVSC_stat_alt_run_literal(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_run_literal;
}

BOOL
TTisVSC_stat_alt_statement_list_next_sentence(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_statement_list_next_sentence;
}

BOOL
TTisVSC_stat_alt_up_down(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_up_down;
}

BOOL
TTisVSC_stat_alt_up_down_by(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alt_up_down_by;
}

BOOL
TTisVSC_stat_alter_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_alter_statement;
}

BOOL
TTisVSC_stat_at_end_of_page_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_at_end_of_page_statement_list;
}

BOOL
TTisVSC_stat_at_end_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_at_end_statement_list;
}

BOOL
TTisVSC_stat_before_after_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_before_after_phrase;
}

BOOL
TTisVSC_stat_by_reference(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_by_reference;
}

BOOL
TTisVSC_stat_call_rest_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_call_rest_phrase;
}

BOOL
TTisVSC_stat_call_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_call_statement;
}

BOOL
TTisVSC_stat_cancel_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_cancel_statement;
}

BOOL
TTisVSC_stat_close_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_close_statement;
}

BOOL
TTisVSC_stat_close_statement_file_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_close_statement_file_name;
}

BOOL
TTisVSC_stat_close_statement_options(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_close_statement_options;
}

BOOL
TTisVSC_stat_close_statement_options_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_close_statement_options_1;
}

BOOL
TTisVSC_stat_close_statement_options_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_close_statement_options_2;
}

BOOL
TTisVSC_stat_cobword_int(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_cobword_int;
}

BOOL
TTisVSC_stat_cobword_rounded(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_cobword_rounded;
}

BOOL
TTisVSC_stat_collating_sequence(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_collating_sequence;
}

BOOL
TTisVSC_stat_compute_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_compute_statement;
}

BOOL
TTisVSC_stat_content_parameter(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_content_parameter;
}

BOOL
TTisVSC_stat_content_parameter_value(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_content_parameter_value;
}

BOOL
TTisVSC_stat_continue_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_continue_statement;
}

BOOL
TTisVSC_stat_corresponding(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_corresponding;
}

BOOL
TTisVSC_stat_count_in_identifier(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_count_in_identifier;
}

BOOL
TTisVSC_stat_date(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_date;
}

BOOL
TTisVSC_stat_delete_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_delete_statement;
}

BOOL
TTisVSC_stat_delimited_by_all_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_delimited_by_all_phrase;
}

BOOL
TTisVSC_stat_delimited_by_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_delimited_by_phrase;
}

BOOL
TTisVSC_stat_delimiter_in_identifier(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_delimiter_in_identifier;
}

BOOL
TTisVSC_stat_display_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_display_statement;
}

BOOL
TTisVSC_stat_divide_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_divide_statement;
}

BOOL
TTisVSC_stat_divide_statement_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_divide_statement_1;
}

BOOL
TTisVSC_stat_divide_statement_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_divide_statement_2;
}

BOOL
TTisVSC_stat_divide_statement_3(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_divide_statement_3;
}

BOOL
TTisVSC_stat_divide_statement_4(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_divide_statement_4;
}

BOOL
TTisVSC_stat_divide_statement_5(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_divide_statement_5;
}

BOOL
TTisVSC_stat_else_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_else_phrase;
}

BOOL
TTisVSC_stat_end_of_page(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_end_of_page;
}

BOOL
TTisVSC_stat_entry_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_entry_statement;
}

BOOL
TTisVSC_stat_equal(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_equal;
}

BOOL
TTisVSC_stat_evaluate_condition(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_evaluate_condition;
}

BOOL
TTisVSC_stat_evaluate_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_evaluate_phrase;
}

BOOL
TTisVSC_stat_evaluate_phrase_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_evaluate_phrase_1;
}

BOOL
TTisVSC_stat_evaluate_phrase_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_evaluate_phrase_2;
}

BOOL
TTisVSC_stat_evaluate_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_evaluate_statement;
}

BOOL
TTisVSC_stat_exit_program_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_exit_program_statement;
}

BOOL
TTisVSC_stat_exit_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_exit_statement;
}

BOOL
TTisVSC_stat_file_names(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_file_names;
}

BOOL
TTisVSC_stat_for_removal(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_for_removal;
}

BOOL
TTisVSC_stat_from_environment_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_from_environment_name;
}

BOOL
TTisVSC_stat_from_identifier(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_from_identifier;
}

BOOL
TTisVSC_stat_giving_file_names(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_giving_file_names;
}

BOOL
TTisVSC_stat_go_to_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_go_to_statement;
}

BOOL
TTisVSC_stat_go_to_statement_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_go_to_statement_1;
}

BOOL
TTisVSC_stat_go_to_statement_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_go_to_statement_2;
}

BOOL
TTisVSC_stat_go_to_statement_3(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_go_to_statement_3;
}

BOOL
TTisVSC_stat_goback_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_goback_statement;
}

BOOL
TTisVSC_stat_id_or_lit(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_id_or_lit;
}

BOOL
TTisVSC_stat_id_or_lit_size(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_id_or_lit_size;
}

BOOL
TTisVSC_stat_if_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_if_statement;
}

BOOL
TTisVSC_stat_initialize_replacing_argument(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_initialize_replacing_argument;
}

BOOL
TTisVSC_stat_initialize_replacing_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_initialize_replacing_phrase;
}

BOOL
TTisVSC_stat_initialize_replacing_type(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_initialize_replacing_type;
}

BOOL
TTisVSC_stat_initialize_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_initialize_statement;
}

BOOL
TTisVSC_stat_input_procedure(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_input_procedure;
}

BOOL
TTisVSC_stat_inspect_by_argument(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_inspect_by_argument;
}

BOOL
TTisVSC_stat_inspect_replacing_argument(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_inspect_replacing_argument;
}

BOOL
TTisVSC_stat_inspect_replacing_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_inspect_replacing_phrase;
}

BOOL
TTisVSC_stat_inspect_replacing_phrase_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_inspect_replacing_phrase_1;
}

BOOL
TTisVSC_stat_inspect_replacing_phrase_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_inspect_replacing_phrase_2;
}

BOOL
TTisVSC_stat_inspect_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_inspect_statement;
}

BOOL
TTisVSC_stat_inspect_statement_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_inspect_statement_1;
}

BOOL
TTisVSC_stat_inspect_statement_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_inspect_statement_2;
}

BOOL
TTisVSC_stat_inspect_statement_3(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_inspect_statement_3;
}

BOOL
TTisVSC_stat_inspect_statement_4(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_inspect_statement_4;
}

BOOL
TTisVSC_stat_into_identifier(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_into_identifier;
}

BOOL
TTisVSC_stat_invalid_key_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_invalid_key_statement_list;
}

BOOL
TTisVSC_stat_key_is(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_key_is;
}

BOOL
TTisVSC_stat_key_is_qualified_data_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_key_is_qualified_data_name;
}

BOOL
TTisVSC_stat_key_is_rel_op_qualified_data_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_key_is_rel_op_qualified_data_name;
}

BOOL
TTisVSC_stat_lines(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_lines;
}

BOOL
TTisVSC_stat_merge_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_merge_statement;
}

BOOL
TTisVSC_stat_merge_statement_tail(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_merge_statement_tail;
}

BOOL
TTisVSC_stat_move_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_move_statement;
}

BOOL
TTisVSC_stat_move_statement_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_move_statement_1;
}

BOOL
TTisVSC_stat_move_statement_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_move_statement_2;
}

BOOL
TTisVSC_stat_multiply_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_multiply_statement;
}

BOOL
TTisVSC_stat_multiply_statement_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_multiply_statement_1;
}

BOOL
TTisVSC_stat_multiply_statement_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_multiply_statement_2;
}

BOOL
TTisVSC_stat_next_sentence(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_next_sentence;
}

BOOL
TTisVSC_stat_no_rewind(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_no_rewind;
}

BOOL
TTisVSC_stat_not_at_end_of_page_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_not_at_end_of_page_statement_list;
}

BOOL
TTisVSC_stat_not_at_end_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_not_at_end_statement_list;
}

BOOL
TTisVSC_stat_not_invalid_key_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_not_invalid_key_statement_list;
}

BOOL
TTisVSC_stat_not_on_exception_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_not_on_exception_statement_list;
}

BOOL
TTisVSC_stat_not_on_overflow_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_not_on_overflow_statement_list;
}

BOOL
TTisVSC_stat_not_on_size_error_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_not_on_size_error_statement_list;
}

BOOL
TTisVSC_stat_nr_lines_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_nr_lines_phrase;
}

BOOL
TTisVSC_stat_on_exception_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_on_exception_statement_list;
}

BOOL
TTisVSC_stat_on_key_is_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_on_key_is_phrase;
}

BOOL
TTisVSC_stat_on_key_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_on_key_phrase;
}

BOOL
TTisVSC_stat_on_overflow_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_on_overflow_statement_list;
}

BOOL
TTisVSC_stat_on_size_error_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_on_size_error_statement_list;
}

BOOL
TTisVSC_stat_open_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_open_statement;
}

BOOL
TTisVSC_stat_open_statement_extend(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_open_statement_extend;
}

BOOL
TTisVSC_stat_open_statement_i_o(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_open_statement_i_o;
}

BOOL
TTisVSC_stat_open_statement_input(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_open_statement_input;
}

BOOL
TTisVSC_stat_open_statement_input_file_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_open_statement_input_file_name;
}

BOOL
TTisVSC_stat_open_statement_output(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_open_statement_output;
}

BOOL
TTisVSC_stat_open_statement_output_file_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_open_statement_output_file_name;
}

BOOL
TTisVSC_stat_open_statement_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_open_statement_phrase;
}

BOOL
TTisVSC_stat_or_all_id_or_lit(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_or_all_id_or_lit;
}

BOOL
TTisVSC_stat_output_procedure(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_output_procedure;
}

BOOL
TTisVSC_stat_page_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_page_phrase;
}

BOOL
TTisVSC_stat_parameter(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_parameter;
}

BOOL
TTisVSC_stat_perform_after_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_after_phrase;
}

BOOL
TTisVSC_stat_perform_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement;
}

BOOL
TTisVSC_stat_perform_statement_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_1;
}

BOOL
TTisVSC_stat_perform_statement_1_alts(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_1_alts;
}

BOOL
TTisVSC_stat_perform_statement_1_procedure(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_1_procedure;
}

BOOL
TTisVSC_stat_perform_statement_1_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_1_statement_list;
}

BOOL
TTisVSC_stat_perform_statement_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_2;
}

BOOL
TTisVSC_stat_perform_statement_2_alts(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_2_alts;
}

BOOL
TTisVSC_stat_perform_statement_2_procedure(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_2_procedure;
}

BOOL
TTisVSC_stat_perform_statement_2_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_2_statement_list;
}

BOOL
TTisVSC_stat_perform_statement_3(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_3;
}

BOOL
TTisVSC_stat_perform_statement_3_alts(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_3_alts;
}

BOOL
TTisVSC_stat_perform_statement_3_procedure(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_3_procedure;
}

BOOL
TTisVSC_stat_perform_statement_3_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_3_statement_list;
}

BOOL
TTisVSC_stat_perform_statement_4(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_4;
}

BOOL
TTisVSC_stat_perform_statement_4_alts(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_4_alts;
}

BOOL
TTisVSC_stat_perform_statement_4_procedure(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_4_procedure;
}

BOOL
TTisVSC_stat_perform_statement_4_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_statement_4_statement_list;
}

BOOL
TTisVSC_stat_perform_until_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_until_phrase;
}

BOOL
TTisVSC_stat_perform_varying_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_perform_varying_phrase;
}

BOOL
TTisVSC_stat_procedure_names(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_procedure_names;
}

BOOL
TTisVSC_stat_procedure_to_procedure(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_procedure_to_procedure;
}

BOOL
TTisVSC_stat_proceed_to(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_proceed_to;
}

BOOL
TTisVSC_stat_read_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_read_statement;
}

BOOL
TTisVSC_stat_reference_parameter(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_reference_parameter;
}

BOOL
TTisVSC_stat_rel_op(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_rel_op;
}

BOOL
TTisVSC_stat_release_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_release_statement;
}

BOOL
TTisVSC_stat_return_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_return_statement;
}

BOOL
TTisVSC_stat_rewrite_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_rewrite_statement;
}

BOOL
TTisVSC_stat_search_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_search_statement;
}

BOOL
TTisVSC_stat_search_statement_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_search_statement_1;
}

BOOL
TTisVSC_stat_search_statement_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_search_statement_2;
}

BOOL
TTisVSC_stat_search_statement_condition(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_search_statement_condition;
}

BOOL
TTisVSC_stat_search_statement_condition_tail(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_search_statement_condition_tail;
}

BOOL
TTisVSC_stat_search_statement_equal_expression(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_search_statement_equal_expression;
}

BOOL
TTisVSC_stat_set_oper(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_set_oper;
}

BOOL
TTisVSC_stat_set_src(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_set_src;
}

BOOL
TTisVSC_stat_set_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_set_statement;
}

BOOL
TTisVSC_stat_set_statement_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_set_statement_phrase;
}

BOOL
TTisVSC_stat_sort_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_sort_statement;
}

BOOL
TTisVSC_stat_sort_statement_in(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_sort_statement_in;
}

BOOL
TTisVSC_stat_sort_statement_out(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_sort_statement_out;
}

BOOL
TTisVSC_stat_start_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_start_statement;
}

BOOL
TTisVSC_stat_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_statement;
}

BOOL
TTisVSC_stat_statement_list(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_statement_list;
}

BOOL
TTisVSC_stat_stop_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_stop_statement;
}

BOOL
TTisVSC_stat_string_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_string_statement;
}

BOOL
TTisVSC_stat_subtract_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_subtract_statement;
}

BOOL
TTisVSC_stat_subtract_statement_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_subtract_statement_1;
}

BOOL
TTisVSC_stat_subtract_statement_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_subtract_statement_2;
}

BOOL
TTisVSC_stat_subtract_statement_3(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_subtract_statement_3;
}

BOOL
TTisVSC_stat_tallying_argument(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_tallying_argument;
}

BOOL
TTisVSC_stat_tallying_for_argument(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_tallying_for_argument;
}

BOOL
TTisVSC_stat_tallying_for_argument_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_tallying_for_argument_1;
}

BOOL
TTisVSC_stat_tallying_for_argument_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_tallying_for_argument_2;
}

BOOL
TTisVSC_stat_tallying_for_id_or_lit(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_tallying_for_id_or_lit;
}

BOOL
TTisVSC_stat_tallying_in_identifier(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_tallying_in_identifier;
}

BOOL
TTisVSC_stat_through_procedure_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_through_procedure_name;
}

BOOL
TTisVSC_stat_to_id_or_lit(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_to_id_or_lit;
}

BOOL
TTisVSC_stat_unstring_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_unstring_statement;
}

BOOL
TTisVSC_stat_unstring_statement_dst(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_unstring_statement_dst;
}

BOOL
TTisVSC_stat_upon_environment_name(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_upon_environment_name;
}

BOOL
TTisVSC_stat_use_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_use_statement;
}

BOOL
TTisVSC_stat_use_statement_1(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_use_statement_1;
}

BOOL
TTisVSC_stat_use_statement_2(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_use_statement_2;
}

BOOL
TTisVSC_stat_use_statement_3(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_use_statement_3;
}

BOOL
TTisVSC_stat_using_data_name_pluslist(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_using_data_name_pluslist;
}

BOOL
TTisVSC_stat_using_file_names(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_using_file_names;
}

BOOL
TTisVSC_stat_using_parameters(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_using_parameters;
}

BOOL
TTisVSC_stat_varying_identifier(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_varying_identifier;
}

BOOL
TTisVSC_stat_when_condition_stats(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_when_condition_stats;
}

BOOL
TTisVSC_stat_when_other_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_when_other_phrase;
}

BOOL
TTisVSC_stat_when_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_when_phrase;
}

BOOL
TTisVSC_stat_when_phrase_also_phrase(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_when_phrase_also_phrase;
}

BOOL
TTisVSC_stat_when_phrases(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_when_phrases;
}

BOOL
TTisVSC_stat_with_duplicates_in_order(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_with_duplicates_in_order;
}

BOOL
TTisVSC_stat_with_no_advancing(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_with_no_advancing;
}

BOOL
TTisVSC_stat_with_no_rewind(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_with_no_rewind;
}

BOOL
TTisVSC_stat_with_pointer_identifier(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_with_pointer_identifier;
}

BOOL
TTisVSC_stat_with_test(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_with_test;
}

BOOL
TTisVSC_stat_write_exceptions(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_write_exceptions;
}

BOOL
TTisVSC_stat_write_statement(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_stat_write_statement;
}

BOOL
TTisVSC_lex_picture_string(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_lex_picture_string;
}

BOOL
TTisVSC_lex_quoted_pseudo_text(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_lex_quoted_pseudo_text;
}

BOOL
TTisVSC_lex_num(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_lex_num;
}

BOOL
TTisVSC_lex_nonnumeric(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_lex_nonnumeric;
}

BOOL
TTisVSC_lex_cobword(TTterm t)
{
    t = TTunsandwich(t);
    return t->fun == TTfunVSC_lex_cobword;
}

TTterm
TTbuildVSC_cond_alt_and_or(TTterm t1)
{
    assert(TTist_AND(t1) || TTist_OR(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_cond_alt_and_or, args);
}

TTterm
TTbuildVSC_cond_and_or_combinable_condition(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_cond_alt_and_or(t1) && TTisVSC_cond_relational_operator_opt(t2) && TTisVSC_cond_combinable_condition(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_cond_and_or_combinable_condition, args);
}

TTterm
TTbuildVSC_cond_class_condition(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_identifier(t1) && TTisVSC_cond_is_or_is_not(t2) && TTisVSC_cond_class_type(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_cond_class_condition, args);
}

TTterm
TTbuildVSC_cond_class_type(TTterm t1)
{
    assert(TTist_NUMERIC(t1) || TTist_ALPHABETIC(t1) || TTist_ALPHABETIC_LOWER(t1) || TTist_ALPHABETIC_UPPER(t1) || TTisVSC_expr_class_name(t1) || TTist_DBCS(t1) || TTist_KANJI(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_cond_class_type, args);
}

TTterm
TTbuildVSC_cond_combinable_condition(TTterm t1)
{
    assert(TTisVSC_cond_simple_condition(t1) || TTisVSC_cond_negated_simple_conditions(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_cond_combinable_condition, args);
}

TTterm
TTbuildVSC_cond_combined_conditions(TTterm t1, TTterm t2)
{
    assert(TTisVSC_cond_combinable_condition(t1) && TTisVSC_cond_and_or_combinable_condition_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_cond_combined_conditions, args);
}

TTterm
TTbuildVSC_cond_condition(TTterm t1)
{
    assert(TTisVSC_cond_combined_conditions(t1) || TTisVSC_cond_combinable_condition(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_cond_condition, args);
}

TTterm
TTbuildVSC_cond_condition_name_reference(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_condition_name(t1) && TTisVSC_expr_in_data_or_file_or_mnemonic_name_star(t2) && TTisVSC_expr_subscript_parentheses_star(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_cond_condition_name_reference, args);
}

TTterm
TTbuildVSC_cond_greater(TTterm t1, TTterm t2)
{
    assert(TTist_GREATER(t1) && TTisVSC_cond_than(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_cond_greater, args);
}

TTterm
TTbuildVSC_cond_greater_equal(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_GREATER(t1) && TTisVSC_cond_than(t2) && TTist_OR(t3) && TTist_EQUAL(t4) && TTist_TO_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_cond_greater_equal, args);
}

TTterm
TTbuildVSC_cond_greater_than(TTterm t1)
{
    assert(TTisVSC_cond_greater_than_1(t1) || TTist_qgt(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_cond_greater_than, args);
}

TTterm
TTbuildVSC_cond_greater_than_1(TTterm t1, TTterm t2)
{
    assert(TTist_GREATER(t1) && TTist_THAN_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_cond_greater_than_1, args);
}

TTterm
TTbuildVSC_cond_greater_than_or_equal_to(TTterm t1)
{
    assert(TTisVSC_cond_greater_than_or_equal_to_1(t1) || TTisVSC_cond_greater_than_or_equal_to_2(t1) || TTisVSC_cond_greater_than_or_equal_to_3(t1) || TTist_qgt_qequal(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_cond_greater_than_or_equal_to, args);
}

TTterm
TTbuildVSC_cond_greater_than_or_equal_to_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_GREATER(t1) && TTist_THAN_opt(t2) && TTist_OR(t3) && TTist_EQUAL(t4) && TTist_TO_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_cond_greater_than_or_equal_to_1, args);
}

TTterm
TTbuildVSC_cond_greater_than_or_equal_to_2(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_NOT(t1) && TTist_LESS(t2) && TTist_THAN_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_cond_greater_than_or_equal_to_2, args);
}

TTterm
TTbuildVSC_cond_greater_than_or_equal_to_3(TTterm t1, TTterm t2)
{
    assert(TTist_NOT(t1) && TTist_qlt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_cond_greater_than_or_equal_to_3, args);
}

TTterm
TTbuildVSC_cond_is_not(TTterm t1, TTterm t2)
{
    assert(TTist_IS_opt(t1) && TTist_NOT_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_cond_is_not, args);
}

TTterm
TTbuildVSC_cond_is_or_is_not(TTterm t1)
{
    assert(TTisVSC_cond_not_is(t1) || TTisVSC_cond_is_not(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_cond_is_or_is_not, args);
}

TTterm
TTbuildVSC_cond_less(TTterm t1, TTterm t2)
{
    assert(TTist_LESS(t1) && TTisVSC_cond_than(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_cond_less, args);
}

TTterm
TTbuildVSC_cond_less_equal(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_LESS(t1) && TTisVSC_cond_than(t2) && TTist_OR(t3) && TTist_EQUAL(t4) && TTist_TO_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_cond_less_equal, args);
}

TTterm
TTbuildVSC_cond_less_equal_2(TTterm t1, TTterm t2)
{
    assert(TTist_qlt(t1) && TTist_qequal(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_cond_less_equal_2, args);
}

TTterm
TTbuildVSC_cond_negated_simple_conditions(TTterm t1, TTterm t2)
{
    assert(TTist_NOT(t1) && TTisVSC_cond_combinable_condition(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_cond_negated_simple_conditions, args);
}

TTterm
TTbuildVSC_cond_not_is(TTterm t1, TTterm t2)
{
    assert(TTist_NOT(t1) && TTist_IS(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_cond_not_is, args);
}

TTterm
TTbuildVSC_cond_not_relational_operator_rest(TTterm t1, TTterm t2)
{
    assert(TTist_NOT_opt(t1) && TTisVSC_cond_relational_operator_rest(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_cond_not_relational_operator_rest, args);
}

TTterm
TTbuildVSC_cond_relation_condition(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_arithmetic_expression(t1) && TTisVSC_cond_relational_operator(t2) && TTisVSC_cond_simple_condition(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_cond_relation_condition, args);
}

TTterm
TTbuildVSC_cond_relational_operator(TTterm t1, TTterm t2)
{
    assert(TTist_IS_opt(t1) && TTisVSC_cond_relational_operator_tail(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_cond_relational_operator, args);
}

TTterm
TTbuildVSC_cond_relational_operator_rest(TTterm t1)
{
    assert(TTisVSC_cond_greater(t1) || TTist_qgt(t1) || TTisVSC_cond_less(t1) || TTist_qlt(t1) || TTisVSC_expr_equal_to(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_cond_relational_operator_rest, args);
}

TTterm
TTbuildVSC_cond_relational_operator_tail(TTterm t1)
{
    assert(TTisVSC_cond_greater_equal(t1) || TTisVSC_cond_less_equal(t1) || TTisVSC_cond_less_equal_2(t1) || TTist_qgt_qequal(t1) || TTisVSC_cond_not_relational_operator_rest(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_cond_relational_operator_tail, args);
}

TTterm
TTbuildVSC_cond_sign_condition(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_arithmetic_expression(t1) && TTisVSC_cond_is_or_is_not(t2) && TTisVSC_cond_sign_type(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_cond_sign_condition, args);
}

TTterm
TTbuildVSC_cond_sign_type(TTterm t1)
{
    assert(TTist_POSITIVE(t1) || TTist_NEGATIVE(t1) || TTist_ZERO(t1) || TTist_ZEROES(t1) || TTist_ZEROS(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_cond_sign_type, args);
}

TTterm
TTbuildVSC_cond_simple_condition(TTterm t1)
{
    assert(TTisVSC_cond_class_condition(t1) || TTisVSC_cond_relation_condition(t1) || TTisVSC_cond_sign_condition(t1) || TTisVSC_cond_simple_condition_1(t1) || TTisVSC_expr_arithmetic_expression(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_cond_simple_condition, args);
}

TTterm
TTbuildVSC_cond_simple_condition_1(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_qpopen(t1) && TTisVSC_cond_condition(t2) && TTist_qpclose(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_cond_simple_condition_1, args);
}

TTterm
TTbuildVSC_cond_than(TTterm t1)
{
    assert(TTist_THAN(t1) || TTist_THEN_opt(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_cond_than, args);
}

TTterm
TTbuildVSC_conf_sec_alphabet_clause(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_ALPHABET(t1) && TTisVSC_expr_alphabet_name(t2) && TTist_IS_opt(t3) && TTisVSC_conf_sec_alphabet_type(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_conf_sec_alphabet_clause, args);
}

TTterm
TTbuildVSC_conf_sec_alphabet_type(TTterm t1)
{
    assert(TTist_STANDARD_1(t1) || TTist_STANDARD_2(t1) || TTist_NATIVE(t1) || TTist_EBCDIC(t1) || TTisVSC_conf_sec_alphabet_type_others(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_conf_sec_alphabet_type, args);
}

TTterm
TTbuildVSC_conf_sec_alphabet_type_also(TTterm t1, TTterm t2)
{
    assert(TTist_ALSO(t1) && TTisVSC_expr_literal(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_conf_sec_alphabet_type_also, args);
}

TTterm
TTbuildVSC_conf_sec_alphabet_type_also_through(TTterm t1)
{
    assert(TTisVSC_expr_through_literal(t1) || TTisVSC_conf_sec_alphabet_type_alsos(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_conf_sec_alphabet_type_also_through, args);
}

TTterm
TTbuildVSC_conf_sec_alphabet_type_alsos(TTterm t1)
{
    assert(TTisVSC_conf_sec_alphabet_type_also_plus(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_conf_sec_alphabet_type_alsos, args);
}

TTterm
TTbuildVSC_conf_sec_alphabet_type_other(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_literal(t1) && TTisVSC_conf_sec_alphabet_type_also_through_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_conf_sec_alphabet_type_other, args);
}

TTterm
TTbuildVSC_conf_sec_alphabet_type_others(TTterm t1)
{
    assert(TTisVSC_conf_sec_alphabet_type_other_plus(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_conf_sec_alphabet_type_others, args);
}

TTterm
TTbuildVSC_conf_sec_are(TTterm t1)
{
    assert(TTist_ARE(t1) || TTist_IS(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_conf_sec_are, args);
}

TTterm
TTbuildVSC_conf_sec_class_clause(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_CLASS(t1) && TTisVSC_expr_class_name(t2) && TTist_IS_opt(t3) && TTisVSC_expr_literal_through_literal_plus(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_conf_sec_class_clause, args);
}

TTterm
TTbuildVSC_conf_sec_configuration_section(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_CONFIGURATION(t1) && TTist_SECTION(t2) && TTist_qdot(t3) && TTisVSC_conf_sec_configuration_section_paragraphs(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_conf_sec_configuration_section, args);
}

TTterm
TTbuildVSC_conf_sec_configuration_section_paragraph(TTterm t1)
{
    assert(TTisVSC_conf_sec_source_computer_paragraph(t1) || TTisVSC_conf_sec_object_computer_paragraph(t1) || TTisVSC_conf_sec_special_names_paragraph(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_conf_sec_configuration_section_paragraph, args);
}

TTterm
TTbuildVSC_conf_sec_configuration_section_paragraphs(TTterm t1)
{
    assert(TTisVSC_conf_sec_configuration_section_paragraph_star(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_conf_sec_configuration_section_paragraphs, args);
}

TTterm
TTbuildVSC_conf_sec_currency_sign_clause(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_CURRENCY(t1) && TTist_SIGN_opt(t2) && TTist_IS_opt(t3) && TTisVSC_expr_literal(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_conf_sec_currency_sign_clause, args);
}

TTterm
TTbuildVSC_conf_sec_decimal_point_clause(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_DECIMAL_POINT(t1) && TTist_IS_opt(t2) && TTist_COMMA(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_conf_sec_decimal_point_clause, args);
}

TTterm
TTbuildVSC_conf_sec_in_alphabet_name(TTterm t1, TTterm t2)
{
    assert(TTist_IN(t1) && TTisVSC_expr_alphabet_name(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_conf_sec_in_alphabet_name, args);
}

TTterm
TTbuildVSC_conf_sec_is_mnemonic_name(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_IS_opt(t1) && TTisVSC_expr_mnemonic_name(t2) && TTisVSC_conf_sec_special_names_paragraph_status_phrase_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_conf_sec_is_mnemonic_name, args);
}

TTterm
TTbuildVSC_conf_sec_memory_size(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_MEMORY(t1) && TTist_SIZE_opt(t2) && TTisVSC_expr_integer(t3) && TTisVSC_conf_sec_memory_size_type(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_conf_sec_memory_size, args);
}

TTterm
TTbuildVSC_conf_sec_memory_size_type(TTterm t1)
{
    assert(TTist_WORDS(t1) || TTist_CHARACTERS(t1) || TTist_MODULES(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_conf_sec_memory_size_type, args);
}

TTterm
TTbuildVSC_conf_sec_object_computer_name(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_expr_computer_name(t1) && TTisVSC_conf_sec_memory_size_opt(t2) && TTisVSC_conf_sec_object_computer_paragraph_sequence_phrase(t3) && TTist_qdot(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_conf_sec_object_computer_name, args);
}

TTterm
TTbuildVSC_conf_sec_object_computer_paragraph(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_OBJECT_COMPUTER(t1) && TTist_qdot(t2) && TTisVSC_conf_sec_object_computer_name_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_conf_sec_object_computer_paragraph, args);
}

TTterm
TTbuildVSC_conf_sec_object_computer_paragraph_sequence_phrase(TTterm t1, TTterm t2)
{
    assert(TTisVSC_conf_sec_program_collating_sequence_opt(t1) && TTisVSC_conf_sec_segment_limit_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_conf_sec_object_computer_paragraph_sequence_phrase, args);
}

TTterm
TTbuildVSC_conf_sec_off_status(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_OFF(t1) && TTist_STATUS_opt(t2) && TTist_IS_opt(t3) && TTisVSC_cond_condition(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_conf_sec_off_status, args);
}

TTterm
TTbuildVSC_conf_sec_on_status(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_ON(t1) && TTist_STATUS_opt(t2) && TTist_IS_opt(t3) && TTisVSC_cond_condition(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_conf_sec_on_status, args);
}

TTterm
TTbuildVSC_conf_sec_program_collating_sequence(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_PROGRAM_opt(t1) && TTist_COLLATING_opt(t2) && TTist_SEQUENCE(t3) && TTist_IS_opt(t4) && TTisVSC_expr_alphabet_name(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_conf_sec_program_collating_sequence, args);
}

TTterm
TTbuildVSC_conf_sec_segment_limit(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_SEGMENT_LIMIT(t1) && TTist_IS_opt(t2) && TTisVSC_expr_priority_number(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_conf_sec_segment_limit, args);
}

TTterm
TTbuildVSC_conf_sec_source_computer_name(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_computer_name(t1) && TTisVSC_conf_sec_with_debugging_mode_opt(t2) && TTist_qdot(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_conf_sec_source_computer_name, args);
}

TTterm
TTbuildVSC_conf_sec_source_computer_paragraph(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_SOURCE_COMPUTER(t1) && TTist_qdot(t2) && TTisVSC_conf_sec_source_computer_name_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_conf_sec_source_computer_paragraph, args);
}

TTterm
TTbuildVSC_conf_sec_special_names_paragraph(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_SPECIAL_NAMES(t1) && TTist_qdot(t2) && TTisVSC_conf_sec_special_names_paragraph_phrase_star(t3) && TTisVSC_conf_sec_special_names_paragraph_clauses(t4) && TTist_qdot_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_conf_sec_special_names_paragraph, args);
}

TTterm
TTbuildVSC_conf_sec_special_names_paragraph_clause(TTterm t1)
{
    assert(TTisVSC_conf_sec_alphabet_clause(t1) || TTisVSC_conf_sec_symbolic_characters_clause(t1) || TTisVSC_conf_sec_class_clause(t1) || TTisVSC_conf_sec_currency_sign_clause(t1) || TTisVSC_conf_sec_decimal_point_clause(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_conf_sec_special_names_paragraph_clause, args);
}

TTterm
TTbuildVSC_conf_sec_special_names_paragraph_clauses(TTterm t1)
{
    assert(TTisVSC_conf_sec_special_names_paragraph_clause_star(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_conf_sec_special_names_paragraph_clauses, args);
}

TTterm
TTbuildVSC_conf_sec_special_names_paragraph_phrase(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_environment_name(t1) && TTisVSC_conf_sec_special_names_paragraph_phrase_tail(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_conf_sec_special_names_paragraph_phrase, args);
}

TTterm
TTbuildVSC_conf_sec_special_names_paragraph_phrase_tail(TTterm t1)
{
    assert(TTisVSC_conf_sec_is_mnemonic_name(t1) || TTisVSC_conf_sec_special_names_paragraph_status_phrase(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_conf_sec_special_names_paragraph_phrase_tail, args);
}

TTterm
TTbuildVSC_conf_sec_special_names_paragraph_status_phrase(TTterm t1)
{
    assert(TTisVSC_conf_sec_special_names_paragraph_status_phrase_1(t1) || TTisVSC_conf_sec_special_names_paragraph_status_phrase_2(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_conf_sec_special_names_paragraph_status_phrase, args);
}

TTterm
TTbuildVSC_conf_sec_special_names_paragraph_status_phrase_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_ON(t1) && TTist_STATUS_opt(t2) && TTist_IS_opt(t3) && TTisVSC_cond_condition(t4) && TTisVSC_conf_sec_off_status_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_conf_sec_special_names_paragraph_status_phrase_1, args);
}

TTterm
TTbuildVSC_conf_sec_special_names_paragraph_status_phrase_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_OFF(t1) && TTist_STATUS_opt(t2) && TTist_IS_opt(t3) && TTisVSC_cond_condition(t4) && TTisVSC_conf_sec_on_status_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_conf_sec_special_names_paragraph_status_phrase_2, args);
}

TTterm
TTbuildVSC_conf_sec_symbolic_character_mapping(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_symbolic_character_plus(t1) && TTisVSC_conf_sec_are_opt(t2) && TTisVSC_expr_integer_plus(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_conf_sec_symbolic_character_mapping, args);
}

TTterm
TTbuildVSC_conf_sec_symbolic_characters_clause(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_SYMBOLIC(t1) && TTist_CHARACTERS_opt(t2) && TTisVSC_conf_sec_symbolic_character_mapping_plus(t3) && TTisVSC_conf_sec_in_alphabet_name_opt(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_conf_sec_symbolic_characters_clause, args);
}

TTterm
TTbuildVSC_conf_sec_with_debugging_mode(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_WITH_opt(t1) && TTist_DEBUGGING(t2) && TTist_MODE(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_conf_sec_with_debugging_mode, args);
}

TTterm
TTbuildVSC_data_div_data_division(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_DATA(t1) && TTist_DIVISION(t2) && TTist_qdot(t3) && TTisVSC_data_div_data_division_content(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_data_div_data_division, args);
}

TTterm
TTbuildVSC_data_div_data_division_content(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_data_div_file_section_opt(t1) && TTisVSC_data_div_working_storage_section_opt(t2) && TTisVSC_data_div_linkage_section_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_data_div_data_division_content, args);
}

TTterm
TTbuildVSC_data_div_file_section(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_FILE(t1) && TTist_SECTION(t2) && TTist_qdot(t3) && TTisVSC_data_div_file_section_entry_star(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_data_div_file_section, args);
}

TTterm
TTbuildVSC_data_div_file_section_entry(TTterm t1, TTterm t2)
{
    assert(TTisVSC_fd_entry_file_and_sort_description_entry(t1) && TTisVSC_dd_entry_data_description_entry_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_data_div_file_section_entry, args);
}

TTterm
TTbuildVSC_data_div_linkage_section(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_LINKAGE(t1) && TTist_SECTION(t2) && TTist_qdot(t3) && TTisVSC_dd_entry_data_description_entry_star(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_data_div_linkage_section, args);
}

TTterm
TTbuildVSC_data_div_working_storage_section(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_WORKING_STORAGE(t1) && TTist_SECTION(t2) && TTist_qdot(t3) && TTisVSC_dd_entry_data_description_entry_star(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_data_div_working_storage_section, args);
}

TTterm
TTbuildVSC_dd_entry_alt_data_name_filler(TTterm t1)
{
    assert(TTisVSC_expr_data_name(t1) || TTist_FILLER(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_dd_entry_alt_data_name_filler, args);
}

TTterm
TTbuildVSC_dd_entry_alt_leading_trailing(TTterm t1)
{
    assert(TTist_LEADING(t1) || TTist_TRAILING(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_dd_entry_alt_leading_trailing, args);
}

TTterm
TTbuildVSC_dd_entry_alt_left_right(TTterm t1)
{
    assert(TTist_LEFT(t1) || TTist_RIGHT(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_dd_entry_alt_left_right, args);
}

TTterm
TTbuildVSC_dd_entry_blank_when_zero_clause(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_BLANK(t1) && TTist_WHEN_opt(t2) && TTisVSC_dd_entry_zeroes(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_dd_entry_blank_when_zero_clause, args);
}

TTterm
TTbuildVSC_dd_entry_condition_value_clause(TTterm t1, TTterm t2)
{
    assert(TTisVSC_dd_entry_values_are(t1) && TTisVSC_expr_literal_through_literal_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_dd_entry_condition_value_clause, args);
}

TTterm
TTbuildVSC_dd_entry_data_description_entry(TTterm t1)
{
    assert(TTisVSC_dd_entry_data_description_entry_1(t1) || TTisVSC_expr_copy_statement(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_dd_entry_data_description_entry, args);
}

TTterm
TTbuildVSC_dd_entry_data_description_entry_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_expr_level_number(t1) && TTisVSC_dd_entry_alt_data_name_filler_opt(t2) && TTisVSC_dd_entry_data_description_entry_clauses(t3) && TTist_qdot_opt(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_dd_entry_data_description_entry_1, args);
}

TTterm
TTbuildVSC_dd_entry_data_description_entry_clause(TTterm t1)
{
    assert(TTisVSC_dd_entry_picture_clause(t1) || TTisVSC_dd_entry_redefines_clause(t1) || TTisVSC_dd_entry_blank_when_zero_clause(t1) || TTisVSC_dd_entry_external_clause(t1) || TTisVSC_dd_entry_global_clause(t1) || TTisVSC_dd_entry_justified_clause(t1) || TTisVSC_dd_entry_occurs_clause(t1) || TTisVSC_dd_entry_sign_clause(t1) || TTisVSC_dd_entry_synchronized_clause(t1) || TTisVSC_dd_entry_usage_clause(t1) || TTisVSC_dd_entry_renames_clause(t1) || TTisVSC_dd_entry_condition_value_clause(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_dd_entry_data_description_entry_clause, args);
}

TTterm
TTbuildVSC_dd_entry_data_description_entry_clauses(TTterm t1)
{
    assert(TTisVSC_dd_entry_data_description_entry_clause_star(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_dd_entry_data_description_entry_clauses, args);
}

TTterm
TTbuildVSC_dd_entry_external_clause(TTterm t1, TTterm t2)
{
    assert(TTist_IS_opt(t1) && TTist_EXTERNAL(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_dd_entry_external_clause, args);
}

TTterm
TTbuildVSC_dd_entry_global_clause(TTterm t1, TTterm t2)
{
    assert(TTist_IS_opt(t1) && TTist_GLOBAL(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_dd_entry_global_clause, args);
}

TTterm
TTbuildVSC_dd_entry_indexed_by(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_INDEXED(t1) && TTist_BY_opt(t2) && TTisVSC_expr_index_name_plus(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_dd_entry_indexed_by, args);
}

TTterm
TTbuildVSC_dd_entry_integer_to(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_integer(t1) && TTist_TO(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_dd_entry_integer_to, args);
}

TTterm
TTbuildVSC_dd_entry_justified(TTterm t1)
{
    assert(TTist_JUSTIFIED(t1) || TTist_JUST(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_dd_entry_justified, args);
}

TTterm
TTbuildVSC_dd_entry_justified_clause(TTterm t1, TTterm t2)
{
    assert(TTisVSC_dd_entry_justified(t1) && TTist_RIGHT_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_dd_entry_justified_clause, args);
}

TTterm
TTbuildVSC_dd_entry_occurs_clause(TTterm t1)
{
    assert(TTisVSC_dd_entry_occurs_clause_2(t1) || TTisVSC_dd_entry_occurs_clause_1(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_dd_entry_occurs_clause, args);
}

TTterm
TTbuildVSC_dd_entry_occurs_clause_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_OCCURS(t1) && TTisVSC_expr_integer(t2) && TTist_TIMES_opt(t3) && TTisVSC_dd_entry_occurs_clause_key_star(t4) && TTisVSC_dd_entry_indexed_by_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_dd_entry_occurs_clause_1, args);
}

TTterm
TTbuildVSC_dd_entry_occurs_clause_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9)
{
    assert(TTist_OCCURS(t1) && TTisVSC_dd_entry_integer_to_opt(t2) && TTisVSC_expr_integer(t3) && TTist_TIMES_opt(t4) && TTist_DEPENDING(t5) && TTist_ON_opt(t6) && TTisVSC_expr_qualified_data_name(t7) && TTisVSC_dd_entry_occurs_clause_key_star(t8) && TTisVSC_dd_entry_indexed_by_opt(t9));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    return TTbuild_term(TTfunVSC_dd_entry_occurs_clause_2, args);
}

TTterm
TTbuildVSC_dd_entry_occurs_clause_key(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_expr_alt_ascending_descending(t1) && TTist_KEY_opt(t2) && TTist_IS_opt(t3) && TTisVSC_expr_qualified_data_name_plus(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_dd_entry_occurs_clause_key, args);
}

TTterm
TTbuildVSC_dd_entry_picture(TTterm t1)
{
    assert(TTist_PICTURE(t1) || TTist_PIC(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_dd_entry_picture, args);
}

TTterm
TTbuildVSC_dd_entry_picture_clause(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_dd_entry_picture(t1) && TTist_IS_opt(t2) && TTisVSC_lex_picture_string(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_dd_entry_picture_clause, args);
}

TTterm
TTbuildVSC_dd_entry_redefines_clause(TTterm t1, TTterm t2)
{
    assert(TTist_REDEFINES(t1) && TTisVSC_expr_data_name(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_dd_entry_redefines_clause, args);
}

TTterm
TTbuildVSC_dd_entry_renames_clause(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_RENAMES(t1) && TTisVSC_expr_qualified_data_name(t2) && TTisVSC_expr_through_qualified_data_name_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_dd_entry_renames_clause, args);
}

TTterm
TTbuildVSC_dd_entry_separate_character(TTterm t1, TTterm t2)
{
    assert(TTist_SEPARATE(t1) && TTist_CHARACTER_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_dd_entry_separate_character, args);
}

TTterm
TTbuildVSC_dd_entry_sign_clause(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_dd_entry_sign_is_opt(t1) && TTisVSC_dd_entry_alt_leading_trailing(t2) && TTisVSC_dd_entry_separate_character_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_dd_entry_sign_clause, args);
}

TTterm
TTbuildVSC_dd_entry_sign_is(TTterm t1, TTterm t2)
{
    assert(TTist_SIGN(t1) && TTist_IS_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_dd_entry_sign_is, args);
}

TTterm
TTbuildVSC_dd_entry_synchronized(TTterm t1)
{
    assert(TTist_SYNCHRONIZED(t1) || TTist_SYNC(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_dd_entry_synchronized, args);
}

TTterm
TTbuildVSC_dd_entry_synchronized_clause(TTterm t1, TTterm t2)
{
    assert(TTisVSC_dd_entry_synchronized(t1) && TTisVSC_dd_entry_alt_left_right_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_dd_entry_synchronized_clause, args);
}

TTterm
TTbuildVSC_dd_entry_usage(TTterm t1)
{
    assert(TTist_BINARY(t1) || TTist_COMP(t1) || TTist_COMP_1(t1) || TTist_COMP_2(t1) || TTist_COMP_3(t1) || TTist_COMP_4(t1) || TTist_COMPUTATIONAL(t1) || TTist_COMPUTATIONAL_1(t1) || TTist_COMPUTATIONAL_2(t1) || TTist_COMPUTATIONAL_3(t1) || TTist_COMPUTATIONAL_4(t1) || TTist_DISPLAY(t1) || TTist_DISPLAY_1(t1) || TTist_INDEX(t1) || TTist_PACKED_DECIMAL(t1) || TTist_POINTER(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_dd_entry_usage, args);
}

TTterm
TTbuildVSC_dd_entry_usage_clause(TTterm t1, TTterm t2)
{
    assert(TTisVSC_dd_entry_usage_is_opt(t1) && TTisVSC_dd_entry_usage(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_dd_entry_usage_clause, args);
}

TTterm
TTbuildVSC_dd_entry_usage_is(TTterm t1, TTterm t2)
{
    assert(TTist_USAGE(t1) && TTist_IS_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_dd_entry_usage_is, args);
}

TTterm
TTbuildVSC_dd_entry_values_are(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_values(t1) && TTisVSC_conf_sec_are_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_dd_entry_values_are, args);
}

TTterm
TTbuildVSC_dd_entry_zeroes(TTterm t1)
{
    assert(TTist_ZERO(t1) || TTist_ZEROS(t1) || TTist_ZEROES(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_dd_entry_zeroes, args);
}

TTterm
TTbuildVSC_env_div_environment_division(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_ENVIRONMENT(t1) && TTist_DIVISION(t2) && TTist_qdot(t3) && TTisVSC_env_div_environment_division_content(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_env_div_environment_division, args);
}

TTterm
TTbuildVSC_env_div_environment_division_content(TTterm t1, TTterm t2)
{
    assert(TTisVSC_conf_sec_configuration_section_opt(t1) && TTisVSC_io_sec_input_output_section_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_env_div_environment_division_content, args);
}

TTterm
TTbuildVSC_expr_alphabet_name(TTterm t1)
{
    assert(TTisVSC_expr_alphabetic_user_defined_word(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_alphabet_name, args);
}

TTterm
TTbuildVSC_expr_alphabetic_user_defined_word(TTterm t1)
{
    assert(TTisVSC_lex_cobword(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_alphabetic_user_defined_word, args);
}

TTterm
TTbuildVSC_expr_alt_ascending_descending(TTterm t1)
{
    assert(TTist_ASCENDING(t1) || TTist_DESCENDING(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_alt_ascending_descending, args);
}

TTterm
TTbuildVSC_expr_alt_library_name_literal(TTterm t1)
{
    assert(TTisVSC_expr_library_name(t1) || TTisVSC_expr_literal(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_alt_library_name_literal, args);
}

TTterm
TTbuildVSC_expr_alt_plus_minus(TTterm t1)
{
    assert(TTist_qplus(t1) || TTist__(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_alt_plus_minus, args);
}

TTterm
TTbuildVSC_expr_alt_reel_unit(TTterm t1)
{
    assert(TTist_REEL(t1) || TTist_UNIT(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_alt_reel_unit, args);
}

TTterm
TTbuildVSC_expr_alt_text_name_literal(TTterm t1)
{
    assert(TTisVSC_expr_text_name(t1) || TTisVSC_expr_literal(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_alt_text_name_literal, args);
}

TTterm
TTbuildVSC_expr_alt_times_div(TTterm t1)
{
    assert(TTist_qmultiply(t1) || TTist_qdivide(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_alt_times_div, args);
}

TTterm
TTbuildVSC_expr_arithmetic_expression(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_times_div(t1) && TTisVSC_expr_arithmetic_expression_tail_star(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_arithmetic_expression, args);
}

TTterm
TTbuildVSC_expr_arithmetic_expression_tail(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_alt_plus_minus(t1) && TTisVSC_expr_times_div(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_arithmetic_expression_tail, args);
}

TTterm
TTbuildVSC_expr_assignment_name(TTterm t1)
{
    assert(TTisVSC_expr_system_name(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_assignment_name, args);
}

TTterm
TTbuildVSC_expr_basis(TTterm t1)
{
    assert(TTisVSC_expr_literal(t1) || TTisVSC_expr_identifier(t1) || TTisVSC_expr_basis_1(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_basis, args);
}

TTterm
TTbuildVSC_expr_basis_1(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_qpopen(t1) && TTisVSC_expr_arithmetic_expression(t2) && TTist_qpclose(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_expr_basis_1, args);
}

TTterm
TTbuildVSC_expr_class_name(TTterm t1)
{
    assert(TTisVSC_expr_alphabetic_user_defined_word(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_class_name, args);
}

TTterm
TTbuildVSC_expr_computer_name(TTterm t1)
{
    assert(TTisVSC_expr_system_name(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_computer_name, args);
}

TTterm
TTbuildVSC_expr_condition_name(TTterm t1)
{
    assert(TTisVSC_expr_alphabetic_user_defined_word(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_condition_name, args);
}

TTterm
TTbuildVSC_expr_copy_operand(TTterm t1)
{
    assert(TTisVSC_lex_quoted_pseudo_text(t1) || TTisVSC_expr_identifier(t1) || TTisVSC_expr_literal(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_copy_operand, args);
}

TTterm
TTbuildVSC_expr_copy_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6)
{
    assert(TTist_COPY(t1) && TTisVSC_expr_alt_text_name_literal(t2) && TTisVSC_expr_in_library_opt(t3) && TTist_SUPPRESS_opt(t4) && TTisVSC_expr_copy_statement_replacing_phrase_opt(t5) && TTist_qdot(t6));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    return TTbuild_term(TTfunVSC_expr_copy_statement, args);
}

TTterm
TTbuildVSC_expr_copy_statement_by_phrase(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_copy_operand(t1) && TTist_BY(t2) && TTisVSC_expr_copy_operand(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_expr_copy_statement_by_phrase, args);
}

TTterm
TTbuildVSC_expr_copy_statement_replacing_phrase(TTterm t1, TTterm t2)
{
    assert(TTist_REPLACING(t1) && TTisVSC_expr_copy_statement_by_phrase_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_copy_statement_replacing_phrase, args);
}

TTterm
TTbuildVSC_expr_data_name(TTterm t1)
{
    assert(TTisVSC_expr_alphabetic_user_defined_word(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_data_name, args);
}

TTterm
TTbuildVSC_expr_data_or_file_name(TTterm t1)
{
    assert(TTisVSC_expr_alphabetic_user_defined_word(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_data_or_file_name, args);
}

TTterm
TTbuildVSC_expr_data_or_file_or_mnemonic_name(TTterm t1)
{
    assert(TTisVSC_expr_alphabetic_user_defined_word(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_data_or_file_or_mnemonic_name, args);
}

TTterm
TTbuildVSC_expr_environment_name(TTterm t1)
{
    assert(TTisVSC_expr_system_name(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_environment_name, args);
}

TTterm
TTbuildVSC_expr_equal_to(TTterm t1)
{
    assert(TTisVSC_expr_equal_to_1(t1) || TTist_qequal(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_equal_to, args);
}

TTterm
TTbuildVSC_expr_equal_to_1(TTterm t1, TTterm t2)
{
    assert(TTist_EQUAL(t1) && TTist_TO_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_equal_to_1, args);
}

TTterm
TTbuildVSC_expr_figurative_constant(TTterm t1)
{
    assert(TTisVSC_expr_figurative_constant_simple(t1) || TTisVSC_expr_figurative_constant_all(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_figurative_constant, args);
}

TTterm
TTbuildVSC_expr_figurative_constant_all(TTterm t1, TTterm t2)
{
    assert(TTist_ALL(t1) && TTisVSC_expr_literal(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_figurative_constant_all, args);
}

TTterm
TTbuildVSC_expr_figurative_constant_simple(TTterm t1)
{
    assert(TTist_ZERO(t1) || TTist_ZEROS(t1) || TTist_ZEROES(t1) || TTist_SPACE(t1) || TTist_SPACES(t1) || TTist_HIGH_VALUE(t1) || TTist_HIGH_VALUES(t1) || TTist_LOW_VALUE(t1) || TTist_LOW_VALUES(t1) || TTist_QUOTE(t1) || TTist_QUOTES(t1) || TTist_NULL(t1) || TTist_NULLS(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_figurative_constant_simple, args);
}

TTterm
TTbuildVSC_expr_file_name(TTterm t1)
{
    assert(TTisVSC_expr_alphabetic_user_defined_word(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_file_name, args);
}

TTterm
TTbuildVSC_expr_identifier(TTterm t1)
{
    assert(TTisVSC_expr_identifier_1(t1) || TTisVSC_expr_identifier_2(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_identifier, args);
}

TTterm
TTbuildVSC_expr_identifier_1(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_qualified_data_name(t1) && TTisVSC_expr_subscript_parentheses_star(t2) && TTisVSC_expr_reference_modification_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_expr_identifier_1, args);
}

TTterm
TTbuildVSC_expr_identifier_2(TTterm t1, TTterm t2)
{
    assert(TTist_LINAGE_COUNTER(t1) && TTisVSC_expr_in_file_name_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_identifier_2, args);
}

TTterm
TTbuildVSC_expr_in(TTterm t1)
{
    assert(TTist_OF(t1) || TTist_IN(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_in, args);
}

TTterm
TTbuildVSC_expr_in_data_or_file_name(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_in(t1) && TTisVSC_expr_data_or_file_name(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_in_data_or_file_name, args);
}

TTterm
TTbuildVSC_expr_in_data_or_file_or_mnemonic_name(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_in(t1) && TTisVSC_expr_data_or_file_or_mnemonic_name(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_in_data_or_file_or_mnemonic_name, args);
}

TTterm
TTbuildVSC_expr_in_file_name(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_in(t1) && TTisVSC_expr_file_name(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_in_file_name, args);
}

TTterm
TTbuildVSC_expr_in_library(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_in(t1) && TTisVSC_expr_alt_library_name_literal(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_in_library, args);
}

TTterm
TTbuildVSC_expr_in_section_name(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_in(t1) && TTisVSC_expr_section_name(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_in_section_name, args);
}

TTterm
TTbuildVSC_expr_index_name(TTterm t1)
{
    assert(TTisVSC_expr_alphabetic_user_defined_word(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_index_name, args);
}

TTterm
TTbuildVSC_expr_integer(TTterm t1)
{
    assert(TTisVSC_lex_num(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_integer, args);
}

TTterm
TTbuildVSC_expr_leftmost_character_position(TTterm t1)
{
    assert(TTisVSC_expr_arithmetic_expression(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_leftmost_character_position, args);
}

TTterm
TTbuildVSC_expr_length(TTterm t1)
{
    assert(TTisVSC_expr_arithmetic_expression(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_length, args);
}

TTterm
TTbuildVSC_expr_level_number(TTterm t1)
{
    assert(TTisVSC_lex_num(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_level_number, args);
}

TTterm
TTbuildVSC_expr_library_name(TTterm t1)
{
    assert(TTisVSC_expr_user_defined_word(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_library_name, args);
}

TTterm
TTbuildVSC_expr_literal(TTterm t1)
{
    assert(TTisVSC_lex_nonnumeric(t1) || TTisVSC_expr_numeric(t1) || TTisVSC_expr_figurative_constant(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_literal, args);
}

TTterm
TTbuildVSC_expr_literal_through_literal(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_literal(t1) && TTisVSC_expr_through_literal_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_literal_through_literal, args);
}

TTterm
TTbuildVSC_expr_mnemonic_name(TTterm t1)
{
    assert(TTisVSC_expr_alphabetic_user_defined_word(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_mnemonic_name, args);
}

TTterm
TTbuildVSC_expr_numeric(TTterm t1)
{
    assert(TTisVSC_lex_num(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_numeric, args);
}

TTterm
TTbuildVSC_expr_paragraph_name(TTterm t1)
{
    assert(TTisVSC_expr_user_defined_word(t1) || TTisVSC_expr_integer(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_paragraph_name, args);
}

TTterm
TTbuildVSC_expr_paragraph_or_section_name(TTterm t1)
{
    assert(TTisVSC_expr_user_defined_word(t1) || TTisVSC_expr_integer(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_paragraph_or_section_name, args);
}

TTterm
TTbuildVSC_expr_plus_minus_integer(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_alt_plus_minus(t1) && TTisVSC_expr_integer(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_plus_minus_integer, args);
}

TTterm
TTbuildVSC_expr_power(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_alt_plus_minus_opt(t1) && TTisVSC_expr_basis(t2) && TTisVSC_expr_power_tail_star(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_expr_power, args);
}

TTterm
TTbuildVSC_expr_power_tail(TTterm t1, TTterm t2)
{
    assert(TTist_qmultiply_qmultiply(t1) && TTisVSC_expr_basis(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_power_tail, args);
}

TTterm
TTbuildVSC_expr_priority_number(TTterm t1)
{
    assert(TTisVSC_lex_num(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_priority_number, args);
}

TTterm
TTbuildVSC_expr_procedure_name(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_paragraph_or_section_name(t1) && TTisVSC_expr_in_section_name_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_procedure_name, args);
}

TTterm
TTbuildVSC_expr_program_name(TTterm t1)
{
    assert(TTisVSC_expr_user_defined_word(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_program_name, args);
}

TTterm
TTbuildVSC_expr_qualified_data_name(TTterm t1)
{
    assert(TTisVSC_expr_qualified_data_name_1(t1) || TTisVSC_expr_special_register_1(t1) || TTisVSC_expr_special_register_2(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_qualified_data_name, args);
}

TTterm
TTbuildVSC_expr_qualified_data_name_1(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_data_name(t1) && TTisVSC_expr_in_data_or_file_name_star(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_qualified_data_name_1, args);
}

TTterm
TTbuildVSC_expr_record_name(TTterm t1)
{
    assert(TTisVSC_expr_qualified_data_name(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_record_name, args);
}

TTterm
TTbuildVSC_expr_records(TTterm t1)
{
    assert(TTist_RECORD(t1) || TTist_RECORDS(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_records, args);
}

TTterm
TTbuildVSC_expr_reference_modification(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_qpopen(t1) && TTisVSC_expr_leftmost_character_position(t2) && TTist_qcolon(t3) && TTisVSC_expr_length_opt(t4) && TTist_qpclose(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_expr_reference_modification, args);
}

TTterm
TTbuildVSC_expr_section_name(TTterm t1)
{
    assert(TTisVSC_expr_user_defined_word(t1) || TTisVSC_expr_integer(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_section_name, args);
}

TTterm
TTbuildVSC_expr_special_register_1(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_ADDRESS(t1) && TTist_OF(t2) && TTisVSC_expr_data_name(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_expr_special_register_1, args);
}

TTterm
TTbuildVSC_expr_special_register_2(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_LENGTH(t1) && TTist_OF(t2) && TTisVSC_expr_identifier(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_expr_special_register_2, args);
}

TTterm
TTbuildVSC_expr_subscript(TTterm t1)
{
    assert(TTisVSC_expr_subscript_expression_plus(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_subscript, args);
}

TTterm
TTbuildVSC_expr_subscript_expression(TTterm t1)
{
    assert(TTisVSC_expr_literal(t1) || TTisVSC_expr_subscript_expression_ambiguous(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_subscript_expression, args);
}

TTterm
TTbuildVSC_expr_subscript_expression_ambiguous(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_qualified_data_name(t1) && TTisVSC_expr_plus_minus_integer_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_subscript_expression_ambiguous, args);
}

TTterm
TTbuildVSC_expr_subscript_parentheses(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_qpopen(t1) && TTisVSC_expr_subscript(t2) && TTist_qpclose(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_expr_subscript_parentheses, args);
}

TTterm
TTbuildVSC_expr_symbolic_character(TTterm t1)
{
    assert(TTisVSC_expr_alphabetic_user_defined_word(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_symbolic_character, args);
}

TTterm
TTbuildVSC_expr_system_name(TTterm t1)
{
    assert(TTisVSC_lex_cobword(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_system_name, args);
}

TTterm
TTbuildVSC_expr_text_name(TTterm t1)
{
    assert(TTisVSC_expr_user_defined_word(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_text_name, args);
}

TTterm
TTbuildVSC_expr_through(TTterm t1)
{
    assert(TTist_THROUGH(t1) || TTist_THRU(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_through, args);
}

TTterm
TTbuildVSC_expr_through_arithmetic_expression(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_through(t1) && TTisVSC_expr_arithmetic_expression(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_through_arithmetic_expression, args);
}

TTterm
TTbuildVSC_expr_through_literal(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_through(t1) && TTisVSC_expr_literal(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_through_literal, args);
}

TTterm
TTbuildVSC_expr_through_qualified_data_name(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_through(t1) && TTisVSC_expr_qualified_data_name(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_through_qualified_data_name, args);
}

TTterm
TTbuildVSC_expr_times_div(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_power(t1) && TTisVSC_expr_times_div_tail_star(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_times_div, args);
}

TTterm
TTbuildVSC_expr_times_div_tail(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_alt_times_div(t1) && TTisVSC_expr_power(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_expr_times_div_tail, args);
}

TTterm
TTbuildVSC_expr_user_defined_word(TTterm t1)
{
    assert(TTisVSC_lex_cobword(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_user_defined_word, args);
}

TTterm
TTbuildVSC_expr_values(TTterm t1)
{
    assert(TTist_VALUE(t1) || TTist_VALUES(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_expr_values, args);
}

TTterm
TTbuildVSC_fd_entry_alt_characters_records(TTterm t1)
{
    assert(TTist_CHARACTERS(t1) || TTist_RECORDS(t1) || TTist_RECORD(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_fd_entry_alt_characters_records, args);
}

TTterm
TTbuildVSC_fd_entry_alt_data_name_integer(TTterm t1)
{
    assert(TTisVSC_expr_data_name(t1) || TTisVSC_expr_integer(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_fd_entry_alt_data_name_integer, args);
}

TTterm
TTbuildVSC_fd_entry_alt_fd_sd(TTterm t1)
{
    assert(TTist_FD(t1) || TTist_SD(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_fd_entry_alt_fd_sd, args);
}

TTterm
TTbuildVSC_fd_entry_alt_qualified_data_name_literal(TTterm t1)
{
    assert(TTisVSC_expr_qualified_data_name(t1) || TTisVSC_expr_literal(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_fd_entry_alt_qualified_data_name_literal, args);
}

TTterm
TTbuildVSC_fd_entry_block_contains_clause(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_BLOCK(t1) && TTist_CONTAINS_opt(t2) && TTisVSC_dd_entry_integer_to_opt(t3) && TTisVSC_expr_integer(t4) && TTisVSC_fd_entry_alt_characters_records_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_fd_entry_block_contains_clause, args);
}

TTterm
TTbuildVSC_fd_entry_code_set_clause(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_CODE_SET(t1) && TTist_IS_opt(t2) && TTisVSC_expr_alphabet_name(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_fd_entry_code_set_clause, args);
}

TTterm
TTbuildVSC_fd_entry_data_names(TTterm t1)
{
    assert(TTisVSC_expr_data_name_plus(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_fd_entry_data_names, args);
}

TTterm
TTbuildVSC_fd_entry_data_records_clause(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_DATA(t1) && TTisVSC_fd_entry_records_are(t2) && TTisVSC_expr_data_name_plus(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_fd_entry_data_records_clause, args);
}

TTterm
TTbuildVSC_fd_entry_depending_on(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_DEPENDING(t1) && TTist_ON_opt(t2) && TTisVSC_expr_data_name(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_fd_entry_depending_on, args);
}

TTterm
TTbuildVSC_fd_entry_file_and_sort_description_entry(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_fd_entry_alt_fd_sd(t1) && TTisVSC_expr_file_name(t2) && TTisVSC_fd_entry_file_and_sort_description_entry_clauses(t3) && TTist_qdot(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_fd_entry_file_and_sort_description_entry, args);
}

TTterm
TTbuildVSC_fd_entry_file_and_sort_description_entry_clause(TTterm t1)
{
    assert(TTisVSC_dd_entry_external_clause(t1) || TTisVSC_dd_entry_global_clause(t1) || TTisVSC_fd_entry_block_contains_clause(t1) || TTisVSC_fd_entry_record_clause(t1) || TTisVSC_fd_entry_label_records_clause(t1) || TTisVSC_fd_entry_value_of_clause(t1) || TTisVSC_fd_entry_data_records_clause(t1) || TTisVSC_fd_entry_linage_clause(t1) || TTisVSC_fd_entry_recording_mode_clause(t1) || TTisVSC_fd_entry_code_set_clause(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_fd_entry_file_and_sort_description_entry_clause, args);
}

TTterm
TTbuildVSC_fd_entry_file_and_sort_description_entry_clauses(TTterm t1)
{
    assert(TTisVSC_fd_entry_file_and_sort_description_entry_clause_star(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_fd_entry_file_and_sort_description_entry_clauses, args);
}

TTterm
TTbuildVSC_fd_entry_footing(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_WITH_opt(t1) && TTist_FOOTING(t2) && TTist_AT_opt(t3) && TTisVSC_fd_entry_alt_data_name_integer(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_fd_entry_footing, args);
}

TTterm
TTbuildVSC_fd_entry_from_integer(TTterm t1, TTterm t2)
{
    assert(TTist_FROM_opt(t1) && TTisVSC_expr_integer(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_fd_entry_from_integer, args);
}

TTterm
TTbuildVSC_fd_entry_label_records_clause(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_LABEL(t1) && TTisVSC_fd_entry_records_are(t2) && TTisVSC_fd_entry_label_records_clause_tail(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_fd_entry_label_records_clause, args);
}

TTterm
TTbuildVSC_fd_entry_label_records_clause_tail(TTterm t1)
{
    assert(TTist_STANDARD(t1) || TTist_OMITTED(t1) || TTisVSC_fd_entry_data_names(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_fd_entry_label_records_clause_tail, args);
}

TTterm
TTbuildVSC_fd_entry_linage_clause(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_LINAGE(t1) && TTist_IS_opt(t2) && TTisVSC_fd_entry_alt_data_name_integer(t3) && TTist_LINES_opt(t4) && TTisVSC_fd_entry_linage_footing_phrase(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_fd_entry_linage_clause, args);
}

TTterm
TTbuildVSC_fd_entry_linage_footing_phrase(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_fd_entry_footing_opt(t1) && TTisVSC_fd_entry_lines_top_opt(t2) && TTisVSC_fd_entry_lines_bottom_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_fd_entry_linage_footing_phrase, args);
}

TTterm
TTbuildVSC_fd_entry_lines_bottom(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_LINES_opt(t1) && TTist_AT_opt(t2) && TTist_BOTTOM(t3) && TTisVSC_fd_entry_alt_data_name_integer(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_fd_entry_lines_bottom, args);
}

TTterm
TTbuildVSC_fd_entry_lines_top(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_LINES_opt(t1) && TTist_AT_opt(t2) && TTist_TOP(t3) && TTisVSC_fd_entry_alt_data_name_integer(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_fd_entry_lines_top, args);
}

TTterm
TTbuildVSC_fd_entry_record_clause(TTterm t1, TTterm t2)
{
    assert(TTist_RECORD(t1) && TTisVSC_fd_entry_record_clause_tail(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_fd_entry_record_clause, args);
}

TTterm
TTbuildVSC_fd_entry_record_clause_tail(TTterm t1)
{
    assert(TTisVSC_fd_entry_record_clause_tail_2(t1) || TTisVSC_fd_entry_record_clause_tail_1(t1) || TTisVSC_fd_entry_record_clause_tail_3(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_fd_entry_record_clause_tail, args);
}

TTterm
TTbuildVSC_fd_entry_record_clause_tail_1(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_CONTAINS_opt(t1) && TTisVSC_expr_integer(t2) && TTist_CHARACTERS_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_fd_entry_record_clause_tail_1, args);
}

TTterm
TTbuildVSC_fd_entry_record_clause_tail_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_CONTAINS_opt(t1) && TTisVSC_expr_integer(t2) && TTist_TO(t3) && TTisVSC_expr_integer(t4) && TTist_CHARACTERS_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_fd_entry_record_clause_tail_2, args);
}

TTterm
TTbuildVSC_fd_entry_record_clause_tail_3(TTterm t1, TTterm t2)
{
    assert(TTisVSC_fd_entry_record_varying_phrase(t1) && TTisVSC_fd_entry_depending_on_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_fd_entry_record_clause_tail_3, args);
}

TTterm
TTbuildVSC_fd_entry_record_varying_phrase(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7)
{
    assert(TTist_IS_opt(t1) && TTist_VARYING(t2) && TTist_IN_opt(t3) && TTist_SIZE_opt(t4) && TTisVSC_fd_entry_from_integer_opt(t5) && TTisVSC_fd_entry_to_integer_opt(t6) && TTist_CHARACTERS_opt(t7));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    return TTbuild_term(TTfunVSC_fd_entry_record_varying_phrase, args);
}

TTterm
TTbuildVSC_fd_entry_recording_mode_clause(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_RECORDING(t1) && TTist_MODE_opt(t2) && TTist_IS_opt(t3) && TTisVSC_lex_cobword(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_fd_entry_recording_mode_clause, args);
}

TTterm
TTbuildVSC_fd_entry_records_are(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_records(t1) && TTisVSC_conf_sec_are_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_fd_entry_records_are, args);
}

TTterm
TTbuildVSC_fd_entry_to_integer(TTterm t1, TTterm t2)
{
    assert(TTist_TO(t1) && TTisVSC_expr_integer(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_fd_entry_to_integer, args);
}

TTterm
TTbuildVSC_fd_entry_value_of_clause(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_VALUE(t1) && TTist_OF(t2) && TTisVSC_fd_entry_value_of_clause_tail_plus(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_fd_entry_value_of_clause, args);
}

TTterm
TTbuildVSC_fd_entry_value_of_clause_tail(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_system_name(t1) && TTist_IS_opt(t2) && TTisVSC_fd_entry_alt_qualified_data_name_literal(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_fd_entry_value_of_clause_tail, args);
}

TTterm
TTbuildVSC_id_div_author(TTterm t1, TTterm t2)
{
    assert(TTist_AUTHOR(t1) && TTist_qdot_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_id_div_author, args);
}

TTterm
TTbuildVSC_id_div_date_compiled(TTterm t1, TTterm t2)
{
    assert(TTist_DATE_COMPILED(t1) && TTist_qdot_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_id_div_date_compiled, args);
}

TTterm
TTbuildVSC_id_div_date_written(TTterm t1, TTterm t2)
{
    assert(TTist_DATE_WRITTEN(t1) && TTist_qdot_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_id_div_date_written, args);
}

TTterm
TTbuildVSC_id_div_identification(TTterm t1)
{
    assert(TTist_IDENTIFICATION(t1) || TTist_ID(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_id_div_identification, args);
}

TTterm
TTbuildVSC_id_div_identification_division(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTisVSC_id_div_identification(t1) && TTist_DIVISION(t2) && TTist_qdot(t3) && TTisVSC_id_div_program_id_cobol_source_program(t4) && TTisVSC_id_div_identification_division_content(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_id_div_identification_division, args);
}

TTterm
TTbuildVSC_id_div_identification_division_content(TTterm t1)
{
    assert(TTisVSC_id_div_identification_division_phrase_star(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_id_div_identification_division_content, args);
}

TTterm
TTbuildVSC_id_div_identification_division_phrase(TTterm t1)
{
    assert(TTisVSC_id_div_author(t1) || TTisVSC_id_div_installation(t1) || TTisVSC_id_div_date_written(t1) || TTisVSC_id_div_date_compiled(t1) || TTisVSC_id_div_security(t1) || TTisVSC_id_div_remarks(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_id_div_identification_division_phrase, args);
}

TTterm
TTbuildVSC_id_div_initial_program(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_IS_opt(t1) && TTist_INITIAL(t2) && TTist_PROGRAM_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_id_div_initial_program, args);
}

TTterm
TTbuildVSC_id_div_installation(TTterm t1, TTterm t2)
{
    assert(TTist_INSTALLATION(t1) && TTist_qdot_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_id_div_installation, args);
}

TTterm
TTbuildVSC_id_div_program_id_cobol_source_program(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_PROGRAM_ID(t1) && TTist_qdot_opt(t2) && TTisVSC_expr_program_name(t3) && TTisVSC_id_div_initial_program_opt(t4) && TTist_qdot_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_id_div_program_id_cobol_source_program, args);
}

TTterm
TTbuildVSC_id_div_remarks(TTterm t1, TTterm t2)
{
    assert(TTist_REMARKS(t1) && TTist_qdot_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_id_div_remarks, args);
}

TTterm
TTbuildVSC_id_div_security(TTterm t1, TTterm t2)
{
    assert(TTist_SECURITY(t1) && TTist_qdot_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_id_div_security, args);
}

TTterm
TTbuildVSC_io_sec_alt_assignment_name_file_name(TTterm t1)
{
    assert(TTisVSC_expr_assignment_name(t1) || TTisVSC_expr_file_name(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_io_sec_alt_assignment_name_file_name, args);
}

TTterm
TTbuildVSC_io_sec_alt_assignment_name_literal(TTterm t1)
{
    assert(TTisVSC_expr_assignment_name(t1) || TTisVSC_expr_literal(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_io_sec_alt_assignment_name_literal, args);
}

TTterm
TTbuildVSC_io_sec_alt_indexed_relative_sequential(TTterm t1)
{
    assert(TTist_INDEXED(t1) || TTist_RELATIVE(t1) || TTist_SEQUENTIAL(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_io_sec_alt_indexed_relative_sequential, args);
}

TTterm
TTbuildVSC_io_sec_alt_sequential_random_dynamic(TTterm t1)
{
    assert(TTist_SEQUENTIAL(t1) || TTist_RANDOM(t1) || TTist_DYNAMIC(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_io_sec_alt_sequential_random_dynamic, args);
}

TTterm
TTbuildVSC_io_sec_alternate_record_key_clause(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7)
{
    assert(TTist_ALTERNATE(t1) && TTist_RECORD_opt(t2) && TTist_KEY_opt(t3) && TTist_IS_opt(t4) && TTisVSC_expr_qualified_data_name(t5) && TTisVSC_io_sec_password_clause_opt(t6) && TTisVSC_io_sec_with_duplicates_opt(t7));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    return TTbuild_term(TTfunVSC_io_sec_alternate_record_key_clause, args);
}

TTterm
TTbuildVSC_io_sec_areas(TTterm t1)
{
    assert(TTist_AREA(t1) || TTist_AREAS(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_io_sec_areas, args);
}

TTterm
TTbuildVSC_io_sec_assign_clause(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_ASSIGN(t1) && TTist_TO_opt(t2) && TTisVSC_io_sec_alt_assignment_name_literal_plus(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_io_sec_assign_clause, args);
}

TTterm
TTbuildVSC_io_sec_every_phrase(TTterm t1)
{
    assert(TTisVSC_io_sec_every_phrase_1(t1) || TTisVSC_io_sec_every_phrase_2(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_io_sec_every_phrase, args);
}

TTterm
TTbuildVSC_io_sec_every_phrase_1(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_integer(t1) && TTist_RECORDS(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_io_sec_every_phrase_1, args);
}

TTterm
TTbuildVSC_io_sec_every_phrase_2(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_END(t1) && TTist_OF_opt(t2) && TTisVSC_expr_alt_reel_unit(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_io_sec_every_phrase_2, args);
}

TTterm
TTbuildVSC_io_sec_fce_access_mode(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_ACCESS(t1) && TTist_MODE_opt(t2) && TTist_IS_opt(t3) && TTisVSC_io_sec_alt_sequential_random_dynamic(t4) && TTisVSC_io_sec_relative_key_clause_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_io_sec_fce_access_mode, args);
}

TTterm
TTbuildVSC_io_sec_fce_organization(TTterm t1, TTterm t2)
{
    assert(TTisVSC_io_sec_organization_is_opt(t1) && TTisVSC_io_sec_alt_indexed_relative_sequential(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_io_sec_fce_organization, args);
}

TTterm
TTbuildVSC_io_sec_fce_phrase(TTterm t1)
{
    assert(TTisVSC_io_sec_reserve_clause(t1) || TTisVSC_io_sec_fce_organization(t1) || TTisVSC_io_sec_fce_access_mode(t1) || TTisVSC_io_sec_record_key_clause(t1) || TTisVSC_io_sec_password_clause(t1) || TTisVSC_io_sec_alternate_record_key_clause(t1) || TTisVSC_io_sec_file_status_clause(t1) || TTisVSC_io_sec_padding_character_clause(t1) || TTisVSC_io_sec_record_delimiter_clause(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_io_sec_fce_phrase, args);
}

TTterm
TTbuildVSC_io_sec_file_control_entry(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_io_sec_select_clause(t1) && TTisVSC_io_sec_assign_clause(t2) && TTisVSC_io_sec_fce_phrase_star(t3) && TTist_qdot(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_io_sec_file_control_entry, args);
}

TTterm
TTbuildVSC_io_sec_file_control_paragraph(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_FILE_CONTROL(t1) && TTist_qdot(t2) && TTisVSC_io_sec_file_control_entry_star(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_io_sec_file_control_paragraph, args);
}

TTterm
TTbuildVSC_io_sec_file_name_position(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_file_name(t1) && TTisVSC_io_sec_position_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_io_sec_file_name_position, args);
}

TTterm
TTbuildVSC_io_sec_file_status_clause(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_FILE_opt(t1) && TTist_STATUS(t2) && TTist_IS_opt(t3) && TTisVSC_expr_qualified_data_name(t4) && TTisVSC_expr_qualified_data_name_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_io_sec_file_status_clause, args);
}

TTterm
TTbuildVSC_io_sec_i_o_control_paragraph(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_I_O_CONTROL(t1) && TTist_qdot(t2) && TTisVSC_io_sec_i_o_sam_opt(t3) && TTisVSC_io_sec_i_o_sort_merge_opt(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_io_sec_i_o_control_paragraph, args);
}

TTterm
TTbuildVSC_io_sec_i_o_sam(TTterm t1, TTterm t2)
{
    assert(TTisVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_plus(t1) && TTist_qdot(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_io_sec_i_o_sam, args);
}

TTterm
TTbuildVSC_io_sec_i_o_sort_merge(TTterm t1, TTterm t2)
{
    assert(TTisVSC_io_sec_sort_merge_i_o_control_entries(t1) && TTist_qdot(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_io_sec_i_o_sort_merge, args);
}

TTterm
TTbuildVSC_io_sec_input_output_section(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_INPUT_OUTPUT(t1) && TTist_SECTION(t2) && TTist_qdot(t3) && TTisVSC_io_sec_file_control_paragraph_opt(t4) && TTisVSC_io_sec_i_o_control_paragraph_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_io_sec_input_output_section, args);
}

TTterm
TTbuildVSC_io_sec_organization_is(TTterm t1, TTterm t2)
{
    assert(TTist_ORGANIZATION(t1) && TTist_IS_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_io_sec_organization_is, args);
}

TTterm
TTbuildVSC_io_sec_padding_character_clause(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_PADDING(t1) && TTist_CHARACTER_opt(t2) && TTist_IS_opt(t3) && TTisVSC_fd_entry_alt_qualified_data_name_literal(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_io_sec_padding_character_clause, args);
}

TTterm
TTbuildVSC_io_sec_password_clause(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_PASSWORD(t1) && TTist_IS_opt(t2) && TTisVSC_expr_data_name(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_io_sec_password_clause, args);
}

TTterm
TTbuildVSC_io_sec_position(TTterm t1, TTterm t2)
{
    assert(TTist_POSITION(t1) && TTisVSC_expr_integer(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_io_sec_position, args);
}

TTterm
TTbuildVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries(TTterm t1)
{
    assert(TTisVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_1(t1) || TTisVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_2(t1) || TTisVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_3(t1) || TTisVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_4(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries, args);
}

TTterm
TTbuildVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7)
{
    assert(TTist_RERUN(t1) && TTist_ON(t2) && TTisVSC_io_sec_alt_assignment_name_file_name(t3) && TTist_EVERY_opt(t4) && TTisVSC_io_sec_every_phrase(t5) && TTist_OF_opt(t6) && TTisVSC_expr_file_name(t7));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    return TTbuild_term(TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_1, args);
}

TTterm
TTbuildVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6)
{
    assert(TTist_SAME(t1) && TTist_RECORD_opt(t2) && TTist_AREA_opt(t3) && TTist_FOR_opt(t4) && TTisVSC_expr_file_name(t5) && TTisVSC_expr_file_name_plus(t6));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    return TTbuild_term(TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_2, args);
}

TTterm
TTbuildVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_3(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_MULTIPLE(t1) && TTist_FILE(t2) && TTist_TAPE_opt(t3) && TTist_CONTAINS_opt(t4) && TTisVSC_io_sec_file_name_position_plus(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_3, args);
}

TTterm
TTbuildVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_4(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_APPLY(t1) && TTist_WRITE_ONLY(t2) && TTist_ON_opt(t3) && TTisVSC_expr_file_name_plus(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_4, args);
}

TTterm
TTbuildVSC_io_sec_record_delimiter_clause(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_RECORD(t1) && TTist_DELIMITER(t2) && TTist_IS_opt(t3) && TTisVSC_io_sec_record_delimiter_name(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_io_sec_record_delimiter_clause, args);
}

TTterm
TTbuildVSC_io_sec_record_delimiter_name(TTterm t1)
{
    assert(TTist_STANDARD_1(t1) || TTisVSC_expr_assignment_name(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_io_sec_record_delimiter_name, args);
}

TTterm
TTbuildVSC_io_sec_record_key_clause(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_RECORD(t1) && TTist_KEY_opt(t2) && TTist_IS_opt(t3) && TTisVSC_expr_qualified_data_name(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_io_sec_record_key_clause, args);
}

TTterm
TTbuildVSC_io_sec_record_sort(TTterm t1)
{
    assert(TTist_RECORD(t1) || TTist_SORT(t1) || TTist_SORT_MERGE(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_io_sec_record_sort, args);
}

TTterm
TTbuildVSC_io_sec_relative_key_clause(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_RELATIVE(t1) && TTist_KEY_opt(t2) && TTist_IS_opt(t3) && TTisVSC_expr_qualified_data_name(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_io_sec_relative_key_clause, args);
}

TTterm
TTbuildVSC_io_sec_rerun_on(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_RERUN(t1) && TTist_ON(t2) && TTisVSC_expr_assignment_name(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_io_sec_rerun_on, args);
}

TTterm
TTbuildVSC_io_sec_reserve_clause(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_RESERVE(t1) && TTisVSC_expr_integer(t2) && TTisVSC_io_sec_areas_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_io_sec_reserve_clause, args);
}

TTterm
TTbuildVSC_io_sec_same_area(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6)
{
    assert(TTist_SAME(t1) && TTisVSC_io_sec_record_sort(t2) && TTist_AREA_opt(t3) && TTist_FOR_opt(t4) && TTisVSC_expr_file_name(t5) && TTisVSC_expr_file_name_plus(t6));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    return TTbuild_term(TTfunVSC_io_sec_same_area, args);
}

TTterm
TTbuildVSC_io_sec_select_clause(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_SELECT(t1) && TTist_OPTIONAL_opt(t2) && TTisVSC_expr_file_name(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_io_sec_select_clause, args);
}

TTterm
TTbuildVSC_io_sec_sort_merge_i_o_control_entries(TTterm t1, TTterm t2)
{
    assert(TTisVSC_io_sec_rerun_on_opt(t1) && TTisVSC_io_sec_same_area_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_io_sec_sort_merge_i_o_control_entries, args);
}

TTterm
TTbuildVSC_io_sec_with_duplicates(TTterm t1, TTterm t2)
{
    assert(TTist_WITH_opt(t1) && TTist_DUPLICATES(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_io_sec_with_duplicates, args);
}

TTterm
TTbuildVSC_main_cobol_source_program(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTisVSC_id_div_identification_division(t1) && TTisVSC_env_div_environment_division_opt(t2) && TTisVSC_data_div_data_division_opt(t3) && TTisVSC_proc_div_procedure_division_opt(t4) && TTisVSC_main_nested_program_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_main_cobol_source_program, args);
}

TTterm
TTbuildVSC_main_common_initial(TTterm t1)
{
    assert(TTisVSC_main_common_initial_1(t1) || TTisVSC_main_common_initial_2(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_main_common_initial, args);
}

TTterm
TTbuildVSC_main_common_initial_1(TTterm t1, TTterm t2)
{
    assert(TTist_COMMON(t1) && TTist_INITIAL_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_main_common_initial_1, args);
}

TTterm
TTbuildVSC_main_common_initial_2(TTterm t1, TTterm t2)
{
    assert(TTist_INITIAL(t1) && TTist_COMMON_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_main_common_initial_2, args);
}

TTterm
TTbuildVSC_main_common_initial_program(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_IS_opt(t1) && TTisVSC_main_common_initial(t2) && TTist_PROGRAM_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_main_common_initial_program, args);
}

TTterm
TTbuildVSC_main_nested_cobol_source_program(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9, TTterm t10, TTterm t11, TTterm t12, TTterm t13)
{
    assert(TTisVSC_id_div_identification(t1) && TTist_DIVISION(t2) && TTist_qdot(t3) && TTisVSC_main_program_id_nested_cobol_source_program(t4) && TTisVSC_id_div_identification_division_content_opt(t5) && TTisVSC_env_div_environment_division_opt(t6) && TTisVSC_data_div_data_division_opt(t7) && TTisVSC_proc_div_procedure_division_opt(t8) && TTisVSC_main_nested_cobol_source_program_star(t9) && TTist_END(t10) && TTist_PROGRAM(t11) && TTisVSC_expr_program_name(t12) && TTist_qdot(t13));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    args[9] = t10;
    args[10] = t11;
    args[11] = t12;
    args[12] = t13;
    return TTbuild_term(TTfunVSC_main_nested_cobol_source_program, args);
}

TTterm
TTbuildVSC_main_nested_program(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTisVSC_main_nested_cobol_source_program_star(t1) && TTist_END(t2) && TTist_PROGRAM(t3) && TTisVSC_expr_program_name(t4) && TTist_qdot(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_main_nested_program, args);
}

TTterm
TTbuildVSC_main_program_id_nested_cobol_source_program(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_PROGRAM_ID(t1) && TTist_qdot_opt(t2) && TTisVSC_expr_program_name(t3) && TTisVSC_main_common_initial_program_opt(t4) && TTist_qdot_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_main_program_id_nested_cobol_source_program, args);
}

TTterm
TTbuildVSC_main_programs(TTterm t1)
{
    assert(TTisVSC_main_cobol_source_program_plus(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_main_programs, args);
}

TTterm
TTbuildVSC_proc_div_altered_goto(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTisVSC_expr_paragraph_name(t1) && TTist_qdot(t2) && TTist_GO(t3) && TTist_TO_opt(t4) && TTist_qdot(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_proc_div_altered_goto, args);
}

TTterm
TTbuildVSC_proc_div_declaratives(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6)
{
    assert(TTist_DECLARATIVES(t1) && TTist_qdot(t2) && TTisVSC_proc_div_declaratives_content_plus(t3) && TTist_END(t4) && TTist_DECLARATIVES(t5) && TTist_qdot(t6));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    return TTbuild_term(TTfunVSC_proc_div_declaratives, args);
}

TTterm
TTbuildVSC_proc_div_declaratives_content(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTisVSC_proc_div_section_header(t1) && TTist_qdot(t2) && TTisVSC_stat_use_statement(t3) && TTist_qdot(t4) && TTisVSC_proc_div_paragraphs(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_proc_div_declaratives_content, args);
}

TTterm
TTbuildVSC_proc_div_paragraph(TTterm t1)
{
    assert(TTisVSC_proc_div_altered_goto(t1) || TTisVSC_proc_div_paragraph_1(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_proc_div_paragraph, args);
}

TTterm
TTbuildVSC_proc_div_paragraph_1(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_paragraph_name(t1) && TTist_qdot(t2) && TTisVSC_proc_div_sentence_star(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_proc_div_paragraph_1, args);
}

TTterm
TTbuildVSC_proc_div_paragraphs(TTterm t1, TTterm t2)
{
    assert(TTisVSC_proc_div_sentence_star(t1) && TTisVSC_proc_div_paragraph_star(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_proc_div_paragraphs, args);
}

TTterm
TTbuildVSC_proc_div_procedure_division(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_PROCEDURE(t1) && TTist_DIVISION(t2) && TTisVSC_proc_div_using_phrase(t3) && TTisVSC_proc_div_declaratives_opt(t4) && TTisVSC_proc_div_sections(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_proc_div_procedure_division, args);
}

TTterm
TTbuildVSC_proc_div_section_header(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_section_name(t1) && TTist_SECTION(t2) && TTisVSC_expr_priority_number_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_proc_div_section_header, args);
}

TTterm
TTbuildVSC_proc_div_section_with_header(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_proc_div_section_header(t1) && TTist_qdot(t2) && TTisVSC_proc_div_paragraphs(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_proc_div_section_with_header, args);
}

TTterm
TTbuildVSC_proc_div_sections(TTterm t1, TTterm t2)
{
    assert(TTisVSC_proc_div_paragraphs(t1) && TTisVSC_proc_div_section_with_header_star(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_proc_div_sections, args);
}

TTterm
TTbuildVSC_proc_div_sentence(TTterm t1)
{
    assert(TTisVSC_proc_div_sentence_1(t1) || TTisVSC_proc_div_sentence_2(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_proc_div_sentence, args);
}

TTterm
TTbuildVSC_proc_div_sentence_1(TTterm t1, TTterm t2)
{
    assert(TTisVSC_stat_statement_list(t1) && TTist_qdot_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_proc_div_sentence_1, args);
}

TTterm
TTbuildVSC_proc_div_sentence_2(TTterm t1, TTterm t2)
{
    assert(TTisVSC_stat_statement_list_opt(t1) && TTisVSC_expr_copy_statement(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_proc_div_sentence_2, args);
}

TTterm
TTbuildVSC_proc_div_using_data_names(TTterm t1, TTterm t2)
{
    assert(TTist_USING(t1) && TTisVSC_expr_data_name_star(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_proc_div_using_data_names, args);
}

TTterm
TTbuildVSC_proc_div_using_phrase(TTterm t1)
{
    assert(TTisVSC_proc_div_using_phrase_1(t1) || TTisVSC_proc_div_using_phrase_2(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_proc_div_using_phrase, args);
}

TTterm
TTbuildVSC_proc_div_using_phrase_1(TTterm t1, TTterm t2)
{
    assert(TTisVSC_stat_using_data_name_pluslist_opt(t1) && TTist_qdot(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_proc_div_using_phrase_1, args);
}

TTterm
TTbuildVSC_proc_div_using_phrase_2(TTterm t1, TTterm t2)
{
    assert(TTisVSC_proc_div_using_data_names_opt(t1) && TTisVSC_expr_copy_statement(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_proc_div_using_phrase_2, args);
}

TTterm
TTbuildVSC_stat_accept_statement(TTterm t1)
{
    assert(TTisVSC_stat_accept_statement_2(t1) || TTisVSC_stat_accept_statement_1(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_accept_statement, args);
}

TTterm
TTbuildVSC_stat_accept_statement_1(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_ACCEPT(t1) && TTisVSC_expr_identifier(t2) && TTisVSC_stat_from_environment_name_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_accept_statement_1, args);
}

TTterm
TTbuildVSC_stat_accept_statement_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_ACCEPT(t1) && TTisVSC_expr_identifier(t2) && TTist_FROM(t3) && TTisVSC_stat_date(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_accept_statement_2, args);
}

TTterm
TTbuildVSC_stat_add_statement(TTterm t1)
{
    assert(TTisVSC_stat_add_statement_2(t1) || TTisVSC_stat_add_statement_1(t1) || TTisVSC_stat_add_statement_3(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_add_statement, args);
}

TTterm
TTbuildVSC_stat_add_statement_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7)
{
    assert(TTist_ADD(t1) && TTisVSC_stat_id_or_lit_plus(t2) && TTist_TO(t3) && TTisVSC_stat_cobword_rounded_plus(t4) && TTisVSC_stat_on_size_error_statement_list_opt(t5) && TTisVSC_stat_not_on_size_error_statement_list_opt(t6) && TTist_END_ADD_opt(t7));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    return TTbuild_term(TTfunVSC_stat_add_statement_1, args);
}

TTterm
TTbuildVSC_stat_add_statement_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8)
{
    assert(TTist_ADD(t1) && TTisVSC_stat_id_or_lit_plus(t2) && TTisVSC_stat_to_id_or_lit_opt(t3) && TTist_GIVING(t4) && TTisVSC_stat_cobword_rounded_plus(t5) && TTisVSC_stat_on_size_error_statement_list_opt(t6) && TTisVSC_stat_not_on_size_error_statement_list_opt(t7) && TTist_END_ADD_opt(t8));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    return TTbuild_term(TTfunVSC_stat_add_statement_2, args);
}

TTterm
TTbuildVSC_stat_add_statement_3(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9)
{
    assert(TTist_ADD(t1) && TTisVSC_stat_corresponding(t2) && TTisVSC_expr_identifier(t3) && TTist_TO(t4) && TTisVSC_expr_identifier(t5) && TTist_ROUNDED_opt(t6) && TTisVSC_stat_on_size_error_statement_list_opt(t7) && TTisVSC_stat_not_on_size_error_statement_list_opt(t8) && TTist_END_ADD_opt(t9));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    return TTbuild_term(TTfunVSC_stat_add_statement_3, args);
}

TTterm
TTbuildVSC_stat_advancing_phrase(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_stat_alt_before_after(t1) && TTist_ADVANCING_opt(t2) && TTisVSC_stat_page_phrase(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_advancing_phrase, args);
}

TTterm
TTbuildVSC_stat_all_procedures(TTterm t1, TTterm t2)
{
    assert(TTist_ALL(t1) && TTist_PROCEDURES(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_all_procedures, args);
}

TTterm
TTbuildVSC_stat_also_phrase(TTterm t1, TTterm t2)
{
    assert(TTist_ALSO(t1) && TTisVSC_stat_evaluate_condition(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_also_phrase, args);
}

TTterm
TTbuildVSC_stat_alt_all_leading(TTterm t1)
{
    assert(TTist_ALL(t1) || TTist_LEADING(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_all_leading, args);
}

TTterm
TTbuildVSC_stat_alt_all_leading_first(TTterm t1)
{
    assert(TTist_ALL(t1) || TTist_LEADING(t1) || TTist_FIRST(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_all_leading_first, args);
}

TTterm
TTbuildVSC_stat_alt_before_after(TTterm t1)
{
    assert(TTist_BEFORE(t1) || TTist_AFTER(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_before_after, args);
}

TTterm
TTbuildVSC_stat_alt_beginning_ending(TTterm t1)
{
    assert(TTist_BEGINNING(t1) || TTist_ENDING(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_beginning_ending, args);
}

TTterm
TTbuildVSC_stat_alt_exception_error(TTterm t1)
{
    assert(TTist_EXCEPTION(t1) || TTist_ERROR(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_exception_error, args);
}

TTterm
TTbuildVSC_stat_alt_file_names_i_o(TTterm t1)
{
    assert(TTisVSC_stat_file_names(t1) || TTist_INPUT(t1) || TTist_OUTPUT(t1) || TTist_I_O(t1) || TTist_EXTEND(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_file_names_i_o, args);
}

TTterm
TTbuildVSC_stat_alt_file_reel_unit(TTterm t1)
{
    assert(TTist_FILE(t1) || TTist_REEL(t1) || TTist_UNIT(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_file_reel_unit, args);
}

TTterm
TTbuildVSC_stat_alt_no_rewind_lock(TTterm t1)
{
    assert(TTisVSC_stat_no_rewind(t1) || TTist_LOCK(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_no_rewind_lock, args);
}

TTterm
TTbuildVSC_stat_alt_procedures_all_procedures(TTterm t1)
{
    assert(TTisVSC_stat_procedure_names(t1) || TTisVSC_stat_all_procedures(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_procedures_all_procedures, args);
}

TTterm
TTbuildVSC_stat_alt_removal_no_rewind(TTterm t1)
{
    assert(TTisVSC_stat_for_removal(t1) || TTisVSC_stat_with_no_rewind(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_removal_no_rewind, args);
}

TTterm
TTbuildVSC_stat_alt_reversed_with_no_rewind(TTterm t1)
{
    assert(TTist_REVERSED(t1) || TTisVSC_stat_with_no_rewind(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_reversed_with_no_rewind, args);
}

TTterm
TTbuildVSC_stat_alt_run_literal(TTterm t1)
{
    assert(TTist_RUN(t1) || TTisVSC_expr_literal(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_run_literal, args);
}

TTterm
TTbuildVSC_stat_alt_statement_list_next_sentence(TTterm t1)
{
    assert(TTisVSC_stat_statement_list(t1) || TTisVSC_stat_next_sentence(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_statement_list_next_sentence, args);
}

TTterm
TTbuildVSC_stat_alt_up_down(TTterm t1)
{
    assert(TTist_UP(t1) || TTist_DOWN(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_alt_up_down, args);
}

TTterm
TTbuildVSC_stat_alt_up_down_by(TTterm t1, TTterm t2)
{
    assert(TTisVSC_stat_alt_up_down(t1) && TTist_BY(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_alt_up_down_by, args);
}

TTterm
TTbuildVSC_stat_alter_statement(TTterm t1, TTterm t2)
{
    assert(TTist_ALTER(t1) && TTisVSC_stat_procedure_to_procedure_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_alter_statement, args);
}

TTterm
TTbuildVSC_stat_at_end_of_page_statement_list(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_AT_opt(t1) && TTisVSC_stat_end_of_page(t2) && TTisVSC_stat_statement_list(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_at_end_of_page_statement_list, args);
}

TTterm
TTbuildVSC_stat_at_end_statement_list(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_AT_opt(t1) && TTist_END(t2) && TTisVSC_stat_statement_list(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_at_end_statement_list, args);
}

TTterm
TTbuildVSC_stat_before_after_phrase(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_stat_alt_before_after(t1) && TTist_INITIAL_opt(t2) && TTisVSC_stat_id_or_lit(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_before_after_phrase, args);
}

TTterm
TTbuildVSC_stat_by_reference(TTterm t1, TTterm t2)
{
    assert(TTist_BY_opt(t1) && TTist_REFERENCE(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_by_reference, args);
}

TTterm
TTbuildVSC_stat_call_rest_phrase(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_stat_on_exception_statement_list_opt(t1) && TTisVSC_stat_not_on_exception_statement_list_opt(t2) && TTisVSC_stat_on_overflow_statement_list_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_call_rest_phrase, args);
}

TTterm
TTbuildVSC_stat_call_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_CALL(t1) && TTisVSC_stat_id_or_lit(t2) && TTisVSC_stat_using_parameters_opt(t3) && TTisVSC_stat_call_rest_phrase(t4) && TTist_END_CALL_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_stat_call_statement, args);
}

TTterm
TTbuildVSC_stat_cancel_statement(TTterm t1, TTterm t2)
{
    assert(TTist_CANCEL(t1) && TTisVSC_stat_id_or_lit_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_cancel_statement, args);
}

TTterm
TTbuildVSC_stat_close_statement(TTterm t1, TTterm t2)
{
    assert(TTist_CLOSE(t1) && TTisVSC_stat_close_statement_file_name_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_close_statement, args);
}

TTterm
TTbuildVSC_stat_close_statement_file_name(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_file_name(t1) && TTisVSC_stat_close_statement_options_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_close_statement_file_name, args);
}

TTterm
TTbuildVSC_stat_close_statement_options(TTterm t1)
{
    assert(TTisVSC_stat_close_statement_options_1(t1) || TTisVSC_stat_close_statement_options_2(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_close_statement_options, args);
}

TTterm
TTbuildVSC_stat_close_statement_options_1(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_alt_reel_unit(t1) && TTisVSC_stat_alt_removal_no_rewind_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_close_statement_options_1, args);
}

TTterm
TTbuildVSC_stat_close_statement_options_2(TTterm t1, TTterm t2)
{
    assert(TTist_WITH_opt(t1) && TTisVSC_stat_alt_no_rewind_lock(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_close_statement_options_2, args);
}

TTterm
TTbuildVSC_stat_cobword_int(TTterm t1)
{
    assert(TTisVSC_expr_identifier(t1) || TTisVSC_expr_integer(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_cobword_int, args);
}

TTterm
TTbuildVSC_stat_cobword_rounded(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_identifier(t1) && TTist_ROUNDED_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_cobword_rounded, args);
}

TTterm
TTbuildVSC_stat_collating_sequence(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_COLLATING_opt(t1) && TTist_SEQUENCE(t2) && TTist_IS_opt(t3) && TTisVSC_expr_alphabet_name(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_collating_sequence, args);
}

TTterm
TTbuildVSC_stat_compute_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7)
{
    assert(TTist_COMPUTE(t1) && TTisVSC_stat_cobword_rounded_plus(t2) && TTisVSC_stat_equal(t3) && TTisVSC_expr_arithmetic_expression(t4) && TTisVSC_stat_on_size_error_statement_list_opt(t5) && TTisVSC_stat_not_on_size_error_statement_list_opt(t6) && TTist_END_COMPUTE_opt(t7));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    return TTbuild_term(TTfunVSC_stat_compute_statement, args);
}

TTterm
TTbuildVSC_stat_content_parameter(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_BY_opt(t1) && TTist_CONTENT(t2) && TTisVSC_stat_content_parameter_value_plus(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_content_parameter, args);
}

TTterm
TTbuildVSC_stat_content_parameter_value(TTterm t1)
{
    assert(TTisVSC_expr_identifier(t1) || TTisVSC_expr_literal(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_content_parameter_value, args);
}

TTterm
TTbuildVSC_stat_continue_statement(TTterm t1)
{
    assert(TTist_CONTINUE(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_continue_statement, args);
}

TTterm
TTbuildVSC_stat_corresponding(TTterm t1)
{
    assert(TTist_CORRESPONDING(t1) || TTist_CORR(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_corresponding, args);
}

TTterm
TTbuildVSC_stat_count_in_identifier(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_COUNT(t1) && TTist_IN_opt(t2) && TTisVSC_expr_identifier(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_count_in_identifier, args);
}

TTterm
TTbuildVSC_stat_date(TTterm t1)
{
    assert(TTist_DATE(t1) || TTist_DAY(t1) || TTist_DAY_OF_WEEK(t1) || TTist_TIME(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_date, args);
}

TTterm
TTbuildVSC_stat_delete_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6)
{
    assert(TTist_DELETE(t1) && TTisVSC_expr_file_name(t2) && TTist_RECORD_opt(t3) && TTisVSC_stat_invalid_key_statement_list_opt(t4) && TTisVSC_stat_not_invalid_key_statement_list_opt(t5) && TTist_END_DELETE_opt(t6));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    return TTbuild_term(TTfunVSC_stat_delete_statement, args);
}

TTterm
TTbuildVSC_stat_delimited_by_all_phrase(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_DELIMITED(t1) && TTist_BY_opt(t2) && TTist_ALL_opt(t3) && TTisVSC_stat_id_or_lit(t4) && TTisVSC_stat_or_all_id_or_lit_star(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_stat_delimited_by_all_phrase, args);
}

TTterm
TTbuildVSC_stat_delimited_by_phrase(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_stat_id_or_lit_plus(t1) && TTist_DELIMITED(t2) && TTist_BY_opt(t3) && TTisVSC_stat_id_or_lit_size(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_delimited_by_phrase, args);
}

TTterm
TTbuildVSC_stat_delimiter_in_identifier(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_DELIMITER(t1) && TTist_IN_opt(t2) && TTisVSC_expr_identifier(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_delimiter_in_identifier, args);
}

TTterm
TTbuildVSC_stat_display_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_DISPLAY(t1) && TTisVSC_stat_id_or_lit_plus(t2) && TTisVSC_stat_upon_environment_name_opt(t3) && TTisVSC_stat_with_no_advancing_opt(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_display_statement, args);
}

TTterm
TTbuildVSC_stat_divide_statement(TTterm t1)
{
    assert(TTisVSC_stat_divide_statement_4(t1) || TTisVSC_stat_divide_statement_5(t1) || TTisVSC_stat_divide_statement_2(t1) || TTisVSC_stat_divide_statement_3(t1) || TTisVSC_stat_divide_statement_1(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_divide_statement, args);
}

TTterm
TTbuildVSC_stat_divide_statement_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7)
{
    assert(TTist_DIVIDE(t1) && TTisVSC_stat_id_or_lit(t2) && TTist_INTO(t3) && TTisVSC_stat_cobword_rounded_plus(t4) && TTisVSC_stat_on_size_error_statement_list_opt(t5) && TTisVSC_stat_not_on_size_error_statement_list_opt(t6) && TTist_END_DIVIDE_opt(t7));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    return TTbuild_term(TTfunVSC_stat_divide_statement_1, args);
}

TTterm
TTbuildVSC_stat_divide_statement_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9)
{
    assert(TTist_DIVIDE(t1) && TTisVSC_stat_id_or_lit(t2) && TTist_INTO(t3) && TTisVSC_stat_id_or_lit(t4) && TTist_GIVING(t5) && TTisVSC_stat_cobword_rounded_plus(t6) && TTisVSC_stat_on_size_error_statement_list_opt(t7) && TTisVSC_stat_not_on_size_error_statement_list_opt(t8) && TTist_END_DIVIDE_opt(t9));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    return TTbuild_term(TTfunVSC_stat_divide_statement_2, args);
}

TTterm
TTbuildVSC_stat_divide_statement_3(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9)
{
    assert(TTist_DIVIDE(t1) && TTisVSC_stat_id_or_lit(t2) && TTist_BY(t3) && TTisVSC_stat_id_or_lit(t4) && TTist_GIVING(t5) && TTisVSC_stat_cobword_rounded_plus(t6) && TTisVSC_stat_on_size_error_statement_list_opt(t7) && TTisVSC_stat_not_on_size_error_statement_list_opt(t8) && TTist_END_DIVIDE_opt(t9));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    return TTbuild_term(TTfunVSC_stat_divide_statement_3, args);
}

TTterm
TTbuildVSC_stat_divide_statement_4(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9, TTterm t10, TTterm t11, TTterm t12)
{
    assert(TTist_DIVIDE(t1) && TTisVSC_stat_id_or_lit(t2) && TTist_INTO(t3) && TTisVSC_stat_id_or_lit(t4) && TTist_GIVING(t5) && TTisVSC_expr_identifier(t6) && TTist_ROUNDED_opt(t7) && TTist_REMAINDER(t8) && TTisVSC_expr_identifier(t9) && TTisVSC_stat_on_size_error_statement_list_opt(t10) && TTisVSC_stat_not_on_size_error_statement_list_opt(t11) && TTist_END_DIVIDE_opt(t12));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    args[9] = t10;
    args[10] = t11;
    args[11] = t12;
    return TTbuild_term(TTfunVSC_stat_divide_statement_4, args);
}

TTterm
TTbuildVSC_stat_divide_statement_5(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9, TTterm t10, TTterm t11, TTterm t12)
{
    assert(TTist_DIVIDE(t1) && TTisVSC_stat_id_or_lit(t2) && TTist_BY(t3) && TTisVSC_stat_id_or_lit(t4) && TTist_GIVING(t5) && TTisVSC_expr_identifier(t6) && TTist_ROUNDED_opt(t7) && TTist_REMAINDER(t8) && TTisVSC_expr_identifier(t9) && TTisVSC_stat_on_size_error_statement_list_opt(t10) && TTisVSC_stat_not_on_size_error_statement_list_opt(t11) && TTist_END_DIVIDE_opt(t12));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    args[9] = t10;
    args[10] = t11;
    args[11] = t12;
    return TTbuild_term(TTfunVSC_stat_divide_statement_5, args);
}

TTterm
TTbuildVSC_stat_else_phrase(TTterm t1, TTterm t2)
{
    assert(TTist_ELSE(t1) && TTisVSC_stat_alt_statement_list_next_sentence(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_else_phrase, args);
}

TTterm
TTbuildVSC_stat_end_of_page(TTterm t1)
{
    assert(TTist_END_OF_PAGE(t1) || TTist_EOP(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_end_of_page, args);
}

TTterm
TTbuildVSC_stat_entry_statement(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_ENTRY(t1) && TTisVSC_expr_literal(t2) && TTisVSC_stat_using_data_name_pluslist_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_entry_statement, args);
}

TTterm
TTbuildVSC_stat_equal(TTterm t1)
{
    assert(TTist_qequal(t1) || TTist_EQUAL(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_equal, args);
}

TTterm
TTbuildVSC_stat_evaluate_condition(TTterm t1)
{
    assert(TTisVSC_cond_condition(t1) || TTist_TRUE(t1) || TTist_FALSE(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_evaluate_condition, args);
}

TTterm
TTbuildVSC_stat_evaluate_phrase(TTterm t1)
{
    assert(TTist_ANY(t1) || TTist_TRUE(t1) || TTist_FALSE(t1) || TTisVSC_stat_evaluate_phrase_2(t1) || TTisVSC_cond_condition(t1) || TTisVSC_stat_evaluate_phrase_1(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_evaluate_phrase, args);
}

TTterm
TTbuildVSC_stat_evaluate_phrase_1(TTterm t1, TTterm t2)
{
    assert(TTist_NOT_opt(t1) && TTisVSC_expr_arithmetic_expression(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_evaluate_phrase_1, args);
}

TTterm
TTbuildVSC_stat_evaluate_phrase_2(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_NOT_opt(t1) && TTisVSC_expr_arithmetic_expression(t2) && TTisVSC_expr_through_arithmetic_expression(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_evaluate_phrase_2, args);
}

TTterm
TTbuildVSC_stat_evaluate_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6)
{
    assert(TTist_EVALUATE(t1) && TTisVSC_stat_evaluate_condition(t2) && TTisVSC_stat_also_phrase_star(t3) && TTisVSC_stat_when_phrases_plus(t4) && TTisVSC_stat_when_other_phrase_opt(t5) && TTist_END_EVALUATE_opt(t6));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    return TTbuild_term(TTfunVSC_stat_evaluate_statement, args);
}

TTterm
TTbuildVSC_stat_exit_program_statement(TTterm t1, TTterm t2)
{
    assert(TTist_EXIT(t1) && TTist_PROGRAM(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_exit_program_statement, args);
}

TTterm
TTbuildVSC_stat_exit_statement(TTterm t1)
{
    assert(TTist_EXIT(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_exit_statement, args);
}

TTterm
TTbuildVSC_stat_file_names(TTterm t1)
{
    assert(TTisVSC_expr_file_name_plus(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_file_names, args);
}

TTterm
TTbuildVSC_stat_for_removal(TTterm t1, TTterm t2)
{
    assert(TTist_FOR_opt(t1) && TTist_REMOVAL(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_for_removal, args);
}

TTterm
TTbuildVSC_stat_from_environment_name(TTterm t1, TTterm t2)
{
    assert(TTist_FROM(t1) && TTisVSC_lex_cobword(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_from_environment_name, args);
}

TTterm
TTbuildVSC_stat_from_identifier(TTterm t1, TTterm t2)
{
    assert(TTist_FROM(t1) && TTisVSC_expr_identifier(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_from_identifier, args);
}

TTterm
TTbuildVSC_stat_giving_file_names(TTterm t1, TTterm t2)
{
    assert(TTist_GIVING(t1) && TTisVSC_expr_file_name_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_giving_file_names, args);
}

TTterm
TTbuildVSC_stat_go_to_statement(TTterm t1)
{
    assert(TTisVSC_stat_go_to_statement_2(t1) || TTisVSC_stat_go_to_statement_1(t1) || TTisVSC_stat_go_to_statement_3(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_go_to_statement, args);
}

TTterm
TTbuildVSC_stat_go_to_statement_1(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_GO(t1) && TTist_TO_opt(t2) && TTisVSC_expr_procedure_name(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_go_to_statement_1, args);
}

TTterm
TTbuildVSC_stat_go_to_statement_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6)
{
    assert(TTist_GO(t1) && TTist_TO_opt(t2) && TTisVSC_expr_procedure_name_plus(t3) && TTist_DEPENDING(t4) && TTist_ON_opt(t5) && TTisVSC_expr_identifier(t6));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    return TTbuild_term(TTfunVSC_stat_go_to_statement_2, args);
}

TTterm
TTbuildVSC_stat_go_to_statement_3(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_GO(t1) && TTist_TO_opt(t2) && TTist_MORE_LABELS(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_go_to_statement_3, args);
}

TTterm
TTbuildVSC_stat_goback_statement(TTterm t1)
{
    assert(TTist_GOBACK(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_goback_statement, args);
}

TTterm
TTbuildVSC_stat_id_or_lit(TTterm t1)
{
    assert(TTisVSC_expr_literal(t1) || TTisVSC_expr_identifier(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_id_or_lit, args);
}

TTterm
TTbuildVSC_stat_id_or_lit_size(TTterm t1)
{
    assert(TTisVSC_expr_literal(t1) || TTisVSC_expr_identifier(t1) || TTist_SIZE(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_id_or_lit_size, args);
}

TTterm
TTbuildVSC_stat_if_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6)
{
    assert(TTist_IF(t1) && TTisVSC_cond_condition(t2) && TTist_THEN_opt(t3) && TTisVSC_stat_alt_statement_list_next_sentence(t4) && TTisVSC_stat_else_phrase_opt(t5) && TTist_END_IF_opt(t6));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    return TTbuild_term(TTfunVSC_stat_if_statement, args);
}

TTterm
TTbuildVSC_stat_initialize_replacing_argument(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_stat_initialize_replacing_type(t1) && TTist_DATA_opt(t2) && TTist_BY(t3) && TTisVSC_stat_id_or_lit(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_initialize_replacing_argument, args);
}

TTterm
TTbuildVSC_stat_initialize_replacing_phrase(TTterm t1, TTterm t2)
{
    assert(TTist_REPLACING(t1) && TTisVSC_stat_initialize_replacing_argument_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_initialize_replacing_phrase, args);
}

TTterm
TTbuildVSC_stat_initialize_replacing_type(TTterm t1)
{
    assert(TTist_ALPHABETIC(t1) || TTist_ALPHANUMERIC(t1) || TTist_NUMERIC(t1) || TTist_ALPHANUMERIC_EDITED(t1) || TTist_NUMERIC_EDITED(t1) || TTist_DBCS(t1) || TTist_EGCS(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_initialize_replacing_type, args);
}

TTterm
TTbuildVSC_stat_initialize_statement(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_INITIALIZE(t1) && TTisVSC_expr_identifier_plus(t2) && TTisVSC_stat_initialize_replacing_phrase_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_initialize_statement, args);
}

TTterm
TTbuildVSC_stat_input_procedure(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_INPUT(t1) && TTist_PROCEDURE(t2) && TTist_IS_opt(t3) && TTisVSC_expr_procedure_name(t4) && TTisVSC_stat_through_procedure_name_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_stat_input_procedure, args);
}

TTterm
TTbuildVSC_stat_inspect_by_argument(TTterm t1)
{
    assert(TTisVSC_expr_identifier(t1) || TTisVSC_lex_nonnumeric(t1) || TTisVSC_expr_figurative_constant_simple(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_inspect_by_argument, args);
}

TTterm
TTbuildVSC_stat_inspect_replacing_argument(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_stat_inspect_by_argument(t1) && TTist_BY(t2) && TTisVSC_stat_inspect_by_argument(t3) && TTisVSC_stat_before_after_phrase_star(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_inspect_replacing_argument, args);
}

TTterm
TTbuildVSC_stat_inspect_replacing_phrase(TTterm t1)
{
    assert(TTisVSC_stat_inspect_replacing_phrase_1(t1) || TTisVSC_stat_inspect_replacing_phrase_2(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_inspect_replacing_phrase, args);
}

TTterm
TTbuildVSC_stat_inspect_replacing_phrase_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_CHARACTERS(t1) && TTist_BY(t2) && TTisVSC_stat_id_or_lit(t3) && TTisVSC_stat_before_after_phrase_star(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_inspect_replacing_phrase_1, args);
}

TTterm
TTbuildVSC_stat_inspect_replacing_phrase_2(TTterm t1, TTterm t2)
{
    assert(TTisVSC_stat_alt_all_leading_first(t1) && TTisVSC_stat_inspect_replacing_argument_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_inspect_replacing_phrase_2, args);
}

TTterm
TTbuildVSC_stat_inspect_statement(TTterm t1)
{
    assert(TTisVSC_stat_inspect_statement_3(t1) || TTisVSC_stat_inspect_statement_1(t1) || TTisVSC_stat_inspect_statement_2(t1) || TTisVSC_stat_inspect_statement_4(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_inspect_statement, args);
}

TTterm
TTbuildVSC_stat_inspect_statement_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_INSPECT(t1) && TTisVSC_expr_identifier(t2) && TTist_TALLYING(t3) && TTisVSC_stat_tallying_argument_plus(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_inspect_statement_1, args);
}

TTterm
TTbuildVSC_stat_inspect_statement_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7)
{
    assert(TTist_INSPECT(t1) && TTisVSC_expr_identifier(t2) && TTist_CONVERTING(t3) && TTisVSC_stat_id_or_lit(t4) && TTist_TO(t5) && TTisVSC_stat_id_or_lit(t6) && TTisVSC_stat_before_after_phrase_star(t7));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    return TTbuild_term(TTfunVSC_stat_inspect_statement_2, args);
}

TTterm
TTbuildVSC_stat_inspect_statement_3(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6)
{
    assert(TTist_INSPECT(t1) && TTisVSC_expr_identifier(t2) && TTist_TALLYING(t3) && TTisVSC_stat_tallying_argument_plus(t4) && TTist_REPLACING(t5) && TTisVSC_stat_inspect_replacing_phrase_plus(t6));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    return TTbuild_term(TTfunVSC_stat_inspect_statement_3, args);
}

TTterm
TTbuildVSC_stat_inspect_statement_4(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_INSPECT(t1) && TTisVSC_expr_identifier(t2) && TTist_REPLACING(t3) && TTisVSC_stat_inspect_replacing_phrase_plus(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_inspect_statement_4, args);
}

TTterm
TTbuildVSC_stat_into_identifier(TTterm t1, TTterm t2)
{
    assert(TTist_INTO(t1) && TTisVSC_expr_identifier(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_into_identifier, args);
}

TTterm
TTbuildVSC_stat_invalid_key_statement_list(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_INVALID(t1) && TTist_KEY_opt(t2) && TTisVSC_stat_statement_list(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_invalid_key_statement_list, args);
}

TTterm
TTbuildVSC_stat_key_is(TTterm t1, TTterm t2)
{
    assert(TTist_KEY(t1) && TTist_IS_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_key_is, args);
}

TTterm
TTbuildVSC_stat_key_is_qualified_data_name(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_KEY(t1) && TTist_IS_opt(t2) && TTisVSC_expr_qualified_data_name(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_key_is_qualified_data_name, args);
}

TTterm
TTbuildVSC_stat_key_is_rel_op_qualified_data_name(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_KEY(t1) && TTist_IS_opt(t2) && TTisVSC_stat_rel_op(t3) && TTisVSC_expr_qualified_data_name(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_key_is_rel_op_qualified_data_name, args);
}

TTterm
TTbuildVSC_stat_lines(TTterm t1)
{
    assert(TTist_LINE(t1) || TTist_LINES(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_lines, args);
}

TTterm
TTbuildVSC_stat_merge_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8)
{
    assert(TTist_MERGE(t1) && TTisVSC_expr_file_name(t2) && TTisVSC_stat_on_key_phrase_plus(t3) && TTisVSC_stat_collating_sequence_opt(t4) && TTist_USING(t5) && TTisVSC_expr_file_name(t6) && TTisVSC_expr_file_name_plus(t7) && TTisVSC_stat_merge_statement_tail(t8));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    return TTbuild_term(TTfunVSC_stat_merge_statement, args);
}

TTterm
TTbuildVSC_stat_merge_statement_tail(TTterm t1)
{
    assert(TTisVSC_stat_output_procedure(t1) || TTisVSC_stat_giving_file_names(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_merge_statement_tail, args);
}

TTterm
TTbuildVSC_stat_move_statement(TTterm t1)
{
    assert(TTisVSC_stat_move_statement_1(t1) || TTisVSC_stat_move_statement_2(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_move_statement, args);
}

TTterm
TTbuildVSC_stat_move_statement_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_MOVE(t1) && TTisVSC_stat_id_or_lit(t2) && TTist_TO(t3) && TTisVSC_expr_identifier_plus(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_move_statement_1, args);
}

TTterm
TTbuildVSC_stat_move_statement_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_MOVE(t1) && TTisVSC_stat_corresponding(t2) && TTisVSC_expr_identifier(t3) && TTist_TO(t4) && TTisVSC_expr_identifier_plus(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_stat_move_statement_2, args);
}

TTterm
TTbuildVSC_stat_multiply_statement(TTterm t1)
{
    assert(TTisVSC_stat_multiply_statement_2(t1) || TTisVSC_stat_multiply_statement_1(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_multiply_statement, args);
}

TTterm
TTbuildVSC_stat_multiply_statement_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7)
{
    assert(TTist_MULTIPLY(t1) && TTisVSC_stat_id_or_lit(t2) && TTist_BY(t3) && TTisVSC_stat_cobword_rounded_plus(t4) && TTisVSC_stat_on_size_error_statement_list_opt(t5) && TTisVSC_stat_not_on_size_error_statement_list_opt(t6) && TTist_END_MULTIPLY_opt(t7));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    return TTbuild_term(TTfunVSC_stat_multiply_statement_1, args);
}

TTterm
TTbuildVSC_stat_multiply_statement_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9)
{
    assert(TTist_MULTIPLY(t1) && TTisVSC_stat_id_or_lit(t2) && TTist_BY(t3) && TTisVSC_stat_id_or_lit(t4) && TTist_GIVING(t5) && TTisVSC_stat_cobword_rounded_plus(t6) && TTisVSC_stat_on_size_error_statement_list_opt(t7) && TTisVSC_stat_not_on_size_error_statement_list_opt(t8) && TTist_END_MULTIPLY_opt(t9));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    return TTbuild_term(TTfunVSC_stat_multiply_statement_2, args);
}

TTterm
TTbuildVSC_stat_next_sentence(TTterm t1, TTterm t2)
{
    assert(TTist_NEXT(t1) && TTist_SENTENCE(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_next_sentence, args);
}

TTterm
TTbuildVSC_stat_no_rewind(TTterm t1, TTterm t2)
{
    assert(TTist_NO(t1) && TTist_REWIND(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_no_rewind, args);
}

TTterm
TTbuildVSC_stat_not_at_end_of_page_statement_list(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_NOT(t1) && TTist_AT_opt(t2) && TTisVSC_stat_end_of_page(t3) && TTisVSC_stat_statement_list(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_not_at_end_of_page_statement_list, args);
}

TTterm
TTbuildVSC_stat_not_at_end_statement_list(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_NOT(t1) && TTist_AT_opt(t2) && TTist_END(t3) && TTisVSC_stat_statement_list(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_not_at_end_statement_list, args);
}

TTterm
TTbuildVSC_stat_not_invalid_key_statement_list(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_NOT(t1) && TTist_INVALID(t2) && TTist_KEY_opt(t3) && TTisVSC_stat_statement_list(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_not_invalid_key_statement_list, args);
}

TTterm
TTbuildVSC_stat_not_on_exception_statement_list(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_NOT(t1) && TTist_ON_opt(t2) && TTist_EXCEPTION(t3) && TTisVSC_stat_statement_list(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_not_on_exception_statement_list, args);
}

TTterm
TTbuildVSC_stat_not_on_overflow_statement_list(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_NOT(t1) && TTist_ON_opt(t2) && TTist_OVERFLOW(t3) && TTisVSC_stat_statement_list(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_not_on_overflow_statement_list, args);
}

TTterm
TTbuildVSC_stat_not_on_size_error_statement_list(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_NOT(t1) && TTist_ON_opt(t2) && TTist_SIZE(t3) && TTist_ERROR(t4) && TTisVSC_stat_statement_list(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_stat_not_on_size_error_statement_list, args);
}

TTterm
TTbuildVSC_stat_nr_lines_phrase(TTterm t1, TTterm t2)
{
    assert(TTisVSC_stat_cobword_int(t1) && TTisVSC_stat_lines_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_nr_lines_phrase, args);
}

TTterm
TTbuildVSC_stat_on_exception_statement_list(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_ON_opt(t1) && TTist_EXCEPTION(t2) && TTisVSC_stat_statement_list(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_on_exception_statement_list, args);
}

TTterm
TTbuildVSC_stat_on_key_is_phrase(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_ON_opt(t1) && TTisVSC_expr_alt_ascending_descending(t2) && TTisVSC_stat_key_is_opt(t3) && TTisVSC_expr_qualified_data_name_plus(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_on_key_is_phrase, args);
}

TTterm
TTbuildVSC_stat_on_key_phrase(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_ON_opt(t1) && TTisVSC_expr_alt_ascending_descending(t2) && TTist_KEY_opt(t3) && TTisVSC_expr_qualified_data_name_plus(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_on_key_phrase, args);
}

TTterm
TTbuildVSC_stat_on_overflow_statement_list(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_ON_opt(t1) && TTist_OVERFLOW(t2) && TTisVSC_stat_statement_list(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_on_overflow_statement_list, args);
}

TTterm
TTbuildVSC_stat_on_size_error_statement_list(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_ON_opt(t1) && TTist_SIZE(t2) && TTist_ERROR(t3) && TTisVSC_stat_statement_list(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_on_size_error_statement_list, args);
}

TTterm
TTbuildVSC_stat_open_statement(TTterm t1, TTterm t2)
{
    assert(TTist_OPEN(t1) && TTisVSC_stat_open_statement_phrase_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_open_statement, args);
}

TTterm
TTbuildVSC_stat_open_statement_extend(TTterm t1, TTterm t2)
{
    assert(TTist_EXTEND(t1) && TTisVSC_expr_file_name_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_open_statement_extend, args);
}

TTterm
TTbuildVSC_stat_open_statement_i_o(TTterm t1, TTterm t2)
{
    assert(TTist_I_O(t1) && TTisVSC_expr_file_name_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_open_statement_i_o, args);
}

TTterm
TTbuildVSC_stat_open_statement_input(TTterm t1, TTterm t2)
{
    assert(TTist_INPUT(t1) && TTisVSC_stat_open_statement_input_file_name_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_open_statement_input, args);
}

TTterm
TTbuildVSC_stat_open_statement_input_file_name(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_file_name(t1) && TTisVSC_stat_alt_reversed_with_no_rewind_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_open_statement_input_file_name, args);
}

TTterm
TTbuildVSC_stat_open_statement_output(TTterm t1, TTterm t2)
{
    assert(TTist_OUTPUT(t1) && TTisVSC_stat_open_statement_output_file_name_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_open_statement_output, args);
}

TTterm
TTbuildVSC_stat_open_statement_output_file_name(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_file_name(t1) && TTisVSC_stat_with_no_rewind_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_open_statement_output_file_name, args);
}

TTterm
TTbuildVSC_stat_open_statement_phrase(TTterm t1)
{
    assert(TTisVSC_stat_open_statement_input(t1) || TTisVSC_stat_open_statement_output(t1) || TTisVSC_stat_open_statement_i_o(t1) || TTisVSC_stat_open_statement_extend(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_open_statement_phrase, args);
}

TTterm
TTbuildVSC_stat_or_all_id_or_lit(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_OR(t1) && TTist_ALL_opt(t2) && TTisVSC_stat_id_or_lit(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_or_all_id_or_lit, args);
}

TTterm
TTbuildVSC_stat_output_procedure(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_OUTPUT(t1) && TTist_PROCEDURE(t2) && TTist_IS_opt(t3) && TTisVSC_expr_procedure_name(t4) && TTisVSC_stat_through_procedure_name_opt(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_stat_output_procedure, args);
}

TTterm
TTbuildVSC_stat_page_phrase(TTterm t1)
{
    assert(TTisVSC_stat_nr_lines_phrase(t1) || TTist_PAGE(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_page_phrase, args);
}

TTterm
TTbuildVSC_stat_parameter(TTterm t1)
{
    assert(TTisVSC_stat_reference_parameter(t1) || TTisVSC_stat_content_parameter(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_parameter, args);
}

TTterm
TTbuildVSC_stat_perform_after_phrase(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8)
{
    assert(TTist_AFTER(t1) && TTisVSC_expr_identifier(t2) && TTist_FROM(t3) && TTisVSC_stat_id_or_lit(t4) && TTist_BY(t5) && TTisVSC_stat_id_or_lit(t6) && TTist_UNTIL(t7) && TTisVSC_cond_condition(t8));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    return TTbuild_term(TTfunVSC_stat_perform_after_phrase, args);
}

TTterm
TTbuildVSC_stat_perform_statement(TTterm t1)
{
    assert(TTisVSC_stat_perform_statement_4(t1) || TTisVSC_stat_perform_statement_2(t1) || TTisVSC_stat_perform_statement_3(t1) || TTisVSC_stat_perform_statement_1(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_perform_statement, args);
}

TTterm
TTbuildVSC_stat_perform_statement_1(TTterm t1, TTterm t2)
{
    assert(TTist_PERFORM(t1) && TTisVSC_stat_perform_statement_1_alts(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_perform_statement_1, args);
}

TTterm
TTbuildVSC_stat_perform_statement_1_alts(TTterm t1)
{
    assert(TTisVSC_stat_perform_statement_1_procedure(t1) || TTisVSC_stat_perform_statement_1_statement_list(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_perform_statement_1_alts, args);
}

TTterm
TTbuildVSC_stat_perform_statement_1_procedure(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_procedure_name(t1) && TTisVSC_stat_through_procedure_name_opt(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_perform_statement_1_procedure, args);
}

TTterm
TTbuildVSC_stat_perform_statement_1_statement_list(TTterm t1, TTterm t2)
{
    assert(TTisVSC_stat_statement_list(t1) && TTist_END_PERFORM(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_perform_statement_1_statement_list, args);
}

TTterm
TTbuildVSC_stat_perform_statement_2(TTterm t1, TTterm t2)
{
    assert(TTist_PERFORM(t1) && TTisVSC_stat_perform_statement_2_alts(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_perform_statement_2, args);
}

TTterm
TTbuildVSC_stat_perform_statement_2_alts(TTterm t1)
{
    assert(TTisVSC_stat_perform_statement_2_procedure(t1) || TTisVSC_stat_perform_statement_2_statement_list(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_perform_statement_2_alts, args);
}

TTterm
TTbuildVSC_stat_perform_statement_2_procedure(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_expr_procedure_name(t1) && TTisVSC_stat_through_procedure_name_opt(t2) && TTisVSC_stat_perform_varying_phrase(t3) && TTisVSC_stat_perform_after_phrase_star(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_perform_statement_2_procedure, args);
}

TTterm
TTbuildVSC_stat_perform_statement_2_statement_list(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_stat_perform_varying_phrase(t1) && TTisVSC_stat_statement_list(t2) && TTist_END_PERFORM(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_perform_statement_2_statement_list, args);
}

TTterm
TTbuildVSC_stat_perform_statement_3(TTterm t1, TTterm t2)
{
    assert(TTist_PERFORM(t1) && TTisVSC_stat_perform_statement_3_alts(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_perform_statement_3, args);
}

TTterm
TTbuildVSC_stat_perform_statement_3_alts(TTterm t1)
{
    assert(TTisVSC_stat_perform_statement_3_procedure(t1) || TTisVSC_stat_perform_statement_3_statement_list(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_perform_statement_3_alts, args);
}

TTterm
TTbuildVSC_stat_perform_statement_3_procedure(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_expr_procedure_name(t1) && TTisVSC_stat_through_procedure_name_opt(t2) && TTisVSC_stat_cobword_int(t3) && TTist_TIMES(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_perform_statement_3_procedure, args);
}

TTterm
TTbuildVSC_stat_perform_statement_3_statement_list(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_stat_cobword_int(t1) && TTist_TIMES(t2) && TTisVSC_stat_statement_list(t3) && TTist_END_PERFORM(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_perform_statement_3_statement_list, args);
}

TTterm
TTbuildVSC_stat_perform_statement_4(TTterm t1, TTterm t2)
{
    assert(TTist_PERFORM(t1) && TTisVSC_stat_perform_statement_4_alts(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_perform_statement_4, args);
}

TTterm
TTbuildVSC_stat_perform_statement_4_alts(TTterm t1)
{
    assert(TTisVSC_stat_perform_statement_4_procedure(t1) || TTisVSC_stat_perform_statement_4_statement_list(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_perform_statement_4_alts, args);
}

TTterm
TTbuildVSC_stat_perform_statement_4_procedure(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_procedure_name(t1) && TTisVSC_stat_through_procedure_name_opt(t2) && TTisVSC_stat_perform_until_phrase(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_perform_statement_4_procedure, args);
}

TTterm
TTbuildVSC_stat_perform_statement_4_statement_list(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_stat_perform_until_phrase(t1) && TTisVSC_stat_statement_list(t2) && TTist_END_PERFORM(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_perform_statement_4_statement_list, args);
}

TTterm
TTbuildVSC_stat_perform_until_phrase(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_stat_with_test_opt(t1) && TTist_UNTIL(t2) && TTisVSC_cond_condition(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_perform_until_phrase, args);
}

TTterm
TTbuildVSC_stat_perform_varying_phrase(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9)
{
    assert(TTisVSC_stat_with_test_opt(t1) && TTist_VARYING(t2) && TTisVSC_expr_identifier(t3) && TTist_FROM(t4) && TTisVSC_stat_id_or_lit(t5) && TTist_BY(t6) && TTisVSC_stat_id_or_lit(t7) && TTist_UNTIL(t8) && TTisVSC_cond_condition(t9));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    return TTbuild_term(TTfunVSC_stat_perform_varying_phrase, args);
}

TTterm
TTbuildVSC_stat_procedure_names(TTterm t1)
{
    assert(TTisVSC_expr_procedure_name_plus(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_procedure_names, args);
}

TTterm
TTbuildVSC_stat_procedure_to_procedure(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_expr_procedure_name(t1) && TTist_TO(t2) && TTisVSC_stat_proceed_to_opt(t3) && TTisVSC_expr_procedure_name(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_procedure_to_procedure, args);
}

TTterm
TTbuildVSC_stat_proceed_to(TTterm t1, TTterm t2)
{
    assert(TTist_PROCEED(t1) && TTist_TO(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_proceed_to, args);
}

TTterm
TTbuildVSC_stat_read_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9, TTterm t10, TTterm t11)
{
    assert(TTist_READ(t1) && TTisVSC_expr_file_name(t2) && TTist_NEXT_opt(t3) && TTist_RECORD_opt(t4) && TTisVSC_stat_into_identifier_opt(t5) && TTisVSC_stat_key_is_qualified_data_name_opt(t6) && TTisVSC_stat_invalid_key_statement_list_opt(t7) && TTisVSC_stat_not_invalid_key_statement_list_opt(t8) && TTisVSC_stat_at_end_statement_list_opt(t9) && TTisVSC_stat_not_at_end_statement_list_opt(t10) && TTist_END_READ_opt(t11));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    args[9] = t10;
    args[10] = t11;
    return TTbuild_term(TTfunVSC_stat_read_statement, args);
}

TTterm
TTbuildVSC_stat_reference_parameter(TTterm t1, TTterm t2)
{
    assert(TTisVSC_stat_by_reference_opt(t1) && TTisVSC_expr_identifier(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_reference_parameter, args);
}

TTterm
TTbuildVSC_stat_rel_op(TTterm t1)
{
    assert(TTisVSC_expr_equal_to(t1) || TTisVSC_cond_greater_than_or_equal_to(t1) || TTisVSC_cond_greater_than(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_rel_op, args);
}

TTterm
TTbuildVSC_stat_release_statement(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_RELEASE(t1) && TTisVSC_expr_record_name(t2) && TTisVSC_stat_from_identifier_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_release_statement, args);
}

TTterm
TTbuildVSC_stat_return_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9)
{
    assert(TTist_RETURN(t1) && TTisVSC_expr_file_name(t2) && TTist_RECORD_opt(t3) && TTisVSC_stat_into_identifier_opt(t4) && TTist_AT_opt(t5) && TTist_END(t6) && TTisVSC_stat_statement_list(t7) && TTisVSC_stat_not_at_end_statement_list_opt(t8) && TTist_END_RETURN_opt(t9));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    return TTbuild_term(TTfunVSC_stat_return_statement, args);
}

TTterm
TTbuildVSC_stat_rewrite_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6)
{
    assert(TTist_REWRITE(t1) && TTisVSC_expr_record_name(t2) && TTisVSC_stat_from_identifier_opt(t3) && TTisVSC_stat_invalid_key_statement_list_opt(t4) && TTisVSC_stat_not_invalid_key_statement_list_opt(t5) && TTist_END_REWRITE_opt(t6));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    return TTbuild_term(TTfunVSC_stat_rewrite_statement, args);
}

TTterm
TTbuildVSC_stat_search_statement(TTterm t1)
{
    assert(TTisVSC_stat_search_statement_1(t1) || TTisVSC_stat_search_statement_2(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_search_statement, args);
}

TTterm
TTbuildVSC_stat_search_statement_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6)
{
    assert(TTist_SEARCH(t1) && TTisVSC_expr_identifier(t2) && TTisVSC_stat_varying_identifier_opt(t3) && TTisVSC_stat_at_end_statement_list_opt(t4) && TTisVSC_stat_when_condition_stats_plus(t5) && TTist_END_SEARCH_opt(t6));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    return TTbuild_term(TTfunVSC_stat_search_statement_1, args);
}

TTterm
TTbuildVSC_stat_search_statement_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9)
{
    assert(TTist_SEARCH(t1) && TTist_ALL(t2) && TTisVSC_expr_identifier(t3) && TTisVSC_stat_at_end_statement_list_opt(t4) && TTist_WHEN(t5) && TTisVSC_stat_search_statement_condition(t6) && TTisVSC_stat_search_statement_condition_tail_star(t7) && TTisVSC_stat_alt_statement_list_next_sentence(t8) && TTist_END_SEARCH_opt(t9));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    return TTbuild_term(TTfunVSC_stat_search_statement_2, args);
}

TTterm
TTbuildVSC_stat_search_statement_condition(TTterm t1)
{
    assert(TTisVSC_stat_search_statement_equal_expression(t1) || TTisVSC_cond_condition_name_reference(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_search_statement_condition, args);
}

TTterm
TTbuildVSC_stat_search_statement_condition_tail(TTterm t1, TTterm t2)
{
    assert(TTist_AND(t1) && TTisVSC_stat_search_statement_condition(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_search_statement_condition_tail, args);
}

TTterm
TTbuildVSC_stat_search_statement_equal_expression(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_expr_identifier(t1) && TTist_IS_opt(t2) && TTisVSC_expr_equal_to(t3) && TTisVSC_expr_arithmetic_expression(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_search_statement_equal_expression, args);
}

TTterm
TTbuildVSC_stat_set_oper(TTterm t1)
{
    assert(TTist_TO(t1) || TTisVSC_stat_alt_up_down_by(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_set_oper, args);
}

TTterm
TTbuildVSC_stat_set_src(TTterm t1)
{
    assert(TTisVSC_expr_identifier(t1) || TTisVSC_expr_literal(t1) || TTist_TRUE(t1) || TTist_ON(t1) || TTist_OFF(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_set_src, args);
}

TTterm
TTbuildVSC_stat_set_statement(TTterm t1, TTterm t2)
{
    assert(TTist_SET(t1) && TTisVSC_stat_set_statement_phrase_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_set_statement, args);
}

TTterm
TTbuildVSC_stat_set_statement_phrase(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_identifier_plus(t1) && TTisVSC_stat_set_oper(t2) && TTisVSC_stat_set_src(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_set_statement_phrase, args);
}

TTterm
TTbuildVSC_stat_sort_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7)
{
    assert(TTist_SORT(t1) && TTisVSC_expr_file_name(t2) && TTisVSC_stat_on_key_is_phrase_plus(t3) && TTisVSC_stat_with_duplicates_in_order_opt(t4) && TTisVSC_stat_collating_sequence_opt(t5) && TTisVSC_stat_sort_statement_in(t6) && TTisVSC_stat_sort_statement_out(t7));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    return TTbuild_term(TTfunVSC_stat_sort_statement, args);
}

TTterm
TTbuildVSC_stat_sort_statement_in(TTterm t1)
{
    assert(TTisVSC_stat_using_file_names(t1) || TTisVSC_stat_input_procedure(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_sort_statement_in, args);
}

TTterm
TTbuildVSC_stat_sort_statement_out(TTterm t1)
{
    assert(TTisVSC_stat_giving_file_names(t1) || TTisVSC_stat_output_procedure(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_sort_statement_out, args);
}

TTterm
TTbuildVSC_stat_start_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6)
{
    assert(TTist_START(t1) && TTisVSC_expr_file_name(t2) && TTisVSC_stat_key_is_rel_op_qualified_data_name_opt(t3) && TTisVSC_stat_invalid_key_statement_list_opt(t4) && TTisVSC_stat_not_invalid_key_statement_list_opt(t5) && TTist_END_START_opt(t6));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    return TTbuild_term(TTfunVSC_stat_start_statement, args);
}

TTterm
TTbuildVSC_stat_statement(TTterm t1)
{
    assert(TTisVSC_stat_move_statement(t1) || TTisVSC_stat_if_statement(t1) || TTisVSC_stat_perform_statement(t1) || TTisVSC_stat_go_to_statement(t1) || TTisVSC_stat_accept_statement(t1) || TTisVSC_stat_add_statement(t1) || TTisVSC_stat_alter_statement(t1) || TTisVSC_stat_call_statement(t1) || TTisVSC_stat_cancel_statement(t1) || TTisVSC_stat_close_statement(t1) || TTisVSC_stat_compute_statement(t1) || TTisVSC_stat_continue_statement(t1) || TTisVSC_stat_delete_statement(t1) || TTisVSC_stat_display_statement(t1) || TTisVSC_stat_divide_statement(t1) || TTisVSC_stat_entry_statement(t1) || TTisVSC_stat_evaluate_statement(t1) || TTisVSC_stat_exit_program_statement(t1) || TTisVSC_stat_exit_statement(t1) || TTisVSC_stat_goback_statement(t1) || TTisVSC_stat_initialize_statement(t1) || TTisVSC_stat_inspect_statement(t1) || TTisVSC_stat_merge_statement(t1) || TTisVSC_stat_multiply_statement(t1) || TTisVSC_stat_open_statement(t1) || TTisVSC_stat_read_statement(t1) || TTisVSC_stat_release_statement(t1) || TTisVSC_stat_return_statement(t1) || TTisVSC_stat_rewrite_statement(t1) || TTisVSC_stat_search_statement(t1) || TTisVSC_stat_set_statement(t1) || TTisVSC_stat_sort_statement(t1) || TTisVSC_stat_start_statement(t1) || TTisVSC_stat_stop_statement(t1) || TTisVSC_stat_string_statement(t1) || TTisVSC_stat_subtract_statement(t1) || TTisVSC_stat_unstring_statement(t1) || TTisVSC_stat_write_statement(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_statement, args);
}

TTterm
TTbuildVSC_stat_statement_list(TTterm t1)
{
    assert(TTisVSC_stat_statement_plus(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_statement_list, args);
}

TTterm
TTbuildVSC_stat_stop_statement(TTterm t1, TTterm t2)
{
    assert(TTist_STOP(t1) && TTisVSC_stat_alt_run_literal(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_stop_statement, args);
}

TTterm
TTbuildVSC_stat_string_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8)
{
    assert(TTist_STRING(t1) && TTisVSC_stat_delimited_by_phrase_plus(t2) && TTist_INTO(t3) && TTisVSC_expr_identifier(t4) && TTisVSC_stat_with_pointer_identifier_opt(t5) && TTisVSC_stat_on_overflow_statement_list_opt(t6) && TTisVSC_stat_not_on_overflow_statement_list_opt(t7) && TTist_END_STRING_opt(t8));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    return TTbuild_term(TTfunVSC_stat_string_statement, args);
}

TTterm
TTbuildVSC_stat_subtract_statement(TTterm t1)
{
    assert(TTisVSC_stat_subtract_statement_2(t1) || TTisVSC_stat_subtract_statement_1(t1) || TTisVSC_stat_subtract_statement_3(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_subtract_statement, args);
}

TTterm
TTbuildVSC_stat_subtract_statement_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7)
{
    assert(TTist_SUBTRACT(t1) && TTisVSC_stat_id_or_lit_plus(t2) && TTist_FROM(t3) && TTisVSC_stat_cobword_rounded_plus(t4) && TTisVSC_stat_on_size_error_statement_list_opt(t5) && TTisVSC_stat_not_on_size_error_statement_list_opt(t6) && TTist_END_SUBTRACT_opt(t7));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    return TTbuild_term(TTfunVSC_stat_subtract_statement_1, args);
}

TTterm
TTbuildVSC_stat_subtract_statement_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9)
{
    assert(TTist_SUBTRACT(t1) && TTisVSC_stat_id_or_lit_plus(t2) && TTist_FROM(t3) && TTisVSC_stat_id_or_lit(t4) && TTist_GIVING(t5) && TTisVSC_stat_cobword_rounded_plus(t6) && TTisVSC_stat_on_size_error_statement_list_opt(t7) && TTisVSC_stat_not_on_size_error_statement_list_opt(t8) && TTist_END_SUBTRACT_opt(t9));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    return TTbuild_term(TTfunVSC_stat_subtract_statement_2, args);
}

TTterm
TTbuildVSC_stat_subtract_statement_3(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9)
{
    assert(TTist_SUBTRACT(t1) && TTisVSC_stat_corresponding(t2) && TTisVSC_expr_identifier(t3) && TTist_FROM(t4) && TTisVSC_expr_identifier(t5) && TTist_ROUNDED_opt(t6) && TTisVSC_stat_on_size_error_statement_list_opt(t7) && TTisVSC_stat_not_on_size_error_statement_list_opt(t8) && TTist_END_SUBTRACT_opt(t9));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    return TTbuild_term(TTfunVSC_stat_subtract_statement_3, args);
}

TTterm
TTbuildVSC_stat_tallying_argument(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_identifier(t1) && TTist_FOR(t2) && TTisVSC_stat_tallying_for_argument_plus(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_tallying_argument, args);
}

TTterm
TTbuildVSC_stat_tallying_for_argument(TTterm t1)
{
    assert(TTisVSC_stat_tallying_for_argument_1(t1) || TTisVSC_stat_tallying_for_argument_2(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_tallying_for_argument, args);
}

TTterm
TTbuildVSC_stat_tallying_for_argument_1(TTterm t1, TTterm t2)
{
    assert(TTist_CHARACTERS(t1) && TTisVSC_stat_before_after_phrase_star(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_tallying_for_argument_1, args);
}

TTterm
TTbuildVSC_stat_tallying_for_argument_2(TTterm t1, TTterm t2)
{
    assert(TTisVSC_stat_alt_all_leading(t1) && TTisVSC_stat_tallying_for_id_or_lit_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_tallying_for_argument_2, args);
}

TTterm
TTbuildVSC_stat_tallying_for_id_or_lit(TTterm t1, TTterm t2)
{
    assert(TTisVSC_stat_id_or_lit(t1) && TTisVSC_stat_before_after_phrase_star(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_tallying_for_id_or_lit, args);
}

TTterm
TTbuildVSC_stat_tallying_in_identifier(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_TALLYING(t1) && TTist_IN_opt(t2) && TTisVSC_expr_identifier(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_tallying_in_identifier, args);
}

TTterm
TTbuildVSC_stat_through_procedure_name(TTterm t1, TTterm t2)
{
    assert(TTisVSC_expr_through(t1) && TTisVSC_expr_procedure_name(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_through_procedure_name, args);
}

TTterm
TTbuildVSC_stat_to_id_or_lit(TTterm t1, TTterm t2)
{
    assert(TTist_TO(t1) && TTisVSC_stat_id_or_lit(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_to_id_or_lit, args);
}

TTterm
TTbuildVSC_stat_unstring_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9, TTterm t10)
{
    assert(TTist_UNSTRING(t1) && TTisVSC_expr_identifier(t2) && TTisVSC_stat_delimited_by_all_phrase_opt(t3) && TTist_INTO(t4) && TTisVSC_stat_unstring_statement_dst_plus(t5) && TTisVSC_stat_with_pointer_identifier_opt(t6) && TTisVSC_stat_tallying_in_identifier_opt(t7) && TTisVSC_stat_on_overflow_statement_list_opt(t8) && TTisVSC_stat_not_on_overflow_statement_list_opt(t9) && TTist_END_UNSTRING_opt(t10));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    args[9] = t10;
    return TTbuild_term(TTfunVSC_stat_unstring_statement, args);
}

TTterm
TTbuildVSC_stat_unstring_statement_dst(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTisVSC_expr_identifier(t1) && TTisVSC_stat_delimiter_in_identifier_opt(t2) && TTisVSC_stat_count_in_identifier_opt(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_unstring_statement_dst, args);
}

TTterm
TTbuildVSC_stat_upon_environment_name(TTterm t1, TTterm t2)
{
    assert(TTist_UPON(t1) && TTisVSC_lex_cobword(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_upon_environment_name, args);
}

TTterm
TTbuildVSC_stat_use_statement(TTterm t1)
{
    assert(TTisVSC_stat_use_statement_1(t1) || TTisVSC_stat_use_statement_2(t1) || TTisVSC_stat_use_statement_3(t1));
    args[0] = t1;
    return TTbuild_term(TTfunVSC_stat_use_statement, args);
}

TTterm
TTbuildVSC_stat_use_statement_1(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8)
{
    assert(TTist_USE(t1) && TTist_GLOBAL_opt(t2) && TTist_AFTER(t3) && TTist_STANDARD_opt(t4) && TTisVSC_stat_alt_exception_error(t5) && TTist_PROCEDURE(t6) && TTist_ON_opt(t7) && TTisVSC_stat_alt_file_names_i_o(t8));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    return TTbuild_term(TTfunVSC_stat_use_statement_1, args);
}

TTterm
TTbuildVSC_stat_use_statement_2(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6, TTterm t7, TTterm t8, TTterm t9, TTterm t10)
{
    assert(TTist_USE(t1) && TTist_GLOBAL_opt(t2) && TTist_AFTER(t3) && TTist_STANDARD_opt(t4) && TTisVSC_stat_alt_beginning_ending_opt(t5) && TTisVSC_stat_alt_file_reel_unit_opt(t6) && TTist_LABEL(t7) && TTist_PROCEDURE(t8) && TTist_ON_opt(t9) && TTisVSC_stat_alt_file_names_i_o(t10));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    args[6] = t7;
    args[7] = t8;
    args[8] = t9;
    args[9] = t10;
    return TTbuild_term(TTfunVSC_stat_use_statement_2, args);
}

TTterm
TTbuildVSC_stat_use_statement_3(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5)
{
    assert(TTist_USE(t1) && TTist_FOR_opt(t2) && TTist_DEBUGGING(t3) && TTist_ON_opt(t4) && TTisVSC_stat_alt_procedures_all_procedures(t5));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    return TTbuild_term(TTfunVSC_stat_use_statement_3, args);
}

TTterm
TTbuildVSC_stat_using_data_name_pluslist(TTterm t1, TTterm t2)
{
    assert(TTist_USING(t1) && TTisVSC_expr_data_name_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_using_data_name_pluslist, args);
}

TTterm
TTbuildVSC_stat_using_file_names(TTterm t1, TTterm t2)
{
    assert(TTist_USING(t1) && TTisVSC_expr_file_name_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_using_file_names, args);
}

TTterm
TTbuildVSC_stat_using_parameters(TTterm t1, TTterm t2)
{
    assert(TTist_USING(t1) && TTisVSC_stat_parameter_plus(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_using_parameters, args);
}

TTterm
TTbuildVSC_stat_varying_identifier(TTterm t1, TTterm t2)
{
    assert(TTist_VARYING(t1) && TTisVSC_expr_identifier(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_varying_identifier, args);
}

TTterm
TTbuildVSC_stat_when_condition_stats(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_WHEN(t1) && TTisVSC_cond_condition(t2) && TTisVSC_stat_alt_statement_list_next_sentence(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_when_condition_stats, args);
}

TTterm
TTbuildVSC_stat_when_other_phrase(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_WHEN(t1) && TTist_OTHER(t2) && TTisVSC_stat_statement_list(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_when_other_phrase, args);
}

TTterm
TTbuildVSC_stat_when_phrase(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_WHEN(t1) && TTisVSC_stat_evaluate_phrase(t2) && TTisVSC_stat_when_phrase_also_phrase_star(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_when_phrase, args);
}

TTterm
TTbuildVSC_stat_when_phrase_also_phrase(TTterm t1, TTterm t2)
{
    assert(TTist_ALSO(t1) && TTisVSC_stat_evaluate_phrase(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_when_phrase_also_phrase, args);
}

TTterm
TTbuildVSC_stat_when_phrases(TTterm t1, TTterm t2)
{
    assert(TTisVSC_stat_when_phrase_plus(t1) && TTisVSC_stat_statement_list(t2));
    args[0] = t1;
    args[1] = t2;
    return TTbuild_term(TTfunVSC_stat_when_phrases, args);
}

TTterm
TTbuildVSC_stat_with_duplicates_in_order(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTist_WITH_opt(t1) && TTist_DUPLICATES(t2) && TTist_IN_opt(t3) && TTist_ORDER_opt(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_with_duplicates_in_order, args);
}

TTterm
TTbuildVSC_stat_with_no_advancing(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_WITH_opt(t1) && TTist_NO(t2) && TTist_ADVANCING(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_with_no_advancing, args);
}

TTterm
TTbuildVSC_stat_with_no_rewind(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_WITH_opt(t1) && TTist_NO(t2) && TTist_REWIND(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_with_no_rewind, args);
}

TTterm
TTbuildVSC_stat_with_pointer_identifier(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_WITH_opt(t1) && TTist_POINTER(t2) && TTisVSC_expr_identifier(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_with_pointer_identifier, args);
}

TTterm
TTbuildVSC_stat_with_test(TTterm t1, TTterm t2, TTterm t3)
{
    assert(TTist_WITH_opt(t1) && TTist_TEST(t2) && TTisVSC_stat_alt_before_after(t3));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    return TTbuild_term(TTfunVSC_stat_with_test, args);
}

TTterm
TTbuildVSC_stat_write_exceptions(TTterm t1, TTterm t2, TTterm t3, TTterm t4)
{
    assert(TTisVSC_stat_at_end_of_page_statement_list_opt(t1) && TTisVSC_stat_not_at_end_of_page_statement_list_opt(t2) && TTisVSC_stat_invalid_key_statement_list_opt(t3) && TTisVSC_stat_not_invalid_key_statement_list_opt(t4));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    return TTbuild_term(TTfunVSC_stat_write_exceptions, args);
}

TTterm
TTbuildVSC_stat_write_statement(TTterm t1, TTterm t2, TTterm t3, TTterm t4, TTterm t5, TTterm t6)
{
    assert(TTist_WRITE(t1) && TTisVSC_expr_record_name(t2) && TTisVSC_stat_from_identifier_opt(t3) && TTisVSC_stat_advancing_phrase_opt(t4) && TTisVSC_stat_write_exceptions(t5) && TTist_END_WRITE_opt(t6));
    args[0] = t1;
    args[1] = t2;
    args[2] = t3;
    args[3] = t4;
    args[4] = t5;
    args[5] = t6;
    return TTbuild_term(TTfunVSC_stat_write_statement, args);
}

TTterm
TTbuildVSC_lex_picture_string(TTtype_string t)
{
    args[0] = (TTterm)t;
    return TTbuild_term(TTfunVSC_lex_picture_string, args);
}

TTterm
TTbuildVSC_lex_quoted_pseudo_text(TTtype_string t)
{
    args[0] = (TTterm)t;
    return TTbuild_term(TTfunVSC_lex_quoted_pseudo_text, args);
}

TTterm
TTbuildVSC_lex_num(TTtype_string t)
{
    args[0] = (TTterm)t;
    return TTbuild_term(TTfunVSC_lex_num, args);
}

TTterm
TTbuildVSC_lex_nonnumeric(TTtype_string t)
{
    args[0] = (TTterm)t;
    return TTbuild_term(TTfunVSC_lex_nonnumeric, args);
}

TTterm
TTbuildVSC_lex_cobword(TTtype_string t)
{
    args[0] = (TTterm)t;
    return TTbuild_term(TTfunVSC_lex_cobword, args);
}

BOOL
TTmatchVSC_cond_alt_and_or(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_cond_alt_and_or)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_and_or_combinable_condition(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_cond_and_or_combinable_condition)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_class_condition(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_cond_class_condition)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_class_type(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_cond_class_type)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_combinable_condition(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_cond_combinable_condition)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_combined_conditions(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_cond_combined_conditions)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_condition(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_cond_condition)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_condition_name_reference(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_cond_condition_name_reference)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_greater(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_cond_greater)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_greater_equal(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_cond_greater_equal)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_greater_than(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_cond_greater_than)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_greater_than_1(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_cond_greater_than_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_greater_than_or_equal_to(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_cond_greater_than_or_equal_to)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_greater_than_or_equal_to_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_cond_greater_than_or_equal_to_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_greater_than_or_equal_to_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_cond_greater_than_or_equal_to_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_greater_than_or_equal_to_3(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_cond_greater_than_or_equal_to_3)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_is_not(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_cond_is_not)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_is_or_is_not(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_cond_is_or_is_not)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_less(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_cond_less)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_less_equal(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_cond_less_equal)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_less_equal_2(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_cond_less_equal_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_negated_simple_conditions(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_cond_negated_simple_conditions)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_not_is(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_cond_not_is)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_not_relational_operator_rest(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_cond_not_relational_operator_rest)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_relation_condition(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_cond_relation_condition)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_relational_operator(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_cond_relational_operator)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_relational_operator_rest(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_cond_relational_operator_rest)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_relational_operator_tail(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_cond_relational_operator_tail)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_sign_condition(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_cond_sign_condition)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_sign_type(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_cond_sign_type)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_simple_condition(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_cond_simple_condition)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_simple_condition_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_cond_simple_condition_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_cond_than(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_cond_than)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_alphabet_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_conf_sec_alphabet_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_alphabet_type(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_conf_sec_alphabet_type)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_alphabet_type_also(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_conf_sec_alphabet_type_also)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_alphabet_type_also_through(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_conf_sec_alphabet_type_also_through)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_alphabet_type_alsos(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_conf_sec_alphabet_type_alsos)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_alphabet_type_other(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_conf_sec_alphabet_type_other)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_alphabet_type_others(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_conf_sec_alphabet_type_others)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_are(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_conf_sec_are)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_class_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_conf_sec_class_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_configuration_section(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_conf_sec_configuration_section)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_configuration_section_paragraph(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_conf_sec_configuration_section_paragraph)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_configuration_section_paragraphs(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_conf_sec_configuration_section_paragraphs)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_currency_sign_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_conf_sec_currency_sign_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_decimal_point_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_conf_sec_decimal_point_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_in_alphabet_name(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_conf_sec_in_alphabet_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_is_mnemonic_name(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_conf_sec_is_mnemonic_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_memory_size(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_conf_sec_memory_size)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_memory_size_type(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_conf_sec_memory_size_type)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_object_computer_name(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_conf_sec_object_computer_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_object_computer_paragraph(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_conf_sec_object_computer_paragraph)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_object_computer_paragraph_sequence_phrase(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_conf_sec_object_computer_paragraph_sequence_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_off_status(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_conf_sec_off_status)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_on_status(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_conf_sec_on_status)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_program_collating_sequence(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_conf_sec_program_collating_sequence)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_segment_limit(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_conf_sec_segment_limit)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_source_computer_name(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_conf_sec_source_computer_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_source_computer_paragraph(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_conf_sec_source_computer_paragraph)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_special_names_paragraph(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_conf_sec_special_names_paragraph)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_special_names_paragraph_clause(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_conf_sec_special_names_paragraph_clause)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_special_names_paragraph_clauses(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_conf_sec_special_names_paragraph_clauses)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_special_names_paragraph_phrase(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_conf_sec_special_names_paragraph_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_special_names_paragraph_phrase_tail(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_conf_sec_special_names_paragraph_phrase_tail)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_special_names_paragraph_status_phrase(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_conf_sec_special_names_paragraph_status_phrase)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_special_names_paragraph_status_phrase_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_conf_sec_special_names_paragraph_status_phrase_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_special_names_paragraph_status_phrase_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_conf_sec_special_names_paragraph_status_phrase_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_symbolic_character_mapping(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_conf_sec_symbolic_character_mapping)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_symbolic_characters_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_conf_sec_symbolic_characters_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_conf_sec_with_debugging_mode(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_conf_sec_with_debugging_mode)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_data_div_data_division(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_data_div_data_division)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_data_div_data_division_content(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_data_div_data_division_content)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_data_div_file_section(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_data_div_file_section)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_data_div_file_section_entry(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_data_div_file_section_entry)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_data_div_linkage_section(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_data_div_linkage_section)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_data_div_working_storage_section(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_data_div_working_storage_section)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_alt_data_name_filler(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_dd_entry_alt_data_name_filler)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_alt_leading_trailing(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_dd_entry_alt_leading_trailing)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_alt_left_right(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_dd_entry_alt_left_right)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_blank_when_zero_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_dd_entry_blank_when_zero_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_condition_value_clause(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_dd_entry_condition_value_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_data_description_entry(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_dd_entry_data_description_entry)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_data_description_entry_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_dd_entry_data_description_entry_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_data_description_entry_clause(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_dd_entry_data_description_entry_clause)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_data_description_entry_clauses(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_dd_entry_data_description_entry_clauses)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_external_clause(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_dd_entry_external_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_global_clause(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_dd_entry_global_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_indexed_by(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_dd_entry_indexed_by)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_integer_to(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_dd_entry_integer_to)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_justified(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_dd_entry_justified)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_justified_clause(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_dd_entry_justified_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_occurs_clause(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_dd_entry_occurs_clause)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_occurs_clause_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_dd_entry_occurs_clause_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_occurs_clause_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9)
{
    if (t->fun == TTfunVSC_dd_entry_occurs_clause_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_occurs_clause_key(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_dd_entry_occurs_clause_key)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_picture(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_dd_entry_picture)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_picture_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_dd_entry_picture_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_redefines_clause(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_dd_entry_redefines_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_renames_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_dd_entry_renames_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_separate_character(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_dd_entry_separate_character)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_sign_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_dd_entry_sign_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_sign_is(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_dd_entry_sign_is)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_synchronized(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_dd_entry_synchronized)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_synchronized_clause(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_dd_entry_synchronized_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_usage(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_dd_entry_usage)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_usage_clause(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_dd_entry_usage_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_usage_is(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_dd_entry_usage_is)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_values_are(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_dd_entry_values_are)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_dd_entry_zeroes(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_dd_entry_zeroes)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_env_div_environment_division(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_env_div_environment_division)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_env_div_environment_division_content(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_env_div_environment_division_content)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_alphabet_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_alphabet_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_alphabetic_user_defined_word(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_alphabetic_user_defined_word)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_alt_ascending_descending(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_alt_ascending_descending)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_alt_library_name_literal(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_alt_library_name_literal)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_alt_plus_minus(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_alt_plus_minus)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_alt_reel_unit(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_alt_reel_unit)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_alt_text_name_literal(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_alt_text_name_literal)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_alt_times_div(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_alt_times_div)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_arithmetic_expression(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_arithmetic_expression)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_arithmetic_expression_tail(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_arithmetic_expression_tail)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_assignment_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_assignment_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_basis(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_basis)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_basis_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_expr_basis_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_class_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_class_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_computer_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_computer_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_condition_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_condition_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_copy_operand(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_copy_operand)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_copy_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6)
{
    if (t->fun == TTfunVSC_expr_copy_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_copy_statement_by_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_expr_copy_statement_by_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_copy_statement_replacing_phrase(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_copy_statement_replacing_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_data_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_data_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_data_or_file_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_data_or_file_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_data_or_file_or_mnemonic_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_data_or_file_or_mnemonic_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_environment_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_environment_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_equal_to(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_equal_to)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_equal_to_1(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_equal_to_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_figurative_constant(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_figurative_constant)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_figurative_constant_all(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_figurative_constant_all)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_figurative_constant_simple(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_figurative_constant_simple)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_file_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_file_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_identifier(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_identifier)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_identifier_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_expr_identifier_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_identifier_2(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_identifier_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_in(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_in)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_in_data_or_file_name(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_in_data_or_file_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_in_data_or_file_or_mnemonic_name(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_in_data_or_file_or_mnemonic_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_in_file_name(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_in_file_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_in_library(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_in_library)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_in_section_name(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_in_section_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_index_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_index_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_integer(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_integer)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_leftmost_character_position(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_leftmost_character_position)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_length(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_length)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_level_number(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_level_number)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_library_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_library_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_literal(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_literal)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_literal_through_literal(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_literal_through_literal)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_mnemonic_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_mnemonic_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_numeric(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_numeric)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_paragraph_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_paragraph_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_paragraph_or_section_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_paragraph_or_section_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_plus_minus_integer(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_plus_minus_integer)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_power(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_expr_power)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_power_tail(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_power_tail)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_priority_number(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_priority_number)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_procedure_name(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_procedure_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_program_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_program_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_qualified_data_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_qualified_data_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_qualified_data_name_1(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_qualified_data_name_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_record_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_record_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_records(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_records)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_reference_modification(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_expr_reference_modification)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_section_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_section_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_special_register_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_expr_special_register_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_special_register_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_expr_special_register_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_subscript(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_subscript)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_subscript_expression(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_subscript_expression)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_subscript_expression_ambiguous(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_subscript_expression_ambiguous)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_subscript_parentheses(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_expr_subscript_parentheses)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_symbolic_character(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_symbolic_character)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_system_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_system_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_text_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_text_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_through(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_through)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_through_arithmetic_expression(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_through_arithmetic_expression)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_through_literal(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_through_literal)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_through_qualified_data_name(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_through_qualified_data_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_times_div(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_times_div)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_times_div_tail(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_expr_times_div_tail)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_user_defined_word(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_user_defined_word)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_expr_values(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_expr_values)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_alt_characters_records(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_fd_entry_alt_characters_records)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_alt_data_name_integer(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_fd_entry_alt_data_name_integer)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_alt_fd_sd(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_fd_entry_alt_fd_sd)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_alt_qualified_data_name_literal(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_fd_entry_alt_qualified_data_name_literal)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_block_contains_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_fd_entry_block_contains_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_code_set_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_fd_entry_code_set_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_data_names(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_fd_entry_data_names)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_data_records_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_fd_entry_data_records_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_depending_on(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_fd_entry_depending_on)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_file_and_sort_description_entry(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_fd_entry_file_and_sort_description_entry)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_file_and_sort_description_entry_clause(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_fd_entry_file_and_sort_description_entry_clause)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_file_and_sort_description_entry_clauses(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_fd_entry_file_and_sort_description_entry_clauses)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_footing(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_fd_entry_footing)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_from_integer(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_fd_entry_from_integer)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_label_records_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_fd_entry_label_records_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_label_records_clause_tail(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_fd_entry_label_records_clause_tail)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_linage_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_fd_entry_linage_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_linage_footing_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_fd_entry_linage_footing_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_lines_bottom(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_fd_entry_lines_bottom)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_lines_top(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_fd_entry_lines_top)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_record_clause(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_fd_entry_record_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_record_clause_tail(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_fd_entry_record_clause_tail)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_record_clause_tail_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_fd_entry_record_clause_tail_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_record_clause_tail_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_fd_entry_record_clause_tail_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_record_clause_tail_3(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_fd_entry_record_clause_tail_3)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_record_varying_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7)
{
    if (t->fun == TTfunVSC_fd_entry_record_varying_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_recording_mode_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_fd_entry_recording_mode_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_records_are(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_fd_entry_records_are)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_to_integer(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_fd_entry_to_integer)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_value_of_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_fd_entry_value_of_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_fd_entry_value_of_clause_tail(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_fd_entry_value_of_clause_tail)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_id_div_author(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_id_div_author)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_id_div_date_compiled(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_id_div_date_compiled)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_id_div_date_written(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_id_div_date_written)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_id_div_identification(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_id_div_identification)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_id_div_identification_division(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_id_div_identification_division)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_id_div_identification_division_content(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_id_div_identification_division_content)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_id_div_identification_division_phrase(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_id_div_identification_division_phrase)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_id_div_initial_program(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_id_div_initial_program)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_id_div_installation(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_id_div_installation)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_id_div_program_id_cobol_source_program(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_id_div_program_id_cobol_source_program)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_id_div_remarks(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_id_div_remarks)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_id_div_security(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_id_div_security)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_alt_assignment_name_file_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_io_sec_alt_assignment_name_file_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_alt_assignment_name_literal(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_io_sec_alt_assignment_name_literal)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_alt_indexed_relative_sequential(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_io_sec_alt_indexed_relative_sequential)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_alt_sequential_random_dynamic(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_io_sec_alt_sequential_random_dynamic)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_alternate_record_key_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7)
{
    if (t->fun == TTfunVSC_io_sec_alternate_record_key_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_areas(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_io_sec_areas)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_assign_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_io_sec_assign_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_every_phrase(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_io_sec_every_phrase)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_every_phrase_1(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_io_sec_every_phrase_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_every_phrase_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_io_sec_every_phrase_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_fce_access_mode(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_io_sec_fce_access_mode)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_fce_organization(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_io_sec_fce_organization)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_fce_phrase(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_io_sec_fce_phrase)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_file_control_entry(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_io_sec_file_control_entry)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_file_control_paragraph(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_io_sec_file_control_paragraph)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_file_name_position(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_io_sec_file_name_position)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_file_status_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_io_sec_file_status_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_i_o_control_paragraph(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_io_sec_i_o_control_paragraph)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_i_o_sam(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_io_sec_i_o_sam)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_i_o_sort_merge(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_io_sec_i_o_sort_merge)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_input_output_section(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_io_sec_input_output_section)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_organization_is(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_io_sec_organization_is)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_padding_character_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_io_sec_padding_character_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_password_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_io_sec_password_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_position(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_io_sec_position)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7)
{
    if (t->fun == TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6)
{
    if (t->fun == TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_3(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_3)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_4(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_io_sec_qsam_or_sam_or_vsam_i_o_control_entries_4)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_record_delimiter_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_io_sec_record_delimiter_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_record_delimiter_name(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_io_sec_record_delimiter_name)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_record_key_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_io_sec_record_key_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_record_sort(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_io_sec_record_sort)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_relative_key_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_io_sec_relative_key_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_rerun_on(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_io_sec_rerun_on)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_reserve_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_io_sec_reserve_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_same_area(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6)
{
    if (t->fun == TTfunVSC_io_sec_same_area)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_select_clause(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_io_sec_select_clause)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_sort_merge_i_o_control_entries(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_io_sec_sort_merge_i_o_control_entries)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_io_sec_with_duplicates(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_io_sec_with_duplicates)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_main_cobol_source_program(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_main_cobol_source_program)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_main_common_initial(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_main_common_initial)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_main_common_initial_1(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_main_common_initial_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_main_common_initial_2(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_main_common_initial_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_main_common_initial_program(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_main_common_initial_program)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_main_nested_cobol_source_program(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9, TTterm *t10, TTterm *t11, TTterm *t12, TTterm *t13)
{
    if (t->fun == TTfunVSC_main_nested_cobol_source_program)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        *t10 = t->u.args[9];
        *t11 = t->u.args[10];
        *t12 = t->u.args[11];
        *t13 = t->u.args[12];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_main_nested_program(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_main_nested_program)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_main_program_id_nested_cobol_source_program(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_main_program_id_nested_cobol_source_program)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_main_programs(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_main_programs)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_altered_goto(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_proc_div_altered_goto)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_declaratives(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6)
{
    if (t->fun == TTfunVSC_proc_div_declaratives)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_declaratives_content(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_proc_div_declaratives_content)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_paragraph(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_proc_div_paragraph)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_paragraph_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_proc_div_paragraph_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_paragraphs(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_proc_div_paragraphs)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_procedure_division(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_proc_div_procedure_division)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_section_header(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_proc_div_section_header)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_section_with_header(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_proc_div_section_with_header)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_sections(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_proc_div_sections)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_sentence(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_proc_div_sentence)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_sentence_1(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_proc_div_sentence_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_sentence_2(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_proc_div_sentence_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_using_data_names(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_proc_div_using_data_names)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_using_phrase(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_proc_div_using_phrase)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_using_phrase_1(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_proc_div_using_phrase_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_proc_div_using_phrase_2(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_proc_div_using_phrase_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_accept_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_accept_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_accept_statement_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_accept_statement_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_accept_statement_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_accept_statement_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_add_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_add_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_add_statement_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7)
{
    if (t->fun == TTfunVSC_stat_add_statement_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_add_statement_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8)
{
    if (t->fun == TTfunVSC_stat_add_statement_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_add_statement_3(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9)
{
    if (t->fun == TTfunVSC_stat_add_statement_3)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_advancing_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_advancing_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_all_procedures(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_all_procedures)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_also_phrase(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_also_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_all_leading(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_all_leading)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_all_leading_first(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_all_leading_first)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_before_after(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_before_after)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_beginning_ending(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_beginning_ending)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_exception_error(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_exception_error)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_file_names_i_o(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_file_names_i_o)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_file_reel_unit(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_file_reel_unit)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_no_rewind_lock(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_no_rewind_lock)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_procedures_all_procedures(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_procedures_all_procedures)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_removal_no_rewind(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_removal_no_rewind)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_reversed_with_no_rewind(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_reversed_with_no_rewind)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_run_literal(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_run_literal)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_statement_list_next_sentence(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_statement_list_next_sentence)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_up_down(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_alt_up_down)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alt_up_down_by(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_alt_up_down_by)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_alter_statement(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_alter_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_at_end_of_page_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_at_end_of_page_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_at_end_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_at_end_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_before_after_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_before_after_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_by_reference(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_by_reference)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_call_rest_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_call_rest_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_call_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_stat_call_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_cancel_statement(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_cancel_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_close_statement(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_close_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_close_statement_file_name(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_close_statement_file_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_close_statement_options(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_close_statement_options)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_close_statement_options_1(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_close_statement_options_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_close_statement_options_2(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_close_statement_options_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_cobword_int(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_cobword_int)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_cobword_rounded(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_cobword_rounded)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_collating_sequence(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_collating_sequence)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_compute_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7)
{
    if (t->fun == TTfunVSC_stat_compute_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_content_parameter(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_content_parameter)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_content_parameter_value(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_content_parameter_value)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_continue_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_continue_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_corresponding(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_corresponding)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_count_in_identifier(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_count_in_identifier)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_date(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_date)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_delete_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6)
{
    if (t->fun == TTfunVSC_stat_delete_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_delimited_by_all_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_stat_delimited_by_all_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_delimited_by_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_delimited_by_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_delimiter_in_identifier(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_delimiter_in_identifier)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_display_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_display_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_divide_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_divide_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_divide_statement_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7)
{
    if (t->fun == TTfunVSC_stat_divide_statement_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_divide_statement_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9)
{
    if (t->fun == TTfunVSC_stat_divide_statement_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_divide_statement_3(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9)
{
    if (t->fun == TTfunVSC_stat_divide_statement_3)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_divide_statement_4(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9, TTterm *t10, TTterm *t11, TTterm *t12)
{
    if (t->fun == TTfunVSC_stat_divide_statement_4)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        *t10 = t->u.args[9];
        *t11 = t->u.args[10];
        *t12 = t->u.args[11];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_divide_statement_5(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9, TTterm *t10, TTterm *t11, TTterm *t12)
{
    if (t->fun == TTfunVSC_stat_divide_statement_5)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        *t10 = t->u.args[9];
        *t11 = t->u.args[10];
        *t12 = t->u.args[11];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_else_phrase(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_else_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_end_of_page(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_end_of_page)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_entry_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_entry_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_equal(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_equal)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_evaluate_condition(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_evaluate_condition)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_evaluate_phrase(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_evaluate_phrase)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_evaluate_phrase_1(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_evaluate_phrase_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_evaluate_phrase_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_evaluate_phrase_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_evaluate_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6)
{
    if (t->fun == TTfunVSC_stat_evaluate_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_exit_program_statement(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_exit_program_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_exit_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_exit_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_file_names(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_file_names)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_for_removal(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_for_removal)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_from_environment_name(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_from_environment_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_from_identifier(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_from_identifier)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_giving_file_names(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_giving_file_names)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_go_to_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_go_to_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_go_to_statement_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_go_to_statement_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_go_to_statement_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6)
{
    if (t->fun == TTfunVSC_stat_go_to_statement_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_go_to_statement_3(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_go_to_statement_3)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_goback_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_goback_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_id_or_lit(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_id_or_lit)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_id_or_lit_size(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_id_or_lit_size)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_if_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6)
{
    if (t->fun == TTfunVSC_stat_if_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_initialize_replacing_argument(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_initialize_replacing_argument)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_initialize_replacing_phrase(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_initialize_replacing_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_initialize_replacing_type(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_initialize_replacing_type)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_initialize_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_initialize_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_input_procedure(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_stat_input_procedure)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_inspect_by_argument(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_inspect_by_argument)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_inspect_replacing_argument(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_inspect_replacing_argument)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_inspect_replacing_phrase(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_inspect_replacing_phrase)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_inspect_replacing_phrase_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_inspect_replacing_phrase_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_inspect_replacing_phrase_2(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_inspect_replacing_phrase_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_inspect_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_inspect_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_inspect_statement_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_inspect_statement_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_inspect_statement_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7)
{
    if (t->fun == TTfunVSC_stat_inspect_statement_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_inspect_statement_3(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6)
{
    if (t->fun == TTfunVSC_stat_inspect_statement_3)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_inspect_statement_4(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_inspect_statement_4)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_into_identifier(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_into_identifier)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_invalid_key_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_invalid_key_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_key_is(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_key_is)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_key_is_qualified_data_name(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_key_is_qualified_data_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_key_is_rel_op_qualified_data_name(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_key_is_rel_op_qualified_data_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_lines(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_lines)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_merge_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8)
{
    if (t->fun == TTfunVSC_stat_merge_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_merge_statement_tail(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_merge_statement_tail)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_move_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_move_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_move_statement_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_move_statement_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_move_statement_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_stat_move_statement_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_multiply_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_multiply_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_multiply_statement_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7)
{
    if (t->fun == TTfunVSC_stat_multiply_statement_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_multiply_statement_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9)
{
    if (t->fun == TTfunVSC_stat_multiply_statement_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_next_sentence(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_next_sentence)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_no_rewind(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_no_rewind)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_not_at_end_of_page_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_not_at_end_of_page_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_not_at_end_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_not_at_end_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_not_invalid_key_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_not_invalid_key_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_not_on_exception_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_not_on_exception_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_not_on_overflow_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_not_on_overflow_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_not_on_size_error_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_stat_not_on_size_error_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_nr_lines_phrase(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_nr_lines_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_on_exception_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_on_exception_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_on_key_is_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_on_key_is_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_on_key_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_on_key_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_on_overflow_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_on_overflow_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_on_size_error_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_on_size_error_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_open_statement(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_open_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_open_statement_extend(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_open_statement_extend)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_open_statement_i_o(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_open_statement_i_o)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_open_statement_input(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_open_statement_input)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_open_statement_input_file_name(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_open_statement_input_file_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_open_statement_output(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_open_statement_output)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_open_statement_output_file_name(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_open_statement_output_file_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_open_statement_phrase(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_open_statement_phrase)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_or_all_id_or_lit(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_or_all_id_or_lit)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_output_procedure(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_stat_output_procedure)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_page_phrase(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_page_phrase)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_parameter(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_parameter)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_after_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8)
{
    if (t->fun == TTfunVSC_stat_perform_after_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_perform_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_1(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_perform_statement_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_1_alts(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_perform_statement_1_alts)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_1_procedure(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_perform_statement_1_procedure)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_1_statement_list(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_perform_statement_1_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_2(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_perform_statement_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_2_alts(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_perform_statement_2_alts)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_2_procedure(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_perform_statement_2_procedure)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_2_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_perform_statement_2_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_3(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_perform_statement_3)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_3_alts(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_perform_statement_3_alts)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_3_procedure(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_perform_statement_3_procedure)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_3_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_perform_statement_3_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_4(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_perform_statement_4)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_4_alts(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_perform_statement_4_alts)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_4_procedure(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_perform_statement_4_procedure)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_statement_4_statement_list(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_perform_statement_4_statement_list)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_until_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_perform_until_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_perform_varying_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9)
{
    if (t->fun == TTfunVSC_stat_perform_varying_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_procedure_names(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_procedure_names)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_procedure_to_procedure(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_procedure_to_procedure)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_proceed_to(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_proceed_to)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_read_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9, TTterm *t10, TTterm *t11)
{
    if (t->fun == TTfunVSC_stat_read_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        *t10 = t->u.args[9];
        *t11 = t->u.args[10];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_reference_parameter(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_reference_parameter)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_rel_op(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_rel_op)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_release_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_release_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_return_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9)
{
    if (t->fun == TTfunVSC_stat_return_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_rewrite_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6)
{
    if (t->fun == TTfunVSC_stat_rewrite_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_search_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_search_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_search_statement_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6)
{
    if (t->fun == TTfunVSC_stat_search_statement_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_search_statement_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9)
{
    if (t->fun == TTfunVSC_stat_search_statement_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_search_statement_condition(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_search_statement_condition)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_search_statement_condition_tail(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_search_statement_condition_tail)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_search_statement_equal_expression(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_search_statement_equal_expression)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_set_oper(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_set_oper)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_set_src(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_set_src)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_set_statement(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_set_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_set_statement_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_set_statement_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_sort_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7)
{
    if (t->fun == TTfunVSC_stat_sort_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_sort_statement_in(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_sort_statement_in)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_sort_statement_out(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_sort_statement_out)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_start_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6)
{
    if (t->fun == TTfunVSC_stat_start_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_statement_list(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_statement_list)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_stop_statement(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_stop_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_string_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8)
{
    if (t->fun == TTfunVSC_stat_string_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_subtract_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_subtract_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_subtract_statement_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7)
{
    if (t->fun == TTfunVSC_stat_subtract_statement_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_subtract_statement_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9)
{
    if (t->fun == TTfunVSC_stat_subtract_statement_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_subtract_statement_3(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9)
{
    if (t->fun == TTfunVSC_stat_subtract_statement_3)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_tallying_argument(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_tallying_argument)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_tallying_for_argument(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_tallying_for_argument)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_tallying_for_argument_1(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_tallying_for_argument_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_tallying_for_argument_2(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_tallying_for_argument_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_tallying_for_id_or_lit(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_tallying_for_id_or_lit)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_tallying_in_identifier(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_tallying_in_identifier)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_through_procedure_name(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_through_procedure_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_to_id_or_lit(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_to_id_or_lit)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_unstring_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9, TTterm *t10)
{
    if (t->fun == TTfunVSC_stat_unstring_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        *t10 = t->u.args[9];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_unstring_statement_dst(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_unstring_statement_dst)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_upon_environment_name(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_upon_environment_name)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_use_statement(TTterm t, TTterm *t1)
{
    if (t->fun == TTfunVSC_stat_use_statement)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_use_statement_1(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8)
{
    if (t->fun == TTfunVSC_stat_use_statement_1)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_use_statement_2(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6, TTterm *t7, TTterm *t8, TTterm *t9, TTterm *t10)
{
    if (t->fun == TTfunVSC_stat_use_statement_2)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        *t7 = t->u.args[6];
        *t8 = t->u.args[7];
        *t9 = t->u.args[8];
        *t10 = t->u.args[9];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_use_statement_3(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5)
{
    if (t->fun == TTfunVSC_stat_use_statement_3)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_using_data_name_pluslist(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_using_data_name_pluslist)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_using_file_names(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_using_file_names)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_using_parameters(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_using_parameters)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_varying_identifier(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_varying_identifier)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_when_condition_stats(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_when_condition_stats)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_when_other_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_when_other_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_when_phrase(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_when_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_when_phrase_also_phrase(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_when_phrase_also_phrase)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_when_phrases(TTterm t, TTterm *t1, TTterm *t2)
{
    if (t->fun == TTfunVSC_stat_when_phrases)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_with_duplicates_in_order(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_with_duplicates_in_order)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_with_no_advancing(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_with_no_advancing)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_with_no_rewind(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_with_no_rewind)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_with_pointer_identifier(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_with_pointer_identifier)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_with_test(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3)
{
    if (t->fun == TTfunVSC_stat_with_test)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_write_exceptions(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4)
{
    if (t->fun == TTfunVSC_stat_write_exceptions)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_stat_write_statement(TTterm t, TTterm *t1, TTterm *t2, TTterm *t3, TTterm *t4, TTterm *t5, TTterm *t6)
{
    if (t->fun == TTfunVSC_stat_write_statement)
    {
        *t1 = t->u.args[0];
        *t2 = t->u.args[1];
        *t3 = t->u.args[2];
        *t4 = t->u.args[3];
        *t5 = t->u.args[4];
        *t6 = t->u.args[5];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_lex_picture_string(TTterm t, TTtype_string *t1)
{
    if (t->fun == TTfunVSC_lex_picture_string)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_lex_quoted_pseudo_text(TTterm t, TTtype_string *t1)
{
    if (t->fun == TTfunVSC_lex_quoted_pseudo_text)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_lex_num(TTterm t, TTtype_string *t1)
{
    if (t->fun == TTfunVSC_lex_num)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_lex_nonnumeric(TTterm t, TTtype_string *t1)
{
    if (t->fun == TTfunVSC_lex_nonnumeric)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

BOOL
TTmatchVSC_lex_cobword(TTterm t, TTtype_string *t1)
{
    if (t->fun == TTfunVSC_lex_cobword)
    {
        *t1 = t->u.args[0];
        return TRUE;
    }
    return FALSE;
}

